// file      : examples/cxx/tree/hello/driver.cxx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : not copyrighted - public domain

#include <memory>   // std::auto_ptr
#include <iostream>
#include <fpml-main-4-2.hxx>

using namespace std;
using namespace xml_schema;
using namespace XMLDSig;
using namespace FpML_4_2;

int main (int argc, char* argv[])
{
  try
  {
    auto_ptr<Document> doc(FpML("xml_swap.xml"));
       
    Document copyDocument(*doc);

    xml_schema::namespace_infomap map;
    map[""].schema = "fpml-main-4-2.xsd";

    FpML(std::cout, copyDocument, map);
  }
  catch (const xml_schema::exception& e)
  {
    cerr << e << endl;
    getchar();
    return 1;
  }
  getchar();
}

