// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_CD_4_2_HXX
#define FPML_CD_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class AdditionalTerm;
  class AdjustedPaymentDates;
  class BasketReferenceInformation;
  class SettlementTerms;
  class CashSettlementTerms;
  class CreditDefaultSwap;
  class CreditEventNotice;
  class CreditEvents;
  class DeliverableObligations;
  class EntityType;
  class FailureToPay;
  class FeeLeg;
  class FixedAmountCalculation;
  class GeneralTerms;
  class GracePeriodExtension;
  class IndexAnnexSource;
  class IndexId;
  class IndexName;
  class IndexReferenceInformation;
  class InitialPayment;
  class PCDeliverableObligationCharac;
  class LoanParticipation;
  class MatrixSource;
  class SingleValuationDate;
  class MultipleValuationDates;
  class NotDomesticCurrency;
  class NotifyingParty;
  class Obligations;
  class PeriodicPayment;
  class PhysicalSettlementPeriod;
  class PhysicalSettlementTerms;
  class ProtectionTerms;
  class ProtectionTermsReference;
  class PubliclyAvailableInformation;
  class ReferenceInformation;
  class ReferenceObligation;
  class ReferencePair;
  class ReferencePool;
  class ReferencePoolItem;
  class Restructuring;
  class RestructuringType;
  class ScheduledTerminationDate;
  class SettledEntityMatrix;
  class SettlementTermsReference;
  class SinglePayment;
  class SpecifiedCurrency;
  class Tranche;
  class ValuationDate;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-asset-4-2.hxx"

namespace FpML_4_2
{
  class AdditionalTerm: public ::xml_schema::normalized_string
  {
    public:
    // additionalTermScheme
    // 
    typedef ::xml_schema::uri additionalTermScheme_type;
    typedef ::xsd::cxx::tree::optional< additionalTermScheme_type > additionalTermScheme_optional;
    typedef ::xsd::cxx::tree::traits< additionalTermScheme_type, char > additionalTermScheme_traits;

    const additionalTermScheme_optional&
    additionalTermScheme () const;

    additionalTermScheme_optional&
    additionalTermScheme ();

    void
    additionalTermScheme (const additionalTermScheme_type& x);

    void
    additionalTermScheme (const additionalTermScheme_optional& x);

    void
    additionalTermScheme (::std::auto_ptr< additionalTermScheme_type > p);

    // Constructors.
    //
    AdditionalTerm ();

    AdditionalTerm (const char*);

    AdditionalTerm (const ::std::string&);

    AdditionalTerm (const ::xml_schema::normalized_string&);

    AdditionalTerm (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    AdditionalTerm (const AdditionalTerm& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual AdditionalTerm*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdditionalTerm ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    additionalTermScheme_optional additionalTermScheme_;
  };

  class AdjustedPaymentDates: public ::xml_schema::type
  {
    public:
    // adjustedPaymentDate
    // 
    typedef ::xml_schema::date adjustedPaymentDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedPaymentDate_type, char > adjustedPaymentDate_traits;

    const adjustedPaymentDate_type&
    adjustedPaymentDate () const;

    adjustedPaymentDate_type&
    adjustedPaymentDate ();

    void
    adjustedPaymentDate (const adjustedPaymentDate_type& x);

    void
    adjustedPaymentDate (::std::auto_ptr< adjustedPaymentDate_type > p);

    // paymentAmount
    // 
    typedef ::FpML_4_2::Money paymentAmount_type;
    typedef ::xsd::cxx::tree::traits< paymentAmount_type, char > paymentAmount_traits;

    const paymentAmount_type&
    paymentAmount () const;

    paymentAmount_type&
    paymentAmount ();

    void
    paymentAmount (const paymentAmount_type& x);

    void
    paymentAmount (::std::auto_ptr< paymentAmount_type > p);

    // Constructors.
    //
    AdjustedPaymentDates (const adjustedPaymentDate_type&,
                          const paymentAmount_type&);

    AdjustedPaymentDates (const adjustedPaymentDate_type&,
                          ::std::auto_ptr< paymentAmount_type >&);

    AdjustedPaymentDates (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    AdjustedPaymentDates (const AdjustedPaymentDates& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual AdjustedPaymentDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdjustedPaymentDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< adjustedPaymentDate_type > adjustedPaymentDate_;
    ::xsd::cxx::tree::one< paymentAmount_type > paymentAmount_;
  };

  class BasketReferenceInformation: public ::xml_schema::type
  {
    public:
    // basketName
    // 
    typedef ::FpML_4_2::BasketName basketName_type;
    typedef ::xsd::cxx::tree::optional< basketName_type > basketName_optional;
    typedef ::xsd::cxx::tree::traits< basketName_type, char > basketName_traits;

    const basketName_optional&
    basketName () const;

    basketName_optional&
    basketName ();

    void
    basketName (const basketName_type& x);

    void
    basketName (const basketName_optional& x);

    void
    basketName (::std::auto_ptr< basketName_type > p);

    // basketId
    // 
    typedef ::FpML_4_2::BasketId basketId_type;
    typedef ::xsd::cxx::tree::sequence< basketId_type > basketId_sequence;
    typedef basketId_sequence::iterator basketId_iterator;
    typedef basketId_sequence::const_iterator basketId_const_iterator;
    typedef ::xsd::cxx::tree::traits< basketId_type, char > basketId_traits;

    const basketId_sequence&
    basketId () const;

    basketId_sequence&
    basketId ();

    void
    basketId (const basketId_sequence& s);

    // referencePool
    // 
    typedef ::FpML_4_2::ReferencePool referencePool_type;
    typedef ::xsd::cxx::tree::traits< referencePool_type, char > referencePool_traits;

    const referencePool_type&
    referencePool () const;

    referencePool_type&
    referencePool ();

    void
    referencePool (const referencePool_type& x);

    void
    referencePool (::std::auto_ptr< referencePool_type > p);

    // nthToDefault
    // 
    typedef ::xml_schema::positive_integer nthToDefault_type;
    typedef ::xsd::cxx::tree::optional< nthToDefault_type > nthToDefault_optional;
    typedef ::xsd::cxx::tree::traits< nthToDefault_type, char > nthToDefault_traits;

    const nthToDefault_optional&
    nthToDefault () const;

    nthToDefault_optional&
    nthToDefault ();

    void
    nthToDefault (const nthToDefault_type& x);

    void
    nthToDefault (const nthToDefault_optional& x);

    // mthToDefault
    // 
    typedef ::xml_schema::positive_integer mthToDefault_type;
    typedef ::xsd::cxx::tree::optional< mthToDefault_type > mthToDefault_optional;
    typedef ::xsd::cxx::tree::traits< mthToDefault_type, char > mthToDefault_traits;

    const mthToDefault_optional&
    mthToDefault () const;

    mthToDefault_optional&
    mthToDefault ();

    void
    mthToDefault (const mthToDefault_type& x);

    void
    mthToDefault (const mthToDefault_optional& x);

    // tranche
    // 
    typedef ::FpML_4_2::Tranche tranche_type;
    typedef ::xsd::cxx::tree::optional< tranche_type > tranche_optional;
    typedef ::xsd::cxx::tree::traits< tranche_type, char > tranche_traits;

    const tranche_optional&
    tranche () const;

    tranche_optional&
    tranche ();

    void
    tranche (const tranche_type& x);

    void
    tranche (const tranche_optional& x);

    void
    tranche (::std::auto_ptr< tranche_type > p);

    // Constructors.
    //
    BasketReferenceInformation (const referencePool_type&);

    BasketReferenceInformation (::std::auto_ptr< referencePool_type >&);

    BasketReferenceInformation (const ::xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    BasketReferenceInformation (const BasketReferenceInformation& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual BasketReferenceInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BasketReferenceInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    basketName_optional basketName_;
    basketId_sequence basketId_;
    ::xsd::cxx::tree::one< referencePool_type > referencePool_;
    nthToDefault_optional nthToDefault_;
    mthToDefault_optional mthToDefault_;
    tranche_optional tranche_;
  };

  class SettlementTerms: public ::xml_schema::type
  {
    public:
    // settlementCurrency
    // 
    typedef ::FpML_4_2::Currency settlementCurrency_type;
    typedef ::xsd::cxx::tree::optional< settlementCurrency_type > settlementCurrency_optional;
    typedef ::xsd::cxx::tree::traits< settlementCurrency_type, char > settlementCurrency_traits;

    const settlementCurrency_optional&
    settlementCurrency () const;

    settlementCurrency_optional&
    settlementCurrency ();

    void
    settlementCurrency (const settlementCurrency_type& x);

    void
    settlementCurrency (const settlementCurrency_optional& x);

    void
    settlementCurrency (::std::auto_ptr< settlementCurrency_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    SettlementTerms ();

    SettlementTerms (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    SettlementTerms (const SettlementTerms& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual SettlementTerms*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SettlementTerms ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    settlementCurrency_optional settlementCurrency_;
    id_optional id_;
  };

  class CashSettlementTerms: public ::FpML_4_2::SettlementTerms
  {
    public:
    // valuationDate
    // 
    typedef ::FpML_4_2::ValuationDate valuationDate_type;
    typedef ::xsd::cxx::tree::optional< valuationDate_type > valuationDate_optional;
    typedef ::xsd::cxx::tree::traits< valuationDate_type, char > valuationDate_traits;

    const valuationDate_optional&
    valuationDate () const;

    valuationDate_optional&
    valuationDate ();

    void
    valuationDate (const valuationDate_type& x);

    void
    valuationDate (const valuationDate_optional& x);

    void
    valuationDate (::std::auto_ptr< valuationDate_type > p);

    // valuationTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime valuationTime_type;
    typedef ::xsd::cxx::tree::optional< valuationTime_type > valuationTime_optional;
    typedef ::xsd::cxx::tree::traits< valuationTime_type, char > valuationTime_traits;

    const valuationTime_optional&
    valuationTime () const;

    valuationTime_optional&
    valuationTime ();

    void
    valuationTime (const valuationTime_type& x);

    void
    valuationTime (const valuationTime_optional& x);

    void
    valuationTime (::std::auto_ptr< valuationTime_type > p);

    // quotationMethod
    // 
    typedef ::FpML_4_2::QuotationRateTypeEnum quotationMethod_type;
    typedef ::xsd::cxx::tree::optional< quotationMethod_type > quotationMethod_optional;
    typedef ::xsd::cxx::tree::traits< quotationMethod_type, char > quotationMethod_traits;

    const quotationMethod_optional&
    quotationMethod () const;

    quotationMethod_optional&
    quotationMethod ();

    void
    quotationMethod (const quotationMethod_type& x);

    void
    quotationMethod (const quotationMethod_optional& x);

    void
    quotationMethod (::std::auto_ptr< quotationMethod_type > p);

    // quotationAmount
    // 
    typedef ::FpML_4_2::Money quotationAmount_type;
    typedef ::xsd::cxx::tree::optional< quotationAmount_type > quotationAmount_optional;
    typedef ::xsd::cxx::tree::traits< quotationAmount_type, char > quotationAmount_traits;

    const quotationAmount_optional&
    quotationAmount () const;

    quotationAmount_optional&
    quotationAmount ();

    void
    quotationAmount (const quotationAmount_type& x);

    void
    quotationAmount (const quotationAmount_optional& x);

    void
    quotationAmount (::std::auto_ptr< quotationAmount_type > p);

    // minimumQuotationAmount
    // 
    typedef ::FpML_4_2::Money minimumQuotationAmount_type;
    typedef ::xsd::cxx::tree::optional< minimumQuotationAmount_type > minimumQuotationAmount_optional;
    typedef ::xsd::cxx::tree::traits< minimumQuotationAmount_type, char > minimumQuotationAmount_traits;

    const minimumQuotationAmount_optional&
    minimumQuotationAmount () const;

    minimumQuotationAmount_optional&
    minimumQuotationAmount ();

    void
    minimumQuotationAmount (const minimumQuotationAmount_type& x);

    void
    minimumQuotationAmount (const minimumQuotationAmount_optional& x);

    void
    minimumQuotationAmount (::std::auto_ptr< minimumQuotationAmount_type > p);

    // dealer
    // 
    typedef ::xml_schema::string dealer_type;
    typedef ::xsd::cxx::tree::sequence< dealer_type > dealer_sequence;
    typedef dealer_sequence::iterator dealer_iterator;
    typedef dealer_sequence::const_iterator dealer_const_iterator;
    typedef ::xsd::cxx::tree::traits< dealer_type, char > dealer_traits;

    const dealer_sequence&
    dealer () const;

    dealer_sequence&
    dealer ();

    void
    dealer (const dealer_sequence& s);

    // cashSettlementBusinessDays
    // 
    typedef ::xml_schema::non_negative_integer cashSettlementBusinessDays_type;
    typedef ::xsd::cxx::tree::optional< cashSettlementBusinessDays_type > cashSettlementBusinessDays_optional;
    typedef ::xsd::cxx::tree::traits< cashSettlementBusinessDays_type, char > cashSettlementBusinessDays_traits;

    const cashSettlementBusinessDays_optional&
    cashSettlementBusinessDays () const;

    cashSettlementBusinessDays_optional&
    cashSettlementBusinessDays ();

    void
    cashSettlementBusinessDays (const cashSettlementBusinessDays_type& x);

    void
    cashSettlementBusinessDays (const cashSettlementBusinessDays_optional& x);

    // cashSettlementAmount
    // 
    typedef ::FpML_4_2::Money cashSettlementAmount_type;
    typedef ::xsd::cxx::tree::optional< cashSettlementAmount_type > cashSettlementAmount_optional;
    typedef ::xsd::cxx::tree::traits< cashSettlementAmount_type, char > cashSettlementAmount_traits;

    const cashSettlementAmount_optional&
    cashSettlementAmount () const;

    cashSettlementAmount_optional&
    cashSettlementAmount ();

    void
    cashSettlementAmount (const cashSettlementAmount_type& x);

    void
    cashSettlementAmount (const cashSettlementAmount_optional& x);

    void
    cashSettlementAmount (::std::auto_ptr< cashSettlementAmount_type > p);

    // accruedInterest
    // 
    typedef ::xml_schema::boolean accruedInterest_type;
    typedef ::xsd::cxx::tree::optional< accruedInterest_type > accruedInterest_optional;
    typedef ::xsd::cxx::tree::traits< accruedInterest_type, char > accruedInterest_traits;

    const accruedInterest_optional&
    accruedInterest () const;

    accruedInterest_optional&
    accruedInterest ();

    void
    accruedInterest (const accruedInterest_type& x);

    void
    accruedInterest (const accruedInterest_optional& x);

    // valuationMethod
    // 
    typedef ::FpML_4_2::ValuationMethodEnum valuationMethod_type;
    typedef ::xsd::cxx::tree::optional< valuationMethod_type > valuationMethod_optional;
    typedef ::xsd::cxx::tree::traits< valuationMethod_type, char > valuationMethod_traits;

    const valuationMethod_optional&
    valuationMethod () const;

    valuationMethod_optional&
    valuationMethod ();

    void
    valuationMethod (const valuationMethod_type& x);

    void
    valuationMethod (const valuationMethod_optional& x);

    void
    valuationMethod (::std::auto_ptr< valuationMethod_type > p);

    // Constructors.
    //
    CashSettlementTerms ();

    CashSettlementTerms (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    CashSettlementTerms (const CashSettlementTerms& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual CashSettlementTerms*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CashSettlementTerms ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    valuationDate_optional valuationDate_;
    valuationTime_optional valuationTime_;
    quotationMethod_optional quotationMethod_;
    quotationAmount_optional quotationAmount_;
    minimumQuotationAmount_optional minimumQuotationAmount_;
    dealer_sequence dealer_;
    cashSettlementBusinessDays_optional cashSettlementBusinessDays_;
    cashSettlementAmount_optional cashSettlementAmount_;
    accruedInterest_optional accruedInterest_;
    valuationMethod_optional valuationMethod_;
  };

  class CreditDefaultSwap: public ::FpML_4_2::Product
  {
    public:
    // generalTerms
    // 
    typedef ::FpML_4_2::GeneralTerms generalTerms_type;
    typedef ::xsd::cxx::tree::traits< generalTerms_type, char > generalTerms_traits;

    const generalTerms_type&
    generalTerms () const;

    generalTerms_type&
    generalTerms ();

    void
    generalTerms (const generalTerms_type& x);

    void
    generalTerms (::std::auto_ptr< generalTerms_type > p);

    // feeLeg
    // 
    typedef ::FpML_4_2::FeeLeg feeLeg_type;
    typedef ::xsd::cxx::tree::traits< feeLeg_type, char > feeLeg_traits;

    const feeLeg_type&
    feeLeg () const;

    feeLeg_type&
    feeLeg ();

    void
    feeLeg (const feeLeg_type& x);

    void
    feeLeg (::std::auto_ptr< feeLeg_type > p);

    // protectionTerms
    // 
    typedef ::FpML_4_2::ProtectionTerms protectionTerms_type;
    typedef ::xsd::cxx::tree::sequence< protectionTerms_type > protectionTerms_sequence;
    typedef protectionTerms_sequence::iterator protectionTerms_iterator;
    typedef protectionTerms_sequence::const_iterator protectionTerms_const_iterator;
    typedef ::xsd::cxx::tree::traits< protectionTerms_type, char > protectionTerms_traits;

    const protectionTerms_sequence&
    protectionTerms () const;

    protectionTerms_sequence&
    protectionTerms ();

    void
    protectionTerms (const protectionTerms_sequence& s);

    // cashSettlementTerms
    // 
    typedef ::FpML_4_2::CashSettlementTerms cashSettlementTerms_type;
    typedef ::xsd::cxx::tree::sequence< cashSettlementTerms_type > cashSettlementTerms_sequence;
    typedef cashSettlementTerms_sequence::iterator cashSettlementTerms_iterator;
    typedef cashSettlementTerms_sequence::const_iterator cashSettlementTerms_const_iterator;
    typedef ::xsd::cxx::tree::traits< cashSettlementTerms_type, char > cashSettlementTerms_traits;

    const cashSettlementTerms_sequence&
    cashSettlementTerms () const;

    cashSettlementTerms_sequence&
    cashSettlementTerms ();

    void
    cashSettlementTerms (const cashSettlementTerms_sequence& s);

    // physicalSettlementTerms
    // 
    typedef ::FpML_4_2::PhysicalSettlementTerms physicalSettlementTerms_type;
    typedef ::xsd::cxx::tree::sequence< physicalSettlementTerms_type > physicalSettlementTerms_sequence;
    typedef physicalSettlementTerms_sequence::iterator physicalSettlementTerms_iterator;
    typedef physicalSettlementTerms_sequence::const_iterator physicalSettlementTerms_const_iterator;
    typedef ::xsd::cxx::tree::traits< physicalSettlementTerms_type, char > physicalSettlementTerms_traits;

    const physicalSettlementTerms_sequence&
    physicalSettlementTerms () const;

    physicalSettlementTerms_sequence&
    physicalSettlementTerms ();

    void
    physicalSettlementTerms (const physicalSettlementTerms_sequence& s);

    // Constructors.
    //
    CreditDefaultSwap (const generalTerms_type&,
                       const feeLeg_type&);

    CreditDefaultSwap (::std::auto_ptr< generalTerms_type >&,
                       ::std::auto_ptr< feeLeg_type >&);

    CreditDefaultSwap (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    CreditDefaultSwap (const CreditDefaultSwap& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual CreditDefaultSwap*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CreditDefaultSwap ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< generalTerms_type > generalTerms_;
    ::xsd::cxx::tree::one< feeLeg_type > feeLeg_;
    protectionTerms_sequence protectionTerms_;
    cashSettlementTerms_sequence cashSettlementTerms_;
    physicalSettlementTerms_sequence physicalSettlementTerms_;
  };

  class CreditEventNotice: public ::xml_schema::type
  {
    public:
    // notifyingParty
    // 
    typedef ::FpML_4_2::NotifyingParty notifyingParty_type;
    typedef ::xsd::cxx::tree::traits< notifyingParty_type, char > notifyingParty_traits;

    const notifyingParty_type&
    notifyingParty () const;

    notifyingParty_type&
    notifyingParty ();

    void
    notifyingParty (const notifyingParty_type& x);

    void
    notifyingParty (::std::auto_ptr< notifyingParty_type > p);

    // businessCenter
    // 
    typedef ::FpML_4_2::BusinessCenter businessCenter_type;
    typedef ::xsd::cxx::tree::optional< businessCenter_type > businessCenter_optional;
    typedef ::xsd::cxx::tree::traits< businessCenter_type, char > businessCenter_traits;

    const businessCenter_optional&
    businessCenter () const;

    businessCenter_optional&
    businessCenter ();

    void
    businessCenter (const businessCenter_type& x);

    void
    businessCenter (const businessCenter_optional& x);

    void
    businessCenter (::std::auto_ptr< businessCenter_type > p);

    // publiclyAvailableInformation
    // 
    typedef ::FpML_4_2::PubliclyAvailableInformation publiclyAvailableInformation_type;
    typedef ::xsd::cxx::tree::optional< publiclyAvailableInformation_type > publiclyAvailableInformation_optional;
    typedef ::xsd::cxx::tree::traits< publiclyAvailableInformation_type, char > publiclyAvailableInformation_traits;

    const publiclyAvailableInformation_optional&
    publiclyAvailableInformation () const;

    publiclyAvailableInformation_optional&
    publiclyAvailableInformation ();

    void
    publiclyAvailableInformation (const publiclyAvailableInformation_type& x);

    void
    publiclyAvailableInformation (const publiclyAvailableInformation_optional& x);

    void
    publiclyAvailableInformation (::std::auto_ptr< publiclyAvailableInformation_type > p);

    // Constructors.
    //
    CreditEventNotice (const notifyingParty_type&);

    CreditEventNotice (::std::auto_ptr< notifyingParty_type >&);

    CreditEventNotice (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    CreditEventNotice (const CreditEventNotice& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual CreditEventNotice*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CreditEventNotice ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< notifyingParty_type > notifyingParty_;
    businessCenter_optional businessCenter_;
    publiclyAvailableInformation_optional publiclyAvailableInformation_;
  };

  class CreditEvents: public ::xml_schema::type
  {
    public:
    // bankruptcy
    // 
    typedef ::FpML_4_2::Empty bankruptcy_type;
    typedef ::xsd::cxx::tree::optional< bankruptcy_type > bankruptcy_optional;
    typedef ::xsd::cxx::tree::traits< bankruptcy_type, char > bankruptcy_traits;

    const bankruptcy_optional&
    bankruptcy () const;

    bankruptcy_optional&
    bankruptcy ();

    void
    bankruptcy (const bankruptcy_type& x);

    void
    bankruptcy (const bankruptcy_optional& x);

    void
    bankruptcy (::std::auto_ptr< bankruptcy_type > p);

    // failureToPay
    // 
    typedef ::FpML_4_2::FailureToPay failureToPay_type;
    typedef ::xsd::cxx::tree::optional< failureToPay_type > failureToPay_optional;
    typedef ::xsd::cxx::tree::traits< failureToPay_type, char > failureToPay_traits;

    const failureToPay_optional&
    failureToPay () const;

    failureToPay_optional&
    failureToPay ();

    void
    failureToPay (const failureToPay_type& x);

    void
    failureToPay (const failureToPay_optional& x);

    void
    failureToPay (::std::auto_ptr< failureToPay_type > p);

    // obligationDefault
    // 
    typedef ::FpML_4_2::Empty obligationDefault_type;
    typedef ::xsd::cxx::tree::optional< obligationDefault_type > obligationDefault_optional;
    typedef ::xsd::cxx::tree::traits< obligationDefault_type, char > obligationDefault_traits;

    const obligationDefault_optional&
    obligationDefault () const;

    obligationDefault_optional&
    obligationDefault ();

    void
    obligationDefault (const obligationDefault_type& x);

    void
    obligationDefault (const obligationDefault_optional& x);

    void
    obligationDefault (::std::auto_ptr< obligationDefault_type > p);

    // obligationAcceleration
    // 
    typedef ::FpML_4_2::Empty obligationAcceleration_type;
    typedef ::xsd::cxx::tree::optional< obligationAcceleration_type > obligationAcceleration_optional;
    typedef ::xsd::cxx::tree::traits< obligationAcceleration_type, char > obligationAcceleration_traits;

    const obligationAcceleration_optional&
    obligationAcceleration () const;

    obligationAcceleration_optional&
    obligationAcceleration ();

    void
    obligationAcceleration (const obligationAcceleration_type& x);

    void
    obligationAcceleration (const obligationAcceleration_optional& x);

    void
    obligationAcceleration (::std::auto_ptr< obligationAcceleration_type > p);

    // repudiationMoratorium
    // 
    typedef ::FpML_4_2::Empty repudiationMoratorium_type;
    typedef ::xsd::cxx::tree::optional< repudiationMoratorium_type > repudiationMoratorium_optional;
    typedef ::xsd::cxx::tree::traits< repudiationMoratorium_type, char > repudiationMoratorium_traits;

    const repudiationMoratorium_optional&
    repudiationMoratorium () const;

    repudiationMoratorium_optional&
    repudiationMoratorium ();

    void
    repudiationMoratorium (const repudiationMoratorium_type& x);

    void
    repudiationMoratorium (const repudiationMoratorium_optional& x);

    void
    repudiationMoratorium (::std::auto_ptr< repudiationMoratorium_type > p);

    // restructuring
    // 
    typedef ::FpML_4_2::Restructuring restructuring_type;
    typedef ::xsd::cxx::tree::optional< restructuring_type > restructuring_optional;
    typedef ::xsd::cxx::tree::traits< restructuring_type, char > restructuring_traits;

    const restructuring_optional&
    restructuring () const;

    restructuring_optional&
    restructuring ();

    void
    restructuring (const restructuring_type& x);

    void
    restructuring (const restructuring_optional& x);

    void
    restructuring (::std::auto_ptr< restructuring_type > p);

    // defaultRequirement
    // 
    typedef ::FpML_4_2::Money defaultRequirement_type;
    typedef ::xsd::cxx::tree::optional< defaultRequirement_type > defaultRequirement_optional;
    typedef ::xsd::cxx::tree::traits< defaultRequirement_type, char > defaultRequirement_traits;

    const defaultRequirement_optional&
    defaultRequirement () const;

    defaultRequirement_optional&
    defaultRequirement ();

    void
    defaultRequirement (const defaultRequirement_type& x);

    void
    defaultRequirement (const defaultRequirement_optional& x);

    void
    defaultRequirement (::std::auto_ptr< defaultRequirement_type > p);

    // creditEventNotice
    // 
    typedef ::FpML_4_2::CreditEventNotice creditEventNotice_type;
    typedef ::xsd::cxx::tree::optional< creditEventNotice_type > creditEventNotice_optional;
    typedef ::xsd::cxx::tree::traits< creditEventNotice_type, char > creditEventNotice_traits;

    const creditEventNotice_optional&
    creditEventNotice () const;

    creditEventNotice_optional&
    creditEventNotice ();

    void
    creditEventNotice (const creditEventNotice_type& x);

    void
    creditEventNotice (const creditEventNotice_optional& x);

    void
    creditEventNotice (::std::auto_ptr< creditEventNotice_type > p);

    // Constructors.
    //
    CreditEvents ();

    CreditEvents (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    CreditEvents (const CreditEvents& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual CreditEvents*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CreditEvents ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    bankruptcy_optional bankruptcy_;
    failureToPay_optional failureToPay_;
    obligationDefault_optional obligationDefault_;
    obligationAcceleration_optional obligationAcceleration_;
    repudiationMoratorium_optional repudiationMoratorium_;
    restructuring_optional restructuring_;
    defaultRequirement_optional defaultRequirement_;
    creditEventNotice_optional creditEventNotice_;
  };

  class DeliverableObligations: public ::xml_schema::type
  {
    public:
    // accruedInterest
    // 
    typedef ::xml_schema::boolean accruedInterest_type;
    typedef ::xsd::cxx::tree::optional< accruedInterest_type > accruedInterest_optional;
    typedef ::xsd::cxx::tree::traits< accruedInterest_type, char > accruedInterest_traits;

    const accruedInterest_optional&
    accruedInterest () const;

    accruedInterest_optional&
    accruedInterest ();

    void
    accruedInterest (const accruedInterest_type& x);

    void
    accruedInterest (const accruedInterest_optional& x);

    // category
    // 
    typedef ::FpML_4_2::ObligationCategoryEnum category_type;
    typedef ::xsd::cxx::tree::optional< category_type > category_optional;
    typedef ::xsd::cxx::tree::traits< category_type, char > category_traits;

    const category_optional&
    category () const;

    category_optional&
    category ();

    void
    category (const category_type& x);

    void
    category (const category_optional& x);

    void
    category (::std::auto_ptr< category_type > p);

    // notSubordinated
    // 
    typedef ::FpML_4_2::Empty notSubordinated_type;
    typedef ::xsd::cxx::tree::optional< notSubordinated_type > notSubordinated_optional;
    typedef ::xsd::cxx::tree::traits< notSubordinated_type, char > notSubordinated_traits;

    const notSubordinated_optional&
    notSubordinated () const;

    notSubordinated_optional&
    notSubordinated ();

    void
    notSubordinated (const notSubordinated_type& x);

    void
    notSubordinated (const notSubordinated_optional& x);

    void
    notSubordinated (::std::auto_ptr< notSubordinated_type > p);

    // specifiedCurrency
    // 
    typedef ::FpML_4_2::SpecifiedCurrency specifiedCurrency_type;
    typedef ::xsd::cxx::tree::optional< specifiedCurrency_type > specifiedCurrency_optional;
    typedef ::xsd::cxx::tree::traits< specifiedCurrency_type, char > specifiedCurrency_traits;

    const specifiedCurrency_optional&
    specifiedCurrency () const;

    specifiedCurrency_optional&
    specifiedCurrency ();

    void
    specifiedCurrency (const specifiedCurrency_type& x);

    void
    specifiedCurrency (const specifiedCurrency_optional& x);

    void
    specifiedCurrency (::std::auto_ptr< specifiedCurrency_type > p);

    // notSovereignLender
    // 
    typedef ::FpML_4_2::Empty notSovereignLender_type;
    typedef ::xsd::cxx::tree::optional< notSovereignLender_type > notSovereignLender_optional;
    typedef ::xsd::cxx::tree::traits< notSovereignLender_type, char > notSovereignLender_traits;

    const notSovereignLender_optional&
    notSovereignLender () const;

    notSovereignLender_optional&
    notSovereignLender ();

    void
    notSovereignLender (const notSovereignLender_type& x);

    void
    notSovereignLender (const notSovereignLender_optional& x);

    void
    notSovereignLender (::std::auto_ptr< notSovereignLender_type > p);

    // notDomesticCurrency
    // 
    typedef ::FpML_4_2::NotDomesticCurrency notDomesticCurrency_type;
    typedef ::xsd::cxx::tree::optional< notDomesticCurrency_type > notDomesticCurrency_optional;
    typedef ::xsd::cxx::tree::traits< notDomesticCurrency_type, char > notDomesticCurrency_traits;

    const notDomesticCurrency_optional&
    notDomesticCurrency () const;

    notDomesticCurrency_optional&
    notDomesticCurrency ();

    void
    notDomesticCurrency (const notDomesticCurrency_type& x);

    void
    notDomesticCurrency (const notDomesticCurrency_optional& x);

    void
    notDomesticCurrency (::std::auto_ptr< notDomesticCurrency_type > p);

    // notDomesticLaw
    // 
    typedef ::FpML_4_2::Empty notDomesticLaw_type;
    typedef ::xsd::cxx::tree::optional< notDomesticLaw_type > notDomesticLaw_optional;
    typedef ::xsd::cxx::tree::traits< notDomesticLaw_type, char > notDomesticLaw_traits;

    const notDomesticLaw_optional&
    notDomesticLaw () const;

    notDomesticLaw_optional&
    notDomesticLaw ();

    void
    notDomesticLaw (const notDomesticLaw_type& x);

    void
    notDomesticLaw (const notDomesticLaw_optional& x);

    void
    notDomesticLaw (::std::auto_ptr< notDomesticLaw_type > p);

    // listed
    // 
    typedef ::FpML_4_2::Empty listed_type;
    typedef ::xsd::cxx::tree::optional< listed_type > listed_optional;
    typedef ::xsd::cxx::tree::traits< listed_type, char > listed_traits;

    const listed_optional&
    listed () const;

    listed_optional&
    listed ();

    void
    listed (const listed_type& x);

    void
    listed (const listed_optional& x);

    void
    listed (::std::auto_ptr< listed_type > p);

    // notContingent
    // 
    typedef ::FpML_4_2::Empty notContingent_type;
    typedef ::xsd::cxx::tree::optional< notContingent_type > notContingent_optional;
    typedef ::xsd::cxx::tree::traits< notContingent_type, char > notContingent_traits;

    const notContingent_optional&
    notContingent () const;

    notContingent_optional&
    notContingent ();

    void
    notContingent (const notContingent_type& x);

    void
    notContingent (const notContingent_optional& x);

    void
    notContingent (::std::auto_ptr< notContingent_type > p);

    // notDomesticIssuance
    // 
    typedef ::FpML_4_2::Empty notDomesticIssuance_type;
    typedef ::xsd::cxx::tree::optional< notDomesticIssuance_type > notDomesticIssuance_optional;
    typedef ::xsd::cxx::tree::traits< notDomesticIssuance_type, char > notDomesticIssuance_traits;

    const notDomesticIssuance_optional&
    notDomesticIssuance () const;

    notDomesticIssuance_optional&
    notDomesticIssuance ();

    void
    notDomesticIssuance (const notDomesticIssuance_type& x);

    void
    notDomesticIssuance (const notDomesticIssuance_optional& x);

    void
    notDomesticIssuance (::std::auto_ptr< notDomesticIssuance_type > p);

    // assignableLoan
    // 
    typedef ::FpML_4_2::PCDeliverableObligationCharac assignableLoan_type;
    typedef ::xsd::cxx::tree::optional< assignableLoan_type > assignableLoan_optional;
    typedef ::xsd::cxx::tree::traits< assignableLoan_type, char > assignableLoan_traits;

    const assignableLoan_optional&
    assignableLoan () const;

    assignableLoan_optional&
    assignableLoan ();

    void
    assignableLoan (const assignableLoan_type& x);

    void
    assignableLoan (const assignableLoan_optional& x);

    void
    assignableLoan (::std::auto_ptr< assignableLoan_type > p);

    // consentRequiredLoan
    // 
    typedef ::FpML_4_2::PCDeliverableObligationCharac consentRequiredLoan_type;
    typedef ::xsd::cxx::tree::optional< consentRequiredLoan_type > consentRequiredLoan_optional;
    typedef ::xsd::cxx::tree::traits< consentRequiredLoan_type, char > consentRequiredLoan_traits;

    const consentRequiredLoan_optional&
    consentRequiredLoan () const;

    consentRequiredLoan_optional&
    consentRequiredLoan ();

    void
    consentRequiredLoan (const consentRequiredLoan_type& x);

    void
    consentRequiredLoan (const consentRequiredLoan_optional& x);

    void
    consentRequiredLoan (::std::auto_ptr< consentRequiredLoan_type > p);

    // directLoanParticipation
    // 
    typedef ::FpML_4_2::LoanParticipation directLoanParticipation_type;
    typedef ::xsd::cxx::tree::optional< directLoanParticipation_type > directLoanParticipation_optional;
    typedef ::xsd::cxx::tree::traits< directLoanParticipation_type, char > directLoanParticipation_traits;

    const directLoanParticipation_optional&
    directLoanParticipation () const;

    directLoanParticipation_optional&
    directLoanParticipation ();

    void
    directLoanParticipation (const directLoanParticipation_type& x);

    void
    directLoanParticipation (const directLoanParticipation_optional& x);

    void
    directLoanParticipation (::std::auto_ptr< directLoanParticipation_type > p);

    // transferable
    // 
    typedef ::FpML_4_2::Empty transferable_type;
    typedef ::xsd::cxx::tree::optional< transferable_type > transferable_optional;
    typedef ::xsd::cxx::tree::traits< transferable_type, char > transferable_traits;

    const transferable_optional&
    transferable () const;

    transferable_optional&
    transferable ();

    void
    transferable (const transferable_type& x);

    void
    transferable (const transferable_optional& x);

    void
    transferable (::std::auto_ptr< transferable_type > p);

    // maximumMaturity
    // 
    typedef ::FpML_4_2::Interval maximumMaturity_type;
    typedef ::xsd::cxx::tree::optional< maximumMaturity_type > maximumMaturity_optional;
    typedef ::xsd::cxx::tree::traits< maximumMaturity_type, char > maximumMaturity_traits;

    const maximumMaturity_optional&
    maximumMaturity () const;

    maximumMaturity_optional&
    maximumMaturity ();

    void
    maximumMaturity (const maximumMaturity_type& x);

    void
    maximumMaturity (const maximumMaturity_optional& x);

    void
    maximumMaturity (::std::auto_ptr< maximumMaturity_type > p);

    // acceleratedOrMatured
    // 
    typedef ::FpML_4_2::Empty acceleratedOrMatured_type;
    typedef ::xsd::cxx::tree::optional< acceleratedOrMatured_type > acceleratedOrMatured_optional;
    typedef ::xsd::cxx::tree::traits< acceleratedOrMatured_type, char > acceleratedOrMatured_traits;

    const acceleratedOrMatured_optional&
    acceleratedOrMatured () const;

    acceleratedOrMatured_optional&
    acceleratedOrMatured ();

    void
    acceleratedOrMatured (const acceleratedOrMatured_type& x);

    void
    acceleratedOrMatured (const acceleratedOrMatured_optional& x);

    void
    acceleratedOrMatured (::std::auto_ptr< acceleratedOrMatured_type > p);

    // notBearer
    // 
    typedef ::FpML_4_2::Empty notBearer_type;
    typedef ::xsd::cxx::tree::optional< notBearer_type > notBearer_optional;
    typedef ::xsd::cxx::tree::traits< notBearer_type, char > notBearer_traits;

    const notBearer_optional&
    notBearer () const;

    notBearer_optional&
    notBearer ();

    void
    notBearer (const notBearer_type& x);

    void
    notBearer (const notBearer_optional& x);

    void
    notBearer (::std::auto_ptr< notBearer_type > p);

    // fullFaithAndCreditObLiability
    // 
    typedef ::FpML_4_2::Empty fullFaithAndCreditObLiability_type;
    typedef ::xsd::cxx::tree::optional< fullFaithAndCreditObLiability_type > fullFaithAndCreditObLiability_optional;
    typedef ::xsd::cxx::tree::traits< fullFaithAndCreditObLiability_type, char > fullFaithAndCreditObLiability_traits;

    const fullFaithAndCreditObLiability_optional&
    fullFaithAndCreditObLiability () const;

    fullFaithAndCreditObLiability_optional&
    fullFaithAndCreditObLiability ();

    void
    fullFaithAndCreditObLiability (const fullFaithAndCreditObLiability_type& x);

    void
    fullFaithAndCreditObLiability (const fullFaithAndCreditObLiability_optional& x);

    void
    fullFaithAndCreditObLiability (::std::auto_ptr< fullFaithAndCreditObLiability_type > p);

    // generalFundObligationLiability
    // 
    typedef ::FpML_4_2::Empty generalFundObligationLiability_type;
    typedef ::xsd::cxx::tree::optional< generalFundObligationLiability_type > generalFundObligationLiability_optional;
    typedef ::xsd::cxx::tree::traits< generalFundObligationLiability_type, char > generalFundObligationLiability_traits;

    const generalFundObligationLiability_optional&
    generalFundObligationLiability () const;

    generalFundObligationLiability_optional&
    generalFundObligationLiability ();

    void
    generalFundObligationLiability (const generalFundObligationLiability_type& x);

    void
    generalFundObligationLiability (const generalFundObligationLiability_optional& x);

    void
    generalFundObligationLiability (::std::auto_ptr< generalFundObligationLiability_type > p);

    // revenueObligationLiability
    // 
    typedef ::FpML_4_2::Empty revenueObligationLiability_type;
    typedef ::xsd::cxx::tree::optional< revenueObligationLiability_type > revenueObligationLiability_optional;
    typedef ::xsd::cxx::tree::traits< revenueObligationLiability_type, char > revenueObligationLiability_traits;

    const revenueObligationLiability_optional&
    revenueObligationLiability () const;

    revenueObligationLiability_optional&
    revenueObligationLiability ();

    void
    revenueObligationLiability (const revenueObligationLiability_type& x);

    void
    revenueObligationLiability (const revenueObligationLiability_optional& x);

    void
    revenueObligationLiability (::std::auto_ptr< revenueObligationLiability_type > p);

    // indirectLoanParticipation
    // 
    typedef ::FpML_4_2::LoanParticipation indirectLoanParticipation_type;
    typedef ::xsd::cxx::tree::optional< indirectLoanParticipation_type > indirectLoanParticipation_optional;
    typedef ::xsd::cxx::tree::traits< indirectLoanParticipation_type, char > indirectLoanParticipation_traits;

    const indirectLoanParticipation_optional&
    indirectLoanParticipation () const;

    indirectLoanParticipation_optional&
    indirectLoanParticipation ();

    void
    indirectLoanParticipation (const indirectLoanParticipation_type& x);

    void
    indirectLoanParticipation (const indirectLoanParticipation_optional& x);

    void
    indirectLoanParticipation (::std::auto_ptr< indirectLoanParticipation_type > p);

    // excluded
    // 
    typedef ::xml_schema::string excluded_type;
    typedef ::xsd::cxx::tree::optional< excluded_type > excluded_optional;
    typedef ::xsd::cxx::tree::traits< excluded_type, char > excluded_traits;

    const excluded_optional&
    excluded () const;

    excluded_optional&
    excluded ();

    void
    excluded (const excluded_type& x);

    void
    excluded (const excluded_optional& x);

    void
    excluded (::std::auto_ptr< excluded_type > p);

    // othReferenceEntityObligations
    // 
    typedef ::xml_schema::string othReferenceEntityObligations_type;
    typedef ::xsd::cxx::tree::optional< othReferenceEntityObligations_type > othReferenceEntityObligations_optional;
    typedef ::xsd::cxx::tree::traits< othReferenceEntityObligations_type, char > othReferenceEntityObligations_traits;

    const othReferenceEntityObligations_optional&
    othReferenceEntityObligations () const;

    othReferenceEntityObligations_optional&
    othReferenceEntityObligations ();

    void
    othReferenceEntityObligations (const othReferenceEntityObligations_type& x);

    void
    othReferenceEntityObligations (const othReferenceEntityObligations_optional& x);

    void
    othReferenceEntityObligations (::std::auto_ptr< othReferenceEntityObligations_type > p);

    // Constructors.
    //
    DeliverableObligations ();

    DeliverableObligations (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    DeliverableObligations (const DeliverableObligations& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual DeliverableObligations*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DeliverableObligations ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    accruedInterest_optional accruedInterest_;
    category_optional category_;
    notSubordinated_optional notSubordinated_;
    specifiedCurrency_optional specifiedCurrency_;
    notSovereignLender_optional notSovereignLender_;
    notDomesticCurrency_optional notDomesticCurrency_;
    notDomesticLaw_optional notDomesticLaw_;
    listed_optional listed_;
    notContingent_optional notContingent_;
    notDomesticIssuance_optional notDomesticIssuance_;
    assignableLoan_optional assignableLoan_;
    consentRequiredLoan_optional consentRequiredLoan_;
    directLoanParticipation_optional directLoanParticipation_;
    transferable_optional transferable_;
    maximumMaturity_optional maximumMaturity_;
    acceleratedOrMatured_optional acceleratedOrMatured_;
    notBearer_optional notBearer_;
    fullFaithAndCreditObLiability_optional fullFaithAndCreditObLiability_;
    generalFundObligationLiability_optional generalFundObligationLiability_;
    revenueObligationLiability_optional revenueObligationLiability_;
    indirectLoanParticipation_optional indirectLoanParticipation_;
    excluded_optional excluded_;
    othReferenceEntityObligations_optional othReferenceEntityObligations_;
  };

  class EntityType: public ::xml_schema::normalized_string
  {
    public:
    // entityTypeScheme
    // 
    typedef ::xml_schema::uri entityTypeScheme_type;
    typedef ::xsd::cxx::tree::traits< entityTypeScheme_type, char > entityTypeScheme_traits;

    const entityTypeScheme_type&
    entityTypeScheme () const;

    entityTypeScheme_type&
    entityTypeScheme ();

    void
    entityTypeScheme (const entityTypeScheme_type& x);

    void
    entityTypeScheme (::std::auto_ptr< entityTypeScheme_type > p);

    static const entityTypeScheme_type&
    entityTypeScheme_default_value ();

    // Constructors.
    //
    EntityType ();

    EntityType (const char*);

    EntityType (const ::std::string&);

    EntityType (const ::xml_schema::normalized_string&);

    EntityType (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    EntityType (const EntityType& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual EntityType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EntityType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< entityTypeScheme_type > entityTypeScheme_;
    static const entityTypeScheme_type entityTypeScheme_default_value_;
  };

  class FailureToPay: public ::xml_schema::type
  {
    public:
    // gracePeriodExtension
    // 
    typedef ::FpML_4_2::GracePeriodExtension gracePeriodExtension_type;
    typedef ::xsd::cxx::tree::optional< gracePeriodExtension_type > gracePeriodExtension_optional;
    typedef ::xsd::cxx::tree::traits< gracePeriodExtension_type, char > gracePeriodExtension_traits;

    const gracePeriodExtension_optional&
    gracePeriodExtension () const;

    gracePeriodExtension_optional&
    gracePeriodExtension ();

    void
    gracePeriodExtension (const gracePeriodExtension_type& x);

    void
    gracePeriodExtension (const gracePeriodExtension_optional& x);

    void
    gracePeriodExtension (::std::auto_ptr< gracePeriodExtension_type > p);

    // paymentRequirement
    // 
    typedef ::FpML_4_2::Money paymentRequirement_type;
    typedef ::xsd::cxx::tree::optional< paymentRequirement_type > paymentRequirement_optional;
    typedef ::xsd::cxx::tree::traits< paymentRequirement_type, char > paymentRequirement_traits;

    const paymentRequirement_optional&
    paymentRequirement () const;

    paymentRequirement_optional&
    paymentRequirement ();

    void
    paymentRequirement (const paymentRequirement_type& x);

    void
    paymentRequirement (const paymentRequirement_optional& x);

    void
    paymentRequirement (::std::auto_ptr< paymentRequirement_type > p);

    // Constructors.
    //
    FailureToPay ();

    FailureToPay (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    FailureToPay (const FailureToPay& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual FailureToPay*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FailureToPay ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    gracePeriodExtension_optional gracePeriodExtension_;
    paymentRequirement_optional paymentRequirement_;
  };

  class FeeLeg: public ::xml_schema::type
  {
    public:
    // initialPayment
    // 
    typedef ::FpML_4_2::InitialPayment initialPayment_type;
    typedef ::xsd::cxx::tree::optional< initialPayment_type > initialPayment_optional;
    typedef ::xsd::cxx::tree::traits< initialPayment_type, char > initialPayment_traits;

    const initialPayment_optional&
    initialPayment () const;

    initialPayment_optional&
    initialPayment ();

    void
    initialPayment (const initialPayment_type& x);

    void
    initialPayment (const initialPayment_optional& x);

    void
    initialPayment (::std::auto_ptr< initialPayment_type > p);

    // singlePayment
    // 
    typedef ::FpML_4_2::SinglePayment singlePayment_type;
    typedef ::xsd::cxx::tree::sequence< singlePayment_type > singlePayment_sequence;
    typedef singlePayment_sequence::iterator singlePayment_iterator;
    typedef singlePayment_sequence::const_iterator singlePayment_const_iterator;
    typedef ::xsd::cxx::tree::traits< singlePayment_type, char > singlePayment_traits;

    const singlePayment_sequence&
    singlePayment () const;

    singlePayment_sequence&
    singlePayment ();

    void
    singlePayment (const singlePayment_sequence& s);

    // periodicPayment
    // 
    typedef ::FpML_4_2::PeriodicPayment periodicPayment_type;
    typedef ::xsd::cxx::tree::optional< periodicPayment_type > periodicPayment_optional;
    typedef ::xsd::cxx::tree::traits< periodicPayment_type, char > periodicPayment_traits;

    const periodicPayment_optional&
    periodicPayment () const;

    periodicPayment_optional&
    periodicPayment ();

    void
    periodicPayment (const periodicPayment_type& x);

    void
    periodicPayment (const periodicPayment_optional& x);

    void
    periodicPayment (::std::auto_ptr< periodicPayment_type > p);

    // marketFixedRate
    // 
    typedef ::xml_schema::decimal marketFixedRate_type;
    typedef ::xsd::cxx::tree::optional< marketFixedRate_type > marketFixedRate_optional;
    typedef ::xsd::cxx::tree::traits< marketFixedRate_type, char, ::xsd::cxx::tree::schema_type::decimal > marketFixedRate_traits;

    const marketFixedRate_optional&
    marketFixedRate () const;

    marketFixedRate_optional&
    marketFixedRate ();

    void
    marketFixedRate (const marketFixedRate_type& x);

    void
    marketFixedRate (const marketFixedRate_optional& x);

    // Constructors.
    //
    FeeLeg ();

    FeeLeg (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    FeeLeg (const FeeLeg& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual FeeLeg*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FeeLeg ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    initialPayment_optional initialPayment_;
    singlePayment_sequence singlePayment_;
    periodicPayment_optional periodicPayment_;
    marketFixedRate_optional marketFixedRate_;
  };

  class FixedAmountCalculation: public ::xml_schema::type
  {
    public:
    // calculationAmount
    // 
    typedef ::FpML_4_2::Money calculationAmount_type;
    typedef ::xsd::cxx::tree::optional< calculationAmount_type > calculationAmount_optional;
    typedef ::xsd::cxx::tree::traits< calculationAmount_type, char > calculationAmount_traits;

    const calculationAmount_optional&
    calculationAmount () const;

    calculationAmount_optional&
    calculationAmount ();

    void
    calculationAmount (const calculationAmount_type& x);

    void
    calculationAmount (const calculationAmount_optional& x);

    void
    calculationAmount (::std::auto_ptr< calculationAmount_type > p);

    // fixedRate
    // 
    typedef ::xml_schema::decimal fixedRate_type;
    typedef ::xsd::cxx::tree::traits< fixedRate_type, char, ::xsd::cxx::tree::schema_type::decimal > fixedRate_traits;

    const fixedRate_type&
    fixedRate () const;

    fixedRate_type&
    fixedRate ();

    void
    fixedRate (const fixedRate_type& x);

    // dayCountFraction
    // 
    typedef ::FpML_4_2::DayCountFraction dayCountFraction_type;
    typedef ::xsd::cxx::tree::optional< dayCountFraction_type > dayCountFraction_optional;
    typedef ::xsd::cxx::tree::traits< dayCountFraction_type, char > dayCountFraction_traits;

    const dayCountFraction_optional&
    dayCountFraction () const;

    dayCountFraction_optional&
    dayCountFraction ();

    void
    dayCountFraction (const dayCountFraction_type& x);

    void
    dayCountFraction (const dayCountFraction_optional& x);

    void
    dayCountFraction (::std::auto_ptr< dayCountFraction_type > p);

    // Constructors.
    //
    FixedAmountCalculation (const fixedRate_type&);

    FixedAmountCalculation (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    FixedAmountCalculation (const FixedAmountCalculation& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual FixedAmountCalculation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FixedAmountCalculation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    calculationAmount_optional calculationAmount_;
    ::xsd::cxx::tree::one< fixedRate_type > fixedRate_;
    dayCountFraction_optional dayCountFraction_;
  };

  class GeneralTerms: public ::xml_schema::type
  {
    public:
    // effectiveDate
    // 
    typedef ::FpML_4_2::AdjustableDate2 effectiveDate_type;
    typedef ::xsd::cxx::tree::optional< effectiveDate_type > effectiveDate_optional;
    typedef ::xsd::cxx::tree::traits< effectiveDate_type, char > effectiveDate_traits;

    const effectiveDate_optional&
    effectiveDate () const;

    effectiveDate_optional&
    effectiveDate ();

    void
    effectiveDate (const effectiveDate_type& x);

    void
    effectiveDate (const effectiveDate_optional& x);

    void
    effectiveDate (::std::auto_ptr< effectiveDate_type > p);

    // scheduledTerminationDate
    // 
    typedef ::FpML_4_2::ScheduledTerminationDate scheduledTerminationDate_type;
    typedef ::xsd::cxx::tree::optional< scheduledTerminationDate_type > scheduledTerminationDate_optional;
    typedef ::xsd::cxx::tree::traits< scheduledTerminationDate_type, char > scheduledTerminationDate_traits;

    const scheduledTerminationDate_optional&
    scheduledTerminationDate () const;

    scheduledTerminationDate_optional&
    scheduledTerminationDate ();

    void
    scheduledTerminationDate (const scheduledTerminationDate_type& x);

    void
    scheduledTerminationDate (const scheduledTerminationDate_optional& x);

    void
    scheduledTerminationDate (::std::auto_ptr< scheduledTerminationDate_type > p);

    // sellerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference sellerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< sellerPartyReference_type, char > sellerPartyReference_traits;

    const sellerPartyReference_type&
    sellerPartyReference () const;

    sellerPartyReference_type&
    sellerPartyReference ();

    void
    sellerPartyReference (const sellerPartyReference_type& x);

    void
    sellerPartyReference (::std::auto_ptr< sellerPartyReference_type > p);

    // buyerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference buyerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< buyerPartyReference_type, char > buyerPartyReference_traits;

    const buyerPartyReference_type&
    buyerPartyReference () const;

    buyerPartyReference_type&
    buyerPartyReference ();

    void
    buyerPartyReference (const buyerPartyReference_type& x);

    void
    buyerPartyReference (::std::auto_ptr< buyerPartyReference_type > p);

    // dateAdjustments
    // 
    typedef ::FpML_4_2::BusinessDayAdjustments dateAdjustments_type;
    typedef ::xsd::cxx::tree::optional< dateAdjustments_type > dateAdjustments_optional;
    typedef ::xsd::cxx::tree::traits< dateAdjustments_type, char > dateAdjustments_traits;

    const dateAdjustments_optional&
    dateAdjustments () const;

    dateAdjustments_optional&
    dateAdjustments ();

    void
    dateAdjustments (const dateAdjustments_type& x);

    void
    dateAdjustments (const dateAdjustments_optional& x);

    void
    dateAdjustments (::std::auto_ptr< dateAdjustments_type > p);

    // referenceInformation
    // 
    typedef ::FpML_4_2::ReferenceInformation referenceInformation_type;
    typedef ::xsd::cxx::tree::optional< referenceInformation_type > referenceInformation_optional;
    typedef ::xsd::cxx::tree::traits< referenceInformation_type, char > referenceInformation_traits;

    const referenceInformation_optional&
    referenceInformation () const;

    referenceInformation_optional&
    referenceInformation ();

    void
    referenceInformation (const referenceInformation_type& x);

    void
    referenceInformation (const referenceInformation_optional& x);

    void
    referenceInformation (::std::auto_ptr< referenceInformation_type > p);

    // indexReferenceInformation
    // 
    typedef ::FpML_4_2::IndexReferenceInformation indexReferenceInformation_type;
    typedef ::xsd::cxx::tree::optional< indexReferenceInformation_type > indexReferenceInformation_optional;
    typedef ::xsd::cxx::tree::traits< indexReferenceInformation_type, char > indexReferenceInformation_traits;

    const indexReferenceInformation_optional&
    indexReferenceInformation () const;

    indexReferenceInformation_optional&
    indexReferenceInformation ();

    void
    indexReferenceInformation (const indexReferenceInformation_type& x);

    void
    indexReferenceInformation (const indexReferenceInformation_optional& x);

    void
    indexReferenceInformation (::std::auto_ptr< indexReferenceInformation_type > p);

    // basketReferenceInformation
    // 
    typedef ::FpML_4_2::BasketReferenceInformation basketReferenceInformation_type;
    typedef ::xsd::cxx::tree::optional< basketReferenceInformation_type > basketReferenceInformation_optional;
    typedef ::xsd::cxx::tree::traits< basketReferenceInformation_type, char > basketReferenceInformation_traits;

    const basketReferenceInformation_optional&
    basketReferenceInformation () const;

    basketReferenceInformation_optional&
    basketReferenceInformation ();

    void
    basketReferenceInformation (const basketReferenceInformation_type& x);

    void
    basketReferenceInformation (const basketReferenceInformation_optional& x);

    void
    basketReferenceInformation (::std::auto_ptr< basketReferenceInformation_type > p);

    // additionalTerm
    // 
    typedef ::FpML_4_2::AdditionalTerm additionalTerm_type;
    typedef ::xsd::cxx::tree::sequence< additionalTerm_type > additionalTerm_sequence;
    typedef additionalTerm_sequence::iterator additionalTerm_iterator;
    typedef additionalTerm_sequence::const_iterator additionalTerm_const_iterator;
    typedef ::xsd::cxx::tree::traits< additionalTerm_type, char > additionalTerm_traits;

    const additionalTerm_sequence&
    additionalTerm () const;

    additionalTerm_sequence&
    additionalTerm ();

    void
    additionalTerm (const additionalTerm_sequence& s);

    // substitution
    // 
    typedef ::FpML_4_2::Empty substitution_type;
    typedef ::xsd::cxx::tree::optional< substitution_type > substitution_optional;
    typedef ::xsd::cxx::tree::traits< substitution_type, char > substitution_traits;

    const substitution_optional&
    substitution () const;

    substitution_optional&
    substitution ();

    void
    substitution (const substitution_type& x);

    void
    substitution (const substitution_optional& x);

    void
    substitution (::std::auto_ptr< substitution_type > p);

    // modifiedEquityDelivery
    // 
    typedef ::FpML_4_2::Empty modifiedEquityDelivery_type;
    typedef ::xsd::cxx::tree::optional< modifiedEquityDelivery_type > modifiedEquityDelivery_optional;
    typedef ::xsd::cxx::tree::traits< modifiedEquityDelivery_type, char > modifiedEquityDelivery_traits;

    const modifiedEquityDelivery_optional&
    modifiedEquityDelivery () const;

    modifiedEquityDelivery_optional&
    modifiedEquityDelivery ();

    void
    modifiedEquityDelivery (const modifiedEquityDelivery_type& x);

    void
    modifiedEquityDelivery (const modifiedEquityDelivery_optional& x);

    void
    modifiedEquityDelivery (::std::auto_ptr< modifiedEquityDelivery_type > p);

    // Constructors.
    //
    GeneralTerms (const sellerPartyReference_type&,
                  const buyerPartyReference_type&);

    GeneralTerms (::std::auto_ptr< sellerPartyReference_type >&,
                  ::std::auto_ptr< buyerPartyReference_type >&);

    GeneralTerms (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    GeneralTerms (const GeneralTerms& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual GeneralTerms*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GeneralTerms ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    effectiveDate_optional effectiveDate_;
    scheduledTerminationDate_optional scheduledTerminationDate_;
    ::xsd::cxx::tree::one< sellerPartyReference_type > sellerPartyReference_;
    ::xsd::cxx::tree::one< buyerPartyReference_type > buyerPartyReference_;
    dateAdjustments_optional dateAdjustments_;
    referenceInformation_optional referenceInformation_;
    indexReferenceInformation_optional indexReferenceInformation_;
    basketReferenceInformation_optional basketReferenceInformation_;
    additionalTerm_sequence additionalTerm_;
    substitution_optional substitution_;
    modifiedEquityDelivery_optional modifiedEquityDelivery_;
  };

  class GracePeriodExtension: public ::xml_schema::type
  {
    public:
    // gracePeriod
    // 
    typedef ::FpML_4_2::Offset gracePeriod_type;
    typedef ::xsd::cxx::tree::optional< gracePeriod_type > gracePeriod_optional;
    typedef ::xsd::cxx::tree::traits< gracePeriod_type, char > gracePeriod_traits;

    const gracePeriod_optional&
    gracePeriod () const;

    gracePeriod_optional&
    gracePeriod ();

    void
    gracePeriod (const gracePeriod_type& x);

    void
    gracePeriod (const gracePeriod_optional& x);

    void
    gracePeriod (::std::auto_ptr< gracePeriod_type > p);

    // Constructors.
    //
    GracePeriodExtension ();

    GracePeriodExtension (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    GracePeriodExtension (const GracePeriodExtension& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual GracePeriodExtension*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GracePeriodExtension ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    gracePeriod_optional gracePeriod_;
  };

  class IndexAnnexSource: public ::xml_schema::normalized_string
  {
    public:
    // indexAnnexSourceScheme
    // 
    typedef ::xml_schema::uri indexAnnexSourceScheme_type;
    typedef ::xsd::cxx::tree::traits< indexAnnexSourceScheme_type, char > indexAnnexSourceScheme_traits;

    const indexAnnexSourceScheme_type&
    indexAnnexSourceScheme () const;

    indexAnnexSourceScheme_type&
    indexAnnexSourceScheme ();

    void
    indexAnnexSourceScheme (const indexAnnexSourceScheme_type& x);

    void
    indexAnnexSourceScheme (::std::auto_ptr< indexAnnexSourceScheme_type > p);

    static const indexAnnexSourceScheme_type&
    indexAnnexSourceScheme_default_value ();

    // Constructors.
    //
    IndexAnnexSource ();

    IndexAnnexSource (const char*);

    IndexAnnexSource (const ::std::string&);

    IndexAnnexSource (const ::xml_schema::normalized_string&);

    IndexAnnexSource (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    IndexAnnexSource (const IndexAnnexSource& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual IndexAnnexSource*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IndexAnnexSource ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< indexAnnexSourceScheme_type > indexAnnexSourceScheme_;
    static const indexAnnexSourceScheme_type indexAnnexSourceScheme_default_value_;
  };

  class IndexId: public ::xml_schema::normalized_string
  {
    public:
    // indexIdScheme
    // 
    typedef ::xml_schema::uri indexIdScheme_type;
    typedef ::xsd::cxx::tree::optional< indexIdScheme_type > indexIdScheme_optional;
    typedef ::xsd::cxx::tree::traits< indexIdScheme_type, char > indexIdScheme_traits;

    const indexIdScheme_optional&
    indexIdScheme () const;

    indexIdScheme_optional&
    indexIdScheme ();

    void
    indexIdScheme (const indexIdScheme_type& x);

    void
    indexIdScheme (const indexIdScheme_optional& x);

    void
    indexIdScheme (::std::auto_ptr< indexIdScheme_type > p);

    // Constructors.
    //
    IndexId ();

    IndexId (const char*);

    IndexId (const ::std::string&);

    IndexId (const ::xml_schema::normalized_string&);

    IndexId (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    IndexId (const IndexId& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual IndexId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IndexId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    indexIdScheme_optional indexIdScheme_;
  };

  class IndexName: public ::xml_schema::normalized_string
  {
    public:
    // indexNameScheme
    // 
    typedef ::xml_schema::uri indexNameScheme_type;
    typedef ::xsd::cxx::tree::optional< indexNameScheme_type > indexNameScheme_optional;
    typedef ::xsd::cxx::tree::traits< indexNameScheme_type, char > indexNameScheme_traits;

    const indexNameScheme_optional&
    indexNameScheme () const;

    indexNameScheme_optional&
    indexNameScheme ();

    void
    indexNameScheme (const indexNameScheme_type& x);

    void
    indexNameScheme (const indexNameScheme_optional& x);

    void
    indexNameScheme (::std::auto_ptr< indexNameScheme_type > p);

    // Constructors.
    //
    IndexName ();

    IndexName (const char*);

    IndexName (const ::std::string&);

    IndexName (const ::xml_schema::normalized_string&);

    IndexName (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    IndexName (const IndexName& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual IndexName*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IndexName ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    indexNameScheme_optional indexNameScheme_;
  };

  class IndexReferenceInformation: public ::xml_schema::type
  {
    public:
    // indexName
    // 
    typedef ::FpML_4_2::IndexName indexName_type;
    typedef ::xsd::cxx::tree::optional< indexName_type > indexName_optional;
    typedef ::xsd::cxx::tree::traits< indexName_type, char > indexName_traits;

    const indexName_optional&
    indexName () const;

    indexName_optional&
    indexName ();

    void
    indexName (const indexName_type& x);

    void
    indexName (const indexName_optional& x);

    void
    indexName (::std::auto_ptr< indexName_type > p);

    // indexId
    // 
    typedef ::FpML_4_2::IndexId indexId_type;
    typedef ::xsd::cxx::tree::sequence< indexId_type > indexId_sequence;
    typedef indexId_sequence::iterator indexId_iterator;
    typedef indexId_sequence::const_iterator indexId_const_iterator;
    typedef ::xsd::cxx::tree::traits< indexId_type, char > indexId_traits;

    const indexId_sequence&
    indexId () const;

    indexId_sequence&
    indexId ();

    void
    indexId (const indexId_sequence& s);

    // indexSeries
    // 
    typedef ::xml_schema::integer indexSeries_type;
    typedef ::xsd::cxx::tree::optional< indexSeries_type > indexSeries_optional;
    typedef ::xsd::cxx::tree::traits< indexSeries_type, char > indexSeries_traits;

    const indexSeries_optional&
    indexSeries () const;

    indexSeries_optional&
    indexSeries ();

    void
    indexSeries (const indexSeries_type& x);

    void
    indexSeries (const indexSeries_optional& x);

    // indexAnnexVersion
    // 
    typedef ::xml_schema::integer indexAnnexVersion_type;
    typedef ::xsd::cxx::tree::optional< indexAnnexVersion_type > indexAnnexVersion_optional;
    typedef ::xsd::cxx::tree::traits< indexAnnexVersion_type, char > indexAnnexVersion_traits;

    const indexAnnexVersion_optional&
    indexAnnexVersion () const;

    indexAnnexVersion_optional&
    indexAnnexVersion ();

    void
    indexAnnexVersion (const indexAnnexVersion_type& x);

    void
    indexAnnexVersion (const indexAnnexVersion_optional& x);

    // indexAnnexDate
    // 
    typedef ::xml_schema::date indexAnnexDate_type;
    typedef ::xsd::cxx::tree::optional< indexAnnexDate_type > indexAnnexDate_optional;
    typedef ::xsd::cxx::tree::traits< indexAnnexDate_type, char > indexAnnexDate_traits;

    const indexAnnexDate_optional&
    indexAnnexDate () const;

    indexAnnexDate_optional&
    indexAnnexDate ();

    void
    indexAnnexDate (const indexAnnexDate_type& x);

    void
    indexAnnexDate (const indexAnnexDate_optional& x);

    void
    indexAnnexDate (::std::auto_ptr< indexAnnexDate_type > p);

    // indexAnnexSource
    // 
    typedef ::FpML_4_2::IndexAnnexSource indexAnnexSource_type;
    typedef ::xsd::cxx::tree::optional< indexAnnexSource_type > indexAnnexSource_optional;
    typedef ::xsd::cxx::tree::traits< indexAnnexSource_type, char > indexAnnexSource_traits;

    const indexAnnexSource_optional&
    indexAnnexSource () const;

    indexAnnexSource_optional&
    indexAnnexSource ();

    void
    indexAnnexSource (const indexAnnexSource_type& x);

    void
    indexAnnexSource (const indexAnnexSource_optional& x);

    void
    indexAnnexSource (::std::auto_ptr< indexAnnexSource_type > p);

    // excludedReferenceEntity
    // 
    typedef ::FpML_4_2::LegalEntity excludedReferenceEntity_type;
    typedef ::xsd::cxx::tree::sequence< excludedReferenceEntity_type > excludedReferenceEntity_sequence;
    typedef excludedReferenceEntity_sequence::iterator excludedReferenceEntity_iterator;
    typedef excludedReferenceEntity_sequence::const_iterator excludedReferenceEntity_const_iterator;
    typedef ::xsd::cxx::tree::traits< excludedReferenceEntity_type, char > excludedReferenceEntity_traits;

    const excludedReferenceEntity_sequence&
    excludedReferenceEntity () const;

    excludedReferenceEntity_sequence&
    excludedReferenceEntity ();

    void
    excludedReferenceEntity (const excludedReferenceEntity_sequence& s);

    // tranche
    // 
    typedef ::FpML_4_2::Tranche tranche_type;
    typedef ::xsd::cxx::tree::optional< tranche_type > tranche_optional;
    typedef ::xsd::cxx::tree::traits< tranche_type, char > tranche_traits;

    const tranche_optional&
    tranche () const;

    tranche_optional&
    tranche ();

    void
    tranche (const tranche_type& x);

    void
    tranche (const tranche_optional& x);

    void
    tranche (::std::auto_ptr< tranche_type > p);

    // settledEntityMatrix
    // 
    typedef ::FpML_4_2::SettledEntityMatrix settledEntityMatrix_type;
    typedef ::xsd::cxx::tree::optional< settledEntityMatrix_type > settledEntityMatrix_optional;
    typedef ::xsd::cxx::tree::traits< settledEntityMatrix_type, char > settledEntityMatrix_traits;

    const settledEntityMatrix_optional&
    settledEntityMatrix () const;

    settledEntityMatrix_optional&
    settledEntityMatrix ();

    void
    settledEntityMatrix (const settledEntityMatrix_type& x);

    void
    settledEntityMatrix (const settledEntityMatrix_optional& x);

    void
    settledEntityMatrix (::std::auto_ptr< settledEntityMatrix_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    IndexReferenceInformation ();

    IndexReferenceInformation (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    IndexReferenceInformation (const IndexReferenceInformation& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual IndexReferenceInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IndexReferenceInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    indexName_optional indexName_;
    indexId_sequence indexId_;
    indexSeries_optional indexSeries_;
    indexAnnexVersion_optional indexAnnexVersion_;
    indexAnnexDate_optional indexAnnexDate_;
    indexAnnexSource_optional indexAnnexSource_;
    excludedReferenceEntity_sequence excludedReferenceEntity_;
    tranche_optional tranche_;
    settledEntityMatrix_optional settledEntityMatrix_;
    id_optional id_;
  };

  class InitialPayment: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // adjustablePaymentDate
    // 
    typedef ::xml_schema::date adjustablePaymentDate_type;
    typedef ::xsd::cxx::tree::optional< adjustablePaymentDate_type > adjustablePaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustablePaymentDate_type, char > adjustablePaymentDate_traits;

    const adjustablePaymentDate_optional&
    adjustablePaymentDate () const;

    adjustablePaymentDate_optional&
    adjustablePaymentDate ();

    void
    adjustablePaymentDate (const adjustablePaymentDate_type& x);

    void
    adjustablePaymentDate (const adjustablePaymentDate_optional& x);

    void
    adjustablePaymentDate (::std::auto_ptr< adjustablePaymentDate_type > p);

    // adjustedPaymentDate
    // 
    typedef ::xml_schema::date adjustedPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedPaymentDate_type > adjustedPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedPaymentDate_type, char > adjustedPaymentDate_traits;

    const adjustedPaymentDate_optional&
    adjustedPaymentDate () const;

    adjustedPaymentDate_optional&
    adjustedPaymentDate ();

    void
    adjustedPaymentDate (const adjustedPaymentDate_type& x);

    void
    adjustedPaymentDate (const adjustedPaymentDate_optional& x);

    void
    adjustedPaymentDate (::std::auto_ptr< adjustedPaymentDate_type > p);

    // paymentAmount
    // 
    typedef ::FpML_4_2::Money paymentAmount_type;
    typedef ::xsd::cxx::tree::traits< paymentAmount_type, char > paymentAmount_traits;

    const paymentAmount_type&
    paymentAmount () const;

    paymentAmount_type&
    paymentAmount ();

    void
    paymentAmount (const paymentAmount_type& x);

    void
    paymentAmount (::std::auto_ptr< paymentAmount_type > p);

    // Constructors.
    //
    InitialPayment (const payerPartyReference_type&,
                    const receiverPartyReference_type&,
                    const paymentAmount_type&);

    InitialPayment (::std::auto_ptr< payerPartyReference_type >&,
                    ::std::auto_ptr< receiverPartyReference_type >&,
                    ::std::auto_ptr< paymentAmount_type >&);

    InitialPayment (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    InitialPayment (const InitialPayment& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual InitialPayment*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InitialPayment ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    adjustablePaymentDate_optional adjustablePaymentDate_;
    adjustedPaymentDate_optional adjustedPaymentDate_;
    ::xsd::cxx::tree::one< paymentAmount_type > paymentAmount_;
  };

  class PCDeliverableObligationCharac: public ::xml_schema::type
  {
    public:
    // partialCashSettlement
    // 
    typedef ::FpML_4_2::Empty partialCashSettlement_type;
    typedef ::xsd::cxx::tree::optional< partialCashSettlement_type > partialCashSettlement_optional;
    typedef ::xsd::cxx::tree::traits< partialCashSettlement_type, char > partialCashSettlement_traits;

    const partialCashSettlement_optional&
    partialCashSettlement () const;

    partialCashSettlement_optional&
    partialCashSettlement ();

    void
    partialCashSettlement (const partialCashSettlement_type& x);

    void
    partialCashSettlement (const partialCashSettlement_optional& x);

    void
    partialCashSettlement (::std::auto_ptr< partialCashSettlement_type > p);

    // Constructors.
    //
    PCDeliverableObligationCharac ();

    PCDeliverableObligationCharac (const ::xercesc::DOMElement& e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    PCDeliverableObligationCharac (const PCDeliverableObligationCharac& x,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    virtual PCDeliverableObligationCharac*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PCDeliverableObligationCharac ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    partialCashSettlement_optional partialCashSettlement_;
  };

  class LoanParticipation: public ::FpML_4_2::PCDeliverableObligationCharac
  {
    public:
    // qualifyingParticipationSeller
    // 
    typedef ::xml_schema::string qualifyingParticipationSeller_type;
    typedef ::xsd::cxx::tree::optional< qualifyingParticipationSeller_type > qualifyingParticipationSeller_optional;
    typedef ::xsd::cxx::tree::traits< qualifyingParticipationSeller_type, char > qualifyingParticipationSeller_traits;

    const qualifyingParticipationSeller_optional&
    qualifyingParticipationSeller () const;

    qualifyingParticipationSeller_optional&
    qualifyingParticipationSeller ();

    void
    qualifyingParticipationSeller (const qualifyingParticipationSeller_type& x);

    void
    qualifyingParticipationSeller (const qualifyingParticipationSeller_optional& x);

    void
    qualifyingParticipationSeller (::std::auto_ptr< qualifyingParticipationSeller_type > p);

    // Constructors.
    //
    LoanParticipation ();

    LoanParticipation (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    LoanParticipation (const LoanParticipation& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual LoanParticipation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~LoanParticipation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    qualifyingParticipationSeller_optional qualifyingParticipationSeller_;
  };

  class MatrixSource: public ::xml_schema::normalized_string
  {
    public:
    // settledEntityMatrixSourceScheme
    // 
    typedef ::xml_schema::uri settledEntityMatrixSourceScheme_type;
    typedef ::xsd::cxx::tree::traits< settledEntityMatrixSourceScheme_type, char > settledEntityMatrixSourceScheme_traits;

    const settledEntityMatrixSourceScheme_type&
    settledEntityMatrixSourceScheme () const;

    settledEntityMatrixSourceScheme_type&
    settledEntityMatrixSourceScheme ();

    void
    settledEntityMatrixSourceScheme (const settledEntityMatrixSourceScheme_type& x);

    void
    settledEntityMatrixSourceScheme (::std::auto_ptr< settledEntityMatrixSourceScheme_type > p);

    static const settledEntityMatrixSourceScheme_type&
    settledEntityMatrixSourceScheme_default_value ();

    // Constructors.
    //
    MatrixSource ();

    MatrixSource (const char*);

    MatrixSource (const ::std::string&);

    MatrixSource (const ::xml_schema::normalized_string&);

    MatrixSource (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    MatrixSource (const MatrixSource& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual MatrixSource*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MatrixSource ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< settledEntityMatrixSourceScheme_type > settledEntityMatrixSourceScheme_;
    static const settledEntityMatrixSourceScheme_type settledEntityMatrixSourceScheme_default_value_;
  };

  class SingleValuationDate: public ::xml_schema::type
  {
    public:
    // businessDays
    // 
    typedef ::xml_schema::non_negative_integer businessDays_type;
    typedef ::xsd::cxx::tree::optional< businessDays_type > businessDays_optional;
    typedef ::xsd::cxx::tree::traits< businessDays_type, char > businessDays_traits;

    const businessDays_optional&
    businessDays () const;

    businessDays_optional&
    businessDays ();

    void
    businessDays (const businessDays_type& x);

    void
    businessDays (const businessDays_optional& x);

    // Constructors.
    //
    SingleValuationDate ();

    SingleValuationDate (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    SingleValuationDate (const SingleValuationDate& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual SingleValuationDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SingleValuationDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    businessDays_optional businessDays_;
  };

  class MultipleValuationDates: public ::FpML_4_2::SingleValuationDate
  {
    public:
    // businessDaysThereafter
    // 
    typedef ::xml_schema::positive_integer businessDaysThereafter_type;
    typedef ::xsd::cxx::tree::optional< businessDaysThereafter_type > businessDaysThereafter_optional;
    typedef ::xsd::cxx::tree::traits< businessDaysThereafter_type, char > businessDaysThereafter_traits;

    const businessDaysThereafter_optional&
    businessDaysThereafter () const;

    businessDaysThereafter_optional&
    businessDaysThereafter ();

    void
    businessDaysThereafter (const businessDaysThereafter_type& x);

    void
    businessDaysThereafter (const businessDaysThereafter_optional& x);

    // numberValuationDates
    // 
    typedef ::xml_schema::positive_integer numberValuationDates_type;
    typedef ::xsd::cxx::tree::optional< numberValuationDates_type > numberValuationDates_optional;
    typedef ::xsd::cxx::tree::traits< numberValuationDates_type, char > numberValuationDates_traits;

    const numberValuationDates_optional&
    numberValuationDates () const;

    numberValuationDates_optional&
    numberValuationDates ();

    void
    numberValuationDates (const numberValuationDates_type& x);

    void
    numberValuationDates (const numberValuationDates_optional& x);

    // Constructors.
    //
    MultipleValuationDates ();

    MultipleValuationDates (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    MultipleValuationDates (const MultipleValuationDates& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual MultipleValuationDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MultipleValuationDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    businessDaysThereafter_optional businessDaysThereafter_;
    numberValuationDates_optional numberValuationDates_;
  };

  class NotDomesticCurrency: public ::xml_schema::type
  {
    public:
    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::optional< currency_type > currency_optional;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_optional&
    currency () const;

    currency_optional&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (const currency_optional& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // Constructors.
    //
    NotDomesticCurrency ();

    NotDomesticCurrency (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    NotDomesticCurrency (const NotDomesticCurrency& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual NotDomesticCurrency*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NotDomesticCurrency ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    currency_optional currency_;
  };

  class NotifyingParty: public ::xml_schema::type
  {
    public:
    // buyerPartyReference
    // 
    typedef ::FpML_4_2::PartyReference buyerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< buyerPartyReference_type, char > buyerPartyReference_traits;

    const buyerPartyReference_type&
    buyerPartyReference () const;

    buyerPartyReference_type&
    buyerPartyReference ();

    void
    buyerPartyReference (const buyerPartyReference_type& x);

    void
    buyerPartyReference (::std::auto_ptr< buyerPartyReference_type > p);

    // sellerPartyReference
    // 
    typedef ::FpML_4_2::PartyReference sellerPartyReference_type;
    typedef ::xsd::cxx::tree::optional< sellerPartyReference_type > sellerPartyReference_optional;
    typedef ::xsd::cxx::tree::traits< sellerPartyReference_type, char > sellerPartyReference_traits;

    const sellerPartyReference_optional&
    sellerPartyReference () const;

    sellerPartyReference_optional&
    sellerPartyReference ();

    void
    sellerPartyReference (const sellerPartyReference_type& x);

    void
    sellerPartyReference (const sellerPartyReference_optional& x);

    void
    sellerPartyReference (::std::auto_ptr< sellerPartyReference_type > p);

    // Constructors.
    //
    NotifyingParty (const buyerPartyReference_type&);

    NotifyingParty (::std::auto_ptr< buyerPartyReference_type >&);

    NotifyingParty (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    NotifyingParty (const NotifyingParty& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual NotifyingParty*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NotifyingParty ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< buyerPartyReference_type > buyerPartyReference_;
    sellerPartyReference_optional sellerPartyReference_;
  };

  class Obligations: public ::xml_schema::type
  {
    public:
    // category
    // 
    typedef ::FpML_4_2::ObligationCategoryEnum category_type;
    typedef ::xsd::cxx::tree::traits< category_type, char > category_traits;

    const category_type&
    category () const;

    category_type&
    category ();

    void
    category (const category_type& x);

    void
    category (::std::auto_ptr< category_type > p);

    // notSubordinated
    // 
    typedef ::FpML_4_2::Empty notSubordinated_type;
    typedef ::xsd::cxx::tree::optional< notSubordinated_type > notSubordinated_optional;
    typedef ::xsd::cxx::tree::traits< notSubordinated_type, char > notSubordinated_traits;

    const notSubordinated_optional&
    notSubordinated () const;

    notSubordinated_optional&
    notSubordinated ();

    void
    notSubordinated (const notSubordinated_type& x);

    void
    notSubordinated (const notSubordinated_optional& x);

    void
    notSubordinated (::std::auto_ptr< notSubordinated_type > p);

    // specifiedCurrency
    // 
    typedef ::FpML_4_2::SpecifiedCurrency specifiedCurrency_type;
    typedef ::xsd::cxx::tree::optional< specifiedCurrency_type > specifiedCurrency_optional;
    typedef ::xsd::cxx::tree::traits< specifiedCurrency_type, char > specifiedCurrency_traits;

    const specifiedCurrency_optional&
    specifiedCurrency () const;

    specifiedCurrency_optional&
    specifiedCurrency ();

    void
    specifiedCurrency (const specifiedCurrency_type& x);

    void
    specifiedCurrency (const specifiedCurrency_optional& x);

    void
    specifiedCurrency (::std::auto_ptr< specifiedCurrency_type > p);

    // notSovereignLender
    // 
    typedef ::FpML_4_2::Empty notSovereignLender_type;
    typedef ::xsd::cxx::tree::optional< notSovereignLender_type > notSovereignLender_optional;
    typedef ::xsd::cxx::tree::traits< notSovereignLender_type, char > notSovereignLender_traits;

    const notSovereignLender_optional&
    notSovereignLender () const;

    notSovereignLender_optional&
    notSovereignLender ();

    void
    notSovereignLender (const notSovereignLender_type& x);

    void
    notSovereignLender (const notSovereignLender_optional& x);

    void
    notSovereignLender (::std::auto_ptr< notSovereignLender_type > p);

    // notDomesticCurrency
    // 
    typedef ::FpML_4_2::NotDomesticCurrency notDomesticCurrency_type;
    typedef ::xsd::cxx::tree::optional< notDomesticCurrency_type > notDomesticCurrency_optional;
    typedef ::xsd::cxx::tree::traits< notDomesticCurrency_type, char > notDomesticCurrency_traits;

    const notDomesticCurrency_optional&
    notDomesticCurrency () const;

    notDomesticCurrency_optional&
    notDomesticCurrency ();

    void
    notDomesticCurrency (const notDomesticCurrency_type& x);

    void
    notDomesticCurrency (const notDomesticCurrency_optional& x);

    void
    notDomesticCurrency (::std::auto_ptr< notDomesticCurrency_type > p);

    // notDomesticLaw
    // 
    typedef ::FpML_4_2::Empty notDomesticLaw_type;
    typedef ::xsd::cxx::tree::optional< notDomesticLaw_type > notDomesticLaw_optional;
    typedef ::xsd::cxx::tree::traits< notDomesticLaw_type, char > notDomesticLaw_traits;

    const notDomesticLaw_optional&
    notDomesticLaw () const;

    notDomesticLaw_optional&
    notDomesticLaw ();

    void
    notDomesticLaw (const notDomesticLaw_type& x);

    void
    notDomesticLaw (const notDomesticLaw_optional& x);

    void
    notDomesticLaw (::std::auto_ptr< notDomesticLaw_type > p);

    // listed
    // 
    typedef ::FpML_4_2::Empty listed_type;
    typedef ::xsd::cxx::tree::optional< listed_type > listed_optional;
    typedef ::xsd::cxx::tree::traits< listed_type, char > listed_traits;

    const listed_optional&
    listed () const;

    listed_optional&
    listed ();

    void
    listed (const listed_type& x);

    void
    listed (const listed_optional& x);

    void
    listed (::std::auto_ptr< listed_type > p);

    // notDomesticIssuance
    // 
    typedef ::FpML_4_2::Empty notDomesticIssuance_type;
    typedef ::xsd::cxx::tree::optional< notDomesticIssuance_type > notDomesticIssuance_optional;
    typedef ::xsd::cxx::tree::traits< notDomesticIssuance_type, char > notDomesticIssuance_traits;

    const notDomesticIssuance_optional&
    notDomesticIssuance () const;

    notDomesticIssuance_optional&
    notDomesticIssuance ();

    void
    notDomesticIssuance (const notDomesticIssuance_type& x);

    void
    notDomesticIssuance (const notDomesticIssuance_optional& x);

    void
    notDomesticIssuance (::std::auto_ptr< notDomesticIssuance_type > p);

    // fullFaithAndCreditObLiability
    // 
    typedef ::FpML_4_2::Empty fullFaithAndCreditObLiability_type;
    typedef ::xsd::cxx::tree::optional< fullFaithAndCreditObLiability_type > fullFaithAndCreditObLiability_optional;
    typedef ::xsd::cxx::tree::traits< fullFaithAndCreditObLiability_type, char > fullFaithAndCreditObLiability_traits;

    const fullFaithAndCreditObLiability_optional&
    fullFaithAndCreditObLiability () const;

    fullFaithAndCreditObLiability_optional&
    fullFaithAndCreditObLiability ();

    void
    fullFaithAndCreditObLiability (const fullFaithAndCreditObLiability_type& x);

    void
    fullFaithAndCreditObLiability (const fullFaithAndCreditObLiability_optional& x);

    void
    fullFaithAndCreditObLiability (::std::auto_ptr< fullFaithAndCreditObLiability_type > p);

    // generalFundObligationLiability
    // 
    typedef ::FpML_4_2::Empty generalFundObligationLiability_type;
    typedef ::xsd::cxx::tree::optional< generalFundObligationLiability_type > generalFundObligationLiability_optional;
    typedef ::xsd::cxx::tree::traits< generalFundObligationLiability_type, char > generalFundObligationLiability_traits;

    const generalFundObligationLiability_optional&
    generalFundObligationLiability () const;

    generalFundObligationLiability_optional&
    generalFundObligationLiability ();

    void
    generalFundObligationLiability (const generalFundObligationLiability_type& x);

    void
    generalFundObligationLiability (const generalFundObligationLiability_optional& x);

    void
    generalFundObligationLiability (::std::auto_ptr< generalFundObligationLiability_type > p);

    // revenueObligationLiability
    // 
    typedef ::FpML_4_2::Empty revenueObligationLiability_type;
    typedef ::xsd::cxx::tree::optional< revenueObligationLiability_type > revenueObligationLiability_optional;
    typedef ::xsd::cxx::tree::traits< revenueObligationLiability_type, char > revenueObligationLiability_traits;

    const revenueObligationLiability_optional&
    revenueObligationLiability () const;

    revenueObligationLiability_optional&
    revenueObligationLiability ();

    void
    revenueObligationLiability (const revenueObligationLiability_type& x);

    void
    revenueObligationLiability (const revenueObligationLiability_optional& x);

    void
    revenueObligationLiability (::std::auto_ptr< revenueObligationLiability_type > p);

    // notContingent
    // 
    typedef ::FpML_4_2::Empty notContingent_type;
    typedef ::xsd::cxx::tree::optional< notContingent_type > notContingent_optional;
    typedef ::xsd::cxx::tree::traits< notContingent_type, char > notContingent_traits;

    const notContingent_optional&
    notContingent () const;

    notContingent_optional&
    notContingent ();

    void
    notContingent (const notContingent_type& x);

    void
    notContingent (const notContingent_optional& x);

    void
    notContingent (::std::auto_ptr< notContingent_type > p);

    // excluded
    // 
    typedef ::xml_schema::string excluded_type;
    typedef ::xsd::cxx::tree::optional< excluded_type > excluded_optional;
    typedef ::xsd::cxx::tree::traits< excluded_type, char > excluded_traits;

    const excluded_optional&
    excluded () const;

    excluded_optional&
    excluded ();

    void
    excluded (const excluded_type& x);

    void
    excluded (const excluded_optional& x);

    void
    excluded (::std::auto_ptr< excluded_type > p);

    // othReferenceEntityObligations
    // 
    typedef ::xml_schema::string othReferenceEntityObligations_type;
    typedef ::xsd::cxx::tree::optional< othReferenceEntityObligations_type > othReferenceEntityObligations_optional;
    typedef ::xsd::cxx::tree::traits< othReferenceEntityObligations_type, char > othReferenceEntityObligations_traits;

    const othReferenceEntityObligations_optional&
    othReferenceEntityObligations () const;

    othReferenceEntityObligations_optional&
    othReferenceEntityObligations ();

    void
    othReferenceEntityObligations (const othReferenceEntityObligations_type& x);

    void
    othReferenceEntityObligations (const othReferenceEntityObligations_optional& x);

    void
    othReferenceEntityObligations (::std::auto_ptr< othReferenceEntityObligations_type > p);

    // Constructors.
    //
    Obligations (const category_type&);

    Obligations (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    Obligations (const Obligations& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual Obligations*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Obligations ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< category_type > category_;
    notSubordinated_optional notSubordinated_;
    specifiedCurrency_optional specifiedCurrency_;
    notSovereignLender_optional notSovereignLender_;
    notDomesticCurrency_optional notDomesticCurrency_;
    notDomesticLaw_optional notDomesticLaw_;
    listed_optional listed_;
    notDomesticIssuance_optional notDomesticIssuance_;
    fullFaithAndCreditObLiability_optional fullFaithAndCreditObLiability_;
    generalFundObligationLiability_optional generalFundObligationLiability_;
    revenueObligationLiability_optional revenueObligationLiability_;
    notContingent_optional notContingent_;
    excluded_optional excluded_;
    othReferenceEntityObligations_optional othReferenceEntityObligations_;
  };

  class PeriodicPayment: public ::xml_schema::type
  {
    public:
    // paymentFrequency
    // 
    typedef ::FpML_4_2::Interval paymentFrequency_type;
    typedef ::xsd::cxx::tree::optional< paymentFrequency_type > paymentFrequency_optional;
    typedef ::xsd::cxx::tree::traits< paymentFrequency_type, char > paymentFrequency_traits;

    const paymentFrequency_optional&
    paymentFrequency () const;

    paymentFrequency_optional&
    paymentFrequency ();

    void
    paymentFrequency (const paymentFrequency_type& x);

    void
    paymentFrequency (const paymentFrequency_optional& x);

    void
    paymentFrequency (::std::auto_ptr< paymentFrequency_type > p);

    // firstPeriodStartDate
    // 
    typedef ::xml_schema::date firstPeriodStartDate_type;
    typedef ::xsd::cxx::tree::optional< firstPeriodStartDate_type > firstPeriodStartDate_optional;
    typedef ::xsd::cxx::tree::traits< firstPeriodStartDate_type, char > firstPeriodStartDate_traits;

    const firstPeriodStartDate_optional&
    firstPeriodStartDate () const;

    firstPeriodStartDate_optional&
    firstPeriodStartDate ();

    void
    firstPeriodStartDate (const firstPeriodStartDate_type& x);

    void
    firstPeriodStartDate (const firstPeriodStartDate_optional& x);

    void
    firstPeriodStartDate (::std::auto_ptr< firstPeriodStartDate_type > p);

    // firstPaymentDate
    // 
    typedef ::xml_schema::date firstPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< firstPaymentDate_type > firstPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< firstPaymentDate_type, char > firstPaymentDate_traits;

    const firstPaymentDate_optional&
    firstPaymentDate () const;

    firstPaymentDate_optional&
    firstPaymentDate ();

    void
    firstPaymentDate (const firstPaymentDate_type& x);

    void
    firstPaymentDate (const firstPaymentDate_optional& x);

    void
    firstPaymentDate (::std::auto_ptr< firstPaymentDate_type > p);

    // lastRegularPaymentDate
    // 
    typedef ::xml_schema::date lastRegularPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< lastRegularPaymentDate_type > lastRegularPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< lastRegularPaymentDate_type, char > lastRegularPaymentDate_traits;

    const lastRegularPaymentDate_optional&
    lastRegularPaymentDate () const;

    lastRegularPaymentDate_optional&
    lastRegularPaymentDate ();

    void
    lastRegularPaymentDate (const lastRegularPaymentDate_type& x);

    void
    lastRegularPaymentDate (const lastRegularPaymentDate_optional& x);

    void
    lastRegularPaymentDate (::std::auto_ptr< lastRegularPaymentDate_type > p);

    // rollConvention
    // 
    typedef ::FpML_4_2::RollConventionEnum rollConvention_type;
    typedef ::xsd::cxx::tree::optional< rollConvention_type > rollConvention_optional;
    typedef ::xsd::cxx::tree::traits< rollConvention_type, char > rollConvention_traits;

    const rollConvention_optional&
    rollConvention () const;

    rollConvention_optional&
    rollConvention ();

    void
    rollConvention (const rollConvention_type& x);

    void
    rollConvention (const rollConvention_optional& x);

    void
    rollConvention (::std::auto_ptr< rollConvention_type > p);

    // fixedAmount
    // 
    typedef ::FpML_4_2::Money fixedAmount_type;
    typedef ::xsd::cxx::tree::optional< fixedAmount_type > fixedAmount_optional;
    typedef ::xsd::cxx::tree::traits< fixedAmount_type, char > fixedAmount_traits;

    const fixedAmount_optional&
    fixedAmount () const;

    fixedAmount_optional&
    fixedAmount ();

    void
    fixedAmount (const fixedAmount_type& x);

    void
    fixedAmount (const fixedAmount_optional& x);

    void
    fixedAmount (::std::auto_ptr< fixedAmount_type > p);

    // fixedAmountCalculation
    // 
    typedef ::FpML_4_2::FixedAmountCalculation fixedAmountCalculation_type;
    typedef ::xsd::cxx::tree::optional< fixedAmountCalculation_type > fixedAmountCalculation_optional;
    typedef ::xsd::cxx::tree::traits< fixedAmountCalculation_type, char > fixedAmountCalculation_traits;

    const fixedAmountCalculation_optional&
    fixedAmountCalculation () const;

    fixedAmountCalculation_optional&
    fixedAmountCalculation ();

    void
    fixedAmountCalculation (const fixedAmountCalculation_type& x);

    void
    fixedAmountCalculation (const fixedAmountCalculation_optional& x);

    void
    fixedAmountCalculation (::std::auto_ptr< fixedAmountCalculation_type > p);

    // adjustedPaymentDates
    // 
    typedef ::FpML_4_2::AdjustedPaymentDates adjustedPaymentDates_type;
    typedef ::xsd::cxx::tree::sequence< adjustedPaymentDates_type > adjustedPaymentDates_sequence;
    typedef adjustedPaymentDates_sequence::iterator adjustedPaymentDates_iterator;
    typedef adjustedPaymentDates_sequence::const_iterator adjustedPaymentDates_const_iterator;
    typedef ::xsd::cxx::tree::traits< adjustedPaymentDates_type, char > adjustedPaymentDates_traits;

    const adjustedPaymentDates_sequence&
    adjustedPaymentDates () const;

    adjustedPaymentDates_sequence&
    adjustedPaymentDates ();

    void
    adjustedPaymentDates (const adjustedPaymentDates_sequence& s);

    // Constructors.
    //
    PeriodicPayment ();

    PeriodicPayment (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    PeriodicPayment (const PeriodicPayment& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual PeriodicPayment*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PeriodicPayment ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    paymentFrequency_optional paymentFrequency_;
    firstPeriodStartDate_optional firstPeriodStartDate_;
    firstPaymentDate_optional firstPaymentDate_;
    lastRegularPaymentDate_optional lastRegularPaymentDate_;
    rollConvention_optional rollConvention_;
    fixedAmount_optional fixedAmount_;
    fixedAmountCalculation_optional fixedAmountCalculation_;
    adjustedPaymentDates_sequence adjustedPaymentDates_;
  };

  class PhysicalSettlementPeriod: public ::xml_schema::type
  {
    public:
    // businessDaysNotSpecified
    // 
    typedef ::FpML_4_2::Empty businessDaysNotSpecified_type;
    typedef ::xsd::cxx::tree::optional< businessDaysNotSpecified_type > businessDaysNotSpecified_optional;
    typedef ::xsd::cxx::tree::traits< businessDaysNotSpecified_type, char > businessDaysNotSpecified_traits;

    const businessDaysNotSpecified_optional&
    businessDaysNotSpecified () const;

    businessDaysNotSpecified_optional&
    businessDaysNotSpecified ();

    void
    businessDaysNotSpecified (const businessDaysNotSpecified_type& x);

    void
    businessDaysNotSpecified (const businessDaysNotSpecified_optional& x);

    void
    businessDaysNotSpecified (::std::auto_ptr< businessDaysNotSpecified_type > p);

    // businessDays
    // 
    typedef ::xml_schema::non_negative_integer businessDays_type;
    typedef ::xsd::cxx::tree::optional< businessDays_type > businessDays_optional;
    typedef ::xsd::cxx::tree::traits< businessDays_type, char > businessDays_traits;

    const businessDays_optional&
    businessDays () const;

    businessDays_optional&
    businessDays ();

    void
    businessDays (const businessDays_type& x);

    void
    businessDays (const businessDays_optional& x);

    // maximumBusinessDays
    // 
    typedef ::xml_schema::non_negative_integer maximumBusinessDays_type;
    typedef ::xsd::cxx::tree::optional< maximumBusinessDays_type > maximumBusinessDays_optional;
    typedef ::xsd::cxx::tree::traits< maximumBusinessDays_type, char > maximumBusinessDays_traits;

    const maximumBusinessDays_optional&
    maximumBusinessDays () const;

    maximumBusinessDays_optional&
    maximumBusinessDays ();

    void
    maximumBusinessDays (const maximumBusinessDays_type& x);

    void
    maximumBusinessDays (const maximumBusinessDays_optional& x);

    // Constructors.
    //
    PhysicalSettlementPeriod ();

    PhysicalSettlementPeriod (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    PhysicalSettlementPeriod (const PhysicalSettlementPeriod& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual PhysicalSettlementPeriod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PhysicalSettlementPeriod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    businessDaysNotSpecified_optional businessDaysNotSpecified_;
    businessDays_optional businessDays_;
    maximumBusinessDays_optional maximumBusinessDays_;
  };

  class PhysicalSettlementTerms: public ::FpML_4_2::SettlementTerms
  {
    public:
    // physicalSettlementPeriod
    // 
    typedef ::FpML_4_2::PhysicalSettlementPeriod physicalSettlementPeriod_type;
    typedef ::xsd::cxx::tree::optional< physicalSettlementPeriod_type > physicalSettlementPeriod_optional;
    typedef ::xsd::cxx::tree::traits< physicalSettlementPeriod_type, char > physicalSettlementPeriod_traits;

    const physicalSettlementPeriod_optional&
    physicalSettlementPeriod () const;

    physicalSettlementPeriod_optional&
    physicalSettlementPeriod ();

    void
    physicalSettlementPeriod (const physicalSettlementPeriod_type& x);

    void
    physicalSettlementPeriod (const physicalSettlementPeriod_optional& x);

    void
    physicalSettlementPeriod (::std::auto_ptr< physicalSettlementPeriod_type > p);

    // deliverableObligations
    // 
    typedef ::FpML_4_2::DeliverableObligations deliverableObligations_type;
    typedef ::xsd::cxx::tree::optional< deliverableObligations_type > deliverableObligations_optional;
    typedef ::xsd::cxx::tree::traits< deliverableObligations_type, char > deliverableObligations_traits;

    const deliverableObligations_optional&
    deliverableObligations () const;

    deliverableObligations_optional&
    deliverableObligations ();

    void
    deliverableObligations (const deliverableObligations_type& x);

    void
    deliverableObligations (const deliverableObligations_optional& x);

    void
    deliverableObligations (::std::auto_ptr< deliverableObligations_type > p);

    // escrow
    // 
    typedef ::xml_schema::boolean escrow_type;
    typedef ::xsd::cxx::tree::optional< escrow_type > escrow_optional;
    typedef ::xsd::cxx::tree::traits< escrow_type, char > escrow_traits;

    const escrow_optional&
    escrow () const;

    escrow_optional&
    escrow ();

    void
    escrow (const escrow_type& x);

    void
    escrow (const escrow_optional& x);

    // sixtyBusinessDaySettlementCap
    // 
    typedef ::xml_schema::boolean sixtyBusinessDaySettlementCap_type;
    typedef ::xsd::cxx::tree::optional< sixtyBusinessDaySettlementCap_type > sixtyBusinessDaySettlementCap_optional;
    typedef ::xsd::cxx::tree::traits< sixtyBusinessDaySettlementCap_type, char > sixtyBusinessDaySettlementCap_traits;

    const sixtyBusinessDaySettlementCap_optional&
    sixtyBusinessDaySettlementCap () const;

    sixtyBusinessDaySettlementCap_optional&
    sixtyBusinessDaySettlementCap ();

    void
    sixtyBusinessDaySettlementCap (const sixtyBusinessDaySettlementCap_type& x);

    void
    sixtyBusinessDaySettlementCap (const sixtyBusinessDaySettlementCap_optional& x);

    // Constructors.
    //
    PhysicalSettlementTerms ();

    PhysicalSettlementTerms (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    PhysicalSettlementTerms (const PhysicalSettlementTerms& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual PhysicalSettlementTerms*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PhysicalSettlementTerms ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    physicalSettlementPeriod_optional physicalSettlementPeriod_;
    deliverableObligations_optional deliverableObligations_;
    escrow_optional escrow_;
    sixtyBusinessDaySettlementCap_optional sixtyBusinessDaySettlementCap_;
  };

  class ProtectionTerms: public ::xml_schema::type
  {
    public:
    // calculationAmount
    // 
    typedef ::FpML_4_2::Money calculationAmount_type;
    typedef ::xsd::cxx::tree::traits< calculationAmount_type, char > calculationAmount_traits;

    const calculationAmount_type&
    calculationAmount () const;

    calculationAmount_type&
    calculationAmount ();

    void
    calculationAmount (const calculationAmount_type& x);

    void
    calculationAmount (::std::auto_ptr< calculationAmount_type > p);

    // creditEvents
    // 
    typedef ::FpML_4_2::CreditEvents creditEvents_type;
    typedef ::xsd::cxx::tree::optional< creditEvents_type > creditEvents_optional;
    typedef ::xsd::cxx::tree::traits< creditEvents_type, char > creditEvents_traits;

    const creditEvents_optional&
    creditEvents () const;

    creditEvents_optional&
    creditEvents ();

    void
    creditEvents (const creditEvents_type& x);

    void
    creditEvents (const creditEvents_optional& x);

    void
    creditEvents (::std::auto_ptr< creditEvents_type > p);

    // obligations
    // 
    typedef ::FpML_4_2::Obligations obligations_type;
    typedef ::xsd::cxx::tree::optional< obligations_type > obligations_optional;
    typedef ::xsd::cxx::tree::traits< obligations_type, char > obligations_traits;

    const obligations_optional&
    obligations () const;

    obligations_optional&
    obligations ();

    void
    obligations (const obligations_type& x);

    void
    obligations (const obligations_optional& x);

    void
    obligations (::std::auto_ptr< obligations_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    ProtectionTerms (const calculationAmount_type&);

    ProtectionTerms (::std::auto_ptr< calculationAmount_type >&);

    ProtectionTerms (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    ProtectionTerms (const ProtectionTerms& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual ProtectionTerms*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ProtectionTerms ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< calculationAmount_type > calculationAmount_;
    creditEvents_optional creditEvents_;
    obligations_optional obligations_;
    id_optional id_;
  };

  class ProtectionTermsReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    ProtectionTermsReference (const href_type&);

    ProtectionTermsReference (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    ProtectionTermsReference (const ProtectionTermsReference& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual ProtectionTermsReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ProtectionTermsReference ();
  };

  class PubliclyAvailableInformation: public ::xml_schema::type
  {
    public:
    // standardPublicSources
    // 
    typedef ::FpML_4_2::Empty standardPublicSources_type;
    typedef ::xsd::cxx::tree::optional< standardPublicSources_type > standardPublicSources_optional;
    typedef ::xsd::cxx::tree::traits< standardPublicSources_type, char > standardPublicSources_traits;

    const standardPublicSources_optional&
    standardPublicSources () const;

    standardPublicSources_optional&
    standardPublicSources ();

    void
    standardPublicSources (const standardPublicSources_type& x);

    void
    standardPublicSources (const standardPublicSources_optional& x);

    void
    standardPublicSources (::std::auto_ptr< standardPublicSources_type > p);

    // publicSource
    // 
    typedef ::xml_schema::string publicSource_type;
    typedef ::xsd::cxx::tree::sequence< publicSource_type > publicSource_sequence;
    typedef publicSource_sequence::iterator publicSource_iterator;
    typedef publicSource_sequence::const_iterator publicSource_const_iterator;
    typedef ::xsd::cxx::tree::traits< publicSource_type, char > publicSource_traits;

    const publicSource_sequence&
    publicSource () const;

    publicSource_sequence&
    publicSource ();

    void
    publicSource (const publicSource_sequence& s);

    // specifiedNumber
    // 
    typedef ::xml_schema::positive_integer specifiedNumber_type;
    typedef ::xsd::cxx::tree::optional< specifiedNumber_type > specifiedNumber_optional;
    typedef ::xsd::cxx::tree::traits< specifiedNumber_type, char > specifiedNumber_traits;

    const specifiedNumber_optional&
    specifiedNumber () const;

    specifiedNumber_optional&
    specifiedNumber ();

    void
    specifiedNumber (const specifiedNumber_type& x);

    void
    specifiedNumber (const specifiedNumber_optional& x);

    // Constructors.
    //
    PubliclyAvailableInformation ();

    PubliclyAvailableInformation (const ::xercesc::DOMElement& e,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    PubliclyAvailableInformation (const PubliclyAvailableInformation& x,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    virtual PubliclyAvailableInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PubliclyAvailableInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    standardPublicSources_optional standardPublicSources_;
    publicSource_sequence publicSource_;
    specifiedNumber_optional specifiedNumber_;
  };

  class ReferenceInformation: public ::xml_schema::type
  {
    public:
    // referenceEntity
    // 
    typedef ::FpML_4_2::LegalEntity referenceEntity_type;
    typedef ::xsd::cxx::tree::traits< referenceEntity_type, char > referenceEntity_traits;

    const referenceEntity_type&
    referenceEntity () const;

    referenceEntity_type&
    referenceEntity ();

    void
    referenceEntity (const referenceEntity_type& x);

    void
    referenceEntity (::std::auto_ptr< referenceEntity_type > p);

    // referenceObligation
    // 
    typedef ::FpML_4_2::ReferenceObligation referenceObligation_type;
    typedef ::xsd::cxx::tree::sequence< referenceObligation_type > referenceObligation_sequence;
    typedef referenceObligation_sequence::iterator referenceObligation_iterator;
    typedef referenceObligation_sequence::const_iterator referenceObligation_const_iterator;
    typedef ::xsd::cxx::tree::traits< referenceObligation_type, char > referenceObligation_traits;

    const referenceObligation_sequence&
    referenceObligation () const;

    referenceObligation_sequence&
    referenceObligation ();

    void
    referenceObligation (const referenceObligation_sequence& s);

    // noReferenceObligation
    // 
    typedef ::FpML_4_2::Empty noReferenceObligation_type;
    typedef ::xsd::cxx::tree::optional< noReferenceObligation_type > noReferenceObligation_optional;
    typedef ::xsd::cxx::tree::traits< noReferenceObligation_type, char > noReferenceObligation_traits;

    const noReferenceObligation_optional&
    noReferenceObligation () const;

    noReferenceObligation_optional&
    noReferenceObligation ();

    void
    noReferenceObligation (const noReferenceObligation_type& x);

    void
    noReferenceObligation (const noReferenceObligation_optional& x);

    void
    noReferenceObligation (::std::auto_ptr< noReferenceObligation_type > p);

    // unknownReferenceObligation
    // 
    typedef ::FpML_4_2::Empty unknownReferenceObligation_type;
    typedef ::xsd::cxx::tree::optional< unknownReferenceObligation_type > unknownReferenceObligation_optional;
    typedef ::xsd::cxx::tree::traits< unknownReferenceObligation_type, char > unknownReferenceObligation_traits;

    const unknownReferenceObligation_optional&
    unknownReferenceObligation () const;

    unknownReferenceObligation_optional&
    unknownReferenceObligation ();

    void
    unknownReferenceObligation (const unknownReferenceObligation_type& x);

    void
    unknownReferenceObligation (const unknownReferenceObligation_optional& x);

    void
    unknownReferenceObligation (::std::auto_ptr< unknownReferenceObligation_type > p);

    // allGuarantees
    // 
    typedef ::xml_schema::boolean allGuarantees_type;
    typedef ::xsd::cxx::tree::optional< allGuarantees_type > allGuarantees_optional;
    typedef ::xsd::cxx::tree::traits< allGuarantees_type, char > allGuarantees_traits;

    const allGuarantees_optional&
    allGuarantees () const;

    allGuarantees_optional&
    allGuarantees ();

    void
    allGuarantees (const allGuarantees_type& x);

    void
    allGuarantees (const allGuarantees_optional& x);

    // referencePrice
    // 
    typedef ::xml_schema::decimal referencePrice_type;
    typedef ::xsd::cxx::tree::optional< referencePrice_type > referencePrice_optional;
    typedef ::xsd::cxx::tree::traits< referencePrice_type, char, ::xsd::cxx::tree::schema_type::decimal > referencePrice_traits;

    const referencePrice_optional&
    referencePrice () const;

    referencePrice_optional&
    referencePrice ();

    void
    referencePrice (const referencePrice_type& x);

    void
    referencePrice (const referencePrice_optional& x);

    // Constructors.
    //
    ReferenceInformation (const referenceEntity_type&);

    ReferenceInformation (::std::auto_ptr< referenceEntity_type >&);

    ReferenceInformation (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    ReferenceInformation (const ReferenceInformation& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual ReferenceInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReferenceInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< referenceEntity_type > referenceEntity_;
    referenceObligation_sequence referenceObligation_;
    noReferenceObligation_optional noReferenceObligation_;
    unknownReferenceObligation_optional unknownReferenceObligation_;
    allGuarantees_optional allGuarantees_;
    referencePrice_optional referencePrice_;
  };

  class ReferenceObligation: public ::xml_schema::type
  {
    public:
    // bond
    // 
    typedef ::FpML_4_2::Bond bond_type;
    typedef ::xsd::cxx::tree::optional< bond_type > bond_optional;
    typedef ::xsd::cxx::tree::traits< bond_type, char > bond_traits;

    const bond_optional&
    bond () const;

    bond_optional&
    bond ();

    void
    bond (const bond_type& x);

    void
    bond (const bond_optional& x);

    void
    bond (::std::auto_ptr< bond_type > p);

    // convertibleBond
    // 
    typedef ::FpML_4_2::ConvertibleBond convertibleBond_type;
    typedef ::xsd::cxx::tree::optional< convertibleBond_type > convertibleBond_optional;
    typedef ::xsd::cxx::tree::traits< convertibleBond_type, char > convertibleBond_traits;

    const convertibleBond_optional&
    convertibleBond () const;

    convertibleBond_optional&
    convertibleBond ();

    void
    convertibleBond (const convertibleBond_type& x);

    void
    convertibleBond (const convertibleBond_optional& x);

    void
    convertibleBond (::std::auto_ptr< convertibleBond_type > p);

    // primaryObligor
    // 
    typedef ::FpML_4_2::LegalEntity primaryObligor_type;
    typedef ::xsd::cxx::tree::optional< primaryObligor_type > primaryObligor_optional;
    typedef ::xsd::cxx::tree::traits< primaryObligor_type, char > primaryObligor_traits;

    const primaryObligor_optional&
    primaryObligor () const;

    primaryObligor_optional&
    primaryObligor ();

    void
    primaryObligor (const primaryObligor_type& x);

    void
    primaryObligor (const primaryObligor_optional& x);

    void
    primaryObligor (::std::auto_ptr< primaryObligor_type > p);

    // primaryObligorReference
    // 
    typedef ::FpML_4_2::LegalEntityReference primaryObligorReference_type;
    typedef ::xsd::cxx::tree::optional< primaryObligorReference_type > primaryObligorReference_optional;
    typedef ::xsd::cxx::tree::traits< primaryObligorReference_type, char > primaryObligorReference_traits;

    const primaryObligorReference_optional&
    primaryObligorReference () const;

    primaryObligorReference_optional&
    primaryObligorReference ();

    void
    primaryObligorReference (const primaryObligorReference_type& x);

    void
    primaryObligorReference (const primaryObligorReference_optional& x);

    void
    primaryObligorReference (::std::auto_ptr< primaryObligorReference_type > p);

    // guarantor
    // 
    typedef ::FpML_4_2::LegalEntity guarantor_type;
    typedef ::xsd::cxx::tree::sequence< guarantor_type > guarantor_sequence;
    typedef guarantor_sequence::iterator guarantor_iterator;
    typedef guarantor_sequence::const_iterator guarantor_const_iterator;
    typedef ::xsd::cxx::tree::traits< guarantor_type, char > guarantor_traits;

    const guarantor_sequence&
    guarantor () const;

    guarantor_sequence&
    guarantor ();

    void
    guarantor (const guarantor_sequence& s);

    // guarantorReference
    // 
    typedef ::FpML_4_2::LegalEntityReference guarantorReference_type;
    typedef ::xsd::cxx::tree::sequence< guarantorReference_type > guarantorReference_sequence;
    typedef guarantorReference_sequence::iterator guarantorReference_iterator;
    typedef guarantorReference_sequence::const_iterator guarantorReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< guarantorReference_type, char > guarantorReference_traits;

    const guarantorReference_sequence&
    guarantorReference () const;

    guarantorReference_sequence&
    guarantorReference ();

    void
    guarantorReference (const guarantorReference_sequence& s);

    // Constructors.
    //
    ReferenceObligation ();

    ReferenceObligation (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ReferenceObligation (const ReferenceObligation& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual ReferenceObligation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReferenceObligation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    bond_optional bond_;
    convertibleBond_optional convertibleBond_;
    primaryObligor_optional primaryObligor_;
    primaryObligorReference_optional primaryObligorReference_;
    guarantor_sequence guarantor_;
    guarantorReference_sequence guarantorReference_;
  };

  class ReferencePair: public ::xml_schema::type
  {
    public:
    // referenceEntity
    // 
    typedef ::FpML_4_2::LegalEntity referenceEntity_type;
    typedef ::xsd::cxx::tree::traits< referenceEntity_type, char > referenceEntity_traits;

    const referenceEntity_type&
    referenceEntity () const;

    referenceEntity_type&
    referenceEntity ();

    void
    referenceEntity (const referenceEntity_type& x);

    void
    referenceEntity (::std::auto_ptr< referenceEntity_type > p);

    // referenceObligation
    // 
    typedef ::FpML_4_2::ReferenceObligation referenceObligation_type;
    typedef ::xsd::cxx::tree::optional< referenceObligation_type > referenceObligation_optional;
    typedef ::xsd::cxx::tree::traits< referenceObligation_type, char > referenceObligation_traits;

    const referenceObligation_optional&
    referenceObligation () const;

    referenceObligation_optional&
    referenceObligation ();

    void
    referenceObligation (const referenceObligation_type& x);

    void
    referenceObligation (const referenceObligation_optional& x);

    void
    referenceObligation (::std::auto_ptr< referenceObligation_type > p);

    // noReferenceObligation
    // 
    typedef ::FpML_4_2::Empty noReferenceObligation_type;
    typedef ::xsd::cxx::tree::optional< noReferenceObligation_type > noReferenceObligation_optional;
    typedef ::xsd::cxx::tree::traits< noReferenceObligation_type, char > noReferenceObligation_traits;

    const noReferenceObligation_optional&
    noReferenceObligation () const;

    noReferenceObligation_optional&
    noReferenceObligation ();

    void
    noReferenceObligation (const noReferenceObligation_type& x);

    void
    noReferenceObligation (const noReferenceObligation_optional& x);

    void
    noReferenceObligation (::std::auto_ptr< noReferenceObligation_type > p);

    // entityType
    // 
    typedef ::FpML_4_2::EntityType entityType_type;
    typedef ::xsd::cxx::tree::traits< entityType_type, char > entityType_traits;

    const entityType_type&
    entityType () const;

    entityType_type&
    entityType ();

    void
    entityType (const entityType_type& x);

    void
    entityType (::std::auto_ptr< entityType_type > p);

    // Constructors.
    //
    ReferencePair (const referenceEntity_type&,
                   const entityType_type&);

    ReferencePair (::std::auto_ptr< referenceEntity_type >&,
                   ::std::auto_ptr< entityType_type >&);

    ReferencePair (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    ReferencePair (const ReferencePair& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual ReferencePair*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReferencePair ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< referenceEntity_type > referenceEntity_;
    referenceObligation_optional referenceObligation_;
    noReferenceObligation_optional noReferenceObligation_;
    ::xsd::cxx::tree::one< entityType_type > entityType_;
  };

  class ReferencePool: public ::xml_schema::type
  {
    public:
    // referencePoolItem
    // 
    typedef ::FpML_4_2::ReferencePoolItem referencePoolItem_type;
    typedef ::xsd::cxx::tree::sequence< referencePoolItem_type > referencePoolItem_sequence;
    typedef referencePoolItem_sequence::iterator referencePoolItem_iterator;
    typedef referencePoolItem_sequence::const_iterator referencePoolItem_const_iterator;
    typedef ::xsd::cxx::tree::traits< referencePoolItem_type, char > referencePoolItem_traits;

    const referencePoolItem_sequence&
    referencePoolItem () const;

    referencePoolItem_sequence&
    referencePoolItem ();

    void
    referencePoolItem (const referencePoolItem_sequence& s);

    // Constructors.
    //
    ReferencePool ();

    ReferencePool (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    ReferencePool (const ReferencePool& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual ReferencePool*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReferencePool ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    referencePoolItem_sequence referencePoolItem_;
  };

  class ReferencePoolItem: public ::xml_schema::type
  {
    public:
    // constituentWeight
    // 
    typedef ::FpML_4_2::ConstituentWeight constituentWeight_type;
    typedef ::xsd::cxx::tree::optional< constituentWeight_type > constituentWeight_optional;
    typedef ::xsd::cxx::tree::traits< constituentWeight_type, char > constituentWeight_traits;

    const constituentWeight_optional&
    constituentWeight () const;

    constituentWeight_optional&
    constituentWeight ();

    void
    constituentWeight (const constituentWeight_type& x);

    void
    constituentWeight (const constituentWeight_optional& x);

    void
    constituentWeight (::std::auto_ptr< constituentWeight_type > p);

    // referencePair
    // 
    typedef ::FpML_4_2::ReferencePair referencePair_type;
    typedef ::xsd::cxx::tree::traits< referencePair_type, char > referencePair_traits;

    const referencePair_type&
    referencePair () const;

    referencePair_type&
    referencePair ();

    void
    referencePair (const referencePair_type& x);

    void
    referencePair (::std::auto_ptr< referencePair_type > p);

    // protectionTermsReference
    // 
    typedef ::FpML_4_2::ProtectionTermsReference protectionTermsReference_type;
    typedef ::xsd::cxx::tree::optional< protectionTermsReference_type > protectionTermsReference_optional;
    typedef ::xsd::cxx::tree::traits< protectionTermsReference_type, char > protectionTermsReference_traits;

    const protectionTermsReference_optional&
    protectionTermsReference () const;

    protectionTermsReference_optional&
    protectionTermsReference ();

    void
    protectionTermsReference (const protectionTermsReference_type& x);

    void
    protectionTermsReference (const protectionTermsReference_optional& x);

    void
    protectionTermsReference (::std::auto_ptr< protectionTermsReference_type > p);

    // settlementTermsReference
    // 
    typedef ::FpML_4_2::SettlementTermsReference settlementTermsReference_type;
    typedef ::xsd::cxx::tree::optional< settlementTermsReference_type > settlementTermsReference_optional;
    typedef ::xsd::cxx::tree::traits< settlementTermsReference_type, char > settlementTermsReference_traits;

    const settlementTermsReference_optional&
    settlementTermsReference () const;

    settlementTermsReference_optional&
    settlementTermsReference ();

    void
    settlementTermsReference (const settlementTermsReference_type& x);

    void
    settlementTermsReference (const settlementTermsReference_optional& x);

    void
    settlementTermsReference (::std::auto_ptr< settlementTermsReference_type > p);

    // Constructors.
    //
    ReferencePoolItem (const referencePair_type&);

    ReferencePoolItem (::std::auto_ptr< referencePair_type >&);

    ReferencePoolItem (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ReferencePoolItem (const ReferencePoolItem& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual ReferencePoolItem*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReferencePoolItem ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    constituentWeight_optional constituentWeight_;
    ::xsd::cxx::tree::one< referencePair_type > referencePair_;
    protectionTermsReference_optional protectionTermsReference_;
    settlementTermsReference_optional settlementTermsReference_;
  };

  class Restructuring: public ::xml_schema::type
  {
    public:
    // restructuringType
    // 
    typedef ::FpML_4_2::RestructuringType restructuringType_type;
    typedef ::xsd::cxx::tree::optional< restructuringType_type > restructuringType_optional;
    typedef ::xsd::cxx::tree::traits< restructuringType_type, char > restructuringType_traits;

    const restructuringType_optional&
    restructuringType () const;

    restructuringType_optional&
    restructuringType ();

    void
    restructuringType (const restructuringType_type& x);

    void
    restructuringType (const restructuringType_optional& x);

    void
    restructuringType (::std::auto_ptr< restructuringType_type > p);

    // multipleHolderObligation
    // 
    typedef ::FpML_4_2::Empty multipleHolderObligation_type;
    typedef ::xsd::cxx::tree::optional< multipleHolderObligation_type > multipleHolderObligation_optional;
    typedef ::xsd::cxx::tree::traits< multipleHolderObligation_type, char > multipleHolderObligation_traits;

    const multipleHolderObligation_optional&
    multipleHolderObligation () const;

    multipleHolderObligation_optional&
    multipleHolderObligation ();

    void
    multipleHolderObligation (const multipleHolderObligation_type& x);

    void
    multipleHolderObligation (const multipleHolderObligation_optional& x);

    void
    multipleHolderObligation (::std::auto_ptr< multipleHolderObligation_type > p);

    // multipleCreditEventNotices
    // 
    typedef ::FpML_4_2::Empty multipleCreditEventNotices_type;
    typedef ::xsd::cxx::tree::optional< multipleCreditEventNotices_type > multipleCreditEventNotices_optional;
    typedef ::xsd::cxx::tree::traits< multipleCreditEventNotices_type, char > multipleCreditEventNotices_traits;

    const multipleCreditEventNotices_optional&
    multipleCreditEventNotices () const;

    multipleCreditEventNotices_optional&
    multipleCreditEventNotices ();

    void
    multipleCreditEventNotices (const multipleCreditEventNotices_type& x);

    void
    multipleCreditEventNotices (const multipleCreditEventNotices_optional& x);

    void
    multipleCreditEventNotices (::std::auto_ptr< multipleCreditEventNotices_type > p);

    // Constructors.
    //
    Restructuring ();

    Restructuring (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    Restructuring (const Restructuring& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual Restructuring*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Restructuring ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    restructuringType_optional restructuringType_;
    multipleHolderObligation_optional multipleHolderObligation_;
    multipleCreditEventNotices_optional multipleCreditEventNotices_;
  };

  class RestructuringType: public ::xml_schema::normalized_string
  {
    public:
    // restructuringScheme
    // 
    typedef ::xml_schema::uri restructuringScheme_type;
    typedef ::xsd::cxx::tree::traits< restructuringScheme_type, char > restructuringScheme_traits;

    const restructuringScheme_type&
    restructuringScheme () const;

    restructuringScheme_type&
    restructuringScheme ();

    void
    restructuringScheme (const restructuringScheme_type& x);

    void
    restructuringScheme (::std::auto_ptr< restructuringScheme_type > p);

    static const restructuringScheme_type&
    restructuringScheme_default_value ();

    // Constructors.
    //
    RestructuringType ();

    RestructuringType (const char*);

    RestructuringType (const ::std::string&);

    RestructuringType (const ::xml_schema::normalized_string&);

    RestructuringType (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    RestructuringType (const RestructuringType& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual RestructuringType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RestructuringType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< restructuringScheme_type > restructuringScheme_;
    static const restructuringScheme_type restructuringScheme_default_value_;
  };

  class ScheduledTerminationDate: public ::xml_schema::type
  {
    public:
    // adjustableDate
    // 
    typedef ::FpML_4_2::AdjustableDate2 adjustableDate_type;
    typedef ::xsd::cxx::tree::optional< adjustableDate_type > adjustableDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustableDate_type, char > adjustableDate_traits;

    const adjustableDate_optional&
    adjustableDate () const;

    adjustableDate_optional&
    adjustableDate ();

    void
    adjustableDate (const adjustableDate_type& x);

    void
    adjustableDate (const adjustableDate_optional& x);

    void
    adjustableDate (::std::auto_ptr< adjustableDate_type > p);

    // relativeDate
    // 
    typedef ::FpML_4_2::Interval relativeDate_type;
    typedef ::xsd::cxx::tree::optional< relativeDate_type > relativeDate_optional;
    typedef ::xsd::cxx::tree::traits< relativeDate_type, char > relativeDate_traits;

    const relativeDate_optional&
    relativeDate () const;

    relativeDate_optional&
    relativeDate ();

    void
    relativeDate (const relativeDate_type& x);

    void
    relativeDate (const relativeDate_optional& x);

    void
    relativeDate (::std::auto_ptr< relativeDate_type > p);

    // Constructors.
    //
    ScheduledTerminationDate ();

    ScheduledTerminationDate (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    ScheduledTerminationDate (const ScheduledTerminationDate& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual ScheduledTerminationDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ScheduledTerminationDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    adjustableDate_optional adjustableDate_;
    relativeDate_optional relativeDate_;
  };

  class SettledEntityMatrix: public ::xml_schema::type
  {
    public:
    // matrixSource
    // 
    typedef ::FpML_4_2::MatrixSource matrixSource_type;
    typedef ::xsd::cxx::tree::traits< matrixSource_type, char > matrixSource_traits;

    const matrixSource_type&
    matrixSource () const;

    matrixSource_type&
    matrixSource ();

    void
    matrixSource (const matrixSource_type& x);

    void
    matrixSource (::std::auto_ptr< matrixSource_type > p);

    // publicationDate
    // 
    typedef ::xml_schema::date publicationDate_type;
    typedef ::xsd::cxx::tree::optional< publicationDate_type > publicationDate_optional;
    typedef ::xsd::cxx::tree::traits< publicationDate_type, char > publicationDate_traits;

    const publicationDate_optional&
    publicationDate () const;

    publicationDate_optional&
    publicationDate ();

    void
    publicationDate (const publicationDate_type& x);

    void
    publicationDate (const publicationDate_optional& x);

    void
    publicationDate (::std::auto_ptr< publicationDate_type > p);

    // Constructors.
    //
    SettledEntityMatrix (const matrixSource_type&);

    SettledEntityMatrix (::std::auto_ptr< matrixSource_type >&);

    SettledEntityMatrix (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    SettledEntityMatrix (const SettledEntityMatrix& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual SettledEntityMatrix*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SettledEntityMatrix ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< matrixSource_type > matrixSource_;
    publicationDate_optional publicationDate_;
  };

  class SettlementTermsReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    SettlementTermsReference (const href_type&);

    SettlementTermsReference (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    SettlementTermsReference (const SettlementTermsReference& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual SettlementTermsReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SettlementTermsReference ();
  };

  class SinglePayment: public ::xml_schema::type
  {
    public:
    // adjustablePaymentDate
    // 
    typedef ::xml_schema::date adjustablePaymentDate_type;
    typedef ::xsd::cxx::tree::traits< adjustablePaymentDate_type, char > adjustablePaymentDate_traits;

    const adjustablePaymentDate_type&
    adjustablePaymentDate () const;

    adjustablePaymentDate_type&
    adjustablePaymentDate ();

    void
    adjustablePaymentDate (const adjustablePaymentDate_type& x);

    void
    adjustablePaymentDate (::std::auto_ptr< adjustablePaymentDate_type > p);

    // adjustedPaymentDate
    // 
    typedef ::xml_schema::date adjustedPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedPaymentDate_type > adjustedPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedPaymentDate_type, char > adjustedPaymentDate_traits;

    const adjustedPaymentDate_optional&
    adjustedPaymentDate () const;

    adjustedPaymentDate_optional&
    adjustedPaymentDate ();

    void
    adjustedPaymentDate (const adjustedPaymentDate_type& x);

    void
    adjustedPaymentDate (const adjustedPaymentDate_optional& x);

    void
    adjustedPaymentDate (::std::auto_ptr< adjustedPaymentDate_type > p);

    // fixedAmount
    // 
    typedef ::FpML_4_2::Money fixedAmount_type;
    typedef ::xsd::cxx::tree::traits< fixedAmount_type, char > fixedAmount_traits;

    const fixedAmount_type&
    fixedAmount () const;

    fixedAmount_type&
    fixedAmount ();

    void
    fixedAmount (const fixedAmount_type& x);

    void
    fixedAmount (::std::auto_ptr< fixedAmount_type > p);

    // Constructors.
    //
    SinglePayment (const adjustablePaymentDate_type&,
                   const fixedAmount_type&);

    SinglePayment (const adjustablePaymentDate_type&,
                   ::std::auto_ptr< fixedAmount_type >&);

    SinglePayment (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    SinglePayment (const SinglePayment& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual SinglePayment*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SinglePayment ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< adjustablePaymentDate_type > adjustablePaymentDate_;
    adjustedPaymentDate_optional adjustedPaymentDate_;
    ::xsd::cxx::tree::one< fixedAmount_type > fixedAmount_;
  };

  class SpecifiedCurrency: public ::xml_schema::type
  {
    public:
    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::sequence< currency_type > currency_sequence;
    typedef currency_sequence::iterator currency_iterator;
    typedef currency_sequence::const_iterator currency_const_iterator;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_sequence&
    currency () const;

    currency_sequence&
    currency ();

    void
    currency (const currency_sequence& s);

    // Constructors.
    //
    SpecifiedCurrency ();

    SpecifiedCurrency (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    SpecifiedCurrency (const SpecifiedCurrency& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual SpecifiedCurrency*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SpecifiedCurrency ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    currency_sequence currency_;
  };

  class Tranche: public ::xml_schema::type
  {
    public:
    // attachmentPoint
    // 
    typedef ::xml_schema::decimal attachmentPoint_type;
    typedef ::xsd::cxx::tree::traits< attachmentPoint_type, char, ::xsd::cxx::tree::schema_type::decimal > attachmentPoint_traits;

    const attachmentPoint_type&
    attachmentPoint () const;

    attachmentPoint_type&
    attachmentPoint ();

    void
    attachmentPoint (const attachmentPoint_type& x);

    // exhaustionPoint
    // 
    typedef ::xml_schema::decimal exhaustionPoint_type;
    typedef ::xsd::cxx::tree::traits< exhaustionPoint_type, char, ::xsd::cxx::tree::schema_type::decimal > exhaustionPoint_traits;

    const exhaustionPoint_type&
    exhaustionPoint () const;

    exhaustionPoint_type&
    exhaustionPoint ();

    void
    exhaustionPoint (const exhaustionPoint_type& x);

    // incurredRecoveryApplicable
    // 
    typedef ::xml_schema::boolean incurredRecoveryApplicable_type;
    typedef ::xsd::cxx::tree::optional< incurredRecoveryApplicable_type > incurredRecoveryApplicable_optional;
    typedef ::xsd::cxx::tree::traits< incurredRecoveryApplicable_type, char > incurredRecoveryApplicable_traits;

    const incurredRecoveryApplicable_optional&
    incurredRecoveryApplicable () const;

    incurredRecoveryApplicable_optional&
    incurredRecoveryApplicable ();

    void
    incurredRecoveryApplicable (const incurredRecoveryApplicable_type& x);

    void
    incurredRecoveryApplicable (const incurredRecoveryApplicable_optional& x);

    // Constructors.
    //
    Tranche (const attachmentPoint_type&,
             const exhaustionPoint_type&);

    Tranche (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Tranche (const Tranche& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Tranche*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Tranche ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< attachmentPoint_type > attachmentPoint_;
    ::xsd::cxx::tree::one< exhaustionPoint_type > exhaustionPoint_;
    incurredRecoveryApplicable_optional incurredRecoveryApplicable_;
  };

  class ValuationDate: public ::xml_schema::type
  {
    public:
    // singleValuationDate
    // 
    typedef ::FpML_4_2::SingleValuationDate singleValuationDate_type;
    typedef ::xsd::cxx::tree::optional< singleValuationDate_type > singleValuationDate_optional;
    typedef ::xsd::cxx::tree::traits< singleValuationDate_type, char > singleValuationDate_traits;

    const singleValuationDate_optional&
    singleValuationDate () const;

    singleValuationDate_optional&
    singleValuationDate ();

    void
    singleValuationDate (const singleValuationDate_type& x);

    void
    singleValuationDate (const singleValuationDate_optional& x);

    void
    singleValuationDate (::std::auto_ptr< singleValuationDate_type > p);

    // multipleValuationDates
    // 
    typedef ::FpML_4_2::MultipleValuationDates multipleValuationDates_type;
    typedef ::xsd::cxx::tree::optional< multipleValuationDates_type > multipleValuationDates_optional;
    typedef ::xsd::cxx::tree::traits< multipleValuationDates_type, char > multipleValuationDates_traits;

    const multipleValuationDates_optional&
    multipleValuationDates () const;

    multipleValuationDates_optional&
    multipleValuationDates ();

    void
    multipleValuationDates (const multipleValuationDates_type& x);

    void
    multipleValuationDates (const multipleValuationDates_optional& x);

    void
    multipleValuationDates (::std::auto_ptr< multipleValuationDates_type > p);

    // Constructors.
    //
    ValuationDate ();

    ValuationDate (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    ValuationDate (const ValuationDate& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual ValuationDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ValuationDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    singleValuationDate_optional singleValuationDate_;
    multipleValuationDates_optional multipleValuationDates_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const AdditionalTerm&);

  void
  operator<< (::xercesc::DOMElement&, const AdjustedPaymentDates&);

  void
  operator<< (::xercesc::DOMElement&, const BasketReferenceInformation&);

  void
  operator<< (::xercesc::DOMElement&, const SettlementTerms&);

  void
  operator<< (::xercesc::DOMElement&, const CashSettlementTerms&);

  void
  operator<< (::xercesc::DOMElement&, const CreditDefaultSwap&);

  void
  operator<< (::xercesc::DOMElement&, const CreditEventNotice&);

  void
  operator<< (::xercesc::DOMElement&, const CreditEvents&);

  void
  operator<< (::xercesc::DOMElement&, const DeliverableObligations&);

  void
  operator<< (::xercesc::DOMElement&, const EntityType&);

  void
  operator<< (::xercesc::DOMElement&, const FailureToPay&);

  void
  operator<< (::xercesc::DOMElement&, const FeeLeg&);

  void
  operator<< (::xercesc::DOMElement&, const FixedAmountCalculation&);

  void
  operator<< (::xercesc::DOMElement&, const GeneralTerms&);

  void
  operator<< (::xercesc::DOMElement&, const GracePeriodExtension&);

  void
  operator<< (::xercesc::DOMElement&, const IndexAnnexSource&);

  void
  operator<< (::xercesc::DOMElement&, const IndexId&);

  void
  operator<< (::xercesc::DOMElement&, const IndexName&);

  void
  operator<< (::xercesc::DOMElement&, const IndexReferenceInformation&);

  void
  operator<< (::xercesc::DOMElement&, const InitialPayment&);

  void
  operator<< (::xercesc::DOMElement&, const PCDeliverableObligationCharac&);

  void
  operator<< (::xercesc::DOMElement&, const LoanParticipation&);

  void
  operator<< (::xercesc::DOMElement&, const MatrixSource&);

  void
  operator<< (::xercesc::DOMElement&, const SingleValuationDate&);

  void
  operator<< (::xercesc::DOMElement&, const MultipleValuationDates&);

  void
  operator<< (::xercesc::DOMElement&, const NotDomesticCurrency&);

  void
  operator<< (::xercesc::DOMElement&, const NotifyingParty&);

  void
  operator<< (::xercesc::DOMElement&, const Obligations&);

  void
  operator<< (::xercesc::DOMElement&, const PeriodicPayment&);

  void
  operator<< (::xercesc::DOMElement&, const PhysicalSettlementPeriod&);

  void
  operator<< (::xercesc::DOMElement&, const PhysicalSettlementTerms&);

  void
  operator<< (::xercesc::DOMElement&, const ProtectionTerms&);

  void
  operator<< (::xercesc::DOMElement&, const ProtectionTermsReference&);

  void
  operator<< (::xercesc::DOMElement&, const PubliclyAvailableInformation&);

  void
  operator<< (::xercesc::DOMElement&, const ReferenceInformation&);

  void
  operator<< (::xercesc::DOMElement&, const ReferenceObligation&);

  void
  operator<< (::xercesc::DOMElement&, const ReferencePair&);

  void
  operator<< (::xercesc::DOMElement&, const ReferencePool&);

  void
  operator<< (::xercesc::DOMElement&, const ReferencePoolItem&);

  void
  operator<< (::xercesc::DOMElement&, const Restructuring&);

  void
  operator<< (::xercesc::DOMElement&, const RestructuringType&);

  void
  operator<< (::xercesc::DOMElement&, const ScheduledTerminationDate&);

  void
  operator<< (::xercesc::DOMElement&, const SettledEntityMatrix&);

  void
  operator<< (::xercesc::DOMElement&, const SettlementTermsReference&);

  void
  operator<< (::xercesc::DOMElement&, const SinglePayment&);

  void
  operator<< (::xercesc::DOMElement&, const SpecifiedCurrency&);

  void
  operator<< (::xercesc::DOMElement&, const Tranche&);

  void
  operator<< (::xercesc::DOMElement&, const ValuationDate&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_CD_4_2_HXX
