// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_DOC_4_2_HXX
#define FPML_DOC_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class QueryParameterValue;
  class Account;
  class AccountId;
  class Allocation;
  class Allocations;
  class TradeIdentifier;
  class PartyTradeIdentifier;
  class AllocationTradeIdentifier;
  class Event;
  class Amendment;
  class Approval;
  class Approvals;
  class BestFitTrade;
  class BlockTradeIdentifier;
  class ChangeContract;
  class ChangeContractSize;
  class Collateral;
  class Contract;
  class ContractHeader;
  class ContractId;
  class ContractIdentifier;
  class ContractNovation;
  class ContractReference;
  class ContractTermination;
  class CreditDerivativesNotices;
  class Document;
  class DataDocument;
  class EventId;
  class FirstPeriodStartDate;
  class Increase;
  class IndependentAmount;
  class LinkId;
  class Party;
  class PartyId;
  class PartyPortfolioName;
  class PartyRole;
  class PartyTradeIdentifiers;
  class PartyTradeInformation;
  class PaymentDetail;
  class PaymentRule;
  class PercentageRule;
  class Portfolio;
  class PortfolioName;
  class QueryParameter;
  class QueryParameterId;
  class QueryParameterOperator;
  class QueryPortfolio;
  class Strategy;
  class Trade;
  class TradeDifference;
  class TradeHeader;
  class TradeId;
  class Trader;
  class TradeSide;
  class Validation;
  class VersionedContractId;
  class VersionedTradeId;
  class version;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-shared-4-2.hxx"

namespace FpML_4_2
{
  class QueryParameterValue: public ::xml_schema::string
  {
    public:
    // Constructors.
    //
    QueryParameterValue ();

    QueryParameterValue (const char*);

    QueryParameterValue (const ::std::string&);

    QueryParameterValue (const ::xml_schema::string&);

    QueryParameterValue (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    QueryParameterValue (const ::xercesc::DOMAttr& a,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    QueryParameterValue (const ::std::string& s,
                         const ::xercesc::DOMElement* e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    QueryParameterValue (const QueryParameterValue& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual QueryParameterValue*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~QueryParameterValue ();
  };

  class Account: public ::xml_schema::type
  {
    public:
    // accountId
    // 
    typedef ::FpML_4_2::AccountId accountId_type;
    typedef ::xsd::cxx::tree::sequence< accountId_type > accountId_sequence;
    typedef accountId_sequence::iterator accountId_iterator;
    typedef accountId_sequence::const_iterator accountId_const_iterator;
    typedef ::xsd::cxx::tree::traits< accountId_type, char > accountId_traits;

    const accountId_sequence&
    accountId () const;

    accountId_sequence&
    accountId ();

    void
    accountId (const accountId_sequence& s);

    // accountName
    // 
    typedef ::xml_schema::normalized_string accountName_type;
    typedef ::xsd::cxx::tree::sequence< accountName_type > accountName_sequence;
    typedef accountName_sequence::iterator accountName_iterator;
    typedef accountName_sequence::const_iterator accountName_const_iterator;
    typedef ::xsd::cxx::tree::traits< accountName_type, char > accountName_traits;

    const accountName_sequence&
    accountName () const;

    accountName_sequence&
    accountName ();

    void
    accountName (const accountName_sequence& s);

    // accountBeneficiary
    // 
    typedef ::FpML_4_2::PartyReference accountBeneficiary_type;
    typedef ::xsd::cxx::tree::optional< accountBeneficiary_type > accountBeneficiary_optional;
    typedef ::xsd::cxx::tree::traits< accountBeneficiary_type, char > accountBeneficiary_traits;

    const accountBeneficiary_optional&
    accountBeneficiary () const;

    accountBeneficiary_optional&
    accountBeneficiary ();

    void
    accountBeneficiary (const accountBeneficiary_type& x);

    void
    accountBeneficiary (const accountBeneficiary_optional& x);

    void
    accountBeneficiary (::std::auto_ptr< accountBeneficiary_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Account (const id_type&);

    Account (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Account (const Account& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Account*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Account ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    accountId_sequence accountId_;
    accountName_sequence accountName_;
    accountBeneficiary_optional accountBeneficiary_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class AccountId: public ::xml_schema::normalized_string
  {
    public:
    // accountIdScheme
    // 
    typedef ::xml_schema::uri accountIdScheme_type;
    typedef ::xsd::cxx::tree::optional< accountIdScheme_type > accountIdScheme_optional;
    typedef ::xsd::cxx::tree::traits< accountIdScheme_type, char > accountIdScheme_traits;

    const accountIdScheme_optional&
    accountIdScheme () const;

    accountIdScheme_optional&
    accountIdScheme ();

    void
    accountIdScheme (const accountIdScheme_type& x);

    void
    accountIdScheme (const accountIdScheme_optional& x);

    void
    accountIdScheme (::std::auto_ptr< accountIdScheme_type > p);

    // Constructors.
    //
    AccountId ();

    AccountId (const char*);

    AccountId (const ::std::string&);

    AccountId (const ::xml_schema::normalized_string&);

    AccountId (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    AccountId (const AccountId& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual AccountId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AccountId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    accountIdScheme_optional accountIdScheme_;
  };

  class Allocation: public ::xml_schema::type
  {
    public:
    // allocationTradeId
    // 
    typedef ::FpML_4_2::PartyTradeIdentifier allocationTradeId_type;
    typedef ::xsd::cxx::tree::traits< allocationTradeId_type, char > allocationTradeId_traits;

    const allocationTradeId_type&
    allocationTradeId () const;

    allocationTradeId_type&
    allocationTradeId ();

    void
    allocationTradeId (const allocationTradeId_type& x);

    void
    allocationTradeId (::std::auto_ptr< allocationTradeId_type > p);

    // accountReference
    // 
    typedef ::FpML_4_2::AccountReference accountReference_type;
    typedef ::xsd::cxx::tree::optional< accountReference_type > accountReference_optional;
    typedef ::xsd::cxx::tree::traits< accountReference_type, char > accountReference_traits;

    const accountReference_optional&
    accountReference () const;

    accountReference_optional&
    accountReference ();

    void
    accountReference (const accountReference_type& x);

    void
    accountReference (const accountReference_optional& x);

    void
    accountReference (::std::auto_ptr< accountReference_type > p);

    // partyReference
    // 
    typedef ::FpML_4_2::PartyReference partyReference_type;
    typedef ::xsd::cxx::tree::optional< partyReference_type > partyReference_optional;
    typedef ::xsd::cxx::tree::traits< partyReference_type, char > partyReference_traits;

    const partyReference_optional&
    partyReference () const;

    partyReference_optional&
    partyReference ();

    void
    partyReference (const partyReference_type& x);

    void
    partyReference (const partyReference_optional& x);

    void
    partyReference (::std::auto_ptr< partyReference_type > p);

    // allocatedFraction
    // 
    typedef ::xml_schema::decimal allocatedFraction_type;
    typedef ::xsd::cxx::tree::optional< allocatedFraction_type > allocatedFraction_optional;
    typedef ::xsd::cxx::tree::traits< allocatedFraction_type, char, ::xsd::cxx::tree::schema_type::decimal > allocatedFraction_traits;

    const allocatedFraction_optional&
    allocatedFraction () const;

    allocatedFraction_optional&
    allocatedFraction ();

    void
    allocatedFraction (const allocatedFraction_type& x);

    void
    allocatedFraction (const allocatedFraction_optional& x);

    // allocatedNotional
    // 
    typedef ::FpML_4_2::Money allocatedNotional_type;
    typedef ::xsd::cxx::tree::optional< allocatedNotional_type > allocatedNotional_optional;
    typedef ::xsd::cxx::tree::traits< allocatedNotional_type, char > allocatedNotional_traits;

    const allocatedNotional_optional&
    allocatedNotional () const;

    allocatedNotional_optional&
    allocatedNotional ();

    void
    allocatedNotional (const allocatedNotional_type& x);

    void
    allocatedNotional (const allocatedNotional_optional& x);

    void
    allocatedNotional (::std::auto_ptr< allocatedNotional_type > p);

    // collateral
    // 
    typedef ::FpML_4_2::Collateral collateral_type;
    typedef ::xsd::cxx::tree::optional< collateral_type > collateral_optional;
    typedef ::xsd::cxx::tree::traits< collateral_type, char > collateral_traits;

    const collateral_optional&
    collateral () const;

    collateral_optional&
    collateral ();

    void
    collateral (const collateral_type& x);

    void
    collateral (const collateral_optional& x);

    void
    collateral (::std::auto_ptr< collateral_type > p);

    // creditChargeAmount
    // 
    typedef ::FpML_4_2::Money creditChargeAmount_type;
    typedef ::xsd::cxx::tree::optional< creditChargeAmount_type > creditChargeAmount_optional;
    typedef ::xsd::cxx::tree::traits< creditChargeAmount_type, char > creditChargeAmount_traits;

    const creditChargeAmount_optional&
    creditChargeAmount () const;

    creditChargeAmount_optional&
    creditChargeAmount ();

    void
    creditChargeAmount (const creditChargeAmount_type& x);

    void
    creditChargeAmount (const creditChargeAmount_optional& x);

    void
    creditChargeAmount (::std::auto_ptr< creditChargeAmount_type > p);

    // approvals
    // 
    typedef ::FpML_4_2::Approvals approvals_type;
    typedef ::xsd::cxx::tree::optional< approvals_type > approvals_optional;
    typedef ::xsd::cxx::tree::traits< approvals_type, char > approvals_traits;

    const approvals_optional&
    approvals () const;

    approvals_optional&
    approvals ();

    void
    approvals (const approvals_type& x);

    void
    approvals (const approvals_optional& x);

    void
    approvals (::std::auto_ptr< approvals_type > p);

    // masterConfirmationDate
    // 
    typedef ::xml_schema::date masterConfirmationDate_type;
    typedef ::xsd::cxx::tree::optional< masterConfirmationDate_type > masterConfirmationDate_optional;
    typedef ::xsd::cxx::tree::traits< masterConfirmationDate_type, char > masterConfirmationDate_traits;

    const masterConfirmationDate_optional&
    masterConfirmationDate () const;

    masterConfirmationDate_optional&
    masterConfirmationDate ();

    void
    masterConfirmationDate (const masterConfirmationDate_type& x);

    void
    masterConfirmationDate (const masterConfirmationDate_optional& x);

    void
    masterConfirmationDate (::std::auto_ptr< masterConfirmationDate_type > p);

    // Constructors.
    //
    Allocation (const allocationTradeId_type&);

    Allocation (::std::auto_ptr< allocationTradeId_type >&);

    Allocation (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    Allocation (const Allocation& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual Allocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Allocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< allocationTradeId_type > allocationTradeId_;
    accountReference_optional accountReference_;
    partyReference_optional partyReference_;
    allocatedFraction_optional allocatedFraction_;
    allocatedNotional_optional allocatedNotional_;
    collateral_optional collateral_;
    creditChargeAmount_optional creditChargeAmount_;
    approvals_optional approvals_;
    masterConfirmationDate_optional masterConfirmationDate_;
  };

  class Allocations: public ::xml_schema::type
  {
    public:
    // allocation
    // 
    typedef ::FpML_4_2::Allocation allocation_type;
    typedef ::xsd::cxx::tree::sequence< allocation_type > allocation_sequence;
    typedef allocation_sequence::iterator allocation_iterator;
    typedef allocation_sequence::const_iterator allocation_const_iterator;
    typedef ::xsd::cxx::tree::traits< allocation_type, char > allocation_traits;

    const allocation_sequence&
    allocation () const;

    allocation_sequence&
    allocation ();

    void
    allocation (const allocation_sequence& s);

    // Constructors.
    //
    Allocations ();

    Allocations (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    Allocations (const Allocations& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual Allocations*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Allocations ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    allocation_sequence allocation_;
  };

  class TradeIdentifier: public ::xml_schema::type
  {
    public:
    // partyReference
    // 
    typedef ::FpML_4_2::PartyReference partyReference_type;
    typedef ::xsd::cxx::tree::traits< partyReference_type, char > partyReference_traits;

    const partyReference_type&
    partyReference () const;

    partyReference_type&
    partyReference ();

    void
    partyReference (const partyReference_type& x);

    void
    partyReference (::std::auto_ptr< partyReference_type > p);

    // tradeId
    // 
    typedef ::FpML_4_2::TradeId tradeId_type;
    typedef ::xsd::cxx::tree::sequence< tradeId_type > tradeId_sequence;
    typedef tradeId_sequence::iterator tradeId_iterator;
    typedef tradeId_sequence::const_iterator tradeId_const_iterator;
    typedef ::xsd::cxx::tree::traits< tradeId_type, char > tradeId_traits;

    const tradeId_sequence&
    tradeId () const;

    tradeId_sequence&
    tradeId ();

    void
    tradeId (const tradeId_sequence& s);

    // versionedTradeId
    // 
    typedef ::FpML_4_2::VersionedTradeId versionedTradeId_type;
    typedef ::xsd::cxx::tree::sequence< versionedTradeId_type > versionedTradeId_sequence;
    typedef versionedTradeId_sequence::iterator versionedTradeId_iterator;
    typedef versionedTradeId_sequence::const_iterator versionedTradeId_const_iterator;
    typedef ::xsd::cxx::tree::traits< versionedTradeId_type, char > versionedTradeId_traits;

    const versionedTradeId_sequence&
    versionedTradeId () const;

    versionedTradeId_sequence&
    versionedTradeId ();

    void
    versionedTradeId (const versionedTradeId_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    TradeIdentifier (const partyReference_type&);

    TradeIdentifier (::std::auto_ptr< partyReference_type >&);

    TradeIdentifier (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    TradeIdentifier (const TradeIdentifier& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual TradeIdentifier*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeIdentifier ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partyReference_type > partyReference_;
    tradeId_sequence tradeId_;
    versionedTradeId_sequence versionedTradeId_;
    id_optional id_;
  };

  class PartyTradeIdentifier: public ::FpML_4_2::TradeIdentifier
  {
    public:
    // linkId
    // 
    typedef ::FpML_4_2::LinkId linkId_type;
    typedef ::xsd::cxx::tree::sequence< linkId_type > linkId_sequence;
    typedef linkId_sequence::iterator linkId_iterator;
    typedef linkId_sequence::const_iterator linkId_const_iterator;
    typedef ::xsd::cxx::tree::traits< linkId_type, char > linkId_traits;

    const linkId_sequence&
    linkId () const;

    linkId_sequence&
    linkId ();

    void
    linkId (const linkId_sequence& s);

    // Constructors.
    //
    PartyTradeIdentifier (const partyReference_type&);

    PartyTradeIdentifier (::std::auto_ptr< partyReference_type >&);

    PartyTradeIdentifier (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    PartyTradeIdentifier (const PartyTradeIdentifier& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual PartyTradeIdentifier*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PartyTradeIdentifier ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    linkId_sequence linkId_;
  };

  class AllocationTradeIdentifier: public ::FpML_4_2::PartyTradeIdentifier
  {
    public:
    // blockTradeId
    // 
    typedef ::FpML_4_2::PartyTradeIdentifier blockTradeId_type;
    typedef ::xsd::cxx::tree::optional< blockTradeId_type > blockTradeId_optional;
    typedef ::xsd::cxx::tree::traits< blockTradeId_type, char > blockTradeId_traits;

    const blockTradeId_optional&
    blockTradeId () const;

    blockTradeId_optional&
    blockTradeId ();

    void
    blockTradeId (const blockTradeId_type& x);

    void
    blockTradeId (const blockTradeId_optional& x);

    void
    blockTradeId (::std::auto_ptr< blockTradeId_type > p);

    // Constructors.
    //
    AllocationTradeIdentifier (const partyReference_type&);

    AllocationTradeIdentifier (::std::auto_ptr< partyReference_type >&);

    AllocationTradeIdentifier (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    AllocationTradeIdentifier (const AllocationTradeIdentifier& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual AllocationTradeIdentifier*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AllocationTradeIdentifier ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    blockTradeId_optional blockTradeId_;
  };

  class Event: public ::xml_schema::type
  {
    public:
    // eventId
    // 
    typedef ::FpML_4_2::EventId eventId_type;
    typedef ::xsd::cxx::tree::sequence< eventId_type > eventId_sequence;
    typedef eventId_sequence::iterator eventId_iterator;
    typedef eventId_sequence::const_iterator eventId_const_iterator;
    typedef ::xsd::cxx::tree::traits< eventId_type, char > eventId_traits;

    const eventId_sequence&
    eventId () const;

    eventId_sequence&
    eventId ();

    void
    eventId (const eventId_sequence& s);

    // Constructors.
    //
    Event ();

    Event (const ::xercesc::DOMElement& e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Event (const Event& x,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    virtual Event*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Event ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    eventId_sequence eventId_;
  };

  class Amendment: public ::FpML_4_2::Event
  {
    public:
    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_type&
    trade () const;

    trade_type&
    trade ();

    void
    trade (const trade_type& x);

    void
    trade (::std::auto_ptr< trade_type > p);

    // amendmentTradeDate
    // 
    typedef ::xml_schema::date amendmentTradeDate_type;
    typedef ::xsd::cxx::tree::traits< amendmentTradeDate_type, char > amendmentTradeDate_traits;

    const amendmentTradeDate_type&
    amendmentTradeDate () const;

    amendmentTradeDate_type&
    amendmentTradeDate ();

    void
    amendmentTradeDate (const amendmentTradeDate_type& x);

    void
    amendmentTradeDate (::std::auto_ptr< amendmentTradeDate_type > p);

    // amendmentEffectiveDate
    // 
    typedef ::xml_schema::date amendmentEffectiveDate_type;
    typedef ::xsd::cxx::tree::traits< amendmentEffectiveDate_type, char > amendmentEffectiveDate_traits;

    const amendmentEffectiveDate_type&
    amendmentEffectiveDate () const;

    amendmentEffectiveDate_type&
    amendmentEffectiveDate ();

    void
    amendmentEffectiveDate (const amendmentEffectiveDate_type& x);

    void
    amendmentEffectiveDate (::std::auto_ptr< amendmentEffectiveDate_type > p);

    // payment
    // 
    typedef ::FpML_4_2::Payment payment_type;
    typedef ::xsd::cxx::tree::optional< payment_type > payment_optional;
    typedef ::xsd::cxx::tree::traits< payment_type, char > payment_traits;

    const payment_optional&
    payment () const;

    payment_optional&
    payment ();

    void
    payment (const payment_type& x);

    void
    payment (const payment_optional& x);

    void
    payment (::std::auto_ptr< payment_type > p);

    // Constructors.
    //
    Amendment (const trade_type&,
               const amendmentTradeDate_type&,
               const amendmentEffectiveDate_type&);

    Amendment (::std::auto_ptr< trade_type >&,
               const amendmentTradeDate_type&,
               const amendmentEffectiveDate_type&);

    Amendment (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Amendment (const Amendment& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual Amendment*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Amendment ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< trade_type > trade_;
    ::xsd::cxx::tree::one< amendmentTradeDate_type > amendmentTradeDate_;
    ::xsd::cxx::tree::one< amendmentEffectiveDate_type > amendmentEffectiveDate_;
    payment_optional payment_;
  };

  class Approval: public ::xml_schema::type
  {
    public:
    // type
    // 
    typedef ::xml_schema::normalized_string type_type;
    typedef ::xsd::cxx::tree::traits< type_type, char > type_traits;

    const type_type&
    type () const;

    type_type&
    type ();

    void
    type (const type_type& x);

    void
    type (::std::auto_ptr< type_type > p);

    // status
    // 
    typedef ::xml_schema::normalized_string status_type;
    typedef ::xsd::cxx::tree::traits< status_type, char > status_traits;

    const status_type&
    status () const;

    status_type&
    status ();

    void
    status (const status_type& x);

    void
    status (::std::auto_ptr< status_type > p);

    // approver
    // 
    typedef ::xml_schema::normalized_string approver_type;
    typedef ::xsd::cxx::tree::optional< approver_type > approver_optional;
    typedef ::xsd::cxx::tree::traits< approver_type, char > approver_traits;

    const approver_optional&
    approver () const;

    approver_optional&
    approver ();

    void
    approver (const approver_type& x);

    void
    approver (const approver_optional& x);

    void
    approver (::std::auto_ptr< approver_type > p);

    // Constructors.
    //
    Approval (const type_type&,
              const status_type&);

    Approval (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Approval (const Approval& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Approval*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Approval ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< type_type > type_;
    ::xsd::cxx::tree::one< status_type > status_;
    approver_optional approver_;
  };

  class Approvals: public ::xml_schema::type
  {
    public:
    // approval
    // 
    typedef ::FpML_4_2::Approval approval_type;
    typedef ::xsd::cxx::tree::sequence< approval_type > approval_sequence;
    typedef approval_sequence::iterator approval_iterator;
    typedef approval_sequence::const_iterator approval_const_iterator;
    typedef ::xsd::cxx::tree::traits< approval_type, char > approval_traits;

    const approval_sequence&
    approval () const;

    approval_sequence&
    approval ();

    void
    approval (const approval_sequence& s);

    // Constructors.
    //
    Approvals ();

    Approvals (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Approvals (const Approvals& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual Approvals*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Approvals ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    approval_sequence approval_;
  };

  class BestFitTrade: public ::xml_schema::type
  {
    public:
    // tradeIdentifier
    // 
    typedef ::FpML_4_2::TradeIdentifier tradeIdentifier_type;
    typedef ::xsd::cxx::tree::traits< tradeIdentifier_type, char > tradeIdentifier_traits;

    const tradeIdentifier_type&
    tradeIdentifier () const;

    tradeIdentifier_type&
    tradeIdentifier ();

    void
    tradeIdentifier (const tradeIdentifier_type& x);

    void
    tradeIdentifier (::std::auto_ptr< tradeIdentifier_type > p);

    // differences
    // 
    typedef ::FpML_4_2::TradeDifference differences_type;
    typedef ::xsd::cxx::tree::sequence< differences_type > differences_sequence;
    typedef differences_sequence::iterator differences_iterator;
    typedef differences_sequence::const_iterator differences_const_iterator;
    typedef ::xsd::cxx::tree::traits< differences_type, char > differences_traits;

    const differences_sequence&
    differences () const;

    differences_sequence&
    differences ();

    void
    differences (const differences_sequence& s);

    // Constructors.
    //
    BestFitTrade (const tradeIdentifier_type&);

    BestFitTrade (::std::auto_ptr< tradeIdentifier_type >&);

    BestFitTrade (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    BestFitTrade (const BestFitTrade& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual BestFitTrade*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BestFitTrade ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tradeIdentifier_type > tradeIdentifier_;
    differences_sequence differences_;
  };

  class BlockTradeIdentifier: public ::FpML_4_2::PartyTradeIdentifier
  {
    public:
    // allocationTradeId
    // 
    typedef ::FpML_4_2::PartyTradeIdentifier allocationTradeId_type;
    typedef ::xsd::cxx::tree::sequence< allocationTradeId_type > allocationTradeId_sequence;
    typedef allocationTradeId_sequence::iterator allocationTradeId_iterator;
    typedef allocationTradeId_sequence::const_iterator allocationTradeId_const_iterator;
    typedef ::xsd::cxx::tree::traits< allocationTradeId_type, char > allocationTradeId_traits;

    const allocationTradeId_sequence&
    allocationTradeId () const;

    allocationTradeId_sequence&
    allocationTradeId ();

    void
    allocationTradeId (const allocationTradeId_sequence& s);

    // blockTradeId
    // 
    typedef ::FpML_4_2::PartyTradeIdentifier blockTradeId_type;
    typedef ::xsd::cxx::tree::optional< blockTradeId_type > blockTradeId_optional;
    typedef ::xsd::cxx::tree::traits< blockTradeId_type, char > blockTradeId_traits;

    const blockTradeId_optional&
    blockTradeId () const;

    blockTradeId_optional&
    blockTradeId ();

    void
    blockTradeId (const blockTradeId_type& x);

    void
    blockTradeId (const blockTradeId_optional& x);

    void
    blockTradeId (::std::auto_ptr< blockTradeId_type > p);

    // Constructors.
    //
    BlockTradeIdentifier (const partyReference_type&);

    BlockTradeIdentifier (::std::auto_ptr< partyReference_type >&);

    BlockTradeIdentifier (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    BlockTradeIdentifier (const BlockTradeIdentifier& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual BlockTradeIdentifier*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BlockTradeIdentifier ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    allocationTradeId_sequence allocationTradeId_;
    blockTradeId_optional blockTradeId_;
  };

  class ChangeContract: public ::xml_schema::type
  {
    public:
    // contractReference
    // 
    typedef ::FpML_4_2::ContractReference contractReference_type;
    typedef ::xsd::cxx::tree::traits< contractReference_type, char > contractReference_traits;

    const contractReference_type&
    contractReference () const;

    contractReference_type&
    contractReference ();

    void
    contractReference (const contractReference_type& x);

    void
    contractReference (::std::auto_ptr< contractReference_type > p);

    // date
    // 
    typedef ::xml_schema::date date_type;
    typedef ::xsd::cxx::tree::traits< date_type, char > date_traits;

    const date_type&
    date () const;

    date_type&
    date ();

    void
    date (const date_type& x);

    void
    date (::std::auto_ptr< date_type > p);

    // effectiveDate
    // 
    typedef ::xml_schema::date effectiveDate_type;
    typedef ::xsd::cxx::tree::traits< effectiveDate_type, char > effectiveDate_traits;

    const effectiveDate_type&
    effectiveDate () const;

    effectiveDate_type&
    effectiveDate ();

    void
    effectiveDate (const effectiveDate_type& x);

    void
    effectiveDate (::std::auto_ptr< effectiveDate_type > p);

    // payment
    // 
    typedef ::FpML_4_2::Payment payment_type;
    typedef ::xsd::cxx::tree::optional< payment_type > payment_optional;
    typedef ::xsd::cxx::tree::traits< payment_type, char > payment_traits;

    const payment_optional&
    payment () const;

    payment_optional&
    payment ();

    void
    payment (const payment_type& x);

    void
    payment (const payment_optional& x);

    void
    payment (::std::auto_ptr< payment_type > p);

    // Constructors.
    //
    ChangeContract (const contractReference_type&,
                    const date_type&,
                    const effectiveDate_type&);

    ChangeContract (::std::auto_ptr< contractReference_type >&,
                    const date_type&,
                    const effectiveDate_type&);

    ChangeContract (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ChangeContract (const ChangeContract& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ChangeContract*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ChangeContract ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< contractReference_type > contractReference_;
    ::xsd::cxx::tree::one< date_type > date_;
    ::xsd::cxx::tree::one< effectiveDate_type > effectiveDate_;
    payment_optional payment_;
  };

  class ChangeContractSize: public ::FpML_4_2::ChangeContract
  {
    public:
    // changeInNotionalAmount
    // 
    typedef ::FpML_4_2::Money changeInNotionalAmount_type;
    typedef ::xsd::cxx::tree::optional< changeInNotionalAmount_type > changeInNotionalAmount_optional;
    typedef ::xsd::cxx::tree::traits< changeInNotionalAmount_type, char > changeInNotionalAmount_traits;

    const changeInNotionalAmount_optional&
    changeInNotionalAmount () const;

    changeInNotionalAmount_optional&
    changeInNotionalAmount ();

    void
    changeInNotionalAmount (const changeInNotionalAmount_type& x);

    void
    changeInNotionalAmount (const changeInNotionalAmount_optional& x);

    void
    changeInNotionalAmount (::std::auto_ptr< changeInNotionalAmount_type > p);

    // outstandingNotionalAmount
    // 
    typedef ::FpML_4_2::Money outstandingNotionalAmount_type;
    typedef ::xsd::cxx::tree::optional< outstandingNotionalAmount_type > outstandingNotionalAmount_optional;
    typedef ::xsd::cxx::tree::traits< outstandingNotionalAmount_type, char > outstandingNotionalAmount_traits;

    const outstandingNotionalAmount_optional&
    outstandingNotionalAmount () const;

    outstandingNotionalAmount_optional&
    outstandingNotionalAmount ();

    void
    outstandingNotionalAmount (const outstandingNotionalAmount_type& x);

    void
    outstandingNotionalAmount (const outstandingNotionalAmount_optional& x);

    void
    outstandingNotionalAmount (::std::auto_ptr< outstandingNotionalAmount_type > p);

    // changeInNumberOfOptions
    // 
    typedef ::xml_schema::decimal changeInNumberOfOptions_type;
    typedef ::xsd::cxx::tree::optional< changeInNumberOfOptions_type > changeInNumberOfOptions_optional;
    typedef ::xsd::cxx::tree::traits< changeInNumberOfOptions_type, char, ::xsd::cxx::tree::schema_type::decimal > changeInNumberOfOptions_traits;

    const changeInNumberOfOptions_optional&
    changeInNumberOfOptions () const;

    changeInNumberOfOptions_optional&
    changeInNumberOfOptions ();

    void
    changeInNumberOfOptions (const changeInNumberOfOptions_type& x);

    void
    changeInNumberOfOptions (const changeInNumberOfOptions_optional& x);

    // outstandingNumberOfOptions
    // 
    typedef ::xml_schema::decimal outstandingNumberOfOptions_type;
    typedef ::xsd::cxx::tree::optional< outstandingNumberOfOptions_type > outstandingNumberOfOptions_optional;
    typedef ::xsd::cxx::tree::traits< outstandingNumberOfOptions_type, char, ::xsd::cxx::tree::schema_type::decimal > outstandingNumberOfOptions_traits;

    const outstandingNumberOfOptions_optional&
    outstandingNumberOfOptions () const;

    outstandingNumberOfOptions_optional&
    outstandingNumberOfOptions ();

    void
    outstandingNumberOfOptions (const outstandingNumberOfOptions_type& x);

    void
    outstandingNumberOfOptions (const outstandingNumberOfOptions_optional& x);

    // changeInNumberOfUnits
    // 
    typedef ::xml_schema::decimal changeInNumberOfUnits_type;
    typedef ::xsd::cxx::tree::optional< changeInNumberOfUnits_type > changeInNumberOfUnits_optional;
    typedef ::xsd::cxx::tree::traits< changeInNumberOfUnits_type, char, ::xsd::cxx::tree::schema_type::decimal > changeInNumberOfUnits_traits;

    const changeInNumberOfUnits_optional&
    changeInNumberOfUnits () const;

    changeInNumberOfUnits_optional&
    changeInNumberOfUnits ();

    void
    changeInNumberOfUnits (const changeInNumberOfUnits_type& x);

    void
    changeInNumberOfUnits (const changeInNumberOfUnits_optional& x);

    // outstandingNumberOfUnits
    // 
    typedef ::xml_schema::decimal outstandingNumberOfUnits_type;
    typedef ::xsd::cxx::tree::optional< outstandingNumberOfUnits_type > outstandingNumberOfUnits_optional;
    typedef ::xsd::cxx::tree::traits< outstandingNumberOfUnits_type, char, ::xsd::cxx::tree::schema_type::decimal > outstandingNumberOfUnits_traits;

    const outstandingNumberOfUnits_optional&
    outstandingNumberOfUnits () const;

    outstandingNumberOfUnits_optional&
    outstandingNumberOfUnits ();

    void
    outstandingNumberOfUnits (const outstandingNumberOfUnits_type& x);

    void
    outstandingNumberOfUnits (const outstandingNumberOfUnits_optional& x);

    // Constructors.
    //
    ChangeContractSize (const contractReference_type&,
                        const date_type&,
                        const effectiveDate_type&);

    ChangeContractSize (::std::auto_ptr< contractReference_type >&,
                        const date_type&,
                        const effectiveDate_type&);

    ChangeContractSize (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    ChangeContractSize (const ChangeContractSize& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual ChangeContractSize*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ChangeContractSize ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    changeInNotionalAmount_optional changeInNotionalAmount_;
    outstandingNotionalAmount_optional outstandingNotionalAmount_;
    changeInNumberOfOptions_optional changeInNumberOfOptions_;
    outstandingNumberOfOptions_optional outstandingNumberOfOptions_;
    changeInNumberOfUnits_optional changeInNumberOfUnits_;
    outstandingNumberOfUnits_optional outstandingNumberOfUnits_;
  };

  class Collateral: public ::xml_schema::type
  {
    public:
    // independentAmount
    // 
    typedef ::FpML_4_2::IndependentAmount independentAmount_type;
    typedef ::xsd::cxx::tree::traits< independentAmount_type, char > independentAmount_traits;

    const independentAmount_type&
    independentAmount () const;

    independentAmount_type&
    independentAmount ();

    void
    independentAmount (const independentAmount_type& x);

    void
    independentAmount (::std::auto_ptr< independentAmount_type > p);

    // Constructors.
    //
    Collateral (const independentAmount_type&);

    Collateral (::std::auto_ptr< independentAmount_type >&);

    Collateral (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    Collateral (const Collateral& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual Collateral*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Collateral ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< independentAmount_type > independentAmount_;
  };

  class Contract: public ::xml_schema::type
  {
    public:
    // header
    // 
    typedef ::FpML_4_2::ContractHeader header_type;
    typedef ::xsd::cxx::tree::traits< header_type, char > header_traits;

    const header_type&
    header () const;

    header_type&
    header ();

    void
    header (const header_type& x);

    void
    header (::std::auto_ptr< header_type > p);

    // product
    // 
    typedef ::FpML_4_2::Product product_type;
    typedef ::xsd::cxx::tree::traits< product_type, char > product_traits;

    const product_type&
    product () const;

    product_type&
    product ();

    void
    product (const product_type& x);

    void
    product (::std::auto_ptr< product_type > p);

    // otherPartyPayment
    // 
    typedef ::FpML_4_2::Payment otherPartyPayment_type;
    typedef ::xsd::cxx::tree::sequence< otherPartyPayment_type > otherPartyPayment_sequence;
    typedef otherPartyPayment_sequence::iterator otherPartyPayment_iterator;
    typedef otherPartyPayment_sequence::const_iterator otherPartyPayment_const_iterator;
    typedef ::xsd::cxx::tree::traits< otherPartyPayment_type, char > otherPartyPayment_traits;

    const otherPartyPayment_sequence&
    otherPartyPayment () const;

    otherPartyPayment_sequence&
    otherPartyPayment ();

    void
    otherPartyPayment (const otherPartyPayment_sequence& s);

    // calculationAgent
    // 
    typedef ::FpML_4_2::CalculationAgent calculationAgent_type;
    typedef ::xsd::cxx::tree::optional< calculationAgent_type > calculationAgent_optional;
    typedef ::xsd::cxx::tree::traits< calculationAgent_type, char > calculationAgent_traits;

    const calculationAgent_optional&
    calculationAgent () const;

    calculationAgent_optional&
    calculationAgent ();

    void
    calculationAgent (const calculationAgent_type& x);

    void
    calculationAgent (const calculationAgent_optional& x);

    void
    calculationAgent (::std::auto_ptr< calculationAgent_type > p);

    // calculationAgentBusinessCenter
    // 
    typedef ::FpML_4_2::BusinessCenter calculationAgentBusinessCenter_type;
    typedef ::xsd::cxx::tree::optional< calculationAgentBusinessCenter_type > calculationAgentBusinessCenter_optional;
    typedef ::xsd::cxx::tree::traits< calculationAgentBusinessCenter_type, char > calculationAgentBusinessCenter_traits;

    const calculationAgentBusinessCenter_optional&
    calculationAgentBusinessCenter () const;

    calculationAgentBusinessCenter_optional&
    calculationAgentBusinessCenter ();

    void
    calculationAgentBusinessCenter (const calculationAgentBusinessCenter_type& x);

    void
    calculationAgentBusinessCenter (const calculationAgentBusinessCenter_optional& x);

    void
    calculationAgentBusinessCenter (::std::auto_ptr< calculationAgentBusinessCenter_type > p);

    // collateral
    // 
    typedef ::FpML_4_2::Collateral collateral_type;
    typedef ::xsd::cxx::tree::optional< collateral_type > collateral_optional;
    typedef ::xsd::cxx::tree::traits< collateral_type, char > collateral_traits;

    const collateral_optional&
    collateral () const;

    collateral_optional&
    collateral ();

    void
    collateral (const collateral_type& x);

    void
    collateral (const collateral_optional& x);

    void
    collateral (::std::auto_ptr< collateral_type > p);

    // documentation
    // 
    typedef ::FpML_4_2::Documentation documentation_type;
    typedef ::xsd::cxx::tree::optional< documentation_type > documentation_optional;
    typedef ::xsd::cxx::tree::traits< documentation_type, char > documentation_traits;

    const documentation_optional&
    documentation () const;

    documentation_optional&
    documentation ();

    void
    documentation (const documentation_type& x);

    void
    documentation (const documentation_optional& x);

    void
    documentation (::std::auto_ptr< documentation_type > p);

    // governingLaw
    // 
    typedef ::FpML_4_2::GoverningLaw governingLaw_type;
    typedef ::xsd::cxx::tree::optional< governingLaw_type > governingLaw_optional;
    typedef ::xsd::cxx::tree::traits< governingLaw_type, char > governingLaw_traits;

    const governingLaw_optional&
    governingLaw () const;

    governingLaw_optional&
    governingLaw ();

    void
    governingLaw (const governingLaw_type& x);

    void
    governingLaw (const governingLaw_optional& x);

    void
    governingLaw (::std::auto_ptr< governingLaw_type > p);

    // Constructors.
    //
    Contract (const header_type&,
              const product_type&);

    Contract (::std::auto_ptr< header_type >&,
              ::std::auto_ptr< product_type >&);

    Contract (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Contract (const Contract& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Contract*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Contract ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< header_type > header_;
    ::xsd::cxx::tree::one< product_type > product_;
    otherPartyPayment_sequence otherPartyPayment_;
    calculationAgent_optional calculationAgent_;
    calculationAgentBusinessCenter_optional calculationAgentBusinessCenter_;
    collateral_optional collateral_;
    documentation_optional documentation_;
    governingLaw_optional governingLaw_;
  };

  class ContractHeader: public ::xml_schema::type
  {
    public:
    // identifier
    // 
    typedef ::FpML_4_2::ContractIdentifier identifier_type;
    typedef ::xsd::cxx::tree::sequence< identifier_type > identifier_sequence;
    typedef identifier_sequence::iterator identifier_iterator;
    typedef identifier_sequence::const_iterator identifier_const_iterator;
    typedef ::xsd::cxx::tree::traits< identifier_type, char > identifier_traits;

    const identifier_sequence&
    identifier () const;

    identifier_sequence&
    identifier ();

    void
    identifier (const identifier_sequence& s);

    // contractDate
    // 
    typedef ::xml_schema::date contractDate_type;
    typedef ::xsd::cxx::tree::traits< contractDate_type, char > contractDate_traits;

    const contractDate_type&
    contractDate () const;

    contractDate_type&
    contractDate ();

    void
    contractDate (const contractDate_type& x);

    void
    contractDate (::std::auto_ptr< contractDate_type > p);

    // Constructors.
    //
    ContractHeader (const contractDate_type&);

    ContractHeader (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ContractHeader (const ContractHeader& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ContractHeader*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ContractHeader ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    identifier_sequence identifier_;
    ::xsd::cxx::tree::one< contractDate_type > contractDate_;
  };

  class ContractId: public ::xml_schema::normalized_string
  {
    public:
    // contractIdScheme
    // 
    typedef ::xml_schema::uri contractIdScheme_type;
    typedef ::xsd::cxx::tree::traits< contractIdScheme_type, char > contractIdScheme_traits;

    const contractIdScheme_type&
    contractIdScheme () const;

    contractIdScheme_type&
    contractIdScheme ();

    void
    contractIdScheme (const contractIdScheme_type& x);

    void
    contractIdScheme (::std::auto_ptr< contractIdScheme_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    ContractId (const contractIdScheme_type&);

    ContractId (const char*,
                const contractIdScheme_type&);

    ContractId (const ::std::string&,
                const contractIdScheme_type&);

    ContractId (const ::xml_schema::normalized_string&,
                const contractIdScheme_type&);

    ContractId (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    ContractId (const ContractId& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual ContractId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ContractId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< contractIdScheme_type > contractIdScheme_;
    id_optional id_;
  };

  class ContractIdentifier: public ::xml_schema::type
  {
    public:
    // partyReference
    // 
    typedef ::FpML_4_2::PartyReference partyReference_type;
    typedef ::xsd::cxx::tree::traits< partyReference_type, char > partyReference_traits;

    const partyReference_type&
    partyReference () const;

    partyReference_type&
    partyReference ();

    void
    partyReference (const partyReference_type& x);

    void
    partyReference (::std::auto_ptr< partyReference_type > p);

    // contractId
    // 
    typedef ::FpML_4_2::ContractId contractId_type;
    typedef ::xsd::cxx::tree::sequence< contractId_type > contractId_sequence;
    typedef contractId_sequence::iterator contractId_iterator;
    typedef contractId_sequence::const_iterator contractId_const_iterator;
    typedef ::xsd::cxx::tree::traits< contractId_type, char > contractId_traits;

    const contractId_sequence&
    contractId () const;

    contractId_sequence&
    contractId ();

    void
    contractId (const contractId_sequence& s);

    // versionedContractId
    // 
    typedef ::FpML_4_2::VersionedContractId versionedContractId_type;
    typedef ::xsd::cxx::tree::sequence< versionedContractId_type > versionedContractId_sequence;
    typedef versionedContractId_sequence::iterator versionedContractId_iterator;
    typedef versionedContractId_sequence::const_iterator versionedContractId_const_iterator;
    typedef ::xsd::cxx::tree::traits< versionedContractId_type, char > versionedContractId_traits;

    const versionedContractId_sequence&
    versionedContractId () const;

    versionedContractId_sequence&
    versionedContractId ();

    void
    versionedContractId (const versionedContractId_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    ContractIdentifier (const partyReference_type&);

    ContractIdentifier (::std::auto_ptr< partyReference_type >&);

    ContractIdentifier (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    ContractIdentifier (const ContractIdentifier& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual ContractIdentifier*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ContractIdentifier ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partyReference_type > partyReference_;
    contractId_sequence contractId_;
    versionedContractId_sequence versionedContractId_;
    id_optional id_;
  };

  class ContractNovation: public ::xml_schema::type
  {
    public:
    // newContractReference
    // 
    typedef ::FpML_4_2::ContractReference newContractReference_type;
    typedef ::xsd::cxx::tree::optional< newContractReference_type > newContractReference_optional;
    typedef ::xsd::cxx::tree::traits< newContractReference_type, char > newContractReference_traits;

    const newContractReference_optional&
    newContractReference () const;

    newContractReference_optional&
    newContractReference ();

    void
    newContractReference (const newContractReference_type& x);

    void
    newContractReference (const newContractReference_optional& x);

    void
    newContractReference (::std::auto_ptr< newContractReference_type > p);

    // newContract
    // 
    typedef ::FpML_4_2::Contract newContract_type;
    typedef ::xsd::cxx::tree::optional< newContract_type > newContract_optional;
    typedef ::xsd::cxx::tree::traits< newContract_type, char > newContract_traits;

    const newContract_optional&
    newContract () const;

    newContract_optional&
    newContract ();

    void
    newContract (const newContract_type& x);

    void
    newContract (const newContract_optional& x);

    void
    newContract (::std::auto_ptr< newContract_type > p);

    // oldContractReference
    // 
    typedef ::FpML_4_2::ContractReference oldContractReference_type;
    typedef ::xsd::cxx::tree::optional< oldContractReference_type > oldContractReference_optional;
    typedef ::xsd::cxx::tree::traits< oldContractReference_type, char > oldContractReference_traits;

    const oldContractReference_optional&
    oldContractReference () const;

    oldContractReference_optional&
    oldContractReference ();

    void
    oldContractReference (const oldContractReference_type& x);

    void
    oldContractReference (const oldContractReference_optional& x);

    void
    oldContractReference (::std::auto_ptr< oldContractReference_type > p);

    // oldContract
    // 
    typedef ::FpML_4_2::Contract oldContract_type;
    typedef ::xsd::cxx::tree::optional< oldContract_type > oldContract_optional;
    typedef ::xsd::cxx::tree::traits< oldContract_type, char > oldContract_traits;

    const oldContract_optional&
    oldContract () const;

    oldContract_optional&
    oldContract ();

    void
    oldContract (const oldContract_type& x);

    void
    oldContract (const oldContract_optional& x);

    void
    oldContract (::std::auto_ptr< oldContract_type > p);

    // transferor
    // 
    typedef ::FpML_4_2::PartyReference transferor_type;
    typedef ::xsd::cxx::tree::traits< transferor_type, char > transferor_traits;

    const transferor_type&
    transferor () const;

    transferor_type&
    transferor ();

    void
    transferor (const transferor_type& x);

    void
    transferor (::std::auto_ptr< transferor_type > p);

    // transferee
    // 
    typedef ::FpML_4_2::PartyReference transferee_type;
    typedef ::xsd::cxx::tree::traits< transferee_type, char > transferee_traits;

    const transferee_type&
    transferee () const;

    transferee_type&
    transferee ();

    void
    transferee (const transferee_type& x);

    void
    transferee (::std::auto_ptr< transferee_type > p);

    // remainingParty
    // 
    typedef ::FpML_4_2::PartyReference remainingParty_type;
    typedef ::xsd::cxx::tree::traits< remainingParty_type, char > remainingParty_traits;

    const remainingParty_type&
    remainingParty () const;

    remainingParty_type&
    remainingParty ();

    void
    remainingParty (const remainingParty_type& x);

    void
    remainingParty (::std::auto_ptr< remainingParty_type > p);

    // otherRemainingParty
    // 
    typedef ::FpML_4_2::PartyReference otherRemainingParty_type;
    typedef ::xsd::cxx::tree::optional< otherRemainingParty_type > otherRemainingParty_optional;
    typedef ::xsd::cxx::tree::traits< otherRemainingParty_type, char > otherRemainingParty_traits;

    const otherRemainingParty_optional&
    otherRemainingParty () const;

    otherRemainingParty_optional&
    otherRemainingParty ();

    void
    otherRemainingParty (const otherRemainingParty_type& x);

    void
    otherRemainingParty (const otherRemainingParty_optional& x);

    void
    otherRemainingParty (::std::auto_ptr< otherRemainingParty_type > p);

    // novationDate
    // 
    typedef ::xml_schema::date novationDate_type;
    typedef ::xsd::cxx::tree::traits< novationDate_type, char > novationDate_traits;

    const novationDate_type&
    novationDate () const;

    novationDate_type&
    novationDate ();

    void
    novationDate (const novationDate_type& x);

    void
    novationDate (::std::auto_ptr< novationDate_type > p);

    // novationContractDate
    // 
    typedef ::xml_schema::date novationContractDate_type;
    typedef ::xsd::cxx::tree::optional< novationContractDate_type > novationContractDate_optional;
    typedef ::xsd::cxx::tree::traits< novationContractDate_type, char > novationContractDate_traits;

    const novationContractDate_optional&
    novationContractDate () const;

    novationContractDate_optional&
    novationContractDate ();

    void
    novationContractDate (const novationContractDate_type& x);

    void
    novationContractDate (const novationContractDate_optional& x);

    void
    novationContractDate (::std::auto_ptr< novationContractDate_type > p);

    // novatedAmount
    // 
    typedef ::FpML_4_2::Money novatedAmount_type;
    typedef ::xsd::cxx::tree::optional< novatedAmount_type > novatedAmount_optional;
    typedef ::xsd::cxx::tree::traits< novatedAmount_type, char > novatedAmount_traits;

    const novatedAmount_optional&
    novatedAmount () const;

    novatedAmount_optional&
    novatedAmount ();

    void
    novatedAmount (const novatedAmount_type& x);

    void
    novatedAmount (const novatedAmount_optional& x);

    void
    novatedAmount (::std::auto_ptr< novatedAmount_type > p);

    // novatedNumberOfOptions
    // 
    typedef ::xml_schema::decimal novatedNumberOfOptions_type;
    typedef ::xsd::cxx::tree::optional< novatedNumberOfOptions_type > novatedNumberOfOptions_optional;
    typedef ::xsd::cxx::tree::traits< novatedNumberOfOptions_type, char, ::xsd::cxx::tree::schema_type::decimal > novatedNumberOfOptions_traits;

    const novatedNumberOfOptions_optional&
    novatedNumberOfOptions () const;

    novatedNumberOfOptions_optional&
    novatedNumberOfOptions ();

    void
    novatedNumberOfOptions (const novatedNumberOfOptions_type& x);

    void
    novatedNumberOfOptions (const novatedNumberOfOptions_optional& x);

    // novatedNumberOfUnits
    // 
    typedef ::xml_schema::decimal novatedNumberOfUnits_type;
    typedef ::xsd::cxx::tree::optional< novatedNumberOfUnits_type > novatedNumberOfUnits_optional;
    typedef ::xsd::cxx::tree::traits< novatedNumberOfUnits_type, char, ::xsd::cxx::tree::schema_type::decimal > novatedNumberOfUnits_traits;

    const novatedNumberOfUnits_optional&
    novatedNumberOfUnits () const;

    novatedNumberOfUnits_optional&
    novatedNumberOfUnits ();

    void
    novatedNumberOfUnits (const novatedNumberOfUnits_type& x);

    void
    novatedNumberOfUnits (const novatedNumberOfUnits_optional& x);

    // fullFirstCalculationPeriod
    // 
    typedef ::xml_schema::boolean fullFirstCalculationPeriod_type;
    typedef ::xsd::cxx::tree::optional< fullFirstCalculationPeriod_type > fullFirstCalculationPeriod_optional;
    typedef ::xsd::cxx::tree::traits< fullFirstCalculationPeriod_type, char > fullFirstCalculationPeriod_traits;

    const fullFirstCalculationPeriod_optional&
    fullFirstCalculationPeriod () const;

    fullFirstCalculationPeriod_optional&
    fullFirstCalculationPeriod ();

    void
    fullFirstCalculationPeriod (const fullFirstCalculationPeriod_type& x);

    void
    fullFirstCalculationPeriod (const fullFirstCalculationPeriod_optional& x);

    // firstPeriodStartDate
    // 
    typedef ::FpML_4_2::FirstPeriodStartDate firstPeriodStartDate_type;
    typedef ::xsd::cxx::tree::sequence< firstPeriodStartDate_type > firstPeriodStartDate_sequence;
    typedef firstPeriodStartDate_sequence::iterator firstPeriodStartDate_iterator;
    typedef firstPeriodStartDate_sequence::const_iterator firstPeriodStartDate_const_iterator;
    typedef ::xsd::cxx::tree::traits< firstPeriodStartDate_type, char > firstPeriodStartDate_traits;

    const firstPeriodStartDate_sequence&
    firstPeriodStartDate () const;

    firstPeriodStartDate_sequence&
    firstPeriodStartDate ();

    void
    firstPeriodStartDate (const firstPeriodStartDate_sequence& s);

    // nonReliance
    // 
    typedef ::FpML_4_2::Empty nonReliance_type;
    typedef ::xsd::cxx::tree::optional< nonReliance_type > nonReliance_optional;
    typedef ::xsd::cxx::tree::traits< nonReliance_type, char > nonReliance_traits;

    const nonReliance_optional&
    nonReliance () const;

    nonReliance_optional&
    nonReliance ();

    void
    nonReliance (const nonReliance_type& x);

    void
    nonReliance (const nonReliance_optional& x);

    void
    nonReliance (::std::auto_ptr< nonReliance_type > p);

    // creditDerivativesNotices
    // 
    typedef ::FpML_4_2::CreditDerivativesNotices creditDerivativesNotices_type;
    typedef ::xsd::cxx::tree::optional< creditDerivativesNotices_type > creditDerivativesNotices_optional;
    typedef ::xsd::cxx::tree::traits< creditDerivativesNotices_type, char > creditDerivativesNotices_traits;

    const creditDerivativesNotices_optional&
    creditDerivativesNotices () const;

    creditDerivativesNotices_optional&
    creditDerivativesNotices ();

    void
    creditDerivativesNotices (const creditDerivativesNotices_type& x);

    void
    creditDerivativesNotices (const creditDerivativesNotices_optional& x);

    void
    creditDerivativesNotices (::std::auto_ptr< creditDerivativesNotices_type > p);

    // contractualDefinitions
    // 
    typedef ::FpML_4_2::ContractualDefinitions contractualDefinitions_type;
    typedef ::xsd::cxx::tree::sequence< contractualDefinitions_type > contractualDefinitions_sequence;
    typedef contractualDefinitions_sequence::iterator contractualDefinitions_iterator;
    typedef contractualDefinitions_sequence::const_iterator contractualDefinitions_const_iterator;
    typedef ::xsd::cxx::tree::traits< contractualDefinitions_type, char > contractualDefinitions_traits;

    const contractualDefinitions_sequence&
    contractualDefinitions () const;

    contractualDefinitions_sequence&
    contractualDefinitions ();

    void
    contractualDefinitions (const contractualDefinitions_sequence& s);

    // contractualTermsSupplement
    // 
    typedef ::FpML_4_2::ContractualTermsSupplement contractualTermsSupplement_type;
    typedef ::xsd::cxx::tree::sequence< contractualTermsSupplement_type > contractualTermsSupplement_sequence;
    typedef contractualTermsSupplement_sequence::iterator contractualTermsSupplement_iterator;
    typedef contractualTermsSupplement_sequence::const_iterator contractualTermsSupplement_const_iterator;
    typedef ::xsd::cxx::tree::traits< contractualTermsSupplement_type, char > contractualTermsSupplement_traits;

    const contractualTermsSupplement_sequence&
    contractualTermsSupplement () const;

    contractualTermsSupplement_sequence&
    contractualTermsSupplement ();

    void
    contractualTermsSupplement (const contractualTermsSupplement_sequence& s);

    // payment
    // 
    typedef ::FpML_4_2::Payment payment_type;
    typedef ::xsd::cxx::tree::optional< payment_type > payment_optional;
    typedef ::xsd::cxx::tree::traits< payment_type, char > payment_traits;

    const payment_optional&
    payment () const;

    payment_optional&
    payment ();

    void
    payment (const payment_type& x);

    void
    payment (const payment_optional& x);

    void
    payment (::std::auto_ptr< payment_type > p);

    // Constructors.
    //
    ContractNovation (const transferor_type&,
                      const transferee_type&,
                      const remainingParty_type&,
                      const novationDate_type&);

    ContractNovation (::std::auto_ptr< transferor_type >&,
                      ::std::auto_ptr< transferee_type >&,
                      ::std::auto_ptr< remainingParty_type >&,
                      const novationDate_type&);

    ContractNovation (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    ContractNovation (const ContractNovation& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual ContractNovation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ContractNovation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    newContractReference_optional newContractReference_;
    newContract_optional newContract_;
    oldContractReference_optional oldContractReference_;
    oldContract_optional oldContract_;
    ::xsd::cxx::tree::one< transferor_type > transferor_;
    ::xsd::cxx::tree::one< transferee_type > transferee_;
    ::xsd::cxx::tree::one< remainingParty_type > remainingParty_;
    otherRemainingParty_optional otherRemainingParty_;
    ::xsd::cxx::tree::one< novationDate_type > novationDate_;
    novationContractDate_optional novationContractDate_;
    novatedAmount_optional novatedAmount_;
    novatedNumberOfOptions_optional novatedNumberOfOptions_;
    novatedNumberOfUnits_optional novatedNumberOfUnits_;
    fullFirstCalculationPeriod_optional fullFirstCalculationPeriod_;
    firstPeriodStartDate_sequence firstPeriodStartDate_;
    nonReliance_optional nonReliance_;
    creditDerivativesNotices_optional creditDerivativesNotices_;
    contractualDefinitions_sequence contractualDefinitions_;
    contractualTermsSupplement_sequence contractualTermsSupplement_;
    payment_optional payment_;
  };

  class ContractReference: public ::xml_schema::type
  {
    public:
    // identifier
    // 
    typedef ::FpML_4_2::ContractIdentifier identifier_type;
    typedef ::xsd::cxx::tree::sequence< identifier_type > identifier_sequence;
    typedef identifier_sequence::iterator identifier_iterator;
    typedef identifier_sequence::const_iterator identifier_const_iterator;
    typedef ::xsd::cxx::tree::traits< identifier_type, char > identifier_traits;

    const identifier_sequence&
    identifier () const;

    identifier_sequence&
    identifier ();

    void
    identifier (const identifier_sequence& s);

    // Constructors.
    //
    ContractReference ();

    ContractReference (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ContractReference (const ContractReference& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual ContractReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ContractReference ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    identifier_sequence identifier_;
  };

  class ContractTermination: public ::FpML_4_2::ChangeContract
  {
    public:
    // Constructors.
    //
    ContractTermination (const contractReference_type&,
                         const date_type&,
                         const effectiveDate_type&);

    ContractTermination (::std::auto_ptr< contractReference_type >&,
                         const date_type&,
                         const effectiveDate_type&);

    ContractTermination (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ContractTermination (const ContractTermination& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual ContractTermination*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ContractTermination ();
  };

  class CreditDerivativesNotices: public ::xml_schema::type
  {
    public:
    // creditEvent
    // 
    typedef ::xml_schema::boolean creditEvent_type;
    typedef ::xsd::cxx::tree::traits< creditEvent_type, char > creditEvent_traits;

    const creditEvent_type&
    creditEvent () const;

    creditEvent_type&
    creditEvent ();

    void
    creditEvent (const creditEvent_type& x);

    // publiclyAvailableInformation
    // 
    typedef ::xml_schema::boolean publiclyAvailableInformation_type;
    typedef ::xsd::cxx::tree::traits< publiclyAvailableInformation_type, char > publiclyAvailableInformation_traits;

    const publiclyAvailableInformation_type&
    publiclyAvailableInformation () const;

    publiclyAvailableInformation_type&
    publiclyAvailableInformation ();

    void
    publiclyAvailableInformation (const publiclyAvailableInformation_type& x);

    // physicalSettlement
    // 
    typedef ::xml_schema::boolean physicalSettlement_type;
    typedef ::xsd::cxx::tree::traits< physicalSettlement_type, char > physicalSettlement_traits;

    const physicalSettlement_type&
    physicalSettlement () const;

    physicalSettlement_type&
    physicalSettlement ();

    void
    physicalSettlement (const physicalSettlement_type& x);

    // Constructors.
    //
    CreditDerivativesNotices (const creditEvent_type&,
                              const publiclyAvailableInformation_type&,
                              const physicalSettlement_type&);

    CreditDerivativesNotices (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    CreditDerivativesNotices (const CreditDerivativesNotices& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual CreditDerivativesNotices*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CreditDerivativesNotices ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< creditEvent_type > creditEvent_;
    ::xsd::cxx::tree::one< publiclyAvailableInformation_type > publiclyAvailableInformation_;
    ::xsd::cxx::tree::one< physicalSettlement_type > physicalSettlement_;
  };

  class Document: public ::xml_schema::type
  {
    public:
    // version
    // 
    typedef ::FpML_4_2::version version_type;
    typedef ::xsd::cxx::tree::traits< version_type, char > version_traits;

    const version_type&
    version () const;

    version_type&
    version ();

    void
    version (const version_type& x);

    void
    version (::std::auto_ptr< version_type > p);

    // expectedBuild
    // 
    typedef ::xml_schema::positive_integer expectedBuild_type;
    typedef ::xsd::cxx::tree::optional< expectedBuild_type > expectedBuild_optional;
    typedef ::xsd::cxx::tree::traits< expectedBuild_type, char > expectedBuild_traits;

    const expectedBuild_optional&
    expectedBuild () const;

    expectedBuild_optional&
    expectedBuild ();

    void
    expectedBuild (const expectedBuild_type& x);

    void
    expectedBuild (const expectedBuild_optional& x);

    // actualBuild
    // 
    typedef ::xml_schema::positive_integer actualBuild_type;
    typedef ::xsd::cxx::tree::traits< actualBuild_type, char > actualBuild_traits;

    const actualBuild_type&
    actualBuild () const;

    static actualBuild_type
    actualBuild_default_value ();

    // Constructors.
    //
    Document (const version_type&);

    Document (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Document (const Document& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Document*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Document ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< version_type > version_;
    expectedBuild_optional expectedBuild_;
    ::xsd::cxx::tree::one< actualBuild_type > actualBuild_;
  };

  class DataDocument: public ::FpML_4_2::Document
  {
    public:
    // validation
    // 
    typedef ::FpML_4_2::Validation validation_type;
    typedef ::xsd::cxx::tree::sequence< validation_type > validation_sequence;
    typedef validation_sequence::iterator validation_iterator;
    typedef validation_sequence::const_iterator validation_const_iterator;
    typedef ::xsd::cxx::tree::traits< validation_type, char > validation_traits;

    const validation_sequence&
    validation () const;

    validation_sequence&
    validation ();

    void
    validation (const validation_sequence& s);

    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::sequence< trade_type > trade_sequence;
    typedef trade_sequence::iterator trade_iterator;
    typedef trade_sequence::const_iterator trade_const_iterator;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_sequence&
    trade () const;

    trade_sequence&
    trade ();

    void
    trade (const trade_sequence& s);

    // portfolio
    // 
    typedef ::FpML_4_2::Portfolio portfolio_type;
    typedef ::xsd::cxx::tree::sequence< portfolio_type > portfolio_sequence;
    typedef portfolio_sequence::iterator portfolio_iterator;
    typedef portfolio_sequence::const_iterator portfolio_const_iterator;
    typedef ::xsd::cxx::tree::traits< portfolio_type, char > portfolio_traits;

    const portfolio_sequence&
    portfolio () const;

    portfolio_sequence&
    portfolio ();

    void
    portfolio (const portfolio_sequence& s);

    // event
    // 
    typedef ::FpML_4_2::Event event_type;
    typedef ::xsd::cxx::tree::sequence< event_type > event_sequence;
    typedef event_sequence::iterator event_iterator;
    typedef event_sequence::const_iterator event_const_iterator;
    typedef ::xsd::cxx::tree::traits< event_type, char > event_traits;

    const event_sequence&
    event () const;

    event_sequence&
    event ();

    void
    event (const event_sequence& s);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    DataDocument (const version_type&);

    DataDocument (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    DataDocument (const DataDocument& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual DataDocument*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DataDocument ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    validation_sequence validation_;
    trade_sequence trade_;
    portfolio_sequence portfolio_;
    event_sequence event_;
    party_sequence party_;
  };

  class EventId: public ::xml_schema::normalized_string
  {
    public:
    // eventIdScheme
    // 
    typedef ::xml_schema::uri eventIdScheme_type;
    typedef ::xsd::cxx::tree::traits< eventIdScheme_type, char > eventIdScheme_traits;

    const eventIdScheme_type&
    eventIdScheme () const;

    eventIdScheme_type&
    eventIdScheme ();

    void
    eventIdScheme (const eventIdScheme_type& x);

    void
    eventIdScheme (::std::auto_ptr< eventIdScheme_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    EventId (const eventIdScheme_type&);

    EventId (const char*,
             const eventIdScheme_type&);

    EventId (const ::std::string&,
             const eventIdScheme_type&);

    EventId (const ::xml_schema::normalized_string&,
             const eventIdScheme_type&);

    EventId (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    EventId (const EventId& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual EventId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EventId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< eventIdScheme_type > eventIdScheme_;
    id_optional id_;
  };

  class FirstPeriodStartDate: public ::xml_schema::date
  {
    public:
    // href
    // 
    typedef ::xml_schema::idref href_type;
    typedef ::xsd::cxx::tree::traits< href_type, char > href_traits;

    const href_type&
    href () const;

    href_type&
    href ();

    void
    href (const href_type& x);

    void
    href (::std::auto_ptr< href_type > p);

    // Constructors.
    //
    FirstPeriodStartDate (const ::xml_schema::date&,
                          const href_type&);

    FirstPeriodStartDate (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    FirstPeriodStartDate (const FirstPeriodStartDate& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual FirstPeriodStartDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FirstPeriodStartDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< href_type > href_;
  };

  class Increase: public ::FpML_4_2::Event
  {
    public:
    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::optional< trade_type > trade_optional;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_optional&
    trade () const;

    trade_optional&
    trade ();

    void
    trade (const trade_type& x);

    void
    trade (const trade_optional& x);

    void
    trade (::std::auto_ptr< trade_type > p);

    // tradeReference
    // 
    typedef ::FpML_4_2::PartyTradeIdentifiers tradeReference_type;
    typedef ::xsd::cxx::tree::optional< tradeReference_type > tradeReference_optional;
    typedef ::xsd::cxx::tree::traits< tradeReference_type, char > tradeReference_traits;

    const tradeReference_optional&
    tradeReference () const;

    tradeReference_optional&
    tradeReference ();

    void
    tradeReference (const tradeReference_type& x);

    void
    tradeReference (const tradeReference_optional& x);

    void
    tradeReference (::std::auto_ptr< tradeReference_type > p);

    // increaseTradeDate
    // 
    typedef ::xml_schema::date increaseTradeDate_type;
    typedef ::xsd::cxx::tree::traits< increaseTradeDate_type, char > increaseTradeDate_traits;

    const increaseTradeDate_type&
    increaseTradeDate () const;

    increaseTradeDate_type&
    increaseTradeDate ();

    void
    increaseTradeDate (const increaseTradeDate_type& x);

    void
    increaseTradeDate (::std::auto_ptr< increaseTradeDate_type > p);

    // increaseEffectiveDate
    // 
    typedef ::xml_schema::date increaseEffectiveDate_type;
    typedef ::xsd::cxx::tree::traits< increaseEffectiveDate_type, char > increaseEffectiveDate_traits;

    const increaseEffectiveDate_type&
    increaseEffectiveDate () const;

    increaseEffectiveDate_type&
    increaseEffectiveDate ();

    void
    increaseEffectiveDate (const increaseEffectiveDate_type& x);

    void
    increaseEffectiveDate (::std::auto_ptr< increaseEffectiveDate_type > p);

    // increaseInNotionalAmount
    // 
    typedef ::FpML_4_2::Money increaseInNotionalAmount_type;
    typedef ::xsd::cxx::tree::optional< increaseInNotionalAmount_type > increaseInNotionalAmount_optional;
    typedef ::xsd::cxx::tree::traits< increaseInNotionalAmount_type, char > increaseInNotionalAmount_traits;

    const increaseInNotionalAmount_optional&
    increaseInNotionalAmount () const;

    increaseInNotionalAmount_optional&
    increaseInNotionalAmount ();

    void
    increaseInNotionalAmount (const increaseInNotionalAmount_type& x);

    void
    increaseInNotionalAmount (const increaseInNotionalAmount_optional& x);

    void
    increaseInNotionalAmount (::std::auto_ptr< increaseInNotionalAmount_type > p);

    // outstandingNotionalAmount
    // 
    typedef ::FpML_4_2::Money outstandingNotionalAmount_type;
    typedef ::xsd::cxx::tree::optional< outstandingNotionalAmount_type > outstandingNotionalAmount_optional;
    typedef ::xsd::cxx::tree::traits< outstandingNotionalAmount_type, char > outstandingNotionalAmount_traits;

    const outstandingNotionalAmount_optional&
    outstandingNotionalAmount () const;

    outstandingNotionalAmount_optional&
    outstandingNotionalAmount ();

    void
    outstandingNotionalAmount (const outstandingNotionalAmount_type& x);

    void
    outstandingNotionalAmount (const outstandingNotionalAmount_optional& x);

    void
    outstandingNotionalAmount (::std::auto_ptr< outstandingNotionalAmount_type > p);

    // increaseInNumberOfOptions
    // 
    typedef ::xml_schema::decimal increaseInNumberOfOptions_type;
    typedef ::xsd::cxx::tree::optional< increaseInNumberOfOptions_type > increaseInNumberOfOptions_optional;
    typedef ::xsd::cxx::tree::traits< increaseInNumberOfOptions_type, char, ::xsd::cxx::tree::schema_type::decimal > increaseInNumberOfOptions_traits;

    const increaseInNumberOfOptions_optional&
    increaseInNumberOfOptions () const;

    increaseInNumberOfOptions_optional&
    increaseInNumberOfOptions ();

    void
    increaseInNumberOfOptions (const increaseInNumberOfOptions_type& x);

    void
    increaseInNumberOfOptions (const increaseInNumberOfOptions_optional& x);

    // outstandingNumberOfOptions
    // 
    typedef ::xml_schema::decimal outstandingNumberOfOptions_type;
    typedef ::xsd::cxx::tree::optional< outstandingNumberOfOptions_type > outstandingNumberOfOptions_optional;
    typedef ::xsd::cxx::tree::traits< outstandingNumberOfOptions_type, char, ::xsd::cxx::tree::schema_type::decimal > outstandingNumberOfOptions_traits;

    const outstandingNumberOfOptions_optional&
    outstandingNumberOfOptions () const;

    outstandingNumberOfOptions_optional&
    outstandingNumberOfOptions ();

    void
    outstandingNumberOfOptions (const outstandingNumberOfOptions_type& x);

    void
    outstandingNumberOfOptions (const outstandingNumberOfOptions_optional& x);

    // payment
    // 
    typedef ::FpML_4_2::Payment payment_type;
    typedef ::xsd::cxx::tree::optional< payment_type > payment_optional;
    typedef ::xsd::cxx::tree::traits< payment_type, char > payment_traits;

    const payment_optional&
    payment () const;

    payment_optional&
    payment ();

    void
    payment (const payment_type& x);

    void
    payment (const payment_optional& x);

    void
    payment (::std::auto_ptr< payment_type > p);

    // Constructors.
    //
    Increase (const increaseTradeDate_type&,
              const increaseEffectiveDate_type&);

    Increase (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Increase (const Increase& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Increase*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Increase ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    trade_optional trade_;
    tradeReference_optional tradeReference_;
    ::xsd::cxx::tree::one< increaseTradeDate_type > increaseTradeDate_;
    ::xsd::cxx::tree::one< increaseEffectiveDate_type > increaseEffectiveDate_;
    increaseInNotionalAmount_optional increaseInNotionalAmount_;
    outstandingNotionalAmount_optional outstandingNotionalAmount_;
    increaseInNumberOfOptions_optional increaseInNumberOfOptions_;
    outstandingNumberOfOptions_optional outstandingNumberOfOptions_;
    payment_optional payment_;
  };

  class IndependentAmount: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // paymentDetail
    // 
    typedef ::FpML_4_2::PaymentDetail paymentDetail_type;
    typedef ::xsd::cxx::tree::sequence< paymentDetail_type > paymentDetail_sequence;
    typedef paymentDetail_sequence::iterator paymentDetail_iterator;
    typedef paymentDetail_sequence::const_iterator paymentDetail_const_iterator;
    typedef ::xsd::cxx::tree::traits< paymentDetail_type, char > paymentDetail_traits;

    const paymentDetail_sequence&
    paymentDetail () const;

    paymentDetail_sequence&
    paymentDetail ();

    void
    paymentDetail (const paymentDetail_sequence& s);

    // Constructors.
    //
    IndependentAmount (const payerPartyReference_type&,
                       const receiverPartyReference_type&);

    IndependentAmount (::std::auto_ptr< payerPartyReference_type >&,
                       ::std::auto_ptr< receiverPartyReference_type >&);

    IndependentAmount (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    IndependentAmount (const IndependentAmount& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual IndependentAmount*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IndependentAmount ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    paymentDetail_sequence paymentDetail_;
  };

  class LinkId: public ::xml_schema::normalized_string
  {
    public:
    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // linkIdScheme
    // 
    typedef ::xml_schema::uri linkIdScheme_type;
    typedef ::xsd::cxx::tree::traits< linkIdScheme_type, char > linkIdScheme_traits;

    const linkIdScheme_type&
    linkIdScheme () const;

    linkIdScheme_type&
    linkIdScheme ();

    void
    linkIdScheme (const linkIdScheme_type& x);

    void
    linkIdScheme (::std::auto_ptr< linkIdScheme_type > p);

    // Constructors.
    //
    LinkId (const linkIdScheme_type&);

    LinkId (const char*,
            const linkIdScheme_type&);

    LinkId (const ::std::string&,
            const linkIdScheme_type&);

    LinkId (const ::xml_schema::normalized_string&,
            const linkIdScheme_type&);

    LinkId (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    LinkId (const LinkId& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual LinkId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~LinkId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    id_optional id_;
    ::xsd::cxx::tree::one< linkIdScheme_type > linkIdScheme_;
  };

  class Party: public ::xml_schema::type
  {
    public:
    // partyId
    // 
    typedef ::FpML_4_2::PartyId partyId_type;
    typedef ::xsd::cxx::tree::sequence< partyId_type > partyId_sequence;
    typedef partyId_sequence::iterator partyId_iterator;
    typedef partyId_sequence::const_iterator partyId_const_iterator;
    typedef ::xsd::cxx::tree::traits< partyId_type, char > partyId_traits;

    const partyId_sequence&
    partyId () const;

    partyId_sequence&
    partyId ();

    void
    partyId (const partyId_sequence& s);

    // partyName
    // 
    typedef ::xml_schema::normalized_string partyName_type;
    typedef ::xsd::cxx::tree::optional< partyName_type > partyName_optional;
    typedef ::xsd::cxx::tree::traits< partyName_type, char > partyName_traits;

    const partyName_optional&
    partyName () const;

    partyName_optional&
    partyName ();

    void
    partyName (const partyName_type& x);

    void
    partyName (const partyName_optional& x);

    void
    partyName (::std::auto_ptr< partyName_type > p);

    // account
    // 
    typedef ::FpML_4_2::Account account_type;
    typedef ::xsd::cxx::tree::sequence< account_type > account_sequence;
    typedef account_sequence::iterator account_iterator;
    typedef account_sequence::const_iterator account_const_iterator;
    typedef ::xsd::cxx::tree::traits< account_type, char > account_traits;

    const account_sequence&
    account () const;

    account_sequence&
    account ();

    void
    account (const account_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Party (const id_type&);

    Party (const ::xercesc::DOMElement& e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Party (const Party& x,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    virtual Party*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Party ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    partyId_sequence partyId_;
    partyName_optional partyName_;
    account_sequence account_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class PartyId: public ::xml_schema::normalized_string
  {
    public:
    // partyIdScheme
    // 
    typedef ::xml_schema::uri partyIdScheme_type;
    typedef ::xsd::cxx::tree::traits< partyIdScheme_type, char > partyIdScheme_traits;

    const partyIdScheme_type&
    partyIdScheme () const;

    partyIdScheme_type&
    partyIdScheme ();

    void
    partyIdScheme (const partyIdScheme_type& x);

    void
    partyIdScheme (::std::auto_ptr< partyIdScheme_type > p);

    static const partyIdScheme_type&
    partyIdScheme_default_value ();

    // Constructors.
    //
    PartyId ();

    PartyId (const char*);

    PartyId (const ::std::string&);

    PartyId (const ::xml_schema::normalized_string&);

    PartyId (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    PartyId (const PartyId& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual PartyId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PartyId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partyIdScheme_type > partyIdScheme_;
    static const partyIdScheme_type partyIdScheme_default_value_;
  };

  class PartyPortfolioName: public ::xml_schema::type
  {
    public:
    // partyReference
    // 
    typedef ::FpML_4_2::PartyReference partyReference_type;
    typedef ::xsd::cxx::tree::traits< partyReference_type, char > partyReference_traits;

    const partyReference_type&
    partyReference () const;

    partyReference_type&
    partyReference ();

    void
    partyReference (const partyReference_type& x);

    void
    partyReference (::std::auto_ptr< partyReference_type > p);

    // portfolioName
    // 
    typedef ::FpML_4_2::PortfolioName portfolioName_type;
    typedef ::xsd::cxx::tree::sequence< portfolioName_type > portfolioName_sequence;
    typedef portfolioName_sequence::iterator portfolioName_iterator;
    typedef portfolioName_sequence::const_iterator portfolioName_const_iterator;
    typedef ::xsd::cxx::tree::traits< portfolioName_type, char > portfolioName_traits;

    const portfolioName_sequence&
    portfolioName () const;

    portfolioName_sequence&
    portfolioName ();

    void
    portfolioName (const portfolioName_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    PartyPortfolioName (const partyReference_type&);

    PartyPortfolioName (::std::auto_ptr< partyReference_type >&);

    PartyPortfolioName (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    PartyPortfolioName (const PartyPortfolioName& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual PartyPortfolioName*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PartyPortfolioName ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partyReference_type > partyReference_;
    portfolioName_sequence portfolioName_;
    id_optional id_;
  };

  class PartyRole: public ::xml_schema::type
  {
    public:
    // party
    // 
    typedef ::FpML_4_2::PartyReference party_type;
    typedef ::xsd::cxx::tree::optional< party_type > party_optional;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_optional&
    party () const;

    party_optional&
    party ();

    void
    party (const party_type& x);

    void
    party (const party_optional& x);

    void
    party (::std::auto_ptr< party_type > p);

    // account
    // 
    typedef ::FpML_4_2::AccountReference account_type;
    typedef ::xsd::cxx::tree::optional< account_type > account_optional;
    typedef ::xsd::cxx::tree::traits< account_type, char > account_traits;

    const account_optional&
    account () const;

    account_optional&
    account ();

    void
    account (const account_type& x);

    void
    account (const account_optional& x);

    void
    account (::std::auto_ptr< account_type > p);

    // Constructors.
    //
    PartyRole ();

    PartyRole (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    PartyRole (const PartyRole& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual PartyRole*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PartyRole ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    party_optional party_;
    account_optional account_;
  };

  class PartyTradeIdentifiers: public ::xml_schema::type
  {
    public:
    // partyTradeIdentifier
    // 
    typedef ::FpML_4_2::PartyTradeIdentifier partyTradeIdentifier_type;
    typedef ::xsd::cxx::tree::sequence< partyTradeIdentifier_type > partyTradeIdentifier_sequence;
    typedef partyTradeIdentifier_sequence::iterator partyTradeIdentifier_iterator;
    typedef partyTradeIdentifier_sequence::const_iterator partyTradeIdentifier_const_iterator;
    typedef ::xsd::cxx::tree::traits< partyTradeIdentifier_type, char > partyTradeIdentifier_traits;

    const partyTradeIdentifier_sequence&
    partyTradeIdentifier () const;

    partyTradeIdentifier_sequence&
    partyTradeIdentifier ();

    void
    partyTradeIdentifier (const partyTradeIdentifier_sequence& s);

    // Constructors.
    //
    PartyTradeIdentifiers ();

    PartyTradeIdentifiers (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    PartyTradeIdentifiers (const PartyTradeIdentifiers& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual PartyTradeIdentifiers*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PartyTradeIdentifiers ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    partyTradeIdentifier_sequence partyTradeIdentifier_;
  };

  class PartyTradeInformation: public ::xml_schema::type
  {
    public:
    // partyReference
    // 
    typedef ::FpML_4_2::PartyReference partyReference_type;
    typedef ::xsd::cxx::tree::traits< partyReference_type, char > partyReference_traits;

    const partyReference_type&
    partyReference () const;

    partyReference_type&
    partyReference ();

    void
    partyReference (const partyReference_type& x);

    void
    partyReference (::std::auto_ptr< partyReference_type > p);

    // trader
    // 
    typedef ::FpML_4_2::Trader trader_type;
    typedef ::xsd::cxx::tree::sequence< trader_type > trader_sequence;
    typedef trader_sequence::iterator trader_iterator;
    typedef trader_sequence::const_iterator trader_const_iterator;
    typedef ::xsd::cxx::tree::traits< trader_type, char > trader_traits;

    const trader_sequence&
    trader () const;

    trader_sequence&
    trader ();

    void
    trader (const trader_sequence& s);

    // Constructors.
    //
    PartyTradeInformation (const partyReference_type&);

    PartyTradeInformation (::std::auto_ptr< partyReference_type >&);

    PartyTradeInformation (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    PartyTradeInformation (const PartyTradeInformation& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual PartyTradeInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PartyTradeInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partyReference_type > partyReference_;
    trader_sequence trader_;
  };

  class PaymentDetail: public ::xml_schema::type
  {
    public:
    // adjustablePaymentDate
    // 
    typedef ::FpML_4_2::AdjustableDate2 adjustablePaymentDate_type;
    typedef ::xsd::cxx::tree::optional< adjustablePaymentDate_type > adjustablePaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustablePaymentDate_type, char > adjustablePaymentDate_traits;

    const adjustablePaymentDate_optional&
    adjustablePaymentDate () const;

    adjustablePaymentDate_optional&
    adjustablePaymentDate ();

    void
    adjustablePaymentDate (const adjustablePaymentDate_type& x);

    void
    adjustablePaymentDate (const adjustablePaymentDate_optional& x);

    void
    adjustablePaymentDate (::std::auto_ptr< adjustablePaymentDate_type > p);

    // adjustedPaymentDate
    // 
    typedef ::xml_schema::date adjustedPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedPaymentDate_type > adjustedPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedPaymentDate_type, char > adjustedPaymentDate_traits;

    const adjustedPaymentDate_optional&
    adjustedPaymentDate () const;

    adjustedPaymentDate_optional&
    adjustedPaymentDate ();

    void
    adjustedPaymentDate (const adjustedPaymentDate_type& x);

    void
    adjustedPaymentDate (const adjustedPaymentDate_optional& x);

    void
    adjustedPaymentDate (::std::auto_ptr< adjustedPaymentDate_type > p);

    // paymentAmount
    // 
    typedef ::FpML_4_2::Money paymentAmount_type;
    typedef ::xsd::cxx::tree::optional< paymentAmount_type > paymentAmount_optional;
    typedef ::xsd::cxx::tree::traits< paymentAmount_type, char > paymentAmount_traits;

    const paymentAmount_optional&
    paymentAmount () const;

    paymentAmount_optional&
    paymentAmount ();

    void
    paymentAmount (const paymentAmount_type& x);

    void
    paymentAmount (const paymentAmount_optional& x);

    void
    paymentAmount (::std::auto_ptr< paymentAmount_type > p);

    // paymentRule
    // 
    typedef ::FpML_4_2::PaymentRule paymentRule_type;
    typedef ::xsd::cxx::tree::optional< paymentRule_type > paymentRule_optional;
    typedef ::xsd::cxx::tree::traits< paymentRule_type, char > paymentRule_traits;

    const paymentRule_optional&
    paymentRule () const;

    paymentRule_optional&
    paymentRule ();

    void
    paymentRule (const paymentRule_type& x);

    void
    paymentRule (const paymentRule_optional& x);

    void
    paymentRule (::std::auto_ptr< paymentRule_type > p);

    // Constructors.
    //
    PaymentDetail ();

    PaymentDetail (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    PaymentDetail (const PaymentDetail& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual PaymentDetail*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PaymentDetail ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    adjustablePaymentDate_optional adjustablePaymentDate_;
    adjustedPaymentDate_optional adjustedPaymentDate_;
    paymentAmount_optional paymentAmount_;
    paymentRule_optional paymentRule_;
  };

  class PaymentRule: public ::xml_schema::type
  {
    public:
    // Constructors.
    //
    PaymentRule ();

    PaymentRule (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    PaymentRule (const ::xercesc::DOMAttr& a,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    PaymentRule (const ::std::string& s,
                 const ::xercesc::DOMElement* e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    PaymentRule (const PaymentRule& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual PaymentRule*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PaymentRule ();
  };

  class PercentageRule: public ::FpML_4_2::PaymentRule
  {
    public:
    // paymentPercent
    // 
    typedef ::xml_schema::decimal paymentPercent_type;
    typedef ::xsd::cxx::tree::traits< paymentPercent_type, char, ::xsd::cxx::tree::schema_type::decimal > paymentPercent_traits;

    const paymentPercent_type&
    paymentPercent () const;

    paymentPercent_type&
    paymentPercent ();

    void
    paymentPercent (const paymentPercent_type& x);

    // notionalAmountReference
    // 
    typedef ::FpML_4_2::NotionalAmountReference notionalAmountReference_type;
    typedef ::xsd::cxx::tree::traits< notionalAmountReference_type, char > notionalAmountReference_traits;

    const notionalAmountReference_type&
    notionalAmountReference () const;

    notionalAmountReference_type&
    notionalAmountReference ();

    void
    notionalAmountReference (const notionalAmountReference_type& x);

    void
    notionalAmountReference (::std::auto_ptr< notionalAmountReference_type > p);

    // Constructors.
    //
    PercentageRule (const paymentPercent_type&,
                    const notionalAmountReference_type&);

    PercentageRule (const paymentPercent_type&,
                    ::std::auto_ptr< notionalAmountReference_type >&);

    PercentageRule (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    PercentageRule (const PercentageRule& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual PercentageRule*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PercentageRule ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< paymentPercent_type > paymentPercent_;
    ::xsd::cxx::tree::one< notionalAmountReference_type > notionalAmountReference_;
  };

  class Portfolio: public ::xml_schema::type
  {
    public:
    // partyPortfolioName
    // 
    typedef ::FpML_4_2::PartyPortfolioName partyPortfolioName_type;
    typedef ::xsd::cxx::tree::optional< partyPortfolioName_type > partyPortfolioName_optional;
    typedef ::xsd::cxx::tree::traits< partyPortfolioName_type, char > partyPortfolioName_traits;

    const partyPortfolioName_optional&
    partyPortfolioName () const;

    partyPortfolioName_optional&
    partyPortfolioName ();

    void
    partyPortfolioName (const partyPortfolioName_type& x);

    void
    partyPortfolioName (const partyPortfolioName_optional& x);

    void
    partyPortfolioName (::std::auto_ptr< partyPortfolioName_type > p);

    // tradeId
    // 
    typedef ::FpML_4_2::TradeId tradeId_type;
    typedef ::xsd::cxx::tree::sequence< tradeId_type > tradeId_sequence;
    typedef tradeId_sequence::iterator tradeId_iterator;
    typedef tradeId_sequence::const_iterator tradeId_const_iterator;
    typedef ::xsd::cxx::tree::traits< tradeId_type, char > tradeId_traits;

    const tradeId_sequence&
    tradeId () const;

    tradeId_sequence&
    tradeId ();

    void
    tradeId (const tradeId_sequence& s);

    // portfolio
    // 
    typedef ::FpML_4_2::Portfolio portfolio_type;
    typedef ::xsd::cxx::tree::sequence< portfolio_type > portfolio_sequence;
    typedef portfolio_sequence::iterator portfolio_iterator;
    typedef portfolio_sequence::const_iterator portfolio_const_iterator;
    typedef ::xsd::cxx::tree::traits< portfolio_type, char > portfolio_traits;

    const portfolio_sequence&
    portfolio () const;

    portfolio_sequence&
    portfolio ();

    void
    portfolio (const portfolio_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Portfolio ();

    Portfolio (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Portfolio (const Portfolio& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual Portfolio*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Portfolio ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    partyPortfolioName_optional partyPortfolioName_;
    tradeId_sequence tradeId_;
    portfolio_sequence portfolio_;
    id_optional id_;
  };

  class PortfolioName: public ::xml_schema::normalized_string
  {
    public:
    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // portfolioNameScheme
    // 
    typedef ::xml_schema::uri portfolioNameScheme_type;
    typedef ::xsd::cxx::tree::optional< portfolioNameScheme_type > portfolioNameScheme_optional;
    typedef ::xsd::cxx::tree::traits< portfolioNameScheme_type, char > portfolioNameScheme_traits;

    const portfolioNameScheme_optional&
    portfolioNameScheme () const;

    portfolioNameScheme_optional&
    portfolioNameScheme ();

    void
    portfolioNameScheme (const portfolioNameScheme_type& x);

    void
    portfolioNameScheme (const portfolioNameScheme_optional& x);

    void
    portfolioNameScheme (::std::auto_ptr< portfolioNameScheme_type > p);

    // Constructors.
    //
    PortfolioName ();

    PortfolioName (const char*);

    PortfolioName (const ::std::string&);

    PortfolioName (const ::xml_schema::normalized_string&);

    PortfolioName (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    PortfolioName (const PortfolioName& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual PortfolioName*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PortfolioName ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    id_optional id_;
    portfolioNameScheme_optional portfolioNameScheme_;
  };

  class QueryParameter: public ::xml_schema::type
  {
    public:
    // queryParameterId
    // 
    typedef ::FpML_4_2::QueryParameterId queryParameterId_type;
    typedef ::xsd::cxx::tree::traits< queryParameterId_type, char > queryParameterId_traits;

    const queryParameterId_type&
    queryParameterId () const;

    queryParameterId_type&
    queryParameterId ();

    void
    queryParameterId (const queryParameterId_type& x);

    void
    queryParameterId (::std::auto_ptr< queryParameterId_type > p);

    // queryParameterValue
    // 
    typedef ::xml_schema::normalized_string queryParameterValue_type;
    typedef ::xsd::cxx::tree::optional< queryParameterValue_type > queryParameterValue_optional;
    typedef ::xsd::cxx::tree::traits< queryParameterValue_type, char > queryParameterValue_traits;

    const queryParameterValue_optional&
    queryParameterValue () const;

    queryParameterValue_optional&
    queryParameterValue ();

    void
    queryParameterValue (const queryParameterValue_type& x);

    void
    queryParameterValue (const queryParameterValue_optional& x);

    void
    queryParameterValue (::std::auto_ptr< queryParameterValue_type > p);

    // queryParameterOperator
    // 
    typedef ::FpML_4_2::QueryParameterOperator queryParameterOperator_type;
    typedef ::xsd::cxx::tree::optional< queryParameterOperator_type > queryParameterOperator_optional;
    typedef ::xsd::cxx::tree::traits< queryParameterOperator_type, char > queryParameterOperator_traits;

    const queryParameterOperator_optional&
    queryParameterOperator () const;

    queryParameterOperator_optional&
    queryParameterOperator ();

    void
    queryParameterOperator (const queryParameterOperator_type& x);

    void
    queryParameterOperator (const queryParameterOperator_optional& x);

    void
    queryParameterOperator (::std::auto_ptr< queryParameterOperator_type > p);

    // Constructors.
    //
    QueryParameter (const queryParameterId_type&);

    QueryParameter (::std::auto_ptr< queryParameterId_type >&);

    QueryParameter (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    QueryParameter (const QueryParameter& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual QueryParameter*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~QueryParameter ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< queryParameterId_type > queryParameterId_;
    queryParameterValue_optional queryParameterValue_;
    queryParameterOperator_optional queryParameterOperator_;
  };

  class QueryParameterId: public ::xml_schema::normalized_string
  {
    public:
    // queryParameterIdScheme
    // 
    typedef ::xml_schema::uri queryParameterIdScheme_type;
    typedef ::xsd::cxx::tree::traits< queryParameterIdScheme_type, char > queryParameterIdScheme_traits;

    const queryParameterIdScheme_type&
    queryParameterIdScheme () const;

    queryParameterIdScheme_type&
    queryParameterIdScheme ();

    void
    queryParameterIdScheme (const queryParameterIdScheme_type& x);

    void
    queryParameterIdScheme (::std::auto_ptr< queryParameterIdScheme_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    QueryParameterId (const queryParameterIdScheme_type&);

    QueryParameterId (const char*,
                      const queryParameterIdScheme_type&);

    QueryParameterId (const ::std::string&,
                      const queryParameterIdScheme_type&);

    QueryParameterId (const ::xml_schema::normalized_string&,
                      const queryParameterIdScheme_type&);

    QueryParameterId (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    QueryParameterId (const QueryParameterId& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual QueryParameterId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~QueryParameterId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< queryParameterIdScheme_type > queryParameterIdScheme_;
    id_optional id_;
  };

  class QueryParameterOperator: public ::xml_schema::normalized_string
  {
    public:
    // queryParameterOperatorScheme
    // 
    typedef ::xml_schema::uri queryParameterOperatorScheme_type;
    typedef ::xsd::cxx::tree::traits< queryParameterOperatorScheme_type, char > queryParameterOperatorScheme_traits;

    const queryParameterOperatorScheme_type&
    queryParameterOperatorScheme () const;

    queryParameterOperatorScheme_type&
    queryParameterOperatorScheme ();

    void
    queryParameterOperatorScheme (const queryParameterOperatorScheme_type& x);

    void
    queryParameterOperatorScheme (::std::auto_ptr< queryParameterOperatorScheme_type > p);

    static const queryParameterOperatorScheme_type&
    queryParameterOperatorScheme_default_value ();

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    QueryParameterOperator ();

    QueryParameterOperator (const char*);

    QueryParameterOperator (const ::std::string&);

    QueryParameterOperator (const ::xml_schema::normalized_string&);

    QueryParameterOperator (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    QueryParameterOperator (const QueryParameterOperator& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual QueryParameterOperator*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~QueryParameterOperator ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< queryParameterOperatorScheme_type > queryParameterOperatorScheme_;
    static const queryParameterOperatorScheme_type queryParameterOperatorScheme_default_value_;
    id_optional id_;
  };

  class QueryPortfolio: public ::FpML_4_2::Portfolio
  {
    public:
    // queryParameter
    // 
    typedef ::FpML_4_2::QueryParameter queryParameter_type;
    typedef ::xsd::cxx::tree::sequence< queryParameter_type > queryParameter_sequence;
    typedef queryParameter_sequence::iterator queryParameter_iterator;
    typedef queryParameter_sequence::const_iterator queryParameter_const_iterator;
    typedef ::xsd::cxx::tree::traits< queryParameter_type, char > queryParameter_traits;

    const queryParameter_sequence&
    queryParameter () const;

    queryParameter_sequence&
    queryParameter ();

    void
    queryParameter (const queryParameter_sequence& s);

    // Constructors.
    //
    QueryPortfolio ();

    QueryPortfolio (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    QueryPortfolio (const QueryPortfolio& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual QueryPortfolio*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~QueryPortfolio ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    queryParameter_sequence queryParameter_;
  };

  class Strategy: public ::FpML_4_2::Product
  {
    public:
    // premiumProductReference
    // 
    typedef ::FpML_4_2::ProductReference premiumProductReference_type;
    typedef ::xsd::cxx::tree::optional< premiumProductReference_type > premiumProductReference_optional;
    typedef ::xsd::cxx::tree::traits< premiumProductReference_type, char > premiumProductReference_traits;

    const premiumProductReference_optional&
    premiumProductReference () const;

    premiumProductReference_optional&
    premiumProductReference ();

    void
    premiumProductReference (const premiumProductReference_type& x);

    void
    premiumProductReference (const premiumProductReference_optional& x);

    void
    premiumProductReference (::std::auto_ptr< premiumProductReference_type > p);

    // product
    // 
    typedef ::FpML_4_2::Product product_type;
    typedef ::xsd::cxx::tree::sequence< product_type > product_sequence;
    typedef product_sequence::iterator product_iterator;
    typedef product_sequence::const_iterator product_const_iterator;
    typedef ::xsd::cxx::tree::traits< product_type, char > product_traits;

    const product_sequence&
    product () const;

    product_sequence&
    product ();

    void
    product (const product_sequence& s);

    // Constructors.
    //
    Strategy ();

    Strategy (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Strategy (const Strategy& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Strategy*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Strategy ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    premiumProductReference_optional premiumProductReference_;
    product_sequence product_;
  };

  class Trade: public ::xml_schema::type
  {
    public:
    // tradeHeader
    // 
    typedef ::FpML_4_2::TradeHeader tradeHeader_type;
    typedef ::xsd::cxx::tree::traits< tradeHeader_type, char > tradeHeader_traits;

    const tradeHeader_type&
    tradeHeader () const;

    tradeHeader_type&
    tradeHeader ();

    void
    tradeHeader (const tradeHeader_type& x);

    void
    tradeHeader (::std::auto_ptr< tradeHeader_type > p);

    // product
    // 
    typedef ::FpML_4_2::Product product_type;
    typedef ::xsd::cxx::tree::traits< product_type, char > product_traits;

    const product_type&
    product () const;

    product_type&
    product ();

    void
    product (const product_type& x);

    void
    product (::std::auto_ptr< product_type > p);

    // otherPartyPayment
    // 
    typedef ::FpML_4_2::Payment otherPartyPayment_type;
    typedef ::xsd::cxx::tree::sequence< otherPartyPayment_type > otherPartyPayment_sequence;
    typedef otherPartyPayment_sequence::iterator otherPartyPayment_iterator;
    typedef otherPartyPayment_sequence::const_iterator otherPartyPayment_const_iterator;
    typedef ::xsd::cxx::tree::traits< otherPartyPayment_type, char > otherPartyPayment_traits;

    const otherPartyPayment_sequence&
    otherPartyPayment () const;

    otherPartyPayment_sequence&
    otherPartyPayment ();

    void
    otherPartyPayment (const otherPartyPayment_sequence& s);

    // brokerPartyReference
    // 
    typedef ::FpML_4_2::PartyReference brokerPartyReference_type;
    typedef ::xsd::cxx::tree::sequence< brokerPartyReference_type > brokerPartyReference_sequence;
    typedef brokerPartyReference_sequence::iterator brokerPartyReference_iterator;
    typedef brokerPartyReference_sequence::const_iterator brokerPartyReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< brokerPartyReference_type, char > brokerPartyReference_traits;

    const brokerPartyReference_sequence&
    brokerPartyReference () const;

    brokerPartyReference_sequence&
    brokerPartyReference ();

    void
    brokerPartyReference (const brokerPartyReference_sequence& s);

    // calculationAgent
    // 
    typedef ::FpML_4_2::CalculationAgent calculationAgent_type;
    typedef ::xsd::cxx::tree::optional< calculationAgent_type > calculationAgent_optional;
    typedef ::xsd::cxx::tree::traits< calculationAgent_type, char > calculationAgent_traits;

    const calculationAgent_optional&
    calculationAgent () const;

    calculationAgent_optional&
    calculationAgent ();

    void
    calculationAgent (const calculationAgent_type& x);

    void
    calculationAgent (const calculationAgent_optional& x);

    void
    calculationAgent (::std::auto_ptr< calculationAgent_type > p);

    // calculationAgentBusinessCenter
    // 
    typedef ::FpML_4_2::BusinessCenter calculationAgentBusinessCenter_type;
    typedef ::xsd::cxx::tree::optional< calculationAgentBusinessCenter_type > calculationAgentBusinessCenter_optional;
    typedef ::xsd::cxx::tree::traits< calculationAgentBusinessCenter_type, char > calculationAgentBusinessCenter_traits;

    const calculationAgentBusinessCenter_optional&
    calculationAgentBusinessCenter () const;

    calculationAgentBusinessCenter_optional&
    calculationAgentBusinessCenter ();

    void
    calculationAgentBusinessCenter (const calculationAgentBusinessCenter_type& x);

    void
    calculationAgentBusinessCenter (const calculationAgentBusinessCenter_optional& x);

    void
    calculationAgentBusinessCenter (::std::auto_ptr< calculationAgentBusinessCenter_type > p);

    // collateral
    // 
    typedef ::FpML_4_2::Collateral collateral_type;
    typedef ::xsd::cxx::tree::optional< collateral_type > collateral_optional;
    typedef ::xsd::cxx::tree::traits< collateral_type, char > collateral_traits;

    const collateral_optional&
    collateral () const;

    collateral_optional&
    collateral ();

    void
    collateral (const collateral_type& x);

    void
    collateral (const collateral_optional& x);

    void
    collateral (::std::auto_ptr< collateral_type > p);

    // documentation
    // 
    typedef ::FpML_4_2::Documentation documentation_type;
    typedef ::xsd::cxx::tree::optional< documentation_type > documentation_optional;
    typedef ::xsd::cxx::tree::traits< documentation_type, char > documentation_traits;

    const documentation_optional&
    documentation () const;

    documentation_optional&
    documentation ();

    void
    documentation (const documentation_type& x);

    void
    documentation (const documentation_optional& x);

    void
    documentation (::std::auto_ptr< documentation_type > p);

    // governingLaw
    // 
    typedef ::FpML_4_2::GoverningLaw governingLaw_type;
    typedef ::xsd::cxx::tree::optional< governingLaw_type > governingLaw_optional;
    typedef ::xsd::cxx::tree::traits< governingLaw_type, char > governingLaw_traits;

    const governingLaw_optional&
    governingLaw () const;

    governingLaw_optional&
    governingLaw ();

    void
    governingLaw (const governingLaw_type& x);

    void
    governingLaw (const governingLaw_optional& x);

    void
    governingLaw (::std::auto_ptr< governingLaw_type > p);

    // allocations
    // 
    typedef ::FpML_4_2::Allocations allocations_type;
    typedef ::xsd::cxx::tree::optional< allocations_type > allocations_optional;
    typedef ::xsd::cxx::tree::traits< allocations_type, char > allocations_traits;

    const allocations_optional&
    allocations () const;

    allocations_optional&
    allocations ();

    void
    allocations (const allocations_type& x);

    void
    allocations (const allocations_optional& x);

    void
    allocations (::std::auto_ptr< allocations_type > p);

    // tradeSide
    // 
    typedef ::FpML_4_2::TradeSide tradeSide_type;
    typedef ::xsd::cxx::tree::sequence< tradeSide_type > tradeSide_sequence;
    typedef tradeSide_sequence::iterator tradeSide_iterator;
    typedef tradeSide_sequence::const_iterator tradeSide_const_iterator;
    typedef ::xsd::cxx::tree::traits< tradeSide_type, char > tradeSide_traits;

    const tradeSide_sequence&
    tradeSide () const;

    tradeSide_sequence&
    tradeSide ();

    void
    tradeSide (const tradeSide_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Trade (const tradeHeader_type&,
           const product_type&);

    Trade (::std::auto_ptr< tradeHeader_type >&,
           ::std::auto_ptr< product_type >&);

    Trade (const ::xercesc::DOMElement& e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Trade (const Trade& x,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    virtual Trade*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Trade ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tradeHeader_type > tradeHeader_;
    ::xsd::cxx::tree::one< product_type > product_;
    otherPartyPayment_sequence otherPartyPayment_;
    brokerPartyReference_sequence brokerPartyReference_;
    calculationAgent_optional calculationAgent_;
    calculationAgentBusinessCenter_optional calculationAgentBusinessCenter_;
    collateral_optional collateral_;
    documentation_optional documentation_;
    governingLaw_optional governingLaw_;
    allocations_optional allocations_;
    tradeSide_sequence tradeSide_;
    id_optional id_;
  };

  class TradeDifference: public ::xml_schema::type
  {
    public:
    // differenceType
    // 
    typedef ::FpML_4_2::DifferenceTypeEnum differenceType_type;
    typedef ::xsd::cxx::tree::traits< differenceType_type, char > differenceType_traits;

    const differenceType_type&
    differenceType () const;

    differenceType_type&
    differenceType ();

    void
    differenceType (const differenceType_type& x);

    void
    differenceType (::std::auto_ptr< differenceType_type > p);

    // differenceSeverity
    // 
    typedef ::FpML_4_2::DifferenceSeverityEnum differenceSeverity_type;
    typedef ::xsd::cxx::tree::traits< differenceSeverity_type, char > differenceSeverity_traits;

    const differenceSeverity_type&
    differenceSeverity () const;

    differenceSeverity_type&
    differenceSeverity ();

    void
    differenceSeverity (const differenceSeverity_type& x);

    void
    differenceSeverity (::std::auto_ptr< differenceSeverity_type > p);

    // element
    // 
    typedef ::xml_schema::string element_type;
    typedef ::xsd::cxx::tree::traits< element_type, char > element_traits;

    const element_type&
    element () const;

    element_type&
    element ();

    void
    element (const element_type& x);

    void
    element (::std::auto_ptr< element_type > p);

    // basePath
    // 
    typedef ::xml_schema::string basePath_type;
    typedef ::xsd::cxx::tree::optional< basePath_type > basePath_optional;
    typedef ::xsd::cxx::tree::traits< basePath_type, char > basePath_traits;

    const basePath_optional&
    basePath () const;

    basePath_optional&
    basePath ();

    void
    basePath (const basePath_type& x);

    void
    basePath (const basePath_optional& x);

    void
    basePath (::std::auto_ptr< basePath_type > p);

    // baseValue
    // 
    typedef ::xml_schema::string baseValue_type;
    typedef ::xsd::cxx::tree::optional< baseValue_type > baseValue_optional;
    typedef ::xsd::cxx::tree::traits< baseValue_type, char > baseValue_traits;

    const baseValue_optional&
    baseValue () const;

    baseValue_optional&
    baseValue ();

    void
    baseValue (const baseValue_type& x);

    void
    baseValue (const baseValue_optional& x);

    void
    baseValue (::std::auto_ptr< baseValue_type > p);

    // otherPath
    // 
    typedef ::xml_schema::string otherPath_type;
    typedef ::xsd::cxx::tree::optional< otherPath_type > otherPath_optional;
    typedef ::xsd::cxx::tree::traits< otherPath_type, char > otherPath_traits;

    const otherPath_optional&
    otherPath () const;

    otherPath_optional&
    otherPath ();

    void
    otherPath (const otherPath_type& x);

    void
    otherPath (const otherPath_optional& x);

    void
    otherPath (::std::auto_ptr< otherPath_type > p);

    // otherValue
    // 
    typedef ::xml_schema::string otherValue_type;
    typedef ::xsd::cxx::tree::optional< otherValue_type > otherValue_optional;
    typedef ::xsd::cxx::tree::traits< otherValue_type, char > otherValue_traits;

    const otherValue_optional&
    otherValue () const;

    otherValue_optional&
    otherValue ();

    void
    otherValue (const otherValue_type& x);

    void
    otherValue (const otherValue_optional& x);

    void
    otherValue (::std::auto_ptr< otherValue_type > p);

    // missingElement
    // 
    typedef ::xml_schema::string missingElement_type;
    typedef ::xsd::cxx::tree::sequence< missingElement_type > missingElement_sequence;
    typedef missingElement_sequence::iterator missingElement_iterator;
    typedef missingElement_sequence::const_iterator missingElement_const_iterator;
    typedef ::xsd::cxx::tree::traits< missingElement_type, char > missingElement_traits;

    const missingElement_sequence&
    missingElement () const;

    missingElement_sequence&
    missingElement ();

    void
    missingElement (const missingElement_sequence& s);

    // extraElement
    // 
    typedef ::xml_schema::string extraElement_type;
    typedef ::xsd::cxx::tree::sequence< extraElement_type > extraElement_sequence;
    typedef extraElement_sequence::iterator extraElement_iterator;
    typedef extraElement_sequence::const_iterator extraElement_const_iterator;
    typedef ::xsd::cxx::tree::traits< extraElement_type, char > extraElement_traits;

    const extraElement_sequence&
    extraElement () const;

    extraElement_sequence&
    extraElement ();

    void
    extraElement (const extraElement_sequence& s);

    // message
    // 
    typedef ::xml_schema::string message_type;
    typedef ::xsd::cxx::tree::traits< message_type, char > message_traits;

    const message_type&
    message () const;

    message_type&
    message ();

    void
    message (const message_type& x);

    void
    message (::std::auto_ptr< message_type > p);

    // Constructors.
    //
    TradeDifference (const differenceType_type&,
                     const differenceSeverity_type&,
                     const element_type&,
                     const message_type&);

    TradeDifference (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    TradeDifference (const TradeDifference& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual TradeDifference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeDifference ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< differenceType_type > differenceType_;
    ::xsd::cxx::tree::one< differenceSeverity_type > differenceSeverity_;
    ::xsd::cxx::tree::one< element_type > element_;
    basePath_optional basePath_;
    baseValue_optional baseValue_;
    otherPath_optional otherPath_;
    otherValue_optional otherValue_;
    missingElement_sequence missingElement_;
    extraElement_sequence extraElement_;
    ::xsd::cxx::tree::one< message_type > message_;
  };

  class TradeHeader: public ::xml_schema::type
  {
    public:
    // partyTradeIdentifier
    // 
    typedef ::FpML_4_2::PartyTradeIdentifier partyTradeIdentifier_type;
    typedef ::xsd::cxx::tree::sequence< partyTradeIdentifier_type > partyTradeIdentifier_sequence;
    typedef partyTradeIdentifier_sequence::iterator partyTradeIdentifier_iterator;
    typedef partyTradeIdentifier_sequence::const_iterator partyTradeIdentifier_const_iterator;
    typedef ::xsd::cxx::tree::traits< partyTradeIdentifier_type, char > partyTradeIdentifier_traits;

    const partyTradeIdentifier_sequence&
    partyTradeIdentifier () const;

    partyTradeIdentifier_sequence&
    partyTradeIdentifier ();

    void
    partyTradeIdentifier (const partyTradeIdentifier_sequence& s);

    // partyTradeInformation
    // 
    typedef ::FpML_4_2::PartyTradeInformation partyTradeInformation_type;
    typedef ::xsd::cxx::tree::sequence< partyTradeInformation_type > partyTradeInformation_sequence;
    typedef partyTradeInformation_sequence::iterator partyTradeInformation_iterator;
    typedef partyTradeInformation_sequence::const_iterator partyTradeInformation_const_iterator;
    typedef ::xsd::cxx::tree::traits< partyTradeInformation_type, char > partyTradeInformation_traits;

    const partyTradeInformation_sequence&
    partyTradeInformation () const;

    partyTradeInformation_sequence&
    partyTradeInformation ();

    void
    partyTradeInformation (const partyTradeInformation_sequence& s);

    // tradeDate
    // 
    typedef ::FpML_4_2::IdentifiedDate tradeDate_type;
    typedef ::xsd::cxx::tree::traits< tradeDate_type, char > tradeDate_traits;

    const tradeDate_type&
    tradeDate () const;

    tradeDate_type&
    tradeDate ();

    void
    tradeDate (const tradeDate_type& x);

    void
    tradeDate (::std::auto_ptr< tradeDate_type > p);

    // Constructors.
    //
    TradeHeader (const tradeDate_type&);

    TradeHeader (::std::auto_ptr< tradeDate_type >&);

    TradeHeader (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    TradeHeader (const TradeHeader& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual TradeHeader*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeHeader ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    partyTradeIdentifier_sequence partyTradeIdentifier_;
    partyTradeInformation_sequence partyTradeInformation_;
    ::xsd::cxx::tree::one< tradeDate_type > tradeDate_;
  };

  class TradeId: public ::xml_schema::normalized_string
  {
    public:
    // tradeIdScheme
    // 
    typedef ::xml_schema::uri tradeIdScheme_type;
    typedef ::xsd::cxx::tree::traits< tradeIdScheme_type, char > tradeIdScheme_traits;

    const tradeIdScheme_type&
    tradeIdScheme () const;

    tradeIdScheme_type&
    tradeIdScheme ();

    void
    tradeIdScheme (const tradeIdScheme_type& x);

    void
    tradeIdScheme (::std::auto_ptr< tradeIdScheme_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    TradeId (const tradeIdScheme_type&);

    TradeId (const char*,
             const tradeIdScheme_type&);

    TradeId (const ::std::string&,
             const tradeIdScheme_type&);

    TradeId (const ::xml_schema::normalized_string&,
             const tradeIdScheme_type&);

    TradeId (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    TradeId (const TradeId& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual TradeId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tradeIdScheme_type > tradeIdScheme_;
    id_optional id_;
  };

  class Trader: public ::xml_schema::normalized_string
  {
    public:
    // traderScheme
    // 
    typedef ::xml_schema::uri traderScheme_type;
    typedef ::xsd::cxx::tree::optional< traderScheme_type > traderScheme_optional;
    typedef ::xsd::cxx::tree::traits< traderScheme_type, char > traderScheme_traits;

    const traderScheme_optional&
    traderScheme () const;

    traderScheme_optional&
    traderScheme ();

    void
    traderScheme (const traderScheme_type& x);

    void
    traderScheme (const traderScheme_optional& x);

    void
    traderScheme (::std::auto_ptr< traderScheme_type > p);

    // Constructors.
    //
    Trader ();

    Trader (const char*);

    Trader (const ::std::string&);

    Trader (const ::xml_schema::normalized_string&);

    Trader (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Trader (const Trader& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Trader*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Trader ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    traderScheme_optional traderScheme_;
  };

  class TradeSide: public ::xml_schema::type
  {
    public:
    // orderer
    // 
    typedef ::FpML_4_2::PartyRole orderer_type;
    typedef ::xsd::cxx::tree::optional< orderer_type > orderer_optional;
    typedef ::xsd::cxx::tree::traits< orderer_type, char > orderer_traits;

    const orderer_optional&
    orderer () const;

    orderer_optional&
    orderer ();

    void
    orderer (const orderer_type& x);

    void
    orderer (const orderer_optional& x);

    void
    orderer (::std::auto_ptr< orderer_type > p);

    // introducer
    // 
    typedef ::FpML_4_2::PartyRole introducer_type;
    typedef ::xsd::cxx::tree::optional< introducer_type > introducer_optional;
    typedef ::xsd::cxx::tree::traits< introducer_type, char > introducer_traits;

    const introducer_optional&
    introducer () const;

    introducer_optional&
    introducer ();

    void
    introducer (const introducer_type& x);

    void
    introducer (const introducer_optional& x);

    void
    introducer (::std::auto_ptr< introducer_type > p);

    // executor
    // 
    typedef ::FpML_4_2::PartyRole executor_type;
    typedef ::xsd::cxx::tree::optional< executor_type > executor_optional;
    typedef ::xsd::cxx::tree::traits< executor_type, char > executor_traits;

    const executor_optional&
    executor () const;

    executor_optional&
    executor ();

    void
    executor (const executor_type& x);

    void
    executor (const executor_optional& x);

    void
    executor (::std::auto_ptr< executor_type > p);

    // confirmer
    // 
    typedef ::FpML_4_2::PartyRole confirmer_type;
    typedef ::xsd::cxx::tree::optional< confirmer_type > confirmer_optional;
    typedef ::xsd::cxx::tree::traits< confirmer_type, char > confirmer_traits;

    const confirmer_optional&
    confirmer () const;

    confirmer_optional&
    confirmer ();

    void
    confirmer (const confirmer_type& x);

    void
    confirmer (const confirmer_optional& x);

    void
    confirmer (::std::auto_ptr< confirmer_type > p);

    // creditor
    // 
    typedef ::FpML_4_2::PartyRole creditor_type;
    typedef ::xsd::cxx::tree::traits< creditor_type, char > creditor_traits;

    const creditor_type&
    creditor () const;

    creditor_type&
    creditor ();

    void
    creditor (const creditor_type& x);

    void
    creditor (::std::auto_ptr< creditor_type > p);

    // calculater
    // 
    typedef ::FpML_4_2::PartyRole calculater_type;
    typedef ::xsd::cxx::tree::optional< calculater_type > calculater_optional;
    typedef ::xsd::cxx::tree::traits< calculater_type, char > calculater_traits;

    const calculater_optional&
    calculater () const;

    calculater_optional&
    calculater ();

    void
    calculater (const calculater_type& x);

    void
    calculater (const calculater_optional& x);

    void
    calculater (::std::auto_ptr< calculater_type > p);

    // settler
    // 
    typedef ::FpML_4_2::PartyRole settler_type;
    typedef ::xsd::cxx::tree::optional< settler_type > settler_optional;
    typedef ::xsd::cxx::tree::traits< settler_type, char > settler_traits;

    const settler_optional&
    settler () const;

    settler_optional&
    settler ();

    void
    settler (const settler_type& x);

    void
    settler (const settler_optional& x);

    void
    settler (::std::auto_ptr< settler_type > p);

    // beneficiary
    // 
    typedef ::FpML_4_2::PartyRole beneficiary_type;
    typedef ::xsd::cxx::tree::optional< beneficiary_type > beneficiary_optional;
    typedef ::xsd::cxx::tree::traits< beneficiary_type, char > beneficiary_traits;

    const beneficiary_optional&
    beneficiary () const;

    beneficiary_optional&
    beneficiary ();

    void
    beneficiary (const beneficiary_type& x);

    void
    beneficiary (const beneficiary_optional& x);

    void
    beneficiary (::std::auto_ptr< beneficiary_type > p);

    // accountant
    // 
    typedef ::FpML_4_2::PartyRole accountant_type;
    typedef ::xsd::cxx::tree::sequence< accountant_type > accountant_sequence;
    typedef accountant_sequence::iterator accountant_iterator;
    typedef accountant_sequence::const_iterator accountant_const_iterator;
    typedef ::xsd::cxx::tree::traits< accountant_type, char > accountant_traits;

    const accountant_sequence&
    accountant () const;

    accountant_sequence&
    accountant ();

    void
    accountant (const accountant_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    TradeSide (const creditor_type&,
               const id_type&);

    TradeSide (::std::auto_ptr< creditor_type >&,
               const id_type&);

    TradeSide (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    TradeSide (const TradeSide& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual TradeSide*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeSide ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    orderer_optional orderer_;
    introducer_optional introducer_;
    executor_optional executor_;
    confirmer_optional confirmer_;
    ::xsd::cxx::tree::one< creditor_type > creditor_;
    calculater_optional calculater_;
    settler_optional settler_;
    beneficiary_optional beneficiary_;
    accountant_sequence accountant_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class Validation: public ::xml_schema::normalized_string
  {
    public:
    // validationScheme
    // 
    typedef ::xml_schema::uri validationScheme_type;
    typedef ::xsd::cxx::tree::optional< validationScheme_type > validationScheme_optional;
    typedef ::xsd::cxx::tree::traits< validationScheme_type, char > validationScheme_traits;

    const validationScheme_optional&
    validationScheme () const;

    validationScheme_optional&
    validationScheme ();

    void
    validationScheme (const validationScheme_type& x);

    void
    validationScheme (const validationScheme_optional& x);

    void
    validationScheme (::std::auto_ptr< validationScheme_type > p);

    // Constructors.
    //
    Validation ();

    Validation (const char*);

    Validation (const ::std::string&);

    Validation (const ::xml_schema::normalized_string&);

    Validation (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    Validation (const Validation& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual Validation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Validation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    validationScheme_optional validationScheme_;
  };

  class VersionedContractId: public ::xml_schema::type
  {
    public:
    // contractId
    // 
    typedef ::FpML_4_2::ContractId contractId_type;
    typedef ::xsd::cxx::tree::traits< contractId_type, char > contractId_traits;

    const contractId_type&
    contractId () const;

    contractId_type&
    contractId ();

    void
    contractId (const contractId_type& x);

    void
    contractId (::std::auto_ptr< contractId_type > p);

    // version
    // 
    typedef ::xml_schema::non_negative_integer version_type;
    typedef ::xsd::cxx::tree::traits< version_type, char > version_traits;

    const version_type&
    version () const;

    version_type&
    version ();

    void
    version (const version_type& x);

    // effectiveDate
    // 
    typedef ::FpML_4_2::IdentifiedDate effectiveDate_type;
    typedef ::xsd::cxx::tree::optional< effectiveDate_type > effectiveDate_optional;
    typedef ::xsd::cxx::tree::traits< effectiveDate_type, char > effectiveDate_traits;

    const effectiveDate_optional&
    effectiveDate () const;

    effectiveDate_optional&
    effectiveDate ();

    void
    effectiveDate (const effectiveDate_type& x);

    void
    effectiveDate (const effectiveDate_optional& x);

    void
    effectiveDate (::std::auto_ptr< effectiveDate_type > p);

    // Constructors.
    //
    VersionedContractId (const contractId_type&,
                         const version_type&);

    VersionedContractId (::std::auto_ptr< contractId_type >&,
                         const version_type&);

    VersionedContractId (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    VersionedContractId (const VersionedContractId& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual VersionedContractId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VersionedContractId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< contractId_type > contractId_;
    ::xsd::cxx::tree::one< version_type > version_;
    effectiveDate_optional effectiveDate_;
  };

  class VersionedTradeId: public ::xml_schema::type
  {
    public:
    // tradeId
    // 
    typedef ::FpML_4_2::TradeId tradeId_type;
    typedef ::xsd::cxx::tree::traits< tradeId_type, char > tradeId_traits;

    const tradeId_type&
    tradeId () const;

    tradeId_type&
    tradeId ();

    void
    tradeId (const tradeId_type& x);

    void
    tradeId (::std::auto_ptr< tradeId_type > p);

    // version
    // 
    typedef ::xml_schema::non_negative_integer version_type;
    typedef ::xsd::cxx::tree::traits< version_type, char > version_traits;

    const version_type&
    version () const;

    version_type&
    version ();

    void
    version (const version_type& x);

    // effectiveDate
    // 
    typedef ::FpML_4_2::IdentifiedDate effectiveDate_type;
    typedef ::xsd::cxx::tree::optional< effectiveDate_type > effectiveDate_optional;
    typedef ::xsd::cxx::tree::traits< effectiveDate_type, char > effectiveDate_traits;

    const effectiveDate_optional&
    effectiveDate () const;

    effectiveDate_optional&
    effectiveDate ();

    void
    effectiveDate (const effectiveDate_type& x);

    void
    effectiveDate (const effectiveDate_optional& x);

    void
    effectiveDate (::std::auto_ptr< effectiveDate_type > p);

    // Constructors.
    //
    VersionedTradeId (const tradeId_type&,
                      const version_type&);

    VersionedTradeId (::std::auto_ptr< tradeId_type >&,
                      const version_type&);

    VersionedTradeId (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    VersionedTradeId (const VersionedTradeId& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual VersionedTradeId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VersionedTradeId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tradeId_type > tradeId_;
    ::xsd::cxx::tree::one< version_type > version_;
    effectiveDate_optional effectiveDate_;
  };

  class version: public ::xml_schema::token
  {
    public:
    enum value
    {
      cxx_4_0,
      cxx_4_1,
      cxx_4_2
    };

    version (value v);

    version (const char* v);

    version (const ::std::string& v);

    version (const ::xml_schema::token& v);

    version (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    version (const ::xercesc::DOMAttr& a,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    version (const ::std::string& s,
             const ::xercesc::DOMElement* e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    version (const version& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual version*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    version&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_version_convert ();
    }

    protected:
    value
    _xsd_version_convert () const;

    public:
    static const char* const _xsd_version_literals_[3];
    static const value _xsd_version_indexes_[3];
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const QueryParameterValue&);

  void
  operator<< (::xercesc::DOMAttr&, const QueryParameterValue&);

  void
  operator<< (::xml_schema::list_stream&,
              const QueryParameterValue&);

  void
  operator<< (::xercesc::DOMElement&, const Account&);

  void
  operator<< (::xercesc::DOMElement&, const AccountId&);

  void
  operator<< (::xercesc::DOMElement&, const Allocation&);

  void
  operator<< (::xercesc::DOMElement&, const Allocations&);

  void
  operator<< (::xercesc::DOMElement&, const TradeIdentifier&);

  void
  operator<< (::xercesc::DOMElement&, const PartyTradeIdentifier&);

  void
  operator<< (::xercesc::DOMElement&, const AllocationTradeIdentifier&);

  void
  operator<< (::xercesc::DOMElement&, const Event&);

  void
  operator<< (::xercesc::DOMElement&, const Amendment&);

  void
  operator<< (::xercesc::DOMElement&, const Approval&);

  void
  operator<< (::xercesc::DOMElement&, const Approvals&);

  void
  operator<< (::xercesc::DOMElement&, const BestFitTrade&);

  void
  operator<< (::xercesc::DOMElement&, const BlockTradeIdentifier&);

  void
  operator<< (::xercesc::DOMElement&, const ChangeContract&);

  void
  operator<< (::xercesc::DOMElement&, const ChangeContractSize&);

  void
  operator<< (::xercesc::DOMElement&, const Collateral&);

  void
  operator<< (::xercesc::DOMElement&, const Contract&);

  void
  operator<< (::xercesc::DOMElement&, const ContractHeader&);

  void
  operator<< (::xercesc::DOMElement&, const ContractId&);

  void
  operator<< (::xercesc::DOMElement&, const ContractIdentifier&);

  void
  operator<< (::xercesc::DOMElement&, const ContractNovation&);

  void
  operator<< (::xercesc::DOMElement&, const ContractReference&);

  void
  operator<< (::xercesc::DOMElement&, const ContractTermination&);

  void
  operator<< (::xercesc::DOMElement&, const CreditDerivativesNotices&);

  void
  operator<< (::xercesc::DOMElement&, const Document&);

  void
  operator<< (::xercesc::DOMElement&, const DataDocument&);

  void
  operator<< (::xercesc::DOMElement&, const EventId&);

  void
  operator<< (::xercesc::DOMElement&, const FirstPeriodStartDate&);

  void
  operator<< (::xercesc::DOMElement&, const Increase&);

  void
  operator<< (::xercesc::DOMElement&, const IndependentAmount&);

  void
  operator<< (::xercesc::DOMElement&, const LinkId&);

  void
  operator<< (::xercesc::DOMElement&, const Party&);

  void
  operator<< (::xercesc::DOMElement&, const PartyId&);

  void
  operator<< (::xercesc::DOMElement&, const PartyPortfolioName&);

  void
  operator<< (::xercesc::DOMElement&, const PartyRole&);

  void
  operator<< (::xercesc::DOMElement&, const PartyTradeIdentifiers&);

  void
  operator<< (::xercesc::DOMElement&, const PartyTradeInformation&);

  void
  operator<< (::xercesc::DOMElement&, const PaymentDetail&);

  void
  operator<< (::xercesc::DOMElement&, const PaymentRule&);

  void
  operator<< (::xercesc::DOMAttr&, const PaymentRule&);

  void
  operator<< (::xml_schema::list_stream&,
              const PaymentRule&);

  void
  operator<< (::xercesc::DOMElement&, const PercentageRule&);

  void
  operator<< (::xercesc::DOMElement&, const Portfolio&);

  void
  operator<< (::xercesc::DOMElement&, const PortfolioName&);

  void
  operator<< (::xercesc::DOMElement&, const QueryParameter&);

  void
  operator<< (::xercesc::DOMElement&, const QueryParameterId&);

  void
  operator<< (::xercesc::DOMElement&, const QueryParameterOperator&);

  void
  operator<< (::xercesc::DOMElement&, const QueryPortfolio&);

  void
  operator<< (::xercesc::DOMElement&, const Strategy&);

  void
  operator<< (::xercesc::DOMElement&, const Trade&);

  void
  operator<< (::xercesc::DOMElement&, const TradeDifference&);

  void
  operator<< (::xercesc::DOMElement&, const TradeHeader&);

  void
  operator<< (::xercesc::DOMElement&, const TradeId&);

  void
  operator<< (::xercesc::DOMElement&, const Trader&);

  void
  operator<< (::xercesc::DOMElement&, const TradeSide&);

  void
  operator<< (::xercesc::DOMElement&, const Validation&);

  void
  operator<< (::xercesc::DOMElement&, const VersionedContractId&);

  void
  operator<< (::xercesc::DOMElement&, const VersionedTradeId&);

  void
  operator<< (::xercesc::DOMElement&, const version&);

  void
  operator<< (::xercesc::DOMAttr&, const version&);

  void
  operator<< (::xml_schema::list_stream&,
              const version&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_DOC_4_2_HXX
