// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_ENUM_4_2_HXX
#define FPML_ENUM_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class AveragingInOutEnum;
  class AveragingMethodEnum;
  class BusinessDayConventionEnum;
  class CalculationAgentPartyEnum;
  class CommissionDenominationEnum;
  class CompoundingMethodEnum;
  class DayTypeEnum;
  class DifferenceSeverityEnum;
  class DifferenceTypeEnum;
  class DiscountingTypeEnum;
  class DividendAmountTypeEnum;
  class DividendDateReferenceEnum;
  class DividendEntitlementEnum;
  class DividendPeriodEnum;
  class ExerciseStyleEnum;
  class FraDiscountingEnum;
  class FrequencyTypeEnum;
  class FxBarrierTypeEnum;
  class IndexEventConsequenceEnum;
  class LengthUnitEnum;
  class MethodOfAdjustmentEnum;
  class NationalisationOrInsolvencyOrDelistingEventEnum;
  class NegativeInterestRateTreatmentEnum;
  class NotionalAdjustmentEnum;
  class ObligationCategoryEnum;
  class OptionTypeEnum;
  class PayerReceiverEnum;
  class PayoutEnum;
  class PayRelativeToEnum;
  class PeriodEnum;
  class PremiumQuoteBasisEnum;
  class PremiumTypeEnum;
  class PriceExpressionEnum;
  class QuotationRateTypeEnum;
  class QuotationSideEnum;
  class QuoteBasisEnum;
  class RateTreatmentEnum;
  class ResetRelativeToEnum;
  class ReturnTypeEnum;
  class RollConventionEnum;
  class RoundingDirectionEnum;
  class SettlementTypeEnum;
  class ShareExtraordinaryEventEnum;
  class SideRateBasisEnum;
  class StandardSettlementStyleEnum;
  class StepRelativeToEnum;
  class StubPeriodTypeEnum;
  class StrikeQuoteBasisEnum;
  class TimeTypeEnum;
  class TouchConditionEnum;
  class TriggerConditionEnum;
  class ValuationMethodEnum;
  class WeeklyRollConventionEnum;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

namespace FpML_4_2
{
  class AveragingInOutEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      In,
      Out,
      Both
    };

    AveragingInOutEnum (value v);

    AveragingInOutEnum (const char* v);

    AveragingInOutEnum (const ::std::string& v);

    AveragingInOutEnum (const ::xml_schema::token& v);

    AveragingInOutEnum (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AveragingInOutEnum (const ::xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AveragingInOutEnum (const ::std::string& s,
                        const ::xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    AveragingInOutEnum (const AveragingInOutEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual AveragingInOutEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    AveragingInOutEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_AveragingInOutEnum_convert ();
    }

    protected:
    value
    _xsd_AveragingInOutEnum_convert () const;

    public:
    static const char* const _xsd_AveragingInOutEnum_literals_[3];
    static const value _xsd_AveragingInOutEnum_indexes_[3];
  };

  class AveragingMethodEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Unweighted,
      Weighted
    };

    AveragingMethodEnum (value v);

    AveragingMethodEnum (const char* v);

    AveragingMethodEnum (const ::std::string& v);

    AveragingMethodEnum (const ::xml_schema::token& v);

    AveragingMethodEnum (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    AveragingMethodEnum (const ::xercesc::DOMAttr& a,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    AveragingMethodEnum (const ::std::string& s,
                         const ::xercesc::DOMElement* e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    AveragingMethodEnum (const AveragingMethodEnum& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual AveragingMethodEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    AveragingMethodEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_AveragingMethodEnum_convert ();
    }

    protected:
    value
    _xsd_AveragingMethodEnum_convert () const;

    public:
    static const char* const _xsd_AveragingMethodEnum_literals_[2];
    static const value _xsd_AveragingMethodEnum_indexes_[2];
  };

  class BusinessDayConventionEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      FOLLOWING,
      FRN,
      MODFOLLOWING,
      PRECEDING,
      MODPRECEDING,
      NONE,
      NotApplicable
    };

    BusinessDayConventionEnum (value v);

    BusinessDayConventionEnum (const char* v);

    BusinessDayConventionEnum (const ::std::string& v);

    BusinessDayConventionEnum (const ::xml_schema::token& v);

    BusinessDayConventionEnum (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    BusinessDayConventionEnum (const ::xercesc::DOMAttr& a,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    BusinessDayConventionEnum (const ::std::string& s,
                               const ::xercesc::DOMElement* e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    BusinessDayConventionEnum (const BusinessDayConventionEnum& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual BusinessDayConventionEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    BusinessDayConventionEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_BusinessDayConventionEnum_convert ();
    }

    protected:
    value
    _xsd_BusinessDayConventionEnum_convert () const;

    public:
    static const char* const _xsd_BusinessDayConventionEnum_literals_[7];
    static const value _xsd_BusinessDayConventionEnum_indexes_[7];
  };

  class CalculationAgentPartyEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      ExercisingParty,
      NonExercisingParty,
      AsSpecifiedInMasterAgreement
    };

    CalculationAgentPartyEnum (value v);

    CalculationAgentPartyEnum (const char* v);

    CalculationAgentPartyEnum (const ::std::string& v);

    CalculationAgentPartyEnum (const ::xml_schema::token& v);

    CalculationAgentPartyEnum (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    CalculationAgentPartyEnum (const ::xercesc::DOMAttr& a,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    CalculationAgentPartyEnum (const ::std::string& s,
                               const ::xercesc::DOMElement* e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    CalculationAgentPartyEnum (const CalculationAgentPartyEnum& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual CalculationAgentPartyEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    CalculationAgentPartyEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_CalculationAgentPartyEnum_convert ();
    }

    protected:
    value
    _xsd_CalculationAgentPartyEnum_convert () const;

    public:
    static const char* const _xsd_CalculationAgentPartyEnum_literals_[3];
    static const value _xsd_CalculationAgentPartyEnum_indexes_[3];
  };

  class CommissionDenominationEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      BPS,
      Percentage,
      CentsPerShare,
      FixedAmount
    };

    CommissionDenominationEnum (value v);

    CommissionDenominationEnum (const char* v);

    CommissionDenominationEnum (const ::std::string& v);

    CommissionDenominationEnum (const ::xml_schema::token& v);

    CommissionDenominationEnum (const ::xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    CommissionDenominationEnum (const ::xercesc::DOMAttr& a,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    CommissionDenominationEnum (const ::std::string& s,
                                const ::xercesc::DOMElement* e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    CommissionDenominationEnum (const CommissionDenominationEnum& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual CommissionDenominationEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    CommissionDenominationEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_CommissionDenominationEnum_convert ();
    }

    protected:
    value
    _xsd_CommissionDenominationEnum_convert () const;

    public:
    static const char* const _xsd_CommissionDenominationEnum_literals_[4];
    static const value _xsd_CommissionDenominationEnum_indexes_[4];
  };

  class CompoundingMethodEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Flat,
      None,
      Straight
    };

    CompoundingMethodEnum (value v);

    CompoundingMethodEnum (const char* v);

    CompoundingMethodEnum (const ::std::string& v);

    CompoundingMethodEnum (const ::xml_schema::token& v);

    CompoundingMethodEnum (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    CompoundingMethodEnum (const ::xercesc::DOMAttr& a,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    CompoundingMethodEnum (const ::std::string& s,
                           const ::xercesc::DOMElement* e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    CompoundingMethodEnum (const CompoundingMethodEnum& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual CompoundingMethodEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    CompoundingMethodEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_CompoundingMethodEnum_convert ();
    }

    protected:
    value
    _xsd_CompoundingMethodEnum_convert () const;

    public:
    static const char* const _xsd_CompoundingMethodEnum_literals_[3];
    static const value _xsd_CompoundingMethodEnum_indexes_[3];
  };

  class DayTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Business,
      Calendar,
      CurrencyBusiness,
      ExchangeBusiness,
      ScheduledTradingDay
    };

    DayTypeEnum (value v);

    DayTypeEnum (const char* v);

    DayTypeEnum (const ::std::string& v);

    DayTypeEnum (const ::xml_schema::token& v);

    DayTypeEnum (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    DayTypeEnum (const ::xercesc::DOMAttr& a,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    DayTypeEnum (const ::std::string& s,
                 const ::xercesc::DOMElement* e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    DayTypeEnum (const DayTypeEnum& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual DayTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DayTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DayTypeEnum_convert ();
    }

    protected:
    value
    _xsd_DayTypeEnum_convert () const;

    public:
    static const char* const _xsd_DayTypeEnum_literals_[5];
    static const value _xsd_DayTypeEnum_indexes_[5];
  };

  class DifferenceSeverityEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Warning,
      Error
    };

    DifferenceSeverityEnum (value v);

    DifferenceSeverityEnum (const char* v);

    DifferenceSeverityEnum (const ::std::string& v);

    DifferenceSeverityEnum (const ::xml_schema::token& v);

    DifferenceSeverityEnum (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    DifferenceSeverityEnum (const ::xercesc::DOMAttr& a,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    DifferenceSeverityEnum (const ::std::string& s,
                            const ::xercesc::DOMElement* e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    DifferenceSeverityEnum (const DifferenceSeverityEnum& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual DifferenceSeverityEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DifferenceSeverityEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DifferenceSeverityEnum_convert ();
    }

    protected:
    value
    _xsd_DifferenceSeverityEnum_convert () const;

    public:
    static const char* const _xsd_DifferenceSeverityEnum_literals_[2];
    static const value _xsd_DifferenceSeverityEnum_indexes_[2];
  };

  class DifferenceTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Value,
      Reference,
      Structure,
      Scheme
    };

    DifferenceTypeEnum (value v);

    DifferenceTypeEnum (const char* v);

    DifferenceTypeEnum (const ::std::string& v);

    DifferenceTypeEnum (const ::xml_schema::token& v);

    DifferenceTypeEnum (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    DifferenceTypeEnum (const ::xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    DifferenceTypeEnum (const ::std::string& s,
                        const ::xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    DifferenceTypeEnum (const DifferenceTypeEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual DifferenceTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DifferenceTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DifferenceTypeEnum_convert ();
    }

    protected:
    value
    _xsd_DifferenceTypeEnum_convert () const;

    public:
    static const char* const _xsd_DifferenceTypeEnum_literals_[4];
    static const value _xsd_DifferenceTypeEnum_indexes_[4];
  };

  class DiscountingTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Standard,
      FRA
    };

    DiscountingTypeEnum (value v);

    DiscountingTypeEnum (const char* v);

    DiscountingTypeEnum (const ::std::string& v);

    DiscountingTypeEnum (const ::xml_schema::token& v);

    DiscountingTypeEnum (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    DiscountingTypeEnum (const ::xercesc::DOMAttr& a,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    DiscountingTypeEnum (const ::std::string& s,
                         const ::xercesc::DOMElement* e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    DiscountingTypeEnum (const DiscountingTypeEnum& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual DiscountingTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DiscountingTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DiscountingTypeEnum_convert ();
    }

    protected:
    value
    _xsd_DiscountingTypeEnum_convert () const;

    public:
    static const char* const _xsd_DiscountingTypeEnum_literals_[2];
    static const value _xsd_DiscountingTypeEnum_indexes_[2];
  };

  class DividendAmountTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      RecordAmount,
      ExAmount,
      PaidAmount,
      AsSpecifiedInMasterConfirmation
    };

    DividendAmountTypeEnum (value v);

    DividendAmountTypeEnum (const char* v);

    DividendAmountTypeEnum (const ::std::string& v);

    DividendAmountTypeEnum (const ::xml_schema::token& v);

    DividendAmountTypeEnum (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    DividendAmountTypeEnum (const ::xercesc::DOMAttr& a,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    DividendAmountTypeEnum (const ::std::string& s,
                            const ::xercesc::DOMElement* e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    DividendAmountTypeEnum (const DividendAmountTypeEnum& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual DividendAmountTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DividendAmountTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DividendAmountTypeEnum_convert ();
    }

    protected:
    value
    _xsd_DividendAmountTypeEnum_convert () const;

    public:
    static const char* const _xsd_DividendAmountTypeEnum_literals_[4];
    static const value _xsd_DividendAmountTypeEnum_indexes_[4];
  };

  class DividendDateReferenceEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      ExDate,
      DividendPaymentDate,
      RecordDate,
      TerminationDate,
      EquityPaymentDate,
      FollowingPaymentDate,
      AdHocDate,
      CumulativeEquityPaid,
      CumulativeLiborPaid,
      CumulativeEquityExDiv,
      CumulativeLiborExDiv
    };

    DividendDateReferenceEnum (value v);

    DividendDateReferenceEnum (const char* v);

    DividendDateReferenceEnum (const ::std::string& v);

    DividendDateReferenceEnum (const ::xml_schema::token& v);

    DividendDateReferenceEnum (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    DividendDateReferenceEnum (const ::xercesc::DOMAttr& a,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    DividendDateReferenceEnum (const ::std::string& s,
                               const ::xercesc::DOMElement* e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    DividendDateReferenceEnum (const DividendDateReferenceEnum& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual DividendDateReferenceEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DividendDateReferenceEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DividendDateReferenceEnum_convert ();
    }

    protected:
    value
    _xsd_DividendDateReferenceEnum_convert () const;

    public:
    static const char* const _xsd_DividendDateReferenceEnum_literals_[11];
    static const value _xsd_DividendDateReferenceEnum_indexes_[11];
  };

  class DividendEntitlementEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      ExDate,
      RecordDate
    };

    DividendEntitlementEnum (value v);

    DividendEntitlementEnum (const char* v);

    DividendEntitlementEnum (const ::std::string& v);

    DividendEntitlementEnum (const ::xml_schema::token& v);

    DividendEntitlementEnum (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    DividendEntitlementEnum (const ::xercesc::DOMAttr& a,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    DividendEntitlementEnum (const ::std::string& s,
                             const ::xercesc::DOMElement* e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    DividendEntitlementEnum (const DividendEntitlementEnum& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual DividendEntitlementEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DividendEntitlementEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DividendEntitlementEnum_convert ();
    }

    protected:
    value
    _xsd_DividendEntitlementEnum_convert () const;

    public:
    static const char* const _xsd_DividendEntitlementEnum_literals_[2];
    static const value _xsd_DividendEntitlementEnum_indexes_[2];
  };

  class DividendPeriodEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      FirstPeriod,
      SecondPeriod
    };

    DividendPeriodEnum (value v);

    DividendPeriodEnum (const char* v);

    DividendPeriodEnum (const ::std::string& v);

    DividendPeriodEnum (const ::xml_schema::token& v);

    DividendPeriodEnum (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    DividendPeriodEnum (const ::xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    DividendPeriodEnum (const ::std::string& s,
                        const ::xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    DividendPeriodEnum (const DividendPeriodEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual DividendPeriodEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    DividendPeriodEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_DividendPeriodEnum_convert ();
    }

    protected:
    value
    _xsd_DividendPeriodEnum_convert () const;

    public:
    static const char* const _xsd_DividendPeriodEnum_literals_[2];
    static const value _xsd_DividendPeriodEnum_indexes_[2];
  };

  class ExerciseStyleEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      American,
      Bermuda,
      European
    };

    ExerciseStyleEnum (value v);

    ExerciseStyleEnum (const char* v);

    ExerciseStyleEnum (const ::std::string& v);

    ExerciseStyleEnum (const ::xml_schema::token& v);

    ExerciseStyleEnum (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ExerciseStyleEnum (const ::xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ExerciseStyleEnum (const ::std::string& s,
                       const ::xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ExerciseStyleEnum (const ExerciseStyleEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual ExerciseStyleEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ExerciseStyleEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ExerciseStyleEnum_convert ();
    }

    protected:
    value
    _xsd_ExerciseStyleEnum_convert () const;

    public:
    static const char* const _xsd_ExerciseStyleEnum_literals_[3];
    static const value _xsd_ExerciseStyleEnum_indexes_[3];
  };

  class FraDiscountingEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      ISDA,
      AFMA,
      NONE
    };

    FraDiscountingEnum (value v);

    FraDiscountingEnum (const char* v);

    FraDiscountingEnum (const ::std::string& v);

    FraDiscountingEnum (const ::xml_schema::token& v);

    FraDiscountingEnum (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    FraDiscountingEnum (const ::xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    FraDiscountingEnum (const ::std::string& s,
                        const ::xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    FraDiscountingEnum (const FraDiscountingEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual FraDiscountingEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    FraDiscountingEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_FraDiscountingEnum_convert ();
    }

    protected:
    value
    _xsd_FraDiscountingEnum_convert () const;

    public:
    static const char* const _xsd_FraDiscountingEnum_literals_[3];
    static const value _xsd_FraDiscountingEnum_indexes_[3];
  };

  class FrequencyTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Day,
      Business
    };

    FrequencyTypeEnum (value v);

    FrequencyTypeEnum (const char* v);

    FrequencyTypeEnum (const ::std::string& v);

    FrequencyTypeEnum (const ::xml_schema::token& v);

    FrequencyTypeEnum (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    FrequencyTypeEnum (const ::xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    FrequencyTypeEnum (const ::std::string& s,
                       const ::xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    FrequencyTypeEnum (const FrequencyTypeEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual FrequencyTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    FrequencyTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_FrequencyTypeEnum_convert ();
    }

    protected:
    value
    _xsd_FrequencyTypeEnum_convert () const;

    public:
    static const char* const _xsd_FrequencyTypeEnum_literals_[2];
    static const value _xsd_FrequencyTypeEnum_indexes_[2];
  };

  class FxBarrierTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Knockin,
      Knockout,
      ReverseKnockin,
      ReverseKnockout
    };

    FxBarrierTypeEnum (value v);

    FxBarrierTypeEnum (const char* v);

    FxBarrierTypeEnum (const ::std::string& v);

    FxBarrierTypeEnum (const ::xml_schema::token& v);

    FxBarrierTypeEnum (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    FxBarrierTypeEnum (const ::xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    FxBarrierTypeEnum (const ::std::string& s,
                       const ::xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    FxBarrierTypeEnum (const FxBarrierTypeEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual FxBarrierTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    FxBarrierTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_FxBarrierTypeEnum_convert ();
    }

    protected:
    value
    _xsd_FxBarrierTypeEnum_convert () const;

    public:
    static const char* const _xsd_FxBarrierTypeEnum_literals_[4];
    static const value _xsd_FxBarrierTypeEnum_indexes_[4];
  };

  class IndexEventConsequenceEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      CalculationAgentAdjustment,
      NegotiatedCloseOut,
      CancellationAndPayment
    };

    IndexEventConsequenceEnum (value v);

    IndexEventConsequenceEnum (const char* v);

    IndexEventConsequenceEnum (const ::std::string& v);

    IndexEventConsequenceEnum (const ::xml_schema::token& v);

    IndexEventConsequenceEnum (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    IndexEventConsequenceEnum (const ::xercesc::DOMAttr& a,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    IndexEventConsequenceEnum (const ::std::string& s,
                               const ::xercesc::DOMElement* e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    IndexEventConsequenceEnum (const IndexEventConsequenceEnum& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual IndexEventConsequenceEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    IndexEventConsequenceEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_IndexEventConsequenceEnum_convert ();
    }

    protected:
    value
    _xsd_IndexEventConsequenceEnum_convert () const;

    public:
    static const char* const _xsd_IndexEventConsequenceEnum_literals_[3];
    static const value _xsd_IndexEventConsequenceEnum_indexes_[3];
  };

  class LengthUnitEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Pages,
      TimeUnit
    };

    LengthUnitEnum (value v);

    LengthUnitEnum (const char* v);

    LengthUnitEnum (const ::std::string& v);

    LengthUnitEnum (const ::xml_schema::token& v);

    LengthUnitEnum (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    LengthUnitEnum (const ::xercesc::DOMAttr& a,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    LengthUnitEnum (const ::std::string& s,
                    const ::xercesc::DOMElement* e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    LengthUnitEnum (const LengthUnitEnum& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual LengthUnitEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    LengthUnitEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_LengthUnitEnum_convert ();
    }

    protected:
    value
    _xsd_LengthUnitEnum_convert () const;

    public:
    static const char* const _xsd_LengthUnitEnum_literals_[2];
    static const value _xsd_LengthUnitEnum_indexes_[2];
  };

  class MethodOfAdjustmentEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      CalculationAgent,
      OptionsExchange
    };

    MethodOfAdjustmentEnum (value v);

    MethodOfAdjustmentEnum (const char* v);

    MethodOfAdjustmentEnum (const ::std::string& v);

    MethodOfAdjustmentEnum (const ::xml_schema::token& v);

    MethodOfAdjustmentEnum (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    MethodOfAdjustmentEnum (const ::xercesc::DOMAttr& a,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    MethodOfAdjustmentEnum (const ::std::string& s,
                            const ::xercesc::DOMElement* e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    MethodOfAdjustmentEnum (const MethodOfAdjustmentEnum& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual MethodOfAdjustmentEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    MethodOfAdjustmentEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_MethodOfAdjustmentEnum_convert ();
    }

    protected:
    value
    _xsd_MethodOfAdjustmentEnum_convert () const;

    public:
    static const char* const _xsd_MethodOfAdjustmentEnum_literals_[2];
    static const value _xsd_MethodOfAdjustmentEnum_indexes_[2];
  };

  class NationalisationOrInsolvencyOrDelistingEventEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      NegotiatedCloseout,
      CancellationAndPayment
    };

    NationalisationOrInsolvencyOrDelistingEventEnum (value v);

    NationalisationOrInsolvencyOrDelistingEventEnum (const char* v);

    NationalisationOrInsolvencyOrDelistingEventEnum (const ::std::string& v);

    NationalisationOrInsolvencyOrDelistingEventEnum (const ::xml_schema::token& v);

    NationalisationOrInsolvencyOrDelistingEventEnum (const ::xercesc::DOMElement& e,
                                                     ::xml_schema::flags f = 0,
                                                     ::xml_schema::container* c = 0);

    NationalisationOrInsolvencyOrDelistingEventEnum (const ::xercesc::DOMAttr& a,
                                                     ::xml_schema::flags f = 0,
                                                     ::xml_schema::container* c = 0);

    NationalisationOrInsolvencyOrDelistingEventEnum (const ::std::string& s,
                                                     const ::xercesc::DOMElement* e,
                                                     ::xml_schema::flags f = 0,
                                                     ::xml_schema::container* c = 0);

    NationalisationOrInsolvencyOrDelistingEventEnum (const NationalisationOrInsolvencyOrDelistingEventEnum& x,
                                                     ::xml_schema::flags f = 0,
                                                     ::xml_schema::container* c = 0);

    virtual NationalisationOrInsolvencyOrDelistingEventEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    NationalisationOrInsolvencyOrDelistingEventEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_NationalisationOrInsolvencyOrDelistingEventEnum_convert ();
    }

    protected:
    value
    _xsd_NationalisationOrInsolvencyOrDelistingEventEnum_convert () const;

    public:
    static const char* const _xsd_NationalisationOrInsolvencyOrDelistingEventEnum_literals_[2];
    static const value _xsd_NationalisationOrInsolvencyOrDelistingEventEnum_indexes_[2];
  };

  class NegativeInterestRateTreatmentEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      NegativeInterestRateMethod,
      ZeroInterestRateMethod
    };

    NegativeInterestRateTreatmentEnum (value v);

    NegativeInterestRateTreatmentEnum (const char* v);

    NegativeInterestRateTreatmentEnum (const ::std::string& v);

    NegativeInterestRateTreatmentEnum (const ::xml_schema::token& v);

    NegativeInterestRateTreatmentEnum (const ::xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    NegativeInterestRateTreatmentEnum (const ::xercesc::DOMAttr& a,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    NegativeInterestRateTreatmentEnum (const ::std::string& s,
                                       const ::xercesc::DOMElement* e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    NegativeInterestRateTreatmentEnum (const NegativeInterestRateTreatmentEnum& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual NegativeInterestRateTreatmentEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    NegativeInterestRateTreatmentEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_NegativeInterestRateTreatmentEnum_convert ();
    }

    protected:
    value
    _xsd_NegativeInterestRateTreatmentEnum_convert () const;

    public:
    static const char* const _xsd_NegativeInterestRateTreatmentEnum_literals_[2];
    static const value _xsd_NegativeInterestRateTreatmentEnum_indexes_[2];
  };

  class NotionalAdjustmentEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Execution,
      PortfolioRebalancing,
      Standard
    };

    NotionalAdjustmentEnum (value v);

    NotionalAdjustmentEnum (const char* v);

    NotionalAdjustmentEnum (const ::std::string& v);

    NotionalAdjustmentEnum (const ::xml_schema::token& v);

    NotionalAdjustmentEnum (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    NotionalAdjustmentEnum (const ::xercesc::DOMAttr& a,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    NotionalAdjustmentEnum (const ::std::string& s,
                            const ::xercesc::DOMElement* e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    NotionalAdjustmentEnum (const NotionalAdjustmentEnum& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual NotionalAdjustmentEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    NotionalAdjustmentEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_NotionalAdjustmentEnum_convert ();
    }

    protected:
    value
    _xsd_NotionalAdjustmentEnum_convert () const;

    public:
    static const char* const _xsd_NotionalAdjustmentEnum_literals_[3];
    static const value _xsd_NotionalAdjustmentEnum_indexes_[3];
  };

  class ObligationCategoryEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Payment,
      BorrowedMoney,
      ReferenceObligationsOnly,
      Bond,
      Loan,
      BondOrLoan
    };

    ObligationCategoryEnum (value v);

    ObligationCategoryEnum (const char* v);

    ObligationCategoryEnum (const ::std::string& v);

    ObligationCategoryEnum (const ::xml_schema::token& v);

    ObligationCategoryEnum (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    ObligationCategoryEnum (const ::xercesc::DOMAttr& a,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    ObligationCategoryEnum (const ::std::string& s,
                            const ::xercesc::DOMElement* e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    ObligationCategoryEnum (const ObligationCategoryEnum& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual ObligationCategoryEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ObligationCategoryEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ObligationCategoryEnum_convert ();
    }

    protected:
    value
    _xsd_ObligationCategoryEnum_convert () const;

    public:
    static const char* const _xsd_ObligationCategoryEnum_literals_[6];
    static const value _xsd_ObligationCategoryEnum_indexes_[6];
  };

  class OptionTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Call,
      Forward,
      Put
    };

    OptionTypeEnum (value v);

    OptionTypeEnum (const char* v);

    OptionTypeEnum (const ::std::string& v);

    OptionTypeEnum (const ::xml_schema::token& v);

    OptionTypeEnum (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    OptionTypeEnum (const ::xercesc::DOMAttr& a,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    OptionTypeEnum (const ::std::string& s,
                    const ::xercesc::DOMElement* e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    OptionTypeEnum (const OptionTypeEnum& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual OptionTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    OptionTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_OptionTypeEnum_convert ();
    }

    protected:
    value
    _xsd_OptionTypeEnum_convert () const;

    public:
    static const char* const _xsd_OptionTypeEnum_literals_[3];
    static const value _xsd_OptionTypeEnum_indexes_[3];
  };

  class PayerReceiverEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Payer,
      Receiver
    };

    PayerReceiverEnum (value v);

    PayerReceiverEnum (const char* v);

    PayerReceiverEnum (const ::std::string& v);

    PayerReceiverEnum (const ::xml_schema::token& v);

    PayerReceiverEnum (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    PayerReceiverEnum (const ::xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    PayerReceiverEnum (const ::std::string& s,
                       const ::xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    PayerReceiverEnum (const PayerReceiverEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual PayerReceiverEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PayerReceiverEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PayerReceiverEnum_convert ();
    }

    protected:
    value
    _xsd_PayerReceiverEnum_convert () const;

    public:
    static const char* const _xsd_PayerReceiverEnum_literals_[2];
    static const value _xsd_PayerReceiverEnum_indexes_[2];
  };

  class PayoutEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Deferred,
      Immediate
    };

    PayoutEnum (value v);

    PayoutEnum (const char* v);

    PayoutEnum (const ::std::string& v);

    PayoutEnum (const ::xml_schema::token& v);

    PayoutEnum (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    PayoutEnum (const ::xercesc::DOMAttr& a,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    PayoutEnum (const ::std::string& s,
                const ::xercesc::DOMElement* e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    PayoutEnum (const PayoutEnum& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual PayoutEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PayoutEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PayoutEnum_convert ();
    }

    protected:
    value
    _xsd_PayoutEnum_convert () const;

    public:
    static const char* const _xsd_PayoutEnum_literals_[2];
    static const value _xsd_PayoutEnum_indexes_[2];
  };

  class PayRelativeToEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      CalculationPeriodStartDate,
      CalculationPeriodEndDate,
      ResetDate
    };

    PayRelativeToEnum (value v);

    PayRelativeToEnum (const char* v);

    PayRelativeToEnum (const ::std::string& v);

    PayRelativeToEnum (const ::xml_schema::token& v);

    PayRelativeToEnum (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    PayRelativeToEnum (const ::xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    PayRelativeToEnum (const ::std::string& s,
                       const ::xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    PayRelativeToEnum (const PayRelativeToEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual PayRelativeToEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PayRelativeToEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PayRelativeToEnum_convert ();
    }

    protected:
    value
    _xsd_PayRelativeToEnum_convert () const;

    public:
    static const char* const _xsd_PayRelativeToEnum_literals_[3];
    static const value _xsd_PayRelativeToEnum_indexes_[3];
  };

  class PeriodEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      D,
      W,
      M,
      Y,
      T
    };

    PeriodEnum (value v);

    PeriodEnum (const char* v);

    PeriodEnum (const ::std::string& v);

    PeriodEnum (const ::xml_schema::token& v);

    PeriodEnum (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    PeriodEnum (const ::xercesc::DOMAttr& a,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    PeriodEnum (const ::std::string& s,
                const ::xercesc::DOMElement* e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    PeriodEnum (const PeriodEnum& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual PeriodEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PeriodEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PeriodEnum_convert ();
    }

    protected:
    value
    _xsd_PeriodEnum_convert () const;

    public:
    static const char* const _xsd_PeriodEnum_literals_[5];
    static const value _xsd_PeriodEnum_indexes_[5];
  };

  class PremiumQuoteBasisEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      PercentageOfCallCurrencyAmount,
      PercentageOfPutCurrencyAmount,
      CallCurrencyPerPutCurrency,
      PutCurrencyPerCallCurrency,
      Explicit
    };

    PremiumQuoteBasisEnum (value v);

    PremiumQuoteBasisEnum (const char* v);

    PremiumQuoteBasisEnum (const ::std::string& v);

    PremiumQuoteBasisEnum (const ::xml_schema::token& v);

    PremiumQuoteBasisEnum (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    PremiumQuoteBasisEnum (const ::xercesc::DOMAttr& a,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    PremiumQuoteBasisEnum (const ::std::string& s,
                           const ::xercesc::DOMElement* e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    PremiumQuoteBasisEnum (const PremiumQuoteBasisEnum& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual PremiumQuoteBasisEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PremiumQuoteBasisEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PremiumQuoteBasisEnum_convert ();
    }

    protected:
    value
    _xsd_PremiumQuoteBasisEnum_convert () const;

    public:
    static const char* const _xsd_PremiumQuoteBasisEnum_literals_[5];
    static const value _xsd_PremiumQuoteBasisEnum_indexes_[5];
  };

  class PremiumTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      PrePaid,
      PostPaid,
      Variable,
      Fixed
    };

    PremiumTypeEnum (value v);

    PremiumTypeEnum (const char* v);

    PremiumTypeEnum (const ::std::string& v);

    PremiumTypeEnum (const ::xml_schema::token& v);

    PremiumTypeEnum (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    PremiumTypeEnum (const ::xercesc::DOMAttr& a,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    PremiumTypeEnum (const ::std::string& s,
                     const ::xercesc::DOMElement* e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    PremiumTypeEnum (const PremiumTypeEnum& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual PremiumTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PremiumTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PremiumTypeEnum_convert ();
    }

    protected:
    value
    _xsd_PremiumTypeEnum_convert () const;

    public:
    static const char* const _xsd_PremiumTypeEnum_literals_[4];
    static const value _xsd_PremiumTypeEnum_indexes_[4];
  };

  class PriceExpressionEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      AbsoluteTerms,
      PercentageOfNotional
    };

    PriceExpressionEnum (value v);

    PriceExpressionEnum (const char* v);

    PriceExpressionEnum (const ::std::string& v);

    PriceExpressionEnum (const ::xml_schema::token& v);

    PriceExpressionEnum (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    PriceExpressionEnum (const ::xercesc::DOMAttr& a,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    PriceExpressionEnum (const ::std::string& s,
                         const ::xercesc::DOMElement* e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    PriceExpressionEnum (const PriceExpressionEnum& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual PriceExpressionEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    PriceExpressionEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_PriceExpressionEnum_convert ();
    }

    protected:
    value
    _xsd_PriceExpressionEnum_convert () const;

    public:
    static const char* const _xsd_PriceExpressionEnum_literals_[2];
    static const value _xsd_PriceExpressionEnum_indexes_[2];
  };

  class QuotationRateTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Bid,
      Ask,
      Mid,
      ExercisingPartyPays
    };

    QuotationRateTypeEnum (value v);

    QuotationRateTypeEnum (const char* v);

    QuotationRateTypeEnum (const ::std::string& v);

    QuotationRateTypeEnum (const ::xml_schema::token& v);

    QuotationRateTypeEnum (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    QuotationRateTypeEnum (const ::xercesc::DOMAttr& a,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    QuotationRateTypeEnum (const ::std::string& s,
                           const ::xercesc::DOMElement* e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    QuotationRateTypeEnum (const QuotationRateTypeEnum& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual QuotationRateTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    QuotationRateTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_QuotationRateTypeEnum_convert ();
    }

    protected:
    value
    _xsd_QuotationRateTypeEnum_convert () const;

    public:
    static const char* const _xsd_QuotationRateTypeEnum_literals_[4];
    static const value _xsd_QuotationRateTypeEnum_indexes_[4];
  };

  class QuotationSideEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Bid,
      Ask,
      Mid
    };

    QuotationSideEnum (value v);

    QuotationSideEnum (const char* v);

    QuotationSideEnum (const ::std::string& v);

    QuotationSideEnum (const ::xml_schema::token& v);

    QuotationSideEnum (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    QuotationSideEnum (const ::xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    QuotationSideEnum (const ::std::string& s,
                       const ::xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    QuotationSideEnum (const QuotationSideEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual QuotationSideEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    QuotationSideEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_QuotationSideEnum_convert ();
    }

    protected:
    value
    _xsd_QuotationSideEnum_convert () const;

    public:
    static const char* const _xsd_QuotationSideEnum_literals_[3];
    static const value _xsd_QuotationSideEnum_indexes_[3];
  };

  class QuoteBasisEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Currency1PerCurrency2,
      Currency2PerCurrency1
    };

    QuoteBasisEnum (value v);

    QuoteBasisEnum (const char* v);

    QuoteBasisEnum (const ::std::string& v);

    QuoteBasisEnum (const ::xml_schema::token& v);

    QuoteBasisEnum (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    QuoteBasisEnum (const ::xercesc::DOMAttr& a,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    QuoteBasisEnum (const ::std::string& s,
                    const ::xercesc::DOMElement* e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    QuoteBasisEnum (const QuoteBasisEnum& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual QuoteBasisEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    QuoteBasisEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_QuoteBasisEnum_convert ();
    }

    protected:
    value
    _xsd_QuoteBasisEnum_convert () const;

    public:
    static const char* const _xsd_QuoteBasisEnum_literals_[2];
    static const value _xsd_QuoteBasisEnum_indexes_[2];
  };

  class RateTreatmentEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      BondEquivalentYield,
      MoneyMarketYield
    };

    RateTreatmentEnum (value v);

    RateTreatmentEnum (const char* v);

    RateTreatmentEnum (const ::std::string& v);

    RateTreatmentEnum (const ::xml_schema::token& v);

    RateTreatmentEnum (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    RateTreatmentEnum (const ::xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    RateTreatmentEnum (const ::std::string& s,
                       const ::xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    RateTreatmentEnum (const RateTreatmentEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual RateTreatmentEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    RateTreatmentEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_RateTreatmentEnum_convert ();
    }

    protected:
    value
    _xsd_RateTreatmentEnum_convert () const;

    public:
    static const char* const _xsd_RateTreatmentEnum_literals_[2];
    static const value _xsd_RateTreatmentEnum_indexes_[2];
  };

  class ResetRelativeToEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      CalculationPeriodStartDate,
      CalculationPeriodEndDate
    };

    ResetRelativeToEnum (value v);

    ResetRelativeToEnum (const char* v);

    ResetRelativeToEnum (const ::std::string& v);

    ResetRelativeToEnum (const ::xml_schema::token& v);

    ResetRelativeToEnum (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ResetRelativeToEnum (const ::xercesc::DOMAttr& a,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ResetRelativeToEnum (const ::std::string& s,
                         const ::xercesc::DOMElement* e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ResetRelativeToEnum (const ResetRelativeToEnum& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual ResetRelativeToEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ResetRelativeToEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ResetRelativeToEnum_convert ();
    }

    protected:
    value
    _xsd_ResetRelativeToEnum_convert () const;

    public:
    static const char* const _xsd_ResetRelativeToEnum_literals_[2];
    static const value _xsd_ResetRelativeToEnum_indexes_[2];
  };

  class ReturnTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Dividend,
      Price,
      Total
    };

    ReturnTypeEnum (value v);

    ReturnTypeEnum (const char* v);

    ReturnTypeEnum (const ::std::string& v);

    ReturnTypeEnum (const ::xml_schema::token& v);

    ReturnTypeEnum (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ReturnTypeEnum (const ::xercesc::DOMAttr& a,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ReturnTypeEnum (const ::std::string& s,
                    const ::xercesc::DOMElement* e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ReturnTypeEnum (const ReturnTypeEnum& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ReturnTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ReturnTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ReturnTypeEnum_convert ();
    }

    protected:
    value
    _xsd_ReturnTypeEnum_convert () const;

    public:
    static const char* const _xsd_ReturnTypeEnum_literals_[3];
    static const value _xsd_ReturnTypeEnum_indexes_[3];
  };

  class RollConventionEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      EOM,
      FRN,
      IMM,
      IMMCAD,
      IMMAUD,
      IMMNZD,
      SFE,
      NONE,
      TBILL,
      cxx_1,
      cxx_2,
      cxx_3,
      cxx_4,
      cxx_5,
      cxx_6,
      cxx_7,
      cxx_8,
      cxx_9,
      cxx_10,
      cxx_11,
      cxx_12,
      cxx_13,
      cxx_14,
      cxx_15,
      cxx_16,
      cxx_17,
      cxx_18,
      cxx_19,
      cxx_20,
      cxx_21,
      cxx_22,
      cxx_23,
      cxx_24,
      cxx_25,
      cxx_26,
      cxx_27,
      cxx_28,
      cxx_29,
      cxx_30,
      MON,
      TUE,
      WED,
      THU,
      FRI,
      SAT,
      SUN
    };

    RollConventionEnum (value v);

    RollConventionEnum (const char* v);

    RollConventionEnum (const ::std::string& v);

    RollConventionEnum (const ::xml_schema::token& v);

    RollConventionEnum (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    RollConventionEnum (const ::xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    RollConventionEnum (const ::std::string& s,
                        const ::xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    RollConventionEnum (const RollConventionEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual RollConventionEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    RollConventionEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_RollConventionEnum_convert ();
    }

    protected:
    value
    _xsd_RollConventionEnum_convert () const;

    public:
    static const char* const _xsd_RollConventionEnum_literals_[46];
    static const value _xsd_RollConventionEnum_indexes_[46];
  };

  class RoundingDirectionEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Up,
      Down,
      Nearest
    };

    RoundingDirectionEnum (value v);

    RoundingDirectionEnum (const char* v);

    RoundingDirectionEnum (const ::std::string& v);

    RoundingDirectionEnum (const ::xml_schema::token& v);

    RoundingDirectionEnum (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    RoundingDirectionEnum (const ::xercesc::DOMAttr& a,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    RoundingDirectionEnum (const ::std::string& s,
                           const ::xercesc::DOMElement* e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    RoundingDirectionEnum (const RoundingDirectionEnum& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual RoundingDirectionEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    RoundingDirectionEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_RoundingDirectionEnum_convert ();
    }

    protected:
    value
    _xsd_RoundingDirectionEnum_convert () const;

    public:
    static const char* const _xsd_RoundingDirectionEnum_literals_[3];
    static const value _xsd_RoundingDirectionEnum_indexes_[3];
  };

  class SettlementTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Cash,
      Election,
      Physical
    };

    SettlementTypeEnum (value v);

    SettlementTypeEnum (const char* v);

    SettlementTypeEnum (const ::std::string& v);

    SettlementTypeEnum (const ::xml_schema::token& v);

    SettlementTypeEnum (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    SettlementTypeEnum (const ::xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    SettlementTypeEnum (const ::std::string& s,
                        const ::xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    SettlementTypeEnum (const SettlementTypeEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual SettlementTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    SettlementTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_SettlementTypeEnum_convert ();
    }

    protected:
    value
    _xsd_SettlementTypeEnum_convert () const;

    public:
    static const char* const _xsd_SettlementTypeEnum_literals_[3];
    static const value _xsd_SettlementTypeEnum_indexes_[3];
  };

  class ShareExtraordinaryEventEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      AlternativeObligation,
      CancellationAndPayment,
      OptionsExchange,
      CalculationAgent,
      ModifiedCalculationAgent,
      PartialCancellationAndPayment,
      Component
    };

    ShareExtraordinaryEventEnum (value v);

    ShareExtraordinaryEventEnum (const char* v);

    ShareExtraordinaryEventEnum (const ::std::string& v);

    ShareExtraordinaryEventEnum (const ::xml_schema::token& v);

    ShareExtraordinaryEventEnum (const ::xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ShareExtraordinaryEventEnum (const ::xercesc::DOMAttr& a,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ShareExtraordinaryEventEnum (const ::std::string& s,
                                 const ::xercesc::DOMElement* e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ShareExtraordinaryEventEnum (const ShareExtraordinaryEventEnum& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual ShareExtraordinaryEventEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ShareExtraordinaryEventEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ShareExtraordinaryEventEnum_convert ();
    }

    protected:
    value
    _xsd_ShareExtraordinaryEventEnum_convert () const;

    public:
    static const char* const _xsd_ShareExtraordinaryEventEnum_literals_[7];
    static const value _xsd_ShareExtraordinaryEventEnum_indexes_[7];
  };

  class SideRateBasisEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Currency1PerBaseCurrency,
      BaseCurrencyPerCurrency1,
      Currency2PerBaseCurrency,
      BaseCurrencyPerCurrency2
    };

    SideRateBasisEnum (value v);

    SideRateBasisEnum (const char* v);

    SideRateBasisEnum (const ::std::string& v);

    SideRateBasisEnum (const ::xml_schema::token& v);

    SideRateBasisEnum (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    SideRateBasisEnum (const ::xercesc::DOMAttr& a,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    SideRateBasisEnum (const ::std::string& s,
                       const ::xercesc::DOMElement* e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    SideRateBasisEnum (const SideRateBasisEnum& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual SideRateBasisEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    SideRateBasisEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_SideRateBasisEnum_convert ();
    }

    protected:
    value
    _xsd_SideRateBasisEnum_convert () const;

    public:
    static const char* const _xsd_SideRateBasisEnum_literals_[4];
    static const value _xsd_SideRateBasisEnum_indexes_[4];
  };

  class StandardSettlementStyleEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Standard,
      Net,
      StandardAndNet
    };

    StandardSettlementStyleEnum (value v);

    StandardSettlementStyleEnum (const char* v);

    StandardSettlementStyleEnum (const ::std::string& v);

    StandardSettlementStyleEnum (const ::xml_schema::token& v);

    StandardSettlementStyleEnum (const ::xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    StandardSettlementStyleEnum (const ::xercesc::DOMAttr& a,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    StandardSettlementStyleEnum (const ::std::string& s,
                                 const ::xercesc::DOMElement* e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    StandardSettlementStyleEnum (const StandardSettlementStyleEnum& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual StandardSettlementStyleEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    StandardSettlementStyleEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_StandardSettlementStyleEnum_convert ();
    }

    protected:
    value
    _xsd_StandardSettlementStyleEnum_convert () const;

    public:
    static const char* const _xsd_StandardSettlementStyleEnum_literals_[3];
    static const value _xsd_StandardSettlementStyleEnum_indexes_[3];
  };

  class StepRelativeToEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Initial,
      Previous
    };

    StepRelativeToEnum (value v);

    StepRelativeToEnum (const char* v);

    StepRelativeToEnum (const ::std::string& v);

    StepRelativeToEnum (const ::xml_schema::token& v);

    StepRelativeToEnum (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    StepRelativeToEnum (const ::xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    StepRelativeToEnum (const ::std::string& s,
                        const ::xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    StepRelativeToEnum (const StepRelativeToEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual StepRelativeToEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    StepRelativeToEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_StepRelativeToEnum_convert ();
    }

    protected:
    value
    _xsd_StepRelativeToEnum_convert () const;

    public:
    static const char* const _xsd_StepRelativeToEnum_literals_[2];
    static const value _xsd_StepRelativeToEnum_indexes_[2];
  };

  class StubPeriodTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      ShortInitial,
      ShortFinal,
      LongInitial,
      LongFinal
    };

    StubPeriodTypeEnum (value v);

    StubPeriodTypeEnum (const char* v);

    StubPeriodTypeEnum (const ::std::string& v);

    StubPeriodTypeEnum (const ::xml_schema::token& v);

    StubPeriodTypeEnum (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    StubPeriodTypeEnum (const ::xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    StubPeriodTypeEnum (const ::std::string& s,
                        const ::xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    StubPeriodTypeEnum (const StubPeriodTypeEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual StubPeriodTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    StubPeriodTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_StubPeriodTypeEnum_convert ();
    }

    protected:
    value
    _xsd_StubPeriodTypeEnum_convert () const;

    public:
    static const char* const _xsd_StubPeriodTypeEnum_literals_[4];
    static const value _xsd_StubPeriodTypeEnum_indexes_[4];
  };

  class StrikeQuoteBasisEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      PutCurrencyPerCallCurrency,
      CallCurrencyPerPutCurrency
    };

    StrikeQuoteBasisEnum (value v);

    StrikeQuoteBasisEnum (const char* v);

    StrikeQuoteBasisEnum (const ::std::string& v);

    StrikeQuoteBasisEnum (const ::xml_schema::token& v);

    StrikeQuoteBasisEnum (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    StrikeQuoteBasisEnum (const ::xercesc::DOMAttr& a,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    StrikeQuoteBasisEnum (const ::std::string& s,
                          const ::xercesc::DOMElement* e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    StrikeQuoteBasisEnum (const StrikeQuoteBasisEnum& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual StrikeQuoteBasisEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    StrikeQuoteBasisEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_StrikeQuoteBasisEnum_convert ();
    }

    protected:
    value
    _xsd_StrikeQuoteBasisEnum_convert () const;

    public:
    static const char* const _xsd_StrikeQuoteBasisEnum_literals_[2];
    static const value _xsd_StrikeQuoteBasisEnum_indexes_[2];
  };

  class TimeTypeEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Close,
      Open,
      OSP,
      SpecificTime,
      XETRA,
      DerivativesClose,
      AsSpecifiedInMasterConfirmation
    };

    TimeTypeEnum (value v);

    TimeTypeEnum (const char* v);

    TimeTypeEnum (const ::std::string& v);

    TimeTypeEnum (const ::xml_schema::token& v);

    TimeTypeEnum (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    TimeTypeEnum (const ::xercesc::DOMAttr& a,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    TimeTypeEnum (const ::std::string& s,
                  const ::xercesc::DOMElement* e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    TimeTypeEnum (const TimeTypeEnum& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual TimeTypeEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TimeTypeEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TimeTypeEnum_convert ();
    }

    protected:
    value
    _xsd_TimeTypeEnum_convert () const;

    public:
    static const char* const _xsd_TimeTypeEnum_literals_[7];
    static const value _xsd_TimeTypeEnum_indexes_[7];
  };

  class TouchConditionEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Touch,
      Notouch
    };

    TouchConditionEnum (value v);

    TouchConditionEnum (const char* v);

    TouchConditionEnum (const ::std::string& v);

    TouchConditionEnum (const ::xml_schema::token& v);

    TouchConditionEnum (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TouchConditionEnum (const ::xercesc::DOMAttr& a,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TouchConditionEnum (const ::std::string& s,
                        const ::xercesc::DOMElement* e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TouchConditionEnum (const TouchConditionEnum& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual TouchConditionEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TouchConditionEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TouchConditionEnum_convert ();
    }

    protected:
    value
    _xsd_TouchConditionEnum_convert () const;

    public:
    static const char* const _xsd_TouchConditionEnum_literals_[2];
    static const value _xsd_TouchConditionEnum_indexes_[2];
  };

  class TriggerConditionEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Above,
      Below
    };

    TriggerConditionEnum (value v);

    TriggerConditionEnum (const char* v);

    TriggerConditionEnum (const ::std::string& v);

    TriggerConditionEnum (const ::xml_schema::token& v);

    TriggerConditionEnum (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    TriggerConditionEnum (const ::xercesc::DOMAttr& a,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    TriggerConditionEnum (const ::std::string& s,
                          const ::xercesc::DOMElement* e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    TriggerConditionEnum (const TriggerConditionEnum& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual TriggerConditionEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    TriggerConditionEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_TriggerConditionEnum_convert ();
    }

    protected:
    value
    _xsd_TriggerConditionEnum_convert () const;

    public:
    static const char* const _xsd_TriggerConditionEnum_literals_[2];
    static const value _xsd_TriggerConditionEnum_indexes_[2];
  };

  class ValuationMethodEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      Market,
      Highest,
      AverageMarket,
      AverageHighest,
      BlendedMarket,
      BlendedHighest,
      AverageBlendedMarket,
      AverageBlendedHighest
    };

    ValuationMethodEnum (value v);

    ValuationMethodEnum (const char* v);

    ValuationMethodEnum (const ::std::string& v);

    ValuationMethodEnum (const ::xml_schema::token& v);

    ValuationMethodEnum (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ValuationMethodEnum (const ::xercesc::DOMAttr& a,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ValuationMethodEnum (const ::std::string& s,
                         const ::xercesc::DOMElement* e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ValuationMethodEnum (const ValuationMethodEnum& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual ValuationMethodEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    ValuationMethodEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_ValuationMethodEnum_convert ();
    }

    protected:
    value
    _xsd_ValuationMethodEnum_convert () const;

    public:
    static const char* const _xsd_ValuationMethodEnum_literals_[8];
    static const value _xsd_ValuationMethodEnum_indexes_[8];
  };

  class WeeklyRollConventionEnum: public ::xml_schema::token
  {
    public:
    enum value
    {
      MON,
      TUE,
      WED,
      THU,
      FRI,
      SAT,
      SUN
    };

    WeeklyRollConventionEnum (value v);

    WeeklyRollConventionEnum (const char* v);

    WeeklyRollConventionEnum (const ::std::string& v);

    WeeklyRollConventionEnum (const ::xml_schema::token& v);

    WeeklyRollConventionEnum (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    WeeklyRollConventionEnum (const ::xercesc::DOMAttr& a,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    WeeklyRollConventionEnum (const ::std::string& s,
                              const ::xercesc::DOMElement* e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    WeeklyRollConventionEnum (const WeeklyRollConventionEnum& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual WeeklyRollConventionEnum*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    WeeklyRollConventionEnum&
    operator= (value v);

    virtual
    operator value () const
    {
      return _xsd_WeeklyRollConventionEnum_convert ();
    }

    protected:
    value
    _xsd_WeeklyRollConventionEnum_convert () const;

    public:
    static const char* const _xsd_WeeklyRollConventionEnum_literals_[7];
    static const value _xsd_WeeklyRollConventionEnum_indexes_[7];
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const AveragingInOutEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const AveragingInOutEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const AveragingInOutEnum&);

  void
  operator<< (::xercesc::DOMElement&, const AveragingMethodEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const AveragingMethodEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const AveragingMethodEnum&);

  void
  operator<< (::xercesc::DOMElement&, const BusinessDayConventionEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const BusinessDayConventionEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const BusinessDayConventionEnum&);

  void
  operator<< (::xercesc::DOMElement&, const CalculationAgentPartyEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const CalculationAgentPartyEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const CalculationAgentPartyEnum&);

  void
  operator<< (::xercesc::DOMElement&, const CommissionDenominationEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const CommissionDenominationEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const CommissionDenominationEnum&);

  void
  operator<< (::xercesc::DOMElement&, const CompoundingMethodEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const CompoundingMethodEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const CompoundingMethodEnum&);

  void
  operator<< (::xercesc::DOMElement&, const DayTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const DayTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const DayTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const DifferenceSeverityEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const DifferenceSeverityEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const DifferenceSeverityEnum&);

  void
  operator<< (::xercesc::DOMElement&, const DifferenceTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const DifferenceTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const DifferenceTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const DiscountingTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const DiscountingTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const DiscountingTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const DividendAmountTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const DividendAmountTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const DividendAmountTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const DividendDateReferenceEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const DividendDateReferenceEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const DividendDateReferenceEnum&);

  void
  operator<< (::xercesc::DOMElement&, const DividendEntitlementEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const DividendEntitlementEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const DividendEntitlementEnum&);

  void
  operator<< (::xercesc::DOMElement&, const DividendPeriodEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const DividendPeriodEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const DividendPeriodEnum&);

  void
  operator<< (::xercesc::DOMElement&, const ExerciseStyleEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const ExerciseStyleEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const ExerciseStyleEnum&);

  void
  operator<< (::xercesc::DOMElement&, const FraDiscountingEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const FraDiscountingEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const FraDiscountingEnum&);

  void
  operator<< (::xercesc::DOMElement&, const FrequencyTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const FrequencyTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const FrequencyTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const FxBarrierTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const FxBarrierTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const FxBarrierTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const IndexEventConsequenceEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const IndexEventConsequenceEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const IndexEventConsequenceEnum&);

  void
  operator<< (::xercesc::DOMElement&, const LengthUnitEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const LengthUnitEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const LengthUnitEnum&);

  void
  operator<< (::xercesc::DOMElement&, const MethodOfAdjustmentEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const MethodOfAdjustmentEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const MethodOfAdjustmentEnum&);

  void
  operator<< (::xercesc::DOMElement&, const NationalisationOrInsolvencyOrDelistingEventEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const NationalisationOrInsolvencyOrDelistingEventEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const NationalisationOrInsolvencyOrDelistingEventEnum&);

  void
  operator<< (::xercesc::DOMElement&, const NegativeInterestRateTreatmentEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const NegativeInterestRateTreatmentEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const NegativeInterestRateTreatmentEnum&);

  void
  operator<< (::xercesc::DOMElement&, const NotionalAdjustmentEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const NotionalAdjustmentEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const NotionalAdjustmentEnum&);

  void
  operator<< (::xercesc::DOMElement&, const ObligationCategoryEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const ObligationCategoryEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const ObligationCategoryEnum&);

  void
  operator<< (::xercesc::DOMElement&, const OptionTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const OptionTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const OptionTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const PayerReceiverEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const PayerReceiverEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const PayerReceiverEnum&);

  void
  operator<< (::xercesc::DOMElement&, const PayoutEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const PayoutEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const PayoutEnum&);

  void
  operator<< (::xercesc::DOMElement&, const PayRelativeToEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const PayRelativeToEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const PayRelativeToEnum&);

  void
  operator<< (::xercesc::DOMElement&, const PeriodEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const PeriodEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const PeriodEnum&);

  void
  operator<< (::xercesc::DOMElement&, const PremiumQuoteBasisEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const PremiumQuoteBasisEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const PremiumQuoteBasisEnum&);

  void
  operator<< (::xercesc::DOMElement&, const PremiumTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const PremiumTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const PremiumTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const PriceExpressionEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const PriceExpressionEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const PriceExpressionEnum&);

  void
  operator<< (::xercesc::DOMElement&, const QuotationRateTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const QuotationRateTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const QuotationRateTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const QuotationSideEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const QuotationSideEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const QuotationSideEnum&);

  void
  operator<< (::xercesc::DOMElement&, const QuoteBasisEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const QuoteBasisEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const QuoteBasisEnum&);

  void
  operator<< (::xercesc::DOMElement&, const RateTreatmentEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const RateTreatmentEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const RateTreatmentEnum&);

  void
  operator<< (::xercesc::DOMElement&, const ResetRelativeToEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const ResetRelativeToEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const ResetRelativeToEnum&);

  void
  operator<< (::xercesc::DOMElement&, const ReturnTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const ReturnTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const ReturnTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const RollConventionEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const RollConventionEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const RollConventionEnum&);

  void
  operator<< (::xercesc::DOMElement&, const RoundingDirectionEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const RoundingDirectionEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const RoundingDirectionEnum&);

  void
  operator<< (::xercesc::DOMElement&, const SettlementTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const SettlementTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const SettlementTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const ShareExtraordinaryEventEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const ShareExtraordinaryEventEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const ShareExtraordinaryEventEnum&);

  void
  operator<< (::xercesc::DOMElement&, const SideRateBasisEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const SideRateBasisEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const SideRateBasisEnum&);

  void
  operator<< (::xercesc::DOMElement&, const StandardSettlementStyleEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const StandardSettlementStyleEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const StandardSettlementStyleEnum&);

  void
  operator<< (::xercesc::DOMElement&, const StepRelativeToEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const StepRelativeToEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const StepRelativeToEnum&);

  void
  operator<< (::xercesc::DOMElement&, const StubPeriodTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const StubPeriodTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const StubPeriodTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const StrikeQuoteBasisEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const StrikeQuoteBasisEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const StrikeQuoteBasisEnum&);

  void
  operator<< (::xercesc::DOMElement&, const TimeTypeEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const TimeTypeEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const TimeTypeEnum&);

  void
  operator<< (::xercesc::DOMElement&, const TouchConditionEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const TouchConditionEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const TouchConditionEnum&);

  void
  operator<< (::xercesc::DOMElement&, const TriggerConditionEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const TriggerConditionEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const TriggerConditionEnum&);

  void
  operator<< (::xercesc::DOMElement&, const ValuationMethodEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const ValuationMethodEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const ValuationMethodEnum&);

  void
  operator<< (::xercesc::DOMElement&, const WeeklyRollConventionEnum&);

  void
  operator<< (::xercesc::DOMAttr&, const WeeklyRollConventionEnum&);

  void
  operator<< (::xml_schema::list_stream&,
              const WeeklyRollConventionEnum&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_ENUM_4_2_HXX
