// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_EQ_SHARED_4_2_HXX
#define FPML_EQ_SHARED_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class AdditionalDisruptionEvents;
  class AdditionalPaymentAmount;
  class AdjustableDateOrRelativeDateSequence;
  class Asian;
  class AveragingPeriod;
  class Barrier;
  class Composite;
  class Compounding;
  class CompoundingRate;
  class EquityCorporateEvents;
  class EquityPremium;
  class EquitySchedule;
  class EquityStrike;
  class EquityValuation;
  class ExtraordinaryEvents;
  class FeaturePayment;
  class FxFeature;
  class IndexAdjustmentEvents;
  class InterestCalculation;
  class InterestCalculationReference;
  class ReturnSwapLeg;
  class InterestLeg;
  class InterestLegCalculationPeriodDates;
  class InterestLegCalculationPeriodDatesReference;
  class InterestLegResetDates;
  class Knock;
  class LegAmount;
  class MakeWholeProvisions;
  class MarketDisruption;
  class OptionFeatures;
  class PassThrough;
  class PassThroughItem;
  class PrincipalExchangeAmount;
  class PrincipalExchangeDescriptions;
  class PrincipalExchangeFeatures;
  class Quanto;
  class Representations;
  class Return;
  class ReturnLeg;
  class ReturnLegValuation;
  class ReturnLegValuationPrice;
  class ReturnSwapBase;
  class ReturnSwap;
  class ReturnSwapAdditionalPayment;
  class ReturnSwapAmount;
  class ReturnSwapEarlyTermination;
  class ReturnSwapNotional;
  class ReturnSwapPaymentDates;
  class StartingDate;
  class StubCalculationPeriod;
  class Trigger;
  class TriggerEvent;
  class Variance;
  class VarianceAmount;
  class VarianceLeg;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-asset-4-2.hxx"

namespace FpML_4_2
{
  class AdditionalDisruptionEvents: public ::xml_schema::type
  {
    public:
    // changeInLaw
    // 
    typedef ::xml_schema::boolean changeInLaw_type;
    typedef ::xsd::cxx::tree::traits< changeInLaw_type, char > changeInLaw_traits;

    const changeInLaw_type&
    changeInLaw () const;

    changeInLaw_type&
    changeInLaw ();

    void
    changeInLaw (const changeInLaw_type& x);

    // failureToDeliver
    // 
    typedef ::xml_schema::boolean failureToDeliver_type;
    typedef ::xsd::cxx::tree::optional< failureToDeliver_type > failureToDeliver_optional;
    typedef ::xsd::cxx::tree::traits< failureToDeliver_type, char > failureToDeliver_traits;

    const failureToDeliver_optional&
    failureToDeliver () const;

    failureToDeliver_optional&
    failureToDeliver ();

    void
    failureToDeliver (const failureToDeliver_type& x);

    void
    failureToDeliver (const failureToDeliver_optional& x);

    // insolvencyFiling
    // 
    typedef ::xml_schema::boolean insolvencyFiling_type;
    typedef ::xsd::cxx::tree::traits< insolvencyFiling_type, char > insolvencyFiling_traits;

    const insolvencyFiling_type&
    insolvencyFiling () const;

    insolvencyFiling_type&
    insolvencyFiling ();

    void
    insolvencyFiling (const insolvencyFiling_type& x);

    // hedgingDisruption
    // 
    typedef ::xml_schema::boolean hedgingDisruption_type;
    typedef ::xsd::cxx::tree::traits< hedgingDisruption_type, char > hedgingDisruption_traits;

    const hedgingDisruption_type&
    hedgingDisruption () const;

    hedgingDisruption_type&
    hedgingDisruption ();

    void
    hedgingDisruption (const hedgingDisruption_type& x);

    // lossOfStockBorrow
    // 
    typedef ::xml_schema::boolean lossOfStockBorrow_type;
    typedef ::xsd::cxx::tree::traits< lossOfStockBorrow_type, char > lossOfStockBorrow_traits;

    const lossOfStockBorrow_type&
    lossOfStockBorrow () const;

    lossOfStockBorrow_type&
    lossOfStockBorrow ();

    void
    lossOfStockBorrow (const lossOfStockBorrow_type& x);

    // increasedCostOfStockBorrow
    // 
    typedef ::xml_schema::boolean increasedCostOfStockBorrow_type;
    typedef ::xsd::cxx::tree::traits< increasedCostOfStockBorrow_type, char > increasedCostOfStockBorrow_traits;

    const increasedCostOfStockBorrow_type&
    increasedCostOfStockBorrow () const;

    increasedCostOfStockBorrow_type&
    increasedCostOfStockBorrow ();

    void
    increasedCostOfStockBorrow (const increasedCostOfStockBorrow_type& x);

    // increasedCostOfHedging
    // 
    typedef ::xml_schema::boolean increasedCostOfHedging_type;
    typedef ::xsd::cxx::tree::traits< increasedCostOfHedging_type, char > increasedCostOfHedging_traits;

    const increasedCostOfHedging_type&
    increasedCostOfHedging () const;

    increasedCostOfHedging_type&
    increasedCostOfHedging ();

    void
    increasedCostOfHedging (const increasedCostOfHedging_type& x);

    // determiningPartyReference
    // 
    typedef ::FpML_4_2::PartyReference determiningPartyReference_type;
    typedef ::xsd::cxx::tree::traits< determiningPartyReference_type, char > determiningPartyReference_traits;

    const determiningPartyReference_type&
    determiningPartyReference () const;

    determiningPartyReference_type&
    determiningPartyReference ();

    void
    determiningPartyReference (const determiningPartyReference_type& x);

    void
    determiningPartyReference (::std::auto_ptr< determiningPartyReference_type > p);

    // Constructors.
    //
    AdditionalDisruptionEvents (const changeInLaw_type&,
                                const insolvencyFiling_type&,
                                const hedgingDisruption_type&,
                                const lossOfStockBorrow_type&,
                                const increasedCostOfStockBorrow_type&,
                                const increasedCostOfHedging_type&,
                                const determiningPartyReference_type&);

    AdditionalDisruptionEvents (const changeInLaw_type&,
                                const insolvencyFiling_type&,
                                const hedgingDisruption_type&,
                                const lossOfStockBorrow_type&,
                                const increasedCostOfStockBorrow_type&,
                                const increasedCostOfHedging_type&,
                                ::std::auto_ptr< determiningPartyReference_type >&);

    AdditionalDisruptionEvents (const ::xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    AdditionalDisruptionEvents (const AdditionalDisruptionEvents& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual AdditionalDisruptionEvents*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdditionalDisruptionEvents ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< changeInLaw_type > changeInLaw_;
    failureToDeliver_optional failureToDeliver_;
    ::xsd::cxx::tree::one< insolvencyFiling_type > insolvencyFiling_;
    ::xsd::cxx::tree::one< hedgingDisruption_type > hedgingDisruption_;
    ::xsd::cxx::tree::one< lossOfStockBorrow_type > lossOfStockBorrow_;
    ::xsd::cxx::tree::one< increasedCostOfStockBorrow_type > increasedCostOfStockBorrow_;
    ::xsd::cxx::tree::one< increasedCostOfHedging_type > increasedCostOfHedging_;
    ::xsd::cxx::tree::one< determiningPartyReference_type > determiningPartyReference_;
  };

  class AdditionalPaymentAmount: public ::xml_schema::type
  {
    public:
    // paymentAmount
    // 
    typedef ::FpML_4_2::Money paymentAmount_type;
    typedef ::xsd::cxx::tree::optional< paymentAmount_type > paymentAmount_optional;
    typedef ::xsd::cxx::tree::traits< paymentAmount_type, char > paymentAmount_traits;

    const paymentAmount_optional&
    paymentAmount () const;

    paymentAmount_optional&
    paymentAmount ();

    void
    paymentAmount (const paymentAmount_type& x);

    void
    paymentAmount (const paymentAmount_optional& x);

    void
    paymentAmount (::std::auto_ptr< paymentAmount_type > p);

    // formula
    // 
    typedef ::FpML_4_2::Formula formula_type;
    typedef ::xsd::cxx::tree::optional< formula_type > formula_optional;
    typedef ::xsd::cxx::tree::traits< formula_type, char > formula_traits;

    const formula_optional&
    formula () const;

    formula_optional&
    formula ();

    void
    formula (const formula_type& x);

    void
    formula (const formula_optional& x);

    void
    formula (::std::auto_ptr< formula_type > p);

    // Constructors.
    //
    AdditionalPaymentAmount ();

    AdditionalPaymentAmount (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    AdditionalPaymentAmount (const AdditionalPaymentAmount& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual AdditionalPaymentAmount*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdditionalPaymentAmount ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    paymentAmount_optional paymentAmount_;
    formula_optional formula_;
  };

  class AdjustableDateOrRelativeDateSequence: public ::xml_schema::type
  {
    public:
    // adjustableDate
    // 
    typedef ::FpML_4_2::AdjustableDate adjustableDate_type;
    typedef ::xsd::cxx::tree::optional< adjustableDate_type > adjustableDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustableDate_type, char > adjustableDate_traits;

    const adjustableDate_optional&
    adjustableDate () const;

    adjustableDate_optional&
    adjustableDate ();

    void
    adjustableDate (const adjustableDate_type& x);

    void
    adjustableDate (const adjustableDate_optional& x);

    void
    adjustableDate (::std::auto_ptr< adjustableDate_type > p);

    // relativeDateSequence
    // 
    typedef ::FpML_4_2::RelativeDateSequence relativeDateSequence_type;
    typedef ::xsd::cxx::tree::optional< relativeDateSequence_type > relativeDateSequence_optional;
    typedef ::xsd::cxx::tree::traits< relativeDateSequence_type, char > relativeDateSequence_traits;

    const relativeDateSequence_optional&
    relativeDateSequence () const;

    relativeDateSequence_optional&
    relativeDateSequence ();

    void
    relativeDateSequence (const relativeDateSequence_type& x);

    void
    relativeDateSequence (const relativeDateSequence_optional& x);

    void
    relativeDateSequence (::std::auto_ptr< relativeDateSequence_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    AdjustableDateOrRelativeDateSequence ();

    AdjustableDateOrRelativeDateSequence (const ::xercesc::DOMElement& e,
                                          ::xml_schema::flags f = 0,
                                          ::xml_schema::container* c = 0);

    AdjustableDateOrRelativeDateSequence (const AdjustableDateOrRelativeDateSequence& x,
                                          ::xml_schema::flags f = 0,
                                          ::xml_schema::container* c = 0);

    virtual AdjustableDateOrRelativeDateSequence*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdjustableDateOrRelativeDateSequence ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    adjustableDate_optional adjustableDate_;
    relativeDateSequence_optional relativeDateSequence_;
    id_optional id_;
  };

  class Asian: public ::xml_schema::type
  {
    public:
    // averagingInOut
    // 
    typedef ::FpML_4_2::AveragingInOutEnum averagingInOut_type;
    typedef ::xsd::cxx::tree::traits< averagingInOut_type, char > averagingInOut_traits;

    const averagingInOut_type&
    averagingInOut () const;

    averagingInOut_type&
    averagingInOut ();

    void
    averagingInOut (const averagingInOut_type& x);

    void
    averagingInOut (::std::auto_ptr< averagingInOut_type > p);

    // strikeFactor
    // 
    typedef ::xml_schema::decimal strikeFactor_type;
    typedef ::xsd::cxx::tree::optional< strikeFactor_type > strikeFactor_optional;
    typedef ::xsd::cxx::tree::traits< strikeFactor_type, char, ::xsd::cxx::tree::schema_type::decimal > strikeFactor_traits;

    const strikeFactor_optional&
    strikeFactor () const;

    strikeFactor_optional&
    strikeFactor ();

    void
    strikeFactor (const strikeFactor_type& x);

    void
    strikeFactor (const strikeFactor_optional& x);

    // averagingPeriodIn
    // 
    typedef ::FpML_4_2::AveragingPeriod averagingPeriodIn_type;
    typedef ::xsd::cxx::tree::optional< averagingPeriodIn_type > averagingPeriodIn_optional;
    typedef ::xsd::cxx::tree::traits< averagingPeriodIn_type, char > averagingPeriodIn_traits;

    const averagingPeriodIn_optional&
    averagingPeriodIn () const;

    averagingPeriodIn_optional&
    averagingPeriodIn ();

    void
    averagingPeriodIn (const averagingPeriodIn_type& x);

    void
    averagingPeriodIn (const averagingPeriodIn_optional& x);

    void
    averagingPeriodIn (::std::auto_ptr< averagingPeriodIn_type > p);

    // averagingPeriodOut
    // 
    typedef ::FpML_4_2::AveragingPeriod averagingPeriodOut_type;
    typedef ::xsd::cxx::tree::optional< averagingPeriodOut_type > averagingPeriodOut_optional;
    typedef ::xsd::cxx::tree::traits< averagingPeriodOut_type, char > averagingPeriodOut_traits;

    const averagingPeriodOut_optional&
    averagingPeriodOut () const;

    averagingPeriodOut_optional&
    averagingPeriodOut ();

    void
    averagingPeriodOut (const averagingPeriodOut_type& x);

    void
    averagingPeriodOut (const averagingPeriodOut_optional& x);

    void
    averagingPeriodOut (::std::auto_ptr< averagingPeriodOut_type > p);

    // Constructors.
    //
    Asian (const averagingInOut_type&);

    Asian (const ::xercesc::DOMElement& e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Asian (const Asian& x,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    virtual Asian*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Asian ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< averagingInOut_type > averagingInOut_;
    strikeFactor_optional strikeFactor_;
    averagingPeriodIn_optional averagingPeriodIn_;
    averagingPeriodOut_optional averagingPeriodOut_;
  };

  class AveragingPeriod: public ::xml_schema::type
  {
    public:
    // schedule
    // 
    typedef ::FpML_4_2::EquitySchedule schedule_type;
    typedef ::xsd::cxx::tree::sequence< schedule_type > schedule_sequence;
    typedef schedule_sequence::iterator schedule_iterator;
    typedef schedule_sequence::const_iterator schedule_const_iterator;
    typedef ::xsd::cxx::tree::traits< schedule_type, char > schedule_traits;

    const schedule_sequence&
    schedule () const;

    schedule_sequence&
    schedule ();

    void
    schedule (const schedule_sequence& s);

    // averagingDateTimes
    // 
    typedef ::FpML_4_2::DateTimeList averagingDateTimes_type;
    typedef ::xsd::cxx::tree::optional< averagingDateTimes_type > averagingDateTimes_optional;
    typedef ::xsd::cxx::tree::traits< averagingDateTimes_type, char > averagingDateTimes_traits;

    const averagingDateTimes_optional&
    averagingDateTimes () const;

    averagingDateTimes_optional&
    averagingDateTimes ();

    void
    averagingDateTimes (const averagingDateTimes_type& x);

    void
    averagingDateTimes (const averagingDateTimes_optional& x);

    void
    averagingDateTimes (::std::auto_ptr< averagingDateTimes_type > p);

    // marketDisruption
    // 
    typedef ::FpML_4_2::MarketDisruption marketDisruption_type;
    typedef ::xsd::cxx::tree::traits< marketDisruption_type, char > marketDisruption_traits;

    const marketDisruption_type&
    marketDisruption () const;

    marketDisruption_type&
    marketDisruption ();

    void
    marketDisruption (const marketDisruption_type& x);

    void
    marketDisruption (::std::auto_ptr< marketDisruption_type > p);

    // Constructors.
    //
    AveragingPeriod (const marketDisruption_type&);

    AveragingPeriod (::std::auto_ptr< marketDisruption_type >&);

    AveragingPeriod (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    AveragingPeriod (const AveragingPeriod& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual AveragingPeriod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AveragingPeriod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    schedule_sequence schedule_;
    averagingDateTimes_optional averagingDateTimes_;
    ::xsd::cxx::tree::one< marketDisruption_type > marketDisruption_;
  };

  class Barrier: public ::xml_schema::type
  {
    public:
    // barrierCap
    // 
    typedef ::FpML_4_2::TriggerEvent barrierCap_type;
    typedef ::xsd::cxx::tree::optional< barrierCap_type > barrierCap_optional;
    typedef ::xsd::cxx::tree::traits< barrierCap_type, char > barrierCap_traits;

    const barrierCap_optional&
    barrierCap () const;

    barrierCap_optional&
    barrierCap ();

    void
    barrierCap (const barrierCap_type& x);

    void
    barrierCap (const barrierCap_optional& x);

    void
    barrierCap (::std::auto_ptr< barrierCap_type > p);

    // barrierFloor
    // 
    typedef ::FpML_4_2::TriggerEvent barrierFloor_type;
    typedef ::xsd::cxx::tree::optional< barrierFloor_type > barrierFloor_optional;
    typedef ::xsd::cxx::tree::traits< barrierFloor_type, char > barrierFloor_traits;

    const barrierFloor_optional&
    barrierFloor () const;

    barrierFloor_optional&
    barrierFloor ();

    void
    barrierFloor (const barrierFloor_type& x);

    void
    barrierFloor (const barrierFloor_optional& x);

    void
    barrierFloor (::std::auto_ptr< barrierFloor_type > p);

    // Constructors.
    //
    Barrier ();

    Barrier (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Barrier (const Barrier& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Barrier*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Barrier ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    barrierCap_optional barrierCap_;
    barrierFloor_optional barrierFloor_;
  };

  class Composite: public ::xml_schema::type
  {
    public:
    // determinationMethod
    // 
    typedef ::FpML_4_2::DeterminationMethod determinationMethod_type;
    typedef ::xsd::cxx::tree::optional< determinationMethod_type > determinationMethod_optional;
    typedef ::xsd::cxx::tree::traits< determinationMethod_type, char > determinationMethod_traits;

    const determinationMethod_optional&
    determinationMethod () const;

    determinationMethod_optional&
    determinationMethod ();

    void
    determinationMethod (const determinationMethod_type& x);

    void
    determinationMethod (const determinationMethod_optional& x);

    void
    determinationMethod (::std::auto_ptr< determinationMethod_type > p);

    // relativeDate
    // 
    typedef ::FpML_4_2::RelativeDateOffset relativeDate_type;
    typedef ::xsd::cxx::tree::optional< relativeDate_type > relativeDate_optional;
    typedef ::xsd::cxx::tree::traits< relativeDate_type, char > relativeDate_traits;

    const relativeDate_optional&
    relativeDate () const;

    relativeDate_optional&
    relativeDate ();

    void
    relativeDate (const relativeDate_type& x);

    void
    relativeDate (const relativeDate_optional& x);

    void
    relativeDate (::std::auto_ptr< relativeDate_type > p);

    // fxSpotRateSource
    // 
    typedef ::FpML_4_2::FxSpotRateSource fxSpotRateSource_type;
    typedef ::xsd::cxx::tree::optional< fxSpotRateSource_type > fxSpotRateSource_optional;
    typedef ::xsd::cxx::tree::traits< fxSpotRateSource_type, char > fxSpotRateSource_traits;

    const fxSpotRateSource_optional&
    fxSpotRateSource () const;

    fxSpotRateSource_optional&
    fxSpotRateSource ();

    void
    fxSpotRateSource (const fxSpotRateSource_type& x);

    void
    fxSpotRateSource (const fxSpotRateSource_optional& x);

    void
    fxSpotRateSource (::std::auto_ptr< fxSpotRateSource_type > p);

    // Constructors.
    //
    Composite ();

    Composite (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Composite (const Composite& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual Composite*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Composite ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    determinationMethod_optional determinationMethod_;
    relativeDate_optional relativeDate_;
    fxSpotRateSource_optional fxSpotRateSource_;
  };

  class Compounding: public ::xml_schema::type
  {
    public:
    // compoundingMethod
    // 
    typedef ::FpML_4_2::CompoundingMethodEnum compoundingMethod_type;
    typedef ::xsd::cxx::tree::traits< compoundingMethod_type, char > compoundingMethod_traits;

    const compoundingMethod_type&
    compoundingMethod () const;

    compoundingMethod_type&
    compoundingMethod ();

    void
    compoundingMethod (const compoundingMethod_type& x);

    void
    compoundingMethod (::std::auto_ptr< compoundingMethod_type > p);

    // compoundingRate
    // 
    typedef ::FpML_4_2::CompoundingRate compoundingRate_type;
    typedef ::xsd::cxx::tree::traits< compoundingRate_type, char > compoundingRate_traits;

    const compoundingRate_type&
    compoundingRate () const;

    compoundingRate_type&
    compoundingRate ();

    void
    compoundingRate (const compoundingRate_type& x);

    void
    compoundingRate (::std::auto_ptr< compoundingRate_type > p);

    // Constructors.
    //
    Compounding (const compoundingMethod_type&,
                 const compoundingRate_type&);

    Compounding (const compoundingMethod_type&,
                 ::std::auto_ptr< compoundingRate_type >&);

    Compounding (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    Compounding (const Compounding& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual Compounding*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Compounding ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< compoundingMethod_type > compoundingMethod_;
    ::xsd::cxx::tree::one< compoundingRate_type > compoundingRate_;
  };

  class CompoundingRate: public ::xml_schema::type
  {
    public:
    // interestLegRate
    // 
    typedef ::FpML_4_2::InterestCalculationReference interestLegRate_type;
    typedef ::xsd::cxx::tree::optional< interestLegRate_type > interestLegRate_optional;
    typedef ::xsd::cxx::tree::traits< interestLegRate_type, char > interestLegRate_traits;

    const interestLegRate_optional&
    interestLegRate () const;

    interestLegRate_optional&
    interestLegRate ();

    void
    interestLegRate (const interestLegRate_type& x);

    void
    interestLegRate (const interestLegRate_optional& x);

    void
    interestLegRate (::std::auto_ptr< interestLegRate_type > p);

    // specificRate
    // 
    typedef ::FpML_4_2::InterestAccrualsMethod specificRate_type;
    typedef ::xsd::cxx::tree::optional< specificRate_type > specificRate_optional;
    typedef ::xsd::cxx::tree::traits< specificRate_type, char > specificRate_traits;

    const specificRate_optional&
    specificRate () const;

    specificRate_optional&
    specificRate ();

    void
    specificRate (const specificRate_type& x);

    void
    specificRate (const specificRate_optional& x);

    void
    specificRate (::std::auto_ptr< specificRate_type > p);

    // Constructors.
    //
    CompoundingRate ();

    CompoundingRate (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    CompoundingRate (const CompoundingRate& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual CompoundingRate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CompoundingRate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    interestLegRate_optional interestLegRate_;
    specificRate_optional specificRate_;
  };

  class EquityCorporateEvents: public ::xml_schema::type
  {
    public:
    // shareForShare
    // 
    typedef ::FpML_4_2::ShareExtraordinaryEventEnum shareForShare_type;
    typedef ::xsd::cxx::tree::traits< shareForShare_type, char > shareForShare_traits;

    const shareForShare_type&
    shareForShare () const;

    shareForShare_type&
    shareForShare ();

    void
    shareForShare (const shareForShare_type& x);

    void
    shareForShare (::std::auto_ptr< shareForShare_type > p);

    // shareForOther
    // 
    typedef ::FpML_4_2::ShareExtraordinaryEventEnum shareForOther_type;
    typedef ::xsd::cxx::tree::traits< shareForOther_type, char > shareForOther_traits;

    const shareForOther_type&
    shareForOther () const;

    shareForOther_type&
    shareForOther ();

    void
    shareForOther (const shareForOther_type& x);

    void
    shareForOther (::std::auto_ptr< shareForOther_type > p);

    // shareForCombined
    // 
    typedef ::FpML_4_2::ShareExtraordinaryEventEnum shareForCombined_type;
    typedef ::xsd::cxx::tree::traits< shareForCombined_type, char > shareForCombined_traits;

    const shareForCombined_type&
    shareForCombined () const;

    shareForCombined_type&
    shareForCombined ();

    void
    shareForCombined (const shareForCombined_type& x);

    void
    shareForCombined (::std::auto_ptr< shareForCombined_type > p);

    // Constructors.
    //
    EquityCorporateEvents (const shareForShare_type&,
                           const shareForOther_type&,
                           const shareForCombined_type&);

    EquityCorporateEvents (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    EquityCorporateEvents (const EquityCorporateEvents& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual EquityCorporateEvents*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityCorporateEvents ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< shareForShare_type > shareForShare_;
    ::xsd::cxx::tree::one< shareForOther_type > shareForOther_;
    ::xsd::cxx::tree::one< shareForCombined_type > shareForCombined_;
  };

  class EquityPremium: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // premiumType
    // 
    typedef ::FpML_4_2::PremiumTypeEnum premiumType_type;
    typedef ::xsd::cxx::tree::optional< premiumType_type > premiumType_optional;
    typedef ::xsd::cxx::tree::traits< premiumType_type, char > premiumType_traits;

    const premiumType_optional&
    premiumType () const;

    premiumType_optional&
    premiumType ();

    void
    premiumType (const premiumType_type& x);

    void
    premiumType (const premiumType_optional& x);

    void
    premiumType (::std::auto_ptr< premiumType_type > p);

    // paymentAmount
    // 
    typedef ::FpML_4_2::Money paymentAmount_type;
    typedef ::xsd::cxx::tree::optional< paymentAmount_type > paymentAmount_optional;
    typedef ::xsd::cxx::tree::traits< paymentAmount_type, char > paymentAmount_traits;

    const paymentAmount_optional&
    paymentAmount () const;

    paymentAmount_optional&
    paymentAmount ();

    void
    paymentAmount (const paymentAmount_type& x);

    void
    paymentAmount (const paymentAmount_optional& x);

    void
    paymentAmount (::std::auto_ptr< paymentAmount_type > p);

    // paymentDate
    // 
    typedef ::FpML_4_2::AdjustableDate paymentDate_type;
    typedef ::xsd::cxx::tree::optional< paymentDate_type > paymentDate_optional;
    typedef ::xsd::cxx::tree::traits< paymentDate_type, char > paymentDate_traits;

    const paymentDate_optional&
    paymentDate () const;

    paymentDate_optional&
    paymentDate ();

    void
    paymentDate (const paymentDate_type& x);

    void
    paymentDate (const paymentDate_optional& x);

    void
    paymentDate (::std::auto_ptr< paymentDate_type > p);

    // swapPremium
    // 
    typedef ::xml_schema::boolean swapPremium_type;
    typedef ::xsd::cxx::tree::optional< swapPremium_type > swapPremium_optional;
    typedef ::xsd::cxx::tree::traits< swapPremium_type, char > swapPremium_traits;

    const swapPremium_optional&
    swapPremium () const;

    swapPremium_optional&
    swapPremium ();

    void
    swapPremium (const swapPremium_type& x);

    void
    swapPremium (const swapPremium_optional& x);

    // pricePerOption
    // 
    typedef ::FpML_4_2::Money pricePerOption_type;
    typedef ::xsd::cxx::tree::optional< pricePerOption_type > pricePerOption_optional;
    typedef ::xsd::cxx::tree::traits< pricePerOption_type, char > pricePerOption_traits;

    const pricePerOption_optional&
    pricePerOption () const;

    pricePerOption_optional&
    pricePerOption ();

    void
    pricePerOption (const pricePerOption_type& x);

    void
    pricePerOption (const pricePerOption_optional& x);

    void
    pricePerOption (::std::auto_ptr< pricePerOption_type > p);

    // percentageOfNotional
    // 
    typedef ::xml_schema::decimal percentageOfNotional_type;
    typedef ::xsd::cxx::tree::optional< percentageOfNotional_type > percentageOfNotional_optional;
    typedef ::xsd::cxx::tree::traits< percentageOfNotional_type, char, ::xsd::cxx::tree::schema_type::decimal > percentageOfNotional_traits;

    const percentageOfNotional_optional&
    percentageOfNotional () const;

    percentageOfNotional_optional&
    percentageOfNotional ();

    void
    percentageOfNotional (const percentageOfNotional_type& x);

    void
    percentageOfNotional (const percentageOfNotional_optional& x);

    // Constructors.
    //
    EquityPremium (const payerPartyReference_type&,
                   const receiverPartyReference_type&);

    EquityPremium (::std::auto_ptr< payerPartyReference_type >&,
                   ::std::auto_ptr< receiverPartyReference_type >&);

    EquityPremium (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    EquityPremium (const EquityPremium& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual EquityPremium*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityPremium ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    premiumType_optional premiumType_;
    paymentAmount_optional paymentAmount_;
    paymentDate_optional paymentDate_;
    swapPremium_optional swapPremium_;
    pricePerOption_optional pricePerOption_;
    percentageOfNotional_optional percentageOfNotional_;
  };

  class EquitySchedule: public ::xml_schema::type
  {
    public:
    // startDate
    // 
    typedef ::xml_schema::date startDate_type;
    typedef ::xsd::cxx::tree::traits< startDate_type, char > startDate_traits;

    const startDate_type&
    startDate () const;

    startDate_type&
    startDate ();

    void
    startDate (const startDate_type& x);

    void
    startDate (::std::auto_ptr< startDate_type > p);

    // endDate
    // 
    typedef ::xml_schema::date endDate_type;
    typedef ::xsd::cxx::tree::traits< endDate_type, char > endDate_traits;

    const endDate_type&
    endDate () const;

    endDate_type&
    endDate ();

    void
    endDate (const endDate_type& x);

    void
    endDate (::std::auto_ptr< endDate_type > p);

    // frequency
    // 
    typedef ::xml_schema::decimal frequency_type;
    typedef ::xsd::cxx::tree::traits< frequency_type, char, ::xsd::cxx::tree::schema_type::decimal > frequency_traits;

    const frequency_type&
    frequency () const;

    frequency_type&
    frequency ();

    void
    frequency (const frequency_type& x);

    // frequencyType
    // 
    typedef ::FpML_4_2::FrequencyTypeEnum frequencyType_type;
    typedef ::xsd::cxx::tree::traits< frequencyType_type, char > frequencyType_traits;

    const frequencyType_type&
    frequencyType () const;

    frequencyType_type&
    frequencyType ();

    void
    frequencyType (const frequencyType_type& x);

    void
    frequencyType (::std::auto_ptr< frequencyType_type > p);

    // weekNumber
    // 
    typedef ::xml_schema::decimal weekNumber_type;
    typedef ::xsd::cxx::tree::optional< weekNumber_type > weekNumber_optional;
    typedef ::xsd::cxx::tree::traits< weekNumber_type, char, ::xsd::cxx::tree::schema_type::decimal > weekNumber_traits;

    const weekNumber_optional&
    weekNumber () const;

    weekNumber_optional&
    weekNumber ();

    void
    weekNumber (const weekNumber_type& x);

    void
    weekNumber (const weekNumber_optional& x);

    // dayOfWeek
    // 
    typedef ::FpML_4_2::WeeklyRollConventionEnum dayOfWeek_type;
    typedef ::xsd::cxx::tree::optional< dayOfWeek_type > dayOfWeek_optional;
    typedef ::xsd::cxx::tree::traits< dayOfWeek_type, char > dayOfWeek_traits;

    const dayOfWeek_optional&
    dayOfWeek () const;

    dayOfWeek_optional&
    dayOfWeek ();

    void
    dayOfWeek (const dayOfWeek_type& x);

    void
    dayOfWeek (const dayOfWeek_optional& x);

    void
    dayOfWeek (::std::auto_ptr< dayOfWeek_type > p);

    // Constructors.
    //
    EquitySchedule (const startDate_type&,
                    const endDate_type&,
                    const frequency_type&,
                    const frequencyType_type&);

    EquitySchedule (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    EquitySchedule (const EquitySchedule& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual EquitySchedule*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquitySchedule ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< startDate_type > startDate_;
    ::xsd::cxx::tree::one< endDate_type > endDate_;
    ::xsd::cxx::tree::one< frequency_type > frequency_;
    ::xsd::cxx::tree::one< frequencyType_type > frequencyType_;
    weekNumber_optional weekNumber_;
    dayOfWeek_optional dayOfWeek_;
  };

  class EquityStrike: public ::xml_schema::type
  {
    public:
    // strikePrice
    // 
    typedef ::xml_schema::decimal strikePrice_type;
    typedef ::xsd::cxx::tree::optional< strikePrice_type > strikePrice_optional;
    typedef ::xsd::cxx::tree::traits< strikePrice_type, char, ::xsd::cxx::tree::schema_type::decimal > strikePrice_traits;

    const strikePrice_optional&
    strikePrice () const;

    strikePrice_optional&
    strikePrice ();

    void
    strikePrice (const strikePrice_type& x);

    void
    strikePrice (const strikePrice_optional& x);

    // strikePercentage
    // 
    typedef ::xml_schema::decimal strikePercentage_type;
    typedef ::xsd::cxx::tree::optional< strikePercentage_type > strikePercentage_optional;
    typedef ::xsd::cxx::tree::traits< strikePercentage_type, char, ::xsd::cxx::tree::schema_type::decimal > strikePercentage_traits;

    const strikePercentage_optional&
    strikePercentage () const;

    strikePercentage_optional&
    strikePercentage ();

    void
    strikePercentage (const strikePercentage_type& x);

    void
    strikePercentage (const strikePercentage_optional& x);

    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::optional< currency_type > currency_optional;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_optional&
    currency () const;

    currency_optional&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (const currency_optional& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // Constructors.
    //
    EquityStrike ();

    EquityStrike (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    EquityStrike (const EquityStrike& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual EquityStrike*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityStrike ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    strikePrice_optional strikePrice_;
    strikePercentage_optional strikePercentage_;
    currency_optional currency_;
  };

  class EquityValuation: public ::xml_schema::type
  {
    public:
    // valuationDate
    // 
    typedef ::FpML_4_2::AdjustableDateOrRelativeDateSequence valuationDate_type;
    typedef ::xsd::cxx::tree::optional< valuationDate_type > valuationDate_optional;
    typedef ::xsd::cxx::tree::traits< valuationDate_type, char > valuationDate_traits;

    const valuationDate_optional&
    valuationDate () const;

    valuationDate_optional&
    valuationDate ();

    void
    valuationDate (const valuationDate_type& x);

    void
    valuationDate (const valuationDate_optional& x);

    void
    valuationDate (::std::auto_ptr< valuationDate_type > p);

    // valuationDates
    // 
    typedef ::FpML_4_2::AdjustableRelativeOrPeriodicDates valuationDates_type;
    typedef ::xsd::cxx::tree::optional< valuationDates_type > valuationDates_optional;
    typedef ::xsd::cxx::tree::traits< valuationDates_type, char > valuationDates_traits;

    const valuationDates_optional&
    valuationDates () const;

    valuationDates_optional&
    valuationDates ();

    void
    valuationDates (const valuationDates_type& x);

    void
    valuationDates (const valuationDates_optional& x);

    void
    valuationDates (::std::auto_ptr< valuationDates_type > p);

    // valuationTimeType
    // 
    typedef ::FpML_4_2::TimeTypeEnum valuationTimeType_type;
    typedef ::xsd::cxx::tree::optional< valuationTimeType_type > valuationTimeType_optional;
    typedef ::xsd::cxx::tree::traits< valuationTimeType_type, char > valuationTimeType_traits;

    const valuationTimeType_optional&
    valuationTimeType () const;

    valuationTimeType_optional&
    valuationTimeType ();

    void
    valuationTimeType (const valuationTimeType_type& x);

    void
    valuationTimeType (const valuationTimeType_optional& x);

    void
    valuationTimeType (::std::auto_ptr< valuationTimeType_type > p);

    // valuationTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime valuationTime_type;
    typedef ::xsd::cxx::tree::optional< valuationTime_type > valuationTime_optional;
    typedef ::xsd::cxx::tree::traits< valuationTime_type, char > valuationTime_traits;

    const valuationTime_optional&
    valuationTime () const;

    valuationTime_optional&
    valuationTime ();

    void
    valuationTime (const valuationTime_type& x);

    void
    valuationTime (const valuationTime_optional& x);

    void
    valuationTime (::std::auto_ptr< valuationTime_type > p);

    // futuresPriceValuation
    // 
    typedef ::xml_schema::boolean futuresPriceValuation_type;
    typedef ::xsd::cxx::tree::optional< futuresPriceValuation_type > futuresPriceValuation_optional;
    typedef ::xsd::cxx::tree::traits< futuresPriceValuation_type, char > futuresPriceValuation_traits;

    const futuresPriceValuation_optional&
    futuresPriceValuation () const;

    futuresPriceValuation_optional&
    futuresPriceValuation ();

    void
    futuresPriceValuation (const futuresPriceValuation_type& x);

    void
    futuresPriceValuation (const futuresPriceValuation_optional& x);

    // optionsPriceValuation
    // 
    typedef ::xml_schema::boolean optionsPriceValuation_type;
    typedef ::xsd::cxx::tree::optional< optionsPriceValuation_type > optionsPriceValuation_optional;
    typedef ::xsd::cxx::tree::traits< optionsPriceValuation_type, char > optionsPriceValuation_traits;

    const optionsPriceValuation_optional&
    optionsPriceValuation () const;

    optionsPriceValuation_optional&
    optionsPriceValuation ();

    void
    optionsPriceValuation (const optionsPriceValuation_type& x);

    void
    optionsPriceValuation (const optionsPriceValuation_optional& x);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    EquityValuation ();

    EquityValuation (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    EquityValuation (const EquityValuation& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual EquityValuation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityValuation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    valuationDate_optional valuationDate_;
    valuationDates_optional valuationDates_;
    valuationTimeType_optional valuationTimeType_;
    valuationTime_optional valuationTime_;
    futuresPriceValuation_optional futuresPriceValuation_;
    optionsPriceValuation_optional optionsPriceValuation_;
    id_optional id_;
  };

  class ExtraordinaryEvents: public ::xml_schema::type
  {
    public:
    // mergerEvents
    // 
    typedef ::FpML_4_2::EquityCorporateEvents mergerEvents_type;
    typedef ::xsd::cxx::tree::optional< mergerEvents_type > mergerEvents_optional;
    typedef ::xsd::cxx::tree::traits< mergerEvents_type, char > mergerEvents_traits;

    const mergerEvents_optional&
    mergerEvents () const;

    mergerEvents_optional&
    mergerEvents ();

    void
    mergerEvents (const mergerEvents_type& x);

    void
    mergerEvents (const mergerEvents_optional& x);

    void
    mergerEvents (::std::auto_ptr< mergerEvents_type > p);

    // tenderOffer
    // 
    typedef ::xml_schema::boolean tenderOffer_type;
    typedef ::xsd::cxx::tree::optional< tenderOffer_type > tenderOffer_optional;
    typedef ::xsd::cxx::tree::traits< tenderOffer_type, char > tenderOffer_traits;

    const tenderOffer_optional&
    tenderOffer () const;

    tenderOffer_optional&
    tenderOffer ();

    void
    tenderOffer (const tenderOffer_type& x);

    void
    tenderOffer (const tenderOffer_optional& x);

    // tenderOfferEvents
    // 
    typedef ::FpML_4_2::EquityCorporateEvents tenderOfferEvents_type;
    typedef ::xsd::cxx::tree::optional< tenderOfferEvents_type > tenderOfferEvents_optional;
    typedef ::xsd::cxx::tree::traits< tenderOfferEvents_type, char > tenderOfferEvents_traits;

    const tenderOfferEvents_optional&
    tenderOfferEvents () const;

    tenderOfferEvents_optional&
    tenderOfferEvents ();

    void
    tenderOfferEvents (const tenderOfferEvents_type& x);

    void
    tenderOfferEvents (const tenderOfferEvents_optional& x);

    void
    tenderOfferEvents (::std::auto_ptr< tenderOfferEvents_type > p);

    // compositionOfCombinedConsideration
    // 
    typedef ::xml_schema::boolean compositionOfCombinedConsideration_type;
    typedef ::xsd::cxx::tree::optional< compositionOfCombinedConsideration_type > compositionOfCombinedConsideration_optional;
    typedef ::xsd::cxx::tree::traits< compositionOfCombinedConsideration_type, char > compositionOfCombinedConsideration_traits;

    const compositionOfCombinedConsideration_optional&
    compositionOfCombinedConsideration () const;

    compositionOfCombinedConsideration_optional&
    compositionOfCombinedConsideration ();

    void
    compositionOfCombinedConsideration (const compositionOfCombinedConsideration_type& x);

    void
    compositionOfCombinedConsideration (const compositionOfCombinedConsideration_optional& x);

    // indexAdjustmentEvents
    // 
    typedef ::FpML_4_2::IndexAdjustmentEvents indexAdjustmentEvents_type;
    typedef ::xsd::cxx::tree::optional< indexAdjustmentEvents_type > indexAdjustmentEvents_optional;
    typedef ::xsd::cxx::tree::traits< indexAdjustmentEvents_type, char > indexAdjustmentEvents_traits;

    const indexAdjustmentEvents_optional&
    indexAdjustmentEvents () const;

    indexAdjustmentEvents_optional&
    indexAdjustmentEvents ();

    void
    indexAdjustmentEvents (const indexAdjustmentEvents_type& x);

    void
    indexAdjustmentEvents (const indexAdjustmentEvents_optional& x);

    void
    indexAdjustmentEvents (::std::auto_ptr< indexAdjustmentEvents_type > p);

    // additionalDisruptionEvents
    // 
    typedef ::FpML_4_2::AdditionalDisruptionEvents additionalDisruptionEvents_type;
    typedef ::xsd::cxx::tree::optional< additionalDisruptionEvents_type > additionalDisruptionEvents_optional;
    typedef ::xsd::cxx::tree::traits< additionalDisruptionEvents_type, char > additionalDisruptionEvents_traits;

    const additionalDisruptionEvents_optional&
    additionalDisruptionEvents () const;

    additionalDisruptionEvents_optional&
    additionalDisruptionEvents ();

    void
    additionalDisruptionEvents (const additionalDisruptionEvents_type& x);

    void
    additionalDisruptionEvents (const additionalDisruptionEvents_optional& x);

    void
    additionalDisruptionEvents (::std::auto_ptr< additionalDisruptionEvents_type > p);

    // failureToDeliver
    // 
    typedef ::xml_schema::boolean failureToDeliver_type;
    typedef ::xsd::cxx::tree::optional< failureToDeliver_type > failureToDeliver_optional;
    typedef ::xsd::cxx::tree::traits< failureToDeliver_type, char > failureToDeliver_traits;

    const failureToDeliver_optional&
    failureToDeliver () const;

    failureToDeliver_optional&
    failureToDeliver ();

    void
    failureToDeliver (const failureToDeliver_type& x);

    void
    failureToDeliver (const failureToDeliver_optional& x);

    // representations
    // 
    typedef ::FpML_4_2::Representations representations_type;
    typedef ::xsd::cxx::tree::optional< representations_type > representations_optional;
    typedef ::xsd::cxx::tree::traits< representations_type, char > representations_traits;

    const representations_optional&
    representations () const;

    representations_optional&
    representations ();

    void
    representations (const representations_type& x);

    void
    representations (const representations_optional& x);

    void
    representations (::std::auto_ptr< representations_type > p);

    // nationalisationOrInsolvency
    // 
    typedef ::FpML_4_2::NationalisationOrInsolvencyOrDelistingEventEnum nationalisationOrInsolvency_type;
    typedef ::xsd::cxx::tree::optional< nationalisationOrInsolvency_type > nationalisationOrInsolvency_optional;
    typedef ::xsd::cxx::tree::traits< nationalisationOrInsolvency_type, char > nationalisationOrInsolvency_traits;

    const nationalisationOrInsolvency_optional&
    nationalisationOrInsolvency () const;

    nationalisationOrInsolvency_optional&
    nationalisationOrInsolvency ();

    void
    nationalisationOrInsolvency (const nationalisationOrInsolvency_type& x);

    void
    nationalisationOrInsolvency (const nationalisationOrInsolvency_optional& x);

    void
    nationalisationOrInsolvency (::std::auto_ptr< nationalisationOrInsolvency_type > p);

    // delisting
    // 
    typedef ::FpML_4_2::NationalisationOrInsolvencyOrDelistingEventEnum delisting_type;
    typedef ::xsd::cxx::tree::optional< delisting_type > delisting_optional;
    typedef ::xsd::cxx::tree::traits< delisting_type, char > delisting_traits;

    const delisting_optional&
    delisting () const;

    delisting_optional&
    delisting ();

    void
    delisting (const delisting_type& x);

    void
    delisting (const delisting_optional& x);

    void
    delisting (::std::auto_ptr< delisting_type > p);

    // Constructors.
    //
    ExtraordinaryEvents ();

    ExtraordinaryEvents (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ExtraordinaryEvents (const ExtraordinaryEvents& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual ExtraordinaryEvents*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExtraordinaryEvents ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    mergerEvents_optional mergerEvents_;
    tenderOffer_optional tenderOffer_;
    tenderOfferEvents_optional tenderOfferEvents_;
    compositionOfCombinedConsideration_optional compositionOfCombinedConsideration_;
    indexAdjustmentEvents_optional indexAdjustmentEvents_;
    additionalDisruptionEvents_optional additionalDisruptionEvents_;
    failureToDeliver_optional failureToDeliver_;
    representations_optional representations_;
    nationalisationOrInsolvency_optional nationalisationOrInsolvency_;
    delisting_optional delisting_;
  };

  class FeaturePayment: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // levelPercentage
    // 
    typedef ::xml_schema::decimal levelPercentage_type;
    typedef ::xsd::cxx::tree::optional< levelPercentage_type > levelPercentage_optional;
    typedef ::xsd::cxx::tree::traits< levelPercentage_type, char, ::xsd::cxx::tree::schema_type::decimal > levelPercentage_traits;

    const levelPercentage_optional&
    levelPercentage () const;

    levelPercentage_optional&
    levelPercentage ();

    void
    levelPercentage (const levelPercentage_type& x);

    void
    levelPercentage (const levelPercentage_optional& x);

    // amount
    // 
    typedef ::xml_schema::decimal amount_type;
    typedef ::xsd::cxx::tree::optional< amount_type > amount_optional;
    typedef ::xsd::cxx::tree::traits< amount_type, char, ::xsd::cxx::tree::schema_type::decimal > amount_traits;

    const amount_optional&
    amount () const;

    amount_optional&
    amount ();

    void
    amount (const amount_type& x);

    void
    amount (const amount_optional& x);

    // time
    // 
    typedef ::FpML_4_2::TimeTypeEnum time_type;
    typedef ::xsd::cxx::tree::optional< time_type > time_optional;
    typedef ::xsd::cxx::tree::traits< time_type, char > time_traits;

    const time_optional&
    time () const;

    time_optional&
    time ();

    void
    time (const time_type& x);

    void
    time (const time_optional& x);

    void
    time (::std::auto_ptr< time_type > p);

    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::optional< currency_type > currency_optional;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_optional&
    currency () const;

    currency_optional&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (const currency_optional& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // featurePaymentDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate featurePaymentDate_type;
    typedef ::xsd::cxx::tree::optional< featurePaymentDate_type > featurePaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< featurePaymentDate_type, char > featurePaymentDate_traits;

    const featurePaymentDate_optional&
    featurePaymentDate () const;

    featurePaymentDate_optional&
    featurePaymentDate ();

    void
    featurePaymentDate (const featurePaymentDate_type& x);

    void
    featurePaymentDate (const featurePaymentDate_optional& x);

    void
    featurePaymentDate (::std::auto_ptr< featurePaymentDate_type > p);

    // Constructors.
    //
    FeaturePayment (const payerPartyReference_type&,
                    const receiverPartyReference_type&);

    FeaturePayment (::std::auto_ptr< payerPartyReference_type >&,
                    ::std::auto_ptr< receiverPartyReference_type >&);

    FeaturePayment (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    FeaturePayment (const FeaturePayment& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual FeaturePayment*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FeaturePayment ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    levelPercentage_optional levelPercentage_;
    amount_optional amount_;
    time_optional time_;
    currency_optional currency_;
    featurePaymentDate_optional featurePaymentDate_;
  };

  class FxFeature: public ::xml_schema::type
  {
    public:
    // referenceCurrency
    // 
    typedef ::FpML_4_2::IdentifiedCurrency referenceCurrency_type;
    typedef ::xsd::cxx::tree::traits< referenceCurrency_type, char > referenceCurrency_traits;

    const referenceCurrency_type&
    referenceCurrency () const;

    referenceCurrency_type&
    referenceCurrency ();

    void
    referenceCurrency (const referenceCurrency_type& x);

    void
    referenceCurrency (::std::auto_ptr< referenceCurrency_type > p);

    // composite
    // 
    typedef ::FpML_4_2::Composite composite_type;
    typedef ::xsd::cxx::tree::optional< composite_type > composite_optional;
    typedef ::xsd::cxx::tree::traits< composite_type, char > composite_traits;

    const composite_optional&
    composite () const;

    composite_optional&
    composite ();

    void
    composite (const composite_type& x);

    void
    composite (const composite_optional& x);

    void
    composite (::std::auto_ptr< composite_type > p);

    // quanto
    // 
    typedef ::FpML_4_2::Quanto quanto_type;
    typedef ::xsd::cxx::tree::optional< quanto_type > quanto_optional;
    typedef ::xsd::cxx::tree::traits< quanto_type, char > quanto_traits;

    const quanto_optional&
    quanto () const;

    quanto_optional&
    quanto ();

    void
    quanto (const quanto_type& x);

    void
    quanto (const quanto_optional& x);

    void
    quanto (::std::auto_ptr< quanto_type > p);

    // crossCurrency
    // 
    typedef ::FpML_4_2::Composite crossCurrency_type;
    typedef ::xsd::cxx::tree::optional< crossCurrency_type > crossCurrency_optional;
    typedef ::xsd::cxx::tree::traits< crossCurrency_type, char > crossCurrency_traits;

    const crossCurrency_optional&
    crossCurrency () const;

    crossCurrency_optional&
    crossCurrency ();

    void
    crossCurrency (const crossCurrency_type& x);

    void
    crossCurrency (const crossCurrency_optional& x);

    void
    crossCurrency (::std::auto_ptr< crossCurrency_type > p);

    // Constructors.
    //
    FxFeature (const referenceCurrency_type&);

    FxFeature (::std::auto_ptr< referenceCurrency_type >&);

    FxFeature (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    FxFeature (const FxFeature& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual FxFeature*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxFeature ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< referenceCurrency_type > referenceCurrency_;
    composite_optional composite_;
    quanto_optional quanto_;
    crossCurrency_optional crossCurrency_;
  };

  class IndexAdjustmentEvents: public ::xml_schema::type
  {
    public:
    // indexModification
    // 
    typedef ::FpML_4_2::IndexEventConsequenceEnum indexModification_type;
    typedef ::xsd::cxx::tree::traits< indexModification_type, char > indexModification_traits;

    const indexModification_type&
    indexModification () const;

    indexModification_type&
    indexModification ();

    void
    indexModification (const indexModification_type& x);

    void
    indexModification (::std::auto_ptr< indexModification_type > p);

    // indexCancellation
    // 
    typedef ::FpML_4_2::IndexEventConsequenceEnum indexCancellation_type;
    typedef ::xsd::cxx::tree::traits< indexCancellation_type, char > indexCancellation_traits;

    const indexCancellation_type&
    indexCancellation () const;

    indexCancellation_type&
    indexCancellation ();

    void
    indexCancellation (const indexCancellation_type& x);

    void
    indexCancellation (::std::auto_ptr< indexCancellation_type > p);

    // indexDisruption
    // 
    typedef ::FpML_4_2::IndexEventConsequenceEnum indexDisruption_type;
    typedef ::xsd::cxx::tree::traits< indexDisruption_type, char > indexDisruption_traits;

    const indexDisruption_type&
    indexDisruption () const;

    indexDisruption_type&
    indexDisruption ();

    void
    indexDisruption (const indexDisruption_type& x);

    void
    indexDisruption (::std::auto_ptr< indexDisruption_type > p);

    // Constructors.
    //
    IndexAdjustmentEvents (const indexModification_type&,
                           const indexCancellation_type&,
                           const indexDisruption_type&);

    IndexAdjustmentEvents (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    IndexAdjustmentEvents (const IndexAdjustmentEvents& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual IndexAdjustmentEvents*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IndexAdjustmentEvents ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< indexModification_type > indexModification_;
    ::xsd::cxx::tree::one< indexCancellation_type > indexCancellation_;
    ::xsd::cxx::tree::one< indexDisruption_type > indexDisruption_;
  };

  class InterestCalculation: public ::FpML_4_2::InterestAccrualsMethod
  {
    public:
    // dayCountFraction
    // 
    typedef ::FpML_4_2::DayCountFraction dayCountFraction_type;
    typedef ::xsd::cxx::tree::traits< dayCountFraction_type, char > dayCountFraction_traits;

    const dayCountFraction_type&
    dayCountFraction () const;

    dayCountFraction_type&
    dayCountFraction ();

    void
    dayCountFraction (const dayCountFraction_type& x);

    void
    dayCountFraction (::std::auto_ptr< dayCountFraction_type > p);

    // compounding
    // 
    typedef ::FpML_4_2::Compounding compounding_type;
    typedef ::xsd::cxx::tree::optional< compounding_type > compounding_optional;
    typedef ::xsd::cxx::tree::traits< compounding_type, char > compounding_traits;

    const compounding_optional&
    compounding () const;

    compounding_optional&
    compounding ();

    void
    compounding (const compounding_type& x);

    void
    compounding (const compounding_optional& x);

    void
    compounding (::std::auto_ptr< compounding_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    InterestCalculation (const dayCountFraction_type&);

    InterestCalculation (::std::auto_ptr< dayCountFraction_type >&);

    InterestCalculation (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    InterestCalculation (const InterestCalculation& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual InterestCalculation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InterestCalculation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< dayCountFraction_type > dayCountFraction_;
    compounding_optional compounding_;
    id_optional id_;
  };

  class InterestCalculationReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    InterestCalculationReference (const href_type&);

    InterestCalculationReference (const ::xercesc::DOMElement& e,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    InterestCalculationReference (const InterestCalculationReference& x,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    virtual InterestCalculationReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InterestCalculationReference ();
  };

  class ReturnSwapLeg: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // paymentFrequency
    // 
    typedef ::FpML_4_2::Interval paymentFrequency_type;
    typedef ::xsd::cxx::tree::optional< paymentFrequency_type > paymentFrequency_optional;
    typedef ::xsd::cxx::tree::traits< paymentFrequency_type, char > paymentFrequency_traits;

    const paymentFrequency_optional&
    paymentFrequency () const;

    paymentFrequency_optional&
    paymentFrequency ();

    void
    paymentFrequency (const paymentFrequency_type& x);

    void
    paymentFrequency (const paymentFrequency_optional& x);

    void
    paymentFrequency (::std::auto_ptr< paymentFrequency_type > p);

    // legIdentifier
    // 
    typedef ::xml_schema::id legIdentifier_type;
    typedef ::xsd::cxx::tree::optional< legIdentifier_type > legIdentifier_optional;
    typedef ::xsd::cxx::tree::traits< legIdentifier_type, char > legIdentifier_traits;

    const legIdentifier_optional&
    legIdentifier () const;

    legIdentifier_optional&
    legIdentifier ();

    void
    legIdentifier (const legIdentifier_type& x);

    void
    legIdentifier (const legIdentifier_optional& x);

    void
    legIdentifier (::std::auto_ptr< legIdentifier_type > p);

    // Constructors.
    //
    ReturnSwapLeg (const payerPartyReference_type&,
                   const receiverPartyReference_type&);

    ReturnSwapLeg (::std::auto_ptr< payerPartyReference_type >&,
                   ::std::auto_ptr< receiverPartyReference_type >&);

    ReturnSwapLeg (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    ReturnSwapLeg (const ReturnSwapLeg& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual ReturnSwapLeg*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReturnSwapLeg ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    paymentFrequency_optional paymentFrequency_;
    legIdentifier_optional legIdentifier_;
  };

  class InterestLeg: public ::FpML_4_2::ReturnSwapLeg
  {
    public:
    // interestLegCalculationPeriodDates
    // 
    typedef ::FpML_4_2::InterestLegCalculationPeriodDates interestLegCalculationPeriodDates_type;
    typedef ::xsd::cxx::tree::traits< interestLegCalculationPeriodDates_type, char > interestLegCalculationPeriodDates_traits;

    const interestLegCalculationPeriodDates_type&
    interestLegCalculationPeriodDates () const;

    interestLegCalculationPeriodDates_type&
    interestLegCalculationPeriodDates ();

    void
    interestLegCalculationPeriodDates (const interestLegCalculationPeriodDates_type& x);

    void
    interestLegCalculationPeriodDates (::std::auto_ptr< interestLegCalculationPeriodDates_type > p);

    // notional
    // 
    typedef ::FpML_4_2::ReturnSwapNotional notional_type;
    typedef ::xsd::cxx::tree::traits< notional_type, char > notional_traits;

    const notional_type&
    notional () const;

    notional_type&
    notional ();

    void
    notional (const notional_type& x);

    void
    notional (::std::auto_ptr< notional_type > p);

    // interestAmount
    // 
    typedef ::FpML_4_2::LegAmount interestAmount_type;
    typedef ::xsd::cxx::tree::traits< interestAmount_type, char > interestAmount_traits;

    const interestAmount_type&
    interestAmount () const;

    interestAmount_type&
    interestAmount ();

    void
    interestAmount (const interestAmount_type& x);

    void
    interestAmount (::std::auto_ptr< interestAmount_type > p);

    // interestCalculation
    // 
    typedef ::FpML_4_2::InterestCalculation interestCalculation_type;
    typedef ::xsd::cxx::tree::traits< interestCalculation_type, char > interestCalculation_traits;

    const interestCalculation_type&
    interestCalculation () const;

    interestCalculation_type&
    interestCalculation ();

    void
    interestCalculation (const interestCalculation_type& x);

    void
    interestCalculation (::std::auto_ptr< interestCalculation_type > p);

    // stubCalculationPeriod
    // 
    typedef ::FpML_4_2::StubCalculationPeriod stubCalculationPeriod_type;
    typedef ::xsd::cxx::tree::optional< stubCalculationPeriod_type > stubCalculationPeriod_optional;
    typedef ::xsd::cxx::tree::traits< stubCalculationPeriod_type, char > stubCalculationPeriod_traits;

    const stubCalculationPeriod_optional&
    stubCalculationPeriod () const;

    stubCalculationPeriod_optional&
    stubCalculationPeriod ();

    void
    stubCalculationPeriod (const stubCalculationPeriod_type& x);

    void
    stubCalculationPeriod (const stubCalculationPeriod_optional& x);

    void
    stubCalculationPeriod (::std::auto_ptr< stubCalculationPeriod_type > p);

    // Constructors.
    //
    InterestLeg (const payerPartyReference_type&,
                 const receiverPartyReference_type&,
                 const interestLegCalculationPeriodDates_type&,
                 const notional_type&,
                 const interestAmount_type&,
                 const interestCalculation_type&);

    InterestLeg (::std::auto_ptr< payerPartyReference_type >&,
                 ::std::auto_ptr< receiverPartyReference_type >&,
                 ::std::auto_ptr< interestLegCalculationPeriodDates_type >&,
                 ::std::auto_ptr< notional_type >&,
                 ::std::auto_ptr< interestAmount_type >&,
                 ::std::auto_ptr< interestCalculation_type >&);

    InterestLeg (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    InterestLeg (const InterestLeg& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual InterestLeg*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InterestLeg ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< interestLegCalculationPeriodDates_type > interestLegCalculationPeriodDates_;
    ::xsd::cxx::tree::one< notional_type > notional_;
    ::xsd::cxx::tree::one< interestAmount_type > interestAmount_;
    ::xsd::cxx::tree::one< interestCalculation_type > interestCalculation_;
    stubCalculationPeriod_optional stubCalculationPeriod_;
  };

  class InterestLegCalculationPeriodDates: public ::xml_schema::type
  {
    public:
    // effectiveDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate effectiveDate_type;
    typedef ::xsd::cxx::tree::traits< effectiveDate_type, char > effectiveDate_traits;

    const effectiveDate_type&
    effectiveDate () const;

    effectiveDate_type&
    effectiveDate ();

    void
    effectiveDate (const effectiveDate_type& x);

    void
    effectiveDate (::std::auto_ptr< effectiveDate_type > p);

    // terminationDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate terminationDate_type;
    typedef ::xsd::cxx::tree::traits< terminationDate_type, char > terminationDate_traits;

    const terminationDate_type&
    terminationDate () const;

    terminationDate_type&
    terminationDate ();

    void
    terminationDate (const terminationDate_type& x);

    void
    terminationDate (::std::auto_ptr< terminationDate_type > p);

    // interestLegResetDates
    // 
    typedef ::FpML_4_2::InterestLegResetDates interestLegResetDates_type;
    typedef ::xsd::cxx::tree::traits< interestLegResetDates_type, char > interestLegResetDates_traits;

    const interestLegResetDates_type&
    interestLegResetDates () const;

    interestLegResetDates_type&
    interestLegResetDates ();

    void
    interestLegResetDates (const interestLegResetDates_type& x);

    void
    interestLegResetDates (::std::auto_ptr< interestLegResetDates_type > p);

    // interestLegPaymentDates
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDates interestLegPaymentDates_type;
    typedef ::xsd::cxx::tree::traits< interestLegPaymentDates_type, char > interestLegPaymentDates_traits;

    const interestLegPaymentDates_type&
    interestLegPaymentDates () const;

    interestLegPaymentDates_type&
    interestLegPaymentDates ();

    void
    interestLegPaymentDates (const interestLegPaymentDates_type& x);

    void
    interestLegPaymentDates (::std::auto_ptr< interestLegPaymentDates_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    InterestLegCalculationPeriodDates (const effectiveDate_type&,
                                       const terminationDate_type&,
                                       const interestLegResetDates_type&,
                                       const interestLegPaymentDates_type&,
                                       const id_type&);

    InterestLegCalculationPeriodDates (::std::auto_ptr< effectiveDate_type >&,
                                       ::std::auto_ptr< terminationDate_type >&,
                                       ::std::auto_ptr< interestLegResetDates_type >&,
                                       ::std::auto_ptr< interestLegPaymentDates_type >&,
                                       const id_type&);

    InterestLegCalculationPeriodDates (const ::xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    InterestLegCalculationPeriodDates (const InterestLegCalculationPeriodDates& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual InterestLegCalculationPeriodDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InterestLegCalculationPeriodDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< effectiveDate_type > effectiveDate_;
    ::xsd::cxx::tree::one< terminationDate_type > terminationDate_;
    ::xsd::cxx::tree::one< interestLegResetDates_type > interestLegResetDates_;
    ::xsd::cxx::tree::one< interestLegPaymentDates_type > interestLegPaymentDates_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class InterestLegCalculationPeriodDatesReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    InterestLegCalculationPeriodDatesReference (const href_type&);

    InterestLegCalculationPeriodDatesReference (const ::xercesc::DOMElement& e,
                                                ::xml_schema::flags f = 0,
                                                ::xml_schema::container* c = 0);

    InterestLegCalculationPeriodDatesReference (const InterestLegCalculationPeriodDatesReference& x,
                                                ::xml_schema::flags f = 0,
                                                ::xml_schema::container* c = 0);

    virtual InterestLegCalculationPeriodDatesReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InterestLegCalculationPeriodDatesReference ();
  };

  class InterestLegResetDates: public ::xml_schema::type
  {
    public:
    // calculationPeriodDatesReference
    // 
    typedef ::FpML_4_2::InterestLegCalculationPeriodDatesReference calculationPeriodDatesReference_type;
    typedef ::xsd::cxx::tree::traits< calculationPeriodDatesReference_type, char > calculationPeriodDatesReference_traits;

    const calculationPeriodDatesReference_type&
    calculationPeriodDatesReference () const;

    calculationPeriodDatesReference_type&
    calculationPeriodDatesReference ();

    void
    calculationPeriodDatesReference (const calculationPeriodDatesReference_type& x);

    void
    calculationPeriodDatesReference (::std::auto_ptr< calculationPeriodDatesReference_type > p);

    // resetRelativeTo
    // 
    typedef ::FpML_4_2::ResetRelativeToEnum resetRelativeTo_type;
    typedef ::xsd::cxx::tree::optional< resetRelativeTo_type > resetRelativeTo_optional;
    typedef ::xsd::cxx::tree::traits< resetRelativeTo_type, char > resetRelativeTo_traits;

    const resetRelativeTo_optional&
    resetRelativeTo () const;

    resetRelativeTo_optional&
    resetRelativeTo ();

    void
    resetRelativeTo (const resetRelativeTo_type& x);

    void
    resetRelativeTo (const resetRelativeTo_optional& x);

    void
    resetRelativeTo (::std::auto_ptr< resetRelativeTo_type > p);

    // resetFrequency
    // 
    typedef ::FpML_4_2::ResetFrequency resetFrequency_type;
    typedef ::xsd::cxx::tree::optional< resetFrequency_type > resetFrequency_optional;
    typedef ::xsd::cxx::tree::traits< resetFrequency_type, char > resetFrequency_traits;

    const resetFrequency_optional&
    resetFrequency () const;

    resetFrequency_optional&
    resetFrequency ();

    void
    resetFrequency (const resetFrequency_type& x);

    void
    resetFrequency (const resetFrequency_optional& x);

    void
    resetFrequency (::std::auto_ptr< resetFrequency_type > p);

    // Constructors.
    //
    InterestLegResetDates (const calculationPeriodDatesReference_type&);

    InterestLegResetDates (::std::auto_ptr< calculationPeriodDatesReference_type >&);

    InterestLegResetDates (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    InterestLegResetDates (const InterestLegResetDates& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual InterestLegResetDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InterestLegResetDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< calculationPeriodDatesReference_type > calculationPeriodDatesReference_;
    resetRelativeTo_optional resetRelativeTo_;
    resetFrequency_optional resetFrequency_;
  };

  class Knock: public ::xml_schema::type
  {
    public:
    // knockIn
    // 
    typedef ::FpML_4_2::TriggerEvent knockIn_type;
    typedef ::xsd::cxx::tree::optional< knockIn_type > knockIn_optional;
    typedef ::xsd::cxx::tree::traits< knockIn_type, char > knockIn_traits;

    const knockIn_optional&
    knockIn () const;

    knockIn_optional&
    knockIn ();

    void
    knockIn (const knockIn_type& x);

    void
    knockIn (const knockIn_optional& x);

    void
    knockIn (::std::auto_ptr< knockIn_type > p);

    // knockOut
    // 
    typedef ::FpML_4_2::TriggerEvent knockOut_type;
    typedef ::xsd::cxx::tree::optional< knockOut_type > knockOut_optional;
    typedef ::xsd::cxx::tree::traits< knockOut_type, char > knockOut_traits;

    const knockOut_optional&
    knockOut () const;

    knockOut_optional&
    knockOut ();

    void
    knockOut (const knockOut_type& x);

    void
    knockOut (const knockOut_optional& x);

    void
    knockOut (::std::auto_ptr< knockOut_type > p);

    // Constructors.
    //
    Knock ();

    Knock (const ::xercesc::DOMElement& e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Knock (const Knock& x,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    virtual Knock*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Knock ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    knockIn_optional knockIn_;
    knockOut_optional knockOut_;
  };

  class LegAmount: public ::xml_schema::type
  {
    public:
    // paymentCurrency
    // 
    typedef ::FpML_4_2::PaymentCurrency paymentCurrency_type;
    typedef ::xsd::cxx::tree::optional< paymentCurrency_type > paymentCurrency_optional;
    typedef ::xsd::cxx::tree::traits< paymentCurrency_type, char > paymentCurrency_traits;

    const paymentCurrency_optional&
    paymentCurrency () const;

    paymentCurrency_optional&
    paymentCurrency ();

    void
    paymentCurrency (const paymentCurrency_type& x);

    void
    paymentCurrency (const paymentCurrency_optional& x);

    void
    paymentCurrency (::std::auto_ptr< paymentCurrency_type > p);

    // referenceAmount
    // 
    typedef ::FpML_4_2::ReferenceAmount referenceAmount_type;
    typedef ::xsd::cxx::tree::optional< referenceAmount_type > referenceAmount_optional;
    typedef ::xsd::cxx::tree::traits< referenceAmount_type, char > referenceAmount_traits;

    const referenceAmount_optional&
    referenceAmount () const;

    referenceAmount_optional&
    referenceAmount ();

    void
    referenceAmount (const referenceAmount_type& x);

    void
    referenceAmount (const referenceAmount_optional& x);

    void
    referenceAmount (::std::auto_ptr< referenceAmount_type > p);

    // formula
    // 
    typedef ::FpML_4_2::Formula formula_type;
    typedef ::xsd::cxx::tree::optional< formula_type > formula_optional;
    typedef ::xsd::cxx::tree::traits< formula_type, char > formula_traits;

    const formula_optional&
    formula () const;

    formula_optional&
    formula ();

    void
    formula (const formula_type& x);

    void
    formula (const formula_optional& x);

    void
    formula (::std::auto_ptr< formula_type > p);

    // encodedDescription
    // 
    typedef ::xml_schema::base64_binary encodedDescription_type;
    typedef ::xsd::cxx::tree::optional< encodedDescription_type > encodedDescription_optional;
    typedef ::xsd::cxx::tree::traits< encodedDescription_type, char > encodedDescription_traits;

    const encodedDescription_optional&
    encodedDescription () const;

    encodedDescription_optional&
    encodedDescription ();

    void
    encodedDescription (const encodedDescription_type& x);

    void
    encodedDescription (const encodedDescription_optional& x);

    void
    encodedDescription (::std::auto_ptr< encodedDescription_type > p);

    // variance
    // 
    typedef ::FpML_4_2::Variance variance_type;
    typedef ::xsd::cxx::tree::optional< variance_type > variance_optional;
    typedef ::xsd::cxx::tree::traits< variance_type, char > variance_traits;

    const variance_optional&
    variance () const;

    variance_optional&
    variance ();

    void
    variance (const variance_type& x);

    void
    variance (const variance_optional& x);

    void
    variance (::std::auto_ptr< variance_type > p);

    // calculationDates
    // 
    typedef ::FpML_4_2::AdjustableRelativeOrPeriodicDates calculationDates_type;
    typedef ::xsd::cxx::tree::optional< calculationDates_type > calculationDates_optional;
    typedef ::xsd::cxx::tree::traits< calculationDates_type, char > calculationDates_traits;

    const calculationDates_optional&
    calculationDates () const;

    calculationDates_optional&
    calculationDates ();

    void
    calculationDates (const calculationDates_type& x);

    void
    calculationDates (const calculationDates_optional& x);

    void
    calculationDates (::std::auto_ptr< calculationDates_type > p);

    // Constructors.
    //
    LegAmount ();

    LegAmount (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    LegAmount (const LegAmount& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual LegAmount*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~LegAmount ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    paymentCurrency_optional paymentCurrency_;
    referenceAmount_optional referenceAmount_;
    formula_optional formula_;
    encodedDescription_optional encodedDescription_;
    variance_optional variance_;
    calculationDates_optional calculationDates_;
  };

  class MakeWholeProvisions: public ::xml_schema::type
  {
    public:
    // makeWholeDate
    // 
    typedef ::xml_schema::date makeWholeDate_type;
    typedef ::xsd::cxx::tree::traits< makeWholeDate_type, char > makeWholeDate_traits;

    const makeWholeDate_type&
    makeWholeDate () const;

    makeWholeDate_type&
    makeWholeDate ();

    void
    makeWholeDate (const makeWholeDate_type& x);

    void
    makeWholeDate (::std::auto_ptr< makeWholeDate_type > p);

    // recallSpread
    // 
    typedef ::xml_schema::decimal recallSpread_type;
    typedef ::xsd::cxx::tree::traits< recallSpread_type, char, ::xsd::cxx::tree::schema_type::decimal > recallSpread_traits;

    const recallSpread_type&
    recallSpread () const;

    recallSpread_type&
    recallSpread ();

    void
    recallSpread (const recallSpread_type& x);

    // Constructors.
    //
    MakeWholeProvisions (const makeWholeDate_type&,
                         const recallSpread_type&);

    MakeWholeProvisions (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    MakeWholeProvisions (const MakeWholeProvisions& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual MakeWholeProvisions*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MakeWholeProvisions ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< makeWholeDate_type > makeWholeDate_;
    ::xsd::cxx::tree::one< recallSpread_type > recallSpread_;
  };

  class MarketDisruption: public ::xml_schema::normalized_string
  {
    public:
    // marketDisruptionScheme
    // 
    typedef ::xml_schema::uri marketDisruptionScheme_type;
    typedef ::xsd::cxx::tree::traits< marketDisruptionScheme_type, char > marketDisruptionScheme_traits;

    const marketDisruptionScheme_type&
    marketDisruptionScheme () const;

    marketDisruptionScheme_type&
    marketDisruptionScheme ();

    void
    marketDisruptionScheme (const marketDisruptionScheme_type& x);

    void
    marketDisruptionScheme (::std::auto_ptr< marketDisruptionScheme_type > p);

    static const marketDisruptionScheme_type&
    marketDisruptionScheme_default_value ();

    // Constructors.
    //
    MarketDisruption ();

    MarketDisruption (const char*);

    MarketDisruption (const ::std::string&);

    MarketDisruption (const ::xml_schema::normalized_string&);

    MarketDisruption (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    MarketDisruption (const MarketDisruption& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual MarketDisruption*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MarketDisruption ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< marketDisruptionScheme_type > marketDisruptionScheme_;
    static const marketDisruptionScheme_type marketDisruptionScheme_default_value_;
  };

  class OptionFeatures: public ::xml_schema::type
  {
    public:
    // asian
    // 
    typedef ::FpML_4_2::Asian asian_type;
    typedef ::xsd::cxx::tree::optional< asian_type > asian_optional;
    typedef ::xsd::cxx::tree::traits< asian_type, char > asian_traits;

    const asian_optional&
    asian () const;

    asian_optional&
    asian ();

    void
    asian (const asian_type& x);

    void
    asian (const asian_optional& x);

    void
    asian (::std::auto_ptr< asian_type > p);

    // barrier
    // 
    typedef ::FpML_4_2::Barrier barrier_type;
    typedef ::xsd::cxx::tree::optional< barrier_type > barrier_optional;
    typedef ::xsd::cxx::tree::traits< barrier_type, char > barrier_traits;

    const barrier_optional&
    barrier () const;

    barrier_optional&
    barrier ();

    void
    barrier (const barrier_type& x);

    void
    barrier (const barrier_optional& x);

    void
    barrier (::std::auto_ptr< barrier_type > p);

    // knock
    // 
    typedef ::FpML_4_2::Knock knock_type;
    typedef ::xsd::cxx::tree::optional< knock_type > knock_optional;
    typedef ::xsd::cxx::tree::traits< knock_type, char > knock_traits;

    const knock_optional&
    knock () const;

    knock_optional&
    knock ();

    void
    knock (const knock_type& x);

    void
    knock (const knock_optional& x);

    void
    knock (::std::auto_ptr< knock_type > p);

    // passThrough
    // 
    typedef ::FpML_4_2::PassThrough passThrough_type;
    typedef ::xsd::cxx::tree::optional< passThrough_type > passThrough_optional;
    typedef ::xsd::cxx::tree::traits< passThrough_type, char > passThrough_traits;

    const passThrough_optional&
    passThrough () const;

    passThrough_optional&
    passThrough ();

    void
    passThrough (const passThrough_type& x);

    void
    passThrough (const passThrough_optional& x);

    void
    passThrough (::std::auto_ptr< passThrough_type > p);

    // Constructors.
    //
    OptionFeatures ();

    OptionFeatures (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    OptionFeatures (const OptionFeatures& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual OptionFeatures*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~OptionFeatures ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    asian_optional asian_;
    barrier_optional barrier_;
    knock_optional knock_;
    passThrough_optional passThrough_;
  };

  class PassThrough: public ::xml_schema::type
  {
    public:
    // passThroughItem
    // 
    typedef ::FpML_4_2::PassThroughItem passThroughItem_type;
    typedef ::xsd::cxx::tree::sequence< passThroughItem_type > passThroughItem_sequence;
    typedef passThroughItem_sequence::iterator passThroughItem_iterator;
    typedef passThroughItem_sequence::const_iterator passThroughItem_const_iterator;
    typedef ::xsd::cxx::tree::traits< passThroughItem_type, char > passThroughItem_traits;

    const passThroughItem_sequence&
    passThroughItem () const;

    passThroughItem_sequence&
    passThroughItem ();

    void
    passThroughItem (const passThroughItem_sequence& s);

    // Constructors.
    //
    PassThrough ();

    PassThrough (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    PassThrough (const PassThrough& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual PassThrough*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PassThrough ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    passThroughItem_sequence passThroughItem_;
  };

  class PassThroughItem: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // underlyerReference
    // 
    typedef ::FpML_4_2::AssetReference underlyerReference_type;
    typedef ::xsd::cxx::tree::traits< underlyerReference_type, char > underlyerReference_traits;

    const underlyerReference_type&
    underlyerReference () const;

    underlyerReference_type&
    underlyerReference ();

    void
    underlyerReference (const underlyerReference_type& x);

    void
    underlyerReference (::std::auto_ptr< underlyerReference_type > p);

    // passThroughPercentage
    // 
    typedef ::xml_schema::decimal passThroughPercentage_type;
    typedef ::xsd::cxx::tree::traits< passThroughPercentage_type, char, ::xsd::cxx::tree::schema_type::decimal > passThroughPercentage_traits;

    const passThroughPercentage_type&
    passThroughPercentage () const;

    passThroughPercentage_type&
    passThroughPercentage ();

    void
    passThroughPercentage (const passThroughPercentage_type& x);

    // Constructors.
    //
    PassThroughItem (const payerPartyReference_type&,
                     const receiverPartyReference_type&,
                     const underlyerReference_type&,
                     const passThroughPercentage_type&);

    PassThroughItem (::std::auto_ptr< payerPartyReference_type >&,
                     ::std::auto_ptr< receiverPartyReference_type >&,
                     ::std::auto_ptr< underlyerReference_type >&,
                     const passThroughPercentage_type&);

    PassThroughItem (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    PassThroughItem (const PassThroughItem& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual PassThroughItem*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PassThroughItem ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    ::xsd::cxx::tree::one< underlyerReference_type > underlyerReference_;
    ::xsd::cxx::tree::one< passThroughPercentage_type > passThroughPercentage_;
  };

  class PrincipalExchangeAmount: public ::xml_schema::type
  {
    public:
    // amountRelativeTo
    // 
    typedef ::FpML_4_2::AmountReference amountRelativeTo_type;
    typedef ::xsd::cxx::tree::optional< amountRelativeTo_type > amountRelativeTo_optional;
    typedef ::xsd::cxx::tree::traits< amountRelativeTo_type, char > amountRelativeTo_traits;

    const amountRelativeTo_optional&
    amountRelativeTo () const;

    amountRelativeTo_optional&
    amountRelativeTo ();

    void
    amountRelativeTo (const amountRelativeTo_type& x);

    void
    amountRelativeTo (const amountRelativeTo_optional& x);

    void
    amountRelativeTo (::std::auto_ptr< amountRelativeTo_type > p);

    // determinationMethod
    // 
    typedef ::FpML_4_2::DeterminationMethod determinationMethod_type;
    typedef ::xsd::cxx::tree::optional< determinationMethod_type > determinationMethod_optional;
    typedef ::xsd::cxx::tree::traits< determinationMethod_type, char > determinationMethod_traits;

    const determinationMethod_optional&
    determinationMethod () const;

    determinationMethod_optional&
    determinationMethod ();

    void
    determinationMethod (const determinationMethod_type& x);

    void
    determinationMethod (const determinationMethod_optional& x);

    void
    determinationMethod (::std::auto_ptr< determinationMethod_type > p);

    // principalAmount
    // 
    typedef ::FpML_4_2::Money principalAmount_type;
    typedef ::xsd::cxx::tree::optional< principalAmount_type > principalAmount_optional;
    typedef ::xsd::cxx::tree::traits< principalAmount_type, char > principalAmount_traits;

    const principalAmount_optional&
    principalAmount () const;

    principalAmount_optional&
    principalAmount ();

    void
    principalAmount (const principalAmount_type& x);

    void
    principalAmount (const principalAmount_optional& x);

    void
    principalAmount (::std::auto_ptr< principalAmount_type > p);

    // Constructors.
    //
    PrincipalExchangeAmount ();

    PrincipalExchangeAmount (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    PrincipalExchangeAmount (const PrincipalExchangeAmount& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual PrincipalExchangeAmount*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PrincipalExchangeAmount ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    amountRelativeTo_optional amountRelativeTo_;
    determinationMethod_optional determinationMethod_;
    principalAmount_optional principalAmount_;
  };

  class PrincipalExchangeDescriptions: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // principalExchangeAmount
    // 
    typedef ::FpML_4_2::PrincipalExchangeAmount principalExchangeAmount_type;
    typedef ::xsd::cxx::tree::traits< principalExchangeAmount_type, char > principalExchangeAmount_traits;

    const principalExchangeAmount_type&
    principalExchangeAmount () const;

    principalExchangeAmount_type&
    principalExchangeAmount ();

    void
    principalExchangeAmount (const principalExchangeAmount_type& x);

    void
    principalExchangeAmount (::std::auto_ptr< principalExchangeAmount_type > p);

    // principalExchangeDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate principalExchangeDate_type;
    typedef ::xsd::cxx::tree::traits< principalExchangeDate_type, char > principalExchangeDate_traits;

    const principalExchangeDate_type&
    principalExchangeDate () const;

    principalExchangeDate_type&
    principalExchangeDate ();

    void
    principalExchangeDate (const principalExchangeDate_type& x);

    void
    principalExchangeDate (::std::auto_ptr< principalExchangeDate_type > p);

    // Constructors.
    //
    PrincipalExchangeDescriptions (const payerPartyReference_type&,
                                   const receiverPartyReference_type&,
                                   const principalExchangeAmount_type&,
                                   const principalExchangeDate_type&);

    PrincipalExchangeDescriptions (::std::auto_ptr< payerPartyReference_type >&,
                                   ::std::auto_ptr< receiverPartyReference_type >&,
                                   ::std::auto_ptr< principalExchangeAmount_type >&,
                                   ::std::auto_ptr< principalExchangeDate_type >&);

    PrincipalExchangeDescriptions (const ::xercesc::DOMElement& e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    PrincipalExchangeDescriptions (const PrincipalExchangeDescriptions& x,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    virtual PrincipalExchangeDescriptions*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PrincipalExchangeDescriptions ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    ::xsd::cxx::tree::one< principalExchangeAmount_type > principalExchangeAmount_;
    ::xsd::cxx::tree::one< principalExchangeDate_type > principalExchangeDate_;
  };

  class PrincipalExchangeFeatures: public ::xml_schema::type
  {
    public:
    // principalExchanges
    // 
    typedef ::FpML_4_2::PrincipalExchanges principalExchanges_type;
    typedef ::xsd::cxx::tree::traits< principalExchanges_type, char > principalExchanges_traits;

    const principalExchanges_type&
    principalExchanges () const;

    principalExchanges_type&
    principalExchanges ();

    void
    principalExchanges (const principalExchanges_type& x);

    void
    principalExchanges (::std::auto_ptr< principalExchanges_type > p);

    // principalExchangeDescriptions
    // 
    typedef ::FpML_4_2::PrincipalExchangeDescriptions principalExchangeDescriptions_type;
    typedef ::xsd::cxx::tree::sequence< principalExchangeDescriptions_type > principalExchangeDescriptions_sequence;
    typedef principalExchangeDescriptions_sequence::iterator principalExchangeDescriptions_iterator;
    typedef principalExchangeDescriptions_sequence::const_iterator principalExchangeDescriptions_const_iterator;
    typedef ::xsd::cxx::tree::traits< principalExchangeDescriptions_type, char > principalExchangeDescriptions_traits;

    const principalExchangeDescriptions_sequence&
    principalExchangeDescriptions () const;

    principalExchangeDescriptions_sequence&
    principalExchangeDescriptions ();

    void
    principalExchangeDescriptions (const principalExchangeDescriptions_sequence& s);

    // Constructors.
    //
    PrincipalExchangeFeatures (const principalExchanges_type&);

    PrincipalExchangeFeatures (::std::auto_ptr< principalExchanges_type >&);

    PrincipalExchangeFeatures (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    PrincipalExchangeFeatures (const PrincipalExchangeFeatures& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual PrincipalExchangeFeatures*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PrincipalExchangeFeatures ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< principalExchanges_type > principalExchanges_;
    principalExchangeDescriptions_sequence principalExchangeDescriptions_;
  };

  class Quanto: public ::xml_schema::type
  {
    public:
    // fxRate
    // 
    typedef ::FpML_4_2::FxRate fxRate_type;
    typedef ::xsd::cxx::tree::sequence< fxRate_type > fxRate_sequence;
    typedef fxRate_sequence::iterator fxRate_iterator;
    typedef fxRate_sequence::const_iterator fxRate_const_iterator;
    typedef ::xsd::cxx::tree::traits< fxRate_type, char > fxRate_traits;

    const fxRate_sequence&
    fxRate () const;

    fxRate_sequence&
    fxRate ();

    void
    fxRate (const fxRate_sequence& s);

    // fxSpotRateSource
    // 
    typedef ::FpML_4_2::FxSpotRateSource fxSpotRateSource_type;
    typedef ::xsd::cxx::tree::optional< fxSpotRateSource_type > fxSpotRateSource_optional;
    typedef ::xsd::cxx::tree::traits< fxSpotRateSource_type, char > fxSpotRateSource_traits;

    const fxSpotRateSource_optional&
    fxSpotRateSource () const;

    fxSpotRateSource_optional&
    fxSpotRateSource ();

    void
    fxSpotRateSource (const fxSpotRateSource_type& x);

    void
    fxSpotRateSource (const fxSpotRateSource_optional& x);

    void
    fxSpotRateSource (::std::auto_ptr< fxSpotRateSource_type > p);

    // Constructors.
    //
    Quanto ();

    Quanto (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Quanto (const Quanto& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Quanto*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Quanto ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    fxRate_sequence fxRate_;
    fxSpotRateSource_optional fxSpotRateSource_;
  };

  class Representations: public ::xml_schema::type
  {
    public:
    // nonReliance
    // 
    typedef ::xml_schema::boolean nonReliance_type;
    typedef ::xsd::cxx::tree::traits< nonReliance_type, char > nonReliance_traits;

    const nonReliance_type&
    nonReliance () const;

    nonReliance_type&
    nonReliance ();

    void
    nonReliance (const nonReliance_type& x);

    // agreementsRegardingHedging
    // 
    typedef ::xml_schema::boolean agreementsRegardingHedging_type;
    typedef ::xsd::cxx::tree::traits< agreementsRegardingHedging_type, char > agreementsRegardingHedging_traits;

    const agreementsRegardingHedging_type&
    agreementsRegardingHedging () const;

    agreementsRegardingHedging_type&
    agreementsRegardingHedging ();

    void
    agreementsRegardingHedging (const agreementsRegardingHedging_type& x);

    // indexDisclaimer
    // 
    typedef ::xml_schema::boolean indexDisclaimer_type;
    typedef ::xsd::cxx::tree::optional< indexDisclaimer_type > indexDisclaimer_optional;
    typedef ::xsd::cxx::tree::traits< indexDisclaimer_type, char > indexDisclaimer_traits;

    const indexDisclaimer_optional&
    indexDisclaimer () const;

    indexDisclaimer_optional&
    indexDisclaimer ();

    void
    indexDisclaimer (const indexDisclaimer_type& x);

    void
    indexDisclaimer (const indexDisclaimer_optional& x);

    // additionalAcknowledgements
    // 
    typedef ::xml_schema::boolean additionalAcknowledgements_type;
    typedef ::xsd::cxx::tree::traits< additionalAcknowledgements_type, char > additionalAcknowledgements_traits;

    const additionalAcknowledgements_type&
    additionalAcknowledgements () const;

    additionalAcknowledgements_type&
    additionalAcknowledgements ();

    void
    additionalAcknowledgements (const additionalAcknowledgements_type& x);

    // Constructors.
    //
    Representations (const nonReliance_type&,
                     const agreementsRegardingHedging_type&,
                     const additionalAcknowledgements_type&);

    Representations (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    Representations (const Representations& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual Representations*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Representations ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< nonReliance_type > nonReliance_;
    ::xsd::cxx::tree::one< agreementsRegardingHedging_type > agreementsRegardingHedging_;
    indexDisclaimer_optional indexDisclaimer_;
    ::xsd::cxx::tree::one< additionalAcknowledgements_type > additionalAcknowledgements_;
  };

  class Return: public ::xml_schema::type
  {
    public:
    // returnType
    // 
    typedef ::FpML_4_2::ReturnTypeEnum returnType_type;
    typedef ::xsd::cxx::tree::traits< returnType_type, char > returnType_traits;

    const returnType_type&
    returnType () const;

    returnType_type&
    returnType ();

    void
    returnType (const returnType_type& x);

    void
    returnType (::std::auto_ptr< returnType_type > p);

    // dividendConditions
    // 
    typedef ::FpML_4_2::DividendConditions dividendConditions_type;
    typedef ::xsd::cxx::tree::optional< dividendConditions_type > dividendConditions_optional;
    typedef ::xsd::cxx::tree::traits< dividendConditions_type, char > dividendConditions_traits;

    const dividendConditions_optional&
    dividendConditions () const;

    dividendConditions_optional&
    dividendConditions ();

    void
    dividendConditions (const dividendConditions_type& x);

    void
    dividendConditions (const dividendConditions_optional& x);

    void
    dividendConditions (::std::auto_ptr< dividendConditions_type > p);

    // Constructors.
    //
    Return (const returnType_type&);

    Return (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Return (const Return& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Return*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Return ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< returnType_type > returnType_;
    dividendConditions_optional dividendConditions_;
  };

  class ReturnLeg: public ::FpML_4_2::ReturnSwapLeg
  {
    public:
    // effectiveDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate effectiveDate_type;
    typedef ::xsd::cxx::tree::traits< effectiveDate_type, char > effectiveDate_traits;

    const effectiveDate_type&
    effectiveDate () const;

    effectiveDate_type&
    effectiveDate ();

    void
    effectiveDate (const effectiveDate_type& x);

    void
    effectiveDate (::std::auto_ptr< effectiveDate_type > p);

    // terminationDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate terminationDate_type;
    typedef ::xsd::cxx::tree::traits< terminationDate_type, char > terminationDate_traits;

    const terminationDate_type&
    terminationDate () const;

    terminationDate_type&
    terminationDate ();

    void
    terminationDate (const terminationDate_type& x);

    void
    terminationDate (::std::auto_ptr< terminationDate_type > p);

    // underlyer
    // 
    typedef ::FpML_4_2::Underlyer underlyer_type;
    typedef ::xsd::cxx::tree::traits< underlyer_type, char > underlyer_traits;

    const underlyer_type&
    underlyer () const;

    underlyer_type&
    underlyer ();

    void
    underlyer (const underlyer_type& x);

    void
    underlyer (::std::auto_ptr< underlyer_type > p);

    // rateOfReturn
    // 
    typedef ::FpML_4_2::ReturnLegValuation rateOfReturn_type;
    typedef ::xsd::cxx::tree::traits< rateOfReturn_type, char > rateOfReturn_traits;

    const rateOfReturn_type&
    rateOfReturn () const;

    rateOfReturn_type&
    rateOfReturn ();

    void
    rateOfReturn (const rateOfReturn_type& x);

    void
    rateOfReturn (::std::auto_ptr< rateOfReturn_type > p);

    // notional
    // 
    typedef ::FpML_4_2::ReturnSwapNotional notional_type;
    typedef ::xsd::cxx::tree::traits< notional_type, char > notional_traits;

    const notional_type&
    notional () const;

    notional_type&
    notional ();

    void
    notional (const notional_type& x);

    void
    notional (::std::auto_ptr< notional_type > p);

    // amount
    // 
    typedef ::FpML_4_2::ReturnSwapAmount amount_type;
    typedef ::xsd::cxx::tree::traits< amount_type, char > amount_traits;

    const amount_type&
    amount () const;

    amount_type&
    amount ();

    void
    amount (const amount_type& x);

    void
    amount (::std::auto_ptr< amount_type > p);

    // return
    // 
    typedef ::FpML_4_2::Return return_type;
    typedef ::xsd::cxx::tree::traits< return_type, char > return_traits;

    const return_type&
    return_ () const;

    return_type&
    return_ ();

    void
    return_ (const return_type& x);

    void
    return_ (::std::auto_ptr< return_type > p);

    // notionalAdjustments
    // 
    typedef ::FpML_4_2::NotionalAdjustmentEnum notionalAdjustments_type;
    typedef ::xsd::cxx::tree::traits< notionalAdjustments_type, char > notionalAdjustments_traits;

    const notionalAdjustments_type&
    notionalAdjustments () const;

    notionalAdjustments_type&
    notionalAdjustments ();

    void
    notionalAdjustments (const notionalAdjustments_type& x);

    void
    notionalAdjustments (::std::auto_ptr< notionalAdjustments_type > p);

    // fxFeature
    // 
    typedef ::FpML_4_2::FxFeature fxFeature_type;
    typedef ::xsd::cxx::tree::optional< fxFeature_type > fxFeature_optional;
    typedef ::xsd::cxx::tree::traits< fxFeature_type, char > fxFeature_traits;

    const fxFeature_optional&
    fxFeature () const;

    fxFeature_optional&
    fxFeature ();

    void
    fxFeature (const fxFeature_type& x);

    void
    fxFeature (const fxFeature_optional& x);

    void
    fxFeature (::std::auto_ptr< fxFeature_type > p);

    // Constructors.
    //
    ReturnLeg (const payerPartyReference_type&,
               const receiverPartyReference_type&,
               const effectiveDate_type&,
               const terminationDate_type&,
               const underlyer_type&,
               const rateOfReturn_type&,
               const notional_type&,
               const amount_type&,
               const return_type&,
               const notionalAdjustments_type&);

    ReturnLeg (::std::auto_ptr< payerPartyReference_type >&,
               ::std::auto_ptr< receiverPartyReference_type >&,
               ::std::auto_ptr< effectiveDate_type >&,
               ::std::auto_ptr< terminationDate_type >&,
               ::std::auto_ptr< underlyer_type >&,
               ::std::auto_ptr< rateOfReturn_type >&,
               ::std::auto_ptr< notional_type >&,
               ::std::auto_ptr< amount_type >&,
               ::std::auto_ptr< return_type >&,
               const notionalAdjustments_type&);

    ReturnLeg (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    ReturnLeg (const ReturnLeg& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual ReturnLeg*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReturnLeg ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< effectiveDate_type > effectiveDate_;
    ::xsd::cxx::tree::one< terminationDate_type > terminationDate_;
    ::xsd::cxx::tree::one< underlyer_type > underlyer_;
    ::xsd::cxx::tree::one< rateOfReturn_type > rateOfReturn_;
    ::xsd::cxx::tree::one< notional_type > notional_;
    ::xsd::cxx::tree::one< amount_type > amount_;
    ::xsd::cxx::tree::one< return_type > return__;
    ::xsd::cxx::tree::one< notionalAdjustments_type > notionalAdjustments_;
    fxFeature_optional fxFeature_;
  };

  class ReturnLegValuation: public ::xml_schema::type
  {
    public:
    // initialPrice
    // 
    typedef ::FpML_4_2::ReturnLegValuationPrice initialPrice_type;
    typedef ::xsd::cxx::tree::traits< initialPrice_type, char > initialPrice_traits;

    const initialPrice_type&
    initialPrice () const;

    initialPrice_type&
    initialPrice ();

    void
    initialPrice (const initialPrice_type& x);

    void
    initialPrice (::std::auto_ptr< initialPrice_type > p);

    // notionalReset
    // 
    typedef ::xml_schema::boolean notionalReset_type;
    typedef ::xsd::cxx::tree::traits< notionalReset_type, char > notionalReset_traits;

    const notionalReset_type&
    notionalReset () const;

    notionalReset_type&
    notionalReset ();

    void
    notionalReset (const notionalReset_type& x);

    // valuationPriceInterim
    // 
    typedef ::FpML_4_2::ReturnLegValuationPrice valuationPriceInterim_type;
    typedef ::xsd::cxx::tree::optional< valuationPriceInterim_type > valuationPriceInterim_optional;
    typedef ::xsd::cxx::tree::traits< valuationPriceInterim_type, char > valuationPriceInterim_traits;

    const valuationPriceInterim_optional&
    valuationPriceInterim () const;

    valuationPriceInterim_optional&
    valuationPriceInterim ();

    void
    valuationPriceInterim (const valuationPriceInterim_type& x);

    void
    valuationPriceInterim (const valuationPriceInterim_optional& x);

    void
    valuationPriceInterim (::std::auto_ptr< valuationPriceInterim_type > p);

    // valuationPriceFinal
    // 
    typedef ::FpML_4_2::ReturnLegValuationPrice valuationPriceFinal_type;
    typedef ::xsd::cxx::tree::traits< valuationPriceFinal_type, char > valuationPriceFinal_traits;

    const valuationPriceFinal_type&
    valuationPriceFinal () const;

    valuationPriceFinal_type&
    valuationPriceFinal ();

    void
    valuationPriceFinal (const valuationPriceFinal_type& x);

    void
    valuationPriceFinal (::std::auto_ptr< valuationPriceFinal_type > p);

    // paymentDates
    // 
    typedef ::FpML_4_2::ReturnSwapPaymentDates paymentDates_type;
    typedef ::xsd::cxx::tree::traits< paymentDates_type, char > paymentDates_traits;

    const paymentDates_type&
    paymentDates () const;

    paymentDates_type&
    paymentDates ();

    void
    paymentDates (const paymentDates_type& x);

    void
    paymentDates (::std::auto_ptr< paymentDates_type > p);

    // Constructors.
    //
    ReturnLegValuation (const initialPrice_type&,
                        const notionalReset_type&,
                        const valuationPriceFinal_type&,
                        const paymentDates_type&);

    ReturnLegValuation (::std::auto_ptr< initialPrice_type >&,
                        const notionalReset_type&,
                        ::std::auto_ptr< valuationPriceFinal_type >&,
                        ::std::auto_ptr< paymentDates_type >&);

    ReturnLegValuation (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    ReturnLegValuation (const ReturnLegValuation& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual ReturnLegValuation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReturnLegValuation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< initialPrice_type > initialPrice_;
    ::xsd::cxx::tree::one< notionalReset_type > notionalReset_;
    valuationPriceInterim_optional valuationPriceInterim_;
    ::xsd::cxx::tree::one< valuationPriceFinal_type > valuationPriceFinal_;
    ::xsd::cxx::tree::one< paymentDates_type > paymentDates_;
  };

  class ReturnLegValuationPrice: public ::FpML_4_2::Price
  {
    public:
    // valuationRules
    // 
    typedef ::FpML_4_2::EquityValuation valuationRules_type;
    typedef ::xsd::cxx::tree::optional< valuationRules_type > valuationRules_optional;
    typedef ::xsd::cxx::tree::traits< valuationRules_type, char > valuationRules_traits;

    const valuationRules_optional&
    valuationRules () const;

    valuationRules_optional&
    valuationRules ();

    void
    valuationRules (const valuationRules_type& x);

    void
    valuationRules (const valuationRules_optional& x);

    void
    valuationRules (::std::auto_ptr< valuationRules_type > p);

    // Constructors.
    //
    ReturnLegValuationPrice ();

    ReturnLegValuationPrice (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    ReturnLegValuationPrice (const ReturnLegValuationPrice& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual ReturnLegValuationPrice*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReturnLegValuationPrice ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    valuationRules_optional valuationRules_;
  };

  class ReturnSwapBase: public ::FpML_4_2::Product
  {
    public:
    // buyerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference buyerPartyReference_type;
    typedef ::xsd::cxx::tree::optional< buyerPartyReference_type > buyerPartyReference_optional;
    typedef ::xsd::cxx::tree::traits< buyerPartyReference_type, char > buyerPartyReference_traits;

    const buyerPartyReference_optional&
    buyerPartyReference () const;

    buyerPartyReference_optional&
    buyerPartyReference ();

    void
    buyerPartyReference (const buyerPartyReference_type& x);

    void
    buyerPartyReference (const buyerPartyReference_optional& x);

    void
    buyerPartyReference (::std::auto_ptr< buyerPartyReference_type > p);

    // sellerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference sellerPartyReference_type;
    typedef ::xsd::cxx::tree::optional< sellerPartyReference_type > sellerPartyReference_optional;
    typedef ::xsd::cxx::tree::traits< sellerPartyReference_type, char > sellerPartyReference_traits;

    const sellerPartyReference_optional&
    sellerPartyReference () const;

    sellerPartyReference_optional&
    sellerPartyReference ();

    void
    sellerPartyReference (const sellerPartyReference_type& x);

    void
    sellerPartyReference (const sellerPartyReference_optional& x);

    void
    sellerPartyReference (::std::auto_ptr< sellerPartyReference_type > p);

    // returnSwapLeg
    // 
    typedef ::FpML_4_2::ReturnSwapLeg returnSwapLeg_type;
    typedef ::xsd::cxx::tree::sequence< returnSwapLeg_type > returnSwapLeg_sequence;
    typedef returnSwapLeg_sequence::iterator returnSwapLeg_iterator;
    typedef returnSwapLeg_sequence::const_iterator returnSwapLeg_const_iterator;
    typedef ::xsd::cxx::tree::traits< returnSwapLeg_type, char > returnSwapLeg_traits;

    const returnSwapLeg_sequence&
    returnSwapLeg () const;

    returnSwapLeg_sequence&
    returnSwapLeg ();

    void
    returnSwapLeg (const returnSwapLeg_sequence& s);

    // Constructors.
    //
    ReturnSwapBase ();

    ReturnSwapBase (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ReturnSwapBase (const ReturnSwapBase& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ReturnSwapBase*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReturnSwapBase ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    buyerPartyReference_optional buyerPartyReference_;
    sellerPartyReference_optional sellerPartyReference_;
    returnSwapLeg_sequence returnSwapLeg_;
  };

  class ReturnSwap: public ::FpML_4_2::ReturnSwapBase
  {
    public:
    // principalExchangeFeatures
    // 
    typedef ::FpML_4_2::PrincipalExchangeFeatures principalExchangeFeatures_type;
    typedef ::xsd::cxx::tree::optional< principalExchangeFeatures_type > principalExchangeFeatures_optional;
    typedef ::xsd::cxx::tree::traits< principalExchangeFeatures_type, char > principalExchangeFeatures_traits;

    const principalExchangeFeatures_optional&
    principalExchangeFeatures () const;

    principalExchangeFeatures_optional&
    principalExchangeFeatures ();

    void
    principalExchangeFeatures (const principalExchangeFeatures_type& x);

    void
    principalExchangeFeatures (const principalExchangeFeatures_optional& x);

    void
    principalExchangeFeatures (::std::auto_ptr< principalExchangeFeatures_type > p);

    // additionalPayment
    // 
    typedef ::FpML_4_2::ReturnSwapAdditionalPayment additionalPayment_type;
    typedef ::xsd::cxx::tree::sequence< additionalPayment_type > additionalPayment_sequence;
    typedef additionalPayment_sequence::iterator additionalPayment_iterator;
    typedef additionalPayment_sequence::const_iterator additionalPayment_const_iterator;
    typedef ::xsd::cxx::tree::traits< additionalPayment_type, char > additionalPayment_traits;

    const additionalPayment_sequence&
    additionalPayment () const;

    additionalPayment_sequence&
    additionalPayment ();

    void
    additionalPayment (const additionalPayment_sequence& s);

    // earlyTermination
    // 
    typedef ::FpML_4_2::ReturnSwapEarlyTermination earlyTermination_type;
    typedef ::xsd::cxx::tree::sequence< earlyTermination_type > earlyTermination_sequence;
    typedef earlyTermination_sequence::iterator earlyTermination_iterator;
    typedef earlyTermination_sequence::const_iterator earlyTermination_const_iterator;
    typedef ::xsd::cxx::tree::traits< earlyTermination_type, char > earlyTermination_traits;

    const earlyTermination_sequence&
    earlyTermination () const;

    earlyTermination_sequence&
    earlyTermination ();

    void
    earlyTermination (const earlyTermination_sequence& s);

    // extraordinaryEvents
    // 
    typedef ::FpML_4_2::ExtraordinaryEvents extraordinaryEvents_type;
    typedef ::xsd::cxx::tree::optional< extraordinaryEvents_type > extraordinaryEvents_optional;
    typedef ::xsd::cxx::tree::traits< extraordinaryEvents_type, char > extraordinaryEvents_traits;

    const extraordinaryEvents_optional&
    extraordinaryEvents () const;

    extraordinaryEvents_optional&
    extraordinaryEvents ();

    void
    extraordinaryEvents (const extraordinaryEvents_type& x);

    void
    extraordinaryEvents (const extraordinaryEvents_optional& x);

    void
    extraordinaryEvents (::std::auto_ptr< extraordinaryEvents_type > p);

    // Constructors.
    //
    ReturnSwap ();

    ReturnSwap (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    ReturnSwap (const ReturnSwap& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual ReturnSwap*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReturnSwap ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    principalExchangeFeatures_optional principalExchangeFeatures_;
    additionalPayment_sequence additionalPayment_;
    earlyTermination_sequence earlyTermination_;
    extraordinaryEvents_optional extraordinaryEvents_;
  };

  class ReturnSwapAdditionalPayment: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // additionalPaymentAmount
    // 
    typedef ::FpML_4_2::AdditionalPaymentAmount additionalPaymentAmount_type;
    typedef ::xsd::cxx::tree::traits< additionalPaymentAmount_type, char > additionalPaymentAmount_traits;

    const additionalPaymentAmount_type&
    additionalPaymentAmount () const;

    additionalPaymentAmount_type&
    additionalPaymentAmount ();

    void
    additionalPaymentAmount (const additionalPaymentAmount_type& x);

    void
    additionalPaymentAmount (::std::auto_ptr< additionalPaymentAmount_type > p);

    // additionalPaymentDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate additionalPaymentDate_type;
    typedef ::xsd::cxx::tree::traits< additionalPaymentDate_type, char > additionalPaymentDate_traits;

    const additionalPaymentDate_type&
    additionalPaymentDate () const;

    additionalPaymentDate_type&
    additionalPaymentDate ();

    void
    additionalPaymentDate (const additionalPaymentDate_type& x);

    void
    additionalPaymentDate (::std::auto_ptr< additionalPaymentDate_type > p);

    // paymentType
    // 
    typedef ::FpML_4_2::PaymentType paymentType_type;
    typedef ::xsd::cxx::tree::optional< paymentType_type > paymentType_optional;
    typedef ::xsd::cxx::tree::traits< paymentType_type, char > paymentType_traits;

    const paymentType_optional&
    paymentType () const;

    paymentType_optional&
    paymentType ();

    void
    paymentType (const paymentType_type& x);

    void
    paymentType (const paymentType_optional& x);

    void
    paymentType (::std::auto_ptr< paymentType_type > p);

    // Constructors.
    //
    ReturnSwapAdditionalPayment (const payerPartyReference_type&,
                                 const receiverPartyReference_type&,
                                 const additionalPaymentAmount_type&,
                                 const additionalPaymentDate_type&);

    ReturnSwapAdditionalPayment (::std::auto_ptr< payerPartyReference_type >&,
                                 ::std::auto_ptr< receiverPartyReference_type >&,
                                 ::std::auto_ptr< additionalPaymentAmount_type >&,
                                 ::std::auto_ptr< additionalPaymentDate_type >&);

    ReturnSwapAdditionalPayment (const ::xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    ReturnSwapAdditionalPayment (const ReturnSwapAdditionalPayment& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual ReturnSwapAdditionalPayment*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReturnSwapAdditionalPayment ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    ::xsd::cxx::tree::one< additionalPaymentAmount_type > additionalPaymentAmount_;
    ::xsd::cxx::tree::one< additionalPaymentDate_type > additionalPaymentDate_;
    paymentType_optional paymentType_;
  };

  class ReturnSwapAmount: public ::FpML_4_2::LegAmount
  {
    public:
    // cashSettlement
    // 
    typedef ::xml_schema::boolean cashSettlement_type;
    typedef ::xsd::cxx::tree::traits< cashSettlement_type, char > cashSettlement_traits;

    const cashSettlement_type&
    cashSettlement () const;

    cashSettlement_type&
    cashSettlement ();

    void
    cashSettlement (const cashSettlement_type& x);

    // optionsExchangeDividends
    // 
    typedef ::xml_schema::boolean optionsExchangeDividends_type;
    typedef ::xsd::cxx::tree::optional< optionsExchangeDividends_type > optionsExchangeDividends_optional;
    typedef ::xsd::cxx::tree::traits< optionsExchangeDividends_type, char > optionsExchangeDividends_traits;

    const optionsExchangeDividends_optional&
    optionsExchangeDividends () const;

    optionsExchangeDividends_optional&
    optionsExchangeDividends ();

    void
    optionsExchangeDividends (const optionsExchangeDividends_type& x);

    void
    optionsExchangeDividends (const optionsExchangeDividends_optional& x);

    // additionalDividends
    // 
    typedef ::xml_schema::boolean additionalDividends_type;
    typedef ::xsd::cxx::tree::optional< additionalDividends_type > additionalDividends_optional;
    typedef ::xsd::cxx::tree::traits< additionalDividends_type, char > additionalDividends_traits;

    const additionalDividends_optional&
    additionalDividends () const;

    additionalDividends_optional&
    additionalDividends ();

    void
    additionalDividends (const additionalDividends_type& x);

    void
    additionalDividends (const additionalDividends_optional& x);

    // Constructors.
    //
    ReturnSwapAmount (const cashSettlement_type&);

    ReturnSwapAmount (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    ReturnSwapAmount (const ReturnSwapAmount& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual ReturnSwapAmount*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReturnSwapAmount ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< cashSettlement_type > cashSettlement_;
    optionsExchangeDividends_optional optionsExchangeDividends_;
    additionalDividends_optional additionalDividends_;
  };

  class ReturnSwapEarlyTermination: public ::xml_schema::type
  {
    public:
    // partyReference
    // 
    typedef ::FpML_4_2::PartyReference partyReference_type;
    typedef ::xsd::cxx::tree::traits< partyReference_type, char > partyReference_traits;

    const partyReference_type&
    partyReference () const;

    partyReference_type&
    partyReference ();

    void
    partyReference (const partyReference_type& x);

    void
    partyReference (::std::auto_ptr< partyReference_type > p);

    // startingDate
    // 
    typedef ::FpML_4_2::StartingDate startingDate_type;
    typedef ::xsd::cxx::tree::traits< startingDate_type, char > startingDate_traits;

    const startingDate_type&
    startingDate () const;

    startingDate_type&
    startingDate ();

    void
    startingDate (const startingDate_type& x);

    void
    startingDate (::std::auto_ptr< startingDate_type > p);

    // Constructors.
    //
    ReturnSwapEarlyTermination (const partyReference_type&,
                                const startingDate_type&);

    ReturnSwapEarlyTermination (::std::auto_ptr< partyReference_type >&,
                                ::std::auto_ptr< startingDate_type >&);

    ReturnSwapEarlyTermination (const ::xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    ReturnSwapEarlyTermination (const ReturnSwapEarlyTermination& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual ReturnSwapEarlyTermination*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReturnSwapEarlyTermination ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partyReference_type > partyReference_;
    ::xsd::cxx::tree::one< startingDate_type > startingDate_;
  };

  class ReturnSwapNotional: public ::xml_schema::type
  {
    public:
    // determinationMethod
    // 
    typedef ::FpML_4_2::DeterminationMethod determinationMethod_type;
    typedef ::xsd::cxx::tree::optional< determinationMethod_type > determinationMethod_optional;
    typedef ::xsd::cxx::tree::traits< determinationMethod_type, char > determinationMethod_traits;

    const determinationMethod_optional&
    determinationMethod () const;

    determinationMethod_optional&
    determinationMethod ();

    void
    determinationMethod (const determinationMethod_type& x);

    void
    determinationMethod (const determinationMethod_optional& x);

    void
    determinationMethod (::std::auto_ptr< determinationMethod_type > p);

    // notionalAmount
    // 
    typedef ::FpML_4_2::Money notionalAmount_type;
    typedef ::xsd::cxx::tree::optional< notionalAmount_type > notionalAmount_optional;
    typedef ::xsd::cxx::tree::traits< notionalAmount_type, char > notionalAmount_traits;

    const notionalAmount_optional&
    notionalAmount () const;

    notionalAmount_optional&
    notionalAmount ();

    void
    notionalAmount (const notionalAmount_type& x);

    void
    notionalAmount (const notionalAmount_optional& x);

    void
    notionalAmount (::std::auto_ptr< notionalAmount_type > p);

    // amountRelativeTo
    // 
    typedef ::FpML_4_2::AmountReference amountRelativeTo_type;
    typedef ::xsd::cxx::tree::optional< amountRelativeTo_type > amountRelativeTo_optional;
    typedef ::xsd::cxx::tree::traits< amountRelativeTo_type, char > amountRelativeTo_traits;

    const amountRelativeTo_optional&
    amountRelativeTo () const;

    amountRelativeTo_optional&
    amountRelativeTo ();

    void
    amountRelativeTo (const amountRelativeTo_type& x);

    void
    amountRelativeTo (const amountRelativeTo_optional& x);

    void
    amountRelativeTo (::std::auto_ptr< amountRelativeTo_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    ReturnSwapNotional ();

    ReturnSwapNotional (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    ReturnSwapNotional (const ReturnSwapNotional& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual ReturnSwapNotional*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReturnSwapNotional ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    determinationMethod_optional determinationMethod_;
    notionalAmount_optional notionalAmount_;
    amountRelativeTo_optional amountRelativeTo_;
    id_optional id_;
  };

  class ReturnSwapPaymentDates: public ::xml_schema::type
  {
    public:
    // paymentDatesInterim
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDates paymentDatesInterim_type;
    typedef ::xsd::cxx::tree::optional< paymentDatesInterim_type > paymentDatesInterim_optional;
    typedef ::xsd::cxx::tree::traits< paymentDatesInterim_type, char > paymentDatesInterim_traits;

    const paymentDatesInterim_optional&
    paymentDatesInterim () const;

    paymentDatesInterim_optional&
    paymentDatesInterim ();

    void
    paymentDatesInterim (const paymentDatesInterim_type& x);

    void
    paymentDatesInterim (const paymentDatesInterim_optional& x);

    void
    paymentDatesInterim (::std::auto_ptr< paymentDatesInterim_type > p);

    // paymentDateFinal
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate paymentDateFinal_type;
    typedef ::xsd::cxx::tree::traits< paymentDateFinal_type, char > paymentDateFinal_traits;

    const paymentDateFinal_type&
    paymentDateFinal () const;

    paymentDateFinal_type&
    paymentDateFinal ();

    void
    paymentDateFinal (const paymentDateFinal_type& x);

    void
    paymentDateFinal (::std::auto_ptr< paymentDateFinal_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    ReturnSwapPaymentDates (const paymentDateFinal_type&);

    ReturnSwapPaymentDates (::std::auto_ptr< paymentDateFinal_type >&);

    ReturnSwapPaymentDates (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    ReturnSwapPaymentDates (const ReturnSwapPaymentDates& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual ReturnSwapPaymentDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReturnSwapPaymentDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    paymentDatesInterim_optional paymentDatesInterim_;
    ::xsd::cxx::tree::one< paymentDateFinal_type > paymentDateFinal_;
    id_optional id_;
  };

  class StartingDate: public ::xml_schema::type
  {
    public:
    // dateRelativeTo
    // 
    typedef ::FpML_4_2::DateReference dateRelativeTo_type;
    typedef ::xsd::cxx::tree::optional< dateRelativeTo_type > dateRelativeTo_optional;
    typedef ::xsd::cxx::tree::traits< dateRelativeTo_type, char > dateRelativeTo_traits;

    const dateRelativeTo_optional&
    dateRelativeTo () const;

    dateRelativeTo_optional&
    dateRelativeTo ();

    void
    dateRelativeTo (const dateRelativeTo_type& x);

    void
    dateRelativeTo (const dateRelativeTo_optional& x);

    void
    dateRelativeTo (::std::auto_ptr< dateRelativeTo_type > p);

    // adjustableDate
    // 
    typedef ::FpML_4_2::AdjustableDate adjustableDate_type;
    typedef ::xsd::cxx::tree::optional< adjustableDate_type > adjustableDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustableDate_type, char > adjustableDate_traits;

    const adjustableDate_optional&
    adjustableDate () const;

    adjustableDate_optional&
    adjustableDate ();

    void
    adjustableDate (const adjustableDate_type& x);

    void
    adjustableDate (const adjustableDate_optional& x);

    void
    adjustableDate (::std::auto_ptr< adjustableDate_type > p);

    // Constructors.
    //
    StartingDate ();

    StartingDate (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    StartingDate (const StartingDate& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual StartingDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~StartingDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    dateRelativeTo_optional dateRelativeTo_;
    adjustableDate_optional adjustableDate_;
  };

  class StubCalculationPeriod: public ::xml_schema::type
  {
    public:
    // initialStub
    // 
    typedef ::FpML_4_2::Stub initialStub_type;
    typedef ::xsd::cxx::tree::optional< initialStub_type > initialStub_optional;
    typedef ::xsd::cxx::tree::traits< initialStub_type, char > initialStub_traits;

    const initialStub_optional&
    initialStub () const;

    initialStub_optional&
    initialStub ();

    void
    initialStub (const initialStub_type& x);

    void
    initialStub (const initialStub_optional& x);

    void
    initialStub (::std::auto_ptr< initialStub_type > p);

    // finalStub
    // 
    typedef ::FpML_4_2::Stub finalStub_type;
    typedef ::xsd::cxx::tree::optional< finalStub_type > finalStub_optional;
    typedef ::xsd::cxx::tree::traits< finalStub_type, char > finalStub_traits;

    const finalStub_optional&
    finalStub () const;

    finalStub_optional&
    finalStub ();

    void
    finalStub (const finalStub_type& x);

    void
    finalStub (const finalStub_optional& x);

    void
    finalStub (::std::auto_ptr< finalStub_type > p);

    // Constructors.
    //
    StubCalculationPeriod ();

    StubCalculationPeriod (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    StubCalculationPeriod (const StubCalculationPeriod& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual StubCalculationPeriod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~StubCalculationPeriod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    initialStub_optional initialStub_;
    finalStub_optional finalStub_;
  };

  class Trigger: public ::xml_schema::type
  {
    public:
    // level
    // 
    typedef ::xml_schema::decimal level_type;
    typedef ::xsd::cxx::tree::optional< level_type > level_optional;
    typedef ::xsd::cxx::tree::traits< level_type, char, ::xsd::cxx::tree::schema_type::decimal > level_traits;

    const level_optional&
    level () const;

    level_optional&
    level ();

    void
    level (const level_type& x);

    void
    level (const level_optional& x);

    // levelPercentage
    // 
    typedef ::xml_schema::decimal levelPercentage_type;
    typedef ::xsd::cxx::tree::optional< levelPercentage_type > levelPercentage_optional;
    typedef ::xsd::cxx::tree::traits< levelPercentage_type, char, ::xsd::cxx::tree::schema_type::decimal > levelPercentage_traits;

    const levelPercentage_optional&
    levelPercentage () const;

    levelPercentage_optional&
    levelPercentage ();

    void
    levelPercentage (const levelPercentage_type& x);

    void
    levelPercentage (const levelPercentage_optional& x);

    // Constructors.
    //
    Trigger ();

    Trigger (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Trigger (const Trigger& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Trigger*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Trigger ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    level_optional level_;
    levelPercentage_optional levelPercentage_;
  };

  class TriggerEvent: public ::xml_schema::type
  {
    public:
    // schedule
    // 
    typedef ::FpML_4_2::EquitySchedule schedule_type;
    typedef ::xsd::cxx::tree::sequence< schedule_type > schedule_sequence;
    typedef schedule_sequence::iterator schedule_iterator;
    typedef schedule_sequence::const_iterator schedule_const_iterator;
    typedef ::xsd::cxx::tree::traits< schedule_type, char > schedule_traits;

    const schedule_sequence&
    schedule () const;

    schedule_sequence&
    schedule ();

    void
    schedule (const schedule_sequence& s);

    // triggerDates
    // 
    typedef ::FpML_4_2::DateList triggerDates_type;
    typedef ::xsd::cxx::tree::optional< triggerDates_type > triggerDates_optional;
    typedef ::xsd::cxx::tree::traits< triggerDates_type, char > triggerDates_traits;

    const triggerDates_optional&
    triggerDates () const;

    triggerDates_optional&
    triggerDates ();

    void
    triggerDates (const triggerDates_type& x);

    void
    triggerDates (const triggerDates_optional& x);

    void
    triggerDates (::std::auto_ptr< triggerDates_type > p);

    // trigger
    // 
    typedef ::FpML_4_2::Trigger trigger_type;
    typedef ::xsd::cxx::tree::traits< trigger_type, char > trigger_traits;

    const trigger_type&
    trigger () const;

    trigger_type&
    trigger ();

    void
    trigger (const trigger_type& x);

    void
    trigger (::std::auto_ptr< trigger_type > p);

    // featurePayment
    // 
    typedef ::FpML_4_2::FeaturePayment featurePayment_type;
    typedef ::xsd::cxx::tree::optional< featurePayment_type > featurePayment_optional;
    typedef ::xsd::cxx::tree::traits< featurePayment_type, char > featurePayment_traits;

    const featurePayment_optional&
    featurePayment () const;

    featurePayment_optional&
    featurePayment ();

    void
    featurePayment (const featurePayment_type& x);

    void
    featurePayment (const featurePayment_optional& x);

    void
    featurePayment (::std::auto_ptr< featurePayment_type > p);

    // Constructors.
    //
    TriggerEvent (const trigger_type&);

    TriggerEvent (::std::auto_ptr< trigger_type >&);

    TriggerEvent (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    TriggerEvent (const TriggerEvent& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual TriggerEvent*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TriggerEvent ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    schedule_sequence schedule_;
    triggerDates_optional triggerDates_;
    ::xsd::cxx::tree::one< trigger_type > trigger_;
    featurePayment_optional featurePayment_;
  };

  class Variance: public ::xml_schema::type
  {
    public:
    // initialLevel
    // 
    typedef ::xml_schema::decimal initialLevel_type;
    typedef ::xsd::cxx::tree::optional< initialLevel_type > initialLevel_optional;
    typedef ::xsd::cxx::tree::traits< initialLevel_type, char, ::xsd::cxx::tree::schema_type::decimal > initialLevel_traits;

    const initialLevel_optional&
    initialLevel () const;

    initialLevel_optional&
    initialLevel ();

    void
    initialLevel (const initialLevel_type& x);

    void
    initialLevel (const initialLevel_optional& x);

    // closingLevel
    // 
    typedef ::xml_schema::boolean closingLevel_type;
    typedef ::xsd::cxx::tree::optional< closingLevel_type > closingLevel_optional;
    typedef ::xsd::cxx::tree::traits< closingLevel_type, char > closingLevel_traits;

    const closingLevel_optional&
    closingLevel () const;

    closingLevel_optional&
    closingLevel ();

    void
    closingLevel (const closingLevel_type& x);

    void
    closingLevel (const closingLevel_optional& x);

    // expiringLevel
    // 
    typedef ::xml_schema::boolean expiringLevel_type;
    typedef ::xsd::cxx::tree::optional< expiringLevel_type > expiringLevel_optional;
    typedef ::xsd::cxx::tree::traits< expiringLevel_type, char > expiringLevel_traits;

    const expiringLevel_optional&
    expiringLevel () const;

    expiringLevel_optional&
    expiringLevel ();

    void
    expiringLevel (const expiringLevel_type& x);

    void
    expiringLevel (const expiringLevel_optional& x);

    // varianceAmount
    // 
    typedef ::FpML_4_2::Money varianceAmount_type;
    typedef ::xsd::cxx::tree::traits< varianceAmount_type, char > varianceAmount_traits;

    const varianceAmount_type&
    varianceAmount () const;

    varianceAmount_type&
    varianceAmount ();

    void
    varianceAmount (const varianceAmount_type& x);

    void
    varianceAmount (::std::auto_ptr< varianceAmount_type > p);

    // volatilityStrikePrice
    // 
    typedef ::xml_schema::decimal volatilityStrikePrice_type;
    typedef ::xsd::cxx::tree::optional< volatilityStrikePrice_type > volatilityStrikePrice_optional;
    typedef ::xsd::cxx::tree::traits< volatilityStrikePrice_type, char, ::xsd::cxx::tree::schema_type::decimal > volatilityStrikePrice_traits;

    const volatilityStrikePrice_optional&
    volatilityStrikePrice () const;

    volatilityStrikePrice_optional&
    volatilityStrikePrice ();

    void
    volatilityStrikePrice (const volatilityStrikePrice_type& x);

    void
    volatilityStrikePrice (const volatilityStrikePrice_optional& x);

    // varianceStrikePrice
    // 
    typedef ::xml_schema::decimal varianceStrikePrice_type;
    typedef ::xsd::cxx::tree::optional< varianceStrikePrice_type > varianceStrikePrice_optional;
    typedef ::xsd::cxx::tree::traits< varianceStrikePrice_type, char, ::xsd::cxx::tree::schema_type::decimal > varianceStrikePrice_traits;

    const varianceStrikePrice_optional&
    varianceStrikePrice () const;

    varianceStrikePrice_optional&
    varianceStrikePrice ();

    void
    varianceStrikePrice (const varianceStrikePrice_type& x);

    void
    varianceStrikePrice (const varianceStrikePrice_optional& x);

    // expectedN
    // 
    typedef ::xml_schema::integer expectedN_type;
    typedef ::xsd::cxx::tree::optional< expectedN_type > expectedN_optional;
    typedef ::xsd::cxx::tree::traits< expectedN_type, char > expectedN_traits;

    const expectedN_optional&
    expectedN () const;

    expectedN_optional&
    expectedN ();

    void
    expectedN (const expectedN_type& x);

    void
    expectedN (const expectedN_optional& x);

    // varianceCap
    // 
    typedef ::xml_schema::boolean varianceCap_type;
    typedef ::xsd::cxx::tree::optional< varianceCap_type > varianceCap_optional;
    typedef ::xsd::cxx::tree::traits< varianceCap_type, char > varianceCap_traits;

    const varianceCap_optional&
    varianceCap () const;

    varianceCap_optional&
    varianceCap ();

    void
    varianceCap (const varianceCap_type& x);

    void
    varianceCap (const varianceCap_optional& x);

    // unadjustedVarianceCap
    // 
    typedef ::xml_schema::decimal unadjustedVarianceCap_type;
    typedef ::xsd::cxx::tree::optional< unadjustedVarianceCap_type > unadjustedVarianceCap_optional;
    typedef ::xsd::cxx::tree::traits< unadjustedVarianceCap_type, char, ::xsd::cxx::tree::schema_type::decimal > unadjustedVarianceCap_traits;

    const unadjustedVarianceCap_optional&
    unadjustedVarianceCap () const;

    unadjustedVarianceCap_optional&
    unadjustedVarianceCap ();

    void
    unadjustedVarianceCap (const unadjustedVarianceCap_type& x);

    void
    unadjustedVarianceCap (const unadjustedVarianceCap_optional& x);

    // exchangeTradedContractNearest
    // 
    typedef ::FpML_4_2::ExchangeTradedContract exchangeTradedContractNearest_type;
    typedef ::xsd::cxx::tree::optional< exchangeTradedContractNearest_type > exchangeTradedContractNearest_optional;
    typedef ::xsd::cxx::tree::traits< exchangeTradedContractNearest_type, char > exchangeTradedContractNearest_traits;

    const exchangeTradedContractNearest_optional&
    exchangeTradedContractNearest () const;

    exchangeTradedContractNearest_optional&
    exchangeTradedContractNearest ();

    void
    exchangeTradedContractNearest (const exchangeTradedContractNearest_type& x);

    void
    exchangeTradedContractNearest (const exchangeTradedContractNearest_optional& x);

    void
    exchangeTradedContractNearest (::std::auto_ptr< exchangeTradedContractNearest_type > p);

    // vegaNotionalAmount
    // 
    typedef ::xml_schema::decimal vegaNotionalAmount_type;
    typedef ::xsd::cxx::tree::optional< vegaNotionalAmount_type > vegaNotionalAmount_optional;
    typedef ::xsd::cxx::tree::traits< vegaNotionalAmount_type, char, ::xsd::cxx::tree::schema_type::decimal > vegaNotionalAmount_traits;

    const vegaNotionalAmount_optional&
    vegaNotionalAmount () const;

    vegaNotionalAmount_optional&
    vegaNotionalAmount ();

    void
    vegaNotionalAmount (const vegaNotionalAmount_type& x);

    void
    vegaNotionalAmount (const vegaNotionalAmount_optional& x);

    // fxFeature
    // 
    typedef ::FpML_4_2::FxFeature fxFeature_type;
    typedef ::xsd::cxx::tree::optional< fxFeature_type > fxFeature_optional;
    typedef ::xsd::cxx::tree::traits< fxFeature_type, char > fxFeature_traits;

    const fxFeature_optional&
    fxFeature () const;

    fxFeature_optional&
    fxFeature ();

    void
    fxFeature (const fxFeature_type& x);

    void
    fxFeature (const fxFeature_optional& x);

    void
    fxFeature (::std::auto_ptr< fxFeature_type > p);

    // Constructors.
    //
    Variance (const varianceAmount_type&);

    Variance (::std::auto_ptr< varianceAmount_type >&);

    Variance (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Variance (const Variance& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Variance*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Variance ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    initialLevel_optional initialLevel_;
    closingLevel_optional closingLevel_;
    expiringLevel_optional expiringLevel_;
    ::xsd::cxx::tree::one< varianceAmount_type > varianceAmount_;
    volatilityStrikePrice_optional volatilityStrikePrice_;
    varianceStrikePrice_optional varianceStrikePrice_;
    expectedN_optional expectedN_;
    varianceCap_optional varianceCap_;
    unadjustedVarianceCap_optional unadjustedVarianceCap_;
    exchangeTradedContractNearest_optional exchangeTradedContractNearest_;
    vegaNotionalAmount_optional vegaNotionalAmount_;
    fxFeature_optional fxFeature_;
  };

  class VarianceAmount: public ::FpML_4_2::ReturnSwapAmount
  {
    public:
    // cashSettlementPaymentDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate cashSettlementPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< cashSettlementPaymentDate_type > cashSettlementPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< cashSettlementPaymentDate_type, char > cashSettlementPaymentDate_traits;

    const cashSettlementPaymentDate_optional&
    cashSettlementPaymentDate () const;

    cashSettlementPaymentDate_optional&
    cashSettlementPaymentDate ();

    void
    cashSettlementPaymentDate (const cashSettlementPaymentDate_type& x);

    void
    cashSettlementPaymentDate (const cashSettlementPaymentDate_optional& x);

    void
    cashSettlementPaymentDate (::std::auto_ptr< cashSettlementPaymentDate_type > p);

    // observationStartDate
    // 
    typedef ::FpML_4_2::StartingDate observationStartDate_type;
    typedef ::xsd::cxx::tree::optional< observationStartDate_type > observationStartDate_optional;
    typedef ::xsd::cxx::tree::traits< observationStartDate_type, char > observationStartDate_traits;

    const observationStartDate_optional&
    observationStartDate () const;

    observationStartDate_optional&
    observationStartDate ();

    void
    observationStartDate (const observationStartDate_type& x);

    void
    observationStartDate (const observationStartDate_optional& x);

    void
    observationStartDate (::std::auto_ptr< observationStartDate_type > p);

    // allDividends
    // 
    typedef ::xml_schema::boolean allDividends_type;
    typedef ::xsd::cxx::tree::optional< allDividends_type > allDividends_optional;
    typedef ::xsd::cxx::tree::traits< allDividends_type, char > allDividends_traits;

    const allDividends_optional&
    allDividends () const;

    allDividends_optional&
    allDividends ();

    void
    allDividends (const allDividends_type& x);

    void
    allDividends (const allDividends_optional& x);

    // Constructors.
    //
    VarianceAmount (const cashSettlement_type&);

    VarianceAmount (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    VarianceAmount (const VarianceAmount& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual VarianceAmount*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VarianceAmount ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    cashSettlementPaymentDate_optional cashSettlementPaymentDate_;
    observationStartDate_optional observationStartDate_;
    allDividends_optional allDividends_;
  };

  class VarianceLeg: public ::FpML_4_2::ReturnSwapLeg
  {
    public:
    // underlyer
    // 
    typedef ::FpML_4_2::Underlyer underlyer_type;
    typedef ::xsd::cxx::tree::traits< underlyer_type, char > underlyer_traits;

    const underlyer_type&
    underlyer () const;

    underlyer_type&
    underlyer ();

    void
    underlyer (const underlyer_type& x);

    void
    underlyer (::std::auto_ptr< underlyer_type > p);

    // equityValuation
    // 
    typedef ::FpML_4_2::EquityValuation equityValuation_type;
    typedef ::xsd::cxx::tree::traits< equityValuation_type, char > equityValuation_traits;

    const equityValuation_type&
    equityValuation () const;

    equityValuation_type&
    equityValuation ();

    void
    equityValuation (const equityValuation_type& x);

    void
    equityValuation (::std::auto_ptr< equityValuation_type > p);

    // equityAmount
    // 
    typedef ::FpML_4_2::VarianceAmount equityAmount_type;
    typedef ::xsd::cxx::tree::traits< equityAmount_type, char > equityAmount_traits;

    const equityAmount_type&
    equityAmount () const;

    equityAmount_type&
    equityAmount ();

    void
    equityAmount (const equityAmount_type& x);

    void
    equityAmount (::std::auto_ptr< equityAmount_type > p);

    // Constructors.
    //
    VarianceLeg (const payerPartyReference_type&,
                 const receiverPartyReference_type&,
                 const underlyer_type&,
                 const equityValuation_type&,
                 const equityAmount_type&);

    VarianceLeg (::std::auto_ptr< payerPartyReference_type >&,
                 ::std::auto_ptr< receiverPartyReference_type >&,
                 ::std::auto_ptr< underlyer_type >&,
                 ::std::auto_ptr< equityValuation_type >&,
                 ::std::auto_ptr< equityAmount_type >&);

    VarianceLeg (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    VarianceLeg (const VarianceLeg& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual VarianceLeg*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VarianceLeg ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< underlyer_type > underlyer_;
    ::xsd::cxx::tree::one< equityValuation_type > equityValuation_;
    ::xsd::cxx::tree::one< equityAmount_type > equityAmount_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const AdditionalDisruptionEvents&);

  void
  operator<< (::xercesc::DOMElement&, const AdditionalPaymentAmount&);

  void
  operator<< (::xercesc::DOMElement&, const AdjustableDateOrRelativeDateSequence&);

  void
  operator<< (::xercesc::DOMElement&, const Asian&);

  void
  operator<< (::xercesc::DOMElement&, const AveragingPeriod&);

  void
  operator<< (::xercesc::DOMElement&, const Barrier&);

  void
  operator<< (::xercesc::DOMElement&, const Composite&);

  void
  operator<< (::xercesc::DOMElement&, const Compounding&);

  void
  operator<< (::xercesc::DOMElement&, const CompoundingRate&);

  void
  operator<< (::xercesc::DOMElement&, const EquityCorporateEvents&);

  void
  operator<< (::xercesc::DOMElement&, const EquityPremium&);

  void
  operator<< (::xercesc::DOMElement&, const EquitySchedule&);

  void
  operator<< (::xercesc::DOMElement&, const EquityStrike&);

  void
  operator<< (::xercesc::DOMElement&, const EquityValuation&);

  void
  operator<< (::xercesc::DOMElement&, const ExtraordinaryEvents&);

  void
  operator<< (::xercesc::DOMElement&, const FeaturePayment&);

  void
  operator<< (::xercesc::DOMElement&, const FxFeature&);

  void
  operator<< (::xercesc::DOMElement&, const IndexAdjustmentEvents&);

  void
  operator<< (::xercesc::DOMElement&, const InterestCalculation&);

  void
  operator<< (::xercesc::DOMElement&, const InterestCalculationReference&);

  void
  operator<< (::xercesc::DOMElement&, const ReturnSwapLeg&);

  void
  operator<< (::xercesc::DOMElement&, const InterestLeg&);

  void
  operator<< (::xercesc::DOMElement&, const InterestLegCalculationPeriodDates&);

  void
  operator<< (::xercesc::DOMElement&, const InterestLegCalculationPeriodDatesReference&);

  void
  operator<< (::xercesc::DOMElement&, const InterestLegResetDates&);

  void
  operator<< (::xercesc::DOMElement&, const Knock&);

  void
  operator<< (::xercesc::DOMElement&, const LegAmount&);

  void
  operator<< (::xercesc::DOMElement&, const MakeWholeProvisions&);

  void
  operator<< (::xercesc::DOMElement&, const MarketDisruption&);

  void
  operator<< (::xercesc::DOMElement&, const OptionFeatures&);

  void
  operator<< (::xercesc::DOMElement&, const PassThrough&);

  void
  operator<< (::xercesc::DOMElement&, const PassThroughItem&);

  void
  operator<< (::xercesc::DOMElement&, const PrincipalExchangeAmount&);

  void
  operator<< (::xercesc::DOMElement&, const PrincipalExchangeDescriptions&);

  void
  operator<< (::xercesc::DOMElement&, const PrincipalExchangeFeatures&);

  void
  operator<< (::xercesc::DOMElement&, const Quanto&);

  void
  operator<< (::xercesc::DOMElement&, const Representations&);

  void
  operator<< (::xercesc::DOMElement&, const Return&);

  void
  operator<< (::xercesc::DOMElement&, const ReturnLeg&);

  void
  operator<< (::xercesc::DOMElement&, const ReturnLegValuation&);

  void
  operator<< (::xercesc::DOMElement&, const ReturnLegValuationPrice&);

  void
  operator<< (::xercesc::DOMElement&, const ReturnSwapBase&);

  void
  operator<< (::xercesc::DOMElement&, const ReturnSwap&);

  void
  operator<< (::xercesc::DOMElement&, const ReturnSwapAdditionalPayment&);

  void
  operator<< (::xercesc::DOMElement&, const ReturnSwapAmount&);

  void
  operator<< (::xercesc::DOMElement&, const ReturnSwapEarlyTermination&);

  void
  operator<< (::xercesc::DOMElement&, const ReturnSwapNotional&);

  void
  operator<< (::xercesc::DOMElement&, const ReturnSwapPaymentDates&);

  void
  operator<< (::xercesc::DOMElement&, const StartingDate&);

  void
  operator<< (::xercesc::DOMElement&, const StubCalculationPeriod&);

  void
  operator<< (::xercesc::DOMElement&, const Trigger&);

  void
  operator<< (::xercesc::DOMElement&, const TriggerEvent&);

  void
  operator<< (::xercesc::DOMElement&, const Variance&);

  void
  operator<< (::xercesc::DOMElement&, const VarianceAmount&);

  void
  operator<< (::xercesc::DOMElement&, const VarianceLeg&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_EQ_SHARED_4_2_HXX
