// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_EQD_4_2_HXX
#define FPML_EQD_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class EquityDerivativeBase;
  class EquityDerivativeShortFormBase;
  class BrokerEquityOption;
  class CalendarSpread;
  class EquityAmericanExercise;
  class EquityBermudaExercise;
  class EquityDerivativeLongFormBase;
  class EquityEuropeanExercise;
  class EquityExerciseValuationSettlement;
  class EquityForward;
  class EquityMultipleExercise;
  class EquityOption;
  class EquityOptionTermination;
  class EquityOptionTransactionSupplement;
  class PrePayment;
  class StrategyFeature;
  class StrikeSpread;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-eq-shared-4-2.hxx"

#include "fpml-doc-4-2.hxx"

namespace FpML_4_2
{
  class EquityDerivativeBase: public ::FpML_4_2::Product
  {
    public:
    // buyerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference buyerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< buyerPartyReference_type, char > buyerPartyReference_traits;

    const buyerPartyReference_type&
    buyerPartyReference () const;

    buyerPartyReference_type&
    buyerPartyReference ();

    void
    buyerPartyReference (const buyerPartyReference_type& x);

    void
    buyerPartyReference (::std::auto_ptr< buyerPartyReference_type > p);

    // sellerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference sellerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< sellerPartyReference_type, char > sellerPartyReference_traits;

    const sellerPartyReference_type&
    sellerPartyReference () const;

    sellerPartyReference_type&
    sellerPartyReference ();

    void
    sellerPartyReference (const sellerPartyReference_type& x);

    void
    sellerPartyReference (::std::auto_ptr< sellerPartyReference_type > p);

    // optionType
    // 
    typedef ::FpML_4_2::OptionTypeEnum optionType_type;
    typedef ::xsd::cxx::tree::traits< optionType_type, char > optionType_traits;

    const optionType_type&
    optionType () const;

    optionType_type&
    optionType ();

    void
    optionType (const optionType_type& x);

    void
    optionType (::std::auto_ptr< optionType_type > p);

    // equityEffectiveDate
    // 
    typedef ::xml_schema::date equityEffectiveDate_type;
    typedef ::xsd::cxx::tree::optional< equityEffectiveDate_type > equityEffectiveDate_optional;
    typedef ::xsd::cxx::tree::traits< equityEffectiveDate_type, char > equityEffectiveDate_traits;

    const equityEffectiveDate_optional&
    equityEffectiveDate () const;

    equityEffectiveDate_optional&
    equityEffectiveDate ();

    void
    equityEffectiveDate (const equityEffectiveDate_type& x);

    void
    equityEffectiveDate (const equityEffectiveDate_optional& x);

    void
    equityEffectiveDate (::std::auto_ptr< equityEffectiveDate_type > p);

    // underlyer
    // 
    typedef ::FpML_4_2::Underlyer underlyer_type;
    typedef ::xsd::cxx::tree::traits< underlyer_type, char > underlyer_traits;

    const underlyer_type&
    underlyer () const;

    underlyer_type&
    underlyer ();

    void
    underlyer (const underlyer_type& x);

    void
    underlyer (::std::auto_ptr< underlyer_type > p);

    // notional
    // 
    typedef ::FpML_4_2::Money notional_type;
    typedef ::xsd::cxx::tree::optional< notional_type > notional_optional;
    typedef ::xsd::cxx::tree::traits< notional_type, char > notional_traits;

    const notional_optional&
    notional () const;

    notional_optional&
    notional ();

    void
    notional (const notional_type& x);

    void
    notional (const notional_optional& x);

    void
    notional (::std::auto_ptr< notional_type > p);

    // equityExercise
    // 
    typedef ::FpML_4_2::EquityExerciseValuationSettlement equityExercise_type;
    typedef ::xsd::cxx::tree::traits< equityExercise_type, char > equityExercise_traits;

    const equityExercise_type&
    equityExercise () const;

    equityExercise_type&
    equityExercise ();

    void
    equityExercise (const equityExercise_type& x);

    void
    equityExercise (::std::auto_ptr< equityExercise_type > p);

    // feature
    // 
    typedef ::FpML_4_2::OptionFeatures feature_type;
    typedef ::xsd::cxx::tree::optional< feature_type > feature_optional;
    typedef ::xsd::cxx::tree::traits< feature_type, char > feature_traits;

    const feature_optional&
    feature () const;

    feature_optional&
    feature ();

    void
    feature (const feature_type& x);

    void
    feature (const feature_optional& x);

    void
    feature (::std::auto_ptr< feature_type > p);

    // fxFeature
    // 
    typedef ::FpML_4_2::FxFeature fxFeature_type;
    typedef ::xsd::cxx::tree::optional< fxFeature_type > fxFeature_optional;
    typedef ::xsd::cxx::tree::traits< fxFeature_type, char > fxFeature_traits;

    const fxFeature_optional&
    fxFeature () const;

    fxFeature_optional&
    fxFeature ();

    void
    fxFeature (const fxFeature_type& x);

    void
    fxFeature (const fxFeature_optional& x);

    void
    fxFeature (::std::auto_ptr< fxFeature_type > p);

    // strategyFeature
    // 
    typedef ::FpML_4_2::StrategyFeature strategyFeature_type;
    typedef ::xsd::cxx::tree::optional< strategyFeature_type > strategyFeature_optional;
    typedef ::xsd::cxx::tree::traits< strategyFeature_type, char > strategyFeature_traits;

    const strategyFeature_optional&
    strategyFeature () const;

    strategyFeature_optional&
    strategyFeature ();

    void
    strategyFeature (const strategyFeature_type& x);

    void
    strategyFeature (const strategyFeature_optional& x);

    void
    strategyFeature (::std::auto_ptr< strategyFeature_type > p);

    // Constructors.
    //
    EquityDerivativeBase (const buyerPartyReference_type&,
                          const sellerPartyReference_type&,
                          const optionType_type&,
                          const underlyer_type&,
                          const equityExercise_type&);

    EquityDerivativeBase (::std::auto_ptr< buyerPartyReference_type >&,
                          ::std::auto_ptr< sellerPartyReference_type >&,
                          const optionType_type&,
                          ::std::auto_ptr< underlyer_type >&,
                          ::std::auto_ptr< equityExercise_type >&);

    EquityDerivativeBase (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    EquityDerivativeBase (const EquityDerivativeBase& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual EquityDerivativeBase*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityDerivativeBase ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< buyerPartyReference_type > buyerPartyReference_;
    ::xsd::cxx::tree::one< sellerPartyReference_type > sellerPartyReference_;
    ::xsd::cxx::tree::one< optionType_type > optionType_;
    equityEffectiveDate_optional equityEffectiveDate_;
    ::xsd::cxx::tree::one< underlyer_type > underlyer_;
    notional_optional notional_;
    ::xsd::cxx::tree::one< equityExercise_type > equityExercise_;
    feature_optional feature_;
    fxFeature_optional fxFeature_;
    strategyFeature_optional strategyFeature_;
  };

  class EquityDerivativeShortFormBase: public ::FpML_4_2::EquityDerivativeBase
  {
    public:
    // strike
    // 
    typedef ::FpML_4_2::EquityStrike strike_type;
    typedef ::xsd::cxx::tree::traits< strike_type, char > strike_traits;

    const strike_type&
    strike () const;

    strike_type&
    strike ();

    void
    strike (const strike_type& x);

    void
    strike (::std::auto_ptr< strike_type > p);

    // spotPrice
    // 
    typedef ::xml_schema::decimal spotPrice_type;
    typedef ::xsd::cxx::tree::optional< spotPrice_type > spotPrice_optional;
    typedef ::xsd::cxx::tree::traits< spotPrice_type, char, ::xsd::cxx::tree::schema_type::decimal > spotPrice_traits;

    const spotPrice_optional&
    spotPrice () const;

    spotPrice_optional&
    spotPrice ();

    void
    spotPrice (const spotPrice_type& x);

    void
    spotPrice (const spotPrice_optional& x);

    // numberOfOptions
    // 
    typedef ::xml_schema::decimal numberOfOptions_type;
    typedef ::xsd::cxx::tree::traits< numberOfOptions_type, char, ::xsd::cxx::tree::schema_type::decimal > numberOfOptions_traits;

    const numberOfOptions_type&
    numberOfOptions () const;

    numberOfOptions_type&
    numberOfOptions ();

    void
    numberOfOptions (const numberOfOptions_type& x);

    // equityPremium
    // 
    typedef ::FpML_4_2::EquityPremium equityPremium_type;
    typedef ::xsd::cxx::tree::traits< equityPremium_type, char > equityPremium_traits;

    const equityPremium_type&
    equityPremium () const;

    equityPremium_type&
    equityPremium ();

    void
    equityPremium (const equityPremium_type& x);

    void
    equityPremium (::std::auto_ptr< equityPremium_type > p);

    // Constructors.
    //
    EquityDerivativeShortFormBase (const buyerPartyReference_type&,
                                   const sellerPartyReference_type&,
                                   const optionType_type&,
                                   const underlyer_type&,
                                   const equityExercise_type&,
                                   const strike_type&,
                                   const numberOfOptions_type&,
                                   const equityPremium_type&);

    EquityDerivativeShortFormBase (::std::auto_ptr< buyerPartyReference_type >&,
                                   ::std::auto_ptr< sellerPartyReference_type >&,
                                   const optionType_type&,
                                   ::std::auto_ptr< underlyer_type >&,
                                   ::std::auto_ptr< equityExercise_type >&,
                                   ::std::auto_ptr< strike_type >&,
                                   const numberOfOptions_type&,
                                   ::std::auto_ptr< equityPremium_type >&);

    EquityDerivativeShortFormBase (const ::xercesc::DOMElement& e,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    EquityDerivativeShortFormBase (const EquityDerivativeShortFormBase& x,
                                   ::xml_schema::flags f = 0,
                                   ::xml_schema::container* c = 0);

    virtual EquityDerivativeShortFormBase*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityDerivativeShortFormBase ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< strike_type > strike_;
    spotPrice_optional spotPrice_;
    ::xsd::cxx::tree::one< numberOfOptions_type > numberOfOptions_;
    ::xsd::cxx::tree::one< equityPremium_type > equityPremium_;
  };

  class BrokerEquityOption: public ::FpML_4_2::EquityDerivativeShortFormBase
  {
    public:
    // deltaCrossed
    // 
    typedef ::xml_schema::boolean deltaCrossed_type;
    typedef ::xsd::cxx::tree::traits< deltaCrossed_type, char > deltaCrossed_traits;

    const deltaCrossed_type&
    deltaCrossed () const;

    deltaCrossed_type&
    deltaCrossed ();

    void
    deltaCrossed (const deltaCrossed_type& x);

    // brokerageFee
    // 
    typedef ::FpML_4_2::Money brokerageFee_type;
    typedef ::xsd::cxx::tree::traits< brokerageFee_type, char > brokerageFee_traits;

    const brokerageFee_type&
    brokerageFee () const;

    brokerageFee_type&
    brokerageFee ();

    void
    brokerageFee (const brokerageFee_type& x);

    void
    brokerageFee (::std::auto_ptr< brokerageFee_type > p);

    // brokerNotes
    // 
    typedef ::xml_schema::string brokerNotes_type;
    typedef ::xsd::cxx::tree::traits< brokerNotes_type, char > brokerNotes_traits;

    const brokerNotes_type&
    brokerNotes () const;

    brokerNotes_type&
    brokerNotes ();

    void
    brokerNotes (const brokerNotes_type& x);

    void
    brokerNotes (::std::auto_ptr< brokerNotes_type > p);

    // Constructors.
    //
    BrokerEquityOption (const buyerPartyReference_type&,
                        const sellerPartyReference_type&,
                        const optionType_type&,
                        const underlyer_type&,
                        const equityExercise_type&,
                        const strike_type&,
                        const numberOfOptions_type&,
                        const equityPremium_type&,
                        const deltaCrossed_type&,
                        const brokerageFee_type&,
                        const brokerNotes_type&);

    BrokerEquityOption (::std::auto_ptr< buyerPartyReference_type >&,
                        ::std::auto_ptr< sellerPartyReference_type >&,
                        const optionType_type&,
                        ::std::auto_ptr< underlyer_type >&,
                        ::std::auto_ptr< equityExercise_type >&,
                        ::std::auto_ptr< strike_type >&,
                        const numberOfOptions_type&,
                        ::std::auto_ptr< equityPremium_type >&,
                        const deltaCrossed_type&,
                        ::std::auto_ptr< brokerageFee_type >&,
                        const brokerNotes_type&);

    BrokerEquityOption (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    BrokerEquityOption (const BrokerEquityOption& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual BrokerEquityOption*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BrokerEquityOption ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< deltaCrossed_type > deltaCrossed_;
    ::xsd::cxx::tree::one< brokerageFee_type > brokerageFee_;
    ::xsd::cxx::tree::one< brokerNotes_type > brokerNotes_;
  };

  class CalendarSpread: public ::xml_schema::type
  {
    public:
    // expirationDateTwo
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate expirationDateTwo_type;
    typedef ::xsd::cxx::tree::traits< expirationDateTwo_type, char > expirationDateTwo_traits;

    const expirationDateTwo_type&
    expirationDateTwo () const;

    expirationDateTwo_type&
    expirationDateTwo ();

    void
    expirationDateTwo (const expirationDateTwo_type& x);

    void
    expirationDateTwo (::std::auto_ptr< expirationDateTwo_type > p);

    // Constructors.
    //
    CalendarSpread (const expirationDateTwo_type&);

    CalendarSpread (::std::auto_ptr< expirationDateTwo_type >&);

    CalendarSpread (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    CalendarSpread (const CalendarSpread& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual CalendarSpread*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CalendarSpread ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< expirationDateTwo_type > expirationDateTwo_;
  };

  class EquityAmericanExercise: public ::FpML_4_2::SharedAmericanExercise
  {
    public:
    // latestExerciseTimeType
    // 
    typedef ::FpML_4_2::TimeTypeEnum latestExerciseTimeType_type;
    typedef ::xsd::cxx::tree::optional< latestExerciseTimeType_type > latestExerciseTimeType_optional;
    typedef ::xsd::cxx::tree::traits< latestExerciseTimeType_type, char > latestExerciseTimeType_traits;

    const latestExerciseTimeType_optional&
    latestExerciseTimeType () const;

    latestExerciseTimeType_optional&
    latestExerciseTimeType ();

    void
    latestExerciseTimeType (const latestExerciseTimeType_type& x);

    void
    latestExerciseTimeType (const latestExerciseTimeType_optional& x);

    void
    latestExerciseTimeType (::std::auto_ptr< latestExerciseTimeType_type > p);

    // equityExpirationTimeType
    // 
    typedef ::FpML_4_2::TimeTypeEnum equityExpirationTimeType_type;
    typedef ::xsd::cxx::tree::traits< equityExpirationTimeType_type, char > equityExpirationTimeType_traits;

    const equityExpirationTimeType_type&
    equityExpirationTimeType () const;

    equityExpirationTimeType_type&
    equityExpirationTimeType ();

    void
    equityExpirationTimeType (const equityExpirationTimeType_type& x);

    void
    equityExpirationTimeType (::std::auto_ptr< equityExpirationTimeType_type > p);

    // equityExpirationTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime equityExpirationTime_type;
    typedef ::xsd::cxx::tree::optional< equityExpirationTime_type > equityExpirationTime_optional;
    typedef ::xsd::cxx::tree::traits< equityExpirationTime_type, char > equityExpirationTime_traits;

    const equityExpirationTime_optional&
    equityExpirationTime () const;

    equityExpirationTime_optional&
    equityExpirationTime ();

    void
    equityExpirationTime (const equityExpirationTime_type& x);

    void
    equityExpirationTime (const equityExpirationTime_optional& x);

    void
    equityExpirationTime (::std::auto_ptr< equityExpirationTime_type > p);

    // equityMultipleExercise
    // 
    typedef ::FpML_4_2::EquityMultipleExercise equityMultipleExercise_type;
    typedef ::xsd::cxx::tree::optional< equityMultipleExercise_type > equityMultipleExercise_optional;
    typedef ::xsd::cxx::tree::traits< equityMultipleExercise_type, char > equityMultipleExercise_traits;

    const equityMultipleExercise_optional&
    equityMultipleExercise () const;

    equityMultipleExercise_optional&
    equityMultipleExercise ();

    void
    equityMultipleExercise (const equityMultipleExercise_type& x);

    void
    equityMultipleExercise (const equityMultipleExercise_optional& x);

    void
    equityMultipleExercise (::std::auto_ptr< equityMultipleExercise_type > p);

    // Constructors.
    //
    EquityAmericanExercise (const commencementDate_type&,
                            const expirationDate_type&,
                            const equityExpirationTimeType_type&);

    EquityAmericanExercise (::std::auto_ptr< commencementDate_type >&,
                            ::std::auto_ptr< expirationDate_type >&,
                            const equityExpirationTimeType_type&);

    EquityAmericanExercise (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    EquityAmericanExercise (const EquityAmericanExercise& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual EquityAmericanExercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityAmericanExercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    latestExerciseTimeType_optional latestExerciseTimeType_;
    ::xsd::cxx::tree::one< equityExpirationTimeType_type > equityExpirationTimeType_;
    equityExpirationTime_optional equityExpirationTime_;
    equityMultipleExercise_optional equityMultipleExercise_;
  };

  class EquityBermudaExercise: public ::FpML_4_2::SharedAmericanExercise
  {
    public:
    // bermudaExerciseDates
    // 
    typedef ::FpML_4_2::DateList bermudaExerciseDates_type;
    typedef ::xsd::cxx::tree::traits< bermudaExerciseDates_type, char > bermudaExerciseDates_traits;

    const bermudaExerciseDates_type&
    bermudaExerciseDates () const;

    bermudaExerciseDates_type&
    bermudaExerciseDates ();

    void
    bermudaExerciseDates (const bermudaExerciseDates_type& x);

    void
    bermudaExerciseDates (::std::auto_ptr< bermudaExerciseDates_type > p);

    // latestExerciseTimeType
    // 
    typedef ::FpML_4_2::TimeTypeEnum latestExerciseTimeType_type;
    typedef ::xsd::cxx::tree::optional< latestExerciseTimeType_type > latestExerciseTimeType_optional;
    typedef ::xsd::cxx::tree::traits< latestExerciseTimeType_type, char > latestExerciseTimeType_traits;

    const latestExerciseTimeType_optional&
    latestExerciseTimeType () const;

    latestExerciseTimeType_optional&
    latestExerciseTimeType ();

    void
    latestExerciseTimeType (const latestExerciseTimeType_type& x);

    void
    latestExerciseTimeType (const latestExerciseTimeType_optional& x);

    void
    latestExerciseTimeType (::std::auto_ptr< latestExerciseTimeType_type > p);

    // equityExpirationTimeType
    // 
    typedef ::FpML_4_2::TimeTypeEnum equityExpirationTimeType_type;
    typedef ::xsd::cxx::tree::traits< equityExpirationTimeType_type, char > equityExpirationTimeType_traits;

    const equityExpirationTimeType_type&
    equityExpirationTimeType () const;

    equityExpirationTimeType_type&
    equityExpirationTimeType ();

    void
    equityExpirationTimeType (const equityExpirationTimeType_type& x);

    void
    equityExpirationTimeType (::std::auto_ptr< equityExpirationTimeType_type > p);

    // equityExpirationTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime equityExpirationTime_type;
    typedef ::xsd::cxx::tree::optional< equityExpirationTime_type > equityExpirationTime_optional;
    typedef ::xsd::cxx::tree::traits< equityExpirationTime_type, char > equityExpirationTime_traits;

    const equityExpirationTime_optional&
    equityExpirationTime () const;

    equityExpirationTime_optional&
    equityExpirationTime ();

    void
    equityExpirationTime (const equityExpirationTime_type& x);

    void
    equityExpirationTime (const equityExpirationTime_optional& x);

    void
    equityExpirationTime (::std::auto_ptr< equityExpirationTime_type > p);

    // equityMultipleExercise
    // 
    typedef ::FpML_4_2::EquityMultipleExercise equityMultipleExercise_type;
    typedef ::xsd::cxx::tree::optional< equityMultipleExercise_type > equityMultipleExercise_optional;
    typedef ::xsd::cxx::tree::traits< equityMultipleExercise_type, char > equityMultipleExercise_traits;

    const equityMultipleExercise_optional&
    equityMultipleExercise () const;

    equityMultipleExercise_optional&
    equityMultipleExercise ();

    void
    equityMultipleExercise (const equityMultipleExercise_type& x);

    void
    equityMultipleExercise (const equityMultipleExercise_optional& x);

    void
    equityMultipleExercise (::std::auto_ptr< equityMultipleExercise_type > p);

    // Constructors.
    //
    EquityBermudaExercise (const commencementDate_type&,
                           const expirationDate_type&,
                           const bermudaExerciseDates_type&,
                           const equityExpirationTimeType_type&);

    EquityBermudaExercise (::std::auto_ptr< commencementDate_type >&,
                           ::std::auto_ptr< expirationDate_type >&,
                           ::std::auto_ptr< bermudaExerciseDates_type >&,
                           const equityExpirationTimeType_type&);

    EquityBermudaExercise (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    EquityBermudaExercise (const EquityBermudaExercise& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual EquityBermudaExercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityBermudaExercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< bermudaExerciseDates_type > bermudaExerciseDates_;
    latestExerciseTimeType_optional latestExerciseTimeType_;
    ::xsd::cxx::tree::one< equityExpirationTimeType_type > equityExpirationTimeType_;
    equityExpirationTime_optional equityExpirationTime_;
    equityMultipleExercise_optional equityMultipleExercise_;
  };

  class EquityDerivativeLongFormBase: public ::FpML_4_2::EquityDerivativeBase
  {
    public:
    // dividendConditions
    // 
    typedef ::FpML_4_2::DividendConditions dividendConditions_type;
    typedef ::xsd::cxx::tree::optional< dividendConditions_type > dividendConditions_optional;
    typedef ::xsd::cxx::tree::traits< dividendConditions_type, char > dividendConditions_traits;

    const dividendConditions_optional&
    dividendConditions () const;

    dividendConditions_optional&
    dividendConditions ();

    void
    dividendConditions (const dividendConditions_type& x);

    void
    dividendConditions (const dividendConditions_optional& x);

    void
    dividendConditions (::std::auto_ptr< dividendConditions_type > p);

    // methodOfAdjustment
    // 
    typedef ::FpML_4_2::MethodOfAdjustmentEnum methodOfAdjustment_type;
    typedef ::xsd::cxx::tree::traits< methodOfAdjustment_type, char > methodOfAdjustment_traits;

    const methodOfAdjustment_type&
    methodOfAdjustment () const;

    methodOfAdjustment_type&
    methodOfAdjustment ();

    void
    methodOfAdjustment (const methodOfAdjustment_type& x);

    void
    methodOfAdjustment (::std::auto_ptr< methodOfAdjustment_type > p);

    // extraordinaryEvents
    // 
    typedef ::FpML_4_2::ExtraordinaryEvents extraordinaryEvents_type;
    typedef ::xsd::cxx::tree::traits< extraordinaryEvents_type, char > extraordinaryEvents_traits;

    const extraordinaryEvents_type&
    extraordinaryEvents () const;

    extraordinaryEvents_type&
    extraordinaryEvents ();

    void
    extraordinaryEvents (const extraordinaryEvents_type& x);

    void
    extraordinaryEvents (::std::auto_ptr< extraordinaryEvents_type > p);

    // equityFeatures
    // 
    typedef ::FpML_4_2::OptionFeatures equityFeatures_type;
    typedef ::xsd::cxx::tree::optional< equityFeatures_type > equityFeatures_optional;
    typedef ::xsd::cxx::tree::traits< equityFeatures_type, char > equityFeatures_traits;

    const equityFeatures_optional&
    equityFeatures () const;

    equityFeatures_optional&
    equityFeatures ();

    void
    equityFeatures (const equityFeatures_type& x);

    void
    equityFeatures (const equityFeatures_optional& x);

    void
    equityFeatures (::std::auto_ptr< equityFeatures_type > p);

    // Constructors.
    //
    EquityDerivativeLongFormBase (const buyerPartyReference_type&,
                                  const sellerPartyReference_type&,
                                  const optionType_type&,
                                  const underlyer_type&,
                                  const equityExercise_type&,
                                  const methodOfAdjustment_type&,
                                  const extraordinaryEvents_type&);

    EquityDerivativeLongFormBase (::std::auto_ptr< buyerPartyReference_type >&,
                                  ::std::auto_ptr< sellerPartyReference_type >&,
                                  const optionType_type&,
                                  ::std::auto_ptr< underlyer_type >&,
                                  ::std::auto_ptr< equityExercise_type >&,
                                  const methodOfAdjustment_type&,
                                  ::std::auto_ptr< extraordinaryEvents_type >&);

    EquityDerivativeLongFormBase (const ::xercesc::DOMElement& e,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    EquityDerivativeLongFormBase (const EquityDerivativeLongFormBase& x,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    virtual EquityDerivativeLongFormBase*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityDerivativeLongFormBase ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    dividendConditions_optional dividendConditions_;
    ::xsd::cxx::tree::one< methodOfAdjustment_type > methodOfAdjustment_;
    ::xsd::cxx::tree::one< extraordinaryEvents_type > extraordinaryEvents_;
    equityFeatures_optional equityFeatures_;
  };

  class EquityEuropeanExercise: public ::FpML_4_2::Exercise
  {
    public:
    // expirationDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate expirationDate_type;
    typedef ::xsd::cxx::tree::traits< expirationDate_type, char > expirationDate_traits;

    const expirationDate_type&
    expirationDate () const;

    expirationDate_type&
    expirationDate ();

    void
    expirationDate (const expirationDate_type& x);

    void
    expirationDate (::std::auto_ptr< expirationDate_type > p);

    // equityExpirationTimeType
    // 
    typedef ::FpML_4_2::TimeTypeEnum equityExpirationTimeType_type;
    typedef ::xsd::cxx::tree::traits< equityExpirationTimeType_type, char > equityExpirationTimeType_traits;

    const equityExpirationTimeType_type&
    equityExpirationTimeType () const;

    equityExpirationTimeType_type&
    equityExpirationTimeType ();

    void
    equityExpirationTimeType (const equityExpirationTimeType_type& x);

    void
    equityExpirationTimeType (::std::auto_ptr< equityExpirationTimeType_type > p);

    // equityExpirationTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime equityExpirationTime_type;
    typedef ::xsd::cxx::tree::optional< equityExpirationTime_type > equityExpirationTime_optional;
    typedef ::xsd::cxx::tree::traits< equityExpirationTime_type, char > equityExpirationTime_traits;

    const equityExpirationTime_optional&
    equityExpirationTime () const;

    equityExpirationTime_optional&
    equityExpirationTime ();

    void
    equityExpirationTime (const equityExpirationTime_type& x);

    void
    equityExpirationTime (const equityExpirationTime_optional& x);

    void
    equityExpirationTime (::std::auto_ptr< equityExpirationTime_type > p);

    // Constructors.
    //
    EquityEuropeanExercise (const expirationDate_type&,
                            const equityExpirationTimeType_type&);

    EquityEuropeanExercise (::std::auto_ptr< expirationDate_type >&,
                            const equityExpirationTimeType_type&);

    EquityEuropeanExercise (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    EquityEuropeanExercise (const EquityEuropeanExercise& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual EquityEuropeanExercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityEuropeanExercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< expirationDate_type > expirationDate_;
    ::xsd::cxx::tree::one< equityExpirationTimeType_type > equityExpirationTimeType_;
    equityExpirationTime_optional equityExpirationTime_;
  };

  class EquityExerciseValuationSettlement: public ::xml_schema::type
  {
    public:
    // equityEuropeanExercise
    // 
    typedef ::FpML_4_2::EquityEuropeanExercise equityEuropeanExercise_type;
    typedef ::xsd::cxx::tree::optional< equityEuropeanExercise_type > equityEuropeanExercise_optional;
    typedef ::xsd::cxx::tree::traits< equityEuropeanExercise_type, char > equityEuropeanExercise_traits;

    const equityEuropeanExercise_optional&
    equityEuropeanExercise () const;

    equityEuropeanExercise_optional&
    equityEuropeanExercise ();

    void
    equityEuropeanExercise (const equityEuropeanExercise_type& x);

    void
    equityEuropeanExercise (const equityEuropeanExercise_optional& x);

    void
    equityEuropeanExercise (::std::auto_ptr< equityEuropeanExercise_type > p);

    // equityAmericanExercise
    // 
    typedef ::FpML_4_2::EquityAmericanExercise equityAmericanExercise_type;
    typedef ::xsd::cxx::tree::optional< equityAmericanExercise_type > equityAmericanExercise_optional;
    typedef ::xsd::cxx::tree::traits< equityAmericanExercise_type, char > equityAmericanExercise_traits;

    const equityAmericanExercise_optional&
    equityAmericanExercise () const;

    equityAmericanExercise_optional&
    equityAmericanExercise ();

    void
    equityAmericanExercise (const equityAmericanExercise_type& x);

    void
    equityAmericanExercise (const equityAmericanExercise_optional& x);

    void
    equityAmericanExercise (::std::auto_ptr< equityAmericanExercise_type > p);

    // equityBermudaExercise
    // 
    typedef ::FpML_4_2::EquityBermudaExercise equityBermudaExercise_type;
    typedef ::xsd::cxx::tree::optional< equityBermudaExercise_type > equityBermudaExercise_optional;
    typedef ::xsd::cxx::tree::traits< equityBermudaExercise_type, char > equityBermudaExercise_traits;

    const equityBermudaExercise_optional&
    equityBermudaExercise () const;

    equityBermudaExercise_optional&
    equityBermudaExercise ();

    void
    equityBermudaExercise (const equityBermudaExercise_type& x);

    void
    equityBermudaExercise (const equityBermudaExercise_optional& x);

    void
    equityBermudaExercise (::std::auto_ptr< equityBermudaExercise_type > p);

    // automaticExercise
    // 
    typedef ::xml_schema::boolean automaticExercise_type;
    typedef ::xsd::cxx::tree::optional< automaticExercise_type > automaticExercise_optional;
    typedef ::xsd::cxx::tree::traits< automaticExercise_type, char > automaticExercise_traits;

    const automaticExercise_optional&
    automaticExercise () const;

    automaticExercise_optional&
    automaticExercise ();

    void
    automaticExercise (const automaticExercise_type& x);

    void
    automaticExercise (const automaticExercise_optional& x);

    // makeWholeProvisions
    // 
    typedef ::FpML_4_2::MakeWholeProvisions makeWholeProvisions_type;
    typedef ::xsd::cxx::tree::optional< makeWholeProvisions_type > makeWholeProvisions_optional;
    typedef ::xsd::cxx::tree::traits< makeWholeProvisions_type, char > makeWholeProvisions_traits;

    const makeWholeProvisions_optional&
    makeWholeProvisions () const;

    makeWholeProvisions_optional&
    makeWholeProvisions ();

    void
    makeWholeProvisions (const makeWholeProvisions_type& x);

    void
    makeWholeProvisions (const makeWholeProvisions_optional& x);

    void
    makeWholeProvisions (::std::auto_ptr< makeWholeProvisions_type > p);

    // prePayment
    // 
    typedef ::FpML_4_2::PrePayment prePayment_type;
    typedef ::xsd::cxx::tree::optional< prePayment_type > prePayment_optional;
    typedef ::xsd::cxx::tree::traits< prePayment_type, char > prePayment_traits;

    const prePayment_optional&
    prePayment () const;

    prePayment_optional&
    prePayment ();

    void
    prePayment (const prePayment_type& x);

    void
    prePayment (const prePayment_optional& x);

    void
    prePayment (::std::auto_ptr< prePayment_type > p);

    // equityValuation
    // 
    typedef ::FpML_4_2::EquityValuation equityValuation_type;
    typedef ::xsd::cxx::tree::traits< equityValuation_type, char > equityValuation_traits;

    const equityValuation_type&
    equityValuation () const;

    equityValuation_type&
    equityValuation ();

    void
    equityValuation (const equityValuation_type& x);

    void
    equityValuation (::std::auto_ptr< equityValuation_type > p);

    // settlementDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate settlementDate_type;
    typedef ::xsd::cxx::tree::optional< settlementDate_type > settlementDate_optional;
    typedef ::xsd::cxx::tree::traits< settlementDate_type, char > settlementDate_traits;

    const settlementDate_optional&
    settlementDate () const;

    settlementDate_optional&
    settlementDate ();

    void
    settlementDate (const settlementDate_type& x);

    void
    settlementDate (const settlementDate_optional& x);

    void
    settlementDate (::std::auto_ptr< settlementDate_type > p);

    // settlementCurrency
    // 
    typedef ::FpML_4_2::Currency settlementCurrency_type;
    typedef ::xsd::cxx::tree::traits< settlementCurrency_type, char > settlementCurrency_traits;

    const settlementCurrency_type&
    settlementCurrency () const;

    settlementCurrency_type&
    settlementCurrency ();

    void
    settlementCurrency (const settlementCurrency_type& x);

    void
    settlementCurrency (::std::auto_ptr< settlementCurrency_type > p);

    // settlementPriceSource
    // 
    typedef ::FpML_4_2::SettlementPriceSource settlementPriceSource_type;
    typedef ::xsd::cxx::tree::optional< settlementPriceSource_type > settlementPriceSource_optional;
    typedef ::xsd::cxx::tree::traits< settlementPriceSource_type, char > settlementPriceSource_traits;

    const settlementPriceSource_optional&
    settlementPriceSource () const;

    settlementPriceSource_optional&
    settlementPriceSource ();

    void
    settlementPriceSource (const settlementPriceSource_type& x);

    void
    settlementPriceSource (const settlementPriceSource_optional& x);

    void
    settlementPriceSource (::std::auto_ptr< settlementPriceSource_type > p);

    // settlementType
    // 
    typedef ::FpML_4_2::SettlementTypeEnum settlementType_type;
    typedef ::xsd::cxx::tree::traits< settlementType_type, char > settlementType_traits;

    const settlementType_type&
    settlementType () const;

    settlementType_type&
    settlementType ();

    void
    settlementType (const settlementType_type& x);

    void
    settlementType (::std::auto_ptr< settlementType_type > p);

    // settlementMethodElectionDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate settlementMethodElectionDate_type;
    typedef ::xsd::cxx::tree::optional< settlementMethodElectionDate_type > settlementMethodElectionDate_optional;
    typedef ::xsd::cxx::tree::traits< settlementMethodElectionDate_type, char > settlementMethodElectionDate_traits;

    const settlementMethodElectionDate_optional&
    settlementMethodElectionDate () const;

    settlementMethodElectionDate_optional&
    settlementMethodElectionDate ();

    void
    settlementMethodElectionDate (const settlementMethodElectionDate_type& x);

    void
    settlementMethodElectionDate (const settlementMethodElectionDate_optional& x);

    void
    settlementMethodElectionDate (::std::auto_ptr< settlementMethodElectionDate_type > p);

    // settlementMethodElectingPartyReference
    // 
    typedef ::FpML_4_2::PartyReference settlementMethodElectingPartyReference_type;
    typedef ::xsd::cxx::tree::optional< settlementMethodElectingPartyReference_type > settlementMethodElectingPartyReference_optional;
    typedef ::xsd::cxx::tree::traits< settlementMethodElectingPartyReference_type, char > settlementMethodElectingPartyReference_traits;

    const settlementMethodElectingPartyReference_optional&
    settlementMethodElectingPartyReference () const;

    settlementMethodElectingPartyReference_optional&
    settlementMethodElectingPartyReference ();

    void
    settlementMethodElectingPartyReference (const settlementMethodElectingPartyReference_type& x);

    void
    settlementMethodElectingPartyReference (const settlementMethodElectingPartyReference_optional& x);

    void
    settlementMethodElectingPartyReference (::std::auto_ptr< settlementMethodElectingPartyReference_type > p);

    // Constructors.
    //
    EquityExerciseValuationSettlement (const equityValuation_type&,
                                       const settlementCurrency_type&,
                                       const settlementType_type&);

    EquityExerciseValuationSettlement (::std::auto_ptr< equityValuation_type >&,
                                       ::std::auto_ptr< settlementCurrency_type >&,
                                       const settlementType_type&);

    EquityExerciseValuationSettlement (const ::xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    EquityExerciseValuationSettlement (const EquityExerciseValuationSettlement& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual EquityExerciseValuationSettlement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityExerciseValuationSettlement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    equityEuropeanExercise_optional equityEuropeanExercise_;
    equityAmericanExercise_optional equityAmericanExercise_;
    equityBermudaExercise_optional equityBermudaExercise_;
    automaticExercise_optional automaticExercise_;
    makeWholeProvisions_optional makeWholeProvisions_;
    prePayment_optional prePayment_;
    ::xsd::cxx::tree::one< equityValuation_type > equityValuation_;
    settlementDate_optional settlementDate_;
    ::xsd::cxx::tree::one< settlementCurrency_type > settlementCurrency_;
    settlementPriceSource_optional settlementPriceSource_;
    ::xsd::cxx::tree::one< settlementType_type > settlementType_;
    settlementMethodElectionDate_optional settlementMethodElectionDate_;
    settlementMethodElectingPartyReference_optional settlementMethodElectingPartyReference_;
  };

  class EquityForward: public ::FpML_4_2::EquityDerivativeLongFormBase
  {
    public:
    // forwardPrice
    // 
    typedef ::FpML_4_2::Money forwardPrice_type;
    typedef ::xsd::cxx::tree::optional< forwardPrice_type > forwardPrice_optional;
    typedef ::xsd::cxx::tree::traits< forwardPrice_type, char > forwardPrice_traits;

    const forwardPrice_optional&
    forwardPrice () const;

    forwardPrice_optional&
    forwardPrice ();

    void
    forwardPrice (const forwardPrice_type& x);

    void
    forwardPrice (const forwardPrice_optional& x);

    void
    forwardPrice (::std::auto_ptr< forwardPrice_type > p);

    // Constructors.
    //
    EquityForward (const buyerPartyReference_type&,
                   const sellerPartyReference_type&,
                   const optionType_type&,
                   const underlyer_type&,
                   const equityExercise_type&,
                   const methodOfAdjustment_type&,
                   const extraordinaryEvents_type&);

    EquityForward (::std::auto_ptr< buyerPartyReference_type >&,
                   ::std::auto_ptr< sellerPartyReference_type >&,
                   const optionType_type&,
                   ::std::auto_ptr< underlyer_type >&,
                   ::std::auto_ptr< equityExercise_type >&,
                   const methodOfAdjustment_type&,
                   ::std::auto_ptr< extraordinaryEvents_type >&);

    EquityForward (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    EquityForward (const EquityForward& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual EquityForward*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityForward ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    forwardPrice_optional forwardPrice_;
  };

  class EquityMultipleExercise: public ::xml_schema::type
  {
    public:
    // integralMultipleExercise
    // 
    typedef ::xml_schema::decimal integralMultipleExercise_type;
    typedef ::xsd::cxx::tree::optional< integralMultipleExercise_type > integralMultipleExercise_optional;
    typedef ::xsd::cxx::tree::traits< integralMultipleExercise_type, char, ::xsd::cxx::tree::schema_type::decimal > integralMultipleExercise_traits;

    const integralMultipleExercise_optional&
    integralMultipleExercise () const;

    integralMultipleExercise_optional&
    integralMultipleExercise ();

    void
    integralMultipleExercise (const integralMultipleExercise_type& x);

    void
    integralMultipleExercise (const integralMultipleExercise_optional& x);

    // minimumNumberOfOptions
    // 
    typedef ::xml_schema::decimal minimumNumberOfOptions_type;
    typedef ::xsd::cxx::tree::traits< minimumNumberOfOptions_type, char, ::xsd::cxx::tree::schema_type::decimal > minimumNumberOfOptions_traits;

    const minimumNumberOfOptions_type&
    minimumNumberOfOptions () const;

    minimumNumberOfOptions_type&
    minimumNumberOfOptions ();

    void
    minimumNumberOfOptions (const minimumNumberOfOptions_type& x);

    // maximumNumberOfOptions
    // 
    typedef ::xml_schema::decimal maximumNumberOfOptions_type;
    typedef ::xsd::cxx::tree::traits< maximumNumberOfOptions_type, char, ::xsd::cxx::tree::schema_type::decimal > maximumNumberOfOptions_traits;

    const maximumNumberOfOptions_type&
    maximumNumberOfOptions () const;

    maximumNumberOfOptions_type&
    maximumNumberOfOptions ();

    void
    maximumNumberOfOptions (const maximumNumberOfOptions_type& x);

    // Constructors.
    //
    EquityMultipleExercise (const minimumNumberOfOptions_type&,
                            const maximumNumberOfOptions_type&);

    EquityMultipleExercise (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    EquityMultipleExercise (const EquityMultipleExercise& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual EquityMultipleExercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityMultipleExercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    integralMultipleExercise_optional integralMultipleExercise_;
    ::xsd::cxx::tree::one< minimumNumberOfOptions_type > minimumNumberOfOptions_;
    ::xsd::cxx::tree::one< maximumNumberOfOptions_type > maximumNumberOfOptions_;
  };

  class EquityOption: public ::FpML_4_2::EquityDerivativeLongFormBase
  {
    public:
    // strike
    // 
    typedef ::FpML_4_2::EquityStrike strike_type;
    typedef ::xsd::cxx::tree::optional< strike_type > strike_optional;
    typedef ::xsd::cxx::tree::traits< strike_type, char > strike_traits;

    const strike_optional&
    strike () const;

    strike_optional&
    strike ();

    void
    strike (const strike_type& x);

    void
    strike (const strike_optional& x);

    void
    strike (::std::auto_ptr< strike_type > p);

    // spotPrice
    // 
    typedef ::xml_schema::decimal spotPrice_type;
    typedef ::xsd::cxx::tree::optional< spotPrice_type > spotPrice_optional;
    typedef ::xsd::cxx::tree::traits< spotPrice_type, char, ::xsd::cxx::tree::schema_type::decimal > spotPrice_traits;

    const spotPrice_optional&
    spotPrice () const;

    spotPrice_optional&
    spotPrice ();

    void
    spotPrice (const spotPrice_type& x);

    void
    spotPrice (const spotPrice_optional& x);

    // numberOfOptions
    // 
    typedef ::xml_schema::decimal numberOfOptions_type;
    typedef ::xsd::cxx::tree::optional< numberOfOptions_type > numberOfOptions_optional;
    typedef ::xsd::cxx::tree::traits< numberOfOptions_type, char, ::xsd::cxx::tree::schema_type::decimal > numberOfOptions_traits;

    const numberOfOptions_optional&
    numberOfOptions () const;

    numberOfOptions_optional&
    numberOfOptions ();

    void
    numberOfOptions (const numberOfOptions_type& x);

    void
    numberOfOptions (const numberOfOptions_optional& x);

    // optionEntitlement
    // 
    typedef ::xml_schema::decimal optionEntitlement_type;
    typedef ::xsd::cxx::tree::traits< optionEntitlement_type, char, ::xsd::cxx::tree::schema_type::decimal > optionEntitlement_traits;

    const optionEntitlement_type&
    optionEntitlement () const;

    optionEntitlement_type&
    optionEntitlement ();

    void
    optionEntitlement (const optionEntitlement_type& x);

    // equityPremium
    // 
    typedef ::FpML_4_2::EquityPremium equityPremium_type;
    typedef ::xsd::cxx::tree::traits< equityPremium_type, char > equityPremium_traits;

    const equityPremium_type&
    equityPremium () const;

    equityPremium_type&
    equityPremium ();

    void
    equityPremium (const equityPremium_type& x);

    void
    equityPremium (::std::auto_ptr< equityPremium_type > p);

    // Constructors.
    //
    EquityOption (const buyerPartyReference_type&,
                  const sellerPartyReference_type&,
                  const optionType_type&,
                  const underlyer_type&,
                  const equityExercise_type&,
                  const methodOfAdjustment_type&,
                  const extraordinaryEvents_type&,
                  const optionEntitlement_type&,
                  const equityPremium_type&);

    EquityOption (::std::auto_ptr< buyerPartyReference_type >&,
                  ::std::auto_ptr< sellerPartyReference_type >&,
                  const optionType_type&,
                  ::std::auto_ptr< underlyer_type >&,
                  ::std::auto_ptr< equityExercise_type >&,
                  const methodOfAdjustment_type&,
                  ::std::auto_ptr< extraordinaryEvents_type >&,
                  const optionEntitlement_type&,
                  ::std::auto_ptr< equityPremium_type >&);

    EquityOption (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    EquityOption (const EquityOption& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual EquityOption*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityOption ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    strike_optional strike_;
    spotPrice_optional spotPrice_;
    numberOfOptions_optional numberOfOptions_;
    ::xsd::cxx::tree::one< optionEntitlement_type > optionEntitlement_;
    ::xsd::cxx::tree::one< equityPremium_type > equityPremium_;
  };

  class EquityOptionTermination: public ::xml_schema::type
  {
    public:
    // settlementAmountPaymentDate
    // 
    typedef ::FpML_4_2::AdjustableDate settlementAmountPaymentDate_type;
    typedef ::xsd::cxx::tree::traits< settlementAmountPaymentDate_type, char > settlementAmountPaymentDate_traits;

    const settlementAmountPaymentDate_type&
    settlementAmountPaymentDate () const;

    settlementAmountPaymentDate_type&
    settlementAmountPaymentDate ();

    void
    settlementAmountPaymentDate (const settlementAmountPaymentDate_type& x);

    void
    settlementAmountPaymentDate (::std::auto_ptr< settlementAmountPaymentDate_type > p);

    // settlementAmount
    // 
    typedef ::FpML_4_2::Money settlementAmount_type;
    typedef ::xsd::cxx::tree::traits< settlementAmount_type, char > settlementAmount_traits;

    const settlementAmount_type&
    settlementAmount () const;

    settlementAmount_type&
    settlementAmount ();

    void
    settlementAmount (const settlementAmount_type& x);

    void
    settlementAmount (::std::auto_ptr< settlementAmount_type > p);

    // Constructors.
    //
    EquityOptionTermination (const settlementAmountPaymentDate_type&,
                             const settlementAmount_type&);

    EquityOptionTermination (::std::auto_ptr< settlementAmountPaymentDate_type >&,
                             ::std::auto_ptr< settlementAmount_type >&);

    EquityOptionTermination (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    EquityOptionTermination (const EquityOptionTermination& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual EquityOptionTermination*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityOptionTermination ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< settlementAmountPaymentDate_type > settlementAmountPaymentDate_;
    ::xsd::cxx::tree::one< settlementAmount_type > settlementAmount_;
  };

  class EquityOptionTransactionSupplement: public ::FpML_4_2::EquityDerivativeShortFormBase
  {
    public:
    // exchangeLookAlike
    // 
    typedef ::xml_schema::boolean exchangeLookAlike_type;
    typedef ::xsd::cxx::tree::optional< exchangeLookAlike_type > exchangeLookAlike_optional;
    typedef ::xsd::cxx::tree::traits< exchangeLookAlike_type, char > exchangeLookAlike_traits;

    const exchangeLookAlike_optional&
    exchangeLookAlike () const;

    exchangeLookAlike_optional&
    exchangeLookAlike ();

    void
    exchangeLookAlike (const exchangeLookAlike_type& x);

    void
    exchangeLookAlike (const exchangeLookAlike_optional& x);

    // exchangeTradedContractNearest
    // 
    typedef ::xml_schema::boolean exchangeTradedContractNearest_type;
    typedef ::xsd::cxx::tree::optional< exchangeTradedContractNearest_type > exchangeTradedContractNearest_optional;
    typedef ::xsd::cxx::tree::traits< exchangeTradedContractNearest_type, char > exchangeTradedContractNearest_traits;

    const exchangeTradedContractNearest_optional&
    exchangeTradedContractNearest () const;

    exchangeTradedContractNearest_optional&
    exchangeTradedContractNearest ();

    void
    exchangeTradedContractNearest (const exchangeTradedContractNearest_type& x);

    void
    exchangeTradedContractNearest (const exchangeTradedContractNearest_optional& x);

    // multipleExchangeIndexAnnexFallback
    // 
    typedef ::xml_schema::boolean multipleExchangeIndexAnnexFallback_type;
    typedef ::xsd::cxx::tree::optional< multipleExchangeIndexAnnexFallback_type > multipleExchangeIndexAnnexFallback_optional;
    typedef ::xsd::cxx::tree::traits< multipleExchangeIndexAnnexFallback_type, char > multipleExchangeIndexAnnexFallback_traits;

    const multipleExchangeIndexAnnexFallback_optional&
    multipleExchangeIndexAnnexFallback () const;

    multipleExchangeIndexAnnexFallback_optional&
    multipleExchangeIndexAnnexFallback ();

    void
    multipleExchangeIndexAnnexFallback (const multipleExchangeIndexAnnexFallback_type& x);

    void
    multipleExchangeIndexAnnexFallback (const multipleExchangeIndexAnnexFallback_optional& x);

    // methodOfAdjustment
    // 
    typedef ::FpML_4_2::MethodOfAdjustmentEnum methodOfAdjustment_type;
    typedef ::xsd::cxx::tree::optional< methodOfAdjustment_type > methodOfAdjustment_optional;
    typedef ::xsd::cxx::tree::traits< methodOfAdjustment_type, char > methodOfAdjustment_traits;

    const methodOfAdjustment_optional&
    methodOfAdjustment () const;

    methodOfAdjustment_optional&
    methodOfAdjustment ();

    void
    methodOfAdjustment (const methodOfAdjustment_type& x);

    void
    methodOfAdjustment (const methodOfAdjustment_optional& x);

    void
    methodOfAdjustment (::std::auto_ptr< methodOfAdjustment_type > p);

    // localJurisdiction
    // 
    typedef ::FpML_4_2::Country localJurisdiction_type;
    typedef ::xsd::cxx::tree::optional< localJurisdiction_type > localJurisdiction_optional;
    typedef ::xsd::cxx::tree::traits< localJurisdiction_type, char > localJurisdiction_traits;

    const localJurisdiction_optional&
    localJurisdiction () const;

    localJurisdiction_optional&
    localJurisdiction ();

    void
    localJurisdiction (const localJurisdiction_type& x);

    void
    localJurisdiction (const localJurisdiction_optional& x);

    void
    localJurisdiction (::std::auto_ptr< localJurisdiction_type > p);

    // optionEntitlement
    // 
    typedef ::xml_schema::decimal optionEntitlement_type;
    typedef ::xsd::cxx::tree::optional< optionEntitlement_type > optionEntitlement_optional;
    typedef ::xsd::cxx::tree::traits< optionEntitlement_type, char, ::xsd::cxx::tree::schema_type::decimal > optionEntitlement_traits;

    const optionEntitlement_optional&
    optionEntitlement () const;

    optionEntitlement_optional&
    optionEntitlement ();

    void
    optionEntitlement (const optionEntitlement_type& x);

    void
    optionEntitlement (const optionEntitlement_optional& x);

    // multiplier
    // 
    typedef ::xml_schema::integer multiplier_type;
    typedef ::xsd::cxx::tree::optional< multiplier_type > multiplier_optional;
    typedef ::xsd::cxx::tree::traits< multiplier_type, char > multiplier_traits;

    const multiplier_optional&
    multiplier () const;

    multiplier_optional&
    multiplier ();

    void
    multiplier (const multiplier_type& x);

    void
    multiplier (const multiplier_optional& x);

    // Constructors.
    //
    EquityOptionTransactionSupplement (const buyerPartyReference_type&,
                                       const sellerPartyReference_type&,
                                       const optionType_type&,
                                       const underlyer_type&,
                                       const equityExercise_type&,
                                       const strike_type&,
                                       const numberOfOptions_type&,
                                       const equityPremium_type&);

    EquityOptionTransactionSupplement (::std::auto_ptr< buyerPartyReference_type >&,
                                       ::std::auto_ptr< sellerPartyReference_type >&,
                                       const optionType_type&,
                                       ::std::auto_ptr< underlyer_type >&,
                                       ::std::auto_ptr< equityExercise_type >&,
                                       ::std::auto_ptr< strike_type >&,
                                       const numberOfOptions_type&,
                                       ::std::auto_ptr< equityPremium_type >&);

    EquityOptionTransactionSupplement (const ::xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    EquityOptionTransactionSupplement (const EquityOptionTransactionSupplement& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual EquityOptionTransactionSupplement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquityOptionTransactionSupplement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    exchangeLookAlike_optional exchangeLookAlike_;
    exchangeTradedContractNearest_optional exchangeTradedContractNearest_;
    multipleExchangeIndexAnnexFallback_optional multipleExchangeIndexAnnexFallback_;
    methodOfAdjustment_optional methodOfAdjustment_;
    localJurisdiction_optional localJurisdiction_;
    optionEntitlement_optional optionEntitlement_;
    multiplier_optional multiplier_;
  };

  class PrePayment: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // prePayment
    // 
    typedef ::xml_schema::boolean prePayment_type;
    typedef ::xsd::cxx::tree::traits< prePayment_type, char > prePayment_traits;

    const prePayment_type&
    prePayment () const;

    prePayment_type&
    prePayment ();

    void
    prePayment (const prePayment_type& x);

    // prePaymentAmount
    // 
    typedef ::FpML_4_2::Money prePaymentAmount_type;
    typedef ::xsd::cxx::tree::traits< prePaymentAmount_type, char > prePaymentAmount_traits;

    const prePaymentAmount_type&
    prePaymentAmount () const;

    prePaymentAmount_type&
    prePaymentAmount ();

    void
    prePaymentAmount (const prePaymentAmount_type& x);

    void
    prePaymentAmount (::std::auto_ptr< prePaymentAmount_type > p);

    // prePaymentDate
    // 
    typedef ::FpML_4_2::AdjustableDate prePaymentDate_type;
    typedef ::xsd::cxx::tree::traits< prePaymentDate_type, char > prePaymentDate_traits;

    const prePaymentDate_type&
    prePaymentDate () const;

    prePaymentDate_type&
    prePaymentDate ();

    void
    prePaymentDate (const prePaymentDate_type& x);

    void
    prePaymentDate (::std::auto_ptr< prePaymentDate_type > p);

    // Constructors.
    //
    PrePayment (const payerPartyReference_type&,
                const receiverPartyReference_type&,
                const prePayment_type&,
                const prePaymentAmount_type&,
                const prePaymentDate_type&);

    PrePayment (::std::auto_ptr< payerPartyReference_type >&,
                ::std::auto_ptr< receiverPartyReference_type >&,
                const prePayment_type&,
                ::std::auto_ptr< prePaymentAmount_type >&,
                ::std::auto_ptr< prePaymentDate_type >&);

    PrePayment (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    PrePayment (const PrePayment& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual PrePayment*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PrePayment ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    ::xsd::cxx::tree::one< prePayment_type > prePayment_;
    ::xsd::cxx::tree::one< prePaymentAmount_type > prePaymentAmount_;
    ::xsd::cxx::tree::one< prePaymentDate_type > prePaymentDate_;
  };

  class StrategyFeature: public ::xml_schema::type
  {
    public:
    // strikeSpread
    // 
    typedef ::FpML_4_2::StrikeSpread strikeSpread_type;
    typedef ::xsd::cxx::tree::optional< strikeSpread_type > strikeSpread_optional;
    typedef ::xsd::cxx::tree::traits< strikeSpread_type, char > strikeSpread_traits;

    const strikeSpread_optional&
    strikeSpread () const;

    strikeSpread_optional&
    strikeSpread ();

    void
    strikeSpread (const strikeSpread_type& x);

    void
    strikeSpread (const strikeSpread_optional& x);

    void
    strikeSpread (::std::auto_ptr< strikeSpread_type > p);

    // calendarSpread
    // 
    typedef ::FpML_4_2::CalendarSpread calendarSpread_type;
    typedef ::xsd::cxx::tree::optional< calendarSpread_type > calendarSpread_optional;
    typedef ::xsd::cxx::tree::traits< calendarSpread_type, char > calendarSpread_traits;

    const calendarSpread_optional&
    calendarSpread () const;

    calendarSpread_optional&
    calendarSpread ();

    void
    calendarSpread (const calendarSpread_type& x);

    void
    calendarSpread (const calendarSpread_optional& x);

    void
    calendarSpread (::std::auto_ptr< calendarSpread_type > p);

    // Constructors.
    //
    StrategyFeature ();

    StrategyFeature (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    StrategyFeature (const StrategyFeature& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual StrategyFeature*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~StrategyFeature ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    strikeSpread_optional strikeSpread_;
    calendarSpread_optional calendarSpread_;
  };

  class StrikeSpread: public ::xml_schema::type
  {
    public:
    // upperStrike
    // 
    typedef ::FpML_4_2::EquityStrike upperStrike_type;
    typedef ::xsd::cxx::tree::traits< upperStrike_type, char > upperStrike_traits;

    const upperStrike_type&
    upperStrike () const;

    upperStrike_type&
    upperStrike ();

    void
    upperStrike (const upperStrike_type& x);

    void
    upperStrike (::std::auto_ptr< upperStrike_type > p);

    // upperStrikeNumberOfOptions
    // 
    typedef ::xml_schema::decimal upperStrikeNumberOfOptions_type;
    typedef ::xsd::cxx::tree::traits< upperStrikeNumberOfOptions_type, char, ::xsd::cxx::tree::schema_type::decimal > upperStrikeNumberOfOptions_traits;

    const upperStrikeNumberOfOptions_type&
    upperStrikeNumberOfOptions () const;

    upperStrikeNumberOfOptions_type&
    upperStrikeNumberOfOptions ();

    void
    upperStrikeNumberOfOptions (const upperStrikeNumberOfOptions_type& x);

    // Constructors.
    //
    StrikeSpread (const upperStrike_type&,
                  const upperStrikeNumberOfOptions_type&);

    StrikeSpread (::std::auto_ptr< upperStrike_type >&,
                  const upperStrikeNumberOfOptions_type&);

    StrikeSpread (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    StrikeSpread (const StrikeSpread& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual StrikeSpread*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~StrikeSpread ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< upperStrike_type > upperStrike_;
    ::xsd::cxx::tree::one< upperStrikeNumberOfOptions_type > upperStrikeNumberOfOptions_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const EquityDerivativeBase&);

  void
  operator<< (::xercesc::DOMElement&, const EquityDerivativeShortFormBase&);

  void
  operator<< (::xercesc::DOMElement&, const BrokerEquityOption&);

  void
  operator<< (::xercesc::DOMElement&, const CalendarSpread&);

  void
  operator<< (::xercesc::DOMElement&, const EquityAmericanExercise&);

  void
  operator<< (::xercesc::DOMElement&, const EquityBermudaExercise&);

  void
  operator<< (::xercesc::DOMElement&, const EquityDerivativeLongFormBase&);

  void
  operator<< (::xercesc::DOMElement&, const EquityEuropeanExercise&);

  void
  operator<< (::xercesc::DOMElement&, const EquityExerciseValuationSettlement&);

  void
  operator<< (::xercesc::DOMElement&, const EquityForward&);

  void
  operator<< (::xercesc::DOMElement&, const EquityMultipleExercise&);

  void
  operator<< (::xercesc::DOMElement&, const EquityOption&);

  void
  operator<< (::xercesc::DOMElement&, const EquityOptionTermination&);

  void
  operator<< (::xercesc::DOMElement&, const EquityOptionTransactionSupplement&);

  void
  operator<< (::xercesc::DOMElement&, const PrePayment&);

  void
  operator<< (::xercesc::DOMElement&, const StrategyFeature&);

  void
  operator<< (::xercesc::DOMElement&, const StrikeSpread&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_EQD_4_2_HXX
