// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_FX_4_2_HXX
#define FPML_FX_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class CutName;
  class ExchangeRate;
  class ExpiryDateTime;
  class FxAmericanTrigger;
  class FxAverageRateObservationDate;
  class FxAverageRateObservationSchedule;
  class FxAverageRateOption;
  class FxBarrier;
  class FxOptionLeg;
  class FxBarrierOption;
  class FxDigitalOption;
  class FxEuropeanTrigger;
  class FxLeg;
  class FxOptionPayout;
  class FxOptionPremium;
  class FxStrikePrice;
  class FxSwap;
  class ObservedRates;
  class PremiumQuote;
  class QuotedAs;
  class SideRate;
  class SideRates;
  class TermDeposit;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-shared-4-2.hxx"

namespace FpML_4_2
{
  class CutName: public ::xml_schema::normalized_string
  {
    public:
    // cutNameScheme
    // 
    typedef ::xml_schema::uri cutNameScheme_type;
    typedef ::xsd::cxx::tree::traits< cutNameScheme_type, char > cutNameScheme_traits;

    const cutNameScheme_type&
    cutNameScheme () const;

    cutNameScheme_type&
    cutNameScheme ();

    void
    cutNameScheme (const cutNameScheme_type& x);

    void
    cutNameScheme (::std::auto_ptr< cutNameScheme_type > p);

    static const cutNameScheme_type&
    cutNameScheme_default_value ();

    // Constructors.
    //
    CutName ();

    CutName (const char*);

    CutName (const ::std::string&);

    CutName (const ::xml_schema::normalized_string&);

    CutName (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    CutName (const CutName& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual CutName*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CutName ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< cutNameScheme_type > cutNameScheme_;
    static const cutNameScheme_type cutNameScheme_default_value_;
  };

  class ExchangeRate: public ::FpML_4_2::FxRate
  {
    public:
    // spotRate
    // 
    typedef ::xml_schema::decimal spotRate_type;
    typedef ::xsd::cxx::tree::optional< spotRate_type > spotRate_optional;
    typedef ::xsd::cxx::tree::traits< spotRate_type, char, ::xsd::cxx::tree::schema_type::decimal > spotRate_traits;

    const spotRate_optional&
    spotRate () const;

    spotRate_optional&
    spotRate ();

    void
    spotRate (const spotRate_type& x);

    void
    spotRate (const spotRate_optional& x);

    // forwardPoints
    // 
    typedef ::xml_schema::decimal forwardPoints_type;
    typedef ::xsd::cxx::tree::optional< forwardPoints_type > forwardPoints_optional;
    typedef ::xsd::cxx::tree::traits< forwardPoints_type, char, ::xsd::cxx::tree::schema_type::decimal > forwardPoints_traits;

    const forwardPoints_optional&
    forwardPoints () const;

    forwardPoints_optional&
    forwardPoints ();

    void
    forwardPoints (const forwardPoints_type& x);

    void
    forwardPoints (const forwardPoints_optional& x);

    // sideRates
    // 
    typedef ::FpML_4_2::SideRates sideRates_type;
    typedef ::xsd::cxx::tree::optional< sideRates_type > sideRates_optional;
    typedef ::xsd::cxx::tree::traits< sideRates_type, char > sideRates_traits;

    const sideRates_optional&
    sideRates () const;

    sideRates_optional&
    sideRates ();

    void
    sideRates (const sideRates_type& x);

    void
    sideRates (const sideRates_optional& x);

    void
    sideRates (::std::auto_ptr< sideRates_type > p);

    // Constructors.
    //
    ExchangeRate (const quotedCurrencyPair_type&,
                  const rate_type&);

    ExchangeRate (::std::auto_ptr< quotedCurrencyPair_type >&,
                  const rate_type&);

    ExchangeRate (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    ExchangeRate (const ExchangeRate& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual ExchangeRate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExchangeRate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    spotRate_optional spotRate_;
    forwardPoints_optional forwardPoints_;
    sideRates_optional sideRates_;
  };

  class ExpiryDateTime: public ::xml_schema::type
  {
    public:
    // expiryDate
    // 
    typedef ::xml_schema::date expiryDate_type;
    typedef ::xsd::cxx::tree::traits< expiryDate_type, char > expiryDate_traits;

    const expiryDate_type&
    expiryDate () const;

    expiryDate_type&
    expiryDate ();

    void
    expiryDate (const expiryDate_type& x);

    void
    expiryDate (::std::auto_ptr< expiryDate_type > p);

    // expiryTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime expiryTime_type;
    typedef ::xsd::cxx::tree::traits< expiryTime_type, char > expiryTime_traits;

    const expiryTime_type&
    expiryTime () const;

    expiryTime_type&
    expiryTime ();

    void
    expiryTime (const expiryTime_type& x);

    void
    expiryTime (::std::auto_ptr< expiryTime_type > p);

    // cutName
    // 
    typedef ::FpML_4_2::CutName cutName_type;
    typedef ::xsd::cxx::tree::optional< cutName_type > cutName_optional;
    typedef ::xsd::cxx::tree::traits< cutName_type, char > cutName_traits;

    const cutName_optional&
    cutName () const;

    cutName_optional&
    cutName ();

    void
    cutName (const cutName_type& x);

    void
    cutName (const cutName_optional& x);

    void
    cutName (::std::auto_ptr< cutName_type > p);

    // Constructors.
    //
    ExpiryDateTime (const expiryDate_type&,
                    const expiryTime_type&);

    ExpiryDateTime (const expiryDate_type&,
                    ::std::auto_ptr< expiryTime_type >&);

    ExpiryDateTime (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ExpiryDateTime (const ExpiryDateTime& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ExpiryDateTime*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExpiryDateTime ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< expiryDate_type > expiryDate_;
    ::xsd::cxx::tree::one< expiryTime_type > expiryTime_;
    cutName_optional cutName_;
  };

  class FxAmericanTrigger: public ::xml_schema::type
  {
    public:
    // touchCondition
    // 
    typedef ::FpML_4_2::TouchConditionEnum touchCondition_type;
    typedef ::xsd::cxx::tree::traits< touchCondition_type, char > touchCondition_traits;

    const touchCondition_type&
    touchCondition () const;

    touchCondition_type&
    touchCondition ();

    void
    touchCondition (const touchCondition_type& x);

    void
    touchCondition (::std::auto_ptr< touchCondition_type > p);

    // quotedCurrencyPair
    // 
    typedef ::FpML_4_2::QuotedCurrencyPair quotedCurrencyPair_type;
    typedef ::xsd::cxx::tree::traits< quotedCurrencyPair_type, char > quotedCurrencyPair_traits;

    const quotedCurrencyPair_type&
    quotedCurrencyPair () const;

    quotedCurrencyPair_type&
    quotedCurrencyPair ();

    void
    quotedCurrencyPair (const quotedCurrencyPair_type& x);

    void
    quotedCurrencyPair (::std::auto_ptr< quotedCurrencyPair_type > p);

    // triggerRate
    // 
    typedef ::xml_schema::decimal triggerRate_type;
    typedef ::xsd::cxx::tree::traits< triggerRate_type, char, ::xsd::cxx::tree::schema_type::decimal > triggerRate_traits;

    const triggerRate_type&
    triggerRate () const;

    triggerRate_type&
    triggerRate ();

    void
    triggerRate (const triggerRate_type& x);

    // informationSource
    // 
    typedef ::FpML_4_2::InformationSource informationSource_type;
    typedef ::xsd::cxx::tree::sequence< informationSource_type > informationSource_sequence;
    typedef informationSource_sequence::iterator informationSource_iterator;
    typedef informationSource_sequence::const_iterator informationSource_const_iterator;
    typedef ::xsd::cxx::tree::traits< informationSource_type, char > informationSource_traits;

    const informationSource_sequence&
    informationSource () const;

    informationSource_sequence&
    informationSource ();

    void
    informationSource (const informationSource_sequence& s);

    // observationStartDate
    // 
    typedef ::xml_schema::date observationStartDate_type;
    typedef ::xsd::cxx::tree::optional< observationStartDate_type > observationStartDate_optional;
    typedef ::xsd::cxx::tree::traits< observationStartDate_type, char > observationStartDate_traits;

    const observationStartDate_optional&
    observationStartDate () const;

    observationStartDate_optional&
    observationStartDate ();

    void
    observationStartDate (const observationStartDate_type& x);

    void
    observationStartDate (const observationStartDate_optional& x);

    void
    observationStartDate (::std::auto_ptr< observationStartDate_type > p);

    // observationEndDate
    // 
    typedef ::xml_schema::date observationEndDate_type;
    typedef ::xsd::cxx::tree::optional< observationEndDate_type > observationEndDate_optional;
    typedef ::xsd::cxx::tree::traits< observationEndDate_type, char > observationEndDate_traits;

    const observationEndDate_optional&
    observationEndDate () const;

    observationEndDate_optional&
    observationEndDate ();

    void
    observationEndDate (const observationEndDate_type& x);

    void
    observationEndDate (const observationEndDate_optional& x);

    void
    observationEndDate (::std::auto_ptr< observationEndDate_type > p);

    // Constructors.
    //
    FxAmericanTrigger (const touchCondition_type&,
                       const quotedCurrencyPair_type&,
                       const triggerRate_type&);

    FxAmericanTrigger (const touchCondition_type&,
                       ::std::auto_ptr< quotedCurrencyPair_type >&,
                       const triggerRate_type&);

    FxAmericanTrigger (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    FxAmericanTrigger (const FxAmericanTrigger& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual FxAmericanTrigger*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxAmericanTrigger ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< touchCondition_type > touchCondition_;
    ::xsd::cxx::tree::one< quotedCurrencyPair_type > quotedCurrencyPair_;
    ::xsd::cxx::tree::one< triggerRate_type > triggerRate_;
    informationSource_sequence informationSource_;
    observationStartDate_optional observationStartDate_;
    observationEndDate_optional observationEndDate_;
  };

  class FxAverageRateObservationDate: public ::xml_schema::type
  {
    public:
    // observationDate
    // 
    typedef ::xml_schema::date observationDate_type;
    typedef ::xsd::cxx::tree::traits< observationDate_type, char > observationDate_traits;

    const observationDate_type&
    observationDate () const;

    observationDate_type&
    observationDate ();

    void
    observationDate (const observationDate_type& x);

    void
    observationDate (::std::auto_ptr< observationDate_type > p);

    // averageRateWeightingFactor
    // 
    typedef ::xml_schema::decimal averageRateWeightingFactor_type;
    typedef ::xsd::cxx::tree::traits< averageRateWeightingFactor_type, char, ::xsd::cxx::tree::schema_type::decimal > averageRateWeightingFactor_traits;

    const averageRateWeightingFactor_type&
    averageRateWeightingFactor () const;

    averageRateWeightingFactor_type&
    averageRateWeightingFactor ();

    void
    averageRateWeightingFactor (const averageRateWeightingFactor_type& x);

    // Constructors.
    //
    FxAverageRateObservationDate (const observationDate_type&,
                                  const averageRateWeightingFactor_type&);

    FxAverageRateObservationDate (const ::xercesc::DOMElement& e,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    FxAverageRateObservationDate (const FxAverageRateObservationDate& x,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    virtual FxAverageRateObservationDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxAverageRateObservationDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< observationDate_type > observationDate_;
    ::xsd::cxx::tree::one< averageRateWeightingFactor_type > averageRateWeightingFactor_;
  };

  class FxAverageRateObservationSchedule: public ::xml_schema::type
  {
    public:
    // observationStartDate
    // 
    typedef ::xml_schema::date observationStartDate_type;
    typedef ::xsd::cxx::tree::traits< observationStartDate_type, char > observationStartDate_traits;

    const observationStartDate_type&
    observationStartDate () const;

    observationStartDate_type&
    observationStartDate ();

    void
    observationStartDate (const observationStartDate_type& x);

    void
    observationStartDate (::std::auto_ptr< observationStartDate_type > p);

    // observationEndDate
    // 
    typedef ::xml_schema::date observationEndDate_type;
    typedef ::xsd::cxx::tree::traits< observationEndDate_type, char > observationEndDate_traits;

    const observationEndDate_type&
    observationEndDate () const;

    observationEndDate_type&
    observationEndDate ();

    void
    observationEndDate (const observationEndDate_type& x);

    void
    observationEndDate (::std::auto_ptr< observationEndDate_type > p);

    // calculationPeriodFrequency
    // 
    typedef ::FpML_4_2::CalculationPeriodFrequency calculationPeriodFrequency_type;
    typedef ::xsd::cxx::tree::traits< calculationPeriodFrequency_type, char > calculationPeriodFrequency_traits;

    const calculationPeriodFrequency_type&
    calculationPeriodFrequency () const;

    calculationPeriodFrequency_type&
    calculationPeriodFrequency ();

    void
    calculationPeriodFrequency (const calculationPeriodFrequency_type& x);

    void
    calculationPeriodFrequency (::std::auto_ptr< calculationPeriodFrequency_type > p);

    // Constructors.
    //
    FxAverageRateObservationSchedule (const observationStartDate_type&,
                                      const observationEndDate_type&,
                                      const calculationPeriodFrequency_type&);

    FxAverageRateObservationSchedule (const observationStartDate_type&,
                                      const observationEndDate_type&,
                                      ::std::auto_ptr< calculationPeriodFrequency_type >&);

    FxAverageRateObservationSchedule (const ::xercesc::DOMElement& e,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    FxAverageRateObservationSchedule (const FxAverageRateObservationSchedule& x,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    virtual FxAverageRateObservationSchedule*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxAverageRateObservationSchedule ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< observationStartDate_type > observationStartDate_;
    ::xsd::cxx::tree::one< observationEndDate_type > observationEndDate_;
    ::xsd::cxx::tree::one< calculationPeriodFrequency_type > calculationPeriodFrequency_;
  };

  class FxAverageRateOption: public ::FpML_4_2::Product
  {
    public:
    // buyerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference buyerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< buyerPartyReference_type, char > buyerPartyReference_traits;

    const buyerPartyReference_type&
    buyerPartyReference () const;

    buyerPartyReference_type&
    buyerPartyReference ();

    void
    buyerPartyReference (const buyerPartyReference_type& x);

    void
    buyerPartyReference (::std::auto_ptr< buyerPartyReference_type > p);

    // sellerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference sellerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< sellerPartyReference_type, char > sellerPartyReference_traits;

    const sellerPartyReference_type&
    sellerPartyReference () const;

    sellerPartyReference_type&
    sellerPartyReference ();

    void
    sellerPartyReference (const sellerPartyReference_type& x);

    void
    sellerPartyReference (::std::auto_ptr< sellerPartyReference_type > p);

    // expiryDateTime
    // 
    typedef ::FpML_4_2::ExpiryDateTime expiryDateTime_type;
    typedef ::xsd::cxx::tree::traits< expiryDateTime_type, char > expiryDateTime_traits;

    const expiryDateTime_type&
    expiryDateTime () const;

    expiryDateTime_type&
    expiryDateTime ();

    void
    expiryDateTime (const expiryDateTime_type& x);

    void
    expiryDateTime (::std::auto_ptr< expiryDateTime_type > p);

    // exerciseStyle
    // 
    typedef ::FpML_4_2::ExerciseStyleEnum exerciseStyle_type;
    typedef ::xsd::cxx::tree::traits< exerciseStyle_type, char > exerciseStyle_traits;

    const exerciseStyle_type&
    exerciseStyle () const;

    exerciseStyle_type&
    exerciseStyle ();

    void
    exerciseStyle (const exerciseStyle_type& x);

    void
    exerciseStyle (::std::auto_ptr< exerciseStyle_type > p);

    // fxOptionPremium
    // 
    typedef ::FpML_4_2::FxOptionPremium fxOptionPremium_type;
    typedef ::xsd::cxx::tree::sequence< fxOptionPremium_type > fxOptionPremium_sequence;
    typedef fxOptionPremium_sequence::iterator fxOptionPremium_iterator;
    typedef fxOptionPremium_sequence::const_iterator fxOptionPremium_const_iterator;
    typedef ::xsd::cxx::tree::traits< fxOptionPremium_type, char > fxOptionPremium_traits;

    const fxOptionPremium_sequence&
    fxOptionPremium () const;

    fxOptionPremium_sequence&
    fxOptionPremium ();

    void
    fxOptionPremium (const fxOptionPremium_sequence& s);

    // valueDate
    // 
    typedef ::xml_schema::date valueDate_type;
    typedef ::xsd::cxx::tree::traits< valueDate_type, char > valueDate_traits;

    const valueDate_type&
    valueDate () const;

    valueDate_type&
    valueDate ();

    void
    valueDate (const valueDate_type& x);

    void
    valueDate (::std::auto_ptr< valueDate_type > p);

    // putCurrencyAmount
    // 
    typedef ::FpML_4_2::Money putCurrencyAmount_type;
    typedef ::xsd::cxx::tree::traits< putCurrencyAmount_type, char > putCurrencyAmount_traits;

    const putCurrencyAmount_type&
    putCurrencyAmount () const;

    putCurrencyAmount_type&
    putCurrencyAmount ();

    void
    putCurrencyAmount (const putCurrencyAmount_type& x);

    void
    putCurrencyAmount (::std::auto_ptr< putCurrencyAmount_type > p);

    // callCurrencyAmount
    // 
    typedef ::FpML_4_2::Money callCurrencyAmount_type;
    typedef ::xsd::cxx::tree::traits< callCurrencyAmount_type, char > callCurrencyAmount_traits;

    const callCurrencyAmount_type&
    callCurrencyAmount () const;

    callCurrencyAmount_type&
    callCurrencyAmount ();

    void
    callCurrencyAmount (const callCurrencyAmount_type& x);

    void
    callCurrencyAmount (::std::auto_ptr< callCurrencyAmount_type > p);

    // fxStrikePrice
    // 
    typedef ::FpML_4_2::FxStrikePrice fxStrikePrice_type;
    typedef ::xsd::cxx::tree::traits< fxStrikePrice_type, char > fxStrikePrice_traits;

    const fxStrikePrice_type&
    fxStrikePrice () const;

    fxStrikePrice_type&
    fxStrikePrice ();

    void
    fxStrikePrice (const fxStrikePrice_type& x);

    void
    fxStrikePrice (::std::auto_ptr< fxStrikePrice_type > p);

    // spotRate
    // 
    typedef ::xml_schema::decimal spotRate_type;
    typedef ::xsd::cxx::tree::optional< spotRate_type > spotRate_optional;
    typedef ::xsd::cxx::tree::traits< spotRate_type, char, ::xsd::cxx::tree::schema_type::decimal > spotRate_traits;

    const spotRate_optional&
    spotRate () const;

    spotRate_optional&
    spotRate ();

    void
    spotRate (const spotRate_type& x);

    void
    spotRate (const spotRate_optional& x);

    // payoutCurrency
    // 
    typedef ::FpML_4_2::Currency payoutCurrency_type;
    typedef ::xsd::cxx::tree::traits< payoutCurrency_type, char > payoutCurrency_traits;

    const payoutCurrency_type&
    payoutCurrency () const;

    payoutCurrency_type&
    payoutCurrency ();

    void
    payoutCurrency (const payoutCurrency_type& x);

    void
    payoutCurrency (::std::auto_ptr< payoutCurrency_type > p);

    // averageRateQuoteBasis
    // 
    typedef ::FpML_4_2::StrikeQuoteBasisEnum averageRateQuoteBasis_type;
    typedef ::xsd::cxx::tree::traits< averageRateQuoteBasis_type, char > averageRateQuoteBasis_traits;

    const averageRateQuoteBasis_type&
    averageRateQuoteBasis () const;

    averageRateQuoteBasis_type&
    averageRateQuoteBasis ();

    void
    averageRateQuoteBasis (const averageRateQuoteBasis_type& x);

    void
    averageRateQuoteBasis (::std::auto_ptr< averageRateQuoteBasis_type > p);

    // precision
    // 
    typedef ::xml_schema::non_negative_integer precision_type;
    typedef ::xsd::cxx::tree::optional< precision_type > precision_optional;
    typedef ::xsd::cxx::tree::traits< precision_type, char > precision_traits;

    const precision_optional&
    precision () const;

    precision_optional&
    precision ();

    void
    precision (const precision_type& x);

    void
    precision (const precision_optional& x);

    // payoutFormula
    // 
    typedef ::xml_schema::string payoutFormula_type;
    typedef ::xsd::cxx::tree::optional< payoutFormula_type > payoutFormula_optional;
    typedef ::xsd::cxx::tree::traits< payoutFormula_type, char > payoutFormula_traits;

    const payoutFormula_optional&
    payoutFormula () const;

    payoutFormula_optional&
    payoutFormula ();

    void
    payoutFormula (const payoutFormula_type& x);

    void
    payoutFormula (const payoutFormula_optional& x);

    void
    payoutFormula (::std::auto_ptr< payoutFormula_type > p);

    // primaryRateSource
    // 
    typedef ::FpML_4_2::InformationSource primaryRateSource_type;
    typedef ::xsd::cxx::tree::traits< primaryRateSource_type, char > primaryRateSource_traits;

    const primaryRateSource_type&
    primaryRateSource () const;

    primaryRateSource_type&
    primaryRateSource ();

    void
    primaryRateSource (const primaryRateSource_type& x);

    void
    primaryRateSource (::std::auto_ptr< primaryRateSource_type > p);

    // secondaryRateSource
    // 
    typedef ::FpML_4_2::InformationSource secondaryRateSource_type;
    typedef ::xsd::cxx::tree::optional< secondaryRateSource_type > secondaryRateSource_optional;
    typedef ::xsd::cxx::tree::traits< secondaryRateSource_type, char > secondaryRateSource_traits;

    const secondaryRateSource_optional&
    secondaryRateSource () const;

    secondaryRateSource_optional&
    secondaryRateSource ();

    void
    secondaryRateSource (const secondaryRateSource_type& x);

    void
    secondaryRateSource (const secondaryRateSource_optional& x);

    void
    secondaryRateSource (::std::auto_ptr< secondaryRateSource_type > p);

    // fixingTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime fixingTime_type;
    typedef ::xsd::cxx::tree::traits< fixingTime_type, char > fixingTime_traits;

    const fixingTime_type&
    fixingTime () const;

    fixingTime_type&
    fixingTime ();

    void
    fixingTime (const fixingTime_type& x);

    void
    fixingTime (::std::auto_ptr< fixingTime_type > p);

    // averageRateObservationSchedule
    // 
    typedef ::FpML_4_2::FxAverageRateObservationSchedule averageRateObservationSchedule_type;
    typedef ::xsd::cxx::tree::optional< averageRateObservationSchedule_type > averageRateObservationSchedule_optional;
    typedef ::xsd::cxx::tree::traits< averageRateObservationSchedule_type, char > averageRateObservationSchedule_traits;

    const averageRateObservationSchedule_optional&
    averageRateObservationSchedule () const;

    averageRateObservationSchedule_optional&
    averageRateObservationSchedule ();

    void
    averageRateObservationSchedule (const averageRateObservationSchedule_type& x);

    void
    averageRateObservationSchedule (const averageRateObservationSchedule_optional& x);

    void
    averageRateObservationSchedule (::std::auto_ptr< averageRateObservationSchedule_type > p);

    // averageRateObservationDate
    // 
    typedef ::FpML_4_2::FxAverageRateObservationDate averageRateObservationDate_type;
    typedef ::xsd::cxx::tree::sequence< averageRateObservationDate_type > averageRateObservationDate_sequence;
    typedef averageRateObservationDate_sequence::iterator averageRateObservationDate_iterator;
    typedef averageRateObservationDate_sequence::const_iterator averageRateObservationDate_const_iterator;
    typedef ::xsd::cxx::tree::traits< averageRateObservationDate_type, char > averageRateObservationDate_traits;

    const averageRateObservationDate_sequence&
    averageRateObservationDate () const;

    averageRateObservationDate_sequence&
    averageRateObservationDate ();

    void
    averageRateObservationDate (const averageRateObservationDate_sequence& s);

    // observedRates
    // 
    typedef ::FpML_4_2::ObservedRates observedRates_type;
    typedef ::xsd::cxx::tree::sequence< observedRates_type > observedRates_sequence;
    typedef observedRates_sequence::iterator observedRates_iterator;
    typedef observedRates_sequence::const_iterator observedRates_const_iterator;
    typedef ::xsd::cxx::tree::traits< observedRates_type, char > observedRates_traits;

    const observedRates_sequence&
    observedRates () const;

    observedRates_sequence&
    observedRates ();

    void
    observedRates (const observedRates_sequence& s);

    // Constructors.
    //
    FxAverageRateOption (const buyerPartyReference_type&,
                         const sellerPartyReference_type&,
                         const expiryDateTime_type&,
                         const exerciseStyle_type&,
                         const valueDate_type&,
                         const putCurrencyAmount_type&,
                         const callCurrencyAmount_type&,
                         const fxStrikePrice_type&,
                         const payoutCurrency_type&,
                         const averageRateQuoteBasis_type&,
                         const primaryRateSource_type&,
                         const fixingTime_type&);

    FxAverageRateOption (::std::auto_ptr< buyerPartyReference_type >&,
                         ::std::auto_ptr< sellerPartyReference_type >&,
                         ::std::auto_ptr< expiryDateTime_type >&,
                         const exerciseStyle_type&,
                         const valueDate_type&,
                         ::std::auto_ptr< putCurrencyAmount_type >&,
                         ::std::auto_ptr< callCurrencyAmount_type >&,
                         ::std::auto_ptr< fxStrikePrice_type >&,
                         ::std::auto_ptr< payoutCurrency_type >&,
                         const averageRateQuoteBasis_type&,
                         ::std::auto_ptr< primaryRateSource_type >&,
                         ::std::auto_ptr< fixingTime_type >&);

    FxAverageRateOption (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    FxAverageRateOption (const FxAverageRateOption& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual FxAverageRateOption*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxAverageRateOption ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< buyerPartyReference_type > buyerPartyReference_;
    ::xsd::cxx::tree::one< sellerPartyReference_type > sellerPartyReference_;
    ::xsd::cxx::tree::one< expiryDateTime_type > expiryDateTime_;
    ::xsd::cxx::tree::one< exerciseStyle_type > exerciseStyle_;
    fxOptionPremium_sequence fxOptionPremium_;
    ::xsd::cxx::tree::one< valueDate_type > valueDate_;
    ::xsd::cxx::tree::one< putCurrencyAmount_type > putCurrencyAmount_;
    ::xsd::cxx::tree::one< callCurrencyAmount_type > callCurrencyAmount_;
    ::xsd::cxx::tree::one< fxStrikePrice_type > fxStrikePrice_;
    spotRate_optional spotRate_;
    ::xsd::cxx::tree::one< payoutCurrency_type > payoutCurrency_;
    ::xsd::cxx::tree::one< averageRateQuoteBasis_type > averageRateQuoteBasis_;
    precision_optional precision_;
    payoutFormula_optional payoutFormula_;
    ::xsd::cxx::tree::one< primaryRateSource_type > primaryRateSource_;
    secondaryRateSource_optional secondaryRateSource_;
    ::xsd::cxx::tree::one< fixingTime_type > fixingTime_;
    averageRateObservationSchedule_optional averageRateObservationSchedule_;
    averageRateObservationDate_sequence averageRateObservationDate_;
    observedRates_sequence observedRates_;
  };

  class FxBarrier: public ::xml_schema::type
  {
    public:
    // fxBarrierType
    // 
    typedef ::FpML_4_2::FxBarrierTypeEnum fxBarrierType_type;
    typedef ::xsd::cxx::tree::optional< fxBarrierType_type > fxBarrierType_optional;
    typedef ::xsd::cxx::tree::traits< fxBarrierType_type, char > fxBarrierType_traits;

    const fxBarrierType_optional&
    fxBarrierType () const;

    fxBarrierType_optional&
    fxBarrierType ();

    void
    fxBarrierType (const fxBarrierType_type& x);

    void
    fxBarrierType (const fxBarrierType_optional& x);

    void
    fxBarrierType (::std::auto_ptr< fxBarrierType_type > p);

    // quotedCurrencyPair
    // 
    typedef ::FpML_4_2::QuotedCurrencyPair quotedCurrencyPair_type;
    typedef ::xsd::cxx::tree::traits< quotedCurrencyPair_type, char > quotedCurrencyPair_traits;

    const quotedCurrencyPair_type&
    quotedCurrencyPair () const;

    quotedCurrencyPair_type&
    quotedCurrencyPair ();

    void
    quotedCurrencyPair (const quotedCurrencyPair_type& x);

    void
    quotedCurrencyPair (::std::auto_ptr< quotedCurrencyPair_type > p);

    // triggerRate
    // 
    typedef ::xml_schema::decimal triggerRate_type;
    typedef ::xsd::cxx::tree::traits< triggerRate_type, char, ::xsd::cxx::tree::schema_type::decimal > triggerRate_traits;

    const triggerRate_type&
    triggerRate () const;

    triggerRate_type&
    triggerRate ();

    void
    triggerRate (const triggerRate_type& x);

    // informationSource
    // 
    typedef ::FpML_4_2::InformationSource informationSource_type;
    typedef ::xsd::cxx::tree::sequence< informationSource_type > informationSource_sequence;
    typedef informationSource_sequence::iterator informationSource_iterator;
    typedef informationSource_sequence::const_iterator informationSource_const_iterator;
    typedef ::xsd::cxx::tree::traits< informationSource_type, char > informationSource_traits;

    const informationSource_sequence&
    informationSource () const;

    informationSource_sequence&
    informationSource ();

    void
    informationSource (const informationSource_sequence& s);

    // observationStartDate
    // 
    typedef ::xml_schema::date observationStartDate_type;
    typedef ::xsd::cxx::tree::optional< observationStartDate_type > observationStartDate_optional;
    typedef ::xsd::cxx::tree::traits< observationStartDate_type, char > observationStartDate_traits;

    const observationStartDate_optional&
    observationStartDate () const;

    observationStartDate_optional&
    observationStartDate ();

    void
    observationStartDate (const observationStartDate_type& x);

    void
    observationStartDate (const observationStartDate_optional& x);

    void
    observationStartDate (::std::auto_ptr< observationStartDate_type > p);

    // observationEndDate
    // 
    typedef ::xml_schema::date observationEndDate_type;
    typedef ::xsd::cxx::tree::optional< observationEndDate_type > observationEndDate_optional;
    typedef ::xsd::cxx::tree::traits< observationEndDate_type, char > observationEndDate_traits;

    const observationEndDate_optional&
    observationEndDate () const;

    observationEndDate_optional&
    observationEndDate ();

    void
    observationEndDate (const observationEndDate_type& x);

    void
    observationEndDate (const observationEndDate_optional& x);

    void
    observationEndDate (::std::auto_ptr< observationEndDate_type > p);

    // Constructors.
    //
    FxBarrier (const quotedCurrencyPair_type&,
               const triggerRate_type&);

    FxBarrier (::std::auto_ptr< quotedCurrencyPair_type >&,
               const triggerRate_type&);

    FxBarrier (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    FxBarrier (const FxBarrier& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual FxBarrier*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxBarrier ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    fxBarrierType_optional fxBarrierType_;
    ::xsd::cxx::tree::one< quotedCurrencyPair_type > quotedCurrencyPair_;
    ::xsd::cxx::tree::one< triggerRate_type > triggerRate_;
    informationSource_sequence informationSource_;
    observationStartDate_optional observationStartDate_;
    observationEndDate_optional observationEndDate_;
  };

  class FxOptionLeg: public ::FpML_4_2::Product
  {
    public:
    // buyerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference buyerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< buyerPartyReference_type, char > buyerPartyReference_traits;

    const buyerPartyReference_type&
    buyerPartyReference () const;

    buyerPartyReference_type&
    buyerPartyReference ();

    void
    buyerPartyReference (const buyerPartyReference_type& x);

    void
    buyerPartyReference (::std::auto_ptr< buyerPartyReference_type > p);

    // sellerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference sellerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< sellerPartyReference_type, char > sellerPartyReference_traits;

    const sellerPartyReference_type&
    sellerPartyReference () const;

    sellerPartyReference_type&
    sellerPartyReference ();

    void
    sellerPartyReference (const sellerPartyReference_type& x);

    void
    sellerPartyReference (::std::auto_ptr< sellerPartyReference_type > p);

    // expiryDateTime
    // 
    typedef ::FpML_4_2::ExpiryDateTime expiryDateTime_type;
    typedef ::xsd::cxx::tree::traits< expiryDateTime_type, char > expiryDateTime_traits;

    const expiryDateTime_type&
    expiryDateTime () const;

    expiryDateTime_type&
    expiryDateTime ();

    void
    expiryDateTime (const expiryDateTime_type& x);

    void
    expiryDateTime (::std::auto_ptr< expiryDateTime_type > p);

    // exerciseStyle
    // 
    typedef ::FpML_4_2::ExerciseStyleEnum exerciseStyle_type;
    typedef ::xsd::cxx::tree::traits< exerciseStyle_type, char > exerciseStyle_traits;

    const exerciseStyle_type&
    exerciseStyle () const;

    exerciseStyle_type&
    exerciseStyle ();

    void
    exerciseStyle (const exerciseStyle_type& x);

    void
    exerciseStyle (::std::auto_ptr< exerciseStyle_type > p);

    // fxOptionPremium
    // 
    typedef ::FpML_4_2::FxOptionPremium fxOptionPremium_type;
    typedef ::xsd::cxx::tree::sequence< fxOptionPremium_type > fxOptionPremium_sequence;
    typedef fxOptionPremium_sequence::iterator fxOptionPremium_iterator;
    typedef fxOptionPremium_sequence::const_iterator fxOptionPremium_const_iterator;
    typedef ::xsd::cxx::tree::traits< fxOptionPremium_type, char > fxOptionPremium_traits;

    const fxOptionPremium_sequence&
    fxOptionPremium () const;

    fxOptionPremium_sequence&
    fxOptionPremium ();

    void
    fxOptionPremium (const fxOptionPremium_sequence& s);

    // valueDate
    // 
    typedef ::xml_schema::date valueDate_type;
    typedef ::xsd::cxx::tree::traits< valueDate_type, char > valueDate_traits;

    const valueDate_type&
    valueDate () const;

    valueDate_type&
    valueDate ();

    void
    valueDate (const valueDate_type& x);

    void
    valueDate (::std::auto_ptr< valueDate_type > p);

    // cashSettlementTerms
    // 
    typedef ::FpML_4_2::FxCashSettlement cashSettlementTerms_type;
    typedef ::xsd::cxx::tree::optional< cashSettlementTerms_type > cashSettlementTerms_optional;
    typedef ::xsd::cxx::tree::traits< cashSettlementTerms_type, char > cashSettlementTerms_traits;

    const cashSettlementTerms_optional&
    cashSettlementTerms () const;

    cashSettlementTerms_optional&
    cashSettlementTerms ();

    void
    cashSettlementTerms (const cashSettlementTerms_type& x);

    void
    cashSettlementTerms (const cashSettlementTerms_optional& x);

    void
    cashSettlementTerms (::std::auto_ptr< cashSettlementTerms_type > p);

    // putCurrencyAmount
    // 
    typedef ::FpML_4_2::Money putCurrencyAmount_type;
    typedef ::xsd::cxx::tree::traits< putCurrencyAmount_type, char > putCurrencyAmount_traits;

    const putCurrencyAmount_type&
    putCurrencyAmount () const;

    putCurrencyAmount_type&
    putCurrencyAmount ();

    void
    putCurrencyAmount (const putCurrencyAmount_type& x);

    void
    putCurrencyAmount (::std::auto_ptr< putCurrencyAmount_type > p);

    // callCurrencyAmount
    // 
    typedef ::FpML_4_2::Money callCurrencyAmount_type;
    typedef ::xsd::cxx::tree::traits< callCurrencyAmount_type, char > callCurrencyAmount_traits;

    const callCurrencyAmount_type&
    callCurrencyAmount () const;

    callCurrencyAmount_type&
    callCurrencyAmount ();

    void
    callCurrencyAmount (const callCurrencyAmount_type& x);

    void
    callCurrencyAmount (::std::auto_ptr< callCurrencyAmount_type > p);

    // fxStrikePrice
    // 
    typedef ::FpML_4_2::FxStrikePrice fxStrikePrice_type;
    typedef ::xsd::cxx::tree::traits< fxStrikePrice_type, char > fxStrikePrice_traits;

    const fxStrikePrice_type&
    fxStrikePrice () const;

    fxStrikePrice_type&
    fxStrikePrice ();

    void
    fxStrikePrice (const fxStrikePrice_type& x);

    void
    fxStrikePrice (::std::auto_ptr< fxStrikePrice_type > p);

    // quotedAs
    // 
    typedef ::FpML_4_2::QuotedAs quotedAs_type;
    typedef ::xsd::cxx::tree::optional< quotedAs_type > quotedAs_optional;
    typedef ::xsd::cxx::tree::traits< quotedAs_type, char > quotedAs_traits;

    const quotedAs_optional&
    quotedAs () const;

    quotedAs_optional&
    quotedAs ();

    void
    quotedAs (const quotedAs_type& x);

    void
    quotedAs (const quotedAs_optional& x);

    void
    quotedAs (::std::auto_ptr< quotedAs_type > p);

    // Constructors.
    //
    FxOptionLeg (const buyerPartyReference_type&,
                 const sellerPartyReference_type&,
                 const expiryDateTime_type&,
                 const exerciseStyle_type&,
                 const valueDate_type&,
                 const putCurrencyAmount_type&,
                 const callCurrencyAmount_type&,
                 const fxStrikePrice_type&);

    FxOptionLeg (::std::auto_ptr< buyerPartyReference_type >&,
                 ::std::auto_ptr< sellerPartyReference_type >&,
                 ::std::auto_ptr< expiryDateTime_type >&,
                 const exerciseStyle_type&,
                 const valueDate_type&,
                 ::std::auto_ptr< putCurrencyAmount_type >&,
                 ::std::auto_ptr< callCurrencyAmount_type >&,
                 ::std::auto_ptr< fxStrikePrice_type >&);

    FxOptionLeg (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    FxOptionLeg (const FxOptionLeg& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual FxOptionLeg*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxOptionLeg ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< buyerPartyReference_type > buyerPartyReference_;
    ::xsd::cxx::tree::one< sellerPartyReference_type > sellerPartyReference_;
    ::xsd::cxx::tree::one< expiryDateTime_type > expiryDateTime_;
    ::xsd::cxx::tree::one< exerciseStyle_type > exerciseStyle_;
    fxOptionPremium_sequence fxOptionPremium_;
    ::xsd::cxx::tree::one< valueDate_type > valueDate_;
    cashSettlementTerms_optional cashSettlementTerms_;
    ::xsd::cxx::tree::one< putCurrencyAmount_type > putCurrencyAmount_;
    ::xsd::cxx::tree::one< callCurrencyAmount_type > callCurrencyAmount_;
    ::xsd::cxx::tree::one< fxStrikePrice_type > fxStrikePrice_;
    quotedAs_optional quotedAs_;
  };

  class FxBarrierOption: public ::FpML_4_2::FxOptionLeg
  {
    public:
    // spotRate
    // 
    typedef ::xml_schema::decimal spotRate_type;
    typedef ::xsd::cxx::tree::optional< spotRate_type > spotRate_optional;
    typedef ::xsd::cxx::tree::traits< spotRate_type, char, ::xsd::cxx::tree::schema_type::decimal > spotRate_traits;

    const spotRate_optional&
    spotRate () const;

    spotRate_optional&
    spotRate ();

    void
    spotRate (const spotRate_type& x);

    void
    spotRate (const spotRate_optional& x);

    // fxBarrier
    // 
    typedef ::FpML_4_2::FxBarrier fxBarrier_type;
    typedef ::xsd::cxx::tree::sequence< fxBarrier_type > fxBarrier_sequence;
    typedef fxBarrier_sequence::iterator fxBarrier_iterator;
    typedef fxBarrier_sequence::const_iterator fxBarrier_const_iterator;
    typedef ::xsd::cxx::tree::traits< fxBarrier_type, char > fxBarrier_traits;

    const fxBarrier_sequence&
    fxBarrier () const;

    fxBarrier_sequence&
    fxBarrier ();

    void
    fxBarrier (const fxBarrier_sequence& s);

    // triggerPayout
    // 
    typedef ::FpML_4_2::FxOptionPayout triggerPayout_type;
    typedef ::xsd::cxx::tree::optional< triggerPayout_type > triggerPayout_optional;
    typedef ::xsd::cxx::tree::traits< triggerPayout_type, char > triggerPayout_traits;

    const triggerPayout_optional&
    triggerPayout () const;

    triggerPayout_optional&
    triggerPayout ();

    void
    triggerPayout (const triggerPayout_type& x);

    void
    triggerPayout (const triggerPayout_optional& x);

    void
    triggerPayout (::std::auto_ptr< triggerPayout_type > p);

    // Constructors.
    //
    FxBarrierOption (const buyerPartyReference_type&,
                     const sellerPartyReference_type&,
                     const expiryDateTime_type&,
                     const exerciseStyle_type&,
                     const valueDate_type&,
                     const putCurrencyAmount_type&,
                     const callCurrencyAmount_type&,
                     const fxStrikePrice_type&);

    FxBarrierOption (::std::auto_ptr< buyerPartyReference_type >&,
                     ::std::auto_ptr< sellerPartyReference_type >&,
                     ::std::auto_ptr< expiryDateTime_type >&,
                     const exerciseStyle_type&,
                     const valueDate_type&,
                     ::std::auto_ptr< putCurrencyAmount_type >&,
                     ::std::auto_ptr< callCurrencyAmount_type >&,
                     ::std::auto_ptr< fxStrikePrice_type >&);

    FxBarrierOption (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    FxBarrierOption (const FxBarrierOption& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual FxBarrierOption*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxBarrierOption ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    spotRate_optional spotRate_;
    fxBarrier_sequence fxBarrier_;
    triggerPayout_optional triggerPayout_;
  };

  class FxDigitalOption: public ::FpML_4_2::Product
  {
    public:
    // buyerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference buyerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< buyerPartyReference_type, char > buyerPartyReference_traits;

    const buyerPartyReference_type&
    buyerPartyReference () const;

    buyerPartyReference_type&
    buyerPartyReference ();

    void
    buyerPartyReference (const buyerPartyReference_type& x);

    void
    buyerPartyReference (::std::auto_ptr< buyerPartyReference_type > p);

    // sellerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference sellerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< sellerPartyReference_type, char > sellerPartyReference_traits;

    const sellerPartyReference_type&
    sellerPartyReference () const;

    sellerPartyReference_type&
    sellerPartyReference ();

    void
    sellerPartyReference (const sellerPartyReference_type& x);

    void
    sellerPartyReference (::std::auto_ptr< sellerPartyReference_type > p);

    // expiryDateTime
    // 
    typedef ::FpML_4_2::ExpiryDateTime expiryDateTime_type;
    typedef ::xsd::cxx::tree::traits< expiryDateTime_type, char > expiryDateTime_traits;

    const expiryDateTime_type&
    expiryDateTime () const;

    expiryDateTime_type&
    expiryDateTime ();

    void
    expiryDateTime (const expiryDateTime_type& x);

    void
    expiryDateTime (::std::auto_ptr< expiryDateTime_type > p);

    // fxOptionPremium
    // 
    typedef ::FpML_4_2::FxOptionPremium fxOptionPremium_type;
    typedef ::xsd::cxx::tree::sequence< fxOptionPremium_type > fxOptionPremium_sequence;
    typedef fxOptionPremium_sequence::iterator fxOptionPremium_iterator;
    typedef fxOptionPremium_sequence::const_iterator fxOptionPremium_const_iterator;
    typedef ::xsd::cxx::tree::traits< fxOptionPremium_type, char > fxOptionPremium_traits;

    const fxOptionPremium_sequence&
    fxOptionPremium () const;

    fxOptionPremium_sequence&
    fxOptionPremium ();

    void
    fxOptionPremium (const fxOptionPremium_sequence& s);

    // valueDate
    // 
    typedef ::xml_schema::date valueDate_type;
    typedef ::xsd::cxx::tree::traits< valueDate_type, char > valueDate_traits;

    const valueDate_type&
    valueDate () const;

    valueDate_type&
    valueDate ();

    void
    valueDate (const valueDate_type& x);

    void
    valueDate (::std::auto_ptr< valueDate_type > p);

    // quotedCurrencyPair
    // 
    typedef ::FpML_4_2::QuotedCurrencyPair quotedCurrencyPair_type;
    typedef ::xsd::cxx::tree::traits< quotedCurrencyPair_type, char > quotedCurrencyPair_traits;

    const quotedCurrencyPair_type&
    quotedCurrencyPair () const;

    quotedCurrencyPair_type&
    quotedCurrencyPair ();

    void
    quotedCurrencyPair (const quotedCurrencyPair_type& x);

    void
    quotedCurrencyPair (::std::auto_ptr< quotedCurrencyPair_type > p);

    // spotRate
    // 
    typedef ::xml_schema::decimal spotRate_type;
    typedef ::xsd::cxx::tree::optional< spotRate_type > spotRate_optional;
    typedef ::xsd::cxx::tree::traits< spotRate_type, char, ::xsd::cxx::tree::schema_type::decimal > spotRate_traits;

    const spotRate_optional&
    spotRate () const;

    spotRate_optional&
    spotRate ();

    void
    spotRate (const spotRate_type& x);

    void
    spotRate (const spotRate_optional& x);

    // fxEuropeanTrigger
    // 
    typedef ::FpML_4_2::FxEuropeanTrigger fxEuropeanTrigger_type;
    typedef ::xsd::cxx::tree::sequence< fxEuropeanTrigger_type > fxEuropeanTrigger_sequence;
    typedef fxEuropeanTrigger_sequence::iterator fxEuropeanTrigger_iterator;
    typedef fxEuropeanTrigger_sequence::const_iterator fxEuropeanTrigger_const_iterator;
    typedef ::xsd::cxx::tree::traits< fxEuropeanTrigger_type, char > fxEuropeanTrigger_traits;

    const fxEuropeanTrigger_sequence&
    fxEuropeanTrigger () const;

    fxEuropeanTrigger_sequence&
    fxEuropeanTrigger ();

    void
    fxEuropeanTrigger (const fxEuropeanTrigger_sequence& s);

    // fxAmericanTrigger
    // 
    typedef ::FpML_4_2::FxAmericanTrigger fxAmericanTrigger_type;
    typedef ::xsd::cxx::tree::sequence< fxAmericanTrigger_type > fxAmericanTrigger_sequence;
    typedef fxAmericanTrigger_sequence::iterator fxAmericanTrigger_iterator;
    typedef fxAmericanTrigger_sequence::const_iterator fxAmericanTrigger_const_iterator;
    typedef ::xsd::cxx::tree::traits< fxAmericanTrigger_type, char > fxAmericanTrigger_traits;

    const fxAmericanTrigger_sequence&
    fxAmericanTrigger () const;

    fxAmericanTrigger_sequence&
    fxAmericanTrigger ();

    void
    fxAmericanTrigger (const fxAmericanTrigger_sequence& s);

    // triggerPayout
    // 
    typedef ::FpML_4_2::FxOptionPayout triggerPayout_type;
    typedef ::xsd::cxx::tree::traits< triggerPayout_type, char > triggerPayout_traits;

    const triggerPayout_type&
    triggerPayout () const;

    triggerPayout_type&
    triggerPayout ();

    void
    triggerPayout (const triggerPayout_type& x);

    void
    triggerPayout (::std::auto_ptr< triggerPayout_type > p);

    // Constructors.
    //
    FxDigitalOption (const buyerPartyReference_type&,
                     const sellerPartyReference_type&,
                     const expiryDateTime_type&,
                     const valueDate_type&,
                     const quotedCurrencyPair_type&,
                     const triggerPayout_type&);

    FxDigitalOption (::std::auto_ptr< buyerPartyReference_type >&,
                     ::std::auto_ptr< sellerPartyReference_type >&,
                     ::std::auto_ptr< expiryDateTime_type >&,
                     const valueDate_type&,
                     ::std::auto_ptr< quotedCurrencyPair_type >&,
                     ::std::auto_ptr< triggerPayout_type >&);

    FxDigitalOption (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    FxDigitalOption (const FxDigitalOption& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual FxDigitalOption*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxDigitalOption ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< buyerPartyReference_type > buyerPartyReference_;
    ::xsd::cxx::tree::one< sellerPartyReference_type > sellerPartyReference_;
    ::xsd::cxx::tree::one< expiryDateTime_type > expiryDateTime_;
    fxOptionPremium_sequence fxOptionPremium_;
    ::xsd::cxx::tree::one< valueDate_type > valueDate_;
    ::xsd::cxx::tree::one< quotedCurrencyPair_type > quotedCurrencyPair_;
    spotRate_optional spotRate_;
    fxEuropeanTrigger_sequence fxEuropeanTrigger_;
    fxAmericanTrigger_sequence fxAmericanTrigger_;
    ::xsd::cxx::tree::one< triggerPayout_type > triggerPayout_;
  };

  class FxEuropeanTrigger: public ::xml_schema::type
  {
    public:
    // triggerCondition
    // 
    typedef ::FpML_4_2::TriggerConditionEnum triggerCondition_type;
    typedef ::xsd::cxx::tree::traits< triggerCondition_type, char > triggerCondition_traits;

    const triggerCondition_type&
    triggerCondition () const;

    triggerCondition_type&
    triggerCondition ();

    void
    triggerCondition (const triggerCondition_type& x);

    void
    triggerCondition (::std::auto_ptr< triggerCondition_type > p);

    // quotedCurrencyPair
    // 
    typedef ::FpML_4_2::QuotedCurrencyPair quotedCurrencyPair_type;
    typedef ::xsd::cxx::tree::traits< quotedCurrencyPair_type, char > quotedCurrencyPair_traits;

    const quotedCurrencyPair_type&
    quotedCurrencyPair () const;

    quotedCurrencyPair_type&
    quotedCurrencyPair ();

    void
    quotedCurrencyPair (const quotedCurrencyPair_type& x);

    void
    quotedCurrencyPair (::std::auto_ptr< quotedCurrencyPair_type > p);

    // triggerRate
    // 
    typedef ::xml_schema::decimal triggerRate_type;
    typedef ::xsd::cxx::tree::traits< triggerRate_type, char, ::xsd::cxx::tree::schema_type::decimal > triggerRate_traits;

    const triggerRate_type&
    triggerRate () const;

    triggerRate_type&
    triggerRate ();

    void
    triggerRate (const triggerRate_type& x);

    // informationSource
    // 
    typedef ::FpML_4_2::InformationSource informationSource_type;
    typedef ::xsd::cxx::tree::sequence< informationSource_type > informationSource_sequence;
    typedef informationSource_sequence::iterator informationSource_iterator;
    typedef informationSource_sequence::const_iterator informationSource_const_iterator;
    typedef ::xsd::cxx::tree::traits< informationSource_type, char > informationSource_traits;

    const informationSource_sequence&
    informationSource () const;

    informationSource_sequence&
    informationSource ();

    void
    informationSource (const informationSource_sequence& s);

    // Constructors.
    //
    FxEuropeanTrigger (const triggerCondition_type&,
                       const quotedCurrencyPair_type&,
                       const triggerRate_type&);

    FxEuropeanTrigger (const triggerCondition_type&,
                       ::std::auto_ptr< quotedCurrencyPair_type >&,
                       const triggerRate_type&);

    FxEuropeanTrigger (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    FxEuropeanTrigger (const FxEuropeanTrigger& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual FxEuropeanTrigger*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxEuropeanTrigger ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< triggerCondition_type > triggerCondition_;
    ::xsd::cxx::tree::one< quotedCurrencyPair_type > quotedCurrencyPair_;
    ::xsd::cxx::tree::one< triggerRate_type > triggerRate_;
    informationSource_sequence informationSource_;
  };

  class FxLeg: public ::FpML_4_2::Product
  {
    public:
    // exchangedCurrency1
    // 
    typedef ::FpML_4_2::Payment exchangedCurrency1_type;
    typedef ::xsd::cxx::tree::traits< exchangedCurrency1_type, char > exchangedCurrency1_traits;

    const exchangedCurrency1_type&
    exchangedCurrency1 () const;

    exchangedCurrency1_type&
    exchangedCurrency1 ();

    void
    exchangedCurrency1 (const exchangedCurrency1_type& x);

    void
    exchangedCurrency1 (::std::auto_ptr< exchangedCurrency1_type > p);

    // exchangedCurrency2
    // 
    typedef ::FpML_4_2::Payment exchangedCurrency2_type;
    typedef ::xsd::cxx::tree::traits< exchangedCurrency2_type, char > exchangedCurrency2_traits;

    const exchangedCurrency2_type&
    exchangedCurrency2 () const;

    exchangedCurrency2_type&
    exchangedCurrency2 ();

    void
    exchangedCurrency2 (const exchangedCurrency2_type& x);

    void
    exchangedCurrency2 (::std::auto_ptr< exchangedCurrency2_type > p);

    // valueDate
    // 
    typedef ::xml_schema::date valueDate_type;
    typedef ::xsd::cxx::tree::optional< valueDate_type > valueDate_optional;
    typedef ::xsd::cxx::tree::traits< valueDate_type, char > valueDate_traits;

    const valueDate_optional&
    valueDate () const;

    valueDate_optional&
    valueDate ();

    void
    valueDate (const valueDate_type& x);

    void
    valueDate (const valueDate_optional& x);

    void
    valueDate (::std::auto_ptr< valueDate_type > p);

    // currency1ValueDate
    // 
    typedef ::xml_schema::date currency1ValueDate_type;
    typedef ::xsd::cxx::tree::optional< currency1ValueDate_type > currency1ValueDate_optional;
    typedef ::xsd::cxx::tree::traits< currency1ValueDate_type, char > currency1ValueDate_traits;

    const currency1ValueDate_optional&
    currency1ValueDate () const;

    currency1ValueDate_optional&
    currency1ValueDate ();

    void
    currency1ValueDate (const currency1ValueDate_type& x);

    void
    currency1ValueDate (const currency1ValueDate_optional& x);

    void
    currency1ValueDate (::std::auto_ptr< currency1ValueDate_type > p);

    // currency2ValueDate
    // 
    typedef ::xml_schema::date currency2ValueDate_type;
    typedef ::xsd::cxx::tree::optional< currency2ValueDate_type > currency2ValueDate_optional;
    typedef ::xsd::cxx::tree::traits< currency2ValueDate_type, char > currency2ValueDate_traits;

    const currency2ValueDate_optional&
    currency2ValueDate () const;

    currency2ValueDate_optional&
    currency2ValueDate ();

    void
    currency2ValueDate (const currency2ValueDate_type& x);

    void
    currency2ValueDate (const currency2ValueDate_optional& x);

    void
    currency2ValueDate (::std::auto_ptr< currency2ValueDate_type > p);

    // exchangeRate
    // 
    typedef ::FpML_4_2::ExchangeRate exchangeRate_type;
    typedef ::xsd::cxx::tree::traits< exchangeRate_type, char > exchangeRate_traits;

    const exchangeRate_type&
    exchangeRate () const;

    exchangeRate_type&
    exchangeRate ();

    void
    exchangeRate (const exchangeRate_type& x);

    void
    exchangeRate (::std::auto_ptr< exchangeRate_type > p);

    // nonDeliverableForward
    // 
    typedef ::FpML_4_2::FxCashSettlement nonDeliverableForward_type;
    typedef ::xsd::cxx::tree::optional< nonDeliverableForward_type > nonDeliverableForward_optional;
    typedef ::xsd::cxx::tree::traits< nonDeliverableForward_type, char > nonDeliverableForward_traits;

    const nonDeliverableForward_optional&
    nonDeliverableForward () const;

    nonDeliverableForward_optional&
    nonDeliverableForward ();

    void
    nonDeliverableForward (const nonDeliverableForward_type& x);

    void
    nonDeliverableForward (const nonDeliverableForward_optional& x);

    void
    nonDeliverableForward (::std::auto_ptr< nonDeliverableForward_type > p);

    // confirmationSenderPartyReference
    // 
    typedef ::FpML_4_2::PartyReference confirmationSenderPartyReference_type;
    typedef ::xsd::cxx::tree::optional< confirmationSenderPartyReference_type > confirmationSenderPartyReference_optional;
    typedef ::xsd::cxx::tree::traits< confirmationSenderPartyReference_type, char > confirmationSenderPartyReference_traits;

    const confirmationSenderPartyReference_optional&
    confirmationSenderPartyReference () const;

    confirmationSenderPartyReference_optional&
    confirmationSenderPartyReference ();

    void
    confirmationSenderPartyReference (const confirmationSenderPartyReference_type& x);

    void
    confirmationSenderPartyReference (const confirmationSenderPartyReference_optional& x);

    void
    confirmationSenderPartyReference (::std::auto_ptr< confirmationSenderPartyReference_type > p);

    // Constructors.
    //
    FxLeg (const exchangedCurrency1_type&,
           const exchangedCurrency2_type&,
           const exchangeRate_type&);

    FxLeg (::std::auto_ptr< exchangedCurrency1_type >&,
           ::std::auto_ptr< exchangedCurrency2_type >&,
           ::std::auto_ptr< exchangeRate_type >&);

    FxLeg (const ::xercesc::DOMElement& e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    FxLeg (const FxLeg& x,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    virtual FxLeg*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxLeg ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< exchangedCurrency1_type > exchangedCurrency1_;
    ::xsd::cxx::tree::one< exchangedCurrency2_type > exchangedCurrency2_;
    valueDate_optional valueDate_;
    currency1ValueDate_optional currency1ValueDate_;
    currency2ValueDate_optional currency2ValueDate_;
    ::xsd::cxx::tree::one< exchangeRate_type > exchangeRate_;
    nonDeliverableForward_optional nonDeliverableForward_;
    confirmationSenderPartyReference_optional confirmationSenderPartyReference_;
  };

  class FxOptionPayout: public ::FpML_4_2::Money
  {
    public:
    // payoutStyle
    // 
    typedef ::FpML_4_2::PayoutEnum payoutStyle_type;
    typedef ::xsd::cxx::tree::traits< payoutStyle_type, char > payoutStyle_traits;

    const payoutStyle_type&
    payoutStyle () const;

    payoutStyle_type&
    payoutStyle ();

    void
    payoutStyle (const payoutStyle_type& x);

    void
    payoutStyle (::std::auto_ptr< payoutStyle_type > p);

    // settlementInformation
    // 
    typedef ::FpML_4_2::SettlementInformation settlementInformation_type;
    typedef ::xsd::cxx::tree::optional< settlementInformation_type > settlementInformation_optional;
    typedef ::xsd::cxx::tree::traits< settlementInformation_type, char > settlementInformation_traits;

    const settlementInformation_optional&
    settlementInformation () const;

    settlementInformation_optional&
    settlementInformation ();

    void
    settlementInformation (const settlementInformation_type& x);

    void
    settlementInformation (const settlementInformation_optional& x);

    void
    settlementInformation (::std::auto_ptr< settlementInformation_type > p);

    // Constructors.
    //
    FxOptionPayout (const currency_type&,
                    const amount_type&,
                    const payoutStyle_type&);

    FxOptionPayout (::std::auto_ptr< currency_type >&,
                    const amount_type&,
                    const payoutStyle_type&);

    FxOptionPayout (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    FxOptionPayout (const FxOptionPayout& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual FxOptionPayout*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxOptionPayout ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payoutStyle_type > payoutStyle_;
    settlementInformation_optional settlementInformation_;
  };

  class FxOptionPremium: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // premiumAmount
    // 
    typedef ::FpML_4_2::Money premiumAmount_type;
    typedef ::xsd::cxx::tree::traits< premiumAmount_type, char > premiumAmount_traits;

    const premiumAmount_type&
    premiumAmount () const;

    premiumAmount_type&
    premiumAmount ();

    void
    premiumAmount (const premiumAmount_type& x);

    void
    premiumAmount (::std::auto_ptr< premiumAmount_type > p);

    // premiumSettlementDate
    // 
    typedef ::xml_schema::date premiumSettlementDate_type;
    typedef ::xsd::cxx::tree::traits< premiumSettlementDate_type, char > premiumSettlementDate_traits;

    const premiumSettlementDate_type&
    premiumSettlementDate () const;

    premiumSettlementDate_type&
    premiumSettlementDate ();

    void
    premiumSettlementDate (const premiumSettlementDate_type& x);

    void
    premiumSettlementDate (::std::auto_ptr< premiumSettlementDate_type > p);

    // settlementInformation
    // 
    typedef ::FpML_4_2::SettlementInformation settlementInformation_type;
    typedef ::xsd::cxx::tree::optional< settlementInformation_type > settlementInformation_optional;
    typedef ::xsd::cxx::tree::traits< settlementInformation_type, char > settlementInformation_traits;

    const settlementInformation_optional&
    settlementInformation () const;

    settlementInformation_optional&
    settlementInformation ();

    void
    settlementInformation (const settlementInformation_type& x);

    void
    settlementInformation (const settlementInformation_optional& x);

    void
    settlementInformation (::std::auto_ptr< settlementInformation_type > p);

    // premiumQuote
    // 
    typedef ::FpML_4_2::PremiumQuote premiumQuote_type;
    typedef ::xsd::cxx::tree::optional< premiumQuote_type > premiumQuote_optional;
    typedef ::xsd::cxx::tree::traits< premiumQuote_type, char > premiumQuote_traits;

    const premiumQuote_optional&
    premiumQuote () const;

    premiumQuote_optional&
    premiumQuote ();

    void
    premiumQuote (const premiumQuote_type& x);

    void
    premiumQuote (const premiumQuote_optional& x);

    void
    premiumQuote (::std::auto_ptr< premiumQuote_type > p);

    // Constructors.
    //
    FxOptionPremium (const payerPartyReference_type&,
                     const receiverPartyReference_type&,
                     const premiumAmount_type&,
                     const premiumSettlementDate_type&);

    FxOptionPremium (::std::auto_ptr< payerPartyReference_type >&,
                     ::std::auto_ptr< receiverPartyReference_type >&,
                     ::std::auto_ptr< premiumAmount_type >&,
                     const premiumSettlementDate_type&);

    FxOptionPremium (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    FxOptionPremium (const FxOptionPremium& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual FxOptionPremium*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxOptionPremium ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    ::xsd::cxx::tree::one< premiumAmount_type > premiumAmount_;
    ::xsd::cxx::tree::one< premiumSettlementDate_type > premiumSettlementDate_;
    settlementInformation_optional settlementInformation_;
    premiumQuote_optional premiumQuote_;
  };

  class FxStrikePrice: public ::xml_schema::type
  {
    public:
    // rate
    // 
    typedef ::xml_schema::decimal rate_type;
    typedef ::xsd::cxx::tree::traits< rate_type, char, ::xsd::cxx::tree::schema_type::decimal > rate_traits;

    const rate_type&
    rate () const;

    rate_type&
    rate ();

    void
    rate (const rate_type& x);

    // strikeQuoteBasis
    // 
    typedef ::FpML_4_2::StrikeQuoteBasisEnum strikeQuoteBasis_type;
    typedef ::xsd::cxx::tree::traits< strikeQuoteBasis_type, char > strikeQuoteBasis_traits;

    const strikeQuoteBasis_type&
    strikeQuoteBasis () const;

    strikeQuoteBasis_type&
    strikeQuoteBasis ();

    void
    strikeQuoteBasis (const strikeQuoteBasis_type& x);

    void
    strikeQuoteBasis (::std::auto_ptr< strikeQuoteBasis_type > p);

    // Constructors.
    //
    FxStrikePrice (const rate_type&,
                   const strikeQuoteBasis_type&);

    FxStrikePrice (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    FxStrikePrice (const FxStrikePrice& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual FxStrikePrice*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxStrikePrice ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< rate_type > rate_;
    ::xsd::cxx::tree::one< strikeQuoteBasis_type > strikeQuoteBasis_;
  };

  class FxSwap: public ::FpML_4_2::Product
  {
    public:
    // fxSingleLeg
    // 
    typedef ::FpML_4_2::FxLeg fxSingleLeg_type;
    typedef ::xsd::cxx::tree::sequence< fxSingleLeg_type > fxSingleLeg_sequence;
    typedef fxSingleLeg_sequence::iterator fxSingleLeg_iterator;
    typedef fxSingleLeg_sequence::const_iterator fxSingleLeg_const_iterator;
    typedef ::xsd::cxx::tree::traits< fxSingleLeg_type, char > fxSingleLeg_traits;

    const fxSingleLeg_sequence&
    fxSingleLeg () const;

    fxSingleLeg_sequence&
    fxSingleLeg ();

    void
    fxSingleLeg (const fxSingleLeg_sequence& s);

    // Constructors.
    //
    FxSwap ();

    FxSwap (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    FxSwap (const FxSwap& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual FxSwap*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxSwap ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    fxSingleLeg_sequence fxSingleLeg_;
  };

  class ObservedRates: public ::xml_schema::type
  {
    public:
    // observationDate
    // 
    typedef ::xml_schema::date observationDate_type;
    typedef ::xsd::cxx::tree::traits< observationDate_type, char > observationDate_traits;

    const observationDate_type&
    observationDate () const;

    observationDate_type&
    observationDate ();

    void
    observationDate (const observationDate_type& x);

    void
    observationDate (::std::auto_ptr< observationDate_type > p);

    // observedRate
    // 
    typedef ::xml_schema::decimal observedRate_type;
    typedef ::xsd::cxx::tree::traits< observedRate_type, char, ::xsd::cxx::tree::schema_type::decimal > observedRate_traits;

    const observedRate_type&
    observedRate () const;

    observedRate_type&
    observedRate ();

    void
    observedRate (const observedRate_type& x);

    // Constructors.
    //
    ObservedRates (const observationDate_type&,
                   const observedRate_type&);

    ObservedRates (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    ObservedRates (const ObservedRates& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual ObservedRates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ObservedRates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< observationDate_type > observationDate_;
    ::xsd::cxx::tree::one< observedRate_type > observedRate_;
  };

  class PremiumQuote: public ::xml_schema::type
  {
    public:
    // premiumValue
    // 
    typedef ::xml_schema::decimal premiumValue_type;
    typedef ::xsd::cxx::tree::traits< premiumValue_type, char, ::xsd::cxx::tree::schema_type::decimal > premiumValue_traits;

    const premiumValue_type&
    premiumValue () const;

    premiumValue_type&
    premiumValue ();

    void
    premiumValue (const premiumValue_type& x);

    // premiumQuoteBasis
    // 
    typedef ::FpML_4_2::PremiumQuoteBasisEnum premiumQuoteBasis_type;
    typedef ::xsd::cxx::tree::traits< premiumQuoteBasis_type, char > premiumQuoteBasis_traits;

    const premiumQuoteBasis_type&
    premiumQuoteBasis () const;

    premiumQuoteBasis_type&
    premiumQuoteBasis ();

    void
    premiumQuoteBasis (const premiumQuoteBasis_type& x);

    void
    premiumQuoteBasis (::std::auto_ptr< premiumQuoteBasis_type > p);

    // Constructors.
    //
    PremiumQuote (const premiumValue_type&,
                  const premiumQuoteBasis_type&);

    PremiumQuote (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    PremiumQuote (const PremiumQuote& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual PremiumQuote*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PremiumQuote ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< premiumValue_type > premiumValue_;
    ::xsd::cxx::tree::one< premiumQuoteBasis_type > premiumQuoteBasis_;
  };

  class QuotedAs: public ::xml_schema::type
  {
    public:
    // optionOnCurrency
    // 
    typedef ::FpML_4_2::Currency optionOnCurrency_type;
    typedef ::xsd::cxx::tree::traits< optionOnCurrency_type, char > optionOnCurrency_traits;

    const optionOnCurrency_type&
    optionOnCurrency () const;

    optionOnCurrency_type&
    optionOnCurrency ();

    void
    optionOnCurrency (const optionOnCurrency_type& x);

    void
    optionOnCurrency (::std::auto_ptr< optionOnCurrency_type > p);

    // faceOnCurrency
    // 
    typedef ::FpML_4_2::Currency faceOnCurrency_type;
    typedef ::xsd::cxx::tree::traits< faceOnCurrency_type, char > faceOnCurrency_traits;

    const faceOnCurrency_type&
    faceOnCurrency () const;

    faceOnCurrency_type&
    faceOnCurrency ();

    void
    faceOnCurrency (const faceOnCurrency_type& x);

    void
    faceOnCurrency (::std::auto_ptr< faceOnCurrency_type > p);

    // quotedTenor
    // 
    typedef ::FpML_4_2::Interval quotedTenor_type;
    typedef ::xsd::cxx::tree::optional< quotedTenor_type > quotedTenor_optional;
    typedef ::xsd::cxx::tree::traits< quotedTenor_type, char > quotedTenor_traits;

    const quotedTenor_optional&
    quotedTenor () const;

    quotedTenor_optional&
    quotedTenor ();

    void
    quotedTenor (const quotedTenor_type& x);

    void
    quotedTenor (const quotedTenor_optional& x);

    void
    quotedTenor (::std::auto_ptr< quotedTenor_type > p);

    // Constructors.
    //
    QuotedAs (const optionOnCurrency_type&,
              const faceOnCurrency_type&);

    QuotedAs (::std::auto_ptr< optionOnCurrency_type >&,
              ::std::auto_ptr< faceOnCurrency_type >&);

    QuotedAs (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    QuotedAs (const QuotedAs& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual QuotedAs*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~QuotedAs ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< optionOnCurrency_type > optionOnCurrency_;
    ::xsd::cxx::tree::one< faceOnCurrency_type > faceOnCurrency_;
    quotedTenor_optional quotedTenor_;
  };

  class SideRate: public ::xml_schema::type
  {
    public:
    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_type&
    currency () const;

    currency_type&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // sideRateBasis
    // 
    typedef ::FpML_4_2::SideRateBasisEnum sideRateBasis_type;
    typedef ::xsd::cxx::tree::traits< sideRateBasis_type, char > sideRateBasis_traits;

    const sideRateBasis_type&
    sideRateBasis () const;

    sideRateBasis_type&
    sideRateBasis ();

    void
    sideRateBasis (const sideRateBasis_type& x);

    void
    sideRateBasis (::std::auto_ptr< sideRateBasis_type > p);

    // rate
    // 
    typedef ::xml_schema::decimal rate_type;
    typedef ::xsd::cxx::tree::traits< rate_type, char, ::xsd::cxx::tree::schema_type::decimal > rate_traits;

    const rate_type&
    rate () const;

    rate_type&
    rate ();

    void
    rate (const rate_type& x);

    // spotRate
    // 
    typedef ::xml_schema::decimal spotRate_type;
    typedef ::xsd::cxx::tree::optional< spotRate_type > spotRate_optional;
    typedef ::xsd::cxx::tree::traits< spotRate_type, char, ::xsd::cxx::tree::schema_type::decimal > spotRate_traits;

    const spotRate_optional&
    spotRate () const;

    spotRate_optional&
    spotRate ();

    void
    spotRate (const spotRate_type& x);

    void
    spotRate (const spotRate_optional& x);

    // forwardPoints
    // 
    typedef ::xml_schema::decimal forwardPoints_type;
    typedef ::xsd::cxx::tree::optional< forwardPoints_type > forwardPoints_optional;
    typedef ::xsd::cxx::tree::traits< forwardPoints_type, char, ::xsd::cxx::tree::schema_type::decimal > forwardPoints_traits;

    const forwardPoints_optional&
    forwardPoints () const;

    forwardPoints_optional&
    forwardPoints ();

    void
    forwardPoints (const forwardPoints_type& x);

    void
    forwardPoints (const forwardPoints_optional& x);

    // Constructors.
    //
    SideRate (const currency_type&,
              const sideRateBasis_type&,
              const rate_type&);

    SideRate (::std::auto_ptr< currency_type >&,
              const sideRateBasis_type&,
              const rate_type&);

    SideRate (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    SideRate (const SideRate& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual SideRate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SideRate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< currency_type > currency_;
    ::xsd::cxx::tree::one< sideRateBasis_type > sideRateBasis_;
    ::xsd::cxx::tree::one< rate_type > rate_;
    spotRate_optional spotRate_;
    forwardPoints_optional forwardPoints_;
  };

  class SideRates: public ::xml_schema::type
  {
    public:
    // baseCurrency
    // 
    typedef ::FpML_4_2::Currency baseCurrency_type;
    typedef ::xsd::cxx::tree::traits< baseCurrency_type, char > baseCurrency_traits;

    const baseCurrency_type&
    baseCurrency () const;

    baseCurrency_type&
    baseCurrency ();

    void
    baseCurrency (const baseCurrency_type& x);

    void
    baseCurrency (::std::auto_ptr< baseCurrency_type > p);

    // currency1SideRate
    // 
    typedef ::FpML_4_2::SideRate currency1SideRate_type;
    typedef ::xsd::cxx::tree::optional< currency1SideRate_type > currency1SideRate_optional;
    typedef ::xsd::cxx::tree::traits< currency1SideRate_type, char > currency1SideRate_traits;

    const currency1SideRate_optional&
    currency1SideRate () const;

    currency1SideRate_optional&
    currency1SideRate ();

    void
    currency1SideRate (const currency1SideRate_type& x);

    void
    currency1SideRate (const currency1SideRate_optional& x);

    void
    currency1SideRate (::std::auto_ptr< currency1SideRate_type > p);

    // currency2SideRate
    // 
    typedef ::FpML_4_2::SideRate currency2SideRate_type;
    typedef ::xsd::cxx::tree::optional< currency2SideRate_type > currency2SideRate_optional;
    typedef ::xsd::cxx::tree::traits< currency2SideRate_type, char > currency2SideRate_traits;

    const currency2SideRate_optional&
    currency2SideRate () const;

    currency2SideRate_optional&
    currency2SideRate ();

    void
    currency2SideRate (const currency2SideRate_type& x);

    void
    currency2SideRate (const currency2SideRate_optional& x);

    void
    currency2SideRate (::std::auto_ptr< currency2SideRate_type > p);

    // Constructors.
    //
    SideRates (const baseCurrency_type&);

    SideRates (::std::auto_ptr< baseCurrency_type >&);

    SideRates (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    SideRates (const SideRates& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual SideRates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SideRates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< baseCurrency_type > baseCurrency_;
    currency1SideRate_optional currency1SideRate_;
    currency2SideRate_optional currency2SideRate_;
  };

  class TermDeposit: public ::FpML_4_2::Product
  {
    public:
    // initialPayerReference
    // 
    typedef ::FpML_4_2::PartyReference initialPayerReference_type;
    typedef ::xsd::cxx::tree::traits< initialPayerReference_type, char > initialPayerReference_traits;

    const initialPayerReference_type&
    initialPayerReference () const;

    initialPayerReference_type&
    initialPayerReference ();

    void
    initialPayerReference (const initialPayerReference_type& x);

    void
    initialPayerReference (::std::auto_ptr< initialPayerReference_type > p);

    // initialReceiverReference
    // 
    typedef ::FpML_4_2::PartyReference initialReceiverReference_type;
    typedef ::xsd::cxx::tree::traits< initialReceiverReference_type, char > initialReceiverReference_traits;

    const initialReceiverReference_type&
    initialReceiverReference () const;

    initialReceiverReference_type&
    initialReceiverReference ();

    void
    initialReceiverReference (const initialReceiverReference_type& x);

    void
    initialReceiverReference (::std::auto_ptr< initialReceiverReference_type > p);

    // startDate
    // 
    typedef ::xml_schema::date startDate_type;
    typedef ::xsd::cxx::tree::traits< startDate_type, char > startDate_traits;

    const startDate_type&
    startDate () const;

    startDate_type&
    startDate ();

    void
    startDate (const startDate_type& x);

    void
    startDate (::std::auto_ptr< startDate_type > p);

    // maturityDate
    // 
    typedef ::xml_schema::date maturityDate_type;
    typedef ::xsd::cxx::tree::traits< maturityDate_type, char > maturityDate_traits;

    const maturityDate_type&
    maturityDate () const;

    maturityDate_type&
    maturityDate ();

    void
    maturityDate (const maturityDate_type& x);

    void
    maturityDate (::std::auto_ptr< maturityDate_type > p);

    // dayCountFraction
    // 
    typedef ::FpML_4_2::DayCountFraction dayCountFraction_type;
    typedef ::xsd::cxx::tree::traits< dayCountFraction_type, char > dayCountFraction_traits;

    const dayCountFraction_type&
    dayCountFraction () const;

    dayCountFraction_type&
    dayCountFraction ();

    void
    dayCountFraction (const dayCountFraction_type& x);

    void
    dayCountFraction (::std::auto_ptr< dayCountFraction_type > p);

    // principal
    // 
    typedef ::FpML_4_2::Money principal_type;
    typedef ::xsd::cxx::tree::traits< principal_type, char > principal_traits;

    const principal_type&
    principal () const;

    principal_type&
    principal ();

    void
    principal (const principal_type& x);

    void
    principal (::std::auto_ptr< principal_type > p);

    // fixedRate
    // 
    typedef ::xml_schema::decimal fixedRate_type;
    typedef ::xsd::cxx::tree::traits< fixedRate_type, char, ::xsd::cxx::tree::schema_type::decimal > fixedRate_traits;

    const fixedRate_type&
    fixedRate () const;

    fixedRate_type&
    fixedRate ();

    void
    fixedRate (const fixedRate_type& x);

    // interest
    // 
    typedef ::FpML_4_2::Money interest_type;
    typedef ::xsd::cxx::tree::optional< interest_type > interest_optional;
    typedef ::xsd::cxx::tree::traits< interest_type, char > interest_traits;

    const interest_optional&
    interest () const;

    interest_optional&
    interest ();

    void
    interest (const interest_type& x);

    void
    interest (const interest_optional& x);

    void
    interest (::std::auto_ptr< interest_type > p);

    // payment
    // 
    typedef ::FpML_4_2::Payment payment_type;
    typedef ::xsd::cxx::tree::sequence< payment_type > payment_sequence;
    typedef payment_sequence::iterator payment_iterator;
    typedef payment_sequence::const_iterator payment_const_iterator;
    typedef ::xsd::cxx::tree::traits< payment_type, char > payment_traits;

    const payment_sequence&
    payment () const;

    payment_sequence&
    payment ();

    void
    payment (const payment_sequence& s);

    // Constructors.
    //
    TermDeposit (const initialPayerReference_type&,
                 const initialReceiverReference_type&,
                 const startDate_type&,
                 const maturityDate_type&,
                 const dayCountFraction_type&,
                 const principal_type&,
                 const fixedRate_type&);

    TermDeposit (::std::auto_ptr< initialPayerReference_type >&,
                 ::std::auto_ptr< initialReceiverReference_type >&,
                 const startDate_type&,
                 const maturityDate_type&,
                 ::std::auto_ptr< dayCountFraction_type >&,
                 ::std::auto_ptr< principal_type >&,
                 const fixedRate_type&);

    TermDeposit (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    TermDeposit (const TermDeposit& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual TermDeposit*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TermDeposit ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< initialPayerReference_type > initialPayerReference_;
    ::xsd::cxx::tree::one< initialReceiverReference_type > initialReceiverReference_;
    ::xsd::cxx::tree::one< startDate_type > startDate_;
    ::xsd::cxx::tree::one< maturityDate_type > maturityDate_;
    ::xsd::cxx::tree::one< dayCountFraction_type > dayCountFraction_;
    ::xsd::cxx::tree::one< principal_type > principal_;
    ::xsd::cxx::tree::one< fixedRate_type > fixedRate_;
    interest_optional interest_;
    payment_sequence payment_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const CutName&);

  void
  operator<< (::xercesc::DOMElement&, const ExchangeRate&);

  void
  operator<< (::xercesc::DOMElement&, const ExpiryDateTime&);

  void
  operator<< (::xercesc::DOMElement&, const FxAmericanTrigger&);

  void
  operator<< (::xercesc::DOMElement&, const FxAverageRateObservationDate&);

  void
  operator<< (::xercesc::DOMElement&, const FxAverageRateObservationSchedule&);

  void
  operator<< (::xercesc::DOMElement&, const FxAverageRateOption&);

  void
  operator<< (::xercesc::DOMElement&, const FxBarrier&);

  void
  operator<< (::xercesc::DOMElement&, const FxOptionLeg&);

  void
  operator<< (::xercesc::DOMElement&, const FxBarrierOption&);

  void
  operator<< (::xercesc::DOMElement&, const FxDigitalOption&);

  void
  operator<< (::xercesc::DOMElement&, const FxEuropeanTrigger&);

  void
  operator<< (::xercesc::DOMElement&, const FxLeg&);

  void
  operator<< (::xercesc::DOMElement&, const FxOptionPayout&);

  void
  operator<< (::xercesc::DOMElement&, const FxOptionPremium&);

  void
  operator<< (::xercesc::DOMElement&, const FxStrikePrice&);

  void
  operator<< (::xercesc::DOMElement&, const FxSwap&);

  void
  operator<< (::xercesc::DOMElement&, const ObservedRates&);

  void
  operator<< (::xercesc::DOMElement&, const PremiumQuote&);

  void
  operator<< (::xercesc::DOMElement&, const QuotedAs&);

  void
  operator<< (::xercesc::DOMElement&, const SideRate&);

  void
  operator<< (::xercesc::DOMElement&, const SideRates&);

  void
  operator<< (::xercesc::DOMElement&, const TermDeposit&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_FX_4_2_HXX
