// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_MKTENV_4_2_HXX
#define FPML_MKTENV_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class CompoundingFrequency;
  class PricingStructure;
  class CreditCurve;
  class PricingStructureValuation;
  class CreditCurveValuation;
  class DefaultProbabilityCurve;
  class ForwardRateCurve;
  class FxCurve;
  class FxCurveValuation;
  class QuotedAssetSet;
  class FxRateSet;
  class GenericDimension;
  class InstrumentSet;
  class InterpolationMethod;
  class Market;
  class MultiDimensionalPricingData;
  class ParametricAdjustment;
  class ParametricAdjustmentPoint;
  class PricingDataPointCoordinate;
  class PricingDataPointCoordinateReference;
  class PricingInputType;
  class PricingMethod;
  class PricingStructureReference;
  class PricingStructurePoint;
  class TermCurve;
  class TermPoint;
  class TimeDimension;
  class VolatilityMatrix;
  class VolatilityRepresentation;
  class YieldCurve;
  class YieldCurveValuation;
  class ZeroRateCurve;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-asset-4-2.hxx"

#include "fpml-valuation-base-4-2.hxx"

#include "fpml-cd-4-2.hxx"

#include "fpml-shared-4-2.hxx"

namespace FpML_4_2
{
  class CompoundingFrequency: public ::xml_schema::normalized_string
  {
    public:
    // compoundingFrequencyScheme
    // 
    typedef ::xml_schema::uri compoundingFrequencyScheme_type;
    typedef ::xsd::cxx::tree::traits< compoundingFrequencyScheme_type, char > compoundingFrequencyScheme_traits;

    const compoundingFrequencyScheme_type&
    compoundingFrequencyScheme () const;

    compoundingFrequencyScheme_type&
    compoundingFrequencyScheme ();

    void
    compoundingFrequencyScheme (const compoundingFrequencyScheme_type& x);

    void
    compoundingFrequencyScheme (::std::auto_ptr< compoundingFrequencyScheme_type > p);

    static const compoundingFrequencyScheme_type&
    compoundingFrequencyScheme_default_value ();

    // Constructors.
    //
    CompoundingFrequency ();

    CompoundingFrequency (const char*);

    CompoundingFrequency (const ::std::string&);

    CompoundingFrequency (const ::xml_schema::normalized_string&);

    CompoundingFrequency (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    CompoundingFrequency (const CompoundingFrequency& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual CompoundingFrequency*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CompoundingFrequency ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< compoundingFrequencyScheme_type > compoundingFrequencyScheme_;
    static const compoundingFrequencyScheme_type compoundingFrequencyScheme_default_value_;
  };

  class PricingStructure: public ::xml_schema::type
  {
    public:
    // name
    // 
    typedef ::xml_schema::normalized_string name_type;
    typedef ::xsd::cxx::tree::optional< name_type > name_optional;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_optional&
    name () const;

    name_optional&
    name ();

    void
    name (const name_type& x);

    void
    name (const name_optional& x);

    void
    name (::std::auto_ptr< name_type > p);

    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::optional< currency_type > currency_optional;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_optional&
    currency () const;

    currency_optional&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (const currency_optional& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    PricingStructure ();

    PricingStructure (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    PricingStructure (const PricingStructure& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual PricingStructure*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PricingStructure ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    name_optional name_;
    currency_optional currency_;
    id_optional id_;
  };

  class CreditCurve: public ::FpML_4_2::PricingStructure
  {
    public:
    // referenceEntity
    // 
    typedef ::FpML_4_2::LegalEntity referenceEntity_type;
    typedef ::xsd::cxx::tree::optional< referenceEntity_type > referenceEntity_optional;
    typedef ::xsd::cxx::tree::traits< referenceEntity_type, char > referenceEntity_traits;

    const referenceEntity_optional&
    referenceEntity () const;

    referenceEntity_optional&
    referenceEntity ();

    void
    referenceEntity (const referenceEntity_type& x);

    void
    referenceEntity (const referenceEntity_optional& x);

    void
    referenceEntity (::std::auto_ptr< referenceEntity_type > p);

    // creditEntityReference
    // 
    typedef ::FpML_4_2::LegalEntityReference creditEntityReference_type;
    typedef ::xsd::cxx::tree::optional< creditEntityReference_type > creditEntityReference_optional;
    typedef ::xsd::cxx::tree::traits< creditEntityReference_type, char > creditEntityReference_traits;

    const creditEntityReference_optional&
    creditEntityReference () const;

    creditEntityReference_optional&
    creditEntityReference ();

    void
    creditEntityReference (const creditEntityReference_type& x);

    void
    creditEntityReference (const creditEntityReference_optional& x);

    void
    creditEntityReference (::std::auto_ptr< creditEntityReference_type > p);

    // creditEvents
    // 
    typedef ::FpML_4_2::CreditEvents creditEvents_type;
    typedef ::xsd::cxx::tree::optional< creditEvents_type > creditEvents_optional;
    typedef ::xsd::cxx::tree::traits< creditEvents_type, char > creditEvents_traits;

    const creditEvents_optional&
    creditEvents () const;

    creditEvents_optional&
    creditEvents ();

    void
    creditEvents (const creditEvents_type& x);

    void
    creditEvents (const creditEvents_optional& x);

    void
    creditEvents (::std::auto_ptr< creditEvents_type > p);

    // seniority
    // 
    typedef ::FpML_4_2::CreditSeniority seniority_type;
    typedef ::xsd::cxx::tree::optional< seniority_type > seniority_optional;
    typedef ::xsd::cxx::tree::traits< seniority_type, char > seniority_traits;

    const seniority_optional&
    seniority () const;

    seniority_optional&
    seniority ();

    void
    seniority (const seniority_type& x);

    void
    seniority (const seniority_optional& x);

    void
    seniority (::std::auto_ptr< seniority_type > p);

    // secured
    // 
    typedef ::xml_schema::boolean secured_type;
    typedef ::xsd::cxx::tree::optional< secured_type > secured_optional;
    typedef ::xsd::cxx::tree::traits< secured_type, char > secured_traits;

    const secured_optional&
    secured () const;

    secured_optional&
    secured ();

    void
    secured (const secured_type& x);

    void
    secured (const secured_optional& x);

    // currency
    // 
    typedef ::FpML_4_2::Currency currency1_type;
    typedef ::xsd::cxx::tree::optional< currency1_type > currency1_optional;
    typedef ::xsd::cxx::tree::traits< currency1_type, char > currency1_traits;

    const currency1_optional&
    currency1 () const;

    currency1_optional&
    currency1 ();

    void
    currency1 (const currency1_type& x);

    void
    currency1 (const currency1_optional& x);

    void
    currency1 (::std::auto_ptr< currency1_type > p);

    // obligations
    // 
    typedef ::FpML_4_2::Obligations obligations_type;
    typedef ::xsd::cxx::tree::optional< obligations_type > obligations_optional;
    typedef ::xsd::cxx::tree::traits< obligations_type, char > obligations_traits;

    const obligations_optional&
    obligations () const;

    obligations_optional&
    obligations ();

    void
    obligations (const obligations_type& x);

    void
    obligations (const obligations_optional& x);

    void
    obligations (::std::auto_ptr< obligations_type > p);

    // deliverableObligations
    // 
    typedef ::FpML_4_2::DeliverableObligations deliverableObligations_type;
    typedef ::xsd::cxx::tree::optional< deliverableObligations_type > deliverableObligations_optional;
    typedef ::xsd::cxx::tree::traits< deliverableObligations_type, char > deliverableObligations_traits;

    const deliverableObligations_optional&
    deliverableObligations () const;

    deliverableObligations_optional&
    deliverableObligations ();

    void
    deliverableObligations (const deliverableObligations_type& x);

    void
    deliverableObligations (const deliverableObligations_optional& x);

    void
    deliverableObligations (::std::auto_ptr< deliverableObligations_type > p);

    // Constructors.
    //
    CreditCurve ();

    CreditCurve (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    CreditCurve (const CreditCurve& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual CreditCurve*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CreditCurve ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    referenceEntity_optional referenceEntity_;
    creditEntityReference_optional creditEntityReference_;
    creditEvents_optional creditEvents_;
    seniority_optional seniority_;
    secured_optional secured_;
    currency1_optional currency1_;
    obligations_optional obligations_;
    deliverableObligations_optional deliverableObligations_;
  };

  class PricingStructureValuation: public ::FpML_4_2::Valuation
  {
    public:
    // baseDate
    // 
    typedef ::FpML_4_2::IdentifiedDate baseDate_type;
    typedef ::xsd::cxx::tree::traits< baseDate_type, char > baseDate_traits;

    const baseDate_type&
    baseDate () const;

    baseDate_type&
    baseDate ();

    void
    baseDate (const baseDate_type& x);

    void
    baseDate (::std::auto_ptr< baseDate_type > p);

    // spotDate
    // 
    typedef ::FpML_4_2::IdentifiedDate spotDate_type;
    typedef ::xsd::cxx::tree::optional< spotDate_type > spotDate_optional;
    typedef ::xsd::cxx::tree::traits< spotDate_type, char > spotDate_traits;

    const spotDate_optional&
    spotDate () const;

    spotDate_optional&
    spotDate ();

    void
    spotDate (const spotDate_type& x);

    void
    spotDate (const spotDate_optional& x);

    void
    spotDate (::std::auto_ptr< spotDate_type > p);

    // inputDataDate
    // 
    typedef ::FpML_4_2::IdentifiedDate inputDataDate_type;
    typedef ::xsd::cxx::tree::optional< inputDataDate_type > inputDataDate_optional;
    typedef ::xsd::cxx::tree::traits< inputDataDate_type, char > inputDataDate_traits;

    const inputDataDate_optional&
    inputDataDate () const;

    inputDataDate_optional&
    inputDataDate ();

    void
    inputDataDate (const inputDataDate_type& x);

    void
    inputDataDate (const inputDataDate_optional& x);

    void
    inputDataDate (::std::auto_ptr< inputDataDate_type > p);

    // endDate
    // 
    typedef ::FpML_4_2::IdentifiedDate endDate_type;
    typedef ::xsd::cxx::tree::optional< endDate_type > endDate_optional;
    typedef ::xsd::cxx::tree::traits< endDate_type, char > endDate_traits;

    const endDate_optional&
    endDate () const;

    endDate_optional&
    endDate ();

    void
    endDate (const endDate_type& x);

    void
    endDate (const endDate_optional& x);

    void
    endDate (::std::auto_ptr< endDate_type > p);

    // buildDateTime
    // 
    typedef ::xml_schema::date_time buildDateTime_type;
    typedef ::xsd::cxx::tree::optional< buildDateTime_type > buildDateTime_optional;
    typedef ::xsd::cxx::tree::traits< buildDateTime_type, char > buildDateTime_traits;

    const buildDateTime_optional&
    buildDateTime () const;

    buildDateTime_optional&
    buildDateTime ();

    void
    buildDateTime (const buildDateTime_type& x);

    void
    buildDateTime (const buildDateTime_optional& x);

    void
    buildDateTime (::std::auto_ptr< buildDateTime_type > p);

    // Constructors.
    //
    PricingStructureValuation (const objectReference_type&,
                               const baseDate_type&);

    PricingStructureValuation (::std::auto_ptr< objectReference_type >&,
                               ::std::auto_ptr< baseDate_type >&);

    PricingStructureValuation (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    PricingStructureValuation (const PricingStructureValuation& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual PricingStructureValuation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PricingStructureValuation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< baseDate_type > baseDate_;
    spotDate_optional spotDate_;
    inputDataDate_optional inputDataDate_;
    endDate_optional endDate_;
    buildDateTime_optional buildDateTime_;
  };

  class CreditCurveValuation: public ::FpML_4_2::PricingStructureValuation
  {
    public:
    // inputs
    // 
    typedef ::FpML_4_2::QuotedAssetSet inputs_type;
    typedef ::xsd::cxx::tree::optional< inputs_type > inputs_optional;
    typedef ::xsd::cxx::tree::traits< inputs_type, char > inputs_traits;

    const inputs_optional&
    inputs () const;

    inputs_optional&
    inputs ();

    void
    inputs (const inputs_type& x);

    void
    inputs (const inputs_optional& x);

    void
    inputs (::std::auto_ptr< inputs_type > p);

    // defaultProbabilityCurve
    // 
    typedef ::FpML_4_2::DefaultProbabilityCurve defaultProbabilityCurve_type;
    typedef ::xsd::cxx::tree::optional< defaultProbabilityCurve_type > defaultProbabilityCurve_optional;
    typedef ::xsd::cxx::tree::traits< defaultProbabilityCurve_type, char > defaultProbabilityCurve_traits;

    const defaultProbabilityCurve_optional&
    defaultProbabilityCurve () const;

    defaultProbabilityCurve_optional&
    defaultProbabilityCurve ();

    void
    defaultProbabilityCurve (const defaultProbabilityCurve_type& x);

    void
    defaultProbabilityCurve (const defaultProbabilityCurve_optional& x);

    void
    defaultProbabilityCurve (::std::auto_ptr< defaultProbabilityCurve_type > p);

    // recoveryRate
    // 
    typedef ::xml_schema::decimal recoveryRate_type;
    typedef ::xsd::cxx::tree::optional< recoveryRate_type > recoveryRate_optional;
    typedef ::xsd::cxx::tree::traits< recoveryRate_type, char, ::xsd::cxx::tree::schema_type::decimal > recoveryRate_traits;

    const recoveryRate_optional&
    recoveryRate () const;

    recoveryRate_optional&
    recoveryRate ();

    void
    recoveryRate (const recoveryRate_type& x);

    void
    recoveryRate (const recoveryRate_optional& x);

    // recoveryRateCurve
    // 
    typedef ::FpML_4_2::TermCurve recoveryRateCurve_type;
    typedef ::xsd::cxx::tree::optional< recoveryRateCurve_type > recoveryRateCurve_optional;
    typedef ::xsd::cxx::tree::traits< recoveryRateCurve_type, char > recoveryRateCurve_traits;

    const recoveryRateCurve_optional&
    recoveryRateCurve () const;

    recoveryRateCurve_optional&
    recoveryRateCurve ();

    void
    recoveryRateCurve (const recoveryRateCurve_type& x);

    void
    recoveryRateCurve (const recoveryRateCurve_optional& x);

    void
    recoveryRateCurve (::std::auto_ptr< recoveryRateCurve_type > p);

    // Constructors.
    //
    CreditCurveValuation (const objectReference_type&,
                          const baseDate_type&);

    CreditCurveValuation (::std::auto_ptr< objectReference_type >&,
                          ::std::auto_ptr< baseDate_type >&);

    CreditCurveValuation (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    CreditCurveValuation (const CreditCurveValuation& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual CreditCurveValuation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CreditCurveValuation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    inputs_optional inputs_;
    defaultProbabilityCurve_optional defaultProbabilityCurve_;
    recoveryRate_optional recoveryRate_;
    recoveryRateCurve_optional recoveryRateCurve_;
  };

  class DefaultProbabilityCurve: public ::FpML_4_2::PricingStructureValuation
  {
    public:
    // baseYieldCurve
    // 
    typedef ::FpML_4_2::PricingStructureReference baseYieldCurve_type;
    typedef ::xsd::cxx::tree::traits< baseYieldCurve_type, char > baseYieldCurve_traits;

    const baseYieldCurve_type&
    baseYieldCurve () const;

    baseYieldCurve_type&
    baseYieldCurve ();

    void
    baseYieldCurve (const baseYieldCurve_type& x);

    void
    baseYieldCurve (::std::auto_ptr< baseYieldCurve_type > p);

    // defaultProbabilities
    // 
    typedef ::FpML_4_2::TermCurve defaultProbabilities_type;
    typedef ::xsd::cxx::tree::optional< defaultProbabilities_type > defaultProbabilities_optional;
    typedef ::xsd::cxx::tree::traits< defaultProbabilities_type, char > defaultProbabilities_traits;

    const defaultProbabilities_optional&
    defaultProbabilities () const;

    defaultProbabilities_optional&
    defaultProbabilities ();

    void
    defaultProbabilities (const defaultProbabilities_type& x);

    void
    defaultProbabilities (const defaultProbabilities_optional& x);

    void
    defaultProbabilities (::std::auto_ptr< defaultProbabilities_type > p);

    // Constructors.
    //
    DefaultProbabilityCurve (const objectReference_type&,
                             const baseDate_type&,
                             const baseYieldCurve_type&);

    DefaultProbabilityCurve (::std::auto_ptr< objectReference_type >&,
                             ::std::auto_ptr< baseDate_type >&,
                             ::std::auto_ptr< baseYieldCurve_type >&);

    DefaultProbabilityCurve (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    DefaultProbabilityCurve (const DefaultProbabilityCurve& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual DefaultProbabilityCurve*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DefaultProbabilityCurve ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< baseYieldCurve_type > baseYieldCurve_;
    defaultProbabilities_optional defaultProbabilities_;
  };

  class ForwardRateCurve: public ::xml_schema::type
  {
    public:
    // assetReference
    // 
    typedef ::FpML_4_2::AssetReference assetReference_type;
    typedef ::xsd::cxx::tree::optional< assetReference_type > assetReference_optional;
    typedef ::xsd::cxx::tree::traits< assetReference_type, char > assetReference_traits;

    const assetReference_optional&
    assetReference () const;

    assetReference_optional&
    assetReference ();

    void
    assetReference (const assetReference_type& x);

    void
    assetReference (const assetReference_optional& x);

    void
    assetReference (::std::auto_ptr< assetReference_type > p);

    // rateCurve
    // 
    typedef ::FpML_4_2::TermCurve rateCurve_type;
    typedef ::xsd::cxx::tree::traits< rateCurve_type, char > rateCurve_traits;

    const rateCurve_type&
    rateCurve () const;

    rateCurve_type&
    rateCurve ();

    void
    rateCurve (const rateCurve_type& x);

    void
    rateCurve (::std::auto_ptr< rateCurve_type > p);

    // Constructors.
    //
    ForwardRateCurve (const rateCurve_type&);

    ForwardRateCurve (::std::auto_ptr< rateCurve_type >&);

    ForwardRateCurve (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    ForwardRateCurve (const ForwardRateCurve& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual ForwardRateCurve*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ForwardRateCurve ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    assetReference_optional assetReference_;
    ::xsd::cxx::tree::one< rateCurve_type > rateCurve_;
  };

  class FxCurve: public ::FpML_4_2::PricingStructure
  {
    public:
    // quotedCurrencyPair
    // 
    typedef ::FpML_4_2::QuotedCurrencyPair quotedCurrencyPair_type;
    typedef ::xsd::cxx::tree::optional< quotedCurrencyPair_type > quotedCurrencyPair_optional;
    typedef ::xsd::cxx::tree::traits< quotedCurrencyPair_type, char > quotedCurrencyPair_traits;

    const quotedCurrencyPair_optional&
    quotedCurrencyPair () const;

    quotedCurrencyPair_optional&
    quotedCurrencyPair ();

    void
    quotedCurrencyPair (const quotedCurrencyPair_type& x);

    void
    quotedCurrencyPair (const quotedCurrencyPair_optional& x);

    void
    quotedCurrencyPair (::std::auto_ptr< quotedCurrencyPair_type > p);

    // Constructors.
    //
    FxCurve ();

    FxCurve (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    FxCurve (const FxCurve& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual FxCurve*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxCurve ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    quotedCurrencyPair_optional quotedCurrencyPair_;
  };

  class FxCurveValuation: public ::FpML_4_2::PricingStructureValuation
  {
    public:
    // settlementCurrencyYieldCurve
    // 
    typedef ::FpML_4_2::PricingStructureReference settlementCurrencyYieldCurve_type;
    typedef ::xsd::cxx::tree::optional< settlementCurrencyYieldCurve_type > settlementCurrencyYieldCurve_optional;
    typedef ::xsd::cxx::tree::traits< settlementCurrencyYieldCurve_type, char > settlementCurrencyYieldCurve_traits;

    const settlementCurrencyYieldCurve_optional&
    settlementCurrencyYieldCurve () const;

    settlementCurrencyYieldCurve_optional&
    settlementCurrencyYieldCurve ();

    void
    settlementCurrencyYieldCurve (const settlementCurrencyYieldCurve_type& x);

    void
    settlementCurrencyYieldCurve (const settlementCurrencyYieldCurve_optional& x);

    void
    settlementCurrencyYieldCurve (::std::auto_ptr< settlementCurrencyYieldCurve_type > p);

    // forecastCurrencyYieldCurve
    // 
    typedef ::FpML_4_2::PricingStructureReference forecastCurrencyYieldCurve_type;
    typedef ::xsd::cxx::tree::optional< forecastCurrencyYieldCurve_type > forecastCurrencyYieldCurve_optional;
    typedef ::xsd::cxx::tree::traits< forecastCurrencyYieldCurve_type, char > forecastCurrencyYieldCurve_traits;

    const forecastCurrencyYieldCurve_optional&
    forecastCurrencyYieldCurve () const;

    forecastCurrencyYieldCurve_optional&
    forecastCurrencyYieldCurve ();

    void
    forecastCurrencyYieldCurve (const forecastCurrencyYieldCurve_type& x);

    void
    forecastCurrencyYieldCurve (const forecastCurrencyYieldCurve_optional& x);

    void
    forecastCurrencyYieldCurve (::std::auto_ptr< forecastCurrencyYieldCurve_type > p);

    // spotRate
    // 
    typedef ::FpML_4_2::FxRateSet spotRate_type;
    typedef ::xsd::cxx::tree::optional< spotRate_type > spotRate_optional;
    typedef ::xsd::cxx::tree::traits< spotRate_type, char > spotRate_traits;

    const spotRate_optional&
    spotRate () const;

    spotRate_optional&
    spotRate ();

    void
    spotRate (const spotRate_type& x);

    void
    spotRate (const spotRate_optional& x);

    void
    spotRate (::std::auto_ptr< spotRate_type > p);

    // fxForwardCurve
    // 
    typedef ::FpML_4_2::TermCurve fxForwardCurve_type;
    typedef ::xsd::cxx::tree::optional< fxForwardCurve_type > fxForwardCurve_optional;
    typedef ::xsd::cxx::tree::traits< fxForwardCurve_type, char > fxForwardCurve_traits;

    const fxForwardCurve_optional&
    fxForwardCurve () const;

    fxForwardCurve_optional&
    fxForwardCurve ();

    void
    fxForwardCurve (const fxForwardCurve_type& x);

    void
    fxForwardCurve (const fxForwardCurve_optional& x);

    void
    fxForwardCurve (::std::auto_ptr< fxForwardCurve_type > p);

    // fxForwardPointsCurve
    // 
    typedef ::FpML_4_2::TermCurve fxForwardPointsCurve_type;
    typedef ::xsd::cxx::tree::optional< fxForwardPointsCurve_type > fxForwardPointsCurve_optional;
    typedef ::xsd::cxx::tree::traits< fxForwardPointsCurve_type, char > fxForwardPointsCurve_traits;

    const fxForwardPointsCurve_optional&
    fxForwardPointsCurve () const;

    fxForwardPointsCurve_optional&
    fxForwardPointsCurve ();

    void
    fxForwardPointsCurve (const fxForwardPointsCurve_type& x);

    void
    fxForwardPointsCurve (const fxForwardPointsCurve_optional& x);

    void
    fxForwardPointsCurve (::std::auto_ptr< fxForwardPointsCurve_type > p);

    // Constructors.
    //
    FxCurveValuation (const objectReference_type&,
                      const baseDate_type&);

    FxCurveValuation (::std::auto_ptr< objectReference_type >&,
                      ::std::auto_ptr< baseDate_type >&);

    FxCurveValuation (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    FxCurveValuation (const FxCurveValuation& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual FxCurveValuation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxCurveValuation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    settlementCurrencyYieldCurve_optional settlementCurrencyYieldCurve_;
    forecastCurrencyYieldCurve_optional forecastCurrencyYieldCurve_;
    spotRate_optional spotRate_;
    fxForwardCurve_optional fxForwardCurve_;
    fxForwardPointsCurve_optional fxForwardPointsCurve_;
  };

  class QuotedAssetSet: public ::xml_schema::type
  {
    public:
    // instrumentSet
    // 
    typedef ::FpML_4_2::InstrumentSet instrumentSet_type;
    typedef ::xsd::cxx::tree::optional< instrumentSet_type > instrumentSet_optional;
    typedef ::xsd::cxx::tree::traits< instrumentSet_type, char > instrumentSet_traits;

    const instrumentSet_optional&
    instrumentSet () const;

    instrumentSet_optional&
    instrumentSet ();

    void
    instrumentSet (const instrumentSet_type& x);

    void
    instrumentSet (const instrumentSet_optional& x);

    void
    instrumentSet (::std::auto_ptr< instrumentSet_type > p);

    // assetQuote
    // 
    typedef ::FpML_4_2::BasicAssetValuation assetQuote_type;
    typedef ::xsd::cxx::tree::sequence< assetQuote_type > assetQuote_sequence;
    typedef assetQuote_sequence::iterator assetQuote_iterator;
    typedef assetQuote_sequence::const_iterator assetQuote_const_iterator;
    typedef ::xsd::cxx::tree::traits< assetQuote_type, char > assetQuote_traits;

    const assetQuote_sequence&
    assetQuote () const;

    assetQuote_sequence&
    assetQuote ();

    void
    assetQuote (const assetQuote_sequence& s);

    // Constructors.
    //
    QuotedAssetSet ();

    QuotedAssetSet (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    QuotedAssetSet (const QuotedAssetSet& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual QuotedAssetSet*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~QuotedAssetSet ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    instrumentSet_optional instrumentSet_;
    assetQuote_sequence assetQuote_;
  };

  class FxRateSet: public ::FpML_4_2::QuotedAssetSet
  {
    public:
    // Constructors.
    //
    FxRateSet ();

    FxRateSet (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    FxRateSet (const FxRateSet& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual FxRateSet*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxRateSet ();
  };

  class GenericDimension: public ::xml_schema::string
  {
    public:
    // name
    // 
    typedef ::xml_schema::normalized_string name_type;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_type&
    name () const;

    name_type&
    name ();

    void
    name (const name_type& x);

    void
    name (::std::auto_ptr< name_type > p);

    // href
    // 
    typedef ::xml_schema::idref href_type;
    typedef ::xsd::cxx::tree::optional< href_type > href_optional;
    typedef ::xsd::cxx::tree::traits< href_type, char > href_traits;

    const href_optional&
    href () const;

    href_optional&
    href ();

    void
    href (const href_type& x);

    void
    href (const href_optional& x);

    void
    href (::std::auto_ptr< href_type > p);

    // Constructors.
    //
    GenericDimension (const name_type&);

    GenericDimension (const char*,
                      const name_type&);

    GenericDimension (const ::std::string&,
                      const name_type&);

    GenericDimension (const ::xml_schema::string&,
                      const name_type&);

    GenericDimension (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    GenericDimension (const GenericDimension& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual GenericDimension*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GenericDimension ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< name_type > name_;
    href_optional href_;
  };

  class InstrumentSet: public ::xml_schema::type
  {
    public:
    // underlyingAsset
    // 
    typedef ::FpML_4_2::Asset underlyingAsset_type;
    typedef ::xsd::cxx::tree::sequence< underlyingAsset_type > underlyingAsset_sequence;
    typedef underlyingAsset_sequence::iterator underlyingAsset_iterator;
    typedef underlyingAsset_sequence::const_iterator underlyingAsset_const_iterator;
    typedef ::xsd::cxx::tree::traits< underlyingAsset_type, char > underlyingAsset_traits;

    const underlyingAsset_sequence&
    underlyingAsset () const;

    underlyingAsset_sequence&
    underlyingAsset ();

    void
    underlyingAsset (const underlyingAsset_sequence& s);

    // Constructors.
    //
    InstrumentSet ();

    InstrumentSet (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    InstrumentSet (const InstrumentSet& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual InstrumentSet*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InstrumentSet ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    underlyingAsset_sequence underlyingAsset_;
  };

  class InterpolationMethod: public ::xml_schema::normalized_string
  {
    public:
    // interpolationMethodScheme
    // 
    typedef ::xml_schema::uri interpolationMethodScheme_type;
    typedef ::xsd::cxx::tree::traits< interpolationMethodScheme_type, char > interpolationMethodScheme_traits;

    const interpolationMethodScheme_type&
    interpolationMethodScheme () const;

    interpolationMethodScheme_type&
    interpolationMethodScheme ();

    void
    interpolationMethodScheme (const interpolationMethodScheme_type& x);

    void
    interpolationMethodScheme (::std::auto_ptr< interpolationMethodScheme_type > p);

    static const interpolationMethodScheme_type&
    interpolationMethodScheme_default_value ();

    // Constructors.
    //
    InterpolationMethod ();

    InterpolationMethod (const char*);

    InterpolationMethod (const ::std::string&);

    InterpolationMethod (const ::xml_schema::normalized_string&);

    InterpolationMethod (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    InterpolationMethod (const InterpolationMethod& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual InterpolationMethod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InterpolationMethod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< interpolationMethodScheme_type > interpolationMethodScheme_;
    static const interpolationMethodScheme_type interpolationMethodScheme_default_value_;
  };

  class Market: public ::xml_schema::type
  {
    public:
    // name
    // 
    typedef ::xml_schema::string name_type;
    typedef ::xsd::cxx::tree::optional< name_type > name_optional;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_optional&
    name () const;

    name_optional&
    name ();

    void
    name (const name_type& x);

    void
    name (const name_optional& x);

    void
    name (::std::auto_ptr< name_type > p);

    // benchmarkQuotes
    // 
    typedef ::FpML_4_2::QuotedAssetSet benchmarkQuotes_type;
    typedef ::xsd::cxx::tree::optional< benchmarkQuotes_type > benchmarkQuotes_optional;
    typedef ::xsd::cxx::tree::traits< benchmarkQuotes_type, char > benchmarkQuotes_traits;

    const benchmarkQuotes_optional&
    benchmarkQuotes () const;

    benchmarkQuotes_optional&
    benchmarkQuotes ();

    void
    benchmarkQuotes (const benchmarkQuotes_type& x);

    void
    benchmarkQuotes (const benchmarkQuotes_optional& x);

    void
    benchmarkQuotes (::std::auto_ptr< benchmarkQuotes_type > p);

    // pricingStructure
    // 
    typedef ::FpML_4_2::PricingStructure pricingStructure_type;
    typedef ::xsd::cxx::tree::sequence< pricingStructure_type > pricingStructure_sequence;
    typedef pricingStructure_sequence::iterator pricingStructure_iterator;
    typedef pricingStructure_sequence::const_iterator pricingStructure_const_iterator;
    typedef ::xsd::cxx::tree::traits< pricingStructure_type, char > pricingStructure_traits;

    const pricingStructure_sequence&
    pricingStructure () const;

    pricingStructure_sequence&
    pricingStructure ();

    void
    pricingStructure (const pricingStructure_sequence& s);

    // pricingStructureValuation
    // 
    typedef ::FpML_4_2::PricingStructureValuation pricingStructureValuation_type;
    typedef ::xsd::cxx::tree::sequence< pricingStructureValuation_type > pricingStructureValuation_sequence;
    typedef pricingStructureValuation_sequence::iterator pricingStructureValuation_iterator;
    typedef pricingStructureValuation_sequence::const_iterator pricingStructureValuation_const_iterator;
    typedef ::xsd::cxx::tree::traits< pricingStructureValuation_type, char > pricingStructureValuation_traits;

    const pricingStructureValuation_sequence&
    pricingStructureValuation () const;

    pricingStructureValuation_sequence&
    pricingStructureValuation ();

    void
    pricingStructureValuation (const pricingStructureValuation_sequence& s);

    // benchmarkPricingMethod
    // 
    typedef ::FpML_4_2::PricingMethod benchmarkPricingMethod_type;
    typedef ::xsd::cxx::tree::sequence< benchmarkPricingMethod_type > benchmarkPricingMethod_sequence;
    typedef benchmarkPricingMethod_sequence::iterator benchmarkPricingMethod_iterator;
    typedef benchmarkPricingMethod_sequence::const_iterator benchmarkPricingMethod_const_iterator;
    typedef ::xsd::cxx::tree::traits< benchmarkPricingMethod_type, char > benchmarkPricingMethod_traits;

    const benchmarkPricingMethod_sequence&
    benchmarkPricingMethod () const;

    benchmarkPricingMethod_sequence&
    benchmarkPricingMethod ();

    void
    benchmarkPricingMethod (const benchmarkPricingMethod_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Market ();

    Market (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Market (const Market& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Market*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Market ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    name_optional name_;
    benchmarkQuotes_optional benchmarkQuotes_;
    pricingStructure_sequence pricingStructure_;
    pricingStructureValuation_sequence pricingStructureValuation_;
    benchmarkPricingMethod_sequence benchmarkPricingMethod_;
    id_optional id_;
  };

  class MultiDimensionalPricingData: public ::xml_schema::type
  {
    public:
    // measureType
    // 
    typedef ::FpML_4_2::AssetMeasureType measureType_type;
    typedef ::xsd::cxx::tree::optional< measureType_type > measureType_optional;
    typedef ::xsd::cxx::tree::traits< measureType_type, char > measureType_traits;

    const measureType_optional&
    measureType () const;

    measureType_optional&
    measureType ();

    void
    measureType (const measureType_type& x);

    void
    measureType (const measureType_optional& x);

    void
    measureType (::std::auto_ptr< measureType_type > p);

    // quoteUnits
    // 
    typedef ::FpML_4_2::PriceQuoteUnits quoteUnits_type;
    typedef ::xsd::cxx::tree::optional< quoteUnits_type > quoteUnits_optional;
    typedef ::xsd::cxx::tree::traits< quoteUnits_type, char > quoteUnits_traits;

    const quoteUnits_optional&
    quoteUnits () const;

    quoteUnits_optional&
    quoteUnits ();

    void
    quoteUnits (const quoteUnits_type& x);

    void
    quoteUnits (const quoteUnits_optional& x);

    void
    quoteUnits (::std::auto_ptr< quoteUnits_type > p);

    // side
    // 
    typedef ::FpML_4_2::QuotationSideEnum side_type;
    typedef ::xsd::cxx::tree::optional< side_type > side_optional;
    typedef ::xsd::cxx::tree::traits< side_type, char > side_traits;

    const side_optional&
    side () const;

    side_optional&
    side ();

    void
    side (const side_type& x);

    void
    side (const side_optional& x);

    void
    side (::std::auto_ptr< side_type > p);

    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::optional< currency_type > currency_optional;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_optional&
    currency () const;

    currency_optional&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (const currency_optional& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // timing
    // 
    typedef ::FpML_4_2::QuoteTiming timing_type;
    typedef ::xsd::cxx::tree::optional< timing_type > timing_optional;
    typedef ::xsd::cxx::tree::traits< timing_type, char > timing_traits;

    const timing_optional&
    timing () const;

    timing_optional&
    timing ();

    void
    timing (const timing_type& x);

    void
    timing (const timing_optional& x);

    void
    timing (::std::auto_ptr< timing_type > p);

    // businessCenter
    // 
    typedef ::FpML_4_2::BusinessCenter businessCenter_type;
    typedef ::xsd::cxx::tree::optional< businessCenter_type > businessCenter_optional;
    typedef ::xsd::cxx::tree::traits< businessCenter_type, char > businessCenter_traits;

    const businessCenter_optional&
    businessCenter () const;

    businessCenter_optional&
    businessCenter ();

    void
    businessCenter (const businessCenter_type& x);

    void
    businessCenter (const businessCenter_optional& x);

    void
    businessCenter (::std::auto_ptr< businessCenter_type > p);

    // exchangeId
    // 
    typedef ::FpML_4_2::ExchangeId exchangeId_type;
    typedef ::xsd::cxx::tree::optional< exchangeId_type > exchangeId_optional;
    typedef ::xsd::cxx::tree::traits< exchangeId_type, char > exchangeId_traits;

    const exchangeId_optional&
    exchangeId () const;

    exchangeId_optional&
    exchangeId ();

    void
    exchangeId (const exchangeId_type& x);

    void
    exchangeId (const exchangeId_optional& x);

    void
    exchangeId (::std::auto_ptr< exchangeId_type > p);

    // informationSource
    // 
    typedef ::FpML_4_2::InformationSource informationSource_type;
    typedef ::xsd::cxx::tree::sequence< informationSource_type > informationSource_sequence;
    typedef informationSource_sequence::iterator informationSource_iterator;
    typedef informationSource_sequence::const_iterator informationSource_const_iterator;
    typedef ::xsd::cxx::tree::traits< informationSource_type, char > informationSource_traits;

    const informationSource_sequence&
    informationSource () const;

    informationSource_sequence&
    informationSource ();

    void
    informationSource (const informationSource_sequence& s);

    // time
    // 
    typedef ::xml_schema::date_time time_type;
    typedef ::xsd::cxx::tree::optional< time_type > time_optional;
    typedef ::xsd::cxx::tree::traits< time_type, char > time_traits;

    const time_optional&
    time () const;

    time_optional&
    time ();

    void
    time (const time_type& x);

    void
    time (const time_optional& x);

    void
    time (::std::auto_ptr< time_type > p);

    // valuationDate
    // 
    typedef ::xml_schema::date valuationDate_type;
    typedef ::xsd::cxx::tree::optional< valuationDate_type > valuationDate_optional;
    typedef ::xsd::cxx::tree::traits< valuationDate_type, char > valuationDate_traits;

    const valuationDate_optional&
    valuationDate () const;

    valuationDate_optional&
    valuationDate ();

    void
    valuationDate (const valuationDate_type& x);

    void
    valuationDate (const valuationDate_optional& x);

    void
    valuationDate (::std::auto_ptr< valuationDate_type > p);

    // expiryTime
    // 
    typedef ::xml_schema::date_time expiryTime_type;
    typedef ::xsd::cxx::tree::optional< expiryTime_type > expiryTime_optional;
    typedef ::xsd::cxx::tree::traits< expiryTime_type, char > expiryTime_traits;

    const expiryTime_optional&
    expiryTime () const;

    expiryTime_optional&
    expiryTime ();

    void
    expiryTime (const expiryTime_type& x);

    void
    expiryTime (const expiryTime_optional& x);

    void
    expiryTime (::std::auto_ptr< expiryTime_type > p);

    // cashFlowType
    // 
    typedef ::FpML_4_2::CashflowType cashFlowType_type;
    typedef ::xsd::cxx::tree::optional< cashFlowType_type > cashFlowType_optional;
    typedef ::xsd::cxx::tree::traits< cashFlowType_type, char > cashFlowType_traits;

    const cashFlowType_optional&
    cashFlowType () const;

    cashFlowType_optional&
    cashFlowType ();

    void
    cashFlowType (const cashFlowType_type& x);

    void
    cashFlowType (const cashFlowType_optional& x);

    void
    cashFlowType (::std::auto_ptr< cashFlowType_type > p);

    // point
    // 
    typedef ::FpML_4_2::PricingStructurePoint point_type;
    typedef ::xsd::cxx::tree::sequence< point_type > point_sequence;
    typedef point_sequence::iterator point_iterator;
    typedef point_sequence::const_iterator point_const_iterator;
    typedef ::xsd::cxx::tree::traits< point_type, char > point_traits;

    const point_sequence&
    point () const;

    point_sequence&
    point ();

    void
    point (const point_sequence& s);

    // Constructors.
    //
    MultiDimensionalPricingData ();

    MultiDimensionalPricingData (const ::xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    MultiDimensionalPricingData (const MultiDimensionalPricingData& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual MultiDimensionalPricingData*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MultiDimensionalPricingData ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    measureType_optional measureType_;
    quoteUnits_optional quoteUnits_;
    side_optional side_;
    currency_optional currency_;
    timing_optional timing_;
    businessCenter_optional businessCenter_;
    exchangeId_optional exchangeId_;
    informationSource_sequence informationSource_;
    time_optional time_;
    valuationDate_optional valuationDate_;
    expiryTime_optional expiryTime_;
    cashFlowType_optional cashFlowType_;
    point_sequence point_;
  };

  class ParametricAdjustment: public ::xml_schema::type
  {
    public:
    // name
    // 
    typedef ::xml_schema::normalized_string name_type;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_type&
    name () const;

    name_type&
    name ();

    void
    name (const name_type& x);

    void
    name (::std::auto_ptr< name_type > p);

    // inputUnits
    // 
    typedef ::FpML_4_2::PriceQuoteUnits inputUnits_type;
    typedef ::xsd::cxx::tree::optional< inputUnits_type > inputUnits_optional;
    typedef ::xsd::cxx::tree::traits< inputUnits_type, char > inputUnits_traits;

    const inputUnits_optional&
    inputUnits () const;

    inputUnits_optional&
    inputUnits ();

    void
    inputUnits (const inputUnits_type& x);

    void
    inputUnits (const inputUnits_optional& x);

    void
    inputUnits (::std::auto_ptr< inputUnits_type > p);

    // datapoint
    // 
    typedef ::FpML_4_2::ParametricAdjustmentPoint datapoint_type;
    typedef ::xsd::cxx::tree::sequence< datapoint_type > datapoint_sequence;
    typedef datapoint_sequence::iterator datapoint_iterator;
    typedef datapoint_sequence::const_iterator datapoint_const_iterator;
    typedef ::xsd::cxx::tree::traits< datapoint_type, char > datapoint_traits;

    const datapoint_sequence&
    datapoint () const;

    datapoint_sequence&
    datapoint ();

    void
    datapoint (const datapoint_sequence& s);

    // Constructors.
    //
    ParametricAdjustment (const name_type&);

    ParametricAdjustment (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    ParametricAdjustment (const ParametricAdjustment& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual ParametricAdjustment*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ParametricAdjustment ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< name_type > name_;
    inputUnits_optional inputUnits_;
    datapoint_sequence datapoint_;
  };

  class ParametricAdjustmentPoint: public ::xml_schema::type
  {
    public:
    // parameterValue
    // 
    typedef ::xml_schema::decimal parameterValue_type;
    typedef ::xsd::cxx::tree::traits< parameterValue_type, char, ::xsd::cxx::tree::schema_type::decimal > parameterValue_traits;

    const parameterValue_type&
    parameterValue () const;

    parameterValue_type&
    parameterValue ();

    void
    parameterValue (const parameterValue_type& x);

    // adjustmentValue
    // 
    typedef ::xml_schema::decimal adjustmentValue_type;
    typedef ::xsd::cxx::tree::traits< adjustmentValue_type, char, ::xsd::cxx::tree::schema_type::decimal > adjustmentValue_traits;

    const adjustmentValue_type&
    adjustmentValue () const;

    adjustmentValue_type&
    adjustmentValue ();

    void
    adjustmentValue (const adjustmentValue_type& x);

    // Constructors.
    //
    ParametricAdjustmentPoint (const parameterValue_type&,
                               const adjustmentValue_type&);

    ParametricAdjustmentPoint (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    ParametricAdjustmentPoint (const ParametricAdjustmentPoint& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual ParametricAdjustmentPoint*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ParametricAdjustmentPoint ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< parameterValue_type > parameterValue_;
    ::xsd::cxx::tree::one< adjustmentValue_type > adjustmentValue_;
  };

  class PricingDataPointCoordinate: public ::xml_schema::type
  {
    public:
    // term
    // 
    typedef ::FpML_4_2::TimeDimension term_type;
    typedef ::xsd::cxx::tree::sequence< term_type > term_sequence;
    typedef term_sequence::iterator term_iterator;
    typedef term_sequence::const_iterator term_const_iterator;
    typedef ::xsd::cxx::tree::traits< term_type, char > term_traits;

    const term_sequence&
    term () const;

    term_sequence&
    term ();

    void
    term (const term_sequence& s);

    // expiration
    // 
    typedef ::FpML_4_2::TimeDimension expiration_type;
    typedef ::xsd::cxx::tree::sequence< expiration_type > expiration_sequence;
    typedef expiration_sequence::iterator expiration_iterator;
    typedef expiration_sequence::const_iterator expiration_const_iterator;
    typedef ::xsd::cxx::tree::traits< expiration_type, char > expiration_traits;

    const expiration_sequence&
    expiration () const;

    expiration_sequence&
    expiration ();

    void
    expiration (const expiration_sequence& s);

    // strike
    // 
    typedef ::xml_schema::decimal strike_type;
    typedef ::xsd::cxx::tree::sequence< strike_type > strike_sequence;
    typedef strike_sequence::iterator strike_iterator;
    typedef strike_sequence::const_iterator strike_const_iterator;
    typedef ::xsd::cxx::tree::traits< strike_type, char, ::xsd::cxx::tree::schema_type::decimal > strike_traits;

    const strike_sequence&
    strike () const;

    strike_sequence&
    strike ();

    void
    strike (const strike_sequence& s);

    // generic
    // 
    typedef ::FpML_4_2::GenericDimension generic_type;
    typedef ::xsd::cxx::tree::sequence< generic_type > generic_sequence;
    typedef generic_sequence::iterator generic_iterator;
    typedef generic_sequence::const_iterator generic_const_iterator;
    typedef ::xsd::cxx::tree::traits< generic_type, char > generic_traits;

    const generic_sequence&
    generic () const;

    generic_sequence&
    generic ();

    void
    generic (const generic_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    PricingDataPointCoordinate ();

    PricingDataPointCoordinate (const ::xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    PricingDataPointCoordinate (const PricingDataPointCoordinate& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual PricingDataPointCoordinate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PricingDataPointCoordinate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    term_sequence term_;
    expiration_sequence expiration_;
    strike_sequence strike_;
    generic_sequence generic_;
    id_optional id_;
  };

  class PricingDataPointCoordinateReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    PricingDataPointCoordinateReference (const href_type&);

    PricingDataPointCoordinateReference (const ::xercesc::DOMElement& e,
                                         ::xml_schema::flags f = 0,
                                         ::xml_schema::container* c = 0);

    PricingDataPointCoordinateReference (const PricingDataPointCoordinateReference& x,
                                         ::xml_schema::flags f = 0,
                                         ::xml_schema::container* c = 0);

    virtual PricingDataPointCoordinateReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PricingDataPointCoordinateReference ();
  };

  class PricingInputType: public ::xml_schema::normalized_string
  {
    public:
    // pricingInputTypeScheme
    // 
    typedef ::xml_schema::uri pricingInputTypeScheme_type;
    typedef ::xsd::cxx::tree::traits< pricingInputTypeScheme_type, char > pricingInputTypeScheme_traits;

    const pricingInputTypeScheme_type&
    pricingInputTypeScheme () const;

    pricingInputTypeScheme_type&
    pricingInputTypeScheme ();

    void
    pricingInputTypeScheme (const pricingInputTypeScheme_type& x);

    void
    pricingInputTypeScheme (::std::auto_ptr< pricingInputTypeScheme_type > p);

    static const pricingInputTypeScheme_type&
    pricingInputTypeScheme_default_value ();

    // Constructors.
    //
    PricingInputType ();

    PricingInputType (const char*);

    PricingInputType (const ::std::string&);

    PricingInputType (const ::xml_schema::normalized_string&);

    PricingInputType (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    PricingInputType (const PricingInputType& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual PricingInputType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PricingInputType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< pricingInputTypeScheme_type > pricingInputTypeScheme_;
    static const pricingInputTypeScheme_type pricingInputTypeScheme_default_value_;
  };

  class PricingMethod: public ::xml_schema::type
  {
    public:
    // assetReference
    // 
    typedef ::FpML_4_2::AnyAssetReference assetReference_type;
    typedef ::xsd::cxx::tree::traits< assetReference_type, char > assetReference_traits;

    const assetReference_type&
    assetReference () const;

    assetReference_type&
    assetReference ();

    void
    assetReference (const assetReference_type& x);

    void
    assetReference (::std::auto_ptr< assetReference_type > p);

    // pricingInputReference
    // 
    typedef ::FpML_4_2::PricingStructureReference pricingInputReference_type;
    typedef ::xsd::cxx::tree::traits< pricingInputReference_type, char > pricingInputReference_traits;

    const pricingInputReference_type&
    pricingInputReference () const;

    pricingInputReference_type&
    pricingInputReference ();

    void
    pricingInputReference (const pricingInputReference_type& x);

    void
    pricingInputReference (::std::auto_ptr< pricingInputReference_type > p);

    // Constructors.
    //
    PricingMethod (const assetReference_type&,
                   const pricingInputReference_type&);

    PricingMethod (::std::auto_ptr< assetReference_type >&,
                   ::std::auto_ptr< pricingInputReference_type >&);

    PricingMethod (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    PricingMethod (const PricingMethod& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual PricingMethod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PricingMethod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< assetReference_type > assetReference_;
    ::xsd::cxx::tree::one< pricingInputReference_type > pricingInputReference_;
  };

  class PricingStructureReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    PricingStructureReference (const href_type&);

    PricingStructureReference (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    PricingStructureReference (const PricingStructureReference& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual PricingStructureReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PricingStructureReference ();
  };

  class PricingStructurePoint: public ::xml_schema::type
  {
    public:
    // coordinate
    // 
    typedef ::FpML_4_2::PricingDataPointCoordinate coordinate_type;
    typedef ::xsd::cxx::tree::sequence< coordinate_type > coordinate_sequence;
    typedef coordinate_sequence::iterator coordinate_iterator;
    typedef coordinate_sequence::const_iterator coordinate_const_iterator;
    typedef ::xsd::cxx::tree::traits< coordinate_type, char > coordinate_traits;

    const coordinate_sequence&
    coordinate () const;

    coordinate_sequence&
    coordinate ();

    void
    coordinate (const coordinate_sequence& s);

    // coordinateReference
    // 
    typedef ::FpML_4_2::PricingDataPointCoordinateReference coordinateReference_type;
    typedef ::xsd::cxx::tree::sequence< coordinateReference_type > coordinateReference_sequence;
    typedef coordinateReference_sequence::iterator coordinateReference_iterator;
    typedef coordinateReference_sequence::const_iterator coordinateReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< coordinateReference_type, char > coordinateReference_traits;

    const coordinateReference_sequence&
    coordinateReference () const;

    coordinateReference_sequence&
    coordinateReference ();

    void
    coordinateReference (const coordinateReference_sequence& s);

    // underlyingAsset
    // 
    typedef ::FpML_4_2::Asset underlyingAsset_type;
    typedef ::xsd::cxx::tree::optional< underlyingAsset_type > underlyingAsset_optional;
    typedef ::xsd::cxx::tree::traits< underlyingAsset_type, char > underlyingAsset_traits;

    const underlyingAsset_optional&
    underlyingAsset () const;

    underlyingAsset_optional&
    underlyingAsset ();

    void
    underlyingAsset (const underlyingAsset_type& x);

    void
    underlyingAsset (const underlyingAsset_optional& x);

    void
    underlyingAsset (::std::auto_ptr< underlyingAsset_type > p);

    // underlyingAssetReference
    // 
    typedef ::FpML_4_2::AssetReference underlyingAssetReference_type;
    typedef ::xsd::cxx::tree::optional< underlyingAssetReference_type > underlyingAssetReference_optional;
    typedef ::xsd::cxx::tree::traits< underlyingAssetReference_type, char > underlyingAssetReference_traits;

    const underlyingAssetReference_optional&
    underlyingAssetReference () const;

    underlyingAssetReference_optional&
    underlyingAssetReference ();

    void
    underlyingAssetReference (const underlyingAssetReference_type& x);

    void
    underlyingAssetReference (const underlyingAssetReference_optional& x);

    void
    underlyingAssetReference (::std::auto_ptr< underlyingAssetReference_type > p);

    // value
    // 
    typedef ::xml_schema::decimal value_type;
    typedef ::xsd::cxx::tree::optional< value_type > value_optional;
    typedef ::xsd::cxx::tree::traits< value_type, char, ::xsd::cxx::tree::schema_type::decimal > value_traits;

    const value_optional&
    value () const;

    value_optional&
    value ();

    void
    value (const value_type& x);

    void
    value (const value_optional& x);

    // measureType
    // 
    typedef ::FpML_4_2::AssetMeasureType measureType_type;
    typedef ::xsd::cxx::tree::optional< measureType_type > measureType_optional;
    typedef ::xsd::cxx::tree::traits< measureType_type, char > measureType_traits;

    const measureType_optional&
    measureType () const;

    measureType_optional&
    measureType ();

    void
    measureType (const measureType_type& x);

    void
    measureType (const measureType_optional& x);

    void
    measureType (::std::auto_ptr< measureType_type > p);

    // quoteUnits
    // 
    typedef ::FpML_4_2::PriceQuoteUnits quoteUnits_type;
    typedef ::xsd::cxx::tree::optional< quoteUnits_type > quoteUnits_optional;
    typedef ::xsd::cxx::tree::traits< quoteUnits_type, char > quoteUnits_traits;

    const quoteUnits_optional&
    quoteUnits () const;

    quoteUnits_optional&
    quoteUnits ();

    void
    quoteUnits (const quoteUnits_type& x);

    void
    quoteUnits (const quoteUnits_optional& x);

    void
    quoteUnits (::std::auto_ptr< quoteUnits_type > p);

    // side
    // 
    typedef ::FpML_4_2::QuotationSideEnum side_type;
    typedef ::xsd::cxx::tree::optional< side_type > side_optional;
    typedef ::xsd::cxx::tree::traits< side_type, char > side_traits;

    const side_optional&
    side () const;

    side_optional&
    side ();

    void
    side (const side_type& x);

    void
    side (const side_optional& x);

    void
    side (::std::auto_ptr< side_type > p);

    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::optional< currency_type > currency_optional;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_optional&
    currency () const;

    currency_optional&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (const currency_optional& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // timing
    // 
    typedef ::FpML_4_2::QuoteTiming timing_type;
    typedef ::xsd::cxx::tree::optional< timing_type > timing_optional;
    typedef ::xsd::cxx::tree::traits< timing_type, char > timing_traits;

    const timing_optional&
    timing () const;

    timing_optional&
    timing ();

    void
    timing (const timing_type& x);

    void
    timing (const timing_optional& x);

    void
    timing (::std::auto_ptr< timing_type > p);

    // businessCenter
    // 
    typedef ::FpML_4_2::BusinessCenter businessCenter_type;
    typedef ::xsd::cxx::tree::optional< businessCenter_type > businessCenter_optional;
    typedef ::xsd::cxx::tree::traits< businessCenter_type, char > businessCenter_traits;

    const businessCenter_optional&
    businessCenter () const;

    businessCenter_optional&
    businessCenter ();

    void
    businessCenter (const businessCenter_type& x);

    void
    businessCenter (const businessCenter_optional& x);

    void
    businessCenter (::std::auto_ptr< businessCenter_type > p);

    // exchangeId
    // 
    typedef ::FpML_4_2::ExchangeId exchangeId_type;
    typedef ::xsd::cxx::tree::optional< exchangeId_type > exchangeId_optional;
    typedef ::xsd::cxx::tree::traits< exchangeId_type, char > exchangeId_traits;

    const exchangeId_optional&
    exchangeId () const;

    exchangeId_optional&
    exchangeId ();

    void
    exchangeId (const exchangeId_type& x);

    void
    exchangeId (const exchangeId_optional& x);

    void
    exchangeId (::std::auto_ptr< exchangeId_type > p);

    // informationSource
    // 
    typedef ::FpML_4_2::InformationSource informationSource_type;
    typedef ::xsd::cxx::tree::sequence< informationSource_type > informationSource_sequence;
    typedef informationSource_sequence::iterator informationSource_iterator;
    typedef informationSource_sequence::const_iterator informationSource_const_iterator;
    typedef ::xsd::cxx::tree::traits< informationSource_type, char > informationSource_traits;

    const informationSource_sequence&
    informationSource () const;

    informationSource_sequence&
    informationSource ();

    void
    informationSource (const informationSource_sequence& s);

    // time
    // 
    typedef ::xml_schema::date_time time_type;
    typedef ::xsd::cxx::tree::optional< time_type > time_optional;
    typedef ::xsd::cxx::tree::traits< time_type, char > time_traits;

    const time_optional&
    time () const;

    time_optional&
    time ();

    void
    time (const time_type& x);

    void
    time (const time_optional& x);

    void
    time (::std::auto_ptr< time_type > p);

    // valuationDate
    // 
    typedef ::xml_schema::date valuationDate_type;
    typedef ::xsd::cxx::tree::optional< valuationDate_type > valuationDate_optional;
    typedef ::xsd::cxx::tree::traits< valuationDate_type, char > valuationDate_traits;

    const valuationDate_optional&
    valuationDate () const;

    valuationDate_optional&
    valuationDate ();

    void
    valuationDate (const valuationDate_type& x);

    void
    valuationDate (const valuationDate_optional& x);

    void
    valuationDate (::std::auto_ptr< valuationDate_type > p);

    // expiryTime
    // 
    typedef ::xml_schema::date_time expiryTime_type;
    typedef ::xsd::cxx::tree::optional< expiryTime_type > expiryTime_optional;
    typedef ::xsd::cxx::tree::traits< expiryTime_type, char > expiryTime_traits;

    const expiryTime_optional&
    expiryTime () const;

    expiryTime_optional&
    expiryTime ();

    void
    expiryTime (const expiryTime_type& x);

    void
    expiryTime (const expiryTime_optional& x);

    void
    expiryTime (::std::auto_ptr< expiryTime_type > p);

    // cashFlowType
    // 
    typedef ::FpML_4_2::CashflowType cashFlowType_type;
    typedef ::xsd::cxx::tree::optional< cashFlowType_type > cashFlowType_optional;
    typedef ::xsd::cxx::tree::traits< cashFlowType_type, char > cashFlowType_traits;

    const cashFlowType_optional&
    cashFlowType () const;

    cashFlowType_optional&
    cashFlowType ();

    void
    cashFlowType (const cashFlowType_type& x);

    void
    cashFlowType (const cashFlowType_optional& x);

    void
    cashFlowType (::std::auto_ptr< cashFlowType_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    PricingStructurePoint ();

    PricingStructurePoint (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    PricingStructurePoint (const PricingStructurePoint& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual PricingStructurePoint*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PricingStructurePoint ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    coordinate_sequence coordinate_;
    coordinateReference_sequence coordinateReference_;
    underlyingAsset_optional underlyingAsset_;
    underlyingAssetReference_optional underlyingAssetReference_;
    value_optional value_;
    measureType_optional measureType_;
    quoteUnits_optional quoteUnits_;
    side_optional side_;
    currency_optional currency_;
    timing_optional timing_;
    businessCenter_optional businessCenter_;
    exchangeId_optional exchangeId_;
    informationSource_sequence informationSource_;
    time_optional time_;
    valuationDate_optional valuationDate_;
    expiryTime_optional expiryTime_;
    cashFlowType_optional cashFlowType_;
    id_optional id_;
  };

  class TermCurve: public ::xml_schema::type
  {
    public:
    // interpolationMethod
    // 
    typedef ::FpML_4_2::InterpolationMethod interpolationMethod_type;
    typedef ::xsd::cxx::tree::optional< interpolationMethod_type > interpolationMethod_optional;
    typedef ::xsd::cxx::tree::traits< interpolationMethod_type, char > interpolationMethod_traits;

    const interpolationMethod_optional&
    interpolationMethod () const;

    interpolationMethod_optional&
    interpolationMethod ();

    void
    interpolationMethod (const interpolationMethod_type& x);

    void
    interpolationMethod (const interpolationMethod_optional& x);

    void
    interpolationMethod (::std::auto_ptr< interpolationMethod_type > p);

    // extrapolationPermitted
    // 
    typedef ::xml_schema::boolean extrapolationPermitted_type;
    typedef ::xsd::cxx::tree::optional< extrapolationPermitted_type > extrapolationPermitted_optional;
    typedef ::xsd::cxx::tree::traits< extrapolationPermitted_type, char > extrapolationPermitted_traits;

    const extrapolationPermitted_optional&
    extrapolationPermitted () const;

    extrapolationPermitted_optional&
    extrapolationPermitted ();

    void
    extrapolationPermitted (const extrapolationPermitted_type& x);

    void
    extrapolationPermitted (const extrapolationPermitted_optional& x);

    // point
    // 
    typedef ::FpML_4_2::TermPoint point_type;
    typedef ::xsd::cxx::tree::sequence< point_type > point_sequence;
    typedef point_sequence::iterator point_iterator;
    typedef point_sequence::const_iterator point_const_iterator;
    typedef ::xsd::cxx::tree::traits< point_type, char > point_traits;

    const point_sequence&
    point () const;

    point_sequence&
    point ();

    void
    point (const point_sequence& s);

    // Constructors.
    //
    TermCurve ();

    TermCurve (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    TermCurve (const TermCurve& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual TermCurve*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TermCurve ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    interpolationMethod_optional interpolationMethod_;
    extrapolationPermitted_optional extrapolationPermitted_;
    point_sequence point_;
  };

  class TermPoint: public ::xml_schema::type
  {
    public:
    // term
    // 
    typedef ::FpML_4_2::TimeDimension term_type;
    typedef ::xsd::cxx::tree::traits< term_type, char > term_traits;

    const term_type&
    term () const;

    term_type&
    term ();

    void
    term (const term_type& x);

    void
    term (::std::auto_ptr< term_type > p);

    // bid
    // 
    typedef ::xml_schema::decimal bid_type;
    typedef ::xsd::cxx::tree::optional< bid_type > bid_optional;
    typedef ::xsd::cxx::tree::traits< bid_type, char, ::xsd::cxx::tree::schema_type::decimal > bid_traits;

    const bid_optional&
    bid () const;

    bid_optional&
    bid ();

    void
    bid (const bid_type& x);

    void
    bid (const bid_optional& x);

    // mid
    // 
    typedef ::xml_schema::decimal mid_type;
    typedef ::xsd::cxx::tree::optional< mid_type > mid_optional;
    typedef ::xsd::cxx::tree::traits< mid_type, char, ::xsd::cxx::tree::schema_type::decimal > mid_traits;

    const mid_optional&
    mid () const;

    mid_optional&
    mid ();

    void
    mid (const mid_type& x);

    void
    mid (const mid_optional& x);

    // ask
    // 
    typedef ::xml_schema::decimal ask_type;
    typedef ::xsd::cxx::tree::optional< ask_type > ask_optional;
    typedef ::xsd::cxx::tree::traits< ask_type, char, ::xsd::cxx::tree::schema_type::decimal > ask_traits;

    const ask_optional&
    ask () const;

    ask_optional&
    ask ();

    void
    ask (const ask_type& x);

    void
    ask (const ask_optional& x);

    // spreadValue
    // 
    typedef ::xml_schema::decimal spreadValue_type;
    typedef ::xsd::cxx::tree::optional< spreadValue_type > spreadValue_optional;
    typedef ::xsd::cxx::tree::traits< spreadValue_type, char, ::xsd::cxx::tree::schema_type::decimal > spreadValue_traits;

    const spreadValue_optional&
    spreadValue () const;

    spreadValue_optional&
    spreadValue ();

    void
    spreadValue (const spreadValue_type& x);

    void
    spreadValue (const spreadValue_optional& x);

    // definition
    // 
    typedef ::FpML_4_2::AssetReference definition_type;
    typedef ::xsd::cxx::tree::optional< definition_type > definition_optional;
    typedef ::xsd::cxx::tree::traits< definition_type, char > definition_traits;

    const definition_optional&
    definition () const;

    definition_optional&
    definition ();

    void
    definition (const definition_type& x);

    void
    definition (const definition_optional& x);

    void
    definition (::std::auto_ptr< definition_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    TermPoint (const term_type&);

    TermPoint (::std::auto_ptr< term_type >&);

    TermPoint (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    TermPoint (const TermPoint& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual TermPoint*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TermPoint ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< term_type > term_;
    bid_optional bid_;
    mid_optional mid_;
    ask_optional ask_;
    spreadValue_optional spreadValue_;
    definition_optional definition_;
    id_optional id_;
  };

  class TimeDimension: public ::xml_schema::type
  {
    public:
    // tenor
    // 
    typedef ::FpML_4_2::Interval tenor_type;
    typedef ::xsd::cxx::tree::optional< tenor_type > tenor_optional;
    typedef ::xsd::cxx::tree::traits< tenor_type, char > tenor_traits;

    const tenor_optional&
    tenor () const;

    tenor_optional&
    tenor ();

    void
    tenor (const tenor_type& x);

    void
    tenor (const tenor_optional& x);

    void
    tenor (::std::auto_ptr< tenor_type > p);

    // date
    // 
    typedef ::xml_schema::date date_type;
    typedef ::xsd::cxx::tree::optional< date_type > date_optional;
    typedef ::xsd::cxx::tree::traits< date_type, char > date_traits;

    const date_optional&
    date () const;

    date_optional&
    date ();

    void
    date (const date_type& x);

    void
    date (const date_optional& x);

    void
    date (::std::auto_ptr< date_type > p);

    // Constructors.
    //
    TimeDimension ();

    TimeDimension (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    TimeDimension (const TimeDimension& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual TimeDimension*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TimeDimension ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    tenor_optional tenor_;
    date_optional date_;
  };

  class VolatilityMatrix: public ::FpML_4_2::PricingStructureValuation
  {
    public:
    // dataPoints
    // 
    typedef ::FpML_4_2::MultiDimensionalPricingData dataPoints_type;
    typedef ::xsd::cxx::tree::traits< dataPoints_type, char > dataPoints_traits;

    const dataPoints_type&
    dataPoints () const;

    dataPoints_type&
    dataPoints ();

    void
    dataPoints (const dataPoints_type& x);

    void
    dataPoints (::std::auto_ptr< dataPoints_type > p);

    // adjustment
    // 
    typedef ::FpML_4_2::ParametricAdjustment adjustment_type;
    typedef ::xsd::cxx::tree::sequence< adjustment_type > adjustment_sequence;
    typedef adjustment_sequence::iterator adjustment_iterator;
    typedef adjustment_sequence::const_iterator adjustment_const_iterator;
    typedef ::xsd::cxx::tree::traits< adjustment_type, char > adjustment_traits;

    const adjustment_sequence&
    adjustment () const;

    adjustment_sequence&
    adjustment ();

    void
    adjustment (const adjustment_sequence& s);

    // Constructors.
    //
    VolatilityMatrix (const objectReference_type&,
                      const baseDate_type&,
                      const dataPoints_type&);

    VolatilityMatrix (::std::auto_ptr< objectReference_type >&,
                      ::std::auto_ptr< baseDate_type >&,
                      ::std::auto_ptr< dataPoints_type >&);

    VolatilityMatrix (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    VolatilityMatrix (const VolatilityMatrix& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual VolatilityMatrix*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VolatilityMatrix ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< dataPoints_type > dataPoints_;
    adjustment_sequence adjustment_;
  };

  class VolatilityRepresentation: public ::FpML_4_2::PricingStructure
  {
    public:
    // asset
    // 
    typedef ::FpML_4_2::AnyAssetReference asset_type;
    typedef ::xsd::cxx::tree::traits< asset_type, char > asset_traits;

    const asset_type&
    asset () const;

    asset_type&
    asset ();

    void
    asset (const asset_type& x);

    void
    asset (::std::auto_ptr< asset_type > p);

    // Constructors.
    //
    VolatilityRepresentation (const asset_type&);

    VolatilityRepresentation (::std::auto_ptr< asset_type >&);

    VolatilityRepresentation (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    VolatilityRepresentation (const VolatilityRepresentation& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual VolatilityRepresentation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~VolatilityRepresentation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< asset_type > asset_;
  };

  class YieldCurve: public ::FpML_4_2::PricingStructure
  {
    public:
    // algorithm
    // 
    typedef ::xml_schema::string algorithm_type;
    typedef ::xsd::cxx::tree::optional< algorithm_type > algorithm_optional;
    typedef ::xsd::cxx::tree::traits< algorithm_type, char > algorithm_traits;

    const algorithm_optional&
    algorithm () const;

    algorithm_optional&
    algorithm ();

    void
    algorithm (const algorithm_type& x);

    void
    algorithm (const algorithm_optional& x);

    void
    algorithm (::std::auto_ptr< algorithm_type > p);

    // forecastRateIndex
    // 
    typedef ::FpML_4_2::ForecastRateIndex forecastRateIndex_type;
    typedef ::xsd::cxx::tree::optional< forecastRateIndex_type > forecastRateIndex_optional;
    typedef ::xsd::cxx::tree::traits< forecastRateIndex_type, char > forecastRateIndex_traits;

    const forecastRateIndex_optional&
    forecastRateIndex () const;

    forecastRateIndex_optional&
    forecastRateIndex ();

    void
    forecastRateIndex (const forecastRateIndex_type& x);

    void
    forecastRateIndex (const forecastRateIndex_optional& x);

    void
    forecastRateIndex (::std::auto_ptr< forecastRateIndex_type > p);

    // Constructors.
    //
    YieldCurve ();

    YieldCurve (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    YieldCurve (const YieldCurve& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual YieldCurve*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~YieldCurve ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    algorithm_optional algorithm_;
    forecastRateIndex_optional forecastRateIndex_;
  };

  class YieldCurveValuation: public ::FpML_4_2::PricingStructureValuation
  {
    public:
    // inputs
    // 
    typedef ::FpML_4_2::QuotedAssetSet inputs_type;
    typedef ::xsd::cxx::tree::optional< inputs_type > inputs_optional;
    typedef ::xsd::cxx::tree::traits< inputs_type, char > inputs_traits;

    const inputs_optional&
    inputs () const;

    inputs_optional&
    inputs ();

    void
    inputs (const inputs_type& x);

    void
    inputs (const inputs_optional& x);

    void
    inputs (::std::auto_ptr< inputs_type > p);

    // zeroCurve
    // 
    typedef ::FpML_4_2::ZeroRateCurve zeroCurve_type;
    typedef ::xsd::cxx::tree::optional< zeroCurve_type > zeroCurve_optional;
    typedef ::xsd::cxx::tree::traits< zeroCurve_type, char > zeroCurve_traits;

    const zeroCurve_optional&
    zeroCurve () const;

    zeroCurve_optional&
    zeroCurve ();

    void
    zeroCurve (const zeroCurve_type& x);

    void
    zeroCurve (const zeroCurve_optional& x);

    void
    zeroCurve (::std::auto_ptr< zeroCurve_type > p);

    // forwardCurve
    // 
    typedef ::FpML_4_2::ForwardRateCurve forwardCurve_type;
    typedef ::xsd::cxx::tree::sequence< forwardCurve_type > forwardCurve_sequence;
    typedef forwardCurve_sequence::iterator forwardCurve_iterator;
    typedef forwardCurve_sequence::const_iterator forwardCurve_const_iterator;
    typedef ::xsd::cxx::tree::traits< forwardCurve_type, char > forwardCurve_traits;

    const forwardCurve_sequence&
    forwardCurve () const;

    forwardCurve_sequence&
    forwardCurve ();

    void
    forwardCurve (const forwardCurve_sequence& s);

    // discountFactorCurve
    // 
    typedef ::FpML_4_2::TermCurve discountFactorCurve_type;
    typedef ::xsd::cxx::tree::optional< discountFactorCurve_type > discountFactorCurve_optional;
    typedef ::xsd::cxx::tree::traits< discountFactorCurve_type, char > discountFactorCurve_traits;

    const discountFactorCurve_optional&
    discountFactorCurve () const;

    discountFactorCurve_optional&
    discountFactorCurve ();

    void
    discountFactorCurve (const discountFactorCurve_type& x);

    void
    discountFactorCurve (const discountFactorCurve_optional& x);

    void
    discountFactorCurve (::std::auto_ptr< discountFactorCurve_type > p);

    // Constructors.
    //
    YieldCurveValuation (const objectReference_type&,
                         const baseDate_type&);

    YieldCurveValuation (::std::auto_ptr< objectReference_type >&,
                         ::std::auto_ptr< baseDate_type >&);

    YieldCurveValuation (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    YieldCurveValuation (const YieldCurveValuation& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual YieldCurveValuation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~YieldCurveValuation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    inputs_optional inputs_;
    zeroCurve_optional zeroCurve_;
    forwardCurve_sequence forwardCurve_;
    discountFactorCurve_optional discountFactorCurve_;
  };

  class ZeroRateCurve: public ::xml_schema::type
  {
    public:
    // compoundingFrequency
    // 
    typedef ::FpML_4_2::CompoundingFrequency compoundingFrequency_type;
    typedef ::xsd::cxx::tree::traits< compoundingFrequency_type, char > compoundingFrequency_traits;

    const compoundingFrequency_type&
    compoundingFrequency () const;

    compoundingFrequency_type&
    compoundingFrequency ();

    void
    compoundingFrequency (const compoundingFrequency_type& x);

    void
    compoundingFrequency (::std::auto_ptr< compoundingFrequency_type > p);

    // rateCurve
    // 
    typedef ::FpML_4_2::TermCurve rateCurve_type;
    typedef ::xsd::cxx::tree::traits< rateCurve_type, char > rateCurve_traits;

    const rateCurve_type&
    rateCurve () const;

    rateCurve_type&
    rateCurve ();

    void
    rateCurve (const rateCurve_type& x);

    void
    rateCurve (::std::auto_ptr< rateCurve_type > p);

    // Constructors.
    //
    ZeroRateCurve (const compoundingFrequency_type&,
                   const rateCurve_type&);

    ZeroRateCurve (::std::auto_ptr< compoundingFrequency_type >&,
                   ::std::auto_ptr< rateCurve_type >&);

    ZeroRateCurve (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    ZeroRateCurve (const ZeroRateCurve& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual ZeroRateCurve*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ZeroRateCurve ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< compoundingFrequency_type > compoundingFrequency_;
    ::xsd::cxx::tree::one< rateCurve_type > rateCurve_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const CompoundingFrequency&);

  void
  operator<< (::xercesc::DOMElement&, const PricingStructure&);

  void
  operator<< (::xercesc::DOMElement&, const CreditCurve&);

  void
  operator<< (::xercesc::DOMElement&, const PricingStructureValuation&);

  void
  operator<< (::xercesc::DOMElement&, const CreditCurveValuation&);

  void
  operator<< (::xercesc::DOMElement&, const DefaultProbabilityCurve&);

  void
  operator<< (::xercesc::DOMElement&, const ForwardRateCurve&);

  void
  operator<< (::xercesc::DOMElement&, const FxCurve&);

  void
  operator<< (::xercesc::DOMElement&, const FxCurveValuation&);

  void
  operator<< (::xercesc::DOMElement&, const QuotedAssetSet&);

  void
  operator<< (::xercesc::DOMElement&, const FxRateSet&);

  void
  operator<< (::xercesc::DOMElement&, const GenericDimension&);

  void
  operator<< (::xercesc::DOMElement&, const InstrumentSet&);

  void
  operator<< (::xercesc::DOMElement&, const InterpolationMethod&);

  void
  operator<< (::xercesc::DOMElement&, const Market&);

  void
  operator<< (::xercesc::DOMElement&, const MultiDimensionalPricingData&);

  void
  operator<< (::xercesc::DOMElement&, const ParametricAdjustment&);

  void
  operator<< (::xercesc::DOMElement&, const ParametricAdjustmentPoint&);

  void
  operator<< (::xercesc::DOMElement&, const PricingDataPointCoordinate&);

  void
  operator<< (::xercesc::DOMElement&, const PricingDataPointCoordinateReference&);

  void
  operator<< (::xercesc::DOMElement&, const PricingInputType&);

  void
  operator<< (::xercesc::DOMElement&, const PricingMethod&);

  void
  operator<< (::xercesc::DOMElement&, const PricingStructureReference&);

  void
  operator<< (::xercesc::DOMElement&, const PricingStructurePoint&);

  void
  operator<< (::xercesc::DOMElement&, const TermCurve&);

  void
  operator<< (::xercesc::DOMElement&, const TermPoint&);

  void
  operator<< (::xercesc::DOMElement&, const TimeDimension&);

  void
  operator<< (::xercesc::DOMElement&, const VolatilityMatrix&);

  void
  operator<< (::xercesc::DOMElement&, const VolatilityRepresentation&);

  void
  operator<< (::xercesc::DOMElement&, const YieldCurve&);

  void
  operator<< (::xercesc::DOMElement&, const YieldCurveValuation&);

  void
  operator<< (::xercesc::DOMElement&, const ZeroRateCurve&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_MKTENV_4_2_HXX
