// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_MSG_4_2_HXX
#define FPML_MSG_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class AdditionalData;
  class Message;
  class NotificationMessage;
  class ContractReferenceMessage;
  class ConversationId;
  class MessageAddress;
  class MessageHeader;
  class MessageId;
  class MessageRejected;
  class NotificationMessageHeader;
  class PartyMessageInformation;
  class ProblemLocation;
  class Reason;
  class ReasonCode;
  class RequestMessage;
  class RequestMessageHeader;
  class RequestTradeStatus;
  class ResponseMessage;
  class ResponseMessageHeader;
  class TradeNotFound;
  class TradeStatus;
  class TradeStatusItem;
  class TradeStatusValue;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "xmldsig-core-schema.hxx"

#include "fpml-doc-4-2.hxx"

namespace FpML_4_2
{
  class AdditionalData: public ::xml_schema::string
  {
    public:
    // additionalDataScheme
    // 
    typedef ::xml_schema::uri additionalDataScheme_type;
    typedef ::xsd::cxx::tree::optional< additionalDataScheme_type > additionalDataScheme_optional;
    typedef ::xsd::cxx::tree::traits< additionalDataScheme_type, char > additionalDataScheme_traits;

    const additionalDataScheme_optional&
    additionalDataScheme () const;

    additionalDataScheme_optional&
    additionalDataScheme ();

    void
    additionalDataScheme (const additionalDataScheme_type& x);

    void
    additionalDataScheme (const additionalDataScheme_optional& x);

    void
    additionalDataScheme (::std::auto_ptr< additionalDataScheme_type > p);

    // Constructors.
    //
    AdditionalData ();

    AdditionalData (const char*);

    AdditionalData (const ::std::string&);

    AdditionalData (const ::xml_schema::string&);

    AdditionalData (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    AdditionalData (const AdditionalData& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual AdditionalData*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdditionalData ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    additionalDataScheme_optional additionalDataScheme_;
  };

  class Message: public ::FpML_4_2::Document
  {
    public:
    // Constructors.
    //
    Message (const version_type&);

    Message (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Message (const Message& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Message*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Message ();
  };

  class NotificationMessage: public ::FpML_4_2::Message
  {
    public:
    // header
    // 
    typedef ::FpML_4_2::NotificationMessageHeader header_type;
    typedef ::xsd::cxx::tree::traits< header_type, char > header_traits;

    const header_type&
    header () const;

    header_type&
    header ();

    void
    header (const header_type& x);

    void
    header (::std::auto_ptr< header_type > p);

    // validation
    // 
    typedef ::FpML_4_2::Validation validation_type;
    typedef ::xsd::cxx::tree::sequence< validation_type > validation_sequence;
    typedef validation_sequence::iterator validation_iterator;
    typedef validation_sequence::const_iterator validation_const_iterator;
    typedef ::xsd::cxx::tree::traits< validation_type, char > validation_traits;

    const validation_sequence&
    validation () const;

    validation_sequence&
    validation ();

    void
    validation (const validation_sequence& s);

    // Constructors.
    //
    NotificationMessage (const version_type&,
                         const header_type&);

    NotificationMessage (const version_type&,
                         ::std::auto_ptr< header_type >&);

    NotificationMessage (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    NotificationMessage (const NotificationMessage& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual NotificationMessage*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NotificationMessage ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< header_type > header_;
    validation_sequence validation_;
  };

  class ContractReferenceMessage: public ::FpML_4_2::NotificationMessage
  {
    public:
    // contractReference
    // 
    typedef ::FpML_4_2::ContractReference contractReference_type;
    typedef ::xsd::cxx::tree::traits< contractReference_type, char > contractReference_traits;

    const contractReference_type&
    contractReference () const;

    contractReference_type&
    contractReference ();

    void
    contractReference (const contractReference_type& x);

    void
    contractReference (::std::auto_ptr< contractReference_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    ContractReferenceMessage (const version_type&,
                              const header_type&,
                              const contractReference_type&);

    ContractReferenceMessage (const version_type&,
                              ::std::auto_ptr< header_type >&,
                              ::std::auto_ptr< contractReference_type >&);

    ContractReferenceMessage (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    ContractReferenceMessage (const ContractReferenceMessage& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual ContractReferenceMessage*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ContractReferenceMessage ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< contractReference_type > contractReference_;
    party_sequence party_;
  };

  class ConversationId: public ::xml_schema::normalized_string
  {
    public:
    // conversationIdScheme
    // 
    typedef ::xml_schema::uri conversationIdScheme_type;
    typedef ::xsd::cxx::tree::traits< conversationIdScheme_type, char > conversationIdScheme_traits;

    const conversationIdScheme_type&
    conversationIdScheme () const;

    conversationIdScheme_type&
    conversationIdScheme ();

    void
    conversationIdScheme (const conversationIdScheme_type& x);

    void
    conversationIdScheme (::std::auto_ptr< conversationIdScheme_type > p);

    // Constructors.
    //
    ConversationId (const conversationIdScheme_type&);

    ConversationId (const char*,
                    const conversationIdScheme_type&);

    ConversationId (const ::std::string&,
                    const conversationIdScheme_type&);

    ConversationId (const ::xml_schema::normalized_string&,
                    const conversationIdScheme_type&);

    ConversationId (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ConversationId (const ConversationId& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ConversationId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ConversationId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< conversationIdScheme_type > conversationIdScheme_;
  };

  class MessageAddress: public ::xml_schema::normalized_string
  {
    public:
    // partyIdScheme
    // 
    typedef ::xml_schema::uri partyIdScheme_type;
    typedef ::xsd::cxx::tree::traits< partyIdScheme_type, char > partyIdScheme_traits;

    const partyIdScheme_type&
    partyIdScheme () const;

    partyIdScheme_type&
    partyIdScheme ();

    void
    partyIdScheme (const partyIdScheme_type& x);

    void
    partyIdScheme (::std::auto_ptr< partyIdScheme_type > p);

    static const partyIdScheme_type&
    partyIdScheme_default_value ();

    // Constructors.
    //
    MessageAddress ();

    MessageAddress (const char*);

    MessageAddress (const ::std::string&);

    MessageAddress (const ::xml_schema::normalized_string&);

    MessageAddress (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    MessageAddress (const MessageAddress& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual MessageAddress*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MessageAddress ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partyIdScheme_type > partyIdScheme_;
    static const partyIdScheme_type partyIdScheme_default_value_;
  };

  class MessageHeader: public ::xml_schema::type
  {
    public:
    // conversationId
    // 
    typedef ::FpML_4_2::ConversationId conversationId_type;
    typedef ::xsd::cxx::tree::optional< conversationId_type > conversationId_optional;
    typedef ::xsd::cxx::tree::traits< conversationId_type, char > conversationId_traits;

    const conversationId_optional&
    conversationId () const;

    conversationId_optional&
    conversationId ();

    void
    conversationId (const conversationId_type& x);

    void
    conversationId (const conversationId_optional& x);

    void
    conversationId (::std::auto_ptr< conversationId_type > p);

    // messageId
    // 
    typedef ::FpML_4_2::MessageId messageId_type;
    typedef ::xsd::cxx::tree::traits< messageId_type, char > messageId_traits;

    const messageId_type&
    messageId () const;

    messageId_type&
    messageId ();

    void
    messageId (const messageId_type& x);

    void
    messageId (::std::auto_ptr< messageId_type > p);

    // Constructors.
    //
    MessageHeader (const messageId_type&);

    MessageHeader (::std::auto_ptr< messageId_type >&);

    MessageHeader (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    MessageHeader (const MessageHeader& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual MessageHeader*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MessageHeader ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    conversationId_optional conversationId_;
    ::xsd::cxx::tree::one< messageId_type > messageId_;
  };

  class MessageId: public ::xml_schema::normalized_string
  {
    public:
    // messageIdScheme
    // 
    typedef ::xml_schema::uri messageIdScheme_type;
    typedef ::xsd::cxx::tree::traits< messageIdScheme_type, char > messageIdScheme_traits;

    const messageIdScheme_type&
    messageIdScheme () const;

    messageIdScheme_type&
    messageIdScheme ();

    void
    messageIdScheme (const messageIdScheme_type& x);

    void
    messageIdScheme (::std::auto_ptr< messageIdScheme_type > p);

    // Constructors.
    //
    MessageId (const messageIdScheme_type&);

    MessageId (const char*,
               const messageIdScheme_type&);

    MessageId (const ::std::string&,
               const messageIdScheme_type&);

    MessageId (const ::xml_schema::normalized_string&,
               const messageIdScheme_type&);

    MessageId (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    MessageId (const MessageId& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual MessageId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MessageId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< messageIdScheme_type > messageIdScheme_;
  };

  class MessageRejected: public ::FpML_4_2::NotificationMessage
  {
    public:
    // reason
    // 
    typedef ::FpML_4_2::Reason reason_type;
    typedef ::xsd::cxx::tree::sequence< reason_type > reason_sequence;
    typedef reason_sequence::iterator reason_iterator;
    typedef reason_sequence::const_iterator reason_const_iterator;
    typedef ::xsd::cxx::tree::traits< reason_type, char > reason_traits;

    const reason_sequence&
    reason () const;

    reason_sequence&
    reason ();

    void
    reason (const reason_sequence& s);

    // additionalData
    // 
    typedef ::FpML_4_2::AdditionalData additionalData_type;
    typedef ::xsd::cxx::tree::optional< additionalData_type > additionalData_optional;
    typedef ::xsd::cxx::tree::traits< additionalData_type, char > additionalData_traits;

    const additionalData_optional&
    additionalData () const;

    additionalData_optional&
    additionalData ();

    void
    additionalData (const additionalData_type& x);

    void
    additionalData (const additionalData_optional& x);

    void
    additionalData (::std::auto_ptr< additionalData_type > p);

    // Constructors.
    //
    MessageRejected (const version_type&,
                     const header_type&);

    MessageRejected (const version_type&,
                     ::std::auto_ptr< header_type >&);

    MessageRejected (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    MessageRejected (const MessageRejected& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual MessageRejected*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MessageRejected ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    reason_sequence reason_;
    additionalData_optional additionalData_;
  };

  class NotificationMessageHeader: public ::FpML_4_2::MessageHeader
  {
    public:
    // inReplyTo
    // 
    typedef ::FpML_4_2::MessageId inReplyTo_type;
    typedef ::xsd::cxx::tree::optional< inReplyTo_type > inReplyTo_optional;
    typedef ::xsd::cxx::tree::traits< inReplyTo_type, char > inReplyTo_traits;

    const inReplyTo_optional&
    inReplyTo () const;

    inReplyTo_optional&
    inReplyTo ();

    void
    inReplyTo (const inReplyTo_type& x);

    void
    inReplyTo (const inReplyTo_optional& x);

    void
    inReplyTo (::std::auto_ptr< inReplyTo_type > p);

    // sentBy
    // 
    typedef ::FpML_4_2::MessageAddress sentBy_type;
    typedef ::xsd::cxx::tree::traits< sentBy_type, char > sentBy_traits;

    const sentBy_type&
    sentBy () const;

    sentBy_type&
    sentBy ();

    void
    sentBy (const sentBy_type& x);

    void
    sentBy (::std::auto_ptr< sentBy_type > p);

    // sendTo
    // 
    typedef ::FpML_4_2::MessageAddress sendTo_type;
    typedef ::xsd::cxx::tree::sequence< sendTo_type > sendTo_sequence;
    typedef sendTo_sequence::iterator sendTo_iterator;
    typedef sendTo_sequence::const_iterator sendTo_const_iterator;
    typedef ::xsd::cxx::tree::traits< sendTo_type, char > sendTo_traits;

    const sendTo_sequence&
    sendTo () const;

    sendTo_sequence&
    sendTo ();

    void
    sendTo (const sendTo_sequence& s);

    // copyTo
    // 
    typedef ::FpML_4_2::MessageAddress copyTo_type;
    typedef ::xsd::cxx::tree::sequence< copyTo_type > copyTo_sequence;
    typedef copyTo_sequence::iterator copyTo_iterator;
    typedef copyTo_sequence::const_iterator copyTo_const_iterator;
    typedef ::xsd::cxx::tree::traits< copyTo_type, char > copyTo_traits;

    const copyTo_sequence&
    copyTo () const;

    copyTo_sequence&
    copyTo ();

    void
    copyTo (const copyTo_sequence& s);

    // creationTimestamp
    // 
    typedef ::xml_schema::date_time creationTimestamp_type;
    typedef ::xsd::cxx::tree::traits< creationTimestamp_type, char > creationTimestamp_traits;

    const creationTimestamp_type&
    creationTimestamp () const;

    creationTimestamp_type&
    creationTimestamp ();

    void
    creationTimestamp (const creationTimestamp_type& x);

    void
    creationTimestamp (::std::auto_ptr< creationTimestamp_type > p);

    // expiryTimestamp
    // 
    typedef ::xml_schema::date_time expiryTimestamp_type;
    typedef ::xsd::cxx::tree::optional< expiryTimestamp_type > expiryTimestamp_optional;
    typedef ::xsd::cxx::tree::traits< expiryTimestamp_type, char > expiryTimestamp_traits;

    const expiryTimestamp_optional&
    expiryTimestamp () const;

    expiryTimestamp_optional&
    expiryTimestamp ();

    void
    expiryTimestamp (const expiryTimestamp_type& x);

    void
    expiryTimestamp (const expiryTimestamp_optional& x);

    void
    expiryTimestamp (::std::auto_ptr< expiryTimestamp_type > p);

    // partyMessageInformation
    // 
    typedef ::FpML_4_2::PartyMessageInformation partyMessageInformation_type;
    typedef ::xsd::cxx::tree::sequence< partyMessageInformation_type > partyMessageInformation_sequence;
    typedef partyMessageInformation_sequence::iterator partyMessageInformation_iterator;
    typedef partyMessageInformation_sequence::const_iterator partyMessageInformation_const_iterator;
    typedef ::xsd::cxx::tree::traits< partyMessageInformation_type, char > partyMessageInformation_traits;

    const partyMessageInformation_sequence&
    partyMessageInformation () const;

    partyMessageInformation_sequence&
    partyMessageInformation ();

    void
    partyMessageInformation (const partyMessageInformation_sequence& s);

    // Signature
    // 
    typedef ::XMLDSig::SignatureType Signature_type;
    typedef ::xsd::cxx::tree::sequence< Signature_type > Signature_sequence;
    typedef Signature_sequence::iterator Signature_iterator;
    typedef Signature_sequence::const_iterator Signature_const_iterator;
    typedef ::xsd::cxx::tree::traits< Signature_type, char > Signature_traits;

    const Signature_sequence&
    Signature () const;

    Signature_sequence&
    Signature ();

    void
    Signature (const Signature_sequence& s);

    // Constructors.
    //
    NotificationMessageHeader (const messageId_type&,
                               const sentBy_type&,
                               const creationTimestamp_type&);

    NotificationMessageHeader (::std::auto_ptr< messageId_type >&,
                               ::std::auto_ptr< sentBy_type >&,
                               const creationTimestamp_type&);

    NotificationMessageHeader (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    NotificationMessageHeader (const NotificationMessageHeader& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual NotificationMessageHeader*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NotificationMessageHeader ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    inReplyTo_optional inReplyTo_;
    ::xsd::cxx::tree::one< sentBy_type > sentBy_;
    sendTo_sequence sendTo_;
    copyTo_sequence copyTo_;
    ::xsd::cxx::tree::one< creationTimestamp_type > creationTimestamp_;
    expiryTimestamp_optional expiryTimestamp_;
    partyMessageInformation_sequence partyMessageInformation_;
    Signature_sequence Signature_;
  };

  class PartyMessageInformation: public ::xml_schema::type
  {
    public:
    // partyReference
    // 
    typedef ::FpML_4_2::PartyReference partyReference_type;
    typedef ::xsd::cxx::tree::traits< partyReference_type, char > partyReference_traits;

    const partyReference_type&
    partyReference () const;

    partyReference_type&
    partyReference ();

    void
    partyReference (const partyReference_type& x);

    void
    partyReference (::std::auto_ptr< partyReference_type > p);

    // Constructors.
    //
    PartyMessageInformation (const partyReference_type&);

    PartyMessageInformation (::std::auto_ptr< partyReference_type >&);

    PartyMessageInformation (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    PartyMessageInformation (const PartyMessageInformation& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual PartyMessageInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PartyMessageInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partyReference_type > partyReference_;
  };

  class ProblemLocation: public ::xml_schema::normalized_string
  {
    public:
    // problemLocationScheme
    // 
    typedef ::xml_schema::uri problemLocationScheme_type;
    typedef ::xsd::cxx::tree::optional< problemLocationScheme_type > problemLocationScheme_optional;
    typedef ::xsd::cxx::tree::traits< problemLocationScheme_type, char > problemLocationScheme_traits;

    const problemLocationScheme_optional&
    problemLocationScheme () const;

    problemLocationScheme_optional&
    problemLocationScheme ();

    void
    problemLocationScheme (const problemLocationScheme_type& x);

    void
    problemLocationScheme (const problemLocationScheme_optional& x);

    void
    problemLocationScheme (::std::auto_ptr< problemLocationScheme_type > p);

    // Constructors.
    //
    ProblemLocation ();

    ProblemLocation (const char*);

    ProblemLocation (const ::std::string&);

    ProblemLocation (const ::xml_schema::normalized_string&);

    ProblemLocation (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    ProblemLocation (const ProblemLocation& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual ProblemLocation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ProblemLocation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    problemLocationScheme_optional problemLocationScheme_;
  };

  class Reason: public ::xml_schema::type
  {
    public:
    // reasonCode
    // 
    typedef ::FpML_4_2::ReasonCode reasonCode_type;
    typedef ::xsd::cxx::tree::traits< reasonCode_type, char > reasonCode_traits;

    const reasonCode_type&
    reasonCode () const;

    reasonCode_type&
    reasonCode ();

    void
    reasonCode (const reasonCode_type& x);

    void
    reasonCode (::std::auto_ptr< reasonCode_type > p);

    // location
    // 
    typedef ::FpML_4_2::ProblemLocation location_type;
    typedef ::xsd::cxx::tree::optional< location_type > location_optional;
    typedef ::xsd::cxx::tree::traits< location_type, char > location_traits;

    const location_optional&
    location () const;

    location_optional&
    location ();

    void
    location (const location_type& x);

    void
    location (const location_optional& x);

    void
    location (::std::auto_ptr< location_type > p);

    // description
    // 
    typedef ::xml_schema::string description_type;
    typedef ::xsd::cxx::tree::optional< description_type > description_optional;
    typedef ::xsd::cxx::tree::traits< description_type, char > description_traits;

    const description_optional&
    description () const;

    description_optional&
    description ();

    void
    description (const description_type& x);

    void
    description (const description_optional& x);

    void
    description (::std::auto_ptr< description_type > p);

    // validationRuleId
    // 
    typedef ::FpML_4_2::Validation validationRuleId_type;
    typedef ::xsd::cxx::tree::optional< validationRuleId_type > validationRuleId_optional;
    typedef ::xsd::cxx::tree::traits< validationRuleId_type, char > validationRuleId_traits;

    const validationRuleId_optional&
    validationRuleId () const;

    validationRuleId_optional&
    validationRuleId ();

    void
    validationRuleId (const validationRuleId_type& x);

    void
    validationRuleId (const validationRuleId_optional& x);

    void
    validationRuleId (::std::auto_ptr< validationRuleId_type > p);

    // additionalData
    // 
    typedef ::FpML_4_2::AdditionalData additionalData_type;
    typedef ::xsd::cxx::tree::sequence< additionalData_type > additionalData_sequence;
    typedef additionalData_sequence::iterator additionalData_iterator;
    typedef additionalData_sequence::const_iterator additionalData_const_iterator;
    typedef ::xsd::cxx::tree::traits< additionalData_type, char > additionalData_traits;

    const additionalData_sequence&
    additionalData () const;

    additionalData_sequence&
    additionalData ();

    void
    additionalData (const additionalData_sequence& s);

    // Constructors.
    //
    Reason (const reasonCode_type&);

    Reason (::std::auto_ptr< reasonCode_type >&);

    Reason (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Reason (const Reason& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Reason*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Reason ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< reasonCode_type > reasonCode_;
    location_optional location_;
    description_optional description_;
    validationRuleId_optional validationRuleId_;
    additionalData_sequence additionalData_;
  };

  class ReasonCode: public ::xml_schema::normalized_string
  {
    public:
    // reasonCodeScheme
    // 
    typedef ::xml_schema::uri reasonCodeScheme_type;
    typedef ::xsd::cxx::tree::traits< reasonCodeScheme_type, char > reasonCodeScheme_traits;

    const reasonCodeScheme_type&
    reasonCodeScheme () const;

    reasonCodeScheme_type&
    reasonCodeScheme ();

    void
    reasonCodeScheme (const reasonCodeScheme_type& x);

    void
    reasonCodeScheme (::std::auto_ptr< reasonCodeScheme_type > p);

    static const reasonCodeScheme_type&
    reasonCodeScheme_default_value ();

    // Constructors.
    //
    ReasonCode ();

    ReasonCode (const char*);

    ReasonCode (const ::std::string&);

    ReasonCode (const ::xml_schema::normalized_string&);

    ReasonCode (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    ReasonCode (const ReasonCode& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual ReasonCode*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReasonCode ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< reasonCodeScheme_type > reasonCodeScheme_;
    static const reasonCodeScheme_type reasonCodeScheme_default_value_;
  };

  class RequestMessage: public ::FpML_4_2::Message
  {
    public:
    // header
    // 
    typedef ::FpML_4_2::RequestMessageHeader header_type;
    typedef ::xsd::cxx::tree::traits< header_type, char > header_traits;

    const header_type&
    header () const;

    header_type&
    header ();

    void
    header (const header_type& x);

    void
    header (::std::auto_ptr< header_type > p);

    // validation
    // 
    typedef ::FpML_4_2::Validation validation_type;
    typedef ::xsd::cxx::tree::sequence< validation_type > validation_sequence;
    typedef validation_sequence::iterator validation_iterator;
    typedef validation_sequence::const_iterator validation_const_iterator;
    typedef ::xsd::cxx::tree::traits< validation_type, char > validation_traits;

    const validation_sequence&
    validation () const;

    validation_sequence&
    validation ();

    void
    validation (const validation_sequence& s);

    // Constructors.
    //
    RequestMessage (const version_type&,
                    const header_type&);

    RequestMessage (const version_type&,
                    ::std::auto_ptr< header_type >&);

    RequestMessage (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    RequestMessage (const RequestMessage& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual RequestMessage*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RequestMessage ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< header_type > header_;
    validation_sequence validation_;
  };

  class RequestMessageHeader: public ::FpML_4_2::MessageHeader
  {
    public:
    // sentBy
    // 
    typedef ::FpML_4_2::MessageAddress sentBy_type;
    typedef ::xsd::cxx::tree::traits< sentBy_type, char > sentBy_traits;

    const sentBy_type&
    sentBy () const;

    sentBy_type&
    sentBy ();

    void
    sentBy (const sentBy_type& x);

    void
    sentBy (::std::auto_ptr< sentBy_type > p);

    // sendTo
    // 
    typedef ::FpML_4_2::MessageAddress sendTo_type;
    typedef ::xsd::cxx::tree::sequence< sendTo_type > sendTo_sequence;
    typedef sendTo_sequence::iterator sendTo_iterator;
    typedef sendTo_sequence::const_iterator sendTo_const_iterator;
    typedef ::xsd::cxx::tree::traits< sendTo_type, char > sendTo_traits;

    const sendTo_sequence&
    sendTo () const;

    sendTo_sequence&
    sendTo ();

    void
    sendTo (const sendTo_sequence& s);

    // copyTo
    // 
    typedef ::FpML_4_2::MessageAddress copyTo_type;
    typedef ::xsd::cxx::tree::sequence< copyTo_type > copyTo_sequence;
    typedef copyTo_sequence::iterator copyTo_iterator;
    typedef copyTo_sequence::const_iterator copyTo_const_iterator;
    typedef ::xsd::cxx::tree::traits< copyTo_type, char > copyTo_traits;

    const copyTo_sequence&
    copyTo () const;

    copyTo_sequence&
    copyTo ();

    void
    copyTo (const copyTo_sequence& s);

    // creationTimestamp
    // 
    typedef ::xml_schema::date_time creationTimestamp_type;
    typedef ::xsd::cxx::tree::traits< creationTimestamp_type, char > creationTimestamp_traits;

    const creationTimestamp_type&
    creationTimestamp () const;

    creationTimestamp_type&
    creationTimestamp ();

    void
    creationTimestamp (const creationTimestamp_type& x);

    void
    creationTimestamp (::std::auto_ptr< creationTimestamp_type > p);

    // expiryTimestamp
    // 
    typedef ::xml_schema::date_time expiryTimestamp_type;
    typedef ::xsd::cxx::tree::optional< expiryTimestamp_type > expiryTimestamp_optional;
    typedef ::xsd::cxx::tree::traits< expiryTimestamp_type, char > expiryTimestamp_traits;

    const expiryTimestamp_optional&
    expiryTimestamp () const;

    expiryTimestamp_optional&
    expiryTimestamp ();

    void
    expiryTimestamp (const expiryTimestamp_type& x);

    void
    expiryTimestamp (const expiryTimestamp_optional& x);

    void
    expiryTimestamp (::std::auto_ptr< expiryTimestamp_type > p);

    // partyMessageInformation
    // 
    typedef ::FpML_4_2::PartyMessageInformation partyMessageInformation_type;
    typedef ::xsd::cxx::tree::sequence< partyMessageInformation_type > partyMessageInformation_sequence;
    typedef partyMessageInformation_sequence::iterator partyMessageInformation_iterator;
    typedef partyMessageInformation_sequence::const_iterator partyMessageInformation_const_iterator;
    typedef ::xsd::cxx::tree::traits< partyMessageInformation_type, char > partyMessageInformation_traits;

    const partyMessageInformation_sequence&
    partyMessageInformation () const;

    partyMessageInformation_sequence&
    partyMessageInformation ();

    void
    partyMessageInformation (const partyMessageInformation_sequence& s);

    // Signature
    // 
    typedef ::XMLDSig::SignatureType Signature_type;
    typedef ::xsd::cxx::tree::sequence< Signature_type > Signature_sequence;
    typedef Signature_sequence::iterator Signature_iterator;
    typedef Signature_sequence::const_iterator Signature_const_iterator;
    typedef ::xsd::cxx::tree::traits< Signature_type, char > Signature_traits;

    const Signature_sequence&
    Signature () const;

    Signature_sequence&
    Signature ();

    void
    Signature (const Signature_sequence& s);

    // Constructors.
    //
    RequestMessageHeader (const messageId_type&,
                          const sentBy_type&,
                          const creationTimestamp_type&);

    RequestMessageHeader (::std::auto_ptr< messageId_type >&,
                          ::std::auto_ptr< sentBy_type >&,
                          const creationTimestamp_type&);

    RequestMessageHeader (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    RequestMessageHeader (const RequestMessageHeader& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual RequestMessageHeader*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RequestMessageHeader ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< sentBy_type > sentBy_;
    sendTo_sequence sendTo_;
    copyTo_sequence copyTo_;
    ::xsd::cxx::tree::one< creationTimestamp_type > creationTimestamp_;
    expiryTimestamp_optional expiryTimestamp_;
    partyMessageInformation_sequence partyMessageInformation_;
    Signature_sequence Signature_;
  };

  class RequestTradeStatus: public ::FpML_4_2::RequestMessage
  {
    public:
    // tradeIdentifier
    // 
    typedef ::FpML_4_2::TradeIdentifier tradeIdentifier_type;
    typedef ::xsd::cxx::tree::sequence< tradeIdentifier_type > tradeIdentifier_sequence;
    typedef tradeIdentifier_sequence::iterator tradeIdentifier_iterator;
    typedef tradeIdentifier_sequence::const_iterator tradeIdentifier_const_iterator;
    typedef ::xsd::cxx::tree::traits< tradeIdentifier_type, char > tradeIdentifier_traits;

    const tradeIdentifier_sequence&
    tradeIdentifier () const;

    tradeIdentifier_sequence&
    tradeIdentifier ();

    void
    tradeIdentifier (const tradeIdentifier_sequence& s);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    RequestTradeStatus (const version_type&,
                        const header_type&);

    RequestTradeStatus (const version_type&,
                        ::std::auto_ptr< header_type >&);

    RequestTradeStatus (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    RequestTradeStatus (const RequestTradeStatus& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual RequestTradeStatus*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RequestTradeStatus ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    tradeIdentifier_sequence tradeIdentifier_;
    party_sequence party_;
  };

  class ResponseMessage: public ::FpML_4_2::Message
  {
    public:
    // header
    // 
    typedef ::FpML_4_2::ResponseMessageHeader header_type;
    typedef ::xsd::cxx::tree::traits< header_type, char > header_traits;

    const header_type&
    header () const;

    header_type&
    header ();

    void
    header (const header_type& x);

    void
    header (::std::auto_ptr< header_type > p);

    // validation
    // 
    typedef ::FpML_4_2::Validation validation_type;
    typedef ::xsd::cxx::tree::sequence< validation_type > validation_sequence;
    typedef validation_sequence::iterator validation_iterator;
    typedef validation_sequence::const_iterator validation_const_iterator;
    typedef ::xsd::cxx::tree::traits< validation_type, char > validation_traits;

    const validation_sequence&
    validation () const;

    validation_sequence&
    validation ();

    void
    validation (const validation_sequence& s);

    // Constructors.
    //
    ResponseMessage (const version_type&,
                     const header_type&);

    ResponseMessage (const version_type&,
                     ::std::auto_ptr< header_type >&);

    ResponseMessage (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    ResponseMessage (const ResponseMessage& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual ResponseMessage*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ResponseMessage ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< header_type > header_;
    validation_sequence validation_;
  };

  class ResponseMessageHeader: public ::FpML_4_2::MessageHeader
  {
    public:
    // inReplyTo
    // 
    typedef ::FpML_4_2::MessageId inReplyTo_type;
    typedef ::xsd::cxx::tree::traits< inReplyTo_type, char > inReplyTo_traits;

    const inReplyTo_type&
    inReplyTo () const;

    inReplyTo_type&
    inReplyTo ();

    void
    inReplyTo (const inReplyTo_type& x);

    void
    inReplyTo (::std::auto_ptr< inReplyTo_type > p);

    // sentBy
    // 
    typedef ::FpML_4_2::MessageAddress sentBy_type;
    typedef ::xsd::cxx::tree::traits< sentBy_type, char > sentBy_traits;

    const sentBy_type&
    sentBy () const;

    sentBy_type&
    sentBy ();

    void
    sentBy (const sentBy_type& x);

    void
    sentBy (::std::auto_ptr< sentBy_type > p);

    // sendTo
    // 
    typedef ::FpML_4_2::MessageAddress sendTo_type;
    typedef ::xsd::cxx::tree::sequence< sendTo_type > sendTo_sequence;
    typedef sendTo_sequence::iterator sendTo_iterator;
    typedef sendTo_sequence::const_iterator sendTo_const_iterator;
    typedef ::xsd::cxx::tree::traits< sendTo_type, char > sendTo_traits;

    const sendTo_sequence&
    sendTo () const;

    sendTo_sequence&
    sendTo ();

    void
    sendTo (const sendTo_sequence& s);

    // copyTo
    // 
    typedef ::FpML_4_2::MessageAddress copyTo_type;
    typedef ::xsd::cxx::tree::sequence< copyTo_type > copyTo_sequence;
    typedef copyTo_sequence::iterator copyTo_iterator;
    typedef copyTo_sequence::const_iterator copyTo_const_iterator;
    typedef ::xsd::cxx::tree::traits< copyTo_type, char > copyTo_traits;

    const copyTo_sequence&
    copyTo () const;

    copyTo_sequence&
    copyTo ();

    void
    copyTo (const copyTo_sequence& s);

    // creationTimestamp
    // 
    typedef ::xml_schema::date_time creationTimestamp_type;
    typedef ::xsd::cxx::tree::traits< creationTimestamp_type, char > creationTimestamp_traits;

    const creationTimestamp_type&
    creationTimestamp () const;

    creationTimestamp_type&
    creationTimestamp ();

    void
    creationTimestamp (const creationTimestamp_type& x);

    void
    creationTimestamp (::std::auto_ptr< creationTimestamp_type > p);

    // expiryTimestamp
    // 
    typedef ::xml_schema::date_time expiryTimestamp_type;
    typedef ::xsd::cxx::tree::optional< expiryTimestamp_type > expiryTimestamp_optional;
    typedef ::xsd::cxx::tree::traits< expiryTimestamp_type, char > expiryTimestamp_traits;

    const expiryTimestamp_optional&
    expiryTimestamp () const;

    expiryTimestamp_optional&
    expiryTimestamp ();

    void
    expiryTimestamp (const expiryTimestamp_type& x);

    void
    expiryTimestamp (const expiryTimestamp_optional& x);

    void
    expiryTimestamp (::std::auto_ptr< expiryTimestamp_type > p);

    // partyMessageInformation
    // 
    typedef ::FpML_4_2::PartyMessageInformation partyMessageInformation_type;
    typedef ::xsd::cxx::tree::sequence< partyMessageInformation_type > partyMessageInformation_sequence;
    typedef partyMessageInformation_sequence::iterator partyMessageInformation_iterator;
    typedef partyMessageInformation_sequence::const_iterator partyMessageInformation_const_iterator;
    typedef ::xsd::cxx::tree::traits< partyMessageInformation_type, char > partyMessageInformation_traits;

    const partyMessageInformation_sequence&
    partyMessageInformation () const;

    partyMessageInformation_sequence&
    partyMessageInformation ();

    void
    partyMessageInformation (const partyMessageInformation_sequence& s);

    // Signature
    // 
    typedef ::XMLDSig::SignatureType Signature_type;
    typedef ::xsd::cxx::tree::sequence< Signature_type > Signature_sequence;
    typedef Signature_sequence::iterator Signature_iterator;
    typedef Signature_sequence::const_iterator Signature_const_iterator;
    typedef ::xsd::cxx::tree::traits< Signature_type, char > Signature_traits;

    const Signature_sequence&
    Signature () const;

    Signature_sequence&
    Signature ();

    void
    Signature (const Signature_sequence& s);

    // Constructors.
    //
    ResponseMessageHeader (const messageId_type&,
                           const inReplyTo_type&,
                           const sentBy_type&,
                           const creationTimestamp_type&);

    ResponseMessageHeader (::std::auto_ptr< messageId_type >&,
                           ::std::auto_ptr< inReplyTo_type >&,
                           ::std::auto_ptr< sentBy_type >&,
                           const creationTimestamp_type&);

    ResponseMessageHeader (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    ResponseMessageHeader (const ResponseMessageHeader& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual ResponseMessageHeader*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ResponseMessageHeader ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< inReplyTo_type > inReplyTo_;
    ::xsd::cxx::tree::one< sentBy_type > sentBy_;
    sendTo_sequence sendTo_;
    copyTo_sequence copyTo_;
    ::xsd::cxx::tree::one< creationTimestamp_type > creationTimestamp_;
    expiryTimestamp_optional expiryTimestamp_;
    partyMessageInformation_sequence partyMessageInformation_;
    Signature_sequence Signature_;
  };

  class TradeNotFound: public ::FpML_4_2::ResponseMessage
  {
    public:
    // tradeIdentifier
    // 
    typedef ::FpML_4_2::TradeIdentifier tradeIdentifier_type;
    typedef ::xsd::cxx::tree::optional< tradeIdentifier_type > tradeIdentifier_optional;
    typedef ::xsd::cxx::tree::traits< tradeIdentifier_type, char > tradeIdentifier_traits;

    const tradeIdentifier_optional&
    tradeIdentifier () const;

    tradeIdentifier_optional&
    tradeIdentifier ();

    void
    tradeIdentifier (const tradeIdentifier_type& x);

    void
    tradeIdentifier (const tradeIdentifier_optional& x);

    void
    tradeIdentifier (::std::auto_ptr< tradeIdentifier_type > p);

    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::optional< trade_type > trade_optional;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_optional&
    trade () const;

    trade_optional&
    trade ();

    void
    trade (const trade_type& x);

    void
    trade (const trade_optional& x);

    void
    trade (::std::auto_ptr< trade_type > p);

    // tradeReference
    // 
    typedef ::FpML_4_2::PartyTradeIdentifiers tradeReference_type;
    typedef ::xsd::cxx::tree::optional< tradeReference_type > tradeReference_optional;
    typedef ::xsd::cxx::tree::traits< tradeReference_type, char > tradeReference_traits;

    const tradeReference_optional&
    tradeReference () const;

    tradeReference_optional&
    tradeReference ();

    void
    tradeReference (const tradeReference_type& x);

    void
    tradeReference (const tradeReference_optional& x);

    void
    tradeReference (::std::auto_ptr< tradeReference_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_type&
    party () const;

    party_type&
    party ();

    void
    party (const party_type& x);

    void
    party (::std::auto_ptr< party_type > p);

    // Constructors.
    //
    TradeNotFound (const version_type&,
                   const header_type&,
                   const party_type&);

    TradeNotFound (const version_type&,
                   ::std::auto_ptr< header_type >&,
                   ::std::auto_ptr< party_type >&);

    TradeNotFound (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    TradeNotFound (const TradeNotFound& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual TradeNotFound*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeNotFound ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    tradeIdentifier_optional tradeIdentifier_;
    trade_optional trade_;
    tradeReference_optional tradeReference_;
    ::xsd::cxx::tree::one< party_type > party_;
  };

  class TradeStatus: public ::FpML_4_2::ResponseMessage
  {
    public:
    // tradeStatusItem
    // 
    typedef ::FpML_4_2::TradeStatusItem tradeStatusItem_type;
    typedef ::xsd::cxx::tree::sequence< tradeStatusItem_type > tradeStatusItem_sequence;
    typedef tradeStatusItem_sequence::iterator tradeStatusItem_iterator;
    typedef tradeStatusItem_sequence::const_iterator tradeStatusItem_const_iterator;
    typedef ::xsd::cxx::tree::traits< tradeStatusItem_type, char > tradeStatusItem_traits;

    const tradeStatusItem_sequence&
    tradeStatusItem () const;

    tradeStatusItem_sequence&
    tradeStatusItem ();

    void
    tradeStatusItem (const tradeStatusItem_sequence& s);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    TradeStatus (const version_type&,
                 const header_type&);

    TradeStatus (const version_type&,
                 ::std::auto_ptr< header_type >&);

    TradeStatus (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    TradeStatus (const TradeStatus& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual TradeStatus*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeStatus ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    tradeStatusItem_sequence tradeStatusItem_;
    party_sequence party_;
  };

  class TradeStatusItem: public ::xml_schema::type
  {
    public:
    // tradeIdentifier
    // 
    typedef ::FpML_4_2::TradeIdentifier tradeIdentifier_type;
    typedef ::xsd::cxx::tree::traits< tradeIdentifier_type, char > tradeIdentifier_traits;

    const tradeIdentifier_type&
    tradeIdentifier () const;

    tradeIdentifier_type&
    tradeIdentifier ();

    void
    tradeIdentifier (const tradeIdentifier_type& x);

    void
    tradeIdentifier (::std::auto_ptr< tradeIdentifier_type > p);

    // tradeStatusValue
    // 
    typedef ::FpML_4_2::TradeStatusValue tradeStatusValue_type;
    typedef ::xsd::cxx::tree::traits< tradeStatusValue_type, char > tradeStatusValue_traits;

    const tradeStatusValue_type&
    tradeStatusValue () const;

    tradeStatusValue_type&
    tradeStatusValue ();

    void
    tradeStatusValue (const tradeStatusValue_type& x);

    void
    tradeStatusValue (::std::auto_ptr< tradeStatusValue_type > p);

    // Constructors.
    //
    TradeStatusItem (const tradeIdentifier_type&,
                     const tradeStatusValue_type&);

    TradeStatusItem (::std::auto_ptr< tradeIdentifier_type >&,
                     ::std::auto_ptr< tradeStatusValue_type >&);

    TradeStatusItem (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    TradeStatusItem (const TradeStatusItem& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual TradeStatusItem*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeStatusItem ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tradeIdentifier_type > tradeIdentifier_;
    ::xsd::cxx::tree::one< tradeStatusValue_type > tradeStatusValue_;
  };

  class TradeStatusValue: public ::xml_schema::normalized_string
  {
    public:
    // tradeStatusScheme
    // 
    typedef ::xml_schema::uri tradeStatusScheme_type;
    typedef ::xsd::cxx::tree::optional< tradeStatusScheme_type > tradeStatusScheme_optional;
    typedef ::xsd::cxx::tree::traits< tradeStatusScheme_type, char > tradeStatusScheme_traits;

    const tradeStatusScheme_optional&
    tradeStatusScheme () const;

    tradeStatusScheme_optional&
    tradeStatusScheme ();

    void
    tradeStatusScheme (const tradeStatusScheme_type& x);

    void
    tradeStatusScheme (const tradeStatusScheme_optional& x);

    void
    tradeStatusScheme (::std::auto_ptr< tradeStatusScheme_type > p);

    // Constructors.
    //
    TradeStatusValue ();

    TradeStatusValue (const char*);

    TradeStatusValue (const ::std::string&);

    TradeStatusValue (const ::xml_schema::normalized_string&);

    TradeStatusValue (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    TradeStatusValue (const TradeStatusValue& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual TradeStatusValue*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeStatusValue ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    tradeStatusScheme_optional tradeStatusScheme_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const AdditionalData&);

  void
  operator<< (::xercesc::DOMElement&, const Message&);

  void
  operator<< (::xercesc::DOMElement&, const NotificationMessage&);

  void
  operator<< (::xercesc::DOMElement&, const ContractReferenceMessage&);

  void
  operator<< (::xercesc::DOMElement&, const ConversationId&);

  void
  operator<< (::xercesc::DOMElement&, const MessageAddress&);

  void
  operator<< (::xercesc::DOMElement&, const MessageHeader&);

  void
  operator<< (::xercesc::DOMElement&, const MessageId&);

  void
  operator<< (::xercesc::DOMElement&, const MessageRejected&);

  void
  operator<< (::xercesc::DOMElement&, const NotificationMessageHeader&);

  void
  operator<< (::xercesc::DOMElement&, const PartyMessageInformation&);

  void
  operator<< (::xercesc::DOMElement&, const ProblemLocation&);

  void
  operator<< (::xercesc::DOMElement&, const Reason&);

  void
  operator<< (::xercesc::DOMElement&, const ReasonCode&);

  void
  operator<< (::xercesc::DOMElement&, const RequestMessage&);

  void
  operator<< (::xercesc::DOMElement&, const RequestMessageHeader&);

  void
  operator<< (::xercesc::DOMElement&, const RequestTradeStatus&);

  void
  operator<< (::xercesc::DOMElement&, const ResponseMessage&);

  void
  operator<< (::xercesc::DOMElement&, const ResponseMessageHeader&);

  void
  operator<< (::xercesc::DOMElement&, const TradeNotFound&);

  void
  operator<< (::xercesc::DOMElement&, const TradeStatus&);

  void
  operator<< (::xercesc::DOMElement&, const TradeStatusItem&);

  void
  operator<< (::xercesc::DOMElement&, const TradeStatusValue&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_MSG_4_2_HXX
