// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_REPORTING_4_2_HXX
#define FPML_REPORTING_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class PositionReport;
  class PortfolioValuationItem;
  class RequestValuationReport;
  class TradeValuationItem;
  class ValuationReport;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-msg-4-2.hxx"

#include "fpml-valuation-4-2.hxx"

namespace FpML_4_2
{
  class PositionReport: public ::FpML_4_2::NotificationMessage
  {
    public:
    // asOfDate
    // 
    typedef ::FpML_4_2::IdentifiedDate asOfDate_type;
    typedef ::xsd::cxx::tree::optional< asOfDate_type > asOfDate_optional;
    typedef ::xsd::cxx::tree::traits< asOfDate_type, char > asOfDate_traits;

    const asOfDate_optional&
    asOfDate () const;

    asOfDate_optional&
    asOfDate ();

    void
    asOfDate (const asOfDate_type& x);

    void
    asOfDate (const asOfDate_optional& x);

    void
    asOfDate (::std::auto_ptr< asOfDate_type > p);

    // dataSetName
    // 
    typedef ::xml_schema::string dataSetName_type;
    typedef ::xsd::cxx::tree::optional< dataSetName_type > dataSetName_optional;
    typedef ::xsd::cxx::tree::traits< dataSetName_type, char > dataSetName_traits;

    const dataSetName_optional&
    dataSetName () const;

    dataSetName_optional&
    dataSetName ();

    void
    dataSetName (const dataSetName_type& x);

    void
    dataSetName (const dataSetName_optional& x);

    void
    dataSetName (::std::auto_ptr< dataSetName_type > p);

    // quotationCharacteristics
    // 
    typedef ::FpML_4_2::QuotationCharacteristics quotationCharacteristics_type;
    typedef ::xsd::cxx::tree::optional< quotationCharacteristics_type > quotationCharacteristics_optional;
    typedef ::xsd::cxx::tree::traits< quotationCharacteristics_type, char > quotationCharacteristics_traits;

    const quotationCharacteristics_optional&
    quotationCharacteristics () const;

    quotationCharacteristics_optional&
    quotationCharacteristics ();

    void
    quotationCharacteristics (const quotationCharacteristics_type& x);

    void
    quotationCharacteristics (const quotationCharacteristics_optional& x);

    void
    quotationCharacteristics (::std::auto_ptr< quotationCharacteristics_type > p);

    // position
    // 
    typedef ::FpML_4_2::Position position_type;
    typedef ::xsd::cxx::tree::sequence< position_type > position_sequence;
    typedef position_sequence::iterator position_iterator;
    typedef position_sequence::const_iterator position_const_iterator;
    typedef ::xsd::cxx::tree::traits< position_type, char > position_traits;

    const position_sequence&
    position () const;

    position_sequence&
    position ();

    void
    position (const position_sequence& s);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    PositionReport (const version_type&,
                    const header_type&);

    PositionReport (const version_type&,
                    ::std::auto_ptr< header_type >&);

    PositionReport (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    PositionReport (const PositionReport& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual PositionReport*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PositionReport ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    asOfDate_optional asOfDate_;
    dataSetName_optional dataSetName_;
    quotationCharacteristics_optional quotationCharacteristics_;
    position_sequence position_;
    party_sequence party_;
  };

  class PortfolioValuationItem: public ::xml_schema::type
  {
    public:
    // portfolio
    // 
    typedef ::FpML_4_2::Portfolio portfolio_type;
    typedef ::xsd::cxx::tree::traits< portfolio_type, char > portfolio_traits;

    const portfolio_type&
    portfolio () const;

    portfolio_type&
    portfolio ();

    void
    portfolio (const portfolio_type& x);

    void
    portfolio (::std::auto_ptr< portfolio_type > p);

    // tradeValuationItem
    // 
    typedef ::FpML_4_2::TradeValuationItem tradeValuationItem_type;
    typedef ::xsd::cxx::tree::sequence< tradeValuationItem_type > tradeValuationItem_sequence;
    typedef tradeValuationItem_sequence::iterator tradeValuationItem_iterator;
    typedef tradeValuationItem_sequence::const_iterator tradeValuationItem_const_iterator;
    typedef ::xsd::cxx::tree::traits< tradeValuationItem_type, char > tradeValuationItem_traits;

    const tradeValuationItem_sequence&
    tradeValuationItem () const;

    tradeValuationItem_sequence&
    tradeValuationItem ();

    void
    tradeValuationItem (const tradeValuationItem_sequence& s);

    // valuationSet
    // 
    typedef ::FpML_4_2::ValuationSet valuationSet_type;
    typedef ::xsd::cxx::tree::optional< valuationSet_type > valuationSet_optional;
    typedef ::xsd::cxx::tree::traits< valuationSet_type, char > valuationSet_traits;

    const valuationSet_optional&
    valuationSet () const;

    valuationSet_optional&
    valuationSet ();

    void
    valuationSet (const valuationSet_type& x);

    void
    valuationSet (const valuationSet_optional& x);

    void
    valuationSet (::std::auto_ptr< valuationSet_type > p);

    // Constructors.
    //
    PortfolioValuationItem (const portfolio_type&);

    PortfolioValuationItem (::std::auto_ptr< portfolio_type >&);

    PortfolioValuationItem (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    PortfolioValuationItem (const PortfolioValuationItem& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual PortfolioValuationItem*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PortfolioValuationItem ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< portfolio_type > portfolio_;
    tradeValuationItem_sequence tradeValuationItem_;
    valuationSet_optional valuationSet_;
  };

  class RequestValuationReport: public ::FpML_4_2::RequestMessage
  {
    public:
    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // market
    // 
    typedef ::FpML_4_2::Market market_type;
    typedef ::xsd::cxx::tree::optional< market_type > market_optional;
    typedef ::xsd::cxx::tree::traits< market_type, char > market_traits;

    const market_optional&
    market () const;

    market_optional&
    market ();

    void
    market (const market_type& x);

    void
    market (const market_optional& x);

    void
    market (::std::auto_ptr< market_type > p);

    // portfolioValuationItem
    // 
    typedef ::FpML_4_2::PortfolioValuationItem portfolioValuationItem_type;
    typedef ::xsd::cxx::tree::sequence< portfolioValuationItem_type > portfolioValuationItem_sequence;
    typedef portfolioValuationItem_sequence::iterator portfolioValuationItem_iterator;
    typedef portfolioValuationItem_sequence::const_iterator portfolioValuationItem_const_iterator;
    typedef ::xsd::cxx::tree::traits< portfolioValuationItem_type, char > portfolioValuationItem_traits;

    const portfolioValuationItem_sequence&
    portfolioValuationItem () const;

    portfolioValuationItem_sequence&
    portfolioValuationItem ();

    void
    portfolioValuationItem (const portfolioValuationItem_sequence& s);

    // tradeValuationItem
    // 
    typedef ::FpML_4_2::TradeValuationItem tradeValuationItem_type;
    typedef ::xsd::cxx::tree::sequence< tradeValuationItem_type > tradeValuationItem_sequence;
    typedef tradeValuationItem_sequence::iterator tradeValuationItem_iterator;
    typedef tradeValuationItem_sequence::const_iterator tradeValuationItem_const_iterator;
    typedef ::xsd::cxx::tree::traits< tradeValuationItem_type, char > tradeValuationItem_traits;

    const tradeValuationItem_sequence&
    tradeValuationItem () const;

    tradeValuationItem_sequence&
    tradeValuationItem ();

    void
    tradeValuationItem (const tradeValuationItem_sequence& s);

    // Constructors.
    //
    RequestValuationReport (const version_type&,
                            const header_type&);

    RequestValuationReport (const version_type&,
                            ::std::auto_ptr< header_type >&);

    RequestValuationReport (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    RequestValuationReport (const RequestValuationReport& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual RequestValuationReport*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RequestValuationReport ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    party_sequence party_;
    market_optional market_;
    portfolioValuationItem_sequence portfolioValuationItem_;
    tradeValuationItem_sequence tradeValuationItem_;
  };

  class TradeValuationItem: public ::xml_schema::type
  {
    public:
    // partyTradeIdentifier
    // 
    typedef ::FpML_4_2::PartyTradeIdentifier partyTradeIdentifier_type;
    typedef ::xsd::cxx::tree::sequence< partyTradeIdentifier_type > partyTradeIdentifier_sequence;
    typedef partyTradeIdentifier_sequence::iterator partyTradeIdentifier_iterator;
    typedef partyTradeIdentifier_sequence::const_iterator partyTradeIdentifier_const_iterator;
    typedef ::xsd::cxx::tree::traits< partyTradeIdentifier_type, char > partyTradeIdentifier_traits;

    const partyTradeIdentifier_sequence&
    partyTradeIdentifier () const;

    partyTradeIdentifier_sequence&
    partyTradeIdentifier ();

    void
    partyTradeIdentifier (const partyTradeIdentifier_sequence& s);

    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::sequence< trade_type > trade_sequence;
    typedef trade_sequence::iterator trade_iterator;
    typedef trade_sequence::const_iterator trade_const_iterator;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_sequence&
    trade () const;

    trade_sequence&
    trade ();

    void
    trade (const trade_sequence& s);

    // valuationSet
    // 
    typedef ::FpML_4_2::ValuationSet valuationSet_type;
    typedef ::xsd::cxx::tree::traits< valuationSet_type, char > valuationSet_traits;

    const valuationSet_type&
    valuationSet () const;

    valuationSet_type&
    valuationSet ();

    void
    valuationSet (const valuationSet_type& x);

    void
    valuationSet (::std::auto_ptr< valuationSet_type > p);

    // Constructors.
    //
    TradeValuationItem (const valuationSet_type&);

    TradeValuationItem (::std::auto_ptr< valuationSet_type >&);

    TradeValuationItem (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TradeValuationItem (const TradeValuationItem& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual TradeValuationItem*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeValuationItem ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    partyTradeIdentifier_sequence partyTradeIdentifier_;
    trade_sequence trade_;
    ::xsd::cxx::tree::one< valuationSet_type > valuationSet_;
  };

  class ValuationReport: public ::FpML_4_2::NotificationMessage
  {
    public:
    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // market
    // 
    typedef ::FpML_4_2::Market market_type;
    typedef ::xsd::cxx::tree::optional< market_type > market_optional;
    typedef ::xsd::cxx::tree::traits< market_type, char > market_traits;

    const market_optional&
    market () const;

    market_optional&
    market ();

    void
    market (const market_type& x);

    void
    market (const market_optional& x);

    void
    market (::std::auto_ptr< market_type > p);

    // portfolioValuationItem
    // 
    typedef ::FpML_4_2::PortfolioValuationItem portfolioValuationItem_type;
    typedef ::xsd::cxx::tree::sequence< portfolioValuationItem_type > portfolioValuationItem_sequence;
    typedef portfolioValuationItem_sequence::iterator portfolioValuationItem_iterator;
    typedef portfolioValuationItem_sequence::const_iterator portfolioValuationItem_const_iterator;
    typedef ::xsd::cxx::tree::traits< portfolioValuationItem_type, char > portfolioValuationItem_traits;

    const portfolioValuationItem_sequence&
    portfolioValuationItem () const;

    portfolioValuationItem_sequence&
    portfolioValuationItem ();

    void
    portfolioValuationItem (const portfolioValuationItem_sequence& s);

    // tradeValuationItem
    // 
    typedef ::FpML_4_2::TradeValuationItem tradeValuationItem_type;
    typedef ::xsd::cxx::tree::sequence< tradeValuationItem_type > tradeValuationItem_sequence;
    typedef tradeValuationItem_sequence::iterator tradeValuationItem_iterator;
    typedef tradeValuationItem_sequence::const_iterator tradeValuationItem_const_iterator;
    typedef ::xsd::cxx::tree::traits< tradeValuationItem_type, char > tradeValuationItem_traits;

    const tradeValuationItem_sequence&
    tradeValuationItem () const;

    tradeValuationItem_sequence&
    tradeValuationItem ();

    void
    tradeValuationItem (const tradeValuationItem_sequence& s);

    // Constructors.
    //
    ValuationReport (const version_type&,
                     const header_type&);

    ValuationReport (const version_type&,
                     ::std::auto_ptr< header_type >&);

    ValuationReport (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    ValuationReport (const ValuationReport& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual ValuationReport*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ValuationReport ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    party_sequence party_;
    market_optional market_;
    portfolioValuationItem_sequence portfolioValuationItem_;
    tradeValuationItem_sequence tradeValuationItem_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const PositionReport&);

  void
  operator<< (::xercesc::DOMElement&, const PortfolioValuationItem&);

  void
  operator<< (::xercesc::DOMElement&, const RequestValuationReport&);

  void
  operator<< (::xercesc::DOMElement&, const TradeValuationItem&);

  void
  operator<< (::xercesc::DOMElement&, const ValuationReport&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_REPORTING_4_2_HXX
