// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_RETURN_SWAPS_4_2_HXX
#define FPML_RETURN_SWAPS_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class DeprecatedEquityLeg;
  class DeprecatedEquityLegValuation;
  class DeprecatedEquityLegValuationPrice;
  class DeprecatedEquityPaymentDates;
  class EquitySwapTransactionSupplement;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-ird-4-2.hxx"

#include "fpml-eq-shared-4-2.hxx"

namespace FpML_4_2
{
  class DeprecatedEquityLeg: public ::FpML_4_2::ReturnSwapLeg
  {
    public:
    // effectiveDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate effectiveDate_type;
    typedef ::xsd::cxx::tree::traits< effectiveDate_type, char > effectiveDate_traits;

    const effectiveDate_type&
    effectiveDate () const;

    effectiveDate_type&
    effectiveDate ();

    void
    effectiveDate (const effectiveDate_type& x);

    void
    effectiveDate (::std::auto_ptr< effectiveDate_type > p);

    // terminationDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate terminationDate_type;
    typedef ::xsd::cxx::tree::traits< terminationDate_type, char > terminationDate_traits;

    const terminationDate_type&
    terminationDate () const;

    terminationDate_type&
    terminationDate ();

    void
    terminationDate (const terminationDate_type& x);

    void
    terminationDate (::std::auto_ptr< terminationDate_type > p);

    // underlyer
    // 
    typedef ::FpML_4_2::Underlyer underlyer_type;
    typedef ::xsd::cxx::tree::traits< underlyer_type, char > underlyer_traits;

    const underlyer_type&
    underlyer () const;

    underlyer_type&
    underlyer ();

    void
    underlyer (const underlyer_type& x);

    void
    underlyer (::std::auto_ptr< underlyer_type > p);

    // valuation
    // 
    typedef ::FpML_4_2::DeprecatedEquityLegValuation valuation_type;
    typedef ::xsd::cxx::tree::traits< valuation_type, char > valuation_traits;

    const valuation_type&
    valuation () const;

    valuation_type&
    valuation ();

    void
    valuation (const valuation_type& x);

    void
    valuation (::std::auto_ptr< valuation_type > p);

    // notional
    // 
    typedef ::FpML_4_2::ReturnSwapNotional notional_type;
    typedef ::xsd::cxx::tree::traits< notional_type, char > notional_traits;

    const notional_type&
    notional () const;

    notional_type&
    notional ();

    void
    notional (const notional_type& x);

    void
    notional (::std::auto_ptr< notional_type > p);

    // equityAmount
    // 
    typedef ::FpML_4_2::ReturnSwapAmount equityAmount_type;
    typedef ::xsd::cxx::tree::traits< equityAmount_type, char > equityAmount_traits;

    const equityAmount_type&
    equityAmount () const;

    equityAmount_type&
    equityAmount ();

    void
    equityAmount (const equityAmount_type& x);

    void
    equityAmount (::std::auto_ptr< equityAmount_type > p);

    // return
    // 
    typedef ::FpML_4_2::Return return_type;
    typedef ::xsd::cxx::tree::traits< return_type, char > return_traits;

    const return_type&
    return_ () const;

    return_type&
    return_ ();

    void
    return_ (const return_type& x);

    void
    return_ (::std::auto_ptr< return_type > p);

    // notionalAdjustments
    // 
    typedef ::FpML_4_2::NotionalAdjustmentEnum notionalAdjustments_type;
    typedef ::xsd::cxx::tree::traits< notionalAdjustments_type, char > notionalAdjustments_traits;

    const notionalAdjustments_type&
    notionalAdjustments () const;

    notionalAdjustments_type&
    notionalAdjustments ();

    void
    notionalAdjustments (const notionalAdjustments_type& x);

    void
    notionalAdjustments (::std::auto_ptr< notionalAdjustments_type > p);

    // fxFeature
    // 
    typedef ::FpML_4_2::FxFeature fxFeature_type;
    typedef ::xsd::cxx::tree::optional< fxFeature_type > fxFeature_optional;
    typedef ::xsd::cxx::tree::traits< fxFeature_type, char > fxFeature_traits;

    const fxFeature_optional&
    fxFeature () const;

    fxFeature_optional&
    fxFeature ();

    void
    fxFeature (const fxFeature_type& x);

    void
    fxFeature (const fxFeature_optional& x);

    void
    fxFeature (::std::auto_ptr< fxFeature_type > p);

    // Constructors.
    //
    DeprecatedEquityLeg (const payerPartyReference_type&,
                         const receiverPartyReference_type&,
                         const effectiveDate_type&,
                         const terminationDate_type&,
                         const underlyer_type&,
                         const valuation_type&,
                         const notional_type&,
                         const equityAmount_type&,
                         const return_type&,
                         const notionalAdjustments_type&);

    DeprecatedEquityLeg (::std::auto_ptr< payerPartyReference_type >&,
                         ::std::auto_ptr< receiverPartyReference_type >&,
                         ::std::auto_ptr< effectiveDate_type >&,
                         ::std::auto_ptr< terminationDate_type >&,
                         ::std::auto_ptr< underlyer_type >&,
                         ::std::auto_ptr< valuation_type >&,
                         ::std::auto_ptr< notional_type >&,
                         ::std::auto_ptr< equityAmount_type >&,
                         ::std::auto_ptr< return_type >&,
                         const notionalAdjustments_type&);

    DeprecatedEquityLeg (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    DeprecatedEquityLeg (const DeprecatedEquityLeg& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual DeprecatedEquityLeg*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DeprecatedEquityLeg ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< effectiveDate_type > effectiveDate_;
    ::xsd::cxx::tree::one< terminationDate_type > terminationDate_;
    ::xsd::cxx::tree::one< underlyer_type > underlyer_;
    ::xsd::cxx::tree::one< valuation_type > valuation_;
    ::xsd::cxx::tree::one< notional_type > notional_;
    ::xsd::cxx::tree::one< equityAmount_type > equityAmount_;
    ::xsd::cxx::tree::one< return_type > return__;
    ::xsd::cxx::tree::one< notionalAdjustments_type > notionalAdjustments_;
    fxFeature_optional fxFeature_;
  };

  class DeprecatedEquityLegValuation: public ::xml_schema::type
  {
    public:
    // initialPrice
    // 
    typedef ::FpML_4_2::DeprecatedEquityLegValuationPrice initialPrice_type;
    typedef ::xsd::cxx::tree::traits< initialPrice_type, char > initialPrice_traits;

    const initialPrice_type&
    initialPrice () const;

    initialPrice_type&
    initialPrice ();

    void
    initialPrice (const initialPrice_type& x);

    void
    initialPrice (::std::auto_ptr< initialPrice_type > p);

    // equityNotionalReset
    // 
    typedef ::xml_schema::boolean equityNotionalReset_type;
    typedef ::xsd::cxx::tree::traits< equityNotionalReset_type, char > equityNotionalReset_traits;

    const equityNotionalReset_type&
    equityNotionalReset () const;

    equityNotionalReset_type&
    equityNotionalReset ();

    void
    equityNotionalReset (const equityNotionalReset_type& x);

    // valuationPriceInterim
    // 
    typedef ::FpML_4_2::DeprecatedEquityLegValuationPrice valuationPriceInterim_type;
    typedef ::xsd::cxx::tree::optional< valuationPriceInterim_type > valuationPriceInterim_optional;
    typedef ::xsd::cxx::tree::traits< valuationPriceInterim_type, char > valuationPriceInterim_traits;

    const valuationPriceInterim_optional&
    valuationPriceInterim () const;

    valuationPriceInterim_optional&
    valuationPriceInterim ();

    void
    valuationPriceInterim (const valuationPriceInterim_type& x);

    void
    valuationPriceInterim (const valuationPriceInterim_optional& x);

    void
    valuationPriceInterim (::std::auto_ptr< valuationPriceInterim_type > p);

    // valuationPriceFinal
    // 
    typedef ::FpML_4_2::DeprecatedEquityLegValuationPrice valuationPriceFinal_type;
    typedef ::xsd::cxx::tree::traits< valuationPriceFinal_type, char > valuationPriceFinal_traits;

    const valuationPriceFinal_type&
    valuationPriceFinal () const;

    valuationPriceFinal_type&
    valuationPriceFinal ();

    void
    valuationPriceFinal (const valuationPriceFinal_type& x);

    void
    valuationPriceFinal (::std::auto_ptr< valuationPriceFinal_type > p);

    // equityPaymentDates
    // 
    typedef ::FpML_4_2::DeprecatedEquityPaymentDates equityPaymentDates_type;
    typedef ::xsd::cxx::tree::traits< equityPaymentDates_type, char > equityPaymentDates_traits;

    const equityPaymentDates_type&
    equityPaymentDates () const;

    equityPaymentDates_type&
    equityPaymentDates ();

    void
    equityPaymentDates (const equityPaymentDates_type& x);

    void
    equityPaymentDates (::std::auto_ptr< equityPaymentDates_type > p);

    // Constructors.
    //
    DeprecatedEquityLegValuation (const initialPrice_type&,
                                  const equityNotionalReset_type&,
                                  const valuationPriceFinal_type&,
                                  const equityPaymentDates_type&);

    DeprecatedEquityLegValuation (::std::auto_ptr< initialPrice_type >&,
                                  const equityNotionalReset_type&,
                                  ::std::auto_ptr< valuationPriceFinal_type >&,
                                  ::std::auto_ptr< equityPaymentDates_type >&);

    DeprecatedEquityLegValuation (const ::xercesc::DOMElement& e,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    DeprecatedEquityLegValuation (const DeprecatedEquityLegValuation& x,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    virtual DeprecatedEquityLegValuation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DeprecatedEquityLegValuation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< initialPrice_type > initialPrice_;
    ::xsd::cxx::tree::one< equityNotionalReset_type > equityNotionalReset_;
    valuationPriceInterim_optional valuationPriceInterim_;
    ::xsd::cxx::tree::one< valuationPriceFinal_type > valuationPriceFinal_;
    ::xsd::cxx::tree::one< equityPaymentDates_type > equityPaymentDates_;
  };

  class DeprecatedEquityLegValuationPrice: public ::FpML_4_2::Price
  {
    public:
    // equityValuation
    // 
    typedef ::FpML_4_2::EquityValuation equityValuation_type;
    typedef ::xsd::cxx::tree::optional< equityValuation_type > equityValuation_optional;
    typedef ::xsd::cxx::tree::traits< equityValuation_type, char > equityValuation_traits;

    const equityValuation_optional&
    equityValuation () const;

    equityValuation_optional&
    equityValuation ();

    void
    equityValuation (const equityValuation_type& x);

    void
    equityValuation (const equityValuation_optional& x);

    void
    equityValuation (::std::auto_ptr< equityValuation_type > p);

    // Constructors.
    //
    DeprecatedEquityLegValuationPrice ();

    DeprecatedEquityLegValuationPrice (const ::xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    DeprecatedEquityLegValuationPrice (const DeprecatedEquityLegValuationPrice& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual DeprecatedEquityLegValuationPrice*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DeprecatedEquityLegValuationPrice ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    equityValuation_optional equityValuation_;
  };

  class DeprecatedEquityPaymentDates: public ::xml_schema::type
  {
    public:
    // equityPaymentDatesInterim
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDates equityPaymentDatesInterim_type;
    typedef ::xsd::cxx::tree::optional< equityPaymentDatesInterim_type > equityPaymentDatesInterim_optional;
    typedef ::xsd::cxx::tree::traits< equityPaymentDatesInterim_type, char > equityPaymentDatesInterim_traits;

    const equityPaymentDatesInterim_optional&
    equityPaymentDatesInterim () const;

    equityPaymentDatesInterim_optional&
    equityPaymentDatesInterim ();

    void
    equityPaymentDatesInterim (const equityPaymentDatesInterim_type& x);

    void
    equityPaymentDatesInterim (const equityPaymentDatesInterim_optional& x);

    void
    equityPaymentDatesInterim (::std::auto_ptr< equityPaymentDatesInterim_type > p);

    // equityPaymentDateFinal
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate equityPaymentDateFinal_type;
    typedef ::xsd::cxx::tree::traits< equityPaymentDateFinal_type, char > equityPaymentDateFinal_traits;

    const equityPaymentDateFinal_type&
    equityPaymentDateFinal () const;

    equityPaymentDateFinal_type&
    equityPaymentDateFinal ();

    void
    equityPaymentDateFinal (const equityPaymentDateFinal_type& x);

    void
    equityPaymentDateFinal (::std::auto_ptr< equityPaymentDateFinal_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    DeprecatedEquityPaymentDates (const equityPaymentDateFinal_type&);

    DeprecatedEquityPaymentDates (::std::auto_ptr< equityPaymentDateFinal_type >&);

    DeprecatedEquityPaymentDates (const ::xercesc::DOMElement& e,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    DeprecatedEquityPaymentDates (const DeprecatedEquityPaymentDates& x,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    virtual DeprecatedEquityPaymentDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DeprecatedEquityPaymentDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    equityPaymentDatesInterim_optional equityPaymentDatesInterim_;
    ::xsd::cxx::tree::one< equityPaymentDateFinal_type > equityPaymentDateFinal_;
    id_optional id_;
  };

  class EquitySwapTransactionSupplement: public ::FpML_4_2::ReturnSwapBase
  {
    public:
    // mutualEarlyTermination
    // 
    typedef ::xml_schema::boolean mutualEarlyTermination_type;
    typedef ::xsd::cxx::tree::optional< mutualEarlyTermination_type > mutualEarlyTermination_optional;
    typedef ::xsd::cxx::tree::traits< mutualEarlyTermination_type, char > mutualEarlyTermination_traits;

    const mutualEarlyTermination_optional&
    mutualEarlyTermination () const;

    mutualEarlyTermination_optional&
    mutualEarlyTermination ();

    void
    mutualEarlyTermination (const mutualEarlyTermination_type& x);

    void
    mutualEarlyTermination (const mutualEarlyTermination_optional& x);

    // multipleExchangeIndexAnnexFallback
    // 
    typedef ::xml_schema::boolean multipleExchangeIndexAnnexFallback_type;
    typedef ::xsd::cxx::tree::optional< multipleExchangeIndexAnnexFallback_type > multipleExchangeIndexAnnexFallback_optional;
    typedef ::xsd::cxx::tree::traits< multipleExchangeIndexAnnexFallback_type, char > multipleExchangeIndexAnnexFallback_traits;

    const multipleExchangeIndexAnnexFallback_optional&
    multipleExchangeIndexAnnexFallback () const;

    multipleExchangeIndexAnnexFallback_optional&
    multipleExchangeIndexAnnexFallback ();

    void
    multipleExchangeIndexAnnexFallback (const multipleExchangeIndexAnnexFallback_type& x);

    void
    multipleExchangeIndexAnnexFallback (const multipleExchangeIndexAnnexFallback_optional& x);

    // localJurisdiction
    // 
    typedef ::FpML_4_2::Country localJurisdiction_type;
    typedef ::xsd::cxx::tree::optional< localJurisdiction_type > localJurisdiction_optional;
    typedef ::xsd::cxx::tree::traits< localJurisdiction_type, char > localJurisdiction_traits;

    const localJurisdiction_optional&
    localJurisdiction () const;

    localJurisdiction_optional&
    localJurisdiction ();

    void
    localJurisdiction (const localJurisdiction_type& x);

    void
    localJurisdiction (const localJurisdiction_optional& x);

    void
    localJurisdiction (::std::auto_ptr< localJurisdiction_type > p);

    // Constructors.
    //
    EquitySwapTransactionSupplement ();

    EquitySwapTransactionSupplement (const ::xercesc::DOMElement& e,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    EquitySwapTransactionSupplement (const EquitySwapTransactionSupplement& x,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    virtual EquitySwapTransactionSupplement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EquitySwapTransactionSupplement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    mutualEarlyTermination_optional mutualEarlyTermination_;
    multipleExchangeIndexAnnexFallback_optional multipleExchangeIndexAnnexFallback_;
    localJurisdiction_optional localJurisdiction_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const DeprecatedEquityLeg&);

  void
  operator<< (::xercesc::DOMElement&, const DeprecatedEquityLegValuation&);

  void
  operator<< (::xercesc::DOMElement&, const DeprecatedEquityLegValuationPrice&);

  void
  operator<< (::xercesc::DOMElement&, const DeprecatedEquityPaymentDates&);

  void
  operator<< (::xercesc::DOMElement&, const EquitySwapTransactionSupplement&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_RETURN_SWAPS_4_2_HXX
