// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_RISKDEF_4_2_HXX
#define FPML_RISKDEF_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class AssetOrTermPointOrPricingStructureReference;
  class DenominatorTerm;
  class DerivativeCalculationMethod;
  class DerivativeCalculationProcedure;
  class DerivativeFormula;
  class FormulaTerm;
  class PerturbationType;
  class PricingParameterDerivative;
  class PricingParameterDerivativeReference;
  class PricingParameterShift;
  class SensitivityDefinition;
  class SensitivitySetDefinition;
  class WeightedPartialDerivative;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-mktenv-4-2.hxx"

namespace FpML_4_2
{
  class AssetOrTermPointOrPricingStructureReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    AssetOrTermPointOrPricingStructureReference (const href_type&);

    AssetOrTermPointOrPricingStructureReference (const ::xercesc::DOMElement& e,
                                                 ::xml_schema::flags f = 0,
                                                 ::xml_schema::container* c = 0);

    AssetOrTermPointOrPricingStructureReference (const AssetOrTermPointOrPricingStructureReference& x,
                                                 ::xml_schema::flags f = 0,
                                                 ::xml_schema::container* c = 0);

    virtual AssetOrTermPointOrPricingStructureReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AssetOrTermPointOrPricingStructureReference ();
  };

  class DenominatorTerm: public ::xml_schema::type
  {
    public:
    // weightedPartial
    // 
    typedef ::FpML_4_2::WeightedPartialDerivative weightedPartial_type;
    typedef ::xsd::cxx::tree::traits< weightedPartial_type, char > weightedPartial_traits;

    const weightedPartial_type&
    weightedPartial () const;

    weightedPartial_type&
    weightedPartial ();

    void
    weightedPartial (const weightedPartial_type& x);

    void
    weightedPartial (::std::auto_ptr< weightedPartial_type > p);

    // power
    // 
    typedef ::xml_schema::integer power_type;
    typedef ::xsd::cxx::tree::traits< power_type, char > power_traits;

    const power_type&
    power () const;

    power_type&
    power ();

    void
    power (const power_type& x);

    // Constructors.
    //
    DenominatorTerm (const weightedPartial_type&,
                     const power_type&);

    DenominatorTerm (::std::auto_ptr< weightedPartial_type >&,
                     const power_type&);

    DenominatorTerm (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    DenominatorTerm (const DenominatorTerm& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual DenominatorTerm*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DenominatorTerm ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< weightedPartial_type > weightedPartial_;
    ::xsd::cxx::tree::one< power_type > power_;
  };

  class DerivativeCalculationMethod: public ::xml_schema::normalized_string
  {
    public:
    // derivativeCalculationMethodScheme
    // 
    typedef ::xml_schema::uri derivativeCalculationMethodScheme_type;
    typedef ::xsd::cxx::tree::traits< derivativeCalculationMethodScheme_type, char > derivativeCalculationMethodScheme_traits;

    const derivativeCalculationMethodScheme_type&
    derivativeCalculationMethodScheme () const;

    derivativeCalculationMethodScheme_type&
    derivativeCalculationMethodScheme ();

    void
    derivativeCalculationMethodScheme (const derivativeCalculationMethodScheme_type& x);

    void
    derivativeCalculationMethodScheme (::std::auto_ptr< derivativeCalculationMethodScheme_type > p);

    static const derivativeCalculationMethodScheme_type&
    derivativeCalculationMethodScheme_default_value ();

    // Constructors.
    //
    DerivativeCalculationMethod ();

    DerivativeCalculationMethod (const char*);

    DerivativeCalculationMethod (const ::std::string&);

    DerivativeCalculationMethod (const ::xml_schema::normalized_string&);

    DerivativeCalculationMethod (const ::xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    DerivativeCalculationMethod (const DerivativeCalculationMethod& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual DerivativeCalculationMethod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DerivativeCalculationMethod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< derivativeCalculationMethodScheme_type > derivativeCalculationMethodScheme_;
    static const derivativeCalculationMethodScheme_type derivativeCalculationMethodScheme_default_value_;
  };

  class DerivativeCalculationProcedure: public ::xml_schema::type
  {
    public:
    // method
    // 
    typedef ::FpML_4_2::DerivativeCalculationMethod method_type;
    typedef ::xsd::cxx::tree::optional< method_type > method_optional;
    typedef ::xsd::cxx::tree::traits< method_type, char > method_traits;

    const method_optional&
    method () const;

    method_optional&
    method ();

    void
    method (const method_type& x);

    void
    method (const method_optional& x);

    void
    method (::std::auto_ptr< method_type > p);

    // perturbationAmount
    // 
    typedef ::xml_schema::decimal perturbationAmount_type;
    typedef ::xsd::cxx::tree::optional< perturbationAmount_type > perturbationAmount_optional;
    typedef ::xsd::cxx::tree::traits< perturbationAmount_type, char, ::xsd::cxx::tree::schema_type::decimal > perturbationAmount_traits;

    const perturbationAmount_optional&
    perturbationAmount () const;

    perturbationAmount_optional&
    perturbationAmount ();

    void
    perturbationAmount (const perturbationAmount_type& x);

    void
    perturbationAmount (const perturbationAmount_optional& x);

    // averaged
    // 
    typedef ::xml_schema::boolean averaged_type;
    typedef ::xsd::cxx::tree::optional< averaged_type > averaged_optional;
    typedef ::xsd::cxx::tree::traits< averaged_type, char > averaged_traits;

    const averaged_optional&
    averaged () const;

    averaged_optional&
    averaged ();

    void
    averaged (const averaged_type& x);

    void
    averaged (const averaged_optional& x);

    // perturbationType
    // 
    typedef ::FpML_4_2::PerturbationType perturbationType_type;
    typedef ::xsd::cxx::tree::optional< perturbationType_type > perturbationType_optional;
    typedef ::xsd::cxx::tree::traits< perturbationType_type, char > perturbationType_traits;

    const perturbationType_optional&
    perturbationType () const;

    perturbationType_optional&
    perturbationType ();

    void
    perturbationType (const perturbationType_type& x);

    void
    perturbationType (const perturbationType_optional& x);

    void
    perturbationType (::std::auto_ptr< perturbationType_type > p);

    // derivativeFormula
    // 
    typedef ::xml_schema::string derivativeFormula_type;
    typedef ::xsd::cxx::tree::optional< derivativeFormula_type > derivativeFormula_optional;
    typedef ::xsd::cxx::tree::traits< derivativeFormula_type, char > derivativeFormula_traits;

    const derivativeFormula_optional&
    derivativeFormula () const;

    derivativeFormula_optional&
    derivativeFormula ();

    void
    derivativeFormula (const derivativeFormula_type& x);

    void
    derivativeFormula (const derivativeFormula_optional& x);

    void
    derivativeFormula (::std::auto_ptr< derivativeFormula_type > p);

    // replacementMarketInput
    // 
    typedef ::FpML_4_2::PricingStructureReference replacementMarketInput_type;
    typedef ::xsd::cxx::tree::optional< replacementMarketInput_type > replacementMarketInput_optional;
    typedef ::xsd::cxx::tree::traits< replacementMarketInput_type, char > replacementMarketInput_traits;

    const replacementMarketInput_optional&
    replacementMarketInput () const;

    replacementMarketInput_optional&
    replacementMarketInput ();

    void
    replacementMarketInput (const replacementMarketInput_type& x);

    void
    replacementMarketInput (const replacementMarketInput_optional& x);

    void
    replacementMarketInput (::std::auto_ptr< replacementMarketInput_type > p);

    // Constructors.
    //
    DerivativeCalculationProcedure ();

    DerivativeCalculationProcedure (const ::xercesc::DOMElement& e,
                                    ::xml_schema::flags f = 0,
                                    ::xml_schema::container* c = 0);

    DerivativeCalculationProcedure (const DerivativeCalculationProcedure& x,
                                    ::xml_schema::flags f = 0,
                                    ::xml_schema::container* c = 0);

    virtual DerivativeCalculationProcedure*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DerivativeCalculationProcedure ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    method_optional method_;
    perturbationAmount_optional perturbationAmount_;
    averaged_optional averaged_;
    perturbationType_optional perturbationType_;
    derivativeFormula_optional derivativeFormula_;
    replacementMarketInput_optional replacementMarketInput_;
  };

  class DerivativeFormula: public ::xml_schema::type
  {
    public:
    // term
    // 
    typedef ::FpML_4_2::FormulaTerm term_type;
    typedef ::xsd::cxx::tree::traits< term_type, char > term_traits;

    const term_type&
    term () const;

    term_type&
    term ();

    void
    term (const term_type& x);

    void
    term (::std::auto_ptr< term_type > p);

    // denominatorTerm
    // 
    typedef ::FpML_4_2::DenominatorTerm denominatorTerm_type;
    typedef ::xsd::cxx::tree::traits< denominatorTerm_type, char > denominatorTerm_traits;

    const denominatorTerm_type&
    denominatorTerm () const;

    denominatorTerm_type&
    denominatorTerm ();

    void
    denominatorTerm (const denominatorTerm_type& x);

    void
    denominatorTerm (::std::auto_ptr< denominatorTerm_type > p);

    // Constructors.
    //
    DerivativeFormula (const term_type&,
                       const denominatorTerm_type&);

    DerivativeFormula (::std::auto_ptr< term_type >&,
                       ::std::auto_ptr< denominatorTerm_type >&);

    DerivativeFormula (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    DerivativeFormula (const DerivativeFormula& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual DerivativeFormula*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DerivativeFormula ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< term_type > term_;
    ::xsd::cxx::tree::one< denominatorTerm_type > denominatorTerm_;
  };

  class FormulaTerm: public ::xml_schema::type
  {
    public:
    // coefficient
    // 
    typedef ::xml_schema::decimal coefficient_type;
    typedef ::xsd::cxx::tree::traits< coefficient_type, char, ::xsd::cxx::tree::schema_type::decimal > coefficient_traits;

    const coefficient_type&
    coefficient () const;

    coefficient_type&
    coefficient ();

    void
    coefficient (const coefficient_type& x);

    // partialDerivativeReference
    // 
    typedef ::FpML_4_2::PricingParameterDerivativeReference partialDerivativeReference_type;
    typedef ::xsd::cxx::tree::sequence< partialDerivativeReference_type > partialDerivativeReference_sequence;
    typedef partialDerivativeReference_sequence::iterator partialDerivativeReference_iterator;
    typedef partialDerivativeReference_sequence::const_iterator partialDerivativeReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< partialDerivativeReference_type, char > partialDerivativeReference_traits;

    const partialDerivativeReference_sequence&
    partialDerivativeReference () const;

    partialDerivativeReference_sequence&
    partialDerivativeReference ();

    void
    partialDerivativeReference (const partialDerivativeReference_sequence& s);

    // Constructors.
    //
    FormulaTerm (const coefficient_type&);

    FormulaTerm (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    FormulaTerm (const FormulaTerm& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual FormulaTerm*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FormulaTerm ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< coefficient_type > coefficient_;
    partialDerivativeReference_sequence partialDerivativeReference_;
  };

  class PerturbationType: public ::xml_schema::normalized_string
  {
    public:
    // perturbationTypeScheme
    // 
    typedef ::xml_schema::uri perturbationTypeScheme_type;
    typedef ::xsd::cxx::tree::traits< perturbationTypeScheme_type, char > perturbationTypeScheme_traits;

    const perturbationTypeScheme_type&
    perturbationTypeScheme () const;

    perturbationTypeScheme_type&
    perturbationTypeScheme ();

    void
    perturbationTypeScheme (const perturbationTypeScheme_type& x);

    void
    perturbationTypeScheme (::std::auto_ptr< perturbationTypeScheme_type > p);

    static const perturbationTypeScheme_type&
    perturbationTypeScheme_default_value ();

    // Constructors.
    //
    PerturbationType ();

    PerturbationType (const char*);

    PerturbationType (const ::std::string&);

    PerturbationType (const ::xml_schema::normalized_string&);

    PerturbationType (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    PerturbationType (const PerturbationType& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual PerturbationType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PerturbationType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< perturbationTypeScheme_type > perturbationTypeScheme_;
    static const perturbationTypeScheme_type perturbationTypeScheme_default_value_;
  };

  class PricingParameterDerivative: public ::xml_schema::type
  {
    public:
    // description
    // 
    typedef ::xml_schema::string description_type;
    typedef ::xsd::cxx::tree::optional< description_type > description_optional;
    typedef ::xsd::cxx::tree::traits< description_type, char > description_traits;

    const description_optional&
    description () const;

    description_optional&
    description ();

    void
    description (const description_type& x);

    void
    description (const description_optional& x);

    void
    description (::std::auto_ptr< description_type > p);

    // parameterReference
    // 
    typedef ::FpML_4_2::AssetOrTermPointOrPricingStructureReference parameterReference_type;
    typedef ::xsd::cxx::tree::optional< parameterReference_type > parameterReference_optional;
    typedef ::xsd::cxx::tree::traits< parameterReference_type, char > parameterReference_traits;

    const parameterReference_optional&
    parameterReference () const;

    parameterReference_optional&
    parameterReference ();

    void
    parameterReference (const parameterReference_type& x);

    void
    parameterReference (const parameterReference_optional& x);

    void
    parameterReference (::std::auto_ptr< parameterReference_type > p);

    // inputDateReference
    // 
    typedef ::FpML_4_2::ValuationReference inputDateReference_type;
    typedef ::xsd::cxx::tree::sequence< inputDateReference_type > inputDateReference_sequence;
    typedef inputDateReference_sequence::iterator inputDateReference_iterator;
    typedef inputDateReference_sequence::const_iterator inputDateReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< inputDateReference_type, char > inputDateReference_traits;

    const inputDateReference_sequence&
    inputDateReference () const;

    inputDateReference_sequence&
    inputDateReference ();

    void
    inputDateReference (const inputDateReference_sequence& s);

    // calculationProcedure
    // 
    typedef ::FpML_4_2::DerivativeCalculationProcedure calculationProcedure_type;
    typedef ::xsd::cxx::tree::optional< calculationProcedure_type > calculationProcedure_optional;
    typedef ::xsd::cxx::tree::traits< calculationProcedure_type, char > calculationProcedure_traits;

    const calculationProcedure_optional&
    calculationProcedure () const;

    calculationProcedure_optional&
    calculationProcedure ();

    void
    calculationProcedure (const calculationProcedure_type& x);

    void
    calculationProcedure (const calculationProcedure_optional& x);

    void
    calculationProcedure (::std::auto_ptr< calculationProcedure_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    PricingParameterDerivative ();

    PricingParameterDerivative (const ::xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    PricingParameterDerivative (const PricingParameterDerivative& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual PricingParameterDerivative*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PricingParameterDerivative ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    description_optional description_;
    parameterReference_optional parameterReference_;
    inputDateReference_sequence inputDateReference_;
    calculationProcedure_optional calculationProcedure_;
    id_optional id_;
  };

  class PricingParameterDerivativeReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    PricingParameterDerivativeReference (const href_type&);

    PricingParameterDerivativeReference (const ::xercesc::DOMElement& e,
                                         ::xml_schema::flags f = 0,
                                         ::xml_schema::container* c = 0);

    PricingParameterDerivativeReference (const PricingParameterDerivativeReference& x,
                                         ::xml_schema::flags f = 0,
                                         ::xml_schema::container* c = 0);

    virtual PricingParameterDerivativeReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PricingParameterDerivativeReference ();
  };

  class PricingParameterShift: public ::xml_schema::type
  {
    public:
    // parameterReference
    // 
    typedef ::FpML_4_2::AssetOrTermPointOrPricingStructureReference parameterReference_type;
    typedef ::xsd::cxx::tree::traits< parameterReference_type, char > parameterReference_traits;

    const parameterReference_type&
    parameterReference () const;

    parameterReference_type&
    parameterReference ();

    void
    parameterReference (const parameterReference_type& x);

    void
    parameterReference (::std::auto_ptr< parameterReference_type > p);

    // shift
    // 
    typedef ::xml_schema::decimal shift_type;
    typedef ::xsd::cxx::tree::traits< shift_type, char, ::xsd::cxx::tree::schema_type::decimal > shift_traits;

    const shift_type&
    shift () const;

    shift_type&
    shift ();

    void
    shift (const shift_type& x);

    // shiftUnits
    // 
    typedef ::FpML_4_2::PriceQuoteUnits shiftUnits_type;
    typedef ::xsd::cxx::tree::optional< shiftUnits_type > shiftUnits_optional;
    typedef ::xsd::cxx::tree::traits< shiftUnits_type, char > shiftUnits_traits;

    const shiftUnits_optional&
    shiftUnits () const;

    shiftUnits_optional&
    shiftUnits ();

    void
    shiftUnits (const shiftUnits_type& x);

    void
    shiftUnits (const shiftUnits_optional& x);

    void
    shiftUnits (::std::auto_ptr< shiftUnits_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    PricingParameterShift (const parameterReference_type&,
                           const shift_type&);

    PricingParameterShift (::std::auto_ptr< parameterReference_type >&,
                           const shift_type&);

    PricingParameterShift (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    PricingParameterShift (const PricingParameterShift& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual PricingParameterShift*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PricingParameterShift ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< parameterReference_type > parameterReference_;
    ::xsd::cxx::tree::one< shift_type > shift_;
    shiftUnits_optional shiftUnits_;
    id_optional id_;
  };

  class SensitivityDefinition: public ::xml_schema::type
  {
    public:
    // name
    // 
    typedef ::xml_schema::string name_type;
    typedef ::xsd::cxx::tree::optional< name_type > name_optional;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_optional&
    name () const;

    name_optional&
    name ();

    void
    name (const name_type& x);

    void
    name (const name_optional& x);

    void
    name (::std::auto_ptr< name_type > p);

    // valuationScenarioReference
    // 
    typedef ::FpML_4_2::ValuationScenarioReference valuationScenarioReference_type;
    typedef ::xsd::cxx::tree::optional< valuationScenarioReference_type > valuationScenarioReference_optional;
    typedef ::xsd::cxx::tree::traits< valuationScenarioReference_type, char > valuationScenarioReference_traits;

    const valuationScenarioReference_optional&
    valuationScenarioReference () const;

    valuationScenarioReference_optional&
    valuationScenarioReference ();

    void
    valuationScenarioReference (const valuationScenarioReference_type& x);

    void
    valuationScenarioReference (const valuationScenarioReference_optional& x);

    void
    valuationScenarioReference (::std::auto_ptr< valuationScenarioReference_type > p);

    // partialDerivative
    // 
    typedef ::FpML_4_2::PricingParameterDerivative partialDerivative_type;
    typedef ::xsd::cxx::tree::sequence< partialDerivative_type > partialDerivative_sequence;
    typedef partialDerivative_sequence::iterator partialDerivative_iterator;
    typedef partialDerivative_sequence::const_iterator partialDerivative_const_iterator;
    typedef ::xsd::cxx::tree::traits< partialDerivative_type, char > partialDerivative_traits;

    const partialDerivative_sequence&
    partialDerivative () const;

    partialDerivative_sequence&
    partialDerivative ();

    void
    partialDerivative (const partialDerivative_sequence& s);

    // formula
    // 
    typedef ::FpML_4_2::DerivativeFormula formula_type;
    typedef ::xsd::cxx::tree::optional< formula_type > formula_optional;
    typedef ::xsd::cxx::tree::traits< formula_type, char > formula_traits;

    const formula_optional&
    formula () const;

    formula_optional&
    formula ();

    void
    formula (const formula_type& x);

    void
    formula (const formula_optional& x);

    void
    formula (::std::auto_ptr< formula_type > p);

    // term
    // 
    typedef ::FpML_4_2::TimeDimension term_type;
    typedef ::xsd::cxx::tree::optional< term_type > term_optional;
    typedef ::xsd::cxx::tree::traits< term_type, char > term_traits;

    const term_optional&
    term () const;

    term_optional&
    term ();

    void
    term (const term_type& x);

    void
    term (const term_optional& x);

    void
    term (::std::auto_ptr< term_type > p);

    // coordinate
    // 
    typedef ::FpML_4_2::PricingDataPointCoordinate coordinate_type;
    typedef ::xsd::cxx::tree::sequence< coordinate_type > coordinate_sequence;
    typedef coordinate_sequence::iterator coordinate_iterator;
    typedef coordinate_sequence::const_iterator coordinate_const_iterator;
    typedef ::xsd::cxx::tree::traits< coordinate_type, char > coordinate_traits;

    const coordinate_sequence&
    coordinate () const;

    coordinate_sequence&
    coordinate ();

    void
    coordinate (const coordinate_sequence& s);

    // coordinateReference
    // 
    typedef ::FpML_4_2::PricingDataPointCoordinateReference coordinateReference_type;
    typedef ::xsd::cxx::tree::sequence< coordinateReference_type > coordinateReference_sequence;
    typedef coordinateReference_sequence::iterator coordinateReference_iterator;
    typedef coordinateReference_sequence::const_iterator coordinateReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< coordinateReference_type, char > coordinateReference_traits;

    const coordinateReference_sequence&
    coordinateReference () const;

    coordinateReference_sequence&
    coordinateReference ();

    void
    coordinateReference (const coordinateReference_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    SensitivityDefinition ();

    SensitivityDefinition (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    SensitivityDefinition (const SensitivityDefinition& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual SensitivityDefinition*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SensitivityDefinition ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    name_optional name_;
    valuationScenarioReference_optional valuationScenarioReference_;
    partialDerivative_sequence partialDerivative_;
    formula_optional formula_;
    term_optional term_;
    coordinate_sequence coordinate_;
    coordinateReference_sequence coordinateReference_;
    id_optional id_;
  };

  class SensitivitySetDefinition: public ::xml_schema::type
  {
    public:
    // name
    // 
    typedef ::xml_schema::string name_type;
    typedef ::xsd::cxx::tree::optional< name_type > name_optional;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_optional&
    name () const;

    name_optional&
    name ();

    void
    name (const name_type& x);

    void
    name (const name_optional& x);

    void
    name (::std::auto_ptr< name_type > p);

    // sensitivityCharacteristics
    // 
    typedef ::FpML_4_2::QuotationCharacteristics sensitivityCharacteristics_type;
    typedef ::xsd::cxx::tree::optional< sensitivityCharacteristics_type > sensitivityCharacteristics_optional;
    typedef ::xsd::cxx::tree::traits< sensitivityCharacteristics_type, char > sensitivityCharacteristics_traits;

    const sensitivityCharacteristics_optional&
    sensitivityCharacteristics () const;

    sensitivityCharacteristics_optional&
    sensitivityCharacteristics ();

    void
    sensitivityCharacteristics (const sensitivityCharacteristics_type& x);

    void
    sensitivityCharacteristics (const sensitivityCharacteristics_optional& x);

    void
    sensitivityCharacteristics (::std::auto_ptr< sensitivityCharacteristics_type > p);

    // valuationScenarioReference
    // 
    typedef ::FpML_4_2::ValuationScenarioReference valuationScenarioReference_type;
    typedef ::xsd::cxx::tree::optional< valuationScenarioReference_type > valuationScenarioReference_optional;
    typedef ::xsd::cxx::tree::traits< valuationScenarioReference_type, char > valuationScenarioReference_traits;

    const valuationScenarioReference_optional&
    valuationScenarioReference () const;

    valuationScenarioReference_optional&
    valuationScenarioReference ();

    void
    valuationScenarioReference (const valuationScenarioReference_type& x);

    void
    valuationScenarioReference (const valuationScenarioReference_optional& x);

    void
    valuationScenarioReference (::std::auto_ptr< valuationScenarioReference_type > p);

    // pricingInputType
    // 
    typedef ::FpML_4_2::PricingInputType pricingInputType_type;
    typedef ::xsd::cxx::tree::optional< pricingInputType_type > pricingInputType_optional;
    typedef ::xsd::cxx::tree::traits< pricingInputType_type, char > pricingInputType_traits;

    const pricingInputType_optional&
    pricingInputType () const;

    pricingInputType_optional&
    pricingInputType ();

    void
    pricingInputType (const pricingInputType_type& x);

    void
    pricingInputType (const pricingInputType_optional& x);

    void
    pricingInputType (::std::auto_ptr< pricingInputType_type > p);

    // pricingInputReference
    // 
    typedef ::FpML_4_2::PricingStructureReference pricingInputReference_type;
    typedef ::xsd::cxx::tree::optional< pricingInputReference_type > pricingInputReference_optional;
    typedef ::xsd::cxx::tree::traits< pricingInputReference_type, char > pricingInputReference_traits;

    const pricingInputReference_optional&
    pricingInputReference () const;

    pricingInputReference_optional&
    pricingInputReference ();

    void
    pricingInputReference (const pricingInputReference_type& x);

    void
    pricingInputReference (const pricingInputReference_optional& x);

    void
    pricingInputReference (::std::auto_ptr< pricingInputReference_type > p);

    // scale
    // 
    typedef ::xml_schema::decimal scale_type;
    typedef ::xsd::cxx::tree::traits< scale_type, char, ::xsd::cxx::tree::schema_type::decimal > scale_traits;

    const scale_type&
    scale () const;

    scale_type&
    scale ();

    void
    scale (const scale_type& x);

    // sensitivityDefinition
    // 
    typedef ::FpML_4_2::SensitivityDefinition sensitivityDefinition_type;
    typedef ::xsd::cxx::tree::sequence< sensitivityDefinition_type > sensitivityDefinition_sequence;
    typedef sensitivityDefinition_sequence::iterator sensitivityDefinition_iterator;
    typedef sensitivityDefinition_sequence::const_iterator sensitivityDefinition_const_iterator;
    typedef ::xsd::cxx::tree::traits< sensitivityDefinition_type, char > sensitivityDefinition_traits;

    const sensitivityDefinition_sequence&
    sensitivityDefinition () const;

    sensitivityDefinition_sequence&
    sensitivityDefinition ();

    void
    sensitivityDefinition (const sensitivityDefinition_sequence& s);

    // calculationProcedure
    // 
    typedef ::FpML_4_2::DerivativeCalculationProcedure calculationProcedure_type;
    typedef ::xsd::cxx::tree::optional< calculationProcedure_type > calculationProcedure_optional;
    typedef ::xsd::cxx::tree::traits< calculationProcedure_type, char > calculationProcedure_traits;

    const calculationProcedure_optional&
    calculationProcedure () const;

    calculationProcedure_optional&
    calculationProcedure ();

    void
    calculationProcedure (const calculationProcedure_type& x);

    void
    calculationProcedure (const calculationProcedure_optional& x);

    void
    calculationProcedure (::std::auto_ptr< calculationProcedure_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    SensitivitySetDefinition (const scale_type&);

    SensitivitySetDefinition (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    SensitivitySetDefinition (const SensitivitySetDefinition& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual SensitivitySetDefinition*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SensitivitySetDefinition ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    name_optional name_;
    sensitivityCharacteristics_optional sensitivityCharacteristics_;
    valuationScenarioReference_optional valuationScenarioReference_;
    pricingInputType_optional pricingInputType_;
    pricingInputReference_optional pricingInputReference_;
    ::xsd::cxx::tree::one< scale_type > scale_;
    sensitivityDefinition_sequence sensitivityDefinition_;
    calculationProcedure_optional calculationProcedure_;
    id_optional id_;
  };

  class WeightedPartialDerivative: public ::xml_schema::type
  {
    public:
    // partialDerivativeReference
    // 
    typedef ::FpML_4_2::PricingStructureReference partialDerivativeReference_type;
    typedef ::xsd::cxx::tree::traits< partialDerivativeReference_type, char > partialDerivativeReference_traits;

    const partialDerivativeReference_type&
    partialDerivativeReference () const;

    partialDerivativeReference_type&
    partialDerivativeReference ();

    void
    partialDerivativeReference (const partialDerivativeReference_type& x);

    void
    partialDerivativeReference (::std::auto_ptr< partialDerivativeReference_type > p);

    // weight
    // 
    typedef ::xml_schema::decimal weight_type;
    typedef ::xsd::cxx::tree::traits< weight_type, char, ::xsd::cxx::tree::schema_type::decimal > weight_traits;

    const weight_type&
    weight () const;

    weight_type&
    weight ();

    void
    weight (const weight_type& x);

    // Constructors.
    //
    WeightedPartialDerivative (const partialDerivativeReference_type&,
                               const weight_type&);

    WeightedPartialDerivative (::std::auto_ptr< partialDerivativeReference_type >&,
                               const weight_type&);

    WeightedPartialDerivative (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    WeightedPartialDerivative (const WeightedPartialDerivative& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual WeightedPartialDerivative*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~WeightedPartialDerivative ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partialDerivativeReference_type > partialDerivativeReference_;
    ::xsd::cxx::tree::one< weight_type > weight_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const AssetOrTermPointOrPricingStructureReference&);

  void
  operator<< (::xercesc::DOMElement&, const DenominatorTerm&);

  void
  operator<< (::xercesc::DOMElement&, const DerivativeCalculationMethod&);

  void
  operator<< (::xercesc::DOMElement&, const DerivativeCalculationProcedure&);

  void
  operator<< (::xercesc::DOMElement&, const DerivativeFormula&);

  void
  operator<< (::xercesc::DOMElement&, const FormulaTerm&);

  void
  operator<< (::xercesc::DOMElement&, const PerturbationType&);

  void
  operator<< (::xercesc::DOMElement&, const PricingParameterDerivative&);

  void
  operator<< (::xercesc::DOMElement&, const PricingParameterDerivativeReference&);

  void
  operator<< (::xercesc::DOMElement&, const PricingParameterShift&);

  void
  operator<< (::xercesc::DOMElement&, const SensitivityDefinition&);

  void
  operator<< (::xercesc::DOMElement&, const SensitivitySetDefinition&);

  void
  operator<< (::xercesc::DOMElement&, const WeightedPartialDerivative&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_RISKDEF_4_2_HXX
