// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_TRADEEXEC_4_2_HXX
#define FPML_TRADEEXEC_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class CancelTradeConfirmation;
  class CancelTradeMatch;
  class ConfirmationCancelled;
  class ConfirmTrade;
  class ModifyTradeConfirmation;
  class ModifyTradeMatch;
  class RequestTradeConfirmation;
  class RequestTradeMatch;
  class TradeAffirmation;
  class TradeAffirmed;
  class TradeAlleged;
  class TradeErrorResponse;
  class TradeAlreadyAffirmed;
  class TradeAlreadyCancelled;
  class TradeAlreadyConfirmed;
  class TradeAlreadyMatched;
  class TradeAlreadySubmitted;
  class TradeAlreadyTerminated;
  class TradeConfirmed;
  class TradeMatched;
  class TradeMismatched;
  class TradeUnmatched;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-msg-4-2.hxx"

namespace FpML_4_2
{
  class CancelTradeConfirmation: public ::FpML_4_2::RequestMessage
  {
    public:
    // partyTradeIdentifier
    // 
    typedef ::FpML_4_2::PartyTradeIdentifier partyTradeIdentifier_type;
    typedef ::xsd::cxx::tree::traits< partyTradeIdentifier_type, char > partyTradeIdentifier_traits;

    const partyTradeIdentifier_type&
    partyTradeIdentifier () const;

    partyTradeIdentifier_type&
    partyTradeIdentifier ();

    void
    partyTradeIdentifier (const partyTradeIdentifier_type& x);

    void
    partyTradeIdentifier (::std::auto_ptr< partyTradeIdentifier_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_type&
    party () const;

    party_type&
    party ();

    void
    party (const party_type& x);

    void
    party (::std::auto_ptr< party_type > p);

    // Constructors.
    //
    CancelTradeConfirmation (const version_type&,
                             const header_type&,
                             const partyTradeIdentifier_type&,
                             const party_type&);

    CancelTradeConfirmation (const version_type&,
                             ::std::auto_ptr< header_type >&,
                             ::std::auto_ptr< partyTradeIdentifier_type >&,
                             ::std::auto_ptr< party_type >&);

    CancelTradeConfirmation (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    CancelTradeConfirmation (const CancelTradeConfirmation& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual CancelTradeConfirmation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CancelTradeConfirmation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partyTradeIdentifier_type > partyTradeIdentifier_;
    ::xsd::cxx::tree::one< party_type > party_;
  };

  class CancelTradeMatch: public ::FpML_4_2::RequestMessage
  {
    public:
    // partyTradeIdentifier
    // 
    typedef ::FpML_4_2::PartyTradeIdentifier partyTradeIdentifier_type;
    typedef ::xsd::cxx::tree::traits< partyTradeIdentifier_type, char > partyTradeIdentifier_traits;

    const partyTradeIdentifier_type&
    partyTradeIdentifier () const;

    partyTradeIdentifier_type&
    partyTradeIdentifier ();

    void
    partyTradeIdentifier (const partyTradeIdentifier_type& x);

    void
    partyTradeIdentifier (::std::auto_ptr< partyTradeIdentifier_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_type&
    party () const;

    party_type&
    party ();

    void
    party (const party_type& x);

    void
    party (::std::auto_ptr< party_type > p);

    // Constructors.
    //
    CancelTradeMatch (const version_type&,
                      const header_type&,
                      const partyTradeIdentifier_type&,
                      const party_type&);

    CancelTradeMatch (const version_type&,
                      ::std::auto_ptr< header_type >&,
                      ::std::auto_ptr< partyTradeIdentifier_type >&,
                      ::std::auto_ptr< party_type >&);

    CancelTradeMatch (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    CancelTradeMatch (const CancelTradeMatch& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual CancelTradeMatch*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CancelTradeMatch ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partyTradeIdentifier_type > partyTradeIdentifier_;
    ::xsd::cxx::tree::one< party_type > party_;
  };

  class ConfirmationCancelled: public ::FpML_4_2::ResponseMessage
  {
    public:
    // tradeIdentifier
    // 
    typedef ::FpML_4_2::TradeIdentifier tradeIdentifier_type;
    typedef ::xsd::cxx::tree::traits< tradeIdentifier_type, char > tradeIdentifier_traits;

    const tradeIdentifier_type&
    tradeIdentifier () const;

    tradeIdentifier_type&
    tradeIdentifier ();

    void
    tradeIdentifier (const tradeIdentifier_type& x);

    void
    tradeIdentifier (::std::auto_ptr< tradeIdentifier_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_type&
    party () const;

    party_type&
    party ();

    void
    party (const party_type& x);

    void
    party (::std::auto_ptr< party_type > p);

    // Constructors.
    //
    ConfirmationCancelled (const version_type&,
                           const header_type&,
                           const tradeIdentifier_type&,
                           const party_type&);

    ConfirmationCancelled (const version_type&,
                           ::std::auto_ptr< header_type >&,
                           ::std::auto_ptr< tradeIdentifier_type >&,
                           ::std::auto_ptr< party_type >&);

    ConfirmationCancelled (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    ConfirmationCancelled (const ConfirmationCancelled& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual ConfirmationCancelled*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ConfirmationCancelled ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tradeIdentifier_type > tradeIdentifier_;
    ::xsd::cxx::tree::one< party_type > party_;
  };

  class ConfirmTrade: public ::FpML_4_2::RequestMessage
  {
    public:
    // partyTradeIdentifier
    // 
    typedef ::FpML_4_2::PartyTradeIdentifier partyTradeIdentifier_type;
    typedef ::xsd::cxx::tree::traits< partyTradeIdentifier_type, char > partyTradeIdentifier_traits;

    const partyTradeIdentifier_type&
    partyTradeIdentifier () const;

    partyTradeIdentifier_type&
    partyTradeIdentifier ();

    void
    partyTradeIdentifier (const partyTradeIdentifier_type& x);

    void
    partyTradeIdentifier (::std::auto_ptr< partyTradeIdentifier_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_type&
    party () const;

    party_type&
    party ();

    void
    party (const party_type& x);

    void
    party (::std::auto_ptr< party_type > p);

    // Constructors.
    //
    ConfirmTrade (const version_type&,
                  const header_type&,
                  const partyTradeIdentifier_type&,
                  const party_type&);

    ConfirmTrade (const version_type&,
                  ::std::auto_ptr< header_type >&,
                  ::std::auto_ptr< partyTradeIdentifier_type >&,
                  ::std::auto_ptr< party_type >&);

    ConfirmTrade (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    ConfirmTrade (const ConfirmTrade& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual ConfirmTrade*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ConfirmTrade ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partyTradeIdentifier_type > partyTradeIdentifier_;
    ::xsd::cxx::tree::one< party_type > party_;
  };

  class ModifyTradeConfirmation: public ::FpML_4_2::RequestMessage
  {
    public:
    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_type&
    trade () const;

    trade_type&
    trade ();

    void
    trade (const trade_type& x);

    void
    trade (::std::auto_ptr< trade_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    ModifyTradeConfirmation (const version_type&,
                             const header_type&,
                             const trade_type&);

    ModifyTradeConfirmation (const version_type&,
                             ::std::auto_ptr< header_type >&,
                             ::std::auto_ptr< trade_type >&);

    ModifyTradeConfirmation (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    ModifyTradeConfirmation (const ModifyTradeConfirmation& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual ModifyTradeConfirmation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ModifyTradeConfirmation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< trade_type > trade_;
    party_sequence party_;
  };

  class ModifyTradeMatch: public ::FpML_4_2::RequestMessage
  {
    public:
    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_type&
    trade () const;

    trade_type&
    trade ();

    void
    trade (const trade_type& x);

    void
    trade (::std::auto_ptr< trade_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    ModifyTradeMatch (const version_type&,
                      const header_type&,
                      const trade_type&);

    ModifyTradeMatch (const version_type&,
                      ::std::auto_ptr< header_type >&,
                      ::std::auto_ptr< trade_type >&);

    ModifyTradeMatch (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    ModifyTradeMatch (const ModifyTradeMatch& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual ModifyTradeMatch*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ModifyTradeMatch ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< trade_type > trade_;
    party_sequence party_;
  };

  class RequestTradeConfirmation: public ::FpML_4_2::RequestMessage
  {
    public:
    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_type&
    trade () const;

    trade_type&
    trade ();

    void
    trade (const trade_type& x);

    void
    trade (::std::auto_ptr< trade_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    RequestTradeConfirmation (const version_type&,
                              const header_type&,
                              const trade_type&);

    RequestTradeConfirmation (const version_type&,
                              ::std::auto_ptr< header_type >&,
                              ::std::auto_ptr< trade_type >&);

    RequestTradeConfirmation (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    RequestTradeConfirmation (const RequestTradeConfirmation& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual RequestTradeConfirmation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RequestTradeConfirmation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< trade_type > trade_;
    party_sequence party_;
  };

  class RequestTradeMatch: public ::FpML_4_2::RequestMessage
  {
    public:
    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_type&
    trade () const;

    trade_type&
    trade ();

    void
    trade (const trade_type& x);

    void
    trade (::std::auto_ptr< trade_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    RequestTradeMatch (const version_type&,
                       const header_type&,
                       const trade_type&);

    RequestTradeMatch (const version_type&,
                       ::std::auto_ptr< header_type >&,
                       ::std::auto_ptr< trade_type >&);

    RequestTradeMatch (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    RequestTradeMatch (const RequestTradeMatch& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual RequestTradeMatch*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RequestTradeMatch ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< trade_type > trade_;
    party_sequence party_;
  };

  class TradeAffirmation: public ::FpML_4_2::NotificationMessage
  {
    public:
    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_type&
    trade () const;

    trade_type&
    trade ();

    void
    trade (const trade_type& x);

    void
    trade (::std::auto_ptr< trade_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    TradeAffirmation (const version_type&,
                      const header_type&,
                      const trade_type&);

    TradeAffirmation (const version_type&,
                      ::std::auto_ptr< header_type >&,
                      ::std::auto_ptr< trade_type >&);

    TradeAffirmation (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    TradeAffirmation (const TradeAffirmation& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual TradeAffirmation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeAffirmation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< trade_type > trade_;
    party_sequence party_;
  };

  class TradeAffirmed: public ::FpML_4_2::ResponseMessage
  {
    public:
    // tradeIdentifier
    // 
    typedef ::FpML_4_2::TradeIdentifier tradeIdentifier_type;
    typedef ::xsd::cxx::tree::sequence< tradeIdentifier_type > tradeIdentifier_sequence;
    typedef tradeIdentifier_sequence::iterator tradeIdentifier_iterator;
    typedef tradeIdentifier_sequence::const_iterator tradeIdentifier_const_iterator;
    typedef ::xsd::cxx::tree::traits< tradeIdentifier_type, char > tradeIdentifier_traits;

    const tradeIdentifier_sequence&
    tradeIdentifier () const;

    tradeIdentifier_sequence&
    tradeIdentifier ();

    void
    tradeIdentifier (const tradeIdentifier_sequence& s);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    TradeAffirmed (const version_type&,
                   const header_type&);

    TradeAffirmed (const version_type&,
                   ::std::auto_ptr< header_type >&);

    TradeAffirmed (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    TradeAffirmed (const TradeAffirmed& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual TradeAffirmed*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeAffirmed ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    tradeIdentifier_sequence tradeIdentifier_;
    party_sequence party_;
  };

  class TradeAlleged: public ::FpML_4_2::NotificationMessage
  {
    public:
    // tradeIdentifier
    // 
    typedef ::FpML_4_2::TradeIdentifier tradeIdentifier_type;
    typedef ::xsd::cxx::tree::traits< tradeIdentifier_type, char > tradeIdentifier_traits;

    const tradeIdentifier_type&
    tradeIdentifier () const;

    tradeIdentifier_type&
    tradeIdentifier ();

    void
    tradeIdentifier (const tradeIdentifier_type& x);

    void
    tradeIdentifier (::std::auto_ptr< tradeIdentifier_type > p);

    // bestFitTradeId
    // 
    typedef ::FpML_4_2::TradeIdentifier bestFitTradeId_type;
    typedef ::xsd::cxx::tree::sequence< bestFitTradeId_type > bestFitTradeId_sequence;
    typedef bestFitTradeId_sequence::iterator bestFitTradeId_iterator;
    typedef bestFitTradeId_sequence::const_iterator bestFitTradeId_const_iterator;
    typedef ::xsd::cxx::tree::traits< bestFitTradeId_type, char > bestFitTradeId_traits;

    const bestFitTradeId_sequence&
    bestFitTradeId () const;

    bestFitTradeId_sequence&
    bestFitTradeId ();

    void
    bestFitTradeId (const bestFitTradeId_sequence& s);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    TradeAlleged (const version_type&,
                  const header_type&,
                  const tradeIdentifier_type&);

    TradeAlleged (const version_type&,
                  ::std::auto_ptr< header_type >&,
                  ::std::auto_ptr< tradeIdentifier_type >&);

    TradeAlleged (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    TradeAlleged (const TradeAlleged& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual TradeAlleged*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeAlleged ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tradeIdentifier_type > tradeIdentifier_;
    bestFitTradeId_sequence bestFitTradeId_;
    party_sequence party_;
  };

  class TradeErrorResponse: public ::FpML_4_2::ResponseMessage
  {
    public:
    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::optional< trade_type > trade_optional;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_optional&
    trade () const;

    trade_optional&
    trade ();

    void
    trade (const trade_type& x);

    void
    trade (const trade_optional& x);

    void
    trade (::std::auto_ptr< trade_type > p);

    // tradeReference
    // 
    typedef ::FpML_4_2::PartyTradeIdentifiers tradeReference_type;
    typedef ::xsd::cxx::tree::optional< tradeReference_type > tradeReference_optional;
    typedef ::xsd::cxx::tree::traits< tradeReference_type, char > tradeReference_traits;

    const tradeReference_optional&
    tradeReference () const;

    tradeReference_optional&
    tradeReference ();

    void
    tradeReference (const tradeReference_type& x);

    void
    tradeReference (const tradeReference_optional& x);

    void
    tradeReference (::std::auto_ptr< tradeReference_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    TradeErrorResponse (const version_type&,
                        const header_type&);

    TradeErrorResponse (const version_type&,
                        ::std::auto_ptr< header_type >&);

    TradeErrorResponse (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    TradeErrorResponse (const TradeErrorResponse& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual TradeErrorResponse*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeErrorResponse ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    trade_optional trade_;
    tradeReference_optional tradeReference_;
    party_sequence party_;
  };

  class TradeAlreadyAffirmed: public ::FpML_4_2::TradeErrorResponse
  {
    public:
    // Constructors.
    //
    TradeAlreadyAffirmed (const version_type&,
                          const header_type&);

    TradeAlreadyAffirmed (const version_type&,
                          ::std::auto_ptr< header_type >&);

    TradeAlreadyAffirmed (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    TradeAlreadyAffirmed (const TradeAlreadyAffirmed& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual TradeAlreadyAffirmed*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeAlreadyAffirmed ();
  };

  class TradeAlreadyCancelled: public ::FpML_4_2::TradeErrorResponse
  {
    public:
    // Constructors.
    //
    TradeAlreadyCancelled (const version_type&,
                           const header_type&);

    TradeAlreadyCancelled (const version_type&,
                           ::std::auto_ptr< header_type >&);

    TradeAlreadyCancelled (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    TradeAlreadyCancelled (const TradeAlreadyCancelled& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual TradeAlreadyCancelled*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeAlreadyCancelled ();
  };

  class TradeAlreadyConfirmed: public ::FpML_4_2::TradeErrorResponse
  {
    public:
    // Constructors.
    //
    TradeAlreadyConfirmed (const version_type&,
                           const header_type&);

    TradeAlreadyConfirmed (const version_type&,
                           ::std::auto_ptr< header_type >&);

    TradeAlreadyConfirmed (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    TradeAlreadyConfirmed (const TradeAlreadyConfirmed& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual TradeAlreadyConfirmed*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeAlreadyConfirmed ();
  };

  class TradeAlreadyMatched: public ::FpML_4_2::ResponseMessage
  {
    public:
    // tradeIdentifier
    // 
    typedef ::FpML_4_2::TradeIdentifier tradeIdentifier_type;
    typedef ::xsd::cxx::tree::traits< tradeIdentifier_type, char > tradeIdentifier_traits;

    const tradeIdentifier_type&
    tradeIdentifier () const;

    tradeIdentifier_type&
    tradeIdentifier ();

    void
    tradeIdentifier (const tradeIdentifier_type& x);

    void
    tradeIdentifier (::std::auto_ptr< tradeIdentifier_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_type&
    party () const;

    party_type&
    party ();

    void
    party (const party_type& x);

    void
    party (::std::auto_ptr< party_type > p);

    // Constructors.
    //
    TradeAlreadyMatched (const version_type&,
                         const header_type&,
                         const tradeIdentifier_type&,
                         const party_type&);

    TradeAlreadyMatched (const version_type&,
                         ::std::auto_ptr< header_type >&,
                         ::std::auto_ptr< tradeIdentifier_type >&,
                         ::std::auto_ptr< party_type >&);

    TradeAlreadyMatched (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    TradeAlreadyMatched (const TradeAlreadyMatched& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual TradeAlreadyMatched*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeAlreadyMatched ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tradeIdentifier_type > tradeIdentifier_;
    ::xsd::cxx::tree::one< party_type > party_;
  };

  class TradeAlreadySubmitted: public ::FpML_4_2::ResponseMessage
  {
    public:
    // tradeIdentifier
    // 
    typedef ::FpML_4_2::TradeIdentifier tradeIdentifier_type;
    typedef ::xsd::cxx::tree::traits< tradeIdentifier_type, char > tradeIdentifier_traits;

    const tradeIdentifier_type&
    tradeIdentifier () const;

    tradeIdentifier_type&
    tradeIdentifier ();

    void
    tradeIdentifier (const tradeIdentifier_type& x);

    void
    tradeIdentifier (::std::auto_ptr< tradeIdentifier_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_type&
    party () const;

    party_type&
    party ();

    void
    party (const party_type& x);

    void
    party (::std::auto_ptr< party_type > p);

    // Constructors.
    //
    TradeAlreadySubmitted (const version_type&,
                           const header_type&,
                           const tradeIdentifier_type&,
                           const party_type&);

    TradeAlreadySubmitted (const version_type&,
                           ::std::auto_ptr< header_type >&,
                           ::std::auto_ptr< tradeIdentifier_type >&,
                           ::std::auto_ptr< party_type >&);

    TradeAlreadySubmitted (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    TradeAlreadySubmitted (const TradeAlreadySubmitted& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual TradeAlreadySubmitted*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeAlreadySubmitted ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tradeIdentifier_type > tradeIdentifier_;
    ::xsd::cxx::tree::one< party_type > party_;
  };

  class TradeAlreadyTerminated: public ::FpML_4_2::TradeErrorResponse
  {
    public:
    // Constructors.
    //
    TradeAlreadyTerminated (const version_type&,
                            const header_type&);

    TradeAlreadyTerminated (const version_type&,
                            ::std::auto_ptr< header_type >&);

    TradeAlreadyTerminated (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    TradeAlreadyTerminated (const TradeAlreadyTerminated& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual TradeAlreadyTerminated*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeAlreadyTerminated ();
  };

  class TradeConfirmed: public ::FpML_4_2::NotificationMessage
  {
    public:
    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_type&
    trade () const;

    trade_type&
    trade ();

    void
    trade (const trade_type& x);

    void
    trade (::std::auto_ptr< trade_type > p);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    TradeConfirmed (const version_type&,
                    const header_type&,
                    const trade_type&);

    TradeConfirmed (const version_type&,
                    ::std::auto_ptr< header_type >&,
                    ::std::auto_ptr< trade_type >&);

    TradeConfirmed (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    TradeConfirmed (const TradeConfirmed& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual TradeConfirmed*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeConfirmed ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< trade_type > trade_;
    party_sequence party_;
  };

  class TradeMatched: public ::FpML_4_2::NotificationMessage
  {
    public:
    // tradeIdentifier
    // 
    typedef ::FpML_4_2::TradeIdentifier tradeIdentifier_type;
    typedef ::xsd::cxx::tree::sequence< tradeIdentifier_type > tradeIdentifier_sequence;
    typedef tradeIdentifier_sequence::iterator tradeIdentifier_iterator;
    typedef tradeIdentifier_sequence::const_iterator tradeIdentifier_const_iterator;
    typedef ::xsd::cxx::tree::traits< tradeIdentifier_type, char > tradeIdentifier_traits;

    const tradeIdentifier_sequence&
    tradeIdentifier () const;

    tradeIdentifier_sequence&
    tradeIdentifier ();

    void
    tradeIdentifier (const tradeIdentifier_sequence& s);

    // differences
    // 
    typedef ::FpML_4_2::TradeDifference differences_type;
    typedef ::xsd::cxx::tree::sequence< differences_type > differences_sequence;
    typedef differences_sequence::iterator differences_iterator;
    typedef differences_sequence::const_iterator differences_const_iterator;
    typedef ::xsd::cxx::tree::traits< differences_type, char > differences_traits;

    const differences_sequence&
    differences () const;

    differences_sequence&
    differences ();

    void
    differences (const differences_sequence& s);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    TradeMatched (const version_type&,
                  const header_type&);

    TradeMatched (const version_type&,
                  ::std::auto_ptr< header_type >&);

    TradeMatched (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    TradeMatched (const TradeMatched& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual TradeMatched*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeMatched ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    tradeIdentifier_sequence tradeIdentifier_;
    differences_sequence differences_;
    party_sequence party_;
  };

  class TradeMismatched: public ::FpML_4_2::NotificationMessage
  {
    public:
    // tradeIdentifier
    // 
    typedef ::FpML_4_2::TradeIdentifier tradeIdentifier_type;
    typedef ::xsd::cxx::tree::traits< tradeIdentifier_type, char > tradeIdentifier_traits;

    const tradeIdentifier_type&
    tradeIdentifier () const;

    tradeIdentifier_type&
    tradeIdentifier ();

    void
    tradeIdentifier (const tradeIdentifier_type& x);

    void
    tradeIdentifier (::std::auto_ptr< tradeIdentifier_type > p);

    // bestFitTrade
    // 
    typedef ::FpML_4_2::BestFitTrade bestFitTrade_type;
    typedef ::xsd::cxx::tree::sequence< bestFitTrade_type > bestFitTrade_sequence;
    typedef bestFitTrade_sequence::iterator bestFitTrade_iterator;
    typedef bestFitTrade_sequence::const_iterator bestFitTrade_const_iterator;
    typedef ::xsd::cxx::tree::traits< bestFitTrade_type, char > bestFitTrade_traits;

    const bestFitTrade_sequence&
    bestFitTrade () const;

    bestFitTrade_sequence&
    bestFitTrade ();

    void
    bestFitTrade (const bestFitTrade_sequence& s);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    TradeMismatched (const version_type&,
                     const header_type&,
                     const tradeIdentifier_type&);

    TradeMismatched (const version_type&,
                     ::std::auto_ptr< header_type >&,
                     ::std::auto_ptr< tradeIdentifier_type >&);

    TradeMismatched (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    TradeMismatched (const TradeMismatched& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual TradeMismatched*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeMismatched ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tradeIdentifier_type > tradeIdentifier_;
    bestFitTrade_sequence bestFitTrade_;
    party_sequence party_;
  };

  class TradeUnmatched: public ::FpML_4_2::NotificationMessage
  {
    public:
    // tradeIdentifier
    // 
    typedef ::FpML_4_2::TradeIdentifier tradeIdentifier_type;
    typedef ::xsd::cxx::tree::traits< tradeIdentifier_type, char > tradeIdentifier_traits;

    const tradeIdentifier_type&
    tradeIdentifier () const;

    tradeIdentifier_type&
    tradeIdentifier ();

    void
    tradeIdentifier (const tradeIdentifier_type& x);

    void
    tradeIdentifier (::std::auto_ptr< tradeIdentifier_type > p);

    // bestFitTradeId
    // 
    typedef ::FpML_4_2::TradeIdentifier bestFitTradeId_type;
    typedef ::xsd::cxx::tree::sequence< bestFitTradeId_type > bestFitTradeId_sequence;
    typedef bestFitTradeId_sequence::iterator bestFitTradeId_iterator;
    typedef bestFitTradeId_sequence::const_iterator bestFitTradeId_const_iterator;
    typedef ::xsd::cxx::tree::traits< bestFitTradeId_type, char > bestFitTradeId_traits;

    const bestFitTradeId_sequence&
    bestFitTradeId () const;

    bestFitTradeId_sequence&
    bestFitTradeId ();

    void
    bestFitTradeId (const bestFitTradeId_sequence& s);

    // party
    // 
    typedef ::FpML_4_2::Party party_type;
    typedef ::xsd::cxx::tree::sequence< party_type > party_sequence;
    typedef party_sequence::iterator party_iterator;
    typedef party_sequence::const_iterator party_const_iterator;
    typedef ::xsd::cxx::tree::traits< party_type, char > party_traits;

    const party_sequence&
    party () const;

    party_sequence&
    party ();

    void
    party (const party_sequence& s);

    // Constructors.
    //
    TradeUnmatched (const version_type&,
                    const header_type&,
                    const tradeIdentifier_type&);

    TradeUnmatched (const version_type&,
                    ::std::auto_ptr< header_type >&,
                    ::std::auto_ptr< tradeIdentifier_type >&);

    TradeUnmatched (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    TradeUnmatched (const TradeUnmatched& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual TradeUnmatched*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~TradeUnmatched ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< tradeIdentifier_type > tradeIdentifier_;
    bestFitTradeId_sequence bestFitTradeId_;
    party_sequence party_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const CancelTradeConfirmation&);

  void
  operator<< (::xercesc::DOMElement&, const CancelTradeMatch&);

  void
  operator<< (::xercesc::DOMElement&, const ConfirmationCancelled&);

  void
  operator<< (::xercesc::DOMElement&, const ConfirmTrade&);

  void
  operator<< (::xercesc::DOMElement&, const ModifyTradeConfirmation&);

  void
  operator<< (::xercesc::DOMElement&, const ModifyTradeMatch&);

  void
  operator<< (::xercesc::DOMElement&, const RequestTradeConfirmation&);

  void
  operator<< (::xercesc::DOMElement&, const RequestTradeMatch&);

  void
  operator<< (::xercesc::DOMElement&, const TradeAffirmation&);

  void
  operator<< (::xercesc::DOMElement&, const TradeAffirmed&);

  void
  operator<< (::xercesc::DOMElement&, const TradeAlleged&);

  void
  operator<< (::xercesc::DOMElement&, const TradeErrorResponse&);

  void
  operator<< (::xercesc::DOMElement&, const TradeAlreadyAffirmed&);

  void
  operator<< (::xercesc::DOMElement&, const TradeAlreadyCancelled&);

  void
  operator<< (::xercesc::DOMElement&, const TradeAlreadyConfirmed&);

  void
  operator<< (::xercesc::DOMElement&, const TradeAlreadyMatched&);

  void
  operator<< (::xercesc::DOMElement&, const TradeAlreadySubmitted&);

  void
  operator<< (::xercesc::DOMElement&, const TradeAlreadyTerminated&);

  void
  operator<< (::xercesc::DOMElement&, const TradeConfirmed&);

  void
  operator<< (::xercesc::DOMElement&, const TradeMatched&);

  void
  operator<< (::xercesc::DOMElement&, const TradeMismatched&);

  void
  operator<< (::xercesc::DOMElement&, const TradeUnmatched&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_TRADEEXEC_4_2_HXX
