// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_VALUATION_4_2_HXX
#define FPML_VALUATION_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class AssetValuation;
  class DerivedValuationScenario;
  class MarketReference;
  class Position;
  class PositionId;
  class PositionConstituent;
  class PricingInputReplacement;
  class Quotation;
  class ReportingRoles;
  class ScheduledDate;
  class ScheduledDates;
  class ScheduledDateType;
  class Sensitivity;
  class SensitivitySet;
  class SensitivitySetReference;
  class Valuations;
  class ValuationScenario;
  class ValuationSet;
  class ValuationSetDetail;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-riskdef-4-2.hxx"

#include "fpml-doc-4-2.hxx"

namespace FpML_4_2
{
  class AssetValuation: public ::FpML_4_2::Valuation
  {
    public:
    // quote
    // 
    typedef ::FpML_4_2::Quotation quote_type;
    typedef ::xsd::cxx::tree::sequence< quote_type > quote_sequence;
    typedef quote_sequence::iterator quote_iterator;
    typedef quote_sequence::const_iterator quote_const_iterator;
    typedef ::xsd::cxx::tree::traits< quote_type, char > quote_traits;

    const quote_sequence&
    quote () const;

    quote_sequence&
    quote ();

    void
    quote (const quote_sequence& s);

    // fxRate
    // 
    typedef ::FpML_4_2::FxRate fxRate_type;
    typedef ::xsd::cxx::tree::optional< fxRate_type > fxRate_optional;
    typedef ::xsd::cxx::tree::traits< fxRate_type, char > fxRate_traits;

    const fxRate_optional&
    fxRate () const;

    fxRate_optional&
    fxRate ();

    void
    fxRate (const fxRate_type& x);

    void
    fxRate (const fxRate_optional& x);

    void
    fxRate (::std::auto_ptr< fxRate_type > p);

    // Constructors.
    //
    AssetValuation (const objectReference_type&);

    AssetValuation (::std::auto_ptr< objectReference_type >&);

    AssetValuation (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    AssetValuation (const AssetValuation& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual AssetValuation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AssetValuation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    quote_sequence quote_;
    fxRate_optional fxRate_;
  };

  class DerivedValuationScenario: public ::xml_schema::type
  {
    public:
    // name
    // 
    typedef ::xml_schema::string name_type;
    typedef ::xsd::cxx::tree::optional< name_type > name_optional;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_optional&
    name () const;

    name_optional&
    name ();

    void
    name (const name_type& x);

    void
    name (const name_optional& x);

    void
    name (::std::auto_ptr< name_type > p);

    // baseValuationScenario
    // 
    typedef ::FpML_4_2::ValuationScenarioReference baseValuationScenario_type;
    typedef ::xsd::cxx::tree::traits< baseValuationScenario_type, char > baseValuationScenario_traits;

    const baseValuationScenario_type&
    baseValuationScenario () const;

    baseValuationScenario_type&
    baseValuationScenario ();

    void
    baseValuationScenario (const baseValuationScenario_type& x);

    void
    baseValuationScenario (::std::auto_ptr< baseValuationScenario_type > p);

    // valuationDate
    // 
    typedef ::FpML_4_2::IdentifiedDate valuationDate_type;
    typedef ::xsd::cxx::tree::optional< valuationDate_type > valuationDate_optional;
    typedef ::xsd::cxx::tree::traits< valuationDate_type, char > valuationDate_traits;

    const valuationDate_optional&
    valuationDate () const;

    valuationDate_optional&
    valuationDate ();

    void
    valuationDate (const valuationDate_type& x);

    void
    valuationDate (const valuationDate_optional& x);

    void
    valuationDate (::std::auto_ptr< valuationDate_type > p);

    // marketReference
    // 
    typedef ::FpML_4_2::MarketReference marketReference_type;
    typedef ::xsd::cxx::tree::optional< marketReference_type > marketReference_optional;
    typedef ::xsd::cxx::tree::traits< marketReference_type, char > marketReference_traits;

    const marketReference_optional&
    marketReference () const;

    marketReference_optional&
    marketReference ();

    void
    marketReference (const marketReference_type& x);

    void
    marketReference (const marketReference_optional& x);

    void
    marketReference (::std::auto_ptr< marketReference_type > p);

    // shift
    // 
    typedef ::FpML_4_2::PricingParameterShift shift_type;
    typedef ::xsd::cxx::tree::sequence< shift_type > shift_sequence;
    typedef shift_sequence::iterator shift_iterator;
    typedef shift_sequence::const_iterator shift_const_iterator;
    typedef ::xsd::cxx::tree::traits< shift_type, char > shift_traits;

    const shift_sequence&
    shift () const;

    shift_sequence&
    shift ();

    void
    shift (const shift_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    DerivedValuationScenario (const baseValuationScenario_type&);

    DerivedValuationScenario (::std::auto_ptr< baseValuationScenario_type >&);

    DerivedValuationScenario (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    DerivedValuationScenario (const DerivedValuationScenario& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual DerivedValuationScenario*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DerivedValuationScenario ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    name_optional name_;
    ::xsd::cxx::tree::one< baseValuationScenario_type > baseValuationScenario_;
    valuationDate_optional valuationDate_;
    marketReference_optional marketReference_;
    shift_sequence shift_;
    id_optional id_;
  };

  class MarketReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    MarketReference (const href_type&);

    MarketReference (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    MarketReference (const MarketReference& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual MarketReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MarketReference ();
  };

  class Position: public ::xml_schema::type
  {
    public:
    // positionId
    // 
    typedef ::FpML_4_2::PositionId positionId_type;
    typedef ::xsd::cxx::tree::traits< positionId_type, char > positionId_traits;

    const positionId_type&
    positionId () const;

    positionId_type&
    positionId ();

    void
    positionId (const positionId_type& x);

    void
    positionId (::std::auto_ptr< positionId_type > p);

    // version
    // 
    typedef ::xml_schema::positive_integer version_type;
    typedef ::xsd::cxx::tree::optional< version_type > version_optional;
    typedef ::xsd::cxx::tree::traits< version_type, char > version_traits;

    const version_optional&
    version () const;

    version_optional&
    version ();

    void
    version (const version_type& x);

    void
    version (const version_optional& x);

    // reportingRoles
    // 
    typedef ::FpML_4_2::ReportingRoles reportingRoles_type;
    typedef ::xsd::cxx::tree::optional< reportingRoles_type > reportingRoles_optional;
    typedef ::xsd::cxx::tree::traits< reportingRoles_type, char > reportingRoles_traits;

    const reportingRoles_optional&
    reportingRoles () const;

    reportingRoles_optional&
    reportingRoles ();

    void
    reportingRoles (const reportingRoles_type& x);

    void
    reportingRoles (const reportingRoles_optional& x);

    void
    reportingRoles (::std::auto_ptr< reportingRoles_type > p);

    // constituent
    // 
    typedef ::FpML_4_2::PositionConstituent constituent_type;
    typedef ::xsd::cxx::tree::traits< constituent_type, char > constituent_traits;

    const constituent_type&
    constituent () const;

    constituent_type&
    constituent ();

    void
    constituent (const constituent_type& x);

    void
    constituent (::std::auto_ptr< constituent_type > p);

    // scheduledDate
    // 
    typedef ::FpML_4_2::ScheduledDate scheduledDate_type;
    typedef ::xsd::cxx::tree::sequence< scheduledDate_type > scheduledDate_sequence;
    typedef scheduledDate_sequence::iterator scheduledDate_iterator;
    typedef scheduledDate_sequence::const_iterator scheduledDate_const_iterator;
    typedef ::xsd::cxx::tree::traits< scheduledDate_type, char > scheduledDate_traits;

    const scheduledDate_sequence&
    scheduledDate () const;

    scheduledDate_sequence&
    scheduledDate ();

    void
    scheduledDate (const scheduledDate_sequence& s);

    // valuation
    // 
    typedef ::FpML_4_2::AssetValuation valuation_type;
    typedef ::xsd::cxx::tree::sequence< valuation_type > valuation_sequence;
    typedef valuation_sequence::iterator valuation_iterator;
    typedef valuation_sequence::const_iterator valuation_const_iterator;
    typedef ::xsd::cxx::tree::traits< valuation_type, char > valuation_traits;

    const valuation_sequence&
    valuation () const;

    valuation_sequence&
    valuation ();

    void
    valuation (const valuation_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Position (const positionId_type&,
              const constituent_type&);

    Position (::std::auto_ptr< positionId_type >&,
              ::std::auto_ptr< constituent_type >&);

    Position (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Position (const Position& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Position*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Position ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< positionId_type > positionId_;
    version_optional version_;
    reportingRoles_optional reportingRoles_;
    ::xsd::cxx::tree::one< constituent_type > constituent_;
    scheduledDate_sequence scheduledDate_;
    valuation_sequence valuation_;
    id_optional id_;
  };

  class PositionId: public ::xml_schema::normalized_string
  {
    public:
    // positionIdScheme
    // 
    typedef ::xml_schema::uri positionIdScheme_type;
    typedef ::xsd::cxx::tree::optional< positionIdScheme_type > positionIdScheme_optional;
    typedef ::xsd::cxx::tree::traits< positionIdScheme_type, char > positionIdScheme_traits;

    const positionIdScheme_optional&
    positionIdScheme () const;

    positionIdScheme_optional&
    positionIdScheme ();

    void
    positionIdScheme (const positionIdScheme_type& x);

    void
    positionIdScheme (const positionIdScheme_optional& x);

    void
    positionIdScheme (::std::auto_ptr< positionIdScheme_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    PositionId ();

    PositionId (const char*);

    PositionId (const ::std::string&);

    PositionId (const ::xml_schema::normalized_string&);

    PositionId (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    PositionId (const PositionId& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual PositionId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PositionId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    positionIdScheme_optional positionIdScheme_;
    id_optional id_;
  };

  class PositionConstituent: public ::xml_schema::type
  {
    public:
    // trade
    // 
    typedef ::FpML_4_2::Trade trade_type;
    typedef ::xsd::cxx::tree::optional< trade_type > trade_optional;
    typedef ::xsd::cxx::tree::traits< trade_type, char > trade_traits;

    const trade_optional&
    trade () const;

    trade_optional&
    trade ();

    void
    trade (const trade_type& x);

    void
    trade (const trade_optional& x);

    void
    trade (::std::auto_ptr< trade_type > p);

    // positionVersionReference
    // 
    typedef ::xml_schema::positive_integer positionVersionReference_type;
    typedef ::xsd::cxx::tree::optional< positionVersionReference_type > positionVersionReference_optional;
    typedef ::xsd::cxx::tree::traits< positionVersionReference_type, char > positionVersionReference_traits;

    const positionVersionReference_optional&
    positionVersionReference () const;

    positionVersionReference_optional&
    positionVersionReference ();

    void
    positionVersionReference (const positionVersionReference_type& x);

    void
    positionVersionReference (const positionVersionReference_optional& x);

    // tradeReference
    // 
    typedef ::FpML_4_2::PartyTradeIdentifiers tradeReference_type;
    typedef ::xsd::cxx::tree::optional< tradeReference_type > tradeReference_optional;
    typedef ::xsd::cxx::tree::traits< tradeReference_type, char > tradeReference_traits;

    const tradeReference_optional&
    tradeReference () const;

    tradeReference_optional&
    tradeReference ();

    void
    tradeReference (const tradeReference_type& x);

    void
    tradeReference (const tradeReference_optional& x);

    void
    tradeReference (::std::auto_ptr< tradeReference_type > p);

    // Constructors.
    //
    PositionConstituent ();

    PositionConstituent (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    PositionConstituent (const PositionConstituent& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual PositionConstituent*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PositionConstituent ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    trade_optional trade_;
    positionVersionReference_optional positionVersionReference_;
    tradeReference_optional tradeReference_;
  };

  class PricingInputReplacement: public ::xml_schema::type
  {
    public:
    // originalInputReference
    // 
    typedef ::FpML_4_2::PricingStructureReference originalInputReference_type;
    typedef ::xsd::cxx::tree::traits< originalInputReference_type, char > originalInputReference_traits;

    const originalInputReference_type&
    originalInputReference () const;

    originalInputReference_type&
    originalInputReference ();

    void
    originalInputReference (const originalInputReference_type& x);

    void
    originalInputReference (::std::auto_ptr< originalInputReference_type > p);

    // replacementInputReference
    // 
    typedef ::FpML_4_2::PricingStructureReference replacementInputReference_type;
    typedef ::xsd::cxx::tree::traits< replacementInputReference_type, char > replacementInputReference_traits;

    const replacementInputReference_type&
    replacementInputReference () const;

    replacementInputReference_type&
    replacementInputReference ();

    void
    replacementInputReference (const replacementInputReference_type& x);

    void
    replacementInputReference (::std::auto_ptr< replacementInputReference_type > p);

    // Constructors.
    //
    PricingInputReplacement (const originalInputReference_type&,
                             const replacementInputReference_type&);

    PricingInputReplacement (::std::auto_ptr< originalInputReference_type >&,
                             ::std::auto_ptr< replacementInputReference_type >&);

    PricingInputReplacement (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    PricingInputReplacement (const PricingInputReplacement& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual PricingInputReplacement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PricingInputReplacement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< originalInputReference_type > originalInputReference_;
    ::xsd::cxx::tree::one< replacementInputReference_type > replacementInputReference_;
  };

  class Quotation: public ::xml_schema::type
  {
    public:
    // value
    // 
    typedef ::xml_schema::decimal value_type;
    typedef ::xsd::cxx::tree::optional< value_type > value_optional;
    typedef ::xsd::cxx::tree::traits< value_type, char, ::xsd::cxx::tree::schema_type::decimal > value_traits;

    const value_optional&
    value () const;

    value_optional&
    value ();

    void
    value (const value_type& x);

    void
    value (const value_optional& x);

    // measureType
    // 
    typedef ::FpML_4_2::AssetMeasureType measureType_type;
    typedef ::xsd::cxx::tree::optional< measureType_type > measureType_optional;
    typedef ::xsd::cxx::tree::traits< measureType_type, char > measureType_traits;

    const measureType_optional&
    measureType () const;

    measureType_optional&
    measureType ();

    void
    measureType (const measureType_type& x);

    void
    measureType (const measureType_optional& x);

    void
    measureType (::std::auto_ptr< measureType_type > p);

    // quoteUnits
    // 
    typedef ::FpML_4_2::PriceQuoteUnits quoteUnits_type;
    typedef ::xsd::cxx::tree::optional< quoteUnits_type > quoteUnits_optional;
    typedef ::xsd::cxx::tree::traits< quoteUnits_type, char > quoteUnits_traits;

    const quoteUnits_optional&
    quoteUnits () const;

    quoteUnits_optional&
    quoteUnits ();

    void
    quoteUnits (const quoteUnits_type& x);

    void
    quoteUnits (const quoteUnits_optional& x);

    void
    quoteUnits (::std::auto_ptr< quoteUnits_type > p);

    // side
    // 
    typedef ::FpML_4_2::QuotationSideEnum side_type;
    typedef ::xsd::cxx::tree::optional< side_type > side_optional;
    typedef ::xsd::cxx::tree::traits< side_type, char > side_traits;

    const side_optional&
    side () const;

    side_optional&
    side ();

    void
    side (const side_type& x);

    void
    side (const side_optional& x);

    void
    side (::std::auto_ptr< side_type > p);

    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::optional< currency_type > currency_optional;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_optional&
    currency () const;

    currency_optional&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (const currency_optional& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // timing
    // 
    typedef ::FpML_4_2::QuoteTiming timing_type;
    typedef ::xsd::cxx::tree::optional< timing_type > timing_optional;
    typedef ::xsd::cxx::tree::traits< timing_type, char > timing_traits;

    const timing_optional&
    timing () const;

    timing_optional&
    timing ();

    void
    timing (const timing_type& x);

    void
    timing (const timing_optional& x);

    void
    timing (::std::auto_ptr< timing_type > p);

    // businessCenter
    // 
    typedef ::FpML_4_2::BusinessCenter businessCenter_type;
    typedef ::xsd::cxx::tree::optional< businessCenter_type > businessCenter_optional;
    typedef ::xsd::cxx::tree::traits< businessCenter_type, char > businessCenter_traits;

    const businessCenter_optional&
    businessCenter () const;

    businessCenter_optional&
    businessCenter ();

    void
    businessCenter (const businessCenter_type& x);

    void
    businessCenter (const businessCenter_optional& x);

    void
    businessCenter (::std::auto_ptr< businessCenter_type > p);

    // exchangeId
    // 
    typedef ::FpML_4_2::ExchangeId exchangeId_type;
    typedef ::xsd::cxx::tree::optional< exchangeId_type > exchangeId_optional;
    typedef ::xsd::cxx::tree::traits< exchangeId_type, char > exchangeId_traits;

    const exchangeId_optional&
    exchangeId () const;

    exchangeId_optional&
    exchangeId ();

    void
    exchangeId (const exchangeId_type& x);

    void
    exchangeId (const exchangeId_optional& x);

    void
    exchangeId (::std::auto_ptr< exchangeId_type > p);

    // informationSource
    // 
    typedef ::FpML_4_2::InformationSource informationSource_type;
    typedef ::xsd::cxx::tree::sequence< informationSource_type > informationSource_sequence;
    typedef informationSource_sequence::iterator informationSource_iterator;
    typedef informationSource_sequence::const_iterator informationSource_const_iterator;
    typedef ::xsd::cxx::tree::traits< informationSource_type, char > informationSource_traits;

    const informationSource_sequence&
    informationSource () const;

    informationSource_sequence&
    informationSource ();

    void
    informationSource (const informationSource_sequence& s);

    // time
    // 
    typedef ::xml_schema::date_time time_type;
    typedef ::xsd::cxx::tree::optional< time_type > time_optional;
    typedef ::xsd::cxx::tree::traits< time_type, char > time_traits;

    const time_optional&
    time () const;

    time_optional&
    time ();

    void
    time (const time_type& x);

    void
    time (const time_optional& x);

    void
    time (::std::auto_ptr< time_type > p);

    // valuationDate
    // 
    typedef ::xml_schema::date valuationDate_type;
    typedef ::xsd::cxx::tree::optional< valuationDate_type > valuationDate_optional;
    typedef ::xsd::cxx::tree::traits< valuationDate_type, char > valuationDate_traits;

    const valuationDate_optional&
    valuationDate () const;

    valuationDate_optional&
    valuationDate ();

    void
    valuationDate (const valuationDate_type& x);

    void
    valuationDate (const valuationDate_optional& x);

    void
    valuationDate (::std::auto_ptr< valuationDate_type > p);

    // expiryTime
    // 
    typedef ::xml_schema::date_time expiryTime_type;
    typedef ::xsd::cxx::tree::optional< expiryTime_type > expiryTime_optional;
    typedef ::xsd::cxx::tree::traits< expiryTime_type, char > expiryTime_traits;

    const expiryTime_optional&
    expiryTime () const;

    expiryTime_optional&
    expiryTime ();

    void
    expiryTime (const expiryTime_type& x);

    void
    expiryTime (const expiryTime_optional& x);

    void
    expiryTime (::std::auto_ptr< expiryTime_type > p);

    // cashFlowType
    // 
    typedef ::FpML_4_2::CashflowType cashFlowType_type;
    typedef ::xsd::cxx::tree::optional< cashFlowType_type > cashFlowType_optional;
    typedef ::xsd::cxx::tree::traits< cashFlowType_type, char > cashFlowType_traits;

    const cashFlowType_optional&
    cashFlowType () const;

    cashFlowType_optional&
    cashFlowType ();

    void
    cashFlowType (const cashFlowType_type& x);

    void
    cashFlowType (const cashFlowType_optional& x);

    void
    cashFlowType (::std::auto_ptr< cashFlowType_type > p);

    // sensitivitySet
    // 
    typedef ::FpML_4_2::SensitivitySet sensitivitySet_type;
    typedef ::xsd::cxx::tree::sequence< sensitivitySet_type > sensitivitySet_sequence;
    typedef sensitivitySet_sequence::iterator sensitivitySet_iterator;
    typedef sensitivitySet_sequence::const_iterator sensitivitySet_const_iterator;
    typedef ::xsd::cxx::tree::traits< sensitivitySet_type, char > sensitivitySet_traits;

    const sensitivitySet_sequence&
    sensitivitySet () const;

    sensitivitySet_sequence&
    sensitivitySet ();

    void
    sensitivitySet (const sensitivitySet_sequence& s);

    // Constructors.
    //
    Quotation ();

    Quotation (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Quotation (const Quotation& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual Quotation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Quotation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    value_optional value_;
    measureType_optional measureType_;
    quoteUnits_optional quoteUnits_;
    side_optional side_;
    currency_optional currency_;
    timing_optional timing_;
    businessCenter_optional businessCenter_;
    exchangeId_optional exchangeId_;
    informationSource_sequence informationSource_;
    time_optional time_;
    valuationDate_optional valuationDate_;
    expiryTime_optional expiryTime_;
    cashFlowType_optional cashFlowType_;
    sensitivitySet_sequence sensitivitySet_;
  };

  class ReportingRoles: public ::xml_schema::type
  {
    public:
    // baseParty
    // 
    typedef ::FpML_4_2::PartyReference baseParty_type;
    typedef ::xsd::cxx::tree::traits< baseParty_type, char > baseParty_traits;

    const baseParty_type&
    baseParty () const;

    baseParty_type&
    baseParty ();

    void
    baseParty (const baseParty_type& x);

    void
    baseParty (::std::auto_ptr< baseParty_type > p);

    // activityProvider
    // 
    typedef ::FpML_4_2::PartyReference activityProvider_type;
    typedef ::xsd::cxx::tree::optional< activityProvider_type > activityProvider_optional;
    typedef ::xsd::cxx::tree::traits< activityProvider_type, char > activityProvider_traits;

    const activityProvider_optional&
    activityProvider () const;

    activityProvider_optional&
    activityProvider ();

    void
    activityProvider (const activityProvider_type& x);

    void
    activityProvider (const activityProvider_optional& x);

    void
    activityProvider (::std::auto_ptr< activityProvider_type > p);

    // positionProvider
    // 
    typedef ::FpML_4_2::PartyReference positionProvider_type;
    typedef ::xsd::cxx::tree::optional< positionProvider_type > positionProvider_optional;
    typedef ::xsd::cxx::tree::traits< positionProvider_type, char > positionProvider_traits;

    const positionProvider_optional&
    positionProvider () const;

    positionProvider_optional&
    positionProvider ();

    void
    positionProvider (const positionProvider_type& x);

    void
    positionProvider (const positionProvider_optional& x);

    void
    positionProvider (::std::auto_ptr< positionProvider_type > p);

    // valuationProvider
    // 
    typedef ::FpML_4_2::PartyReference valuationProvider_type;
    typedef ::xsd::cxx::tree::optional< valuationProvider_type > valuationProvider_optional;
    typedef ::xsd::cxx::tree::traits< valuationProvider_type, char > valuationProvider_traits;

    const valuationProvider_optional&
    valuationProvider () const;

    valuationProvider_optional&
    valuationProvider ();

    void
    valuationProvider (const valuationProvider_type& x);

    void
    valuationProvider (const valuationProvider_optional& x);

    void
    valuationProvider (::std::auto_ptr< valuationProvider_type > p);

    // Constructors.
    //
    ReportingRoles (const baseParty_type&);

    ReportingRoles (::std::auto_ptr< baseParty_type >&);

    ReportingRoles (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ReportingRoles (const ReportingRoles& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ReportingRoles*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReportingRoles ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< baseParty_type > baseParty_;
    activityProvider_optional activityProvider_;
    positionProvider_optional positionProvider_;
    valuationProvider_optional valuationProvider_;
  };

  class ScheduledDate: public ::xml_schema::type
  {
    public:
    // unadjustedDate
    // 
    typedef ::xml_schema::date unadjustedDate_type;
    typedef ::xsd::cxx::tree::optional< unadjustedDate_type > unadjustedDate_optional;
    typedef ::xsd::cxx::tree::traits< unadjustedDate_type, char > unadjustedDate_traits;

    const unadjustedDate_optional&
    unadjustedDate () const;

    unadjustedDate_optional&
    unadjustedDate ();

    void
    unadjustedDate (const unadjustedDate_type& x);

    void
    unadjustedDate (const unadjustedDate_optional& x);

    void
    unadjustedDate (::std::auto_ptr< unadjustedDate_type > p);

    // adjustedDate
    // 
    typedef ::xml_schema::date adjustedDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedDate_type > adjustedDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedDate_type, char > adjustedDate_traits;

    const adjustedDate_optional&
    adjustedDate () const;

    adjustedDate_optional&
    adjustedDate ();

    void
    adjustedDate (const adjustedDate_type& x);

    void
    adjustedDate (const adjustedDate_optional& x);

    void
    adjustedDate (::std::auto_ptr< adjustedDate_type > p);

    // type
    // 
    typedef ::FpML_4_2::ScheduledDateType type_type;
    typedef ::xsd::cxx::tree::traits< type_type, char > type_traits;

    const type_type&
    type () const;

    type_type&
    type ();

    void
    type (const type_type& x);

    void
    type (::std::auto_ptr< type_type > p);

    // assetReference
    // 
    typedef ::FpML_4_2::AnyAssetReference assetReference_type;
    typedef ::xsd::cxx::tree::optional< assetReference_type > assetReference_optional;
    typedef ::xsd::cxx::tree::traits< assetReference_type, char > assetReference_traits;

    const assetReference_optional&
    assetReference () const;

    assetReference_optional&
    assetReference ();

    void
    assetReference (const assetReference_type& x);

    void
    assetReference (const assetReference_optional& x);

    void
    assetReference (::std::auto_ptr< assetReference_type > p);

    // associatedValue
    // 
    typedef ::FpML_4_2::AssetValuation associatedValue_type;
    typedef ::xsd::cxx::tree::sequence< associatedValue_type > associatedValue_sequence;
    typedef associatedValue_sequence::iterator associatedValue_iterator;
    typedef associatedValue_sequence::const_iterator associatedValue_const_iterator;
    typedef ::xsd::cxx::tree::traits< associatedValue_type, char > associatedValue_traits;

    const associatedValue_sequence&
    associatedValue () const;

    associatedValue_sequence&
    associatedValue ();

    void
    associatedValue (const associatedValue_sequence& s);

    // associatedValueReference
    // 
    typedef ::FpML_4_2::ValuationReference associatedValueReference_type;
    typedef ::xsd::cxx::tree::sequence< associatedValueReference_type > associatedValueReference_sequence;
    typedef associatedValueReference_sequence::iterator associatedValueReference_iterator;
    typedef associatedValueReference_sequence::const_iterator associatedValueReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< associatedValueReference_type, char > associatedValueReference_traits;

    const associatedValueReference_sequence&
    associatedValueReference () const;

    associatedValueReference_sequence&
    associatedValueReference ();

    void
    associatedValueReference (const associatedValueReference_sequence& s);

    // Constructors.
    //
    ScheduledDate (const type_type&);

    ScheduledDate (::std::auto_ptr< type_type >&);

    ScheduledDate (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    ScheduledDate (const ScheduledDate& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual ScheduledDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ScheduledDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    unadjustedDate_optional unadjustedDate_;
    adjustedDate_optional adjustedDate_;
    ::xsd::cxx::tree::one< type_type > type_;
    assetReference_optional assetReference_;
    associatedValue_sequence associatedValue_;
    associatedValueReference_sequence associatedValueReference_;
  };

  class ScheduledDates: public ::xml_schema::type
  {
    public:
    // scheduledDate
    // 
    typedef ::FpML_4_2::ScheduledDate scheduledDate_type;
    typedef ::xsd::cxx::tree::sequence< scheduledDate_type > scheduledDate_sequence;
    typedef scheduledDate_sequence::iterator scheduledDate_iterator;
    typedef scheduledDate_sequence::const_iterator scheduledDate_const_iterator;
    typedef ::xsd::cxx::tree::traits< scheduledDate_type, char > scheduledDate_traits;

    const scheduledDate_sequence&
    scheduledDate () const;

    scheduledDate_sequence&
    scheduledDate ();

    void
    scheduledDate (const scheduledDate_sequence& s);

    // Constructors.
    //
    ScheduledDates ();

    ScheduledDates (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ScheduledDates (const ScheduledDates& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ScheduledDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ScheduledDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    scheduledDate_sequence scheduledDate_;
  };

  class ScheduledDateType: public ::xml_schema::normalized_string
  {
    public:
    // scheduledDateTypeScheme
    // 
    typedef ::xml_schema::uri scheduledDateTypeScheme_type;
    typedef ::xsd::cxx::tree::traits< scheduledDateTypeScheme_type, char > scheduledDateTypeScheme_traits;

    const scheduledDateTypeScheme_type&
    scheduledDateTypeScheme () const;

    scheduledDateTypeScheme_type&
    scheduledDateTypeScheme ();

    void
    scheduledDateTypeScheme (const scheduledDateTypeScheme_type& x);

    void
    scheduledDateTypeScheme (::std::auto_ptr< scheduledDateTypeScheme_type > p);

    static const scheduledDateTypeScheme_type&
    scheduledDateTypeScheme_default_value ();

    // Constructors.
    //
    ScheduledDateType ();

    ScheduledDateType (const char*);

    ScheduledDateType (const ::std::string&);

    ScheduledDateType (const ::xml_schema::normalized_string&);

    ScheduledDateType (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ScheduledDateType (const ScheduledDateType& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual ScheduledDateType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ScheduledDateType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< scheduledDateTypeScheme_type > scheduledDateTypeScheme_;
    static const scheduledDateTypeScheme_type scheduledDateTypeScheme_default_value_;
  };

  class Sensitivity: public ::xsd::cxx::tree::fundamental_base< ::xml_schema::decimal, char, ::xml_schema::simple_type, ::xsd::cxx::tree::schema_type::decimal >
  {
    public:
    // name
    // 
    typedef ::xml_schema::normalized_string name_type;
    typedef ::xsd::cxx::tree::optional< name_type > name_optional;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_optional&
    name () const;

    name_optional&
    name ();

    void
    name (const name_type& x);

    void
    name (const name_optional& x);

    void
    name (::std::auto_ptr< name_type > p);

    // definitionRef
    // 
    typedef ::xml_schema::idref definitionRef_type;
    typedef ::xsd::cxx::tree::optional< definitionRef_type > definitionRef_optional;
    typedef ::xsd::cxx::tree::traits< definitionRef_type, char > definitionRef_traits;

    const definitionRef_optional&
    definitionRef () const;

    definitionRef_optional&
    definitionRef ();

    void
    definitionRef (const definitionRef_type& x);

    void
    definitionRef (const definitionRef_optional& x);

    void
    definitionRef (::std::auto_ptr< definitionRef_type > p);

    // Constructors.
    //
    Sensitivity (const ::xml_schema::decimal&);

    Sensitivity (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    Sensitivity (const Sensitivity& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual Sensitivity*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Sensitivity ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    name_optional name_;
    definitionRef_optional definitionRef_;
  };

  class SensitivitySet: public ::xml_schema::type
  {
    public:
    // name
    // 
    typedef ::xml_schema::string name_type;
    typedef ::xsd::cxx::tree::optional< name_type > name_optional;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_optional&
    name () const;

    name_optional&
    name ();

    void
    name (const name_type& x);

    void
    name (const name_optional& x);

    void
    name (::std::auto_ptr< name_type > p);

    // definitionReference
    // 
    typedef ::FpML_4_2::SensitivitySetReference definitionReference_type;
    typedef ::xsd::cxx::tree::optional< definitionReference_type > definitionReference_optional;
    typedef ::xsd::cxx::tree::traits< definitionReference_type, char > definitionReference_traits;

    const definitionReference_optional&
    definitionReference () const;

    definitionReference_optional&
    definitionReference ();

    void
    definitionReference (const definitionReference_type& x);

    void
    definitionReference (const definitionReference_optional& x);

    void
    definitionReference (::std::auto_ptr< definitionReference_type > p);

    // sensitivity
    // 
    typedef ::FpML_4_2::Sensitivity sensitivity_type;
    typedef ::xsd::cxx::tree::sequence< sensitivity_type > sensitivity_sequence;
    typedef sensitivity_sequence::iterator sensitivity_iterator;
    typedef sensitivity_sequence::const_iterator sensitivity_const_iterator;
    typedef ::xsd::cxx::tree::traits< sensitivity_type, char > sensitivity_traits;

    const sensitivity_sequence&
    sensitivity () const;

    sensitivity_sequence&
    sensitivity ();

    void
    sensitivity (const sensitivity_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    SensitivitySet ();

    SensitivitySet (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    SensitivitySet (const SensitivitySet& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual SensitivitySet*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SensitivitySet ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    name_optional name_;
    definitionReference_optional definitionReference_;
    sensitivity_sequence sensitivity_;
    id_optional id_;
  };

  class SensitivitySetReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    SensitivitySetReference (const href_type&);

    SensitivitySetReference (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    SensitivitySetReference (const SensitivitySetReference& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual SensitivitySetReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SensitivitySetReference ();
  };

  class Valuations: public ::xml_schema::type
  {
    public:
    // valuation
    // 
    typedef ::FpML_4_2::AssetValuation valuation_type;
    typedef ::xsd::cxx::tree::sequence< valuation_type > valuation_sequence;
    typedef valuation_sequence::iterator valuation_iterator;
    typedef valuation_sequence::const_iterator valuation_const_iterator;
    typedef ::xsd::cxx::tree::traits< valuation_type, char > valuation_traits;

    const valuation_sequence&
    valuation () const;

    valuation_sequence&
    valuation ();

    void
    valuation (const valuation_sequence& s);

    // valuationReference
    // 
    typedef ::FpML_4_2::ValuationReference valuationReference_type;
    typedef ::xsd::cxx::tree::sequence< valuationReference_type > valuationReference_sequence;
    typedef valuationReference_sequence::iterator valuationReference_iterator;
    typedef valuationReference_sequence::const_iterator valuationReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< valuationReference_type, char > valuationReference_traits;

    const valuationReference_sequence&
    valuationReference () const;

    valuationReference_sequence&
    valuationReference ();

    void
    valuationReference (const valuationReference_sequence& s);

    // Constructors.
    //
    Valuations ();

    Valuations (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    Valuations (const Valuations& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual Valuations*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Valuations ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    valuation_sequence valuation_;
    valuationReference_sequence valuationReference_;
  };

  class ValuationScenario: public ::xml_schema::type
  {
    public:
    // name
    // 
    typedef ::xml_schema::string name_type;
    typedef ::xsd::cxx::tree::optional< name_type > name_optional;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_optional&
    name () const;

    name_optional&
    name ();

    void
    name (const name_type& x);

    void
    name (const name_optional& x);

    void
    name (::std::auto_ptr< name_type > p);

    // valuationDate
    // 
    typedef ::FpML_4_2::IdentifiedDate valuationDate_type;
    typedef ::xsd::cxx::tree::traits< valuationDate_type, char > valuationDate_traits;

    const valuationDate_type&
    valuationDate () const;

    valuationDate_type&
    valuationDate ();

    void
    valuationDate (const valuationDate_type& x);

    void
    valuationDate (::std::auto_ptr< valuationDate_type > p);

    // marketReference
    // 
    typedef ::FpML_4_2::MarketReference marketReference_type;
    typedef ::xsd::cxx::tree::optional< marketReference_type > marketReference_optional;
    typedef ::xsd::cxx::tree::traits< marketReference_type, char > marketReference_traits;

    const marketReference_optional&
    marketReference () const;

    marketReference_optional&
    marketReference ();

    void
    marketReference (const marketReference_type& x);

    void
    marketReference (const marketReference_optional& x);

    void
    marketReference (::std::auto_ptr< marketReference_type > p);

    // shift
    // 
    typedef ::FpML_4_2::PricingParameterShift shift_type;
    typedef ::xsd::cxx::tree::sequence< shift_type > shift_sequence;
    typedef shift_sequence::iterator shift_iterator;
    typedef shift_sequence::const_iterator shift_const_iterator;
    typedef ::xsd::cxx::tree::traits< shift_type, char > shift_traits;

    const shift_sequence&
    shift () const;

    shift_sequence&
    shift ();

    void
    shift (const shift_sequence& s);

    // replacement
    // 
    typedef ::FpML_4_2::PricingInputReplacement replacement_type;
    typedef ::xsd::cxx::tree::sequence< replacement_type > replacement_sequence;
    typedef replacement_sequence::iterator replacement_iterator;
    typedef replacement_sequence::const_iterator replacement_const_iterator;
    typedef ::xsd::cxx::tree::traits< replacement_type, char > replacement_traits;

    const replacement_sequence&
    replacement () const;

    replacement_sequence&
    replacement ();

    void
    replacement (const replacement_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    ValuationScenario (const valuationDate_type&);

    ValuationScenario (::std::auto_ptr< valuationDate_type >&);

    ValuationScenario (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ValuationScenario (const ValuationScenario& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual ValuationScenario*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ValuationScenario ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    name_optional name_;
    ::xsd::cxx::tree::one< valuationDate_type > valuationDate_;
    marketReference_optional marketReference_;
    shift_sequence shift_;
    replacement_sequence replacement_;
    id_optional id_;
  };

  class ValuationSet: public ::xml_schema::type
  {
    public:
    // name
    // 
    typedef ::xml_schema::string name_type;
    typedef ::xsd::cxx::tree::optional< name_type > name_optional;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_optional&
    name () const;

    name_optional&
    name ();

    void
    name (const name_type& x);

    void
    name (const name_optional& x);

    void
    name (::std::auto_ptr< name_type > p);

    // valuationScenario
    // 
    typedef ::FpML_4_2::ValuationScenario valuationScenario_type;
    typedef ::xsd::cxx::tree::sequence< valuationScenario_type > valuationScenario_sequence;
    typedef valuationScenario_sequence::iterator valuationScenario_iterator;
    typedef valuationScenario_sequence::const_iterator valuationScenario_const_iterator;
    typedef ::xsd::cxx::tree::traits< valuationScenario_type, char > valuationScenario_traits;

    const valuationScenario_sequence&
    valuationScenario () const;

    valuationScenario_sequence&
    valuationScenario ();

    void
    valuationScenario (const valuationScenario_sequence& s);

    // valuationScenarioReference
    // 
    typedef ::FpML_4_2::ValuationScenarioReference valuationScenarioReference_type;
    typedef ::xsd::cxx::tree::sequence< valuationScenarioReference_type > valuationScenarioReference_sequence;
    typedef valuationScenarioReference_sequence::iterator valuationScenarioReference_iterator;
    typedef valuationScenarioReference_sequence::const_iterator valuationScenarioReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< valuationScenarioReference_type, char > valuationScenarioReference_traits;

    const valuationScenarioReference_sequence&
    valuationScenarioReference () const;

    valuationScenarioReference_sequence&
    valuationScenarioReference ();

    void
    valuationScenarioReference (const valuationScenarioReference_sequence& s);

    // baseParty
    // 
    typedef ::FpML_4_2::PartyReference baseParty_type;
    typedef ::xsd::cxx::tree::optional< baseParty_type > baseParty_optional;
    typedef ::xsd::cxx::tree::traits< baseParty_type, char > baseParty_traits;

    const baseParty_optional&
    baseParty () const;

    baseParty_optional&
    baseParty ();

    void
    baseParty (const baseParty_type& x);

    void
    baseParty (const baseParty_optional& x);

    void
    baseParty (::std::auto_ptr< baseParty_type > p);

    // quotationCharacteristics
    // 
    typedef ::FpML_4_2::QuotationCharacteristics quotationCharacteristics_type;
    typedef ::xsd::cxx::tree::sequence< quotationCharacteristics_type > quotationCharacteristics_sequence;
    typedef quotationCharacteristics_sequence::iterator quotationCharacteristics_iterator;
    typedef quotationCharacteristics_sequence::const_iterator quotationCharacteristics_const_iterator;
    typedef ::xsd::cxx::tree::traits< quotationCharacteristics_type, char > quotationCharacteristics_traits;

    const quotationCharacteristics_sequence&
    quotationCharacteristics () const;

    quotationCharacteristics_sequence&
    quotationCharacteristics ();

    void
    quotationCharacteristics (const quotationCharacteristics_sequence& s);

    // sensitivitySetDefinition
    // 
    typedef ::FpML_4_2::SensitivitySetDefinition sensitivitySetDefinition_type;
    typedef ::xsd::cxx::tree::sequence< sensitivitySetDefinition_type > sensitivitySetDefinition_sequence;
    typedef sensitivitySetDefinition_sequence::iterator sensitivitySetDefinition_iterator;
    typedef sensitivitySetDefinition_sequence::const_iterator sensitivitySetDefinition_const_iterator;
    typedef ::xsd::cxx::tree::traits< sensitivitySetDefinition_type, char > sensitivitySetDefinition_traits;

    const sensitivitySetDefinition_sequence&
    sensitivitySetDefinition () const;

    sensitivitySetDefinition_sequence&
    sensitivitySetDefinition ();

    void
    sensitivitySetDefinition (const sensitivitySetDefinition_sequence& s);

    // detail
    // 
    typedef ::FpML_4_2::ValuationSetDetail detail_type;
    typedef ::xsd::cxx::tree::optional< detail_type > detail_optional;
    typedef ::xsd::cxx::tree::traits< detail_type, char > detail_traits;

    const detail_optional&
    detail () const;

    detail_optional&
    detail ();

    void
    detail (const detail_type& x);

    void
    detail (const detail_optional& x);

    void
    detail (::std::auto_ptr< detail_type > p);

    // assetValuation
    // 
    typedef ::FpML_4_2::AssetValuation assetValuation_type;
    typedef ::xsd::cxx::tree::sequence< assetValuation_type > assetValuation_sequence;
    typedef assetValuation_sequence::iterator assetValuation_iterator;
    typedef assetValuation_sequence::const_iterator assetValuation_const_iterator;
    typedef ::xsd::cxx::tree::traits< assetValuation_type, char > assetValuation_traits;

    const assetValuation_sequence&
    assetValuation () const;

    assetValuation_sequence&
    assetValuation ();

    void
    assetValuation (const assetValuation_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    ValuationSet ();

    ValuationSet (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    ValuationSet (const ValuationSet& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual ValuationSet*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ValuationSet ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    name_optional name_;
    valuationScenario_sequence valuationScenario_;
    valuationScenarioReference_sequence valuationScenarioReference_;
    baseParty_optional baseParty_;
    quotationCharacteristics_sequence quotationCharacteristics_;
    sensitivitySetDefinition_sequence sensitivitySetDefinition_;
    detail_optional detail_;
    assetValuation_sequence assetValuation_;
    id_optional id_;
  };

  class ValuationSetDetail: public ::xml_schema::normalized_string
  {
    public:
    // valuationSetDetailScheme
    // 
    typedef ::xml_schema::uri valuationSetDetailScheme_type;
    typedef ::xsd::cxx::tree::optional< valuationSetDetailScheme_type > valuationSetDetailScheme_optional;
    typedef ::xsd::cxx::tree::traits< valuationSetDetailScheme_type, char > valuationSetDetailScheme_traits;

    const valuationSetDetailScheme_optional&
    valuationSetDetailScheme () const;

    valuationSetDetailScheme_optional&
    valuationSetDetailScheme ();

    void
    valuationSetDetailScheme (const valuationSetDetailScheme_type& x);

    void
    valuationSetDetailScheme (const valuationSetDetailScheme_optional& x);

    void
    valuationSetDetailScheme (::std::auto_ptr< valuationSetDetailScheme_type > p);

    // Constructors.
    //
    ValuationSetDetail ();

    ValuationSetDetail (const char*);

    ValuationSetDetail (const ::std::string&);

    ValuationSetDetail (const ::xml_schema::normalized_string&);

    ValuationSetDetail (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    ValuationSetDetail (const ValuationSetDetail& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual ValuationSetDetail*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ValuationSetDetail ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    valuationSetDetailScheme_optional valuationSetDetailScheme_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const AssetValuation&);

  void
  operator<< (::xercesc::DOMElement&, const DerivedValuationScenario&);

  void
  operator<< (::xercesc::DOMElement&, const MarketReference&);

  void
  operator<< (::xercesc::DOMElement&, const Position&);

  void
  operator<< (::xercesc::DOMElement&, const PositionId&);

  void
  operator<< (::xercesc::DOMElement&, const PositionConstituent&);

  void
  operator<< (::xercesc::DOMElement&, const PricingInputReplacement&);

  void
  operator<< (::xercesc::DOMElement&, const Quotation&);

  void
  operator<< (::xercesc::DOMElement&, const ReportingRoles&);

  void
  operator<< (::xercesc::DOMElement&, const ScheduledDate&);

  void
  operator<< (::xercesc::DOMElement&, const ScheduledDates&);

  void
  operator<< (::xercesc::DOMElement&, const ScheduledDateType&);

  void
  operator<< (::xercesc::DOMElement&, const Sensitivity&);

  void
  operator<< (::xercesc::DOMElement&, const SensitivitySet&);

  void
  operator<< (::xercesc::DOMElement&, const SensitivitySetReference&);

  void
  operator<< (::xercesc::DOMElement&, const Valuations&);

  void
  operator<< (::xercesc::DOMElement&, const ValuationScenario&);

  void
  operator<< (::xercesc::DOMElement&, const ValuationSet&);

  void
  operator<< (::xercesc::DOMElement&, const ValuationSetDetail&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_VALUATION_4_2_HXX
