// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_VALUATION_BASE_4_2_HXX
#define FPML_VALUATION_BASE_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class AnyAssetReference;
  class AssetMeasureType;
  class Valuation;
  class BasicAssetValuation;
  class BasicQuotation;
  class PriceQuoteUnits;
  class QuotationCharacteristics;
  class QuoteTiming;
  class ValuationReference;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-shared-4-2.hxx"

namespace FpML_4_2
{
  class AnyAssetReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    AnyAssetReference (const href_type&);

    AnyAssetReference (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    AnyAssetReference (const AnyAssetReference& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual AnyAssetReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AnyAssetReference ();
  };

  class AssetMeasureType: public ::xml_schema::normalized_string
  {
    public:
    // assetMeasureScheme
    // 
    typedef ::xml_schema::uri assetMeasureScheme_type;
    typedef ::xsd::cxx::tree::traits< assetMeasureScheme_type, char > assetMeasureScheme_traits;

    const assetMeasureScheme_type&
    assetMeasureScheme () const;

    assetMeasureScheme_type&
    assetMeasureScheme ();

    void
    assetMeasureScheme (const assetMeasureScheme_type& x);

    void
    assetMeasureScheme (::std::auto_ptr< assetMeasureScheme_type > p);

    static const assetMeasureScheme_type&
    assetMeasureScheme_default_value ();

    // Constructors.
    //
    AssetMeasureType ();

    AssetMeasureType (const char*);

    AssetMeasureType (const ::std::string&);

    AssetMeasureType (const ::xml_schema::normalized_string&);

    AssetMeasureType (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    AssetMeasureType (const AssetMeasureType& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual AssetMeasureType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AssetMeasureType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< assetMeasureScheme_type > assetMeasureScheme_;
    static const assetMeasureScheme_type assetMeasureScheme_default_value_;
  };

  class Valuation: public ::xml_schema::type
  {
    public:
    // objectReference
    // 
    typedef ::FpML_4_2::AnyAssetReference objectReference_type;
    typedef ::xsd::cxx::tree::traits< objectReference_type, char > objectReference_traits;

    const objectReference_type&
    objectReference () const;

    objectReference_type&
    objectReference ();

    void
    objectReference (const objectReference_type& x);

    void
    objectReference (::std::auto_ptr< objectReference_type > p);

    // valuationScenarioReference
    // 
    typedef ::FpML_4_2::ValuationScenarioReference valuationScenarioReference_type;
    typedef ::xsd::cxx::tree::optional< valuationScenarioReference_type > valuationScenarioReference_optional;
    typedef ::xsd::cxx::tree::traits< valuationScenarioReference_type, char > valuationScenarioReference_traits;

    const valuationScenarioReference_optional&
    valuationScenarioReference () const;

    valuationScenarioReference_optional&
    valuationScenarioReference ();

    void
    valuationScenarioReference (const valuationScenarioReference_type& x);

    void
    valuationScenarioReference (const valuationScenarioReference_optional& x);

    void
    valuationScenarioReference (::std::auto_ptr< valuationScenarioReference_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // definitionRef
    // 
    typedef ::xml_schema::idref definitionRef_type;
    typedef ::xsd::cxx::tree::optional< definitionRef_type > definitionRef_optional;
    typedef ::xsd::cxx::tree::traits< definitionRef_type, char > definitionRef_traits;

    const definitionRef_optional&
    definitionRef () const;

    definitionRef_optional&
    definitionRef ();

    void
    definitionRef (const definitionRef_type& x);

    void
    definitionRef (const definitionRef_optional& x);

    void
    definitionRef (::std::auto_ptr< definitionRef_type > p);

    // Constructors.
    //
    Valuation (const objectReference_type&);

    Valuation (::std::auto_ptr< objectReference_type >&);

    Valuation (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Valuation (const Valuation& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual Valuation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Valuation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< objectReference_type > objectReference_;
    valuationScenarioReference_optional valuationScenarioReference_;
    id_optional id_;
    definitionRef_optional definitionRef_;
  };

  class BasicAssetValuation: public ::FpML_4_2::Valuation
  {
    public:
    // quote
    // 
    typedef ::FpML_4_2::BasicQuotation quote_type;
    typedef ::xsd::cxx::tree::sequence< quote_type > quote_sequence;
    typedef quote_sequence::iterator quote_iterator;
    typedef quote_sequence::const_iterator quote_const_iterator;
    typedef ::xsd::cxx::tree::traits< quote_type, char > quote_traits;

    const quote_sequence&
    quote () const;

    quote_sequence&
    quote ();

    void
    quote (const quote_sequence& s);

    // Constructors.
    //
    BasicAssetValuation (const objectReference_type&);

    BasicAssetValuation (::std::auto_ptr< objectReference_type >&);

    BasicAssetValuation (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    BasicAssetValuation (const BasicAssetValuation& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual BasicAssetValuation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BasicAssetValuation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    quote_sequence quote_;
  };

  class BasicQuotation: public ::xml_schema::type
  {
    public:
    // value
    // 
    typedef ::xml_schema::decimal value_type;
    typedef ::xsd::cxx::tree::optional< value_type > value_optional;
    typedef ::xsd::cxx::tree::traits< value_type, char, ::xsd::cxx::tree::schema_type::decimal > value_traits;

    const value_optional&
    value () const;

    value_optional&
    value ();

    void
    value (const value_type& x);

    void
    value (const value_optional& x);

    // measureType
    // 
    typedef ::FpML_4_2::AssetMeasureType measureType_type;
    typedef ::xsd::cxx::tree::optional< measureType_type > measureType_optional;
    typedef ::xsd::cxx::tree::traits< measureType_type, char > measureType_traits;

    const measureType_optional&
    measureType () const;

    measureType_optional&
    measureType ();

    void
    measureType (const measureType_type& x);

    void
    measureType (const measureType_optional& x);

    void
    measureType (::std::auto_ptr< measureType_type > p);

    // quoteUnits
    // 
    typedef ::FpML_4_2::PriceQuoteUnits quoteUnits_type;
    typedef ::xsd::cxx::tree::optional< quoteUnits_type > quoteUnits_optional;
    typedef ::xsd::cxx::tree::traits< quoteUnits_type, char > quoteUnits_traits;

    const quoteUnits_optional&
    quoteUnits () const;

    quoteUnits_optional&
    quoteUnits ();

    void
    quoteUnits (const quoteUnits_type& x);

    void
    quoteUnits (const quoteUnits_optional& x);

    void
    quoteUnits (::std::auto_ptr< quoteUnits_type > p);

    // side
    // 
    typedef ::FpML_4_2::QuotationSideEnum side_type;
    typedef ::xsd::cxx::tree::optional< side_type > side_optional;
    typedef ::xsd::cxx::tree::traits< side_type, char > side_traits;

    const side_optional&
    side () const;

    side_optional&
    side ();

    void
    side (const side_type& x);

    void
    side (const side_optional& x);

    void
    side (::std::auto_ptr< side_type > p);

    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::optional< currency_type > currency_optional;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_optional&
    currency () const;

    currency_optional&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (const currency_optional& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // timing
    // 
    typedef ::FpML_4_2::QuoteTiming timing_type;
    typedef ::xsd::cxx::tree::optional< timing_type > timing_optional;
    typedef ::xsd::cxx::tree::traits< timing_type, char > timing_traits;

    const timing_optional&
    timing () const;

    timing_optional&
    timing ();

    void
    timing (const timing_type& x);

    void
    timing (const timing_optional& x);

    void
    timing (::std::auto_ptr< timing_type > p);

    // businessCenter
    // 
    typedef ::FpML_4_2::BusinessCenter businessCenter_type;
    typedef ::xsd::cxx::tree::optional< businessCenter_type > businessCenter_optional;
    typedef ::xsd::cxx::tree::traits< businessCenter_type, char > businessCenter_traits;

    const businessCenter_optional&
    businessCenter () const;

    businessCenter_optional&
    businessCenter ();

    void
    businessCenter (const businessCenter_type& x);

    void
    businessCenter (const businessCenter_optional& x);

    void
    businessCenter (::std::auto_ptr< businessCenter_type > p);

    // exchangeId
    // 
    typedef ::FpML_4_2::ExchangeId exchangeId_type;
    typedef ::xsd::cxx::tree::optional< exchangeId_type > exchangeId_optional;
    typedef ::xsd::cxx::tree::traits< exchangeId_type, char > exchangeId_traits;

    const exchangeId_optional&
    exchangeId () const;

    exchangeId_optional&
    exchangeId ();

    void
    exchangeId (const exchangeId_type& x);

    void
    exchangeId (const exchangeId_optional& x);

    void
    exchangeId (::std::auto_ptr< exchangeId_type > p);

    // informationSource
    // 
    typedef ::FpML_4_2::InformationSource informationSource_type;
    typedef ::xsd::cxx::tree::sequence< informationSource_type > informationSource_sequence;
    typedef informationSource_sequence::iterator informationSource_iterator;
    typedef informationSource_sequence::const_iterator informationSource_const_iterator;
    typedef ::xsd::cxx::tree::traits< informationSource_type, char > informationSource_traits;

    const informationSource_sequence&
    informationSource () const;

    informationSource_sequence&
    informationSource ();

    void
    informationSource (const informationSource_sequence& s);

    // time
    // 
    typedef ::xml_schema::date_time time_type;
    typedef ::xsd::cxx::tree::optional< time_type > time_optional;
    typedef ::xsd::cxx::tree::traits< time_type, char > time_traits;

    const time_optional&
    time () const;

    time_optional&
    time ();

    void
    time (const time_type& x);

    void
    time (const time_optional& x);

    void
    time (::std::auto_ptr< time_type > p);

    // valuationDate
    // 
    typedef ::xml_schema::date valuationDate_type;
    typedef ::xsd::cxx::tree::optional< valuationDate_type > valuationDate_optional;
    typedef ::xsd::cxx::tree::traits< valuationDate_type, char > valuationDate_traits;

    const valuationDate_optional&
    valuationDate () const;

    valuationDate_optional&
    valuationDate ();

    void
    valuationDate (const valuationDate_type& x);

    void
    valuationDate (const valuationDate_optional& x);

    void
    valuationDate (::std::auto_ptr< valuationDate_type > p);

    // expiryTime
    // 
    typedef ::xml_schema::date_time expiryTime_type;
    typedef ::xsd::cxx::tree::optional< expiryTime_type > expiryTime_optional;
    typedef ::xsd::cxx::tree::traits< expiryTime_type, char > expiryTime_traits;

    const expiryTime_optional&
    expiryTime () const;

    expiryTime_optional&
    expiryTime ();

    void
    expiryTime (const expiryTime_type& x);

    void
    expiryTime (const expiryTime_optional& x);

    void
    expiryTime (::std::auto_ptr< expiryTime_type > p);

    // cashFlowType
    // 
    typedef ::FpML_4_2::CashflowType cashFlowType_type;
    typedef ::xsd::cxx::tree::optional< cashFlowType_type > cashFlowType_optional;
    typedef ::xsd::cxx::tree::traits< cashFlowType_type, char > cashFlowType_traits;

    const cashFlowType_optional&
    cashFlowType () const;

    cashFlowType_optional&
    cashFlowType ();

    void
    cashFlowType (const cashFlowType_type& x);

    void
    cashFlowType (const cashFlowType_optional& x);

    void
    cashFlowType (::std::auto_ptr< cashFlowType_type > p);

    // Constructors.
    //
    BasicQuotation ();

    BasicQuotation (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    BasicQuotation (const BasicQuotation& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual BasicQuotation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BasicQuotation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    value_optional value_;
    measureType_optional measureType_;
    quoteUnits_optional quoteUnits_;
    side_optional side_;
    currency_optional currency_;
    timing_optional timing_;
    businessCenter_optional businessCenter_;
    exchangeId_optional exchangeId_;
    informationSource_sequence informationSource_;
    time_optional time_;
    valuationDate_optional valuationDate_;
    expiryTime_optional expiryTime_;
    cashFlowType_optional cashFlowType_;
  };

  class PriceQuoteUnits: public ::xml_schema::normalized_string
  {
    public:
    // priceQuoteUnitsScheme
    // 
    typedef ::xml_schema::uri priceQuoteUnitsScheme_type;
    typedef ::xsd::cxx::tree::traits< priceQuoteUnitsScheme_type, char > priceQuoteUnitsScheme_traits;

    const priceQuoteUnitsScheme_type&
    priceQuoteUnitsScheme () const;

    priceQuoteUnitsScheme_type&
    priceQuoteUnitsScheme ();

    void
    priceQuoteUnitsScheme (const priceQuoteUnitsScheme_type& x);

    void
    priceQuoteUnitsScheme (::std::auto_ptr< priceQuoteUnitsScheme_type > p);

    static const priceQuoteUnitsScheme_type&
    priceQuoteUnitsScheme_default_value ();

    // Constructors.
    //
    PriceQuoteUnits ();

    PriceQuoteUnits (const char*);

    PriceQuoteUnits (const ::std::string&);

    PriceQuoteUnits (const ::xml_schema::normalized_string&);

    PriceQuoteUnits (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    PriceQuoteUnits (const PriceQuoteUnits& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual PriceQuoteUnits*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PriceQuoteUnits ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< priceQuoteUnitsScheme_type > priceQuoteUnitsScheme_;
    static const priceQuoteUnitsScheme_type priceQuoteUnitsScheme_default_value_;
  };

  class QuotationCharacteristics: public ::xml_schema::type
  {
    public:
    // measureType
    // 
    typedef ::FpML_4_2::AssetMeasureType measureType_type;
    typedef ::xsd::cxx::tree::optional< measureType_type > measureType_optional;
    typedef ::xsd::cxx::tree::traits< measureType_type, char > measureType_traits;

    const measureType_optional&
    measureType () const;

    measureType_optional&
    measureType ();

    void
    measureType (const measureType_type& x);

    void
    measureType (const measureType_optional& x);

    void
    measureType (::std::auto_ptr< measureType_type > p);

    // quoteUnits
    // 
    typedef ::FpML_4_2::PriceQuoteUnits quoteUnits_type;
    typedef ::xsd::cxx::tree::optional< quoteUnits_type > quoteUnits_optional;
    typedef ::xsd::cxx::tree::traits< quoteUnits_type, char > quoteUnits_traits;

    const quoteUnits_optional&
    quoteUnits () const;

    quoteUnits_optional&
    quoteUnits ();

    void
    quoteUnits (const quoteUnits_type& x);

    void
    quoteUnits (const quoteUnits_optional& x);

    void
    quoteUnits (::std::auto_ptr< quoteUnits_type > p);

    // side
    // 
    typedef ::FpML_4_2::QuotationSideEnum side_type;
    typedef ::xsd::cxx::tree::optional< side_type > side_optional;
    typedef ::xsd::cxx::tree::traits< side_type, char > side_traits;

    const side_optional&
    side () const;

    side_optional&
    side ();

    void
    side (const side_type& x);

    void
    side (const side_optional& x);

    void
    side (::std::auto_ptr< side_type > p);

    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::optional< currency_type > currency_optional;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_optional&
    currency () const;

    currency_optional&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (const currency_optional& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // timing
    // 
    typedef ::FpML_4_2::QuoteTiming timing_type;
    typedef ::xsd::cxx::tree::optional< timing_type > timing_optional;
    typedef ::xsd::cxx::tree::traits< timing_type, char > timing_traits;

    const timing_optional&
    timing () const;

    timing_optional&
    timing ();

    void
    timing (const timing_type& x);

    void
    timing (const timing_optional& x);

    void
    timing (::std::auto_ptr< timing_type > p);

    // businessCenter
    // 
    typedef ::FpML_4_2::BusinessCenter businessCenter_type;
    typedef ::xsd::cxx::tree::optional< businessCenter_type > businessCenter_optional;
    typedef ::xsd::cxx::tree::traits< businessCenter_type, char > businessCenter_traits;

    const businessCenter_optional&
    businessCenter () const;

    businessCenter_optional&
    businessCenter ();

    void
    businessCenter (const businessCenter_type& x);

    void
    businessCenter (const businessCenter_optional& x);

    void
    businessCenter (::std::auto_ptr< businessCenter_type > p);

    // exchangeId
    // 
    typedef ::FpML_4_2::ExchangeId exchangeId_type;
    typedef ::xsd::cxx::tree::optional< exchangeId_type > exchangeId_optional;
    typedef ::xsd::cxx::tree::traits< exchangeId_type, char > exchangeId_traits;

    const exchangeId_optional&
    exchangeId () const;

    exchangeId_optional&
    exchangeId ();

    void
    exchangeId (const exchangeId_type& x);

    void
    exchangeId (const exchangeId_optional& x);

    void
    exchangeId (::std::auto_ptr< exchangeId_type > p);

    // informationSource
    // 
    typedef ::FpML_4_2::InformationSource informationSource_type;
    typedef ::xsd::cxx::tree::sequence< informationSource_type > informationSource_sequence;
    typedef informationSource_sequence::iterator informationSource_iterator;
    typedef informationSource_sequence::const_iterator informationSource_const_iterator;
    typedef ::xsd::cxx::tree::traits< informationSource_type, char > informationSource_traits;

    const informationSource_sequence&
    informationSource () const;

    informationSource_sequence&
    informationSource ();

    void
    informationSource (const informationSource_sequence& s);

    // time
    // 
    typedef ::xml_schema::date_time time_type;
    typedef ::xsd::cxx::tree::optional< time_type > time_optional;
    typedef ::xsd::cxx::tree::traits< time_type, char > time_traits;

    const time_optional&
    time () const;

    time_optional&
    time ();

    void
    time (const time_type& x);

    void
    time (const time_optional& x);

    void
    time (::std::auto_ptr< time_type > p);

    // valuationDate
    // 
    typedef ::xml_schema::date valuationDate_type;
    typedef ::xsd::cxx::tree::optional< valuationDate_type > valuationDate_optional;
    typedef ::xsd::cxx::tree::traits< valuationDate_type, char > valuationDate_traits;

    const valuationDate_optional&
    valuationDate () const;

    valuationDate_optional&
    valuationDate ();

    void
    valuationDate (const valuationDate_type& x);

    void
    valuationDate (const valuationDate_optional& x);

    void
    valuationDate (::std::auto_ptr< valuationDate_type > p);

    // expiryTime
    // 
    typedef ::xml_schema::date_time expiryTime_type;
    typedef ::xsd::cxx::tree::optional< expiryTime_type > expiryTime_optional;
    typedef ::xsd::cxx::tree::traits< expiryTime_type, char > expiryTime_traits;

    const expiryTime_optional&
    expiryTime () const;

    expiryTime_optional&
    expiryTime ();

    void
    expiryTime (const expiryTime_type& x);

    void
    expiryTime (const expiryTime_optional& x);

    void
    expiryTime (::std::auto_ptr< expiryTime_type > p);

    // cashFlowType
    // 
    typedef ::FpML_4_2::CashflowType cashFlowType_type;
    typedef ::xsd::cxx::tree::optional< cashFlowType_type > cashFlowType_optional;
    typedef ::xsd::cxx::tree::traits< cashFlowType_type, char > cashFlowType_traits;

    const cashFlowType_optional&
    cashFlowType () const;

    cashFlowType_optional&
    cashFlowType ();

    void
    cashFlowType (const cashFlowType_type& x);

    void
    cashFlowType (const cashFlowType_optional& x);

    void
    cashFlowType (::std::auto_ptr< cashFlowType_type > p);

    // Constructors.
    //
    QuotationCharacteristics ();

    QuotationCharacteristics (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    QuotationCharacteristics (const QuotationCharacteristics& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual QuotationCharacteristics*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~QuotationCharacteristics ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    measureType_optional measureType_;
    quoteUnits_optional quoteUnits_;
    side_optional side_;
    currency_optional currency_;
    timing_optional timing_;
    businessCenter_optional businessCenter_;
    exchangeId_optional exchangeId_;
    informationSource_sequence informationSource_;
    time_optional time_;
    valuationDate_optional valuationDate_;
    expiryTime_optional expiryTime_;
    cashFlowType_optional cashFlowType_;
  };

  class QuoteTiming: public ::xml_schema::normalized_string
  {
    public:
    // quoteTimingScheme
    // 
    typedef ::xml_schema::uri quoteTimingScheme_type;
    typedef ::xsd::cxx::tree::traits< quoteTimingScheme_type, char > quoteTimingScheme_traits;

    const quoteTimingScheme_type&
    quoteTimingScheme () const;

    quoteTimingScheme_type&
    quoteTimingScheme ();

    void
    quoteTimingScheme (const quoteTimingScheme_type& x);

    void
    quoteTimingScheme (::std::auto_ptr< quoteTimingScheme_type > p);

    static const quoteTimingScheme_type&
    quoteTimingScheme_default_value ();

    // Constructors.
    //
    QuoteTiming ();

    QuoteTiming (const char*);

    QuoteTiming (const ::std::string&);

    QuoteTiming (const ::xml_schema::normalized_string&);

    QuoteTiming (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    QuoteTiming (const QuoteTiming& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual QuoteTiming*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~QuoteTiming ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< quoteTimingScheme_type > quoteTimingScheme_;
    static const quoteTimingScheme_type quoteTimingScheme_default_value_;
  };

  class ValuationReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    ValuationReference (const href_type&);

    ValuationReference (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    ValuationReference (const ValuationReference& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual ValuationReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ValuationReference ();
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const AnyAssetReference&);

  void
  operator<< (::xercesc::DOMElement&, const AssetMeasureType&);

  void
  operator<< (::xercesc::DOMElement&, const Valuation&);

  void
  operator<< (::xercesc::DOMElement&, const BasicAssetValuation&);

  void
  operator<< (::xercesc::DOMElement&, const BasicQuotation&);

  void
  operator<< (::xercesc::DOMElement&, const PriceQuoteUnits&);

  void
  operator<< (::xercesc::DOMElement&, const QuotationCharacteristics&);

  void
  operator<< (::xercesc::DOMElement&, const QuoteTiming&);

  void
  operator<< (::xercesc::DOMElement&, const ValuationReference&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_VALUATION_BASE_4_2_HXX
