// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_IRD_4_2_HXX
#define FPML_IRD_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class SimplePricingStructureReference;
  class BondReference;
  class BulletPayment;
  class Calculation;
  class CalculationPeriod;
  class CalculationPeriodAmount;
  class CalculationPeriodDates;
  class CalculationPeriodDatesReference;
  class CancelableProvision;
  class CancelableProvisionAdjustedDates;
  class CancellationEvent;
  class CapFloor;
  class Cashflows;
  class CashPriceMethod;
  class CashSettlement;
  class CashSettlementPaymentDate;
  class DateRelativeToPaymentDates;
  class Discounting;
  class EarlyTerminationEvent;
  class EarlyTerminationProvision;
  class ExerciseEvent;
  class ExercisePeriod;
  class ExtendibleProvision;
  class ExtendibleProvisionAdjustedDates;
  class ExtensionEvent;
  class FloatingRateDefinition;
  class Fra;
  class FxFixingDate;
  class FxLinkedNotionalAmount;
  class FxLinkedNotionalSchedule;
  class InflationRateCalculation;
  class InterestRateStream;
  class MandatoryEarlyTermination;
  class MandatoryEarlyTerminationAdjustedDates;
  class NonDeliverableSettlement;
  class Notional;
  class NotionalStepRule;
  class OptionalEarlyTermination;
  class OptionalEarlyTerminationAdjustedDates;
  class PaymentCalculationPeriod;
  class PaymentDates;
  class PaymentDatesReference;
  class PrincipalExchange;
  class ResetDates;
  class ResetDatesReference;
  class SettlementProvision;
  class SettlementRateOption;
  class SinglePartyOption;
  class StubCalculationPeriodAmount;
  class Swap;
  class SwapAdditionalTerms;
  class Swaption;
  class SwaptionAdjustedDates;
  class YieldCurveMethod;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-shared-4-2.hxx"

#include "fpml-asset-4-2.hxx"

#include "fpml-mktenv-4-2.hxx"

namespace FpML_4_2
{
  class SimplePricingStructureReference: public ::xml_schema::idref
  {
    public:
    // Constructors.
    //
    SimplePricingStructureReference (const ::xml_schema::idref&);

    SimplePricingStructureReference (const ::xercesc::DOMElement& e,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    SimplePricingStructureReference (const ::xercesc::DOMAttr& a,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    SimplePricingStructureReference (const ::std::string& s,
                                     const ::xercesc::DOMElement* e,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    SimplePricingStructureReference (const SimplePricingStructureReference& x,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    virtual SimplePricingStructureReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SimplePricingStructureReference ();
  };

  class BondReference: public ::xml_schema::type
  {
    public:
    // bond
    // 
    typedef ::FpML_4_2::Bond bond_type;
    typedef ::xsd::cxx::tree::traits< bond_type, char > bond_traits;

    const bond_type&
    bond () const;

    bond_type&
    bond ();

    void
    bond (const bond_type& x);

    void
    bond (::std::auto_ptr< bond_type > p);

    // conditionPrecedentBond
    // 
    typedef ::xml_schema::boolean conditionPrecedentBond_type;
    typedef ::xsd::cxx::tree::traits< conditionPrecedentBond_type, char > conditionPrecedentBond_traits;

    const conditionPrecedentBond_type&
    conditionPrecedentBond () const;

    conditionPrecedentBond_type&
    conditionPrecedentBond ();

    void
    conditionPrecedentBond (const conditionPrecedentBond_type& x);

    // discrepancyClause
    // 
    typedef ::xml_schema::boolean discrepancyClause_type;
    typedef ::xsd::cxx::tree::optional< discrepancyClause_type > discrepancyClause_optional;
    typedef ::xsd::cxx::tree::traits< discrepancyClause_type, char > discrepancyClause_traits;

    const discrepancyClause_optional&
    discrepancyClause () const;

    discrepancyClause_optional&
    discrepancyClause ();

    void
    discrepancyClause (const discrepancyClause_type& x);

    void
    discrepancyClause (const discrepancyClause_optional& x);

    // Constructors.
    //
    BondReference (const bond_type&,
                   const conditionPrecedentBond_type&);

    BondReference (::std::auto_ptr< bond_type >&,
                   const conditionPrecedentBond_type&);

    BondReference (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    BondReference (const BondReference& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual BondReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BondReference ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< bond_type > bond_;
    ::xsd::cxx::tree::one< conditionPrecedentBond_type > conditionPrecedentBond_;
    discrepancyClause_optional discrepancyClause_;
  };

  class BulletPayment: public ::FpML_4_2::Product
  {
    public:
    // payment
    // 
    typedef ::FpML_4_2::Payment payment_type;
    typedef ::xsd::cxx::tree::traits< payment_type, char > payment_traits;

    const payment_type&
    payment () const;

    payment_type&
    payment ();

    void
    payment (const payment_type& x);

    void
    payment (::std::auto_ptr< payment_type > p);

    // Constructors.
    //
    BulletPayment (const payment_type&);

    BulletPayment (::std::auto_ptr< payment_type >&);

    BulletPayment (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    BulletPayment (const BulletPayment& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual BulletPayment*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BulletPayment ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payment_type > payment_;
  };

  class Calculation: public ::xml_schema::type
  {
    public:
    // notionalSchedule
    // 
    typedef ::FpML_4_2::Notional notionalSchedule_type;
    typedef ::xsd::cxx::tree::optional< notionalSchedule_type > notionalSchedule_optional;
    typedef ::xsd::cxx::tree::traits< notionalSchedule_type, char > notionalSchedule_traits;

    const notionalSchedule_optional&
    notionalSchedule () const;

    notionalSchedule_optional&
    notionalSchedule ();

    void
    notionalSchedule (const notionalSchedule_type& x);

    void
    notionalSchedule (const notionalSchedule_optional& x);

    void
    notionalSchedule (::std::auto_ptr< notionalSchedule_type > p);

    // fxLinkedNotionalSchedule
    // 
    typedef ::FpML_4_2::FxLinkedNotionalSchedule fxLinkedNotionalSchedule_type;
    typedef ::xsd::cxx::tree::optional< fxLinkedNotionalSchedule_type > fxLinkedNotionalSchedule_optional;
    typedef ::xsd::cxx::tree::traits< fxLinkedNotionalSchedule_type, char > fxLinkedNotionalSchedule_traits;

    const fxLinkedNotionalSchedule_optional&
    fxLinkedNotionalSchedule () const;

    fxLinkedNotionalSchedule_optional&
    fxLinkedNotionalSchedule ();

    void
    fxLinkedNotionalSchedule (const fxLinkedNotionalSchedule_type& x);

    void
    fxLinkedNotionalSchedule (const fxLinkedNotionalSchedule_optional& x);

    void
    fxLinkedNotionalSchedule (::std::auto_ptr< fxLinkedNotionalSchedule_type > p);

    // fixedRateSchedule
    // 
    typedef ::FpML_4_2::Schedule fixedRateSchedule_type;
    typedef ::xsd::cxx::tree::optional< fixedRateSchedule_type > fixedRateSchedule_optional;
    typedef ::xsd::cxx::tree::traits< fixedRateSchedule_type, char > fixedRateSchedule_traits;

    const fixedRateSchedule_optional&
    fixedRateSchedule () const;

    fixedRateSchedule_optional&
    fixedRateSchedule ();

    void
    fixedRateSchedule (const fixedRateSchedule_type& x);

    void
    fixedRateSchedule (const fixedRateSchedule_optional& x);

    void
    fixedRateSchedule (::std::auto_ptr< fixedRateSchedule_type > p);

    // rateCalculation
    // 
    typedef ::FpML_4_2::Rate rateCalculation_type;
    typedef ::xsd::cxx::tree::optional< rateCalculation_type > rateCalculation_optional;
    typedef ::xsd::cxx::tree::traits< rateCalculation_type, char > rateCalculation_traits;

    const rateCalculation_optional&
    rateCalculation () const;

    rateCalculation_optional&
    rateCalculation ();

    void
    rateCalculation (const rateCalculation_type& x);

    void
    rateCalculation (const rateCalculation_optional& x);

    void
    rateCalculation (::std::auto_ptr< rateCalculation_type > p);

    // dayCountFraction
    // 
    typedef ::FpML_4_2::DayCountFraction dayCountFraction_type;
    typedef ::xsd::cxx::tree::traits< dayCountFraction_type, char > dayCountFraction_traits;

    const dayCountFraction_type&
    dayCountFraction () const;

    dayCountFraction_type&
    dayCountFraction ();

    void
    dayCountFraction (const dayCountFraction_type& x);

    void
    dayCountFraction (::std::auto_ptr< dayCountFraction_type > p);

    // discounting
    // 
    typedef ::FpML_4_2::Discounting discounting_type;
    typedef ::xsd::cxx::tree::optional< discounting_type > discounting_optional;
    typedef ::xsd::cxx::tree::traits< discounting_type, char > discounting_traits;

    const discounting_optional&
    discounting () const;

    discounting_optional&
    discounting ();

    void
    discounting (const discounting_type& x);

    void
    discounting (const discounting_optional& x);

    void
    discounting (::std::auto_ptr< discounting_type > p);

    // compoundingMethod
    // 
    typedef ::FpML_4_2::CompoundingMethodEnum compoundingMethod_type;
    typedef ::xsd::cxx::tree::optional< compoundingMethod_type > compoundingMethod_optional;
    typedef ::xsd::cxx::tree::traits< compoundingMethod_type, char > compoundingMethod_traits;

    const compoundingMethod_optional&
    compoundingMethod () const;

    compoundingMethod_optional&
    compoundingMethod ();

    void
    compoundingMethod (const compoundingMethod_type& x);

    void
    compoundingMethod (const compoundingMethod_optional& x);

    void
    compoundingMethod (::std::auto_ptr< compoundingMethod_type > p);

    // Constructors.
    //
    Calculation (const dayCountFraction_type&);

    Calculation (::std::auto_ptr< dayCountFraction_type >&);

    Calculation (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    Calculation (const Calculation& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual Calculation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Calculation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    notionalSchedule_optional notionalSchedule_;
    fxLinkedNotionalSchedule_optional fxLinkedNotionalSchedule_;
    fixedRateSchedule_optional fixedRateSchedule_;
    rateCalculation_optional rateCalculation_;
    ::xsd::cxx::tree::one< dayCountFraction_type > dayCountFraction_;
    discounting_optional discounting_;
    compoundingMethod_optional compoundingMethod_;
  };

  class CalculationPeriod: public ::xml_schema::type
  {
    public:
    // unadjustedStartDate
    // 
    typedef ::xml_schema::date unadjustedStartDate_type;
    typedef ::xsd::cxx::tree::optional< unadjustedStartDate_type > unadjustedStartDate_optional;
    typedef ::xsd::cxx::tree::traits< unadjustedStartDate_type, char > unadjustedStartDate_traits;

    const unadjustedStartDate_optional&
    unadjustedStartDate () const;

    unadjustedStartDate_optional&
    unadjustedStartDate ();

    void
    unadjustedStartDate (const unadjustedStartDate_type& x);

    void
    unadjustedStartDate (const unadjustedStartDate_optional& x);

    void
    unadjustedStartDate (::std::auto_ptr< unadjustedStartDate_type > p);

    // unadjustedEndDate
    // 
    typedef ::xml_schema::date unadjustedEndDate_type;
    typedef ::xsd::cxx::tree::optional< unadjustedEndDate_type > unadjustedEndDate_optional;
    typedef ::xsd::cxx::tree::traits< unadjustedEndDate_type, char > unadjustedEndDate_traits;

    const unadjustedEndDate_optional&
    unadjustedEndDate () const;

    unadjustedEndDate_optional&
    unadjustedEndDate ();

    void
    unadjustedEndDate (const unadjustedEndDate_type& x);

    void
    unadjustedEndDate (const unadjustedEndDate_optional& x);

    void
    unadjustedEndDate (::std::auto_ptr< unadjustedEndDate_type > p);

    // adjustedStartDate
    // 
    typedef ::xml_schema::date adjustedStartDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedStartDate_type > adjustedStartDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedStartDate_type, char > adjustedStartDate_traits;

    const adjustedStartDate_optional&
    adjustedStartDate () const;

    adjustedStartDate_optional&
    adjustedStartDate ();

    void
    adjustedStartDate (const adjustedStartDate_type& x);

    void
    adjustedStartDate (const adjustedStartDate_optional& x);

    void
    adjustedStartDate (::std::auto_ptr< adjustedStartDate_type > p);

    // adjustedEndDate
    // 
    typedef ::xml_schema::date adjustedEndDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedEndDate_type > adjustedEndDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedEndDate_type, char > adjustedEndDate_traits;

    const adjustedEndDate_optional&
    adjustedEndDate () const;

    adjustedEndDate_optional&
    adjustedEndDate ();

    void
    adjustedEndDate (const adjustedEndDate_type& x);

    void
    adjustedEndDate (const adjustedEndDate_optional& x);

    void
    adjustedEndDate (::std::auto_ptr< adjustedEndDate_type > p);

    // calculationPeriodNumberOfDays
    // 
    typedef ::xml_schema::positive_integer calculationPeriodNumberOfDays_type;
    typedef ::xsd::cxx::tree::optional< calculationPeriodNumberOfDays_type > calculationPeriodNumberOfDays_optional;
    typedef ::xsd::cxx::tree::traits< calculationPeriodNumberOfDays_type, char > calculationPeriodNumberOfDays_traits;

    const calculationPeriodNumberOfDays_optional&
    calculationPeriodNumberOfDays () const;

    calculationPeriodNumberOfDays_optional&
    calculationPeriodNumberOfDays ();

    void
    calculationPeriodNumberOfDays (const calculationPeriodNumberOfDays_type& x);

    void
    calculationPeriodNumberOfDays (const calculationPeriodNumberOfDays_optional& x);

    // notionalAmount
    // 
    typedef ::xml_schema::decimal notionalAmount_type;
    typedef ::xsd::cxx::tree::optional< notionalAmount_type > notionalAmount_optional;
    typedef ::xsd::cxx::tree::traits< notionalAmount_type, char, ::xsd::cxx::tree::schema_type::decimal > notionalAmount_traits;

    const notionalAmount_optional&
    notionalAmount () const;

    notionalAmount_optional&
    notionalAmount ();

    void
    notionalAmount (const notionalAmount_type& x);

    void
    notionalAmount (const notionalAmount_optional& x);

    // fxLinkedNotionalAmount
    // 
    typedef ::FpML_4_2::FxLinkedNotionalAmount fxLinkedNotionalAmount_type;
    typedef ::xsd::cxx::tree::optional< fxLinkedNotionalAmount_type > fxLinkedNotionalAmount_optional;
    typedef ::xsd::cxx::tree::traits< fxLinkedNotionalAmount_type, char > fxLinkedNotionalAmount_traits;

    const fxLinkedNotionalAmount_optional&
    fxLinkedNotionalAmount () const;

    fxLinkedNotionalAmount_optional&
    fxLinkedNotionalAmount ();

    void
    fxLinkedNotionalAmount (const fxLinkedNotionalAmount_type& x);

    void
    fxLinkedNotionalAmount (const fxLinkedNotionalAmount_optional& x);

    void
    fxLinkedNotionalAmount (::std::auto_ptr< fxLinkedNotionalAmount_type > p);

    // floatingRateDefinition
    // 
    typedef ::FpML_4_2::FloatingRateDefinition floatingRateDefinition_type;
    typedef ::xsd::cxx::tree::optional< floatingRateDefinition_type > floatingRateDefinition_optional;
    typedef ::xsd::cxx::tree::traits< floatingRateDefinition_type, char > floatingRateDefinition_traits;

    const floatingRateDefinition_optional&
    floatingRateDefinition () const;

    floatingRateDefinition_optional&
    floatingRateDefinition ();

    void
    floatingRateDefinition (const floatingRateDefinition_type& x);

    void
    floatingRateDefinition (const floatingRateDefinition_optional& x);

    void
    floatingRateDefinition (::std::auto_ptr< floatingRateDefinition_type > p);

    // fixedRate
    // 
    typedef ::xml_schema::decimal fixedRate_type;
    typedef ::xsd::cxx::tree::optional< fixedRate_type > fixedRate_optional;
    typedef ::xsd::cxx::tree::traits< fixedRate_type, char, ::xsd::cxx::tree::schema_type::decimal > fixedRate_traits;

    const fixedRate_optional&
    fixedRate () const;

    fixedRate_optional&
    fixedRate ();

    void
    fixedRate (const fixedRate_type& x);

    void
    fixedRate (const fixedRate_optional& x);

    // dayCountYearFraction
    // 
    typedef ::xml_schema::decimal dayCountYearFraction_type;
    typedef ::xsd::cxx::tree::optional< dayCountYearFraction_type > dayCountYearFraction_optional;
    typedef ::xsd::cxx::tree::traits< dayCountYearFraction_type, char, ::xsd::cxx::tree::schema_type::decimal > dayCountYearFraction_traits;

    const dayCountYearFraction_optional&
    dayCountYearFraction () const;

    dayCountYearFraction_optional&
    dayCountYearFraction ();

    void
    dayCountYearFraction (const dayCountYearFraction_type& x);

    void
    dayCountYearFraction (const dayCountYearFraction_optional& x);

    // forecastAmount
    // 
    typedef ::FpML_4_2::Money forecastAmount_type;
    typedef ::xsd::cxx::tree::optional< forecastAmount_type > forecastAmount_optional;
    typedef ::xsd::cxx::tree::traits< forecastAmount_type, char > forecastAmount_traits;

    const forecastAmount_optional&
    forecastAmount () const;

    forecastAmount_optional&
    forecastAmount ();

    void
    forecastAmount (const forecastAmount_type& x);

    void
    forecastAmount (const forecastAmount_optional& x);

    void
    forecastAmount (::std::auto_ptr< forecastAmount_type > p);

    // forecastRate
    // 
    typedef ::xml_schema::decimal forecastRate_type;
    typedef ::xsd::cxx::tree::optional< forecastRate_type > forecastRate_optional;
    typedef ::xsd::cxx::tree::traits< forecastRate_type, char, ::xsd::cxx::tree::schema_type::decimal > forecastRate_traits;

    const forecastRate_optional&
    forecastRate () const;

    forecastRate_optional&
    forecastRate ();

    void
    forecastRate (const forecastRate_type& x);

    void
    forecastRate (const forecastRate_optional& x);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    CalculationPeriod ();

    CalculationPeriod (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    CalculationPeriod (const CalculationPeriod& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual CalculationPeriod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CalculationPeriod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    unadjustedStartDate_optional unadjustedStartDate_;
    unadjustedEndDate_optional unadjustedEndDate_;
    adjustedStartDate_optional adjustedStartDate_;
    adjustedEndDate_optional adjustedEndDate_;
    calculationPeriodNumberOfDays_optional calculationPeriodNumberOfDays_;
    notionalAmount_optional notionalAmount_;
    fxLinkedNotionalAmount_optional fxLinkedNotionalAmount_;
    floatingRateDefinition_optional floatingRateDefinition_;
    fixedRate_optional fixedRate_;
    dayCountYearFraction_optional dayCountYearFraction_;
    forecastAmount_optional forecastAmount_;
    forecastRate_optional forecastRate_;
    id_optional id_;
  };

  class CalculationPeriodAmount: public ::xml_schema::type
  {
    public:
    // calculation
    // 
    typedef ::FpML_4_2::Calculation calculation_type;
    typedef ::xsd::cxx::tree::optional< calculation_type > calculation_optional;
    typedef ::xsd::cxx::tree::traits< calculation_type, char > calculation_traits;

    const calculation_optional&
    calculation () const;

    calculation_optional&
    calculation ();

    void
    calculation (const calculation_type& x);

    void
    calculation (const calculation_optional& x);

    void
    calculation (::std::auto_ptr< calculation_type > p);

    // knownAmountSchedule
    // 
    typedef ::FpML_4_2::AmountSchedule knownAmountSchedule_type;
    typedef ::xsd::cxx::tree::optional< knownAmountSchedule_type > knownAmountSchedule_optional;
    typedef ::xsd::cxx::tree::traits< knownAmountSchedule_type, char > knownAmountSchedule_traits;

    const knownAmountSchedule_optional&
    knownAmountSchedule () const;

    knownAmountSchedule_optional&
    knownAmountSchedule ();

    void
    knownAmountSchedule (const knownAmountSchedule_type& x);

    void
    knownAmountSchedule (const knownAmountSchedule_optional& x);

    void
    knownAmountSchedule (::std::auto_ptr< knownAmountSchedule_type > p);

    // Constructors.
    //
    CalculationPeriodAmount ();

    CalculationPeriodAmount (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    CalculationPeriodAmount (const CalculationPeriodAmount& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual CalculationPeriodAmount*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CalculationPeriodAmount ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    calculation_optional calculation_;
    knownAmountSchedule_optional knownAmountSchedule_;
  };

  class CalculationPeriodDates: public ::xml_schema::type
  {
    public:
    // effectiveDate
    // 
    typedef ::FpML_4_2::AdjustableDate effectiveDate_type;
    typedef ::xsd::cxx::tree::optional< effectiveDate_type > effectiveDate_optional;
    typedef ::xsd::cxx::tree::traits< effectiveDate_type, char > effectiveDate_traits;

    const effectiveDate_optional&
    effectiveDate () const;

    effectiveDate_optional&
    effectiveDate ();

    void
    effectiveDate (const effectiveDate_type& x);

    void
    effectiveDate (const effectiveDate_optional& x);

    void
    effectiveDate (::std::auto_ptr< effectiveDate_type > p);

    // relativeEffectiveDate
    // 
    typedef ::FpML_4_2::AdjustedRelativeDateOffset relativeEffectiveDate_type;
    typedef ::xsd::cxx::tree::optional< relativeEffectiveDate_type > relativeEffectiveDate_optional;
    typedef ::xsd::cxx::tree::traits< relativeEffectiveDate_type, char > relativeEffectiveDate_traits;

    const relativeEffectiveDate_optional&
    relativeEffectiveDate () const;

    relativeEffectiveDate_optional&
    relativeEffectiveDate ();

    void
    relativeEffectiveDate (const relativeEffectiveDate_type& x);

    void
    relativeEffectiveDate (const relativeEffectiveDate_optional& x);

    void
    relativeEffectiveDate (::std::auto_ptr< relativeEffectiveDate_type > p);

    // terminationDate
    // 
    typedef ::FpML_4_2::AdjustableDate terminationDate_type;
    typedef ::xsd::cxx::tree::optional< terminationDate_type > terminationDate_optional;
    typedef ::xsd::cxx::tree::traits< terminationDate_type, char > terminationDate_traits;

    const terminationDate_optional&
    terminationDate () const;

    terminationDate_optional&
    terminationDate ();

    void
    terminationDate (const terminationDate_type& x);

    void
    terminationDate (const terminationDate_optional& x);

    void
    terminationDate (::std::auto_ptr< terminationDate_type > p);

    // relativeTerminationDate
    // 
    typedef ::FpML_4_2::RelativeDateOffset relativeTerminationDate_type;
    typedef ::xsd::cxx::tree::optional< relativeTerminationDate_type > relativeTerminationDate_optional;
    typedef ::xsd::cxx::tree::traits< relativeTerminationDate_type, char > relativeTerminationDate_traits;

    const relativeTerminationDate_optional&
    relativeTerminationDate () const;

    relativeTerminationDate_optional&
    relativeTerminationDate ();

    void
    relativeTerminationDate (const relativeTerminationDate_type& x);

    void
    relativeTerminationDate (const relativeTerminationDate_optional& x);

    void
    relativeTerminationDate (::std::auto_ptr< relativeTerminationDate_type > p);

    // calculationPeriodDatesAdjustments
    // 
    typedef ::FpML_4_2::BusinessDayAdjustments calculationPeriodDatesAdjustments_type;
    typedef ::xsd::cxx::tree::traits< calculationPeriodDatesAdjustments_type, char > calculationPeriodDatesAdjustments_traits;

    const calculationPeriodDatesAdjustments_type&
    calculationPeriodDatesAdjustments () const;

    calculationPeriodDatesAdjustments_type&
    calculationPeriodDatesAdjustments ();

    void
    calculationPeriodDatesAdjustments (const calculationPeriodDatesAdjustments_type& x);

    void
    calculationPeriodDatesAdjustments (::std::auto_ptr< calculationPeriodDatesAdjustments_type > p);

    // firstPeriodStartDate
    // 
    typedef ::FpML_4_2::AdjustableDate firstPeriodStartDate_type;
    typedef ::xsd::cxx::tree::optional< firstPeriodStartDate_type > firstPeriodStartDate_optional;
    typedef ::xsd::cxx::tree::traits< firstPeriodStartDate_type, char > firstPeriodStartDate_traits;

    const firstPeriodStartDate_optional&
    firstPeriodStartDate () const;

    firstPeriodStartDate_optional&
    firstPeriodStartDate ();

    void
    firstPeriodStartDate (const firstPeriodStartDate_type& x);

    void
    firstPeriodStartDate (const firstPeriodStartDate_optional& x);

    void
    firstPeriodStartDate (::std::auto_ptr< firstPeriodStartDate_type > p);

    // firstRegularPeriodStartDate
    // 
    typedef ::xml_schema::date firstRegularPeriodStartDate_type;
    typedef ::xsd::cxx::tree::optional< firstRegularPeriodStartDate_type > firstRegularPeriodStartDate_optional;
    typedef ::xsd::cxx::tree::traits< firstRegularPeriodStartDate_type, char > firstRegularPeriodStartDate_traits;

    const firstRegularPeriodStartDate_optional&
    firstRegularPeriodStartDate () const;

    firstRegularPeriodStartDate_optional&
    firstRegularPeriodStartDate ();

    void
    firstRegularPeriodStartDate (const firstRegularPeriodStartDate_type& x);

    void
    firstRegularPeriodStartDate (const firstRegularPeriodStartDate_optional& x);

    void
    firstRegularPeriodStartDate (::std::auto_ptr< firstRegularPeriodStartDate_type > p);

    // lastRegularPeriodEndDate
    // 
    typedef ::xml_schema::date lastRegularPeriodEndDate_type;
    typedef ::xsd::cxx::tree::optional< lastRegularPeriodEndDate_type > lastRegularPeriodEndDate_optional;
    typedef ::xsd::cxx::tree::traits< lastRegularPeriodEndDate_type, char > lastRegularPeriodEndDate_traits;

    const lastRegularPeriodEndDate_optional&
    lastRegularPeriodEndDate () const;

    lastRegularPeriodEndDate_optional&
    lastRegularPeriodEndDate ();

    void
    lastRegularPeriodEndDate (const lastRegularPeriodEndDate_type& x);

    void
    lastRegularPeriodEndDate (const lastRegularPeriodEndDate_optional& x);

    void
    lastRegularPeriodEndDate (::std::auto_ptr< lastRegularPeriodEndDate_type > p);

    // stubPeriodType
    // 
    typedef ::FpML_4_2::StubPeriodTypeEnum stubPeriodType_type;
    typedef ::xsd::cxx::tree::optional< stubPeriodType_type > stubPeriodType_optional;
    typedef ::xsd::cxx::tree::traits< stubPeriodType_type, char > stubPeriodType_traits;

    const stubPeriodType_optional&
    stubPeriodType () const;

    stubPeriodType_optional&
    stubPeriodType ();

    void
    stubPeriodType (const stubPeriodType_type& x);

    void
    stubPeriodType (const stubPeriodType_optional& x);

    void
    stubPeriodType (::std::auto_ptr< stubPeriodType_type > p);

    // calculationPeriodFrequency
    // 
    typedef ::FpML_4_2::CalculationPeriodFrequency calculationPeriodFrequency_type;
    typedef ::xsd::cxx::tree::traits< calculationPeriodFrequency_type, char > calculationPeriodFrequency_traits;

    const calculationPeriodFrequency_type&
    calculationPeriodFrequency () const;

    calculationPeriodFrequency_type&
    calculationPeriodFrequency ();

    void
    calculationPeriodFrequency (const calculationPeriodFrequency_type& x);

    void
    calculationPeriodFrequency (::std::auto_ptr< calculationPeriodFrequency_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    CalculationPeriodDates (const calculationPeriodDatesAdjustments_type&,
                            const calculationPeriodFrequency_type&,
                            const id_type&);

    CalculationPeriodDates (::std::auto_ptr< calculationPeriodDatesAdjustments_type >&,
                            ::std::auto_ptr< calculationPeriodFrequency_type >&,
                            const id_type&);

    CalculationPeriodDates (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    CalculationPeriodDates (const CalculationPeriodDates& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual CalculationPeriodDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CalculationPeriodDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    effectiveDate_optional effectiveDate_;
    relativeEffectiveDate_optional relativeEffectiveDate_;
    terminationDate_optional terminationDate_;
    relativeTerminationDate_optional relativeTerminationDate_;
    ::xsd::cxx::tree::one< calculationPeriodDatesAdjustments_type > calculationPeriodDatesAdjustments_;
    firstPeriodStartDate_optional firstPeriodStartDate_;
    firstRegularPeriodStartDate_optional firstRegularPeriodStartDate_;
    lastRegularPeriodEndDate_optional lastRegularPeriodEndDate_;
    stubPeriodType_optional stubPeriodType_;
    ::xsd::cxx::tree::one< calculationPeriodFrequency_type > calculationPeriodFrequency_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class CalculationPeriodDatesReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    CalculationPeriodDatesReference (const href_type&);

    CalculationPeriodDatesReference (const ::xercesc::DOMElement& e,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    CalculationPeriodDatesReference (const CalculationPeriodDatesReference& x,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    virtual CalculationPeriodDatesReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CalculationPeriodDatesReference ();
  };

  class CancelableProvision: public ::xml_schema::type
  {
    public:
    // buyerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference buyerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< buyerPartyReference_type, char > buyerPartyReference_traits;

    const buyerPartyReference_type&
    buyerPartyReference () const;

    buyerPartyReference_type&
    buyerPartyReference ();

    void
    buyerPartyReference (const buyerPartyReference_type& x);

    void
    buyerPartyReference (::std::auto_ptr< buyerPartyReference_type > p);

    // sellerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference sellerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< sellerPartyReference_type, char > sellerPartyReference_traits;

    const sellerPartyReference_type&
    sellerPartyReference () const;

    sellerPartyReference_type&
    sellerPartyReference ();

    void
    sellerPartyReference (const sellerPartyReference_type& x);

    void
    sellerPartyReference (::std::auto_ptr< sellerPartyReference_type > p);

    // exercise
    // 
    typedef ::FpML_4_2::Exercise exercise_type;
    typedef ::xsd::cxx::tree::traits< exercise_type, char > exercise_traits;

    const exercise_type&
    exercise () const;

    exercise_type&
    exercise ();

    void
    exercise (const exercise_type& x);

    void
    exercise (::std::auto_ptr< exercise_type > p);

    // exerciseNotice
    // 
    typedef ::FpML_4_2::ExerciseNotice exerciseNotice_type;
    typedef ::xsd::cxx::tree::optional< exerciseNotice_type > exerciseNotice_optional;
    typedef ::xsd::cxx::tree::traits< exerciseNotice_type, char > exerciseNotice_traits;

    const exerciseNotice_optional&
    exerciseNotice () const;

    exerciseNotice_optional&
    exerciseNotice ();

    void
    exerciseNotice (const exerciseNotice_type& x);

    void
    exerciseNotice (const exerciseNotice_optional& x);

    void
    exerciseNotice (::std::auto_ptr< exerciseNotice_type > p);

    // followUpConfirmation
    // 
    typedef ::xml_schema::boolean followUpConfirmation_type;
    typedef ::xsd::cxx::tree::traits< followUpConfirmation_type, char > followUpConfirmation_traits;

    const followUpConfirmation_type&
    followUpConfirmation () const;

    followUpConfirmation_type&
    followUpConfirmation ();

    void
    followUpConfirmation (const followUpConfirmation_type& x);

    // cancelableProvisionAdjustedDates
    // 
    typedef ::FpML_4_2::CancelableProvisionAdjustedDates cancelableProvisionAdjustedDates_type;
    typedef ::xsd::cxx::tree::optional< cancelableProvisionAdjustedDates_type > cancelableProvisionAdjustedDates_optional;
    typedef ::xsd::cxx::tree::traits< cancelableProvisionAdjustedDates_type, char > cancelableProvisionAdjustedDates_traits;

    const cancelableProvisionAdjustedDates_optional&
    cancelableProvisionAdjustedDates () const;

    cancelableProvisionAdjustedDates_optional&
    cancelableProvisionAdjustedDates ();

    void
    cancelableProvisionAdjustedDates (const cancelableProvisionAdjustedDates_type& x);

    void
    cancelableProvisionAdjustedDates (const cancelableProvisionAdjustedDates_optional& x);

    void
    cancelableProvisionAdjustedDates (::std::auto_ptr< cancelableProvisionAdjustedDates_type > p);

    // Constructors.
    //
    CancelableProvision (const buyerPartyReference_type&,
                         const sellerPartyReference_type&,
                         const exercise_type&,
                         const followUpConfirmation_type&);

    CancelableProvision (::std::auto_ptr< buyerPartyReference_type >&,
                         ::std::auto_ptr< sellerPartyReference_type >&,
                         ::std::auto_ptr< exercise_type >&,
                         const followUpConfirmation_type&);

    CancelableProvision (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    CancelableProvision (const CancelableProvision& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual CancelableProvision*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CancelableProvision ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< buyerPartyReference_type > buyerPartyReference_;
    ::xsd::cxx::tree::one< sellerPartyReference_type > sellerPartyReference_;
    ::xsd::cxx::tree::one< exercise_type > exercise_;
    exerciseNotice_optional exerciseNotice_;
    ::xsd::cxx::tree::one< followUpConfirmation_type > followUpConfirmation_;
    cancelableProvisionAdjustedDates_optional cancelableProvisionAdjustedDates_;
  };

  class CancelableProvisionAdjustedDates: public ::xml_schema::type
  {
    public:
    // cancellationEvent
    // 
    typedef ::FpML_4_2::CancellationEvent cancellationEvent_type;
    typedef ::xsd::cxx::tree::sequence< cancellationEvent_type > cancellationEvent_sequence;
    typedef cancellationEvent_sequence::iterator cancellationEvent_iterator;
    typedef cancellationEvent_sequence::const_iterator cancellationEvent_const_iterator;
    typedef ::xsd::cxx::tree::traits< cancellationEvent_type, char > cancellationEvent_traits;

    const cancellationEvent_sequence&
    cancellationEvent () const;

    cancellationEvent_sequence&
    cancellationEvent ();

    void
    cancellationEvent (const cancellationEvent_sequence& s);

    // Constructors.
    //
    CancelableProvisionAdjustedDates ();

    CancelableProvisionAdjustedDates (const ::xercesc::DOMElement& e,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    CancelableProvisionAdjustedDates (const CancelableProvisionAdjustedDates& x,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    virtual CancelableProvisionAdjustedDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CancelableProvisionAdjustedDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    cancellationEvent_sequence cancellationEvent_;
  };

  class CancellationEvent: public ::xml_schema::type
  {
    public:
    // adjustedExerciseDate
    // 
    typedef ::xml_schema::date adjustedExerciseDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedExerciseDate_type, char > adjustedExerciseDate_traits;

    const adjustedExerciseDate_type&
    adjustedExerciseDate () const;

    adjustedExerciseDate_type&
    adjustedExerciseDate ();

    void
    adjustedExerciseDate (const adjustedExerciseDate_type& x);

    void
    adjustedExerciseDate (::std::auto_ptr< adjustedExerciseDate_type > p);

    // adjustedEarlyTerminationDate
    // 
    typedef ::xml_schema::date adjustedEarlyTerminationDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedEarlyTerminationDate_type, char > adjustedEarlyTerminationDate_traits;

    const adjustedEarlyTerminationDate_type&
    adjustedEarlyTerminationDate () const;

    adjustedEarlyTerminationDate_type&
    adjustedEarlyTerminationDate ();

    void
    adjustedEarlyTerminationDate (const adjustedEarlyTerminationDate_type& x);

    void
    adjustedEarlyTerminationDate (::std::auto_ptr< adjustedEarlyTerminationDate_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    CancellationEvent (const adjustedExerciseDate_type&,
                       const adjustedEarlyTerminationDate_type&);

    CancellationEvent (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    CancellationEvent (const CancellationEvent& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual CancellationEvent*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CancellationEvent ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< adjustedExerciseDate_type > adjustedExerciseDate_;
    ::xsd::cxx::tree::one< adjustedEarlyTerminationDate_type > adjustedEarlyTerminationDate_;
    id_optional id_;
  };

  class CapFloor: public ::FpML_4_2::Product
  {
    public:
    // capFloorStream
    // 
    typedef ::FpML_4_2::InterestRateStream capFloorStream_type;
    typedef ::xsd::cxx::tree::traits< capFloorStream_type, char > capFloorStream_traits;

    const capFloorStream_type&
    capFloorStream () const;

    capFloorStream_type&
    capFloorStream ();

    void
    capFloorStream (const capFloorStream_type& x);

    void
    capFloorStream (::std::auto_ptr< capFloorStream_type > p);

    // premium
    // 
    typedef ::FpML_4_2::Payment premium_type;
    typedef ::xsd::cxx::tree::sequence< premium_type > premium_sequence;
    typedef premium_sequence::iterator premium_iterator;
    typedef premium_sequence::const_iterator premium_const_iterator;
    typedef ::xsd::cxx::tree::traits< premium_type, char > premium_traits;

    const premium_sequence&
    premium () const;

    premium_sequence&
    premium ();

    void
    premium (const premium_sequence& s);

    // additionalPayment
    // 
    typedef ::FpML_4_2::Payment additionalPayment_type;
    typedef ::xsd::cxx::tree::sequence< additionalPayment_type > additionalPayment_sequence;
    typedef additionalPayment_sequence::iterator additionalPayment_iterator;
    typedef additionalPayment_sequence::const_iterator additionalPayment_const_iterator;
    typedef ::xsd::cxx::tree::traits< additionalPayment_type, char > additionalPayment_traits;

    const additionalPayment_sequence&
    additionalPayment () const;

    additionalPayment_sequence&
    additionalPayment ();

    void
    additionalPayment (const additionalPayment_sequence& s);

    // earlyTerminationProvision
    // 
    typedef ::FpML_4_2::EarlyTerminationProvision earlyTerminationProvision_type;
    typedef ::xsd::cxx::tree::optional< earlyTerminationProvision_type > earlyTerminationProvision_optional;
    typedef ::xsd::cxx::tree::traits< earlyTerminationProvision_type, char > earlyTerminationProvision_traits;

    const earlyTerminationProvision_optional&
    earlyTerminationProvision () const;

    earlyTerminationProvision_optional&
    earlyTerminationProvision ();

    void
    earlyTerminationProvision (const earlyTerminationProvision_type& x);

    void
    earlyTerminationProvision (const earlyTerminationProvision_optional& x);

    void
    earlyTerminationProvision (::std::auto_ptr< earlyTerminationProvision_type > p);

    // Constructors.
    //
    CapFloor (const capFloorStream_type&);

    CapFloor (::std::auto_ptr< capFloorStream_type >&);

    CapFloor (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    CapFloor (const CapFloor& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual CapFloor*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CapFloor ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< capFloorStream_type > capFloorStream_;
    premium_sequence premium_;
    additionalPayment_sequence additionalPayment_;
    earlyTerminationProvision_optional earlyTerminationProvision_;
  };

  class Cashflows: public ::xml_schema::type
  {
    public:
    // cashflowsMatchParameters
    // 
    typedef ::xml_schema::boolean cashflowsMatchParameters_type;
    typedef ::xsd::cxx::tree::traits< cashflowsMatchParameters_type, char > cashflowsMatchParameters_traits;

    const cashflowsMatchParameters_type&
    cashflowsMatchParameters () const;

    cashflowsMatchParameters_type&
    cashflowsMatchParameters ();

    void
    cashflowsMatchParameters (const cashflowsMatchParameters_type& x);

    // principalExchange
    // 
    typedef ::FpML_4_2::PrincipalExchange principalExchange_type;
    typedef ::xsd::cxx::tree::sequence< principalExchange_type > principalExchange_sequence;
    typedef principalExchange_sequence::iterator principalExchange_iterator;
    typedef principalExchange_sequence::const_iterator principalExchange_const_iterator;
    typedef ::xsd::cxx::tree::traits< principalExchange_type, char > principalExchange_traits;

    const principalExchange_sequence&
    principalExchange () const;

    principalExchange_sequence&
    principalExchange ();

    void
    principalExchange (const principalExchange_sequence& s);

    // paymentCalculationPeriod
    // 
    typedef ::FpML_4_2::PaymentCalculationPeriod paymentCalculationPeriod_type;
    typedef ::xsd::cxx::tree::sequence< paymentCalculationPeriod_type > paymentCalculationPeriod_sequence;
    typedef paymentCalculationPeriod_sequence::iterator paymentCalculationPeriod_iterator;
    typedef paymentCalculationPeriod_sequence::const_iterator paymentCalculationPeriod_const_iterator;
    typedef ::xsd::cxx::tree::traits< paymentCalculationPeriod_type, char > paymentCalculationPeriod_traits;

    const paymentCalculationPeriod_sequence&
    paymentCalculationPeriod () const;

    paymentCalculationPeriod_sequence&
    paymentCalculationPeriod ();

    void
    paymentCalculationPeriod (const paymentCalculationPeriod_sequence& s);

    // Constructors.
    //
    Cashflows (const cashflowsMatchParameters_type&);

    Cashflows (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Cashflows (const Cashflows& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual Cashflows*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Cashflows ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< cashflowsMatchParameters_type > cashflowsMatchParameters_;
    principalExchange_sequence principalExchange_;
    paymentCalculationPeriod_sequence paymentCalculationPeriod_;
  };

  class CashPriceMethod: public ::xml_schema::type
  {
    public:
    // cashSettlementReferenceBanks
    // 
    typedef ::FpML_4_2::CashSettlementReferenceBanks cashSettlementReferenceBanks_type;
    typedef ::xsd::cxx::tree::optional< cashSettlementReferenceBanks_type > cashSettlementReferenceBanks_optional;
    typedef ::xsd::cxx::tree::traits< cashSettlementReferenceBanks_type, char > cashSettlementReferenceBanks_traits;

    const cashSettlementReferenceBanks_optional&
    cashSettlementReferenceBanks () const;

    cashSettlementReferenceBanks_optional&
    cashSettlementReferenceBanks ();

    void
    cashSettlementReferenceBanks (const cashSettlementReferenceBanks_type& x);

    void
    cashSettlementReferenceBanks (const cashSettlementReferenceBanks_optional& x);

    void
    cashSettlementReferenceBanks (::std::auto_ptr< cashSettlementReferenceBanks_type > p);

    // cashSettlementCurrency
    // 
    typedef ::FpML_4_2::Currency cashSettlementCurrency_type;
    typedef ::xsd::cxx::tree::traits< cashSettlementCurrency_type, char > cashSettlementCurrency_traits;

    const cashSettlementCurrency_type&
    cashSettlementCurrency () const;

    cashSettlementCurrency_type&
    cashSettlementCurrency ();

    void
    cashSettlementCurrency (const cashSettlementCurrency_type& x);

    void
    cashSettlementCurrency (::std::auto_ptr< cashSettlementCurrency_type > p);

    // quotationRateType
    // 
    typedef ::FpML_4_2::QuotationRateTypeEnum quotationRateType_type;
    typedef ::xsd::cxx::tree::traits< quotationRateType_type, char > quotationRateType_traits;

    const quotationRateType_type&
    quotationRateType () const;

    quotationRateType_type&
    quotationRateType ();

    void
    quotationRateType (const quotationRateType_type& x);

    void
    quotationRateType (::std::auto_ptr< quotationRateType_type > p);

    // Constructors.
    //
    CashPriceMethod (const cashSettlementCurrency_type&,
                     const quotationRateType_type&);

    CashPriceMethod (::std::auto_ptr< cashSettlementCurrency_type >&,
                     const quotationRateType_type&);

    CashPriceMethod (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    CashPriceMethod (const CashPriceMethod& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual CashPriceMethod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CashPriceMethod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    cashSettlementReferenceBanks_optional cashSettlementReferenceBanks_;
    ::xsd::cxx::tree::one< cashSettlementCurrency_type > cashSettlementCurrency_;
    ::xsd::cxx::tree::one< quotationRateType_type > quotationRateType_;
  };

  class CashSettlement: public ::xml_schema::type
  {
    public:
    // cashSettlementValuationTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime cashSettlementValuationTime_type;
    typedef ::xsd::cxx::tree::optional< cashSettlementValuationTime_type > cashSettlementValuationTime_optional;
    typedef ::xsd::cxx::tree::traits< cashSettlementValuationTime_type, char > cashSettlementValuationTime_traits;

    const cashSettlementValuationTime_optional&
    cashSettlementValuationTime () const;

    cashSettlementValuationTime_optional&
    cashSettlementValuationTime ();

    void
    cashSettlementValuationTime (const cashSettlementValuationTime_type& x);

    void
    cashSettlementValuationTime (const cashSettlementValuationTime_optional& x);

    void
    cashSettlementValuationTime (::std::auto_ptr< cashSettlementValuationTime_type > p);

    // cashSettlementValuationDate
    // 
    typedef ::FpML_4_2::RelativeDateOffset cashSettlementValuationDate_type;
    typedef ::xsd::cxx::tree::optional< cashSettlementValuationDate_type > cashSettlementValuationDate_optional;
    typedef ::xsd::cxx::tree::traits< cashSettlementValuationDate_type, char > cashSettlementValuationDate_traits;

    const cashSettlementValuationDate_optional&
    cashSettlementValuationDate () const;

    cashSettlementValuationDate_optional&
    cashSettlementValuationDate ();

    void
    cashSettlementValuationDate (const cashSettlementValuationDate_type& x);

    void
    cashSettlementValuationDate (const cashSettlementValuationDate_optional& x);

    void
    cashSettlementValuationDate (::std::auto_ptr< cashSettlementValuationDate_type > p);

    // cashSettlementPaymentDate
    // 
    typedef ::FpML_4_2::CashSettlementPaymentDate cashSettlementPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< cashSettlementPaymentDate_type > cashSettlementPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< cashSettlementPaymentDate_type, char > cashSettlementPaymentDate_traits;

    const cashSettlementPaymentDate_optional&
    cashSettlementPaymentDate () const;

    cashSettlementPaymentDate_optional&
    cashSettlementPaymentDate ();

    void
    cashSettlementPaymentDate (const cashSettlementPaymentDate_type& x);

    void
    cashSettlementPaymentDate (const cashSettlementPaymentDate_optional& x);

    void
    cashSettlementPaymentDate (::std::auto_ptr< cashSettlementPaymentDate_type > p);

    // cashPriceMethod
    // 
    typedef ::FpML_4_2::CashPriceMethod cashPriceMethod_type;
    typedef ::xsd::cxx::tree::optional< cashPriceMethod_type > cashPriceMethod_optional;
    typedef ::xsd::cxx::tree::traits< cashPriceMethod_type, char > cashPriceMethod_traits;

    const cashPriceMethod_optional&
    cashPriceMethod () const;

    cashPriceMethod_optional&
    cashPriceMethod ();

    void
    cashPriceMethod (const cashPriceMethod_type& x);

    void
    cashPriceMethod (const cashPriceMethod_optional& x);

    void
    cashPriceMethod (::std::auto_ptr< cashPriceMethod_type > p);

    // cashPriceAlternateMethod
    // 
    typedef ::FpML_4_2::CashPriceMethod cashPriceAlternateMethod_type;
    typedef ::xsd::cxx::tree::optional< cashPriceAlternateMethod_type > cashPriceAlternateMethod_optional;
    typedef ::xsd::cxx::tree::traits< cashPriceAlternateMethod_type, char > cashPriceAlternateMethod_traits;

    const cashPriceAlternateMethod_optional&
    cashPriceAlternateMethod () const;

    cashPriceAlternateMethod_optional&
    cashPriceAlternateMethod ();

    void
    cashPriceAlternateMethod (const cashPriceAlternateMethod_type& x);

    void
    cashPriceAlternateMethod (const cashPriceAlternateMethod_optional& x);

    void
    cashPriceAlternateMethod (::std::auto_ptr< cashPriceAlternateMethod_type > p);

    // parYieldCurveAdjustedMethod
    // 
    typedef ::FpML_4_2::YieldCurveMethod parYieldCurveAdjustedMethod_type;
    typedef ::xsd::cxx::tree::optional< parYieldCurveAdjustedMethod_type > parYieldCurveAdjustedMethod_optional;
    typedef ::xsd::cxx::tree::traits< parYieldCurveAdjustedMethod_type, char > parYieldCurveAdjustedMethod_traits;

    const parYieldCurveAdjustedMethod_optional&
    parYieldCurveAdjustedMethod () const;

    parYieldCurveAdjustedMethod_optional&
    parYieldCurveAdjustedMethod ();

    void
    parYieldCurveAdjustedMethod (const parYieldCurveAdjustedMethod_type& x);

    void
    parYieldCurveAdjustedMethod (const parYieldCurveAdjustedMethod_optional& x);

    void
    parYieldCurveAdjustedMethod (::std::auto_ptr< parYieldCurveAdjustedMethod_type > p);

    // zeroCouponYieldAdjustedMethod
    // 
    typedef ::FpML_4_2::YieldCurveMethod zeroCouponYieldAdjustedMethod_type;
    typedef ::xsd::cxx::tree::optional< zeroCouponYieldAdjustedMethod_type > zeroCouponYieldAdjustedMethod_optional;
    typedef ::xsd::cxx::tree::traits< zeroCouponYieldAdjustedMethod_type, char > zeroCouponYieldAdjustedMethod_traits;

    const zeroCouponYieldAdjustedMethod_optional&
    zeroCouponYieldAdjustedMethod () const;

    zeroCouponYieldAdjustedMethod_optional&
    zeroCouponYieldAdjustedMethod ();

    void
    zeroCouponYieldAdjustedMethod (const zeroCouponYieldAdjustedMethod_type& x);

    void
    zeroCouponYieldAdjustedMethod (const zeroCouponYieldAdjustedMethod_optional& x);

    void
    zeroCouponYieldAdjustedMethod (::std::auto_ptr< zeroCouponYieldAdjustedMethod_type > p);

    // parYieldCurveUnadjustedMethod
    // 
    typedef ::FpML_4_2::YieldCurveMethod parYieldCurveUnadjustedMethod_type;
    typedef ::xsd::cxx::tree::optional< parYieldCurveUnadjustedMethod_type > parYieldCurveUnadjustedMethod_optional;
    typedef ::xsd::cxx::tree::traits< parYieldCurveUnadjustedMethod_type, char > parYieldCurveUnadjustedMethod_traits;

    const parYieldCurveUnadjustedMethod_optional&
    parYieldCurveUnadjustedMethod () const;

    parYieldCurveUnadjustedMethod_optional&
    parYieldCurveUnadjustedMethod ();

    void
    parYieldCurveUnadjustedMethod (const parYieldCurveUnadjustedMethod_type& x);

    void
    parYieldCurveUnadjustedMethod (const parYieldCurveUnadjustedMethod_optional& x);

    void
    parYieldCurveUnadjustedMethod (::std::auto_ptr< parYieldCurveUnadjustedMethod_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    CashSettlement ();

    CashSettlement (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    CashSettlement (const CashSettlement& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual CashSettlement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CashSettlement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    cashSettlementValuationTime_optional cashSettlementValuationTime_;
    cashSettlementValuationDate_optional cashSettlementValuationDate_;
    cashSettlementPaymentDate_optional cashSettlementPaymentDate_;
    cashPriceMethod_optional cashPriceMethod_;
    cashPriceAlternateMethod_optional cashPriceAlternateMethod_;
    parYieldCurveAdjustedMethod_optional parYieldCurveAdjustedMethod_;
    zeroCouponYieldAdjustedMethod_optional zeroCouponYieldAdjustedMethod_;
    parYieldCurveUnadjustedMethod_optional parYieldCurveUnadjustedMethod_;
    id_optional id_;
  };

  class CashSettlementPaymentDate: public ::xml_schema::type
  {
    public:
    // adjustableDates
    // 
    typedef ::FpML_4_2::AdjustableDates adjustableDates_type;
    typedef ::xsd::cxx::tree::optional< adjustableDates_type > adjustableDates_optional;
    typedef ::xsd::cxx::tree::traits< adjustableDates_type, char > adjustableDates_traits;

    const adjustableDates_optional&
    adjustableDates () const;

    adjustableDates_optional&
    adjustableDates ();

    void
    adjustableDates (const adjustableDates_type& x);

    void
    adjustableDates (const adjustableDates_optional& x);

    void
    adjustableDates (::std::auto_ptr< adjustableDates_type > p);

    // relativeDate
    // 
    typedef ::FpML_4_2::RelativeDateOffset relativeDate_type;
    typedef ::xsd::cxx::tree::optional< relativeDate_type > relativeDate_optional;
    typedef ::xsd::cxx::tree::traits< relativeDate_type, char > relativeDate_traits;

    const relativeDate_optional&
    relativeDate () const;

    relativeDate_optional&
    relativeDate ();

    void
    relativeDate (const relativeDate_type& x);

    void
    relativeDate (const relativeDate_optional& x);

    void
    relativeDate (::std::auto_ptr< relativeDate_type > p);

    // businessDateRange
    // 
    typedef ::FpML_4_2::BusinessDateRange businessDateRange_type;
    typedef ::xsd::cxx::tree::optional< businessDateRange_type > businessDateRange_optional;
    typedef ::xsd::cxx::tree::traits< businessDateRange_type, char > businessDateRange_traits;

    const businessDateRange_optional&
    businessDateRange () const;

    businessDateRange_optional&
    businessDateRange ();

    void
    businessDateRange (const businessDateRange_type& x);

    void
    businessDateRange (const businessDateRange_optional& x);

    void
    businessDateRange (::std::auto_ptr< businessDateRange_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    CashSettlementPaymentDate ();

    CashSettlementPaymentDate (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    CashSettlementPaymentDate (const CashSettlementPaymentDate& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual CashSettlementPaymentDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CashSettlementPaymentDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    adjustableDates_optional adjustableDates_;
    relativeDate_optional relativeDate_;
    businessDateRange_optional businessDateRange_;
    id_optional id_;
  };

  class DateRelativeToPaymentDates: public ::xml_schema::type
  {
    public:
    // paymentDatesReference
    // 
    typedef ::FpML_4_2::PaymentDatesReference paymentDatesReference_type;
    typedef ::xsd::cxx::tree::sequence< paymentDatesReference_type > paymentDatesReference_sequence;
    typedef paymentDatesReference_sequence::iterator paymentDatesReference_iterator;
    typedef paymentDatesReference_sequence::const_iterator paymentDatesReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< paymentDatesReference_type, char > paymentDatesReference_traits;

    const paymentDatesReference_sequence&
    paymentDatesReference () const;

    paymentDatesReference_sequence&
    paymentDatesReference ();

    void
    paymentDatesReference (const paymentDatesReference_sequence& s);

    // Constructors.
    //
    DateRelativeToPaymentDates ();

    DateRelativeToPaymentDates (const ::xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    DateRelativeToPaymentDates (const DateRelativeToPaymentDates& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual DateRelativeToPaymentDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DateRelativeToPaymentDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    paymentDatesReference_sequence paymentDatesReference_;
  };

  class Discounting: public ::xml_schema::type
  {
    public:
    // discountingType
    // 
    typedef ::FpML_4_2::DiscountingTypeEnum discountingType_type;
    typedef ::xsd::cxx::tree::traits< discountingType_type, char > discountingType_traits;

    const discountingType_type&
    discountingType () const;

    discountingType_type&
    discountingType ();

    void
    discountingType (const discountingType_type& x);

    void
    discountingType (::std::auto_ptr< discountingType_type > p);

    // discountRate
    // 
    typedef ::xml_schema::decimal discountRate_type;
    typedef ::xsd::cxx::tree::optional< discountRate_type > discountRate_optional;
    typedef ::xsd::cxx::tree::traits< discountRate_type, char, ::xsd::cxx::tree::schema_type::decimal > discountRate_traits;

    const discountRate_optional&
    discountRate () const;

    discountRate_optional&
    discountRate ();

    void
    discountRate (const discountRate_type& x);

    void
    discountRate (const discountRate_optional& x);

    // discountRateDayCountFraction
    // 
    typedef ::FpML_4_2::DayCountFraction discountRateDayCountFraction_type;
    typedef ::xsd::cxx::tree::optional< discountRateDayCountFraction_type > discountRateDayCountFraction_optional;
    typedef ::xsd::cxx::tree::traits< discountRateDayCountFraction_type, char > discountRateDayCountFraction_traits;

    const discountRateDayCountFraction_optional&
    discountRateDayCountFraction () const;

    discountRateDayCountFraction_optional&
    discountRateDayCountFraction ();

    void
    discountRateDayCountFraction (const discountRateDayCountFraction_type& x);

    void
    discountRateDayCountFraction (const discountRateDayCountFraction_optional& x);

    void
    discountRateDayCountFraction (::std::auto_ptr< discountRateDayCountFraction_type > p);

    // Constructors.
    //
    Discounting (const discountingType_type&);

    Discounting (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    Discounting (const Discounting& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual Discounting*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Discounting ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< discountingType_type > discountingType_;
    discountRate_optional discountRate_;
    discountRateDayCountFraction_optional discountRateDayCountFraction_;
  };

  class EarlyTerminationEvent: public ::xml_schema::type
  {
    public:
    // adjustedExerciseDate
    // 
    typedef ::xml_schema::date adjustedExerciseDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedExerciseDate_type, char > adjustedExerciseDate_traits;

    const adjustedExerciseDate_type&
    adjustedExerciseDate () const;

    adjustedExerciseDate_type&
    adjustedExerciseDate ();

    void
    adjustedExerciseDate (const adjustedExerciseDate_type& x);

    void
    adjustedExerciseDate (::std::auto_ptr< adjustedExerciseDate_type > p);

    // adjustedEarlyTerminationDate
    // 
    typedef ::xml_schema::date adjustedEarlyTerminationDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedEarlyTerminationDate_type, char > adjustedEarlyTerminationDate_traits;

    const adjustedEarlyTerminationDate_type&
    adjustedEarlyTerminationDate () const;

    adjustedEarlyTerminationDate_type&
    adjustedEarlyTerminationDate ();

    void
    adjustedEarlyTerminationDate (const adjustedEarlyTerminationDate_type& x);

    void
    adjustedEarlyTerminationDate (::std::auto_ptr< adjustedEarlyTerminationDate_type > p);

    // adjustedCashSettlementValuationDate
    // 
    typedef ::xml_schema::date adjustedCashSettlementValuationDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedCashSettlementValuationDate_type, char > adjustedCashSettlementValuationDate_traits;

    const adjustedCashSettlementValuationDate_type&
    adjustedCashSettlementValuationDate () const;

    adjustedCashSettlementValuationDate_type&
    adjustedCashSettlementValuationDate ();

    void
    adjustedCashSettlementValuationDate (const adjustedCashSettlementValuationDate_type& x);

    void
    adjustedCashSettlementValuationDate (::std::auto_ptr< adjustedCashSettlementValuationDate_type > p);

    // adjustedCashSettlementPaymentDate
    // 
    typedef ::xml_schema::date adjustedCashSettlementPaymentDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedCashSettlementPaymentDate_type, char > adjustedCashSettlementPaymentDate_traits;

    const adjustedCashSettlementPaymentDate_type&
    adjustedCashSettlementPaymentDate () const;

    adjustedCashSettlementPaymentDate_type&
    adjustedCashSettlementPaymentDate ();

    void
    adjustedCashSettlementPaymentDate (const adjustedCashSettlementPaymentDate_type& x);

    void
    adjustedCashSettlementPaymentDate (::std::auto_ptr< adjustedCashSettlementPaymentDate_type > p);

    // adjustedExerciseFeePaymentDate
    // 
    typedef ::xml_schema::date adjustedExerciseFeePaymentDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedExerciseFeePaymentDate_type > adjustedExerciseFeePaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedExerciseFeePaymentDate_type, char > adjustedExerciseFeePaymentDate_traits;

    const adjustedExerciseFeePaymentDate_optional&
    adjustedExerciseFeePaymentDate () const;

    adjustedExerciseFeePaymentDate_optional&
    adjustedExerciseFeePaymentDate ();

    void
    adjustedExerciseFeePaymentDate (const adjustedExerciseFeePaymentDate_type& x);

    void
    adjustedExerciseFeePaymentDate (const adjustedExerciseFeePaymentDate_optional& x);

    void
    adjustedExerciseFeePaymentDate (::std::auto_ptr< adjustedExerciseFeePaymentDate_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    EarlyTerminationEvent (const adjustedExerciseDate_type&,
                           const adjustedEarlyTerminationDate_type&,
                           const adjustedCashSettlementValuationDate_type&,
                           const adjustedCashSettlementPaymentDate_type&);

    EarlyTerminationEvent (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    EarlyTerminationEvent (const EarlyTerminationEvent& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual EarlyTerminationEvent*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EarlyTerminationEvent ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< adjustedExerciseDate_type > adjustedExerciseDate_;
    ::xsd::cxx::tree::one< adjustedEarlyTerminationDate_type > adjustedEarlyTerminationDate_;
    ::xsd::cxx::tree::one< adjustedCashSettlementValuationDate_type > adjustedCashSettlementValuationDate_;
    ::xsd::cxx::tree::one< adjustedCashSettlementPaymentDate_type > adjustedCashSettlementPaymentDate_;
    adjustedExerciseFeePaymentDate_optional adjustedExerciseFeePaymentDate_;
    id_optional id_;
  };

  class EarlyTerminationProvision: public ::xml_schema::type
  {
    public:
    // mandatoryEarlyTermination
    // 
    typedef ::FpML_4_2::MandatoryEarlyTermination mandatoryEarlyTermination_type;
    typedef ::xsd::cxx::tree::optional< mandatoryEarlyTermination_type > mandatoryEarlyTermination_optional;
    typedef ::xsd::cxx::tree::traits< mandatoryEarlyTermination_type, char > mandatoryEarlyTermination_traits;

    const mandatoryEarlyTermination_optional&
    mandatoryEarlyTermination () const;

    mandatoryEarlyTermination_optional&
    mandatoryEarlyTermination ();

    void
    mandatoryEarlyTermination (const mandatoryEarlyTermination_type& x);

    void
    mandatoryEarlyTermination (const mandatoryEarlyTermination_optional& x);

    void
    mandatoryEarlyTermination (::std::auto_ptr< mandatoryEarlyTermination_type > p);

    // mandatoryEarlyTerminationDateTenor
    // 
    typedef ::FpML_4_2::Interval mandatoryEarlyTerminationDateTenor_type;
    typedef ::xsd::cxx::tree::optional< mandatoryEarlyTerminationDateTenor_type > mandatoryEarlyTerminationDateTenor_optional;
    typedef ::xsd::cxx::tree::traits< mandatoryEarlyTerminationDateTenor_type, char > mandatoryEarlyTerminationDateTenor_traits;

    const mandatoryEarlyTerminationDateTenor_optional&
    mandatoryEarlyTerminationDateTenor () const;

    mandatoryEarlyTerminationDateTenor_optional&
    mandatoryEarlyTerminationDateTenor ();

    void
    mandatoryEarlyTerminationDateTenor (const mandatoryEarlyTerminationDateTenor_type& x);

    void
    mandatoryEarlyTerminationDateTenor (const mandatoryEarlyTerminationDateTenor_optional& x);

    void
    mandatoryEarlyTerminationDateTenor (::std::auto_ptr< mandatoryEarlyTerminationDateTenor_type > p);

    // optionalEarlyTermination
    // 
    typedef ::FpML_4_2::OptionalEarlyTermination optionalEarlyTermination_type;
    typedef ::xsd::cxx::tree::optional< optionalEarlyTermination_type > optionalEarlyTermination_optional;
    typedef ::xsd::cxx::tree::traits< optionalEarlyTermination_type, char > optionalEarlyTermination_traits;

    const optionalEarlyTermination_optional&
    optionalEarlyTermination () const;

    optionalEarlyTermination_optional&
    optionalEarlyTermination ();

    void
    optionalEarlyTermination (const optionalEarlyTermination_type& x);

    void
    optionalEarlyTermination (const optionalEarlyTermination_optional& x);

    void
    optionalEarlyTermination (::std::auto_ptr< optionalEarlyTermination_type > p);

    // optionalEarlyTerminationParameters
    // 
    typedef ::FpML_4_2::ExercisePeriod optionalEarlyTerminationParameters_type;
    typedef ::xsd::cxx::tree::optional< optionalEarlyTerminationParameters_type > optionalEarlyTerminationParameters_optional;
    typedef ::xsd::cxx::tree::traits< optionalEarlyTerminationParameters_type, char > optionalEarlyTerminationParameters_traits;

    const optionalEarlyTerminationParameters_optional&
    optionalEarlyTerminationParameters () const;

    optionalEarlyTerminationParameters_optional&
    optionalEarlyTerminationParameters ();

    void
    optionalEarlyTerminationParameters (const optionalEarlyTerminationParameters_type& x);

    void
    optionalEarlyTerminationParameters (const optionalEarlyTerminationParameters_optional& x);

    void
    optionalEarlyTerminationParameters (::std::auto_ptr< optionalEarlyTerminationParameters_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    EarlyTerminationProvision ();

    EarlyTerminationProvision (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    EarlyTerminationProvision (const EarlyTerminationProvision& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual EarlyTerminationProvision*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EarlyTerminationProvision ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    mandatoryEarlyTermination_optional mandatoryEarlyTermination_;
    mandatoryEarlyTerminationDateTenor_optional mandatoryEarlyTerminationDateTenor_;
    optionalEarlyTermination_optional optionalEarlyTermination_;
    optionalEarlyTerminationParameters_optional optionalEarlyTerminationParameters_;
    id_optional id_;
  };

  class ExerciseEvent: public ::xml_schema::type
  {
    public:
    // adjustedExerciseDate
    // 
    typedef ::xml_schema::date adjustedExerciseDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedExerciseDate_type, char > adjustedExerciseDate_traits;

    const adjustedExerciseDate_type&
    adjustedExerciseDate () const;

    adjustedExerciseDate_type&
    adjustedExerciseDate ();

    void
    adjustedExerciseDate (const adjustedExerciseDate_type& x);

    void
    adjustedExerciseDate (::std::auto_ptr< adjustedExerciseDate_type > p);

    // adjustedRelevantSwapEffectiveDate
    // 
    typedef ::xml_schema::date adjustedRelevantSwapEffectiveDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedRelevantSwapEffectiveDate_type, char > adjustedRelevantSwapEffectiveDate_traits;

    const adjustedRelevantSwapEffectiveDate_type&
    adjustedRelevantSwapEffectiveDate () const;

    adjustedRelevantSwapEffectiveDate_type&
    adjustedRelevantSwapEffectiveDate ();

    void
    adjustedRelevantSwapEffectiveDate (const adjustedRelevantSwapEffectiveDate_type& x);

    void
    adjustedRelevantSwapEffectiveDate (::std::auto_ptr< adjustedRelevantSwapEffectiveDate_type > p);

    // adjustedCashSettlementValuationDate
    // 
    typedef ::xml_schema::date adjustedCashSettlementValuationDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedCashSettlementValuationDate_type > adjustedCashSettlementValuationDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedCashSettlementValuationDate_type, char > adjustedCashSettlementValuationDate_traits;

    const adjustedCashSettlementValuationDate_optional&
    adjustedCashSettlementValuationDate () const;

    adjustedCashSettlementValuationDate_optional&
    adjustedCashSettlementValuationDate ();

    void
    adjustedCashSettlementValuationDate (const adjustedCashSettlementValuationDate_type& x);

    void
    adjustedCashSettlementValuationDate (const adjustedCashSettlementValuationDate_optional& x);

    void
    adjustedCashSettlementValuationDate (::std::auto_ptr< adjustedCashSettlementValuationDate_type > p);

    // adjustedCashSettlementPaymentDate
    // 
    typedef ::xml_schema::date adjustedCashSettlementPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedCashSettlementPaymentDate_type > adjustedCashSettlementPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedCashSettlementPaymentDate_type, char > adjustedCashSettlementPaymentDate_traits;

    const adjustedCashSettlementPaymentDate_optional&
    adjustedCashSettlementPaymentDate () const;

    adjustedCashSettlementPaymentDate_optional&
    adjustedCashSettlementPaymentDate ();

    void
    adjustedCashSettlementPaymentDate (const adjustedCashSettlementPaymentDate_type& x);

    void
    adjustedCashSettlementPaymentDate (const adjustedCashSettlementPaymentDate_optional& x);

    void
    adjustedCashSettlementPaymentDate (::std::auto_ptr< adjustedCashSettlementPaymentDate_type > p);

    // adjustedExerciseFeePaymentDate
    // 
    typedef ::xml_schema::date adjustedExerciseFeePaymentDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedExerciseFeePaymentDate_type > adjustedExerciseFeePaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedExerciseFeePaymentDate_type, char > adjustedExerciseFeePaymentDate_traits;

    const adjustedExerciseFeePaymentDate_optional&
    adjustedExerciseFeePaymentDate () const;

    adjustedExerciseFeePaymentDate_optional&
    adjustedExerciseFeePaymentDate ();

    void
    adjustedExerciseFeePaymentDate (const adjustedExerciseFeePaymentDate_type& x);

    void
    adjustedExerciseFeePaymentDate (const adjustedExerciseFeePaymentDate_optional& x);

    void
    adjustedExerciseFeePaymentDate (::std::auto_ptr< adjustedExerciseFeePaymentDate_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    ExerciseEvent (const adjustedExerciseDate_type&,
                   const adjustedRelevantSwapEffectiveDate_type&);

    ExerciseEvent (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    ExerciseEvent (const ExerciseEvent& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual ExerciseEvent*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExerciseEvent ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< adjustedExerciseDate_type > adjustedExerciseDate_;
    ::xsd::cxx::tree::one< adjustedRelevantSwapEffectiveDate_type > adjustedRelevantSwapEffectiveDate_;
    adjustedCashSettlementValuationDate_optional adjustedCashSettlementValuationDate_;
    adjustedCashSettlementPaymentDate_optional adjustedCashSettlementPaymentDate_;
    adjustedExerciseFeePaymentDate_optional adjustedExerciseFeePaymentDate_;
    id_optional id_;
  };

  class ExercisePeriod: public ::xml_schema::type
  {
    public:
    // earliestExerciseDateTenor
    // 
    typedef ::FpML_4_2::Interval earliestExerciseDateTenor_type;
    typedef ::xsd::cxx::tree::traits< earliestExerciseDateTenor_type, char > earliestExerciseDateTenor_traits;

    const earliestExerciseDateTenor_type&
    earliestExerciseDateTenor () const;

    earliestExerciseDateTenor_type&
    earliestExerciseDateTenor ();

    void
    earliestExerciseDateTenor (const earliestExerciseDateTenor_type& x);

    void
    earliestExerciseDateTenor (::std::auto_ptr< earliestExerciseDateTenor_type > p);

    // exerciseFrequency
    // 
    typedef ::FpML_4_2::Interval exerciseFrequency_type;
    typedef ::xsd::cxx::tree::optional< exerciseFrequency_type > exerciseFrequency_optional;
    typedef ::xsd::cxx::tree::traits< exerciseFrequency_type, char > exerciseFrequency_traits;

    const exerciseFrequency_optional&
    exerciseFrequency () const;

    exerciseFrequency_optional&
    exerciseFrequency ();

    void
    exerciseFrequency (const exerciseFrequency_type& x);

    void
    exerciseFrequency (const exerciseFrequency_optional& x);

    void
    exerciseFrequency (::std::auto_ptr< exerciseFrequency_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    ExercisePeriod (const earliestExerciseDateTenor_type&);

    ExercisePeriod (::std::auto_ptr< earliestExerciseDateTenor_type >&);

    ExercisePeriod (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ExercisePeriod (const ExercisePeriod& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ExercisePeriod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExercisePeriod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< earliestExerciseDateTenor_type > earliestExerciseDateTenor_;
    exerciseFrequency_optional exerciseFrequency_;
    id_optional id_;
  };

  class ExtendibleProvision: public ::xml_schema::type
  {
    public:
    // buyerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference buyerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< buyerPartyReference_type, char > buyerPartyReference_traits;

    const buyerPartyReference_type&
    buyerPartyReference () const;

    buyerPartyReference_type&
    buyerPartyReference ();

    void
    buyerPartyReference (const buyerPartyReference_type& x);

    void
    buyerPartyReference (::std::auto_ptr< buyerPartyReference_type > p);

    // sellerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference sellerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< sellerPartyReference_type, char > sellerPartyReference_traits;

    const sellerPartyReference_type&
    sellerPartyReference () const;

    sellerPartyReference_type&
    sellerPartyReference ();

    void
    sellerPartyReference (const sellerPartyReference_type& x);

    void
    sellerPartyReference (::std::auto_ptr< sellerPartyReference_type > p);

    // exercise
    // 
    typedef ::FpML_4_2::Exercise exercise_type;
    typedef ::xsd::cxx::tree::traits< exercise_type, char > exercise_traits;

    const exercise_type&
    exercise () const;

    exercise_type&
    exercise ();

    void
    exercise (const exercise_type& x);

    void
    exercise (::std::auto_ptr< exercise_type > p);

    // exerciseNotice
    // 
    typedef ::FpML_4_2::ExerciseNotice exerciseNotice_type;
    typedef ::xsd::cxx::tree::optional< exerciseNotice_type > exerciseNotice_optional;
    typedef ::xsd::cxx::tree::traits< exerciseNotice_type, char > exerciseNotice_traits;

    const exerciseNotice_optional&
    exerciseNotice () const;

    exerciseNotice_optional&
    exerciseNotice ();

    void
    exerciseNotice (const exerciseNotice_type& x);

    void
    exerciseNotice (const exerciseNotice_optional& x);

    void
    exerciseNotice (::std::auto_ptr< exerciseNotice_type > p);

    // followUpConfirmation
    // 
    typedef ::xml_schema::boolean followUpConfirmation_type;
    typedef ::xsd::cxx::tree::traits< followUpConfirmation_type, char > followUpConfirmation_traits;

    const followUpConfirmation_type&
    followUpConfirmation () const;

    followUpConfirmation_type&
    followUpConfirmation ();

    void
    followUpConfirmation (const followUpConfirmation_type& x);

    // extendibleProvisionAdjustedDates
    // 
    typedef ::FpML_4_2::ExtendibleProvisionAdjustedDates extendibleProvisionAdjustedDates_type;
    typedef ::xsd::cxx::tree::optional< extendibleProvisionAdjustedDates_type > extendibleProvisionAdjustedDates_optional;
    typedef ::xsd::cxx::tree::traits< extendibleProvisionAdjustedDates_type, char > extendibleProvisionAdjustedDates_traits;

    const extendibleProvisionAdjustedDates_optional&
    extendibleProvisionAdjustedDates () const;

    extendibleProvisionAdjustedDates_optional&
    extendibleProvisionAdjustedDates ();

    void
    extendibleProvisionAdjustedDates (const extendibleProvisionAdjustedDates_type& x);

    void
    extendibleProvisionAdjustedDates (const extendibleProvisionAdjustedDates_optional& x);

    void
    extendibleProvisionAdjustedDates (::std::auto_ptr< extendibleProvisionAdjustedDates_type > p);

    // Constructors.
    //
    ExtendibleProvision (const buyerPartyReference_type&,
                         const sellerPartyReference_type&,
                         const exercise_type&,
                         const followUpConfirmation_type&);

    ExtendibleProvision (::std::auto_ptr< buyerPartyReference_type >&,
                         ::std::auto_ptr< sellerPartyReference_type >&,
                         ::std::auto_ptr< exercise_type >&,
                         const followUpConfirmation_type&);

    ExtendibleProvision (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ExtendibleProvision (const ExtendibleProvision& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual ExtendibleProvision*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExtendibleProvision ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< buyerPartyReference_type > buyerPartyReference_;
    ::xsd::cxx::tree::one< sellerPartyReference_type > sellerPartyReference_;
    ::xsd::cxx::tree::one< exercise_type > exercise_;
    exerciseNotice_optional exerciseNotice_;
    ::xsd::cxx::tree::one< followUpConfirmation_type > followUpConfirmation_;
    extendibleProvisionAdjustedDates_optional extendibleProvisionAdjustedDates_;
  };

  class ExtendibleProvisionAdjustedDates: public ::xml_schema::type
  {
    public:
    // extensionEvent
    // 
    typedef ::FpML_4_2::ExtensionEvent extensionEvent_type;
    typedef ::xsd::cxx::tree::sequence< extensionEvent_type > extensionEvent_sequence;
    typedef extensionEvent_sequence::iterator extensionEvent_iterator;
    typedef extensionEvent_sequence::const_iterator extensionEvent_const_iterator;
    typedef ::xsd::cxx::tree::traits< extensionEvent_type, char > extensionEvent_traits;

    const extensionEvent_sequence&
    extensionEvent () const;

    extensionEvent_sequence&
    extensionEvent ();

    void
    extensionEvent (const extensionEvent_sequence& s);

    // Constructors.
    //
    ExtendibleProvisionAdjustedDates ();

    ExtendibleProvisionAdjustedDates (const ::xercesc::DOMElement& e,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    ExtendibleProvisionAdjustedDates (const ExtendibleProvisionAdjustedDates& x,
                                      ::xml_schema::flags f = 0,
                                      ::xml_schema::container* c = 0);

    virtual ExtendibleProvisionAdjustedDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExtendibleProvisionAdjustedDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    extensionEvent_sequence extensionEvent_;
  };

  class ExtensionEvent: public ::xml_schema::type
  {
    public:
    // adjustedExerciseDate
    // 
    typedef ::xml_schema::date adjustedExerciseDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedExerciseDate_type, char > adjustedExerciseDate_traits;

    const adjustedExerciseDate_type&
    adjustedExerciseDate () const;

    adjustedExerciseDate_type&
    adjustedExerciseDate ();

    void
    adjustedExerciseDate (const adjustedExerciseDate_type& x);

    void
    adjustedExerciseDate (::std::auto_ptr< adjustedExerciseDate_type > p);

    // adjustedExtendedTerminationDate
    // 
    typedef ::xml_schema::date adjustedExtendedTerminationDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedExtendedTerminationDate_type, char > adjustedExtendedTerminationDate_traits;

    const adjustedExtendedTerminationDate_type&
    adjustedExtendedTerminationDate () const;

    adjustedExtendedTerminationDate_type&
    adjustedExtendedTerminationDate ();

    void
    adjustedExtendedTerminationDate (const adjustedExtendedTerminationDate_type& x);

    void
    adjustedExtendedTerminationDate (::std::auto_ptr< adjustedExtendedTerminationDate_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    ExtensionEvent (const adjustedExerciseDate_type&,
                    const adjustedExtendedTerminationDate_type&);

    ExtensionEvent (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ExtensionEvent (const ExtensionEvent& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ExtensionEvent*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExtensionEvent ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< adjustedExerciseDate_type > adjustedExerciseDate_;
    ::xsd::cxx::tree::one< adjustedExtendedTerminationDate_type > adjustedExtendedTerminationDate_;
    id_optional id_;
  };

  class FloatingRateDefinition: public ::xml_schema::type
  {
    public:
    // calculatedRate
    // 
    typedef ::xml_schema::decimal calculatedRate_type;
    typedef ::xsd::cxx::tree::optional< calculatedRate_type > calculatedRate_optional;
    typedef ::xsd::cxx::tree::traits< calculatedRate_type, char, ::xsd::cxx::tree::schema_type::decimal > calculatedRate_traits;

    const calculatedRate_optional&
    calculatedRate () const;

    calculatedRate_optional&
    calculatedRate ();

    void
    calculatedRate (const calculatedRate_type& x);

    void
    calculatedRate (const calculatedRate_optional& x);

    // rateObservation
    // 
    typedef ::FpML_4_2::RateObservation rateObservation_type;
    typedef ::xsd::cxx::tree::sequence< rateObservation_type > rateObservation_sequence;
    typedef rateObservation_sequence::iterator rateObservation_iterator;
    typedef rateObservation_sequence::const_iterator rateObservation_const_iterator;
    typedef ::xsd::cxx::tree::traits< rateObservation_type, char > rateObservation_traits;

    const rateObservation_sequence&
    rateObservation () const;

    rateObservation_sequence&
    rateObservation ();

    void
    rateObservation (const rateObservation_sequence& s);

    // floatingRateMultiplier
    // 
    typedef ::xml_schema::decimal floatingRateMultiplier_type;
    typedef ::xsd::cxx::tree::optional< floatingRateMultiplier_type > floatingRateMultiplier_optional;
    typedef ::xsd::cxx::tree::traits< floatingRateMultiplier_type, char, ::xsd::cxx::tree::schema_type::decimal > floatingRateMultiplier_traits;

    const floatingRateMultiplier_optional&
    floatingRateMultiplier () const;

    floatingRateMultiplier_optional&
    floatingRateMultiplier ();

    void
    floatingRateMultiplier (const floatingRateMultiplier_type& x);

    void
    floatingRateMultiplier (const floatingRateMultiplier_optional& x);

    // spread
    // 
    typedef ::xml_schema::decimal spread_type;
    typedef ::xsd::cxx::tree::optional< spread_type > spread_optional;
    typedef ::xsd::cxx::tree::traits< spread_type, char, ::xsd::cxx::tree::schema_type::decimal > spread_traits;

    const spread_optional&
    spread () const;

    spread_optional&
    spread ();

    void
    spread (const spread_type& x);

    void
    spread (const spread_optional& x);

    // capRate
    // 
    typedef ::FpML_4_2::Strike capRate_type;
    typedef ::xsd::cxx::tree::sequence< capRate_type > capRate_sequence;
    typedef capRate_sequence::iterator capRate_iterator;
    typedef capRate_sequence::const_iterator capRate_const_iterator;
    typedef ::xsd::cxx::tree::traits< capRate_type, char > capRate_traits;

    const capRate_sequence&
    capRate () const;

    capRate_sequence&
    capRate ();

    void
    capRate (const capRate_sequence& s);

    // floorRate
    // 
    typedef ::FpML_4_2::Strike floorRate_type;
    typedef ::xsd::cxx::tree::sequence< floorRate_type > floorRate_sequence;
    typedef floorRate_sequence::iterator floorRate_iterator;
    typedef floorRate_sequence::const_iterator floorRate_const_iterator;
    typedef ::xsd::cxx::tree::traits< floorRate_type, char > floorRate_traits;

    const floorRate_sequence&
    floorRate () const;

    floorRate_sequence&
    floorRate ();

    void
    floorRate (const floorRate_sequence& s);

    // Constructors.
    //
    FloatingRateDefinition ();

    FloatingRateDefinition (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    FloatingRateDefinition (const FloatingRateDefinition& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual FloatingRateDefinition*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FloatingRateDefinition ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    calculatedRate_optional calculatedRate_;
    rateObservation_sequence rateObservation_;
    floatingRateMultiplier_optional floatingRateMultiplier_;
    spread_optional spread_;
    capRate_sequence capRate_;
    floorRate_sequence floorRate_;
  };

  class Fra: public ::FpML_4_2::Product
  {
    public:
    // buyerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference buyerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< buyerPartyReference_type, char > buyerPartyReference_traits;

    const buyerPartyReference_type&
    buyerPartyReference () const;

    buyerPartyReference_type&
    buyerPartyReference ();

    void
    buyerPartyReference (const buyerPartyReference_type& x);

    void
    buyerPartyReference (::std::auto_ptr< buyerPartyReference_type > p);

    // sellerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference sellerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< sellerPartyReference_type, char > sellerPartyReference_traits;

    const sellerPartyReference_type&
    sellerPartyReference () const;

    sellerPartyReference_type&
    sellerPartyReference ();

    void
    sellerPartyReference (const sellerPartyReference_type& x);

    void
    sellerPartyReference (::std::auto_ptr< sellerPartyReference_type > p);

    // adjustedEffectiveDate
    // 
    typedef ::FpML_4_2::RequiredIdentifierDate adjustedEffectiveDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedEffectiveDate_type, char > adjustedEffectiveDate_traits;

    const adjustedEffectiveDate_type&
    adjustedEffectiveDate () const;

    adjustedEffectiveDate_type&
    adjustedEffectiveDate ();

    void
    adjustedEffectiveDate (const adjustedEffectiveDate_type& x);

    void
    adjustedEffectiveDate (::std::auto_ptr< adjustedEffectiveDate_type > p);

    // adjustedTerminationDate
    // 
    typedef ::xml_schema::date adjustedTerminationDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedTerminationDate_type, char > adjustedTerminationDate_traits;

    const adjustedTerminationDate_type&
    adjustedTerminationDate () const;

    adjustedTerminationDate_type&
    adjustedTerminationDate ();

    void
    adjustedTerminationDate (const adjustedTerminationDate_type& x);

    void
    adjustedTerminationDate (::std::auto_ptr< adjustedTerminationDate_type > p);

    // paymentDate
    // 
    typedef ::FpML_4_2::AdjustableDate paymentDate_type;
    typedef ::xsd::cxx::tree::traits< paymentDate_type, char > paymentDate_traits;

    const paymentDate_type&
    paymentDate () const;

    paymentDate_type&
    paymentDate ();

    void
    paymentDate (const paymentDate_type& x);

    void
    paymentDate (::std::auto_ptr< paymentDate_type > p);

    // fixingDateOffset
    // 
    typedef ::FpML_4_2::RelativeDateOffset fixingDateOffset_type;
    typedef ::xsd::cxx::tree::traits< fixingDateOffset_type, char > fixingDateOffset_traits;

    const fixingDateOffset_type&
    fixingDateOffset () const;

    fixingDateOffset_type&
    fixingDateOffset ();

    void
    fixingDateOffset (const fixingDateOffset_type& x);

    void
    fixingDateOffset (::std::auto_ptr< fixingDateOffset_type > p);

    // dayCountFraction
    // 
    typedef ::FpML_4_2::DayCountFraction dayCountFraction_type;
    typedef ::xsd::cxx::tree::traits< dayCountFraction_type, char > dayCountFraction_traits;

    const dayCountFraction_type&
    dayCountFraction () const;

    dayCountFraction_type&
    dayCountFraction ();

    void
    dayCountFraction (const dayCountFraction_type& x);

    void
    dayCountFraction (::std::auto_ptr< dayCountFraction_type > p);

    // calculationPeriodNumberOfDays
    // 
    typedef ::xml_schema::positive_integer calculationPeriodNumberOfDays_type;
    typedef ::xsd::cxx::tree::traits< calculationPeriodNumberOfDays_type, char > calculationPeriodNumberOfDays_traits;

    const calculationPeriodNumberOfDays_type&
    calculationPeriodNumberOfDays () const;

    calculationPeriodNumberOfDays_type&
    calculationPeriodNumberOfDays ();

    void
    calculationPeriodNumberOfDays (const calculationPeriodNumberOfDays_type& x);

    // notional
    // 
    typedef ::FpML_4_2::Money notional_type;
    typedef ::xsd::cxx::tree::traits< notional_type, char > notional_traits;

    const notional_type&
    notional () const;

    notional_type&
    notional ();

    void
    notional (const notional_type& x);

    void
    notional (::std::auto_ptr< notional_type > p);

    // fixedRate
    // 
    typedef ::xml_schema::decimal fixedRate_type;
    typedef ::xsd::cxx::tree::traits< fixedRate_type, char, ::xsd::cxx::tree::schema_type::decimal > fixedRate_traits;

    const fixedRate_type&
    fixedRate () const;

    fixedRate_type&
    fixedRate ();

    void
    fixedRate (const fixedRate_type& x);

    // floatingRateIndex
    // 
    typedef ::FpML_4_2::FloatingRateIndex floatingRateIndex_type;
    typedef ::xsd::cxx::tree::traits< floatingRateIndex_type, char > floatingRateIndex_traits;

    const floatingRateIndex_type&
    floatingRateIndex () const;

    floatingRateIndex_type&
    floatingRateIndex ();

    void
    floatingRateIndex (const floatingRateIndex_type& x);

    void
    floatingRateIndex (::std::auto_ptr< floatingRateIndex_type > p);

    // indexTenor
    // 
    typedef ::FpML_4_2::Interval indexTenor_type;
    typedef ::xsd::cxx::tree::sequence< indexTenor_type > indexTenor_sequence;
    typedef indexTenor_sequence::iterator indexTenor_iterator;
    typedef indexTenor_sequence::const_iterator indexTenor_const_iterator;
    typedef ::xsd::cxx::tree::traits< indexTenor_type, char > indexTenor_traits;

    const indexTenor_sequence&
    indexTenor () const;

    indexTenor_sequence&
    indexTenor ();

    void
    indexTenor (const indexTenor_sequence& s);

    // fraDiscounting
    // 
    typedef ::FpML_4_2::FraDiscountingEnum fraDiscounting_type;
    typedef ::xsd::cxx::tree::traits< fraDiscounting_type, char > fraDiscounting_traits;

    const fraDiscounting_type&
    fraDiscounting () const;

    fraDiscounting_type&
    fraDiscounting ();

    void
    fraDiscounting (const fraDiscounting_type& x);

    void
    fraDiscounting (::std::auto_ptr< fraDiscounting_type > p);

    // Constructors.
    //
    Fra (const buyerPartyReference_type&,
         const sellerPartyReference_type&,
         const adjustedEffectiveDate_type&,
         const adjustedTerminationDate_type&,
         const paymentDate_type&,
         const fixingDateOffset_type&,
         const dayCountFraction_type&,
         const calculationPeriodNumberOfDays_type&,
         const notional_type&,
         const fixedRate_type&,
         const floatingRateIndex_type&,
         const fraDiscounting_type&);

    Fra (::std::auto_ptr< buyerPartyReference_type >&,
         ::std::auto_ptr< sellerPartyReference_type >&,
         ::std::auto_ptr< adjustedEffectiveDate_type >&,
         const adjustedTerminationDate_type&,
         ::std::auto_ptr< paymentDate_type >&,
         ::std::auto_ptr< fixingDateOffset_type >&,
         ::std::auto_ptr< dayCountFraction_type >&,
         const calculationPeriodNumberOfDays_type&,
         ::std::auto_ptr< notional_type >&,
         const fixedRate_type&,
         ::std::auto_ptr< floatingRateIndex_type >&,
         const fraDiscounting_type&);

    Fra (const ::xercesc::DOMElement& e,
         ::xml_schema::flags f = 0,
         ::xml_schema::container* c = 0);

    Fra (const Fra& x,
         ::xml_schema::flags f = 0,
         ::xml_schema::container* c = 0);

    virtual Fra*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Fra ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< buyerPartyReference_type > buyerPartyReference_;
    ::xsd::cxx::tree::one< sellerPartyReference_type > sellerPartyReference_;
    ::xsd::cxx::tree::one< adjustedEffectiveDate_type > adjustedEffectiveDate_;
    ::xsd::cxx::tree::one< adjustedTerminationDate_type > adjustedTerminationDate_;
    ::xsd::cxx::tree::one< paymentDate_type > paymentDate_;
    ::xsd::cxx::tree::one< fixingDateOffset_type > fixingDateOffset_;
    ::xsd::cxx::tree::one< dayCountFraction_type > dayCountFraction_;
    ::xsd::cxx::tree::one< calculationPeriodNumberOfDays_type > calculationPeriodNumberOfDays_;
    ::xsd::cxx::tree::one< notional_type > notional_;
    ::xsd::cxx::tree::one< fixedRate_type > fixedRate_;
    ::xsd::cxx::tree::one< floatingRateIndex_type > floatingRateIndex_;
    indexTenor_sequence indexTenor_;
    ::xsd::cxx::tree::one< fraDiscounting_type > fraDiscounting_;
  };

  class FxFixingDate: public ::FpML_4_2::Offset
  {
    public:
    // businessDayConvention
    // 
    typedef ::FpML_4_2::BusinessDayConventionEnum businessDayConvention_type;
    typedef ::xsd::cxx::tree::traits< businessDayConvention_type, char > businessDayConvention_traits;

    const businessDayConvention_type&
    businessDayConvention () const;

    businessDayConvention_type&
    businessDayConvention ();

    void
    businessDayConvention (const businessDayConvention_type& x);

    void
    businessDayConvention (::std::auto_ptr< businessDayConvention_type > p);

    // businessCentersReference
    // 
    typedef ::FpML_4_2::BusinessCentersReference businessCentersReference_type;
    typedef ::xsd::cxx::tree::optional< businessCentersReference_type > businessCentersReference_optional;
    typedef ::xsd::cxx::tree::traits< businessCentersReference_type, char > businessCentersReference_traits;

    const businessCentersReference_optional&
    businessCentersReference () const;

    businessCentersReference_optional&
    businessCentersReference ();

    void
    businessCentersReference (const businessCentersReference_type& x);

    void
    businessCentersReference (const businessCentersReference_optional& x);

    void
    businessCentersReference (::std::auto_ptr< businessCentersReference_type > p);

    // businessCenters
    // 
    typedef ::FpML_4_2::BusinessCenters businessCenters_type;
    typedef ::xsd::cxx::tree::optional< businessCenters_type > businessCenters_optional;
    typedef ::xsd::cxx::tree::traits< businessCenters_type, char > businessCenters_traits;

    const businessCenters_optional&
    businessCenters () const;

    businessCenters_optional&
    businessCenters ();

    void
    businessCenters (const businessCenters_type& x);

    void
    businessCenters (const businessCenters_optional& x);

    void
    businessCenters (::std::auto_ptr< businessCenters_type > p);

    // dateRelativeToPaymentDates
    // 
    typedef ::FpML_4_2::DateRelativeToPaymentDates dateRelativeToPaymentDates_type;
    typedef ::xsd::cxx::tree::traits< dateRelativeToPaymentDates_type, char > dateRelativeToPaymentDates_traits;

    const dateRelativeToPaymentDates_type&
    dateRelativeToPaymentDates () const;

    dateRelativeToPaymentDates_type&
    dateRelativeToPaymentDates ();

    void
    dateRelativeToPaymentDates (const dateRelativeToPaymentDates_type& x);

    void
    dateRelativeToPaymentDates (::std::auto_ptr< dateRelativeToPaymentDates_type > p);

    // Constructors.
    //
    FxFixingDate (const periodMultiplier_type&,
                  const period_type&,
                  const businessDayConvention_type&,
                  const dateRelativeToPaymentDates_type&);

    FxFixingDate (const periodMultiplier_type&,
                  const period_type&,
                  const businessDayConvention_type&,
                  ::std::auto_ptr< dateRelativeToPaymentDates_type >&);

    FxFixingDate (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    FxFixingDate (const FxFixingDate& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual FxFixingDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxFixingDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< businessDayConvention_type > businessDayConvention_;
    businessCentersReference_optional businessCentersReference_;
    businessCenters_optional businessCenters_;
    ::xsd::cxx::tree::one< dateRelativeToPaymentDates_type > dateRelativeToPaymentDates_;
  };

  class FxLinkedNotionalAmount: public ::xml_schema::type
  {
    public:
    // resetDate
    // 
    typedef ::xml_schema::date resetDate_type;
    typedef ::xsd::cxx::tree::optional< resetDate_type > resetDate_optional;
    typedef ::xsd::cxx::tree::traits< resetDate_type, char > resetDate_traits;

    const resetDate_optional&
    resetDate () const;

    resetDate_optional&
    resetDate ();

    void
    resetDate (const resetDate_type& x);

    void
    resetDate (const resetDate_optional& x);

    void
    resetDate (::std::auto_ptr< resetDate_type > p);

    // adjustedFxSpotFixingDate
    // 
    typedef ::xml_schema::date adjustedFxSpotFixingDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedFxSpotFixingDate_type > adjustedFxSpotFixingDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedFxSpotFixingDate_type, char > adjustedFxSpotFixingDate_traits;

    const adjustedFxSpotFixingDate_optional&
    adjustedFxSpotFixingDate () const;

    adjustedFxSpotFixingDate_optional&
    adjustedFxSpotFixingDate ();

    void
    adjustedFxSpotFixingDate (const adjustedFxSpotFixingDate_type& x);

    void
    adjustedFxSpotFixingDate (const adjustedFxSpotFixingDate_optional& x);

    void
    adjustedFxSpotFixingDate (::std::auto_ptr< adjustedFxSpotFixingDate_type > p);

    // observedFxSpotRate
    // 
    typedef ::xml_schema::decimal observedFxSpotRate_type;
    typedef ::xsd::cxx::tree::optional< observedFxSpotRate_type > observedFxSpotRate_optional;
    typedef ::xsd::cxx::tree::traits< observedFxSpotRate_type, char, ::xsd::cxx::tree::schema_type::decimal > observedFxSpotRate_traits;

    const observedFxSpotRate_optional&
    observedFxSpotRate () const;

    observedFxSpotRate_optional&
    observedFxSpotRate ();

    void
    observedFxSpotRate (const observedFxSpotRate_type& x);

    void
    observedFxSpotRate (const observedFxSpotRate_optional& x);

    // notionalAmount
    // 
    typedef ::xml_schema::decimal notionalAmount_type;
    typedef ::xsd::cxx::tree::optional< notionalAmount_type > notionalAmount_optional;
    typedef ::xsd::cxx::tree::traits< notionalAmount_type, char, ::xsd::cxx::tree::schema_type::decimal > notionalAmount_traits;

    const notionalAmount_optional&
    notionalAmount () const;

    notionalAmount_optional&
    notionalAmount ();

    void
    notionalAmount (const notionalAmount_type& x);

    void
    notionalAmount (const notionalAmount_optional& x);

    // Constructors.
    //
    FxLinkedNotionalAmount ();

    FxLinkedNotionalAmount (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    FxLinkedNotionalAmount (const FxLinkedNotionalAmount& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual FxLinkedNotionalAmount*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxLinkedNotionalAmount ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    resetDate_optional resetDate_;
    adjustedFxSpotFixingDate_optional adjustedFxSpotFixingDate_;
    observedFxSpotRate_optional observedFxSpotRate_;
    notionalAmount_optional notionalAmount_;
  };

  class FxLinkedNotionalSchedule: public ::xml_schema::type
  {
    public:
    // constantNotionalScheduleReference
    // 
    typedef ::FpML_4_2::ScheduleReference constantNotionalScheduleReference_type;
    typedef ::xsd::cxx::tree::traits< constantNotionalScheduleReference_type, char > constantNotionalScheduleReference_traits;

    const constantNotionalScheduleReference_type&
    constantNotionalScheduleReference () const;

    constantNotionalScheduleReference_type&
    constantNotionalScheduleReference ();

    void
    constantNotionalScheduleReference (const constantNotionalScheduleReference_type& x);

    void
    constantNotionalScheduleReference (::std::auto_ptr< constantNotionalScheduleReference_type > p);

    // initialValue
    // 
    typedef ::xml_schema::decimal initialValue_type;
    typedef ::xsd::cxx::tree::optional< initialValue_type > initialValue_optional;
    typedef ::xsd::cxx::tree::traits< initialValue_type, char, ::xsd::cxx::tree::schema_type::decimal > initialValue_traits;

    const initialValue_optional&
    initialValue () const;

    initialValue_optional&
    initialValue ();

    void
    initialValue (const initialValue_type& x);

    void
    initialValue (const initialValue_optional& x);

    // varyingNotionalCurrency
    // 
    typedef ::xml_schema::string varyingNotionalCurrency_type;
    typedef ::xsd::cxx::tree::traits< varyingNotionalCurrency_type, char > varyingNotionalCurrency_traits;

    const varyingNotionalCurrency_type&
    varyingNotionalCurrency () const;

    varyingNotionalCurrency_type&
    varyingNotionalCurrency ();

    void
    varyingNotionalCurrency (const varyingNotionalCurrency_type& x);

    void
    varyingNotionalCurrency (::std::auto_ptr< varyingNotionalCurrency_type > p);

    // varyingNotionalFixingDates
    // 
    typedef ::FpML_4_2::RelativeDateOffset varyingNotionalFixingDates_type;
    typedef ::xsd::cxx::tree::traits< varyingNotionalFixingDates_type, char > varyingNotionalFixingDates_traits;

    const varyingNotionalFixingDates_type&
    varyingNotionalFixingDates () const;

    varyingNotionalFixingDates_type&
    varyingNotionalFixingDates ();

    void
    varyingNotionalFixingDates (const varyingNotionalFixingDates_type& x);

    void
    varyingNotionalFixingDates (::std::auto_ptr< varyingNotionalFixingDates_type > p);

    // fxSpotRateSource
    // 
    typedef ::FpML_4_2::FxSpotRateSource fxSpotRateSource_type;
    typedef ::xsd::cxx::tree::traits< fxSpotRateSource_type, char > fxSpotRateSource_traits;

    const fxSpotRateSource_type&
    fxSpotRateSource () const;

    fxSpotRateSource_type&
    fxSpotRateSource ();

    void
    fxSpotRateSource (const fxSpotRateSource_type& x);

    void
    fxSpotRateSource (::std::auto_ptr< fxSpotRateSource_type > p);

    // varyingNotionalInterimExchangePaymentDates
    // 
    typedef ::FpML_4_2::RelativeDateOffset varyingNotionalInterimExchangePaymentDates_type;
    typedef ::xsd::cxx::tree::traits< varyingNotionalInterimExchangePaymentDates_type, char > varyingNotionalInterimExchangePaymentDates_traits;

    const varyingNotionalInterimExchangePaymentDates_type&
    varyingNotionalInterimExchangePaymentDates () const;

    varyingNotionalInterimExchangePaymentDates_type&
    varyingNotionalInterimExchangePaymentDates ();

    void
    varyingNotionalInterimExchangePaymentDates (const varyingNotionalInterimExchangePaymentDates_type& x);

    void
    varyingNotionalInterimExchangePaymentDates (::std::auto_ptr< varyingNotionalInterimExchangePaymentDates_type > p);

    // Constructors.
    //
    FxLinkedNotionalSchedule (const constantNotionalScheduleReference_type&,
                              const varyingNotionalCurrency_type&,
                              const varyingNotionalFixingDates_type&,
                              const fxSpotRateSource_type&,
                              const varyingNotionalInterimExchangePaymentDates_type&);

    FxLinkedNotionalSchedule (::std::auto_ptr< constantNotionalScheduleReference_type >&,
                              const varyingNotionalCurrency_type&,
                              ::std::auto_ptr< varyingNotionalFixingDates_type >&,
                              ::std::auto_ptr< fxSpotRateSource_type >&,
                              ::std::auto_ptr< varyingNotionalInterimExchangePaymentDates_type >&);

    FxLinkedNotionalSchedule (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    FxLinkedNotionalSchedule (const FxLinkedNotionalSchedule& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual FxLinkedNotionalSchedule*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxLinkedNotionalSchedule ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< constantNotionalScheduleReference_type > constantNotionalScheduleReference_;
    initialValue_optional initialValue_;
    ::xsd::cxx::tree::one< varyingNotionalCurrency_type > varyingNotionalCurrency_;
    ::xsd::cxx::tree::one< varyingNotionalFixingDates_type > varyingNotionalFixingDates_;
    ::xsd::cxx::tree::one< fxSpotRateSource_type > fxSpotRateSource_;
    ::xsd::cxx::tree::one< varyingNotionalInterimExchangePaymentDates_type > varyingNotionalInterimExchangePaymentDates_;
  };

  class InflationRateCalculation: public ::FpML_4_2::FloatingRateCalculation
  {
    public:
    // inflationLag
    // 
    typedef ::FpML_4_2::Offset inflationLag_type;
    typedef ::xsd::cxx::tree::traits< inflationLag_type, char > inflationLag_traits;

    const inflationLag_type&
    inflationLag () const;

    inflationLag_type&
    inflationLag ();

    void
    inflationLag (const inflationLag_type& x);

    void
    inflationLag (::std::auto_ptr< inflationLag_type > p);

    // indexSource
    // 
    typedef ::FpML_4_2::RateSourcePage indexSource_type;
    typedef ::xsd::cxx::tree::traits< indexSource_type, char > indexSource_traits;

    const indexSource_type&
    indexSource () const;

    indexSource_type&
    indexSource ();

    void
    indexSource (const indexSource_type& x);

    void
    indexSource (::std::auto_ptr< indexSource_type > p);

    // mainPublication
    // 
    typedef ::FpML_4_2::MainPublication mainPublication_type;
    typedef ::xsd::cxx::tree::optional< mainPublication_type > mainPublication_optional;
    typedef ::xsd::cxx::tree::traits< mainPublication_type, char > mainPublication_traits;

    const mainPublication_optional&
    mainPublication () const;

    mainPublication_optional&
    mainPublication ();

    void
    mainPublication (const mainPublication_type& x);

    void
    mainPublication (const mainPublication_optional& x);

    void
    mainPublication (::std::auto_ptr< mainPublication_type > p);

    // interpolationMethod
    // 
    typedef ::FpML_4_2::InterpolationMethod interpolationMethod_type;
    typedef ::xsd::cxx::tree::traits< interpolationMethod_type, char > interpolationMethod_traits;

    const interpolationMethod_type&
    interpolationMethod () const;

    interpolationMethod_type&
    interpolationMethod ();

    void
    interpolationMethod (const interpolationMethod_type& x);

    void
    interpolationMethod (::std::auto_ptr< interpolationMethod_type > p);

    // initialIndexLevel
    // 
    typedef ::xml_schema::decimal initialIndexLevel_type;
    typedef ::xsd::cxx::tree::optional< initialIndexLevel_type > initialIndexLevel_optional;
    typedef ::xsd::cxx::tree::traits< initialIndexLevel_type, char, ::xsd::cxx::tree::schema_type::decimal > initialIndexLevel_traits;

    const initialIndexLevel_optional&
    initialIndexLevel () const;

    initialIndexLevel_optional&
    initialIndexLevel ();

    void
    initialIndexLevel (const initialIndexLevel_type& x);

    void
    initialIndexLevel (const initialIndexLevel_optional& x);

    // Constructors.
    //
    InflationRateCalculation (const floatingRateIndex_type&,
                              const inflationLag_type&,
                              const indexSource_type&,
                              const interpolationMethod_type&);

    InflationRateCalculation (::std::auto_ptr< floatingRateIndex_type >&,
                              ::std::auto_ptr< inflationLag_type >&,
                              ::std::auto_ptr< indexSource_type >&,
                              ::std::auto_ptr< interpolationMethod_type >&);

    InflationRateCalculation (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    InflationRateCalculation (const InflationRateCalculation& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual InflationRateCalculation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InflationRateCalculation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< inflationLag_type > inflationLag_;
    ::xsd::cxx::tree::one< indexSource_type > indexSource_;
    mainPublication_optional mainPublication_;
    ::xsd::cxx::tree::one< interpolationMethod_type > interpolationMethod_;
    initialIndexLevel_optional initialIndexLevel_;
  };

  class InterestRateStream: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // calculationPeriodDates
    // 
    typedef ::FpML_4_2::CalculationPeriodDates calculationPeriodDates_type;
    typedef ::xsd::cxx::tree::traits< calculationPeriodDates_type, char > calculationPeriodDates_traits;

    const calculationPeriodDates_type&
    calculationPeriodDates () const;

    calculationPeriodDates_type&
    calculationPeriodDates ();

    void
    calculationPeriodDates (const calculationPeriodDates_type& x);

    void
    calculationPeriodDates (::std::auto_ptr< calculationPeriodDates_type > p);

    // paymentDates
    // 
    typedef ::FpML_4_2::PaymentDates paymentDates_type;
    typedef ::xsd::cxx::tree::traits< paymentDates_type, char > paymentDates_traits;

    const paymentDates_type&
    paymentDates () const;

    paymentDates_type&
    paymentDates ();

    void
    paymentDates (const paymentDates_type& x);

    void
    paymentDates (::std::auto_ptr< paymentDates_type > p);

    // resetDates
    // 
    typedef ::FpML_4_2::ResetDates resetDates_type;
    typedef ::xsd::cxx::tree::optional< resetDates_type > resetDates_optional;
    typedef ::xsd::cxx::tree::traits< resetDates_type, char > resetDates_traits;

    const resetDates_optional&
    resetDates () const;

    resetDates_optional&
    resetDates ();

    void
    resetDates (const resetDates_type& x);

    void
    resetDates (const resetDates_optional& x);

    void
    resetDates (::std::auto_ptr< resetDates_type > p);

    // calculationPeriodAmount
    // 
    typedef ::FpML_4_2::CalculationPeriodAmount calculationPeriodAmount_type;
    typedef ::xsd::cxx::tree::traits< calculationPeriodAmount_type, char > calculationPeriodAmount_traits;

    const calculationPeriodAmount_type&
    calculationPeriodAmount () const;

    calculationPeriodAmount_type&
    calculationPeriodAmount ();

    void
    calculationPeriodAmount (const calculationPeriodAmount_type& x);

    void
    calculationPeriodAmount (::std::auto_ptr< calculationPeriodAmount_type > p);

    // stubCalculationPeriodAmount
    // 
    typedef ::FpML_4_2::StubCalculationPeriodAmount stubCalculationPeriodAmount_type;
    typedef ::xsd::cxx::tree::optional< stubCalculationPeriodAmount_type > stubCalculationPeriodAmount_optional;
    typedef ::xsd::cxx::tree::traits< stubCalculationPeriodAmount_type, char > stubCalculationPeriodAmount_traits;

    const stubCalculationPeriodAmount_optional&
    stubCalculationPeriodAmount () const;

    stubCalculationPeriodAmount_optional&
    stubCalculationPeriodAmount ();

    void
    stubCalculationPeriodAmount (const stubCalculationPeriodAmount_type& x);

    void
    stubCalculationPeriodAmount (const stubCalculationPeriodAmount_optional& x);

    void
    stubCalculationPeriodAmount (::std::auto_ptr< stubCalculationPeriodAmount_type > p);

    // principalExchanges
    // 
    typedef ::FpML_4_2::PrincipalExchanges principalExchanges_type;
    typedef ::xsd::cxx::tree::optional< principalExchanges_type > principalExchanges_optional;
    typedef ::xsd::cxx::tree::traits< principalExchanges_type, char > principalExchanges_traits;

    const principalExchanges_optional&
    principalExchanges () const;

    principalExchanges_optional&
    principalExchanges ();

    void
    principalExchanges (const principalExchanges_type& x);

    void
    principalExchanges (const principalExchanges_optional& x);

    void
    principalExchanges (::std::auto_ptr< principalExchanges_type > p);

    // cashflows
    // 
    typedef ::FpML_4_2::Cashflows cashflows_type;
    typedef ::xsd::cxx::tree::optional< cashflows_type > cashflows_optional;
    typedef ::xsd::cxx::tree::traits< cashflows_type, char > cashflows_traits;

    const cashflows_optional&
    cashflows () const;

    cashflows_optional&
    cashflows ();

    void
    cashflows (const cashflows_type& x);

    void
    cashflows (const cashflows_optional& x);

    void
    cashflows (::std::auto_ptr< cashflows_type > p);

    // settlementProvision
    // 
    typedef ::FpML_4_2::SettlementProvision settlementProvision_type;
    typedef ::xsd::cxx::tree::optional< settlementProvision_type > settlementProvision_optional;
    typedef ::xsd::cxx::tree::traits< settlementProvision_type, char > settlementProvision_traits;

    const settlementProvision_optional&
    settlementProvision () const;

    settlementProvision_optional&
    settlementProvision ();

    void
    settlementProvision (const settlementProvision_type& x);

    void
    settlementProvision (const settlementProvision_optional& x);

    void
    settlementProvision (::std::auto_ptr< settlementProvision_type > p);

    // formula
    // 
    typedef ::FpML_4_2::Formula formula_type;
    typedef ::xsd::cxx::tree::optional< formula_type > formula_optional;
    typedef ::xsd::cxx::tree::traits< formula_type, char > formula_traits;

    const formula_optional&
    formula () const;

    formula_optional&
    formula ();

    void
    formula (const formula_type& x);

    void
    formula (const formula_optional& x);

    void
    formula (::std::auto_ptr< formula_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    InterestRateStream (const payerPartyReference_type&,
                        const receiverPartyReference_type&,
                        const calculationPeriodDates_type&,
                        const paymentDates_type&,
                        const calculationPeriodAmount_type&);

    InterestRateStream (::std::auto_ptr< payerPartyReference_type >&,
                        ::std::auto_ptr< receiverPartyReference_type >&,
                        ::std::auto_ptr< calculationPeriodDates_type >&,
                        ::std::auto_ptr< paymentDates_type >&,
                        ::std::auto_ptr< calculationPeriodAmount_type >&);

    InterestRateStream (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    InterestRateStream (const InterestRateStream& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual InterestRateStream*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InterestRateStream ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    ::xsd::cxx::tree::one< calculationPeriodDates_type > calculationPeriodDates_;
    ::xsd::cxx::tree::one< paymentDates_type > paymentDates_;
    resetDates_optional resetDates_;
    ::xsd::cxx::tree::one< calculationPeriodAmount_type > calculationPeriodAmount_;
    stubCalculationPeriodAmount_optional stubCalculationPeriodAmount_;
    principalExchanges_optional principalExchanges_;
    cashflows_optional cashflows_;
    settlementProvision_optional settlementProvision_;
    formula_optional formula_;
    id_optional id_;
  };

  class MandatoryEarlyTermination: public ::xml_schema::type
  {
    public:
    // mandatoryEarlyTerminationDate
    // 
    typedef ::FpML_4_2::AdjustableDate mandatoryEarlyTerminationDate_type;
    typedef ::xsd::cxx::tree::traits< mandatoryEarlyTerminationDate_type, char > mandatoryEarlyTerminationDate_traits;

    const mandatoryEarlyTerminationDate_type&
    mandatoryEarlyTerminationDate () const;

    mandatoryEarlyTerminationDate_type&
    mandatoryEarlyTerminationDate ();

    void
    mandatoryEarlyTerminationDate (const mandatoryEarlyTerminationDate_type& x);

    void
    mandatoryEarlyTerminationDate (::std::auto_ptr< mandatoryEarlyTerminationDate_type > p);

    // calculationAgent
    // 
    typedef ::FpML_4_2::CalculationAgent calculationAgent_type;
    typedef ::xsd::cxx::tree::traits< calculationAgent_type, char > calculationAgent_traits;

    const calculationAgent_type&
    calculationAgent () const;

    calculationAgent_type&
    calculationAgent ();

    void
    calculationAgent (const calculationAgent_type& x);

    void
    calculationAgent (::std::auto_ptr< calculationAgent_type > p);

    // cashSettlement
    // 
    typedef ::FpML_4_2::CashSettlement cashSettlement_type;
    typedef ::xsd::cxx::tree::traits< cashSettlement_type, char > cashSettlement_traits;

    const cashSettlement_type&
    cashSettlement () const;

    cashSettlement_type&
    cashSettlement ();

    void
    cashSettlement (const cashSettlement_type& x);

    void
    cashSettlement (::std::auto_ptr< cashSettlement_type > p);

    // mandatoryEarlyTerminationAdjustedDates
    // 
    typedef ::FpML_4_2::MandatoryEarlyTerminationAdjustedDates mandatoryEarlyTerminationAdjustedDates_type;
    typedef ::xsd::cxx::tree::optional< mandatoryEarlyTerminationAdjustedDates_type > mandatoryEarlyTerminationAdjustedDates_optional;
    typedef ::xsd::cxx::tree::traits< mandatoryEarlyTerminationAdjustedDates_type, char > mandatoryEarlyTerminationAdjustedDates_traits;

    const mandatoryEarlyTerminationAdjustedDates_optional&
    mandatoryEarlyTerminationAdjustedDates () const;

    mandatoryEarlyTerminationAdjustedDates_optional&
    mandatoryEarlyTerminationAdjustedDates ();

    void
    mandatoryEarlyTerminationAdjustedDates (const mandatoryEarlyTerminationAdjustedDates_type& x);

    void
    mandatoryEarlyTerminationAdjustedDates (const mandatoryEarlyTerminationAdjustedDates_optional& x);

    void
    mandatoryEarlyTerminationAdjustedDates (::std::auto_ptr< mandatoryEarlyTerminationAdjustedDates_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    MandatoryEarlyTermination (const mandatoryEarlyTerminationDate_type&,
                               const calculationAgent_type&,
                               const cashSettlement_type&);

    MandatoryEarlyTermination (::std::auto_ptr< mandatoryEarlyTerminationDate_type >&,
                               ::std::auto_ptr< calculationAgent_type >&,
                               ::std::auto_ptr< cashSettlement_type >&);

    MandatoryEarlyTermination (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    MandatoryEarlyTermination (const MandatoryEarlyTermination& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual MandatoryEarlyTermination*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MandatoryEarlyTermination ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< mandatoryEarlyTerminationDate_type > mandatoryEarlyTerminationDate_;
    ::xsd::cxx::tree::one< calculationAgent_type > calculationAgent_;
    ::xsd::cxx::tree::one< cashSettlement_type > cashSettlement_;
    mandatoryEarlyTerminationAdjustedDates_optional mandatoryEarlyTerminationAdjustedDates_;
    id_optional id_;
  };

  class MandatoryEarlyTerminationAdjustedDates: public ::xml_schema::type
  {
    public:
    // adjustedEarlyTerminationDate
    // 
    typedef ::xml_schema::date adjustedEarlyTerminationDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedEarlyTerminationDate_type, char > adjustedEarlyTerminationDate_traits;

    const adjustedEarlyTerminationDate_type&
    adjustedEarlyTerminationDate () const;

    adjustedEarlyTerminationDate_type&
    adjustedEarlyTerminationDate ();

    void
    adjustedEarlyTerminationDate (const adjustedEarlyTerminationDate_type& x);

    void
    adjustedEarlyTerminationDate (::std::auto_ptr< adjustedEarlyTerminationDate_type > p);

    // adjustedCashSettlementValuationDate
    // 
    typedef ::xml_schema::date adjustedCashSettlementValuationDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedCashSettlementValuationDate_type, char > adjustedCashSettlementValuationDate_traits;

    const adjustedCashSettlementValuationDate_type&
    adjustedCashSettlementValuationDate () const;

    adjustedCashSettlementValuationDate_type&
    adjustedCashSettlementValuationDate ();

    void
    adjustedCashSettlementValuationDate (const adjustedCashSettlementValuationDate_type& x);

    void
    adjustedCashSettlementValuationDate (::std::auto_ptr< adjustedCashSettlementValuationDate_type > p);

    // adjustedCashSettlementPaymentDate
    // 
    typedef ::xml_schema::date adjustedCashSettlementPaymentDate_type;
    typedef ::xsd::cxx::tree::traits< adjustedCashSettlementPaymentDate_type, char > adjustedCashSettlementPaymentDate_traits;

    const adjustedCashSettlementPaymentDate_type&
    adjustedCashSettlementPaymentDate () const;

    adjustedCashSettlementPaymentDate_type&
    adjustedCashSettlementPaymentDate ();

    void
    adjustedCashSettlementPaymentDate (const adjustedCashSettlementPaymentDate_type& x);

    void
    adjustedCashSettlementPaymentDate (::std::auto_ptr< adjustedCashSettlementPaymentDate_type > p);

    // Constructors.
    //
    MandatoryEarlyTerminationAdjustedDates (const adjustedEarlyTerminationDate_type&,
                                            const adjustedCashSettlementValuationDate_type&,
                                            const adjustedCashSettlementPaymentDate_type&);

    MandatoryEarlyTerminationAdjustedDates (const ::xercesc::DOMElement& e,
                                            ::xml_schema::flags f = 0,
                                            ::xml_schema::container* c = 0);

    MandatoryEarlyTerminationAdjustedDates (const MandatoryEarlyTerminationAdjustedDates& x,
                                            ::xml_schema::flags f = 0,
                                            ::xml_schema::container* c = 0);

    virtual MandatoryEarlyTerminationAdjustedDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MandatoryEarlyTerminationAdjustedDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< adjustedEarlyTerminationDate_type > adjustedEarlyTerminationDate_;
    ::xsd::cxx::tree::one< adjustedCashSettlementValuationDate_type > adjustedCashSettlementValuationDate_;
    ::xsd::cxx::tree::one< adjustedCashSettlementPaymentDate_type > adjustedCashSettlementPaymentDate_;
  };

  class NonDeliverableSettlement: public ::xml_schema::type
  {
    public:
    // referenceCurrency
    // 
    typedef ::FpML_4_2::Currency referenceCurrency_type;
    typedef ::xsd::cxx::tree::traits< referenceCurrency_type, char > referenceCurrency_traits;

    const referenceCurrency_type&
    referenceCurrency () const;

    referenceCurrency_type&
    referenceCurrency ();

    void
    referenceCurrency (const referenceCurrency_type& x);

    void
    referenceCurrency (::std::auto_ptr< referenceCurrency_type > p);

    // fxFixingDate
    // 
    typedef ::FpML_4_2::FxFixingDate fxFixingDate_type;
    typedef ::xsd::cxx::tree::traits< fxFixingDate_type, char > fxFixingDate_traits;

    const fxFixingDate_type&
    fxFixingDate () const;

    fxFixingDate_type&
    fxFixingDate ();

    void
    fxFixingDate (const fxFixingDate_type& x);

    void
    fxFixingDate (::std::auto_ptr< fxFixingDate_type > p);

    // settlementRateOption
    // 
    typedef ::FpML_4_2::SettlementRateOption settlementRateOption_type;
    typedef ::xsd::cxx::tree::traits< settlementRateOption_type, char > settlementRateOption_traits;

    const settlementRateOption_type&
    settlementRateOption () const;

    settlementRateOption_type&
    settlementRateOption ();

    void
    settlementRateOption (const settlementRateOption_type& x);

    void
    settlementRateOption (::std::auto_ptr< settlementRateOption_type > p);

    // Constructors.
    //
    NonDeliverableSettlement (const referenceCurrency_type&,
                              const fxFixingDate_type&,
                              const settlementRateOption_type&);

    NonDeliverableSettlement (::std::auto_ptr< referenceCurrency_type >&,
                              ::std::auto_ptr< fxFixingDate_type >&,
                              ::std::auto_ptr< settlementRateOption_type >&);

    NonDeliverableSettlement (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    NonDeliverableSettlement (const NonDeliverableSettlement& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual NonDeliverableSettlement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NonDeliverableSettlement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< referenceCurrency_type > referenceCurrency_;
    ::xsd::cxx::tree::one< fxFixingDate_type > fxFixingDate_;
    ::xsd::cxx::tree::one< settlementRateOption_type > settlementRateOption_;
  };

  class Notional: public ::xml_schema::type
  {
    public:
    // notionalStepSchedule
    // 
    typedef ::FpML_4_2::AmountSchedule notionalStepSchedule_type;
    typedef ::xsd::cxx::tree::traits< notionalStepSchedule_type, char > notionalStepSchedule_traits;

    const notionalStepSchedule_type&
    notionalStepSchedule () const;

    notionalStepSchedule_type&
    notionalStepSchedule ();

    void
    notionalStepSchedule (const notionalStepSchedule_type& x);

    void
    notionalStepSchedule (::std::auto_ptr< notionalStepSchedule_type > p);

    // notionalStepParameters
    // 
    typedef ::FpML_4_2::NotionalStepRule notionalStepParameters_type;
    typedef ::xsd::cxx::tree::optional< notionalStepParameters_type > notionalStepParameters_optional;
    typedef ::xsd::cxx::tree::traits< notionalStepParameters_type, char > notionalStepParameters_traits;

    const notionalStepParameters_optional&
    notionalStepParameters () const;

    notionalStepParameters_optional&
    notionalStepParameters ();

    void
    notionalStepParameters (const notionalStepParameters_type& x);

    void
    notionalStepParameters (const notionalStepParameters_optional& x);

    void
    notionalStepParameters (::std::auto_ptr< notionalStepParameters_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Notional (const notionalStepSchedule_type&);

    Notional (::std::auto_ptr< notionalStepSchedule_type >&);

    Notional (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Notional (const Notional& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Notional*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Notional ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< notionalStepSchedule_type > notionalStepSchedule_;
    notionalStepParameters_optional notionalStepParameters_;
    id_optional id_;
  };

  class NotionalStepRule: public ::xml_schema::type
  {
    public:
    // calculationPeriodDatesReference
    // 
    typedef ::FpML_4_2::CalculationPeriodDatesReference calculationPeriodDatesReference_type;
    typedef ::xsd::cxx::tree::traits< calculationPeriodDatesReference_type, char > calculationPeriodDatesReference_traits;

    const calculationPeriodDatesReference_type&
    calculationPeriodDatesReference () const;

    calculationPeriodDatesReference_type&
    calculationPeriodDatesReference ();

    void
    calculationPeriodDatesReference (const calculationPeriodDatesReference_type& x);

    void
    calculationPeriodDatesReference (::std::auto_ptr< calculationPeriodDatesReference_type > p);

    // stepFrequency
    // 
    typedef ::FpML_4_2::Interval stepFrequency_type;
    typedef ::xsd::cxx::tree::traits< stepFrequency_type, char > stepFrequency_traits;

    const stepFrequency_type&
    stepFrequency () const;

    stepFrequency_type&
    stepFrequency ();

    void
    stepFrequency (const stepFrequency_type& x);

    void
    stepFrequency (::std::auto_ptr< stepFrequency_type > p);

    // firstNotionalStepDate
    // 
    typedef ::xml_schema::date firstNotionalStepDate_type;
    typedef ::xsd::cxx::tree::traits< firstNotionalStepDate_type, char > firstNotionalStepDate_traits;

    const firstNotionalStepDate_type&
    firstNotionalStepDate () const;

    firstNotionalStepDate_type&
    firstNotionalStepDate ();

    void
    firstNotionalStepDate (const firstNotionalStepDate_type& x);

    void
    firstNotionalStepDate (::std::auto_ptr< firstNotionalStepDate_type > p);

    // lastNotionalStepDate
    // 
    typedef ::xml_schema::date lastNotionalStepDate_type;
    typedef ::xsd::cxx::tree::traits< lastNotionalStepDate_type, char > lastNotionalStepDate_traits;

    const lastNotionalStepDate_type&
    lastNotionalStepDate () const;

    lastNotionalStepDate_type&
    lastNotionalStepDate ();

    void
    lastNotionalStepDate (const lastNotionalStepDate_type& x);

    void
    lastNotionalStepDate (::std::auto_ptr< lastNotionalStepDate_type > p);

    // notionalStepAmount
    // 
    typedef ::xml_schema::decimal notionalStepAmount_type;
    typedef ::xsd::cxx::tree::optional< notionalStepAmount_type > notionalStepAmount_optional;
    typedef ::xsd::cxx::tree::traits< notionalStepAmount_type, char, ::xsd::cxx::tree::schema_type::decimal > notionalStepAmount_traits;

    const notionalStepAmount_optional&
    notionalStepAmount () const;

    notionalStepAmount_optional&
    notionalStepAmount ();

    void
    notionalStepAmount (const notionalStepAmount_type& x);

    void
    notionalStepAmount (const notionalStepAmount_optional& x);

    // notionalStepRate
    // 
    typedef ::xml_schema::decimal notionalStepRate_type;
    typedef ::xsd::cxx::tree::optional< notionalStepRate_type > notionalStepRate_optional;
    typedef ::xsd::cxx::tree::traits< notionalStepRate_type, char, ::xsd::cxx::tree::schema_type::decimal > notionalStepRate_traits;

    const notionalStepRate_optional&
    notionalStepRate () const;

    notionalStepRate_optional&
    notionalStepRate ();

    void
    notionalStepRate (const notionalStepRate_type& x);

    void
    notionalStepRate (const notionalStepRate_optional& x);

    // stepRelativeTo
    // 
    typedef ::FpML_4_2::StepRelativeToEnum stepRelativeTo_type;
    typedef ::xsd::cxx::tree::optional< stepRelativeTo_type > stepRelativeTo_optional;
    typedef ::xsd::cxx::tree::traits< stepRelativeTo_type, char > stepRelativeTo_traits;

    const stepRelativeTo_optional&
    stepRelativeTo () const;

    stepRelativeTo_optional&
    stepRelativeTo ();

    void
    stepRelativeTo (const stepRelativeTo_type& x);

    void
    stepRelativeTo (const stepRelativeTo_optional& x);

    void
    stepRelativeTo (::std::auto_ptr< stepRelativeTo_type > p);

    // Constructors.
    //
    NotionalStepRule (const calculationPeriodDatesReference_type&,
                      const stepFrequency_type&,
                      const firstNotionalStepDate_type&,
                      const lastNotionalStepDate_type&);

    NotionalStepRule (::std::auto_ptr< calculationPeriodDatesReference_type >&,
                      ::std::auto_ptr< stepFrequency_type >&,
                      const firstNotionalStepDate_type&,
                      const lastNotionalStepDate_type&);

    NotionalStepRule (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    NotionalStepRule (const NotionalStepRule& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual NotionalStepRule*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NotionalStepRule ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< calculationPeriodDatesReference_type > calculationPeriodDatesReference_;
    ::xsd::cxx::tree::one< stepFrequency_type > stepFrequency_;
    ::xsd::cxx::tree::one< firstNotionalStepDate_type > firstNotionalStepDate_;
    ::xsd::cxx::tree::one< lastNotionalStepDate_type > lastNotionalStepDate_;
    notionalStepAmount_optional notionalStepAmount_;
    notionalStepRate_optional notionalStepRate_;
    stepRelativeTo_optional stepRelativeTo_;
  };

  class OptionalEarlyTermination: public ::xml_schema::type
  {
    public:
    // singlePartyOption
    // 
    typedef ::FpML_4_2::SinglePartyOption singlePartyOption_type;
    typedef ::xsd::cxx::tree::optional< singlePartyOption_type > singlePartyOption_optional;
    typedef ::xsd::cxx::tree::traits< singlePartyOption_type, char > singlePartyOption_traits;

    const singlePartyOption_optional&
    singlePartyOption () const;

    singlePartyOption_optional&
    singlePartyOption ();

    void
    singlePartyOption (const singlePartyOption_type& x);

    void
    singlePartyOption (const singlePartyOption_optional& x);

    void
    singlePartyOption (::std::auto_ptr< singlePartyOption_type > p);

    // exercise
    // 
    typedef ::FpML_4_2::Exercise exercise_type;
    typedef ::xsd::cxx::tree::traits< exercise_type, char > exercise_traits;

    const exercise_type&
    exercise () const;

    exercise_type&
    exercise ();

    void
    exercise (const exercise_type& x);

    void
    exercise (::std::auto_ptr< exercise_type > p);

    // exerciseNotice
    // 
    typedef ::FpML_4_2::ExerciseNotice exerciseNotice_type;
    typedef ::xsd::cxx::tree::sequence< exerciseNotice_type > exerciseNotice_sequence;
    typedef exerciseNotice_sequence::iterator exerciseNotice_iterator;
    typedef exerciseNotice_sequence::const_iterator exerciseNotice_const_iterator;
    typedef ::xsd::cxx::tree::traits< exerciseNotice_type, char > exerciseNotice_traits;

    const exerciseNotice_sequence&
    exerciseNotice () const;

    exerciseNotice_sequence&
    exerciseNotice ();

    void
    exerciseNotice (const exerciseNotice_sequence& s);

    // followUpConfirmation
    // 
    typedef ::xml_schema::boolean followUpConfirmation_type;
    typedef ::xsd::cxx::tree::optional< followUpConfirmation_type > followUpConfirmation_optional;
    typedef ::xsd::cxx::tree::traits< followUpConfirmation_type, char > followUpConfirmation_traits;

    const followUpConfirmation_optional&
    followUpConfirmation () const;

    followUpConfirmation_optional&
    followUpConfirmation ();

    void
    followUpConfirmation (const followUpConfirmation_type& x);

    void
    followUpConfirmation (const followUpConfirmation_optional& x);

    // calculationAgent
    // 
    typedef ::FpML_4_2::CalculationAgent calculationAgent_type;
    typedef ::xsd::cxx::tree::traits< calculationAgent_type, char > calculationAgent_traits;

    const calculationAgent_type&
    calculationAgent () const;

    calculationAgent_type&
    calculationAgent ();

    void
    calculationAgent (const calculationAgent_type& x);

    void
    calculationAgent (::std::auto_ptr< calculationAgent_type > p);

    // cashSettlement
    // 
    typedef ::FpML_4_2::CashSettlement cashSettlement_type;
    typedef ::xsd::cxx::tree::traits< cashSettlement_type, char > cashSettlement_traits;

    const cashSettlement_type&
    cashSettlement () const;

    cashSettlement_type&
    cashSettlement ();

    void
    cashSettlement (const cashSettlement_type& x);

    void
    cashSettlement (::std::auto_ptr< cashSettlement_type > p);

    // optionalEarlyTerminationAdjustedDates
    // 
    typedef ::FpML_4_2::OptionalEarlyTerminationAdjustedDates optionalEarlyTerminationAdjustedDates_type;
    typedef ::xsd::cxx::tree::optional< optionalEarlyTerminationAdjustedDates_type > optionalEarlyTerminationAdjustedDates_optional;
    typedef ::xsd::cxx::tree::traits< optionalEarlyTerminationAdjustedDates_type, char > optionalEarlyTerminationAdjustedDates_traits;

    const optionalEarlyTerminationAdjustedDates_optional&
    optionalEarlyTerminationAdjustedDates () const;

    optionalEarlyTerminationAdjustedDates_optional&
    optionalEarlyTerminationAdjustedDates ();

    void
    optionalEarlyTerminationAdjustedDates (const optionalEarlyTerminationAdjustedDates_type& x);

    void
    optionalEarlyTerminationAdjustedDates (const optionalEarlyTerminationAdjustedDates_optional& x);

    void
    optionalEarlyTerminationAdjustedDates (::std::auto_ptr< optionalEarlyTerminationAdjustedDates_type > p);

    // Constructors.
    //
    OptionalEarlyTermination (const exercise_type&,
                              const calculationAgent_type&,
                              const cashSettlement_type&);

    OptionalEarlyTermination (::std::auto_ptr< exercise_type >&,
                              ::std::auto_ptr< calculationAgent_type >&,
                              ::std::auto_ptr< cashSettlement_type >&);

    OptionalEarlyTermination (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    OptionalEarlyTermination (const OptionalEarlyTermination& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual OptionalEarlyTermination*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~OptionalEarlyTermination ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    singlePartyOption_optional singlePartyOption_;
    ::xsd::cxx::tree::one< exercise_type > exercise_;
    exerciseNotice_sequence exerciseNotice_;
    followUpConfirmation_optional followUpConfirmation_;
    ::xsd::cxx::tree::one< calculationAgent_type > calculationAgent_;
    ::xsd::cxx::tree::one< cashSettlement_type > cashSettlement_;
    optionalEarlyTerminationAdjustedDates_optional optionalEarlyTerminationAdjustedDates_;
  };

  class OptionalEarlyTerminationAdjustedDates: public ::xml_schema::type
  {
    public:
    // earlyTerminationEvent
    // 
    typedef ::FpML_4_2::EarlyTerminationEvent earlyTerminationEvent_type;
    typedef ::xsd::cxx::tree::sequence< earlyTerminationEvent_type > earlyTerminationEvent_sequence;
    typedef earlyTerminationEvent_sequence::iterator earlyTerminationEvent_iterator;
    typedef earlyTerminationEvent_sequence::const_iterator earlyTerminationEvent_const_iterator;
    typedef ::xsd::cxx::tree::traits< earlyTerminationEvent_type, char > earlyTerminationEvent_traits;

    const earlyTerminationEvent_sequence&
    earlyTerminationEvent () const;

    earlyTerminationEvent_sequence&
    earlyTerminationEvent ();

    void
    earlyTerminationEvent (const earlyTerminationEvent_sequence& s);

    // Constructors.
    //
    OptionalEarlyTerminationAdjustedDates ();

    OptionalEarlyTerminationAdjustedDates (const ::xercesc::DOMElement& e,
                                           ::xml_schema::flags f = 0,
                                           ::xml_schema::container* c = 0);

    OptionalEarlyTerminationAdjustedDates (const OptionalEarlyTerminationAdjustedDates& x,
                                           ::xml_schema::flags f = 0,
                                           ::xml_schema::container* c = 0);

    virtual OptionalEarlyTerminationAdjustedDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~OptionalEarlyTerminationAdjustedDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    earlyTerminationEvent_sequence earlyTerminationEvent_;
  };

  class PaymentCalculationPeriod: public ::xml_schema::type
  {
    public:
    // unadjustedPaymentDate
    // 
    typedef ::xml_schema::date unadjustedPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< unadjustedPaymentDate_type > unadjustedPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< unadjustedPaymentDate_type, char > unadjustedPaymentDate_traits;

    const unadjustedPaymentDate_optional&
    unadjustedPaymentDate () const;

    unadjustedPaymentDate_optional&
    unadjustedPaymentDate ();

    void
    unadjustedPaymentDate (const unadjustedPaymentDate_type& x);

    void
    unadjustedPaymentDate (const unadjustedPaymentDate_optional& x);

    void
    unadjustedPaymentDate (::std::auto_ptr< unadjustedPaymentDate_type > p);

    // adjustedPaymentDate
    // 
    typedef ::xml_schema::date adjustedPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedPaymentDate_type > adjustedPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedPaymentDate_type, char > adjustedPaymentDate_traits;

    const adjustedPaymentDate_optional&
    adjustedPaymentDate () const;

    adjustedPaymentDate_optional&
    adjustedPaymentDate ();

    void
    adjustedPaymentDate (const adjustedPaymentDate_type& x);

    void
    adjustedPaymentDate (const adjustedPaymentDate_optional& x);

    void
    adjustedPaymentDate (::std::auto_ptr< adjustedPaymentDate_type > p);

    // calculationPeriod
    // 
    typedef ::FpML_4_2::CalculationPeriod calculationPeriod_type;
    typedef ::xsd::cxx::tree::sequence< calculationPeriod_type > calculationPeriod_sequence;
    typedef calculationPeriod_sequence::iterator calculationPeriod_iterator;
    typedef calculationPeriod_sequence::const_iterator calculationPeriod_const_iterator;
    typedef ::xsd::cxx::tree::traits< calculationPeriod_type, char > calculationPeriod_traits;

    const calculationPeriod_sequence&
    calculationPeriod () const;

    calculationPeriod_sequence&
    calculationPeriod ();

    void
    calculationPeriod (const calculationPeriod_sequence& s);

    // fixedPaymentAmount
    // 
    typedef ::xml_schema::decimal fixedPaymentAmount_type;
    typedef ::xsd::cxx::tree::optional< fixedPaymentAmount_type > fixedPaymentAmount_optional;
    typedef ::xsd::cxx::tree::traits< fixedPaymentAmount_type, char, ::xsd::cxx::tree::schema_type::decimal > fixedPaymentAmount_traits;

    const fixedPaymentAmount_optional&
    fixedPaymentAmount () const;

    fixedPaymentAmount_optional&
    fixedPaymentAmount ();

    void
    fixedPaymentAmount (const fixedPaymentAmount_type& x);

    void
    fixedPaymentAmount (const fixedPaymentAmount_optional& x);

    // discountFactor
    // 
    typedef ::xml_schema::decimal discountFactor_type;
    typedef ::xsd::cxx::tree::optional< discountFactor_type > discountFactor_optional;
    typedef ::xsd::cxx::tree::traits< discountFactor_type, char, ::xsd::cxx::tree::schema_type::decimal > discountFactor_traits;

    const discountFactor_optional&
    discountFactor () const;

    discountFactor_optional&
    discountFactor ();

    void
    discountFactor (const discountFactor_type& x);

    void
    discountFactor (const discountFactor_optional& x);

    // forecastPaymentAmount
    // 
    typedef ::FpML_4_2::Money forecastPaymentAmount_type;
    typedef ::xsd::cxx::tree::optional< forecastPaymentAmount_type > forecastPaymentAmount_optional;
    typedef ::xsd::cxx::tree::traits< forecastPaymentAmount_type, char > forecastPaymentAmount_traits;

    const forecastPaymentAmount_optional&
    forecastPaymentAmount () const;

    forecastPaymentAmount_optional&
    forecastPaymentAmount ();

    void
    forecastPaymentAmount (const forecastPaymentAmount_type& x);

    void
    forecastPaymentAmount (const forecastPaymentAmount_optional& x);

    void
    forecastPaymentAmount (::std::auto_ptr< forecastPaymentAmount_type > p);

    // presentValueAmount
    // 
    typedef ::FpML_4_2::Money presentValueAmount_type;
    typedef ::xsd::cxx::tree::optional< presentValueAmount_type > presentValueAmount_optional;
    typedef ::xsd::cxx::tree::traits< presentValueAmount_type, char > presentValueAmount_traits;

    const presentValueAmount_optional&
    presentValueAmount () const;

    presentValueAmount_optional&
    presentValueAmount ();

    void
    presentValueAmount (const presentValueAmount_type& x);

    void
    presentValueAmount (const presentValueAmount_optional& x);

    void
    presentValueAmount (::std::auto_ptr< presentValueAmount_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // href
    // 
    typedef ::FpML_4_2::SimplePricingStructureReference href_type;
    typedef ::xsd::cxx::tree::optional< href_type > href_optional;
    typedef ::xsd::cxx::tree::traits< href_type, char > href_traits;

    const href_optional&
    href () const;

    href_optional&
    href ();

    void
    href (const href_type& x);

    void
    href (const href_optional& x);

    void
    href (::std::auto_ptr< href_type > p);

    // Constructors.
    //
    PaymentCalculationPeriod ();

    PaymentCalculationPeriod (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    PaymentCalculationPeriod (const PaymentCalculationPeriod& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual PaymentCalculationPeriod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PaymentCalculationPeriod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    unadjustedPaymentDate_optional unadjustedPaymentDate_;
    adjustedPaymentDate_optional adjustedPaymentDate_;
    calculationPeriod_sequence calculationPeriod_;
    fixedPaymentAmount_optional fixedPaymentAmount_;
    discountFactor_optional discountFactor_;
    forecastPaymentAmount_optional forecastPaymentAmount_;
    presentValueAmount_optional presentValueAmount_;
    id_optional id_;
    href_optional href_;
  };

  class PaymentDates: public ::xml_schema::type
  {
    public:
    // calculationPeriodDatesReference
    // 
    typedef ::FpML_4_2::CalculationPeriodDatesReference calculationPeriodDatesReference_type;
    typedef ::xsd::cxx::tree::optional< calculationPeriodDatesReference_type > calculationPeriodDatesReference_optional;
    typedef ::xsd::cxx::tree::traits< calculationPeriodDatesReference_type, char > calculationPeriodDatesReference_traits;

    const calculationPeriodDatesReference_optional&
    calculationPeriodDatesReference () const;

    calculationPeriodDatesReference_optional&
    calculationPeriodDatesReference ();

    void
    calculationPeriodDatesReference (const calculationPeriodDatesReference_type& x);

    void
    calculationPeriodDatesReference (const calculationPeriodDatesReference_optional& x);

    void
    calculationPeriodDatesReference (::std::auto_ptr< calculationPeriodDatesReference_type > p);

    // resetDatesReference
    // 
    typedef ::FpML_4_2::ResetDatesReference resetDatesReference_type;
    typedef ::xsd::cxx::tree::optional< resetDatesReference_type > resetDatesReference_optional;
    typedef ::xsd::cxx::tree::traits< resetDatesReference_type, char > resetDatesReference_traits;

    const resetDatesReference_optional&
    resetDatesReference () const;

    resetDatesReference_optional&
    resetDatesReference ();

    void
    resetDatesReference (const resetDatesReference_type& x);

    void
    resetDatesReference (const resetDatesReference_optional& x);

    void
    resetDatesReference (::std::auto_ptr< resetDatesReference_type > p);

    // paymentFrequency
    // 
    typedef ::FpML_4_2::Interval paymentFrequency_type;
    typedef ::xsd::cxx::tree::traits< paymentFrequency_type, char > paymentFrequency_traits;

    const paymentFrequency_type&
    paymentFrequency () const;

    paymentFrequency_type&
    paymentFrequency ();

    void
    paymentFrequency (const paymentFrequency_type& x);

    void
    paymentFrequency (::std::auto_ptr< paymentFrequency_type > p);

    // firstPaymentDate
    // 
    typedef ::xml_schema::date firstPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< firstPaymentDate_type > firstPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< firstPaymentDate_type, char > firstPaymentDate_traits;

    const firstPaymentDate_optional&
    firstPaymentDate () const;

    firstPaymentDate_optional&
    firstPaymentDate ();

    void
    firstPaymentDate (const firstPaymentDate_type& x);

    void
    firstPaymentDate (const firstPaymentDate_optional& x);

    void
    firstPaymentDate (::std::auto_ptr< firstPaymentDate_type > p);

    // lastRegularPaymentDate
    // 
    typedef ::xml_schema::date lastRegularPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< lastRegularPaymentDate_type > lastRegularPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< lastRegularPaymentDate_type, char > lastRegularPaymentDate_traits;

    const lastRegularPaymentDate_optional&
    lastRegularPaymentDate () const;

    lastRegularPaymentDate_optional&
    lastRegularPaymentDate ();

    void
    lastRegularPaymentDate (const lastRegularPaymentDate_type& x);

    void
    lastRegularPaymentDate (const lastRegularPaymentDate_optional& x);

    void
    lastRegularPaymentDate (::std::auto_ptr< lastRegularPaymentDate_type > p);

    // payRelativeTo
    // 
    typedef ::FpML_4_2::PayRelativeToEnum payRelativeTo_type;
    typedef ::xsd::cxx::tree::traits< payRelativeTo_type, char > payRelativeTo_traits;

    const payRelativeTo_type&
    payRelativeTo () const;

    payRelativeTo_type&
    payRelativeTo ();

    void
    payRelativeTo (const payRelativeTo_type& x);

    void
    payRelativeTo (::std::auto_ptr< payRelativeTo_type > p);

    // paymentDaysOffset
    // 
    typedef ::FpML_4_2::Offset paymentDaysOffset_type;
    typedef ::xsd::cxx::tree::optional< paymentDaysOffset_type > paymentDaysOffset_optional;
    typedef ::xsd::cxx::tree::traits< paymentDaysOffset_type, char > paymentDaysOffset_traits;

    const paymentDaysOffset_optional&
    paymentDaysOffset () const;

    paymentDaysOffset_optional&
    paymentDaysOffset ();

    void
    paymentDaysOffset (const paymentDaysOffset_type& x);

    void
    paymentDaysOffset (const paymentDaysOffset_optional& x);

    void
    paymentDaysOffset (::std::auto_ptr< paymentDaysOffset_type > p);

    // paymentDatesAdjustments
    // 
    typedef ::FpML_4_2::BusinessDayAdjustments paymentDatesAdjustments_type;
    typedef ::xsd::cxx::tree::traits< paymentDatesAdjustments_type, char > paymentDatesAdjustments_traits;

    const paymentDatesAdjustments_type&
    paymentDatesAdjustments () const;

    paymentDatesAdjustments_type&
    paymentDatesAdjustments ();

    void
    paymentDatesAdjustments (const paymentDatesAdjustments_type& x);

    void
    paymentDatesAdjustments (::std::auto_ptr< paymentDatesAdjustments_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    PaymentDates (const paymentFrequency_type&,
                  const payRelativeTo_type&,
                  const paymentDatesAdjustments_type&);

    PaymentDates (::std::auto_ptr< paymentFrequency_type >&,
                  const payRelativeTo_type&,
                  ::std::auto_ptr< paymentDatesAdjustments_type >&);

    PaymentDates (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    PaymentDates (const PaymentDates& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual PaymentDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PaymentDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    calculationPeriodDatesReference_optional calculationPeriodDatesReference_;
    resetDatesReference_optional resetDatesReference_;
    ::xsd::cxx::tree::one< paymentFrequency_type > paymentFrequency_;
    firstPaymentDate_optional firstPaymentDate_;
    lastRegularPaymentDate_optional lastRegularPaymentDate_;
    ::xsd::cxx::tree::one< payRelativeTo_type > payRelativeTo_;
    paymentDaysOffset_optional paymentDaysOffset_;
    ::xsd::cxx::tree::one< paymentDatesAdjustments_type > paymentDatesAdjustments_;
    id_optional id_;
  };

  class PaymentDatesReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    PaymentDatesReference (const href_type&);

    PaymentDatesReference (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    PaymentDatesReference (const PaymentDatesReference& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual PaymentDatesReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PaymentDatesReference ();
  };

  class PrincipalExchange: public ::xml_schema::type
  {
    public:
    // unadjustedPrincipalExchangeDate
    // 
    typedef ::xml_schema::date unadjustedPrincipalExchangeDate_type;
    typedef ::xsd::cxx::tree::optional< unadjustedPrincipalExchangeDate_type > unadjustedPrincipalExchangeDate_optional;
    typedef ::xsd::cxx::tree::traits< unadjustedPrincipalExchangeDate_type, char > unadjustedPrincipalExchangeDate_traits;

    const unadjustedPrincipalExchangeDate_optional&
    unadjustedPrincipalExchangeDate () const;

    unadjustedPrincipalExchangeDate_optional&
    unadjustedPrincipalExchangeDate ();

    void
    unadjustedPrincipalExchangeDate (const unadjustedPrincipalExchangeDate_type& x);

    void
    unadjustedPrincipalExchangeDate (const unadjustedPrincipalExchangeDate_optional& x);

    void
    unadjustedPrincipalExchangeDate (::std::auto_ptr< unadjustedPrincipalExchangeDate_type > p);

    // adjustedPrincipalExchangeDate
    // 
    typedef ::xml_schema::date adjustedPrincipalExchangeDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedPrincipalExchangeDate_type > adjustedPrincipalExchangeDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedPrincipalExchangeDate_type, char > adjustedPrincipalExchangeDate_traits;

    const adjustedPrincipalExchangeDate_optional&
    adjustedPrincipalExchangeDate () const;

    adjustedPrincipalExchangeDate_optional&
    adjustedPrincipalExchangeDate ();

    void
    adjustedPrincipalExchangeDate (const adjustedPrincipalExchangeDate_type& x);

    void
    adjustedPrincipalExchangeDate (const adjustedPrincipalExchangeDate_optional& x);

    void
    adjustedPrincipalExchangeDate (::std::auto_ptr< adjustedPrincipalExchangeDate_type > p);

    // principalExchangeAmount
    // 
    typedef ::xml_schema::decimal principalExchangeAmount_type;
    typedef ::xsd::cxx::tree::optional< principalExchangeAmount_type > principalExchangeAmount_optional;
    typedef ::xsd::cxx::tree::traits< principalExchangeAmount_type, char, ::xsd::cxx::tree::schema_type::decimal > principalExchangeAmount_traits;

    const principalExchangeAmount_optional&
    principalExchangeAmount () const;

    principalExchangeAmount_optional&
    principalExchangeAmount ();

    void
    principalExchangeAmount (const principalExchangeAmount_type& x);

    void
    principalExchangeAmount (const principalExchangeAmount_optional& x);

    // discountFactor
    // 
    typedef ::xml_schema::decimal discountFactor_type;
    typedef ::xsd::cxx::tree::optional< discountFactor_type > discountFactor_optional;
    typedef ::xsd::cxx::tree::traits< discountFactor_type, char, ::xsd::cxx::tree::schema_type::decimal > discountFactor_traits;

    const discountFactor_optional&
    discountFactor () const;

    discountFactor_optional&
    discountFactor ();

    void
    discountFactor (const discountFactor_type& x);

    void
    discountFactor (const discountFactor_optional& x);

    // presentValuePrincipalExchangeAmount
    // 
    typedef ::FpML_4_2::Money presentValuePrincipalExchangeAmount_type;
    typedef ::xsd::cxx::tree::optional< presentValuePrincipalExchangeAmount_type > presentValuePrincipalExchangeAmount_optional;
    typedef ::xsd::cxx::tree::traits< presentValuePrincipalExchangeAmount_type, char > presentValuePrincipalExchangeAmount_traits;

    const presentValuePrincipalExchangeAmount_optional&
    presentValuePrincipalExchangeAmount () const;

    presentValuePrincipalExchangeAmount_optional&
    presentValuePrincipalExchangeAmount ();

    void
    presentValuePrincipalExchangeAmount (const presentValuePrincipalExchangeAmount_type& x);

    void
    presentValuePrincipalExchangeAmount (const presentValuePrincipalExchangeAmount_optional& x);

    void
    presentValuePrincipalExchangeAmount (::std::auto_ptr< presentValuePrincipalExchangeAmount_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    PrincipalExchange ();

    PrincipalExchange (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    PrincipalExchange (const PrincipalExchange& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual PrincipalExchange*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PrincipalExchange ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    unadjustedPrincipalExchangeDate_optional unadjustedPrincipalExchangeDate_;
    adjustedPrincipalExchangeDate_optional adjustedPrincipalExchangeDate_;
    principalExchangeAmount_optional principalExchangeAmount_;
    discountFactor_optional discountFactor_;
    presentValuePrincipalExchangeAmount_optional presentValuePrincipalExchangeAmount_;
    id_optional id_;
  };

  class ResetDates: public ::xml_schema::type
  {
    public:
    // calculationPeriodDatesReference
    // 
    typedef ::FpML_4_2::CalculationPeriodDatesReference calculationPeriodDatesReference_type;
    typedef ::xsd::cxx::tree::traits< calculationPeriodDatesReference_type, char > calculationPeriodDatesReference_traits;

    const calculationPeriodDatesReference_type&
    calculationPeriodDatesReference () const;

    calculationPeriodDatesReference_type&
    calculationPeriodDatesReference ();

    void
    calculationPeriodDatesReference (const calculationPeriodDatesReference_type& x);

    void
    calculationPeriodDatesReference (::std::auto_ptr< calculationPeriodDatesReference_type > p);

    // resetRelativeTo
    // 
    typedef ::FpML_4_2::ResetRelativeToEnum resetRelativeTo_type;
    typedef ::xsd::cxx::tree::optional< resetRelativeTo_type > resetRelativeTo_optional;
    typedef ::xsd::cxx::tree::traits< resetRelativeTo_type, char > resetRelativeTo_traits;

    const resetRelativeTo_optional&
    resetRelativeTo () const;

    resetRelativeTo_optional&
    resetRelativeTo ();

    void
    resetRelativeTo (const resetRelativeTo_type& x);

    void
    resetRelativeTo (const resetRelativeTo_optional& x);

    void
    resetRelativeTo (::std::auto_ptr< resetRelativeTo_type > p);

    // initialFixingDate
    // 
    typedef ::FpML_4_2::RelativeDateOffset initialFixingDate_type;
    typedef ::xsd::cxx::tree::optional< initialFixingDate_type > initialFixingDate_optional;
    typedef ::xsd::cxx::tree::traits< initialFixingDate_type, char > initialFixingDate_traits;

    const initialFixingDate_optional&
    initialFixingDate () const;

    initialFixingDate_optional&
    initialFixingDate ();

    void
    initialFixingDate (const initialFixingDate_type& x);

    void
    initialFixingDate (const initialFixingDate_optional& x);

    void
    initialFixingDate (::std::auto_ptr< initialFixingDate_type > p);

    // fixingDates
    // 
    typedef ::FpML_4_2::RelativeDateOffset fixingDates_type;
    typedef ::xsd::cxx::tree::traits< fixingDates_type, char > fixingDates_traits;

    const fixingDates_type&
    fixingDates () const;

    fixingDates_type&
    fixingDates ();

    void
    fixingDates (const fixingDates_type& x);

    void
    fixingDates (::std::auto_ptr< fixingDates_type > p);

    // rateCutOffDaysOffset
    // 
    typedef ::FpML_4_2::Offset rateCutOffDaysOffset_type;
    typedef ::xsd::cxx::tree::optional< rateCutOffDaysOffset_type > rateCutOffDaysOffset_optional;
    typedef ::xsd::cxx::tree::traits< rateCutOffDaysOffset_type, char > rateCutOffDaysOffset_traits;

    const rateCutOffDaysOffset_optional&
    rateCutOffDaysOffset () const;

    rateCutOffDaysOffset_optional&
    rateCutOffDaysOffset ();

    void
    rateCutOffDaysOffset (const rateCutOffDaysOffset_type& x);

    void
    rateCutOffDaysOffset (const rateCutOffDaysOffset_optional& x);

    void
    rateCutOffDaysOffset (::std::auto_ptr< rateCutOffDaysOffset_type > p);

    // resetFrequency
    // 
    typedef ::FpML_4_2::ResetFrequency resetFrequency_type;
    typedef ::xsd::cxx::tree::traits< resetFrequency_type, char > resetFrequency_traits;

    const resetFrequency_type&
    resetFrequency () const;

    resetFrequency_type&
    resetFrequency ();

    void
    resetFrequency (const resetFrequency_type& x);

    void
    resetFrequency (::std::auto_ptr< resetFrequency_type > p);

    // resetDatesAdjustments
    // 
    typedef ::FpML_4_2::BusinessDayAdjustments resetDatesAdjustments_type;
    typedef ::xsd::cxx::tree::traits< resetDatesAdjustments_type, char > resetDatesAdjustments_traits;

    const resetDatesAdjustments_type&
    resetDatesAdjustments () const;

    resetDatesAdjustments_type&
    resetDatesAdjustments ();

    void
    resetDatesAdjustments (const resetDatesAdjustments_type& x);

    void
    resetDatesAdjustments (::std::auto_ptr< resetDatesAdjustments_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    ResetDates (const calculationPeriodDatesReference_type&,
                const fixingDates_type&,
                const resetFrequency_type&,
                const resetDatesAdjustments_type&,
                const id_type&);

    ResetDates (::std::auto_ptr< calculationPeriodDatesReference_type >&,
                ::std::auto_ptr< fixingDates_type >&,
                ::std::auto_ptr< resetFrequency_type >&,
                ::std::auto_ptr< resetDatesAdjustments_type >&,
                const id_type&);

    ResetDates (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    ResetDates (const ResetDates& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual ResetDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ResetDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< calculationPeriodDatesReference_type > calculationPeriodDatesReference_;
    resetRelativeTo_optional resetRelativeTo_;
    initialFixingDate_optional initialFixingDate_;
    ::xsd::cxx::tree::one< fixingDates_type > fixingDates_;
    rateCutOffDaysOffset_optional rateCutOffDaysOffset_;
    ::xsd::cxx::tree::one< resetFrequency_type > resetFrequency_;
    ::xsd::cxx::tree::one< resetDatesAdjustments_type > resetDatesAdjustments_;
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class ResetDatesReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    ResetDatesReference (const href_type&);

    ResetDatesReference (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ResetDatesReference (const ResetDatesReference& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual ResetDatesReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ResetDatesReference ();
  };

  class SettlementProvision: public ::xml_schema::type
  {
    public:
    // settlementCurrency
    // 
    typedef ::FpML_4_2::Currency settlementCurrency_type;
    typedef ::xsd::cxx::tree::traits< settlementCurrency_type, char > settlementCurrency_traits;

    const settlementCurrency_type&
    settlementCurrency () const;

    settlementCurrency_type&
    settlementCurrency ();

    void
    settlementCurrency (const settlementCurrency_type& x);

    void
    settlementCurrency (::std::auto_ptr< settlementCurrency_type > p);

    // nonDeliverableSettlement
    // 
    typedef ::FpML_4_2::NonDeliverableSettlement nonDeliverableSettlement_type;
    typedef ::xsd::cxx::tree::optional< nonDeliverableSettlement_type > nonDeliverableSettlement_optional;
    typedef ::xsd::cxx::tree::traits< nonDeliverableSettlement_type, char > nonDeliverableSettlement_traits;

    const nonDeliverableSettlement_optional&
    nonDeliverableSettlement () const;

    nonDeliverableSettlement_optional&
    nonDeliverableSettlement ();

    void
    nonDeliverableSettlement (const nonDeliverableSettlement_type& x);

    void
    nonDeliverableSettlement (const nonDeliverableSettlement_optional& x);

    void
    nonDeliverableSettlement (::std::auto_ptr< nonDeliverableSettlement_type > p);

    // Constructors.
    //
    SettlementProvision (const settlementCurrency_type&);

    SettlementProvision (::std::auto_ptr< settlementCurrency_type >&);

    SettlementProvision (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    SettlementProvision (const SettlementProvision& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual SettlementProvision*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SettlementProvision ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< settlementCurrency_type > settlementCurrency_;
    nonDeliverableSettlement_optional nonDeliverableSettlement_;
  };

  class SettlementRateOption: public ::xml_schema::normalized_string
  {
    public:
    // settlementRateOptionScheme
    // 
    typedef ::xml_schema::uri settlementRateOptionScheme_type;
    typedef ::xsd::cxx::tree::traits< settlementRateOptionScheme_type, char > settlementRateOptionScheme_traits;

    const settlementRateOptionScheme_type&
    settlementRateOptionScheme () const;

    settlementRateOptionScheme_type&
    settlementRateOptionScheme ();

    void
    settlementRateOptionScheme (const settlementRateOptionScheme_type& x);

    void
    settlementRateOptionScheme (::std::auto_ptr< settlementRateOptionScheme_type > p);

    static const settlementRateOptionScheme_type&
    settlementRateOptionScheme_default_value ();

    // Constructors.
    //
    SettlementRateOption ();

    SettlementRateOption (const char*);

    SettlementRateOption (const ::std::string&);

    SettlementRateOption (const ::xml_schema::normalized_string&);

    SettlementRateOption (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    SettlementRateOption (const SettlementRateOption& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual SettlementRateOption*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SettlementRateOption ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< settlementRateOptionScheme_type > settlementRateOptionScheme_;
    static const settlementRateOptionScheme_type settlementRateOptionScheme_default_value_;
  };

  class SinglePartyOption: public ::xml_schema::type
  {
    public:
    // buyerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference buyerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< buyerPartyReference_type, char > buyerPartyReference_traits;

    const buyerPartyReference_type&
    buyerPartyReference () const;

    buyerPartyReference_type&
    buyerPartyReference ();

    void
    buyerPartyReference (const buyerPartyReference_type& x);

    void
    buyerPartyReference (::std::auto_ptr< buyerPartyReference_type > p);

    // sellerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference sellerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< sellerPartyReference_type, char > sellerPartyReference_traits;

    const sellerPartyReference_type&
    sellerPartyReference () const;

    sellerPartyReference_type&
    sellerPartyReference ();

    void
    sellerPartyReference (const sellerPartyReference_type& x);

    void
    sellerPartyReference (::std::auto_ptr< sellerPartyReference_type > p);

    // Constructors.
    //
    SinglePartyOption (const buyerPartyReference_type&,
                       const sellerPartyReference_type&);

    SinglePartyOption (::std::auto_ptr< buyerPartyReference_type >&,
                       ::std::auto_ptr< sellerPartyReference_type >&);

    SinglePartyOption (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    SinglePartyOption (const SinglePartyOption& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual SinglePartyOption*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SinglePartyOption ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< buyerPartyReference_type > buyerPartyReference_;
    ::xsd::cxx::tree::one< sellerPartyReference_type > sellerPartyReference_;
  };

  class StubCalculationPeriodAmount: public ::xml_schema::type
  {
    public:
    // calculationPeriodDatesReference
    // 
    typedef ::FpML_4_2::CalculationPeriodDatesReference calculationPeriodDatesReference_type;
    typedef ::xsd::cxx::tree::traits< calculationPeriodDatesReference_type, char > calculationPeriodDatesReference_traits;

    const calculationPeriodDatesReference_type&
    calculationPeriodDatesReference () const;

    calculationPeriodDatesReference_type&
    calculationPeriodDatesReference ();

    void
    calculationPeriodDatesReference (const calculationPeriodDatesReference_type& x);

    void
    calculationPeriodDatesReference (::std::auto_ptr< calculationPeriodDatesReference_type > p);

    // initialStub
    // 
    typedef ::FpML_4_2::Stub initialStub_type;
    typedef ::xsd::cxx::tree::optional< initialStub_type > initialStub_optional;
    typedef ::xsd::cxx::tree::traits< initialStub_type, char > initialStub_traits;

    const initialStub_optional&
    initialStub () const;

    initialStub_optional&
    initialStub ();

    void
    initialStub (const initialStub_type& x);

    void
    initialStub (const initialStub_optional& x);

    void
    initialStub (::std::auto_ptr< initialStub_type > p);

    // finalStub
    // 
    typedef ::FpML_4_2::Stub finalStub_type;
    typedef ::xsd::cxx::tree::optional< finalStub_type > finalStub_optional;
    typedef ::xsd::cxx::tree::traits< finalStub_type, char > finalStub_traits;

    const finalStub_optional&
    finalStub () const;

    finalStub_optional&
    finalStub ();

    void
    finalStub (const finalStub_type& x);

    void
    finalStub (const finalStub_optional& x);

    void
    finalStub (::std::auto_ptr< finalStub_type > p);

    // Constructors.
    //
    StubCalculationPeriodAmount (const calculationPeriodDatesReference_type&);

    StubCalculationPeriodAmount (::std::auto_ptr< calculationPeriodDatesReference_type >&);

    StubCalculationPeriodAmount (const ::xercesc::DOMElement& e,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    StubCalculationPeriodAmount (const StubCalculationPeriodAmount& x,
                                 ::xml_schema::flags f = 0,
                                 ::xml_schema::container* c = 0);

    virtual StubCalculationPeriodAmount*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~StubCalculationPeriodAmount ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< calculationPeriodDatesReference_type > calculationPeriodDatesReference_;
    initialStub_optional initialStub_;
    finalStub_optional finalStub_;
  };

  class Swap: public ::FpML_4_2::Product
  {
    public:
    // swapStream
    // 
    typedef ::FpML_4_2::InterestRateStream swapStream_type;
    typedef ::xsd::cxx::tree::sequence< swapStream_type > swapStream_sequence;
    typedef swapStream_sequence::iterator swapStream_iterator;
    typedef swapStream_sequence::const_iterator swapStream_const_iterator;
    typedef ::xsd::cxx::tree::traits< swapStream_type, char > swapStream_traits;

    const swapStream_sequence&
    swapStream () const;

    swapStream_sequence&
    swapStream ();

    void
    swapStream (const swapStream_sequence& s);

    // earlyTerminationProvision
    // 
    typedef ::FpML_4_2::EarlyTerminationProvision earlyTerminationProvision_type;
    typedef ::xsd::cxx::tree::optional< earlyTerminationProvision_type > earlyTerminationProvision_optional;
    typedef ::xsd::cxx::tree::traits< earlyTerminationProvision_type, char > earlyTerminationProvision_traits;

    const earlyTerminationProvision_optional&
    earlyTerminationProvision () const;

    earlyTerminationProvision_optional&
    earlyTerminationProvision ();

    void
    earlyTerminationProvision (const earlyTerminationProvision_type& x);

    void
    earlyTerminationProvision (const earlyTerminationProvision_optional& x);

    void
    earlyTerminationProvision (::std::auto_ptr< earlyTerminationProvision_type > p);

    // cancelableProvision
    // 
    typedef ::FpML_4_2::CancelableProvision cancelableProvision_type;
    typedef ::xsd::cxx::tree::optional< cancelableProvision_type > cancelableProvision_optional;
    typedef ::xsd::cxx::tree::traits< cancelableProvision_type, char > cancelableProvision_traits;

    const cancelableProvision_optional&
    cancelableProvision () const;

    cancelableProvision_optional&
    cancelableProvision ();

    void
    cancelableProvision (const cancelableProvision_type& x);

    void
    cancelableProvision (const cancelableProvision_optional& x);

    void
    cancelableProvision (::std::auto_ptr< cancelableProvision_type > p);

    // extendibleProvision
    // 
    typedef ::FpML_4_2::ExtendibleProvision extendibleProvision_type;
    typedef ::xsd::cxx::tree::optional< extendibleProvision_type > extendibleProvision_optional;
    typedef ::xsd::cxx::tree::traits< extendibleProvision_type, char > extendibleProvision_traits;

    const extendibleProvision_optional&
    extendibleProvision () const;

    extendibleProvision_optional&
    extendibleProvision ();

    void
    extendibleProvision (const extendibleProvision_type& x);

    void
    extendibleProvision (const extendibleProvision_optional& x);

    void
    extendibleProvision (::std::auto_ptr< extendibleProvision_type > p);

    // additionalPayment
    // 
    typedef ::FpML_4_2::Payment additionalPayment_type;
    typedef ::xsd::cxx::tree::sequence< additionalPayment_type > additionalPayment_sequence;
    typedef additionalPayment_sequence::iterator additionalPayment_iterator;
    typedef additionalPayment_sequence::const_iterator additionalPayment_const_iterator;
    typedef ::xsd::cxx::tree::traits< additionalPayment_type, char > additionalPayment_traits;

    const additionalPayment_sequence&
    additionalPayment () const;

    additionalPayment_sequence&
    additionalPayment ();

    void
    additionalPayment (const additionalPayment_sequence& s);

    // additionalTerms
    // 
    typedef ::FpML_4_2::SwapAdditionalTerms additionalTerms_type;
    typedef ::xsd::cxx::tree::optional< additionalTerms_type > additionalTerms_optional;
    typedef ::xsd::cxx::tree::traits< additionalTerms_type, char > additionalTerms_traits;

    const additionalTerms_optional&
    additionalTerms () const;

    additionalTerms_optional&
    additionalTerms ();

    void
    additionalTerms (const additionalTerms_type& x);

    void
    additionalTerms (const additionalTerms_optional& x);

    void
    additionalTerms (::std::auto_ptr< additionalTerms_type > p);

    // Constructors.
    //
    Swap ();

    Swap (const ::xercesc::DOMElement& e,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    Swap (const Swap& x,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    virtual Swap*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Swap ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    swapStream_sequence swapStream_;
    earlyTerminationProvision_optional earlyTerminationProvision_;
    cancelableProvision_optional cancelableProvision_;
    extendibleProvision_optional extendibleProvision_;
    additionalPayment_sequence additionalPayment_;
    additionalTerms_optional additionalTerms_;
  };

  class SwapAdditionalTerms: public ::xml_schema::type
  {
    public:
    // bondReference
    // 
    typedef ::FpML_4_2::BondReference bondReference_type;
    typedef ::xsd::cxx::tree::optional< bondReference_type > bondReference_optional;
    typedef ::xsd::cxx::tree::traits< bondReference_type, char > bondReference_traits;

    const bondReference_optional&
    bondReference () const;

    bondReference_optional&
    bondReference ();

    void
    bondReference (const bondReference_type& x);

    void
    bondReference (const bondReference_optional& x);

    void
    bondReference (::std::auto_ptr< bondReference_type > p);

    // Constructors.
    //
    SwapAdditionalTerms ();

    SwapAdditionalTerms (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    SwapAdditionalTerms (const SwapAdditionalTerms& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual SwapAdditionalTerms*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SwapAdditionalTerms ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    bondReference_optional bondReference_;
  };

  class Swaption: public ::FpML_4_2::Product
  {
    public:
    // buyerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference buyerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< buyerPartyReference_type, char > buyerPartyReference_traits;

    const buyerPartyReference_type&
    buyerPartyReference () const;

    buyerPartyReference_type&
    buyerPartyReference ();

    void
    buyerPartyReference (const buyerPartyReference_type& x);

    void
    buyerPartyReference (::std::auto_ptr< buyerPartyReference_type > p);

    // sellerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrTradeSideReference sellerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< sellerPartyReference_type, char > sellerPartyReference_traits;

    const sellerPartyReference_type&
    sellerPartyReference () const;

    sellerPartyReference_type&
    sellerPartyReference ();

    void
    sellerPartyReference (const sellerPartyReference_type& x);

    void
    sellerPartyReference (::std::auto_ptr< sellerPartyReference_type > p);

    // premium
    // 
    typedef ::FpML_4_2::Payment premium_type;
    typedef ::xsd::cxx::tree::sequence< premium_type > premium_sequence;
    typedef premium_sequence::iterator premium_iterator;
    typedef premium_sequence::const_iterator premium_const_iterator;
    typedef ::xsd::cxx::tree::traits< premium_type, char > premium_traits;

    const premium_sequence&
    premium () const;

    premium_sequence&
    premium ();

    void
    premium (const premium_sequence& s);

    // exercise
    // 
    typedef ::FpML_4_2::Exercise exercise_type;
    typedef ::xsd::cxx::tree::traits< exercise_type, char > exercise_traits;

    const exercise_type&
    exercise () const;

    exercise_type&
    exercise ();

    void
    exercise (const exercise_type& x);

    void
    exercise (::std::auto_ptr< exercise_type > p);

    // exerciseProcedure
    // 
    typedef ::FpML_4_2::ExerciseProcedure exerciseProcedure_type;
    typedef ::xsd::cxx::tree::optional< exerciseProcedure_type > exerciseProcedure_optional;
    typedef ::xsd::cxx::tree::traits< exerciseProcedure_type, char > exerciseProcedure_traits;

    const exerciseProcedure_optional&
    exerciseProcedure () const;

    exerciseProcedure_optional&
    exerciseProcedure ();

    void
    exerciseProcedure (const exerciseProcedure_type& x);

    void
    exerciseProcedure (const exerciseProcedure_optional& x);

    void
    exerciseProcedure (::std::auto_ptr< exerciseProcedure_type > p);

    // calculationAgent
    // 
    typedef ::FpML_4_2::CalculationAgent calculationAgent_type;
    typedef ::xsd::cxx::tree::optional< calculationAgent_type > calculationAgent_optional;
    typedef ::xsd::cxx::tree::traits< calculationAgent_type, char > calculationAgent_traits;

    const calculationAgent_optional&
    calculationAgent () const;

    calculationAgent_optional&
    calculationAgent ();

    void
    calculationAgent (const calculationAgent_type& x);

    void
    calculationAgent (const calculationAgent_optional& x);

    void
    calculationAgent (::std::auto_ptr< calculationAgent_type > p);

    // cashSettlement
    // 
    typedef ::FpML_4_2::CashSettlement cashSettlement_type;
    typedef ::xsd::cxx::tree::optional< cashSettlement_type > cashSettlement_optional;
    typedef ::xsd::cxx::tree::traits< cashSettlement_type, char > cashSettlement_traits;

    const cashSettlement_optional&
    cashSettlement () const;

    cashSettlement_optional&
    cashSettlement ();

    void
    cashSettlement (const cashSettlement_type& x);

    void
    cashSettlement (const cashSettlement_optional& x);

    void
    cashSettlement (::std::auto_ptr< cashSettlement_type > p);

    // swaptionStraddle
    // 
    typedef ::xml_schema::boolean swaptionStraddle_type;
    typedef ::xsd::cxx::tree::traits< swaptionStraddle_type, char > swaptionStraddle_traits;

    const swaptionStraddle_type&
    swaptionStraddle () const;

    swaptionStraddle_type&
    swaptionStraddle ();

    void
    swaptionStraddle (const swaptionStraddle_type& x);

    // swaptionAdjustedDates
    // 
    typedef ::FpML_4_2::SwaptionAdjustedDates swaptionAdjustedDates_type;
    typedef ::xsd::cxx::tree::optional< swaptionAdjustedDates_type > swaptionAdjustedDates_optional;
    typedef ::xsd::cxx::tree::traits< swaptionAdjustedDates_type, char > swaptionAdjustedDates_traits;

    const swaptionAdjustedDates_optional&
    swaptionAdjustedDates () const;

    swaptionAdjustedDates_optional&
    swaptionAdjustedDates ();

    void
    swaptionAdjustedDates (const swaptionAdjustedDates_type& x);

    void
    swaptionAdjustedDates (const swaptionAdjustedDates_optional& x);

    void
    swaptionAdjustedDates (::std::auto_ptr< swaptionAdjustedDates_type > p);

    // swap
    // 
    typedef ::FpML_4_2::Swap swap_type;
    typedef ::xsd::cxx::tree::traits< swap_type, char > swap_traits;

    const swap_type&
    swap () const;

    swap_type&
    swap ();

    void
    swap (const swap_type& x);

    void
    swap (::std::auto_ptr< swap_type > p);

    // Constructors.
    //
    Swaption (const buyerPartyReference_type&,
              const sellerPartyReference_type&,
              const exercise_type&,
              const swaptionStraddle_type&,
              const swap_type&);

    Swaption (::std::auto_ptr< buyerPartyReference_type >&,
              ::std::auto_ptr< sellerPartyReference_type >&,
              ::std::auto_ptr< exercise_type >&,
              const swaptionStraddle_type&,
              ::std::auto_ptr< swap_type >&);

    Swaption (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Swaption (const Swaption& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Swaption*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Swaption ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< buyerPartyReference_type > buyerPartyReference_;
    ::xsd::cxx::tree::one< sellerPartyReference_type > sellerPartyReference_;
    premium_sequence premium_;
    ::xsd::cxx::tree::one< exercise_type > exercise_;
    exerciseProcedure_optional exerciseProcedure_;
    calculationAgent_optional calculationAgent_;
    cashSettlement_optional cashSettlement_;
    ::xsd::cxx::tree::one< swaptionStraddle_type > swaptionStraddle_;
    swaptionAdjustedDates_optional swaptionAdjustedDates_;
    ::xsd::cxx::tree::one< swap_type > swap_;
  };

  class SwaptionAdjustedDates: public ::xml_schema::type
  {
    public:
    // exerciseEvent
    // 
    typedef ::FpML_4_2::ExerciseEvent exerciseEvent_type;
    typedef ::xsd::cxx::tree::sequence< exerciseEvent_type > exerciseEvent_sequence;
    typedef exerciseEvent_sequence::iterator exerciseEvent_iterator;
    typedef exerciseEvent_sequence::const_iterator exerciseEvent_const_iterator;
    typedef ::xsd::cxx::tree::traits< exerciseEvent_type, char > exerciseEvent_traits;

    const exerciseEvent_sequence&
    exerciseEvent () const;

    exerciseEvent_sequence&
    exerciseEvent ();

    void
    exerciseEvent (const exerciseEvent_sequence& s);

    // Constructors.
    //
    SwaptionAdjustedDates ();

    SwaptionAdjustedDates (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    SwaptionAdjustedDates (const SwaptionAdjustedDates& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual SwaptionAdjustedDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SwaptionAdjustedDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    exerciseEvent_sequence exerciseEvent_;
  };

  class YieldCurveMethod: public ::xml_schema::type
  {
    public:
    // settlementRateSource
    // 
    typedef ::FpML_4_2::SettlementRateSource settlementRateSource_type;
    typedef ::xsd::cxx::tree::optional< settlementRateSource_type > settlementRateSource_optional;
    typedef ::xsd::cxx::tree::traits< settlementRateSource_type, char > settlementRateSource_traits;

    const settlementRateSource_optional&
    settlementRateSource () const;

    settlementRateSource_optional&
    settlementRateSource ();

    void
    settlementRateSource (const settlementRateSource_type& x);

    void
    settlementRateSource (const settlementRateSource_optional& x);

    void
    settlementRateSource (::std::auto_ptr< settlementRateSource_type > p);

    // quotationRateType
    // 
    typedef ::FpML_4_2::QuotationRateTypeEnum quotationRateType_type;
    typedef ::xsd::cxx::tree::traits< quotationRateType_type, char > quotationRateType_traits;

    const quotationRateType_type&
    quotationRateType () const;

    quotationRateType_type&
    quotationRateType ();

    void
    quotationRateType (const quotationRateType_type& x);

    void
    quotationRateType (::std::auto_ptr< quotationRateType_type > p);

    // Constructors.
    //
    YieldCurveMethod (const quotationRateType_type&);

    YieldCurveMethod (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    YieldCurveMethod (const YieldCurveMethod& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual YieldCurveMethod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~YieldCurveMethod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    settlementRateSource_optional settlementRateSource_;
    ::xsd::cxx::tree::one< quotationRateType_type > quotationRateType_;
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const SimplePricingStructureReference&);

  void
  operator<< (::xercesc::DOMAttr&, const SimplePricingStructureReference&);

  void
  operator<< (::xml_schema::list_stream&,
              const SimplePricingStructureReference&);

  void
  operator<< (::xercesc::DOMElement&, const BondReference&);

  void
  operator<< (::xercesc::DOMElement&, const BulletPayment&);

  void
  operator<< (::xercesc::DOMElement&, const Calculation&);

  void
  operator<< (::xercesc::DOMElement&, const CalculationPeriod&);

  void
  operator<< (::xercesc::DOMElement&, const CalculationPeriodAmount&);

  void
  operator<< (::xercesc::DOMElement&, const CalculationPeriodDates&);

  void
  operator<< (::xercesc::DOMElement&, const CalculationPeriodDatesReference&);

  void
  operator<< (::xercesc::DOMElement&, const CancelableProvision&);

  void
  operator<< (::xercesc::DOMElement&, const CancelableProvisionAdjustedDates&);

  void
  operator<< (::xercesc::DOMElement&, const CancellationEvent&);

  void
  operator<< (::xercesc::DOMElement&, const CapFloor&);

  void
  operator<< (::xercesc::DOMElement&, const Cashflows&);

  void
  operator<< (::xercesc::DOMElement&, const CashPriceMethod&);

  void
  operator<< (::xercesc::DOMElement&, const CashSettlement&);

  void
  operator<< (::xercesc::DOMElement&, const CashSettlementPaymentDate&);

  void
  operator<< (::xercesc::DOMElement&, const DateRelativeToPaymentDates&);

  void
  operator<< (::xercesc::DOMElement&, const Discounting&);

  void
  operator<< (::xercesc::DOMElement&, const EarlyTerminationEvent&);

  void
  operator<< (::xercesc::DOMElement&, const EarlyTerminationProvision&);

  void
  operator<< (::xercesc::DOMElement&, const ExerciseEvent&);

  void
  operator<< (::xercesc::DOMElement&, const ExercisePeriod&);

  void
  operator<< (::xercesc::DOMElement&, const ExtendibleProvision&);

  void
  operator<< (::xercesc::DOMElement&, const ExtendibleProvisionAdjustedDates&);

  void
  operator<< (::xercesc::DOMElement&, const ExtensionEvent&);

  void
  operator<< (::xercesc::DOMElement&, const FloatingRateDefinition&);

  void
  operator<< (::xercesc::DOMElement&, const Fra&);

  void
  operator<< (::xercesc::DOMElement&, const FxFixingDate&);

  void
  operator<< (::xercesc::DOMElement&, const FxLinkedNotionalAmount&);

  void
  operator<< (::xercesc::DOMElement&, const FxLinkedNotionalSchedule&);

  void
  operator<< (::xercesc::DOMElement&, const InflationRateCalculation&);

  void
  operator<< (::xercesc::DOMElement&, const InterestRateStream&);

  void
  operator<< (::xercesc::DOMElement&, const MandatoryEarlyTermination&);

  void
  operator<< (::xercesc::DOMElement&, const MandatoryEarlyTerminationAdjustedDates&);

  void
  operator<< (::xercesc::DOMElement&, const NonDeliverableSettlement&);

  void
  operator<< (::xercesc::DOMElement&, const Notional&);

  void
  operator<< (::xercesc::DOMElement&, const NotionalStepRule&);

  void
  operator<< (::xercesc::DOMElement&, const OptionalEarlyTermination&);

  void
  operator<< (::xercesc::DOMElement&, const OptionalEarlyTerminationAdjustedDates&);

  void
  operator<< (::xercesc::DOMElement&, const PaymentCalculationPeriod&);

  void
  operator<< (::xercesc::DOMElement&, const PaymentDates&);

  void
  operator<< (::xercesc::DOMElement&, const PaymentDatesReference&);

  void
  operator<< (::xercesc::DOMElement&, const PrincipalExchange&);

  void
  operator<< (::xercesc::DOMElement&, const ResetDates&);

  void
  operator<< (::xercesc::DOMElement&, const ResetDatesReference&);

  void
  operator<< (::xercesc::DOMElement&, const SettlementProvision&);

  void
  operator<< (::xercesc::DOMElement&, const SettlementRateOption&);

  void
  operator<< (::xercesc::DOMElement&, const SinglePartyOption&);

  void
  operator<< (::xercesc::DOMElement&, const StubCalculationPeriodAmount&);

  void
  operator<< (::xercesc::DOMElement&, const Swap&);

  void
  operator<< (::xercesc::DOMElement&, const SwapAdditionalTerms&);

  void
  operator<< (::xercesc::DOMElement&, const Swaption&);

  void
  operator<< (::xercesc::DOMElement&, const SwaptionAdjustedDates&);

  void
  operator<< (::xercesc::DOMElement&, const YieldCurveMethod&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_IRD_4_2_HXX
