// Copyright (C) 2005-2010 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef FPML_SHARED_4_2_HXX
#define FPML_SHARED_4_2_HXX

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/config.hxx>

#if (XSD_INT_VERSION != 3030000L)
#error XSD runtime version mismatch
#endif

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_TREE_USE_CHAR
#define XSD_CXX_TREE_USE_CHAR
#endif

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/types.hxx>

#include <xsd/cxx/xml/error-handler.hxx>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

#include <xsd/cxx/tree/parsing.hxx>
#include <xsd/cxx/tree/parsing/byte.hxx>
#include <xsd/cxx/tree/parsing/unsigned-byte.hxx>
#include <xsd/cxx/tree/parsing/short.hxx>
#include <xsd/cxx/tree/parsing/unsigned-short.hxx>
#include <xsd/cxx/tree/parsing/int.hxx>
#include <xsd/cxx/tree/parsing/unsigned-int.hxx>
#include <xsd/cxx/tree/parsing/long.hxx>
#include <xsd/cxx/tree/parsing/unsigned-long.hxx>
#include <xsd/cxx/tree/parsing/boolean.hxx>
#include <xsd/cxx/tree/parsing/float.hxx>
#include <xsd/cxx/tree/parsing/double.hxx>
#include <xsd/cxx/tree/parsing/decimal.hxx>

#include <xsd/cxx/xml/dom/serialization-header.hxx>
#include <xsd/cxx/tree/serialization.hxx>
#include <xsd/cxx/tree/serialization/byte.hxx>
#include <xsd/cxx/tree/serialization/unsigned-byte.hxx>
#include <xsd/cxx/tree/serialization/short.hxx>
#include <xsd/cxx/tree/serialization/unsigned-short.hxx>
#include <xsd/cxx/tree/serialization/int.hxx>
#include <xsd/cxx/tree/serialization/unsigned-int.hxx>
#include <xsd/cxx/tree/serialization/long.hxx>
#include <xsd/cxx/tree/serialization/unsigned-long.hxx>
#include <xsd/cxx/tree/serialization/boolean.hxx>
#include <xsd/cxx/tree/serialization/float.hxx>
#include <xsd/cxx/tree/serialization/double.hxx>
#include <xsd/cxx/tree/serialization/decimal.hxx>

namespace xml_schema
{
  // anyType and anySimpleType.
  //
  typedef ::xsd::cxx::tree::type type;
  typedef ::xsd::cxx::tree::simple_type< type > simple_type;
  typedef ::xsd::cxx::tree::type container;

  // 8-bit
  //
  typedef signed char byte;
  typedef unsigned char unsigned_byte;

  // 16-bit
  //
  typedef short short_;
  typedef unsigned short unsigned_short;

  // 32-bit
  //
  typedef int int_;
  typedef unsigned int unsigned_int;

  // 64-bit
  //
  typedef long long long_;
  typedef unsigned long long unsigned_long;

  // Supposed to be arbitrary-length integral types.
  //
  typedef long long integer;
  typedef long long non_positive_integer;
  typedef unsigned long long non_negative_integer;
  typedef unsigned long long positive_integer;
  typedef long long negative_integer;

  // Boolean.
  //
  typedef bool boolean;

  // Floating-point types.
  //
  typedef float float_;
  typedef double double_;
  typedef double decimal;

  // String types.
  //
  typedef ::xsd::cxx::tree::string< char, simple_type > string;
  typedef ::xsd::cxx::tree::normalized_string< char, string > normalized_string;
  typedef ::xsd::cxx::tree::token< char, normalized_string > token;
  typedef ::xsd::cxx::tree::name< char, token > name;
  typedef ::xsd::cxx::tree::nmtoken< char, token > nmtoken;
  typedef ::xsd::cxx::tree::nmtokens< char, simple_type, nmtoken > nmtokens;
  typedef ::xsd::cxx::tree::ncname< char, name > ncname;
  typedef ::xsd::cxx::tree::language< char, token > language;

  // ID/IDREF.
  //
  typedef ::xsd::cxx::tree::id< char, ncname > id;
  typedef ::xsd::cxx::tree::idref< char, ncname, type > idref;
  typedef ::xsd::cxx::tree::idrefs< char, simple_type, idref > idrefs;

  // URI.
  //
  typedef ::xsd::cxx::tree::uri< char, simple_type > uri;

  // Qualified name.
  //
  typedef ::xsd::cxx::tree::qname< char, simple_type, uri, ncname > qname;

  // Binary.
  //
  typedef ::xsd::cxx::tree::buffer< char > buffer;
  typedef ::xsd::cxx::tree::base64_binary< char, simple_type > base64_binary;
  typedef ::xsd::cxx::tree::hex_binary< char, simple_type > hex_binary;

  // Date/time.
  //
  typedef ::xsd::cxx::tree::time_zone time_zone;
  typedef ::xsd::cxx::tree::date< char, simple_type > date;
  typedef ::xsd::cxx::tree::date_time< char, simple_type > date_time;
  typedef ::xsd::cxx::tree::duration< char, simple_type > duration;
  typedef ::xsd::cxx::tree::gday< char, simple_type > gday;
  typedef ::xsd::cxx::tree::gmonth< char, simple_type > gmonth;
  typedef ::xsd::cxx::tree::gmonth_day< char, simple_type > gmonth_day;
  typedef ::xsd::cxx::tree::gyear< char, simple_type > gyear;
  typedef ::xsd::cxx::tree::gyear_month< char, simple_type > gyear_month;
  typedef ::xsd::cxx::tree::time< char, simple_type > time;

  // Entity.
  //
  typedef ::xsd::cxx::tree::entity< char, ncname > entity;
  typedef ::xsd::cxx::tree::entities< char, simple_type, entity > entities;

  // Namespace information and list stream. Used in
  // serialization functions.
  //
  typedef ::xsd::cxx::xml::dom::namespace_info< char > namespace_info;
  typedef ::xsd::cxx::xml::dom::namespace_infomap< char > namespace_infomap;
  typedef ::xsd::cxx::tree::list_stream< char > list_stream;
  typedef ::xsd::cxx::tree::as_double< double_ > as_double;
  typedef ::xsd::cxx::tree::as_decimal< decimal > as_decimal;
  typedef ::xsd::cxx::tree::facet facet;

  // Flags and properties.
  //
  typedef ::xsd::cxx::tree::flags flags;
  typedef ::xsd::cxx::tree::properties< char > properties;

  // Parsing/serialization diagnostics.
  //
  typedef ::xsd::cxx::tree::severity severity;
  typedef ::xsd::cxx::tree::error< char > error;
  typedef ::xsd::cxx::tree::diagnostics< char > diagnostics;

  // Exceptions.
  //
  typedef ::xsd::cxx::tree::exception< char > exception;
  typedef ::xsd::cxx::tree::bounds< char > bounds;
  typedef ::xsd::cxx::tree::duplicate_id< char > duplicate_id;
  typedef ::xsd::cxx::tree::parsing< char > parsing;
  typedef ::xsd::cxx::tree::expected_element< char > expected_element;
  typedef ::xsd::cxx::tree::unexpected_element< char > unexpected_element;
  typedef ::xsd::cxx::tree::expected_attribute< char > expected_attribute;
  typedef ::xsd::cxx::tree::unexpected_enumerator< char > unexpected_enumerator;
  typedef ::xsd::cxx::tree::expected_text_content< char > expected_text_content;
  typedef ::xsd::cxx::tree::no_prefix_mapping< char > no_prefix_mapping;
  typedef ::xsd::cxx::tree::no_type_info< char > no_type_info;
  typedef ::xsd::cxx::tree::not_derived< char > not_derived;
  typedef ::xsd::cxx::tree::serialization< char > serialization;

  // Error handler callback interface.
  //
  typedef ::xsd::cxx::xml::error_handler< char > error_handler;

  // DOM interaction.
  //
  namespace dom
  {
    // Automatic pointer for DOMDocument.
    //
    using ::xsd::cxx::xml::dom::auto_ptr;

#ifndef XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
#define XSD_CXX_TREE_TREE_NODE_KEY__XML_SCHEMA
    // DOM user data key for back pointers to tree nodes.
    //
    const XMLCh* const tree_node_key = ::xsd::cxx::tree::user_data_keys::node;
#endif
  }
}

// Forward declarations.
//
namespace FpML_4_2
{
  class HourMinuteTime;
  class RestrictedPercentage;
  class Reference;
  class AccountReference;
  class Address;
  class AdjustableDate;
  class AdjustableDate2;
  class AdjustableDates;
  class AdjustableOrRelativeDate;
  class AdjustableOrRelativeDates;
  class AdjustableRelativeOrPeriodicDates;
  class Interval;
  class Offset;
  class RelativeDateOffset;
  class AdjustedRelativeDateOffset;
  class Exercise;
  class AmericanExercise;
  class AmountReference;
  class Schedule;
  class AmountSchedule;
  class AssetReference;
  class AutomaticExercise;
  class Routing;
  class Beneficiary;
  class BermudaExercise;
  class BrokerConfirmation;
  class BrokerConfirmationType;
  class BusinessCenter;
  class BusinessCenters;
  class BusinessCentersReference;
  class BusinessCenterTime;
  class DateRange;
  class BusinessDateRange;
  class BusinessDayAdjustments;
  class BusinessDayAdjustmentsReference;
  class CalculationAgent;
  class CalculationPeriodFrequency;
  class CashflowType;
  class CashSettlementReferenceBanks;
  class ClearanceSystem;
  class ContractualDefinitions;
  class ContractualMatrix;
  class ContractualSupplement;
  class ContractualTermsSupplement;
  class CorrespondentInformation;
  class Country;
  class CreditSeniority;
  class Currency;
  class DateList;
  class DateOffset;
  class DateReference;
  class DateTimeList;
  class DayCountFraction;
  class DeterminationMethod;
  class DividendConditions;
  class DividendPaymentDate;
  class Documentation;
  class Empty;
  class EntityId;
  class EntityName;
  class EuropeanExercise;
  class ExchangeId;
  class ExerciseFee;
  class ExerciseFeeSchedule;
  class ExerciseNotice;
  class ExerciseProcedure;
  class Rate;
  class FloatingRate;
  class FloatingRateCalculation;
  class FloatingRateIndex;
  class ForecastRateIndex;
  class Formula;
  class FormulaComponent;
  class FxCashSettlement;
  class FxSpotRateSource;
  class FxFixing;
  class FxRate;
  class GoverningLaw;
  class IdentifiedCurrency;
  class IdentifiedDate;
  class IdentifiedPayerReceiver;
  class InformationProvider;
  class InformationSource;
  class InstrumentId;
  class InterestAccrualsMethod;
  class InterestAccrualsCompoundingMethod;
  class IntermediaryInformation;
  class LegalEntity;
  class LegalEntityReference;
  class MainPublication;
  class ManualExercise;
  class MasterAgreement;
  class MasterAgreementType;
  class MasterConfirmation;
  class MasterConfirmationType;
  class Math;
  class MatrixType;
  class MatrixTerm;
  class Money;
  class PartialExercise;
  class MultipleExercise;
  class NotionalAmountReference;
  class PartyOrAccountReference;
  class PartyOrTradeSideReference;
  class PartyReference;
  class Payment;
  class PaymentCurrency;
  class PaymentType;
  class PeriodicDates;
  class PrincipalExchanges;
  class Product;
  class ProductId;
  class ProductReference;
  class ProductType;
  class QuotedCurrencyPair;
  class RateReference;
  class RateObservation;
  class RateSourcePage;
  class ReferenceAmount;
  class ReferenceBank;
  class ReferenceBankId;
  class RelativeDates;
  class RelativeDateSequence;
  class RequiredIdentifierDate;
  class ResetFrequency;
  class Rounding;
  class RoutingExplicitDetails;
  class RoutingId;
  class RoutingIds;
  class RoutingIdsAndExplicitDetails;
  class ScheduleReference;
  class SettlementInformation;
  class SettlementInstruction;
  class SettlementMethod;
  class SettlementPriceSource;
  class SettlementRateSource;
  class SharedAmericanExercise;
  class SplitSettlement;
  class SpreadSchedule;
  class SpreadScheduleReference;
  class SpreadScheduleType;
  class Step;
  class StreetAddress;
  class Stub;
  class Strike;
  class StrikeSchedule;
  class ValuationScenarioReference;
}


#include <memory>    // std::auto_ptr
#include <limits>    // std::numeric_limits
#include <algorithm> // std::binary_search

#include <xsd/cxx/xml/char-utf8.hxx>

#include <xsd/cxx/tree/exceptions.hxx>
#include <xsd/cxx/tree/elements.hxx>
#include <xsd/cxx/tree/containers.hxx>
#include <xsd/cxx/tree/list.hxx>

#include <xsd/cxx/xml/dom/parsing-header.hxx>

#include "fpml-enum-4-2.hxx"

namespace FpML_4_2
{
  class HourMinuteTime: public ::xml_schema::time
  {
    public:
    // Constructors.
    //
    HourMinuteTime (const ::xml_schema::time&);

    HourMinuteTime (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    HourMinuteTime (const ::xercesc::DOMAttr& a,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    HourMinuteTime (const ::std::string& s,
                    const ::xercesc::DOMElement* e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    HourMinuteTime (const HourMinuteTime& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual HourMinuteTime*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~HourMinuteTime ();
  };

  class RestrictedPercentage: public ::xsd::cxx::tree::fundamental_base< ::xml_schema::decimal, char, ::xml_schema::simple_type, ::xsd::cxx::tree::schema_type::decimal >
  {
    public:
    // Constructors.
    //
    RestrictedPercentage (const ::xml_schema::decimal&);

    RestrictedPercentage (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    RestrictedPercentage (const ::xercesc::DOMAttr& a,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    RestrictedPercentage (const ::std::string& s,
                          const ::xercesc::DOMElement* e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    RestrictedPercentage (const RestrictedPercentage& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual RestrictedPercentage*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RestrictedPercentage ();
  };

  class Reference: public ::xml_schema::type
  {
    public:
    // href
    // 
    typedef ::xml_schema::idref href_type;
    typedef ::xsd::cxx::tree::traits< href_type, char > href_traits;

    const href_type&
    href () const;

    href_type&
    href ();

    void
    href (const href_type& x);

    void
    href (::std::auto_ptr< href_type > p);

    // Constructors.
    //
    Reference (const href_type&);

    Reference (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    Reference (const Reference& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual Reference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Reference ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< href_type > href_;
  };

  class AccountReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    AccountReference (const href_type&);

    AccountReference (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    AccountReference (const AccountReference& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual AccountReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AccountReference ();
  };

  class Address: public ::xml_schema::type
  {
    public:
    // streetAddress
    // 
    typedef ::FpML_4_2::StreetAddress streetAddress_type;
    typedef ::xsd::cxx::tree::optional< streetAddress_type > streetAddress_optional;
    typedef ::xsd::cxx::tree::traits< streetAddress_type, char > streetAddress_traits;

    const streetAddress_optional&
    streetAddress () const;

    streetAddress_optional&
    streetAddress ();

    void
    streetAddress (const streetAddress_type& x);

    void
    streetAddress (const streetAddress_optional& x);

    void
    streetAddress (::std::auto_ptr< streetAddress_type > p);

    // city
    // 
    typedef ::xml_schema::string city_type;
    typedef ::xsd::cxx::tree::optional< city_type > city_optional;
    typedef ::xsd::cxx::tree::traits< city_type, char > city_traits;

    const city_optional&
    city () const;

    city_optional&
    city ();

    void
    city (const city_type& x);

    void
    city (const city_optional& x);

    void
    city (::std::auto_ptr< city_type > p);

    // state
    // 
    typedef ::xml_schema::string state_type;
    typedef ::xsd::cxx::tree::optional< state_type > state_optional;
    typedef ::xsd::cxx::tree::traits< state_type, char > state_traits;

    const state_optional&
    state () const;

    state_optional&
    state ();

    void
    state (const state_type& x);

    void
    state (const state_optional& x);

    void
    state (::std::auto_ptr< state_type > p);

    // country
    // 
    typedef ::FpML_4_2::Country country_type;
    typedef ::xsd::cxx::tree::optional< country_type > country_optional;
    typedef ::xsd::cxx::tree::traits< country_type, char > country_traits;

    const country_optional&
    country () const;

    country_optional&
    country ();

    void
    country (const country_type& x);

    void
    country (const country_optional& x);

    void
    country (::std::auto_ptr< country_type > p);

    // postalCode
    // 
    typedef ::xml_schema::string postalCode_type;
    typedef ::xsd::cxx::tree::optional< postalCode_type > postalCode_optional;
    typedef ::xsd::cxx::tree::traits< postalCode_type, char > postalCode_traits;

    const postalCode_optional&
    postalCode () const;

    postalCode_optional&
    postalCode ();

    void
    postalCode (const postalCode_type& x);

    void
    postalCode (const postalCode_optional& x);

    void
    postalCode (::std::auto_ptr< postalCode_type > p);

    // Constructors.
    //
    Address ();

    Address (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Address (const Address& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Address*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Address ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    streetAddress_optional streetAddress_;
    city_optional city_;
    state_optional state_;
    country_optional country_;
    postalCode_optional postalCode_;
  };

  class AdjustableDate: public ::xml_schema::type
  {
    public:
    // unadjustedDate
    // 
    typedef ::FpML_4_2::IdentifiedDate unadjustedDate_type;
    typedef ::xsd::cxx::tree::traits< unadjustedDate_type, char > unadjustedDate_traits;

    const unadjustedDate_type&
    unadjustedDate () const;

    unadjustedDate_type&
    unadjustedDate ();

    void
    unadjustedDate (const unadjustedDate_type& x);

    void
    unadjustedDate (::std::auto_ptr< unadjustedDate_type > p);

    // dateAdjustments
    // 
    typedef ::FpML_4_2::BusinessDayAdjustments dateAdjustments_type;
    typedef ::xsd::cxx::tree::traits< dateAdjustments_type, char > dateAdjustments_traits;

    const dateAdjustments_type&
    dateAdjustments () const;

    dateAdjustments_type&
    dateAdjustments ();

    void
    dateAdjustments (const dateAdjustments_type& x);

    void
    dateAdjustments (::std::auto_ptr< dateAdjustments_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    AdjustableDate (const unadjustedDate_type&,
                    const dateAdjustments_type&);

    AdjustableDate (::std::auto_ptr< unadjustedDate_type >&,
                    ::std::auto_ptr< dateAdjustments_type >&);

    AdjustableDate (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    AdjustableDate (const AdjustableDate& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual AdjustableDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdjustableDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< unadjustedDate_type > unadjustedDate_;
    ::xsd::cxx::tree::one< dateAdjustments_type > dateAdjustments_;
    id_optional id_;
  };

  class AdjustableDate2: public ::xml_schema::type
  {
    public:
    // unadjustedDate
    // 
    typedef ::FpML_4_2::IdentifiedDate unadjustedDate_type;
    typedef ::xsd::cxx::tree::traits< unadjustedDate_type, char > unadjustedDate_traits;

    const unadjustedDate_type&
    unadjustedDate () const;

    unadjustedDate_type&
    unadjustedDate ();

    void
    unadjustedDate (const unadjustedDate_type& x);

    void
    unadjustedDate (::std::auto_ptr< unadjustedDate_type > p);

    // dateAdjustments
    // 
    typedef ::FpML_4_2::BusinessDayAdjustments dateAdjustments_type;
    typedef ::xsd::cxx::tree::optional< dateAdjustments_type > dateAdjustments_optional;
    typedef ::xsd::cxx::tree::traits< dateAdjustments_type, char > dateAdjustments_traits;

    const dateAdjustments_optional&
    dateAdjustments () const;

    dateAdjustments_optional&
    dateAdjustments ();

    void
    dateAdjustments (const dateAdjustments_type& x);

    void
    dateAdjustments (const dateAdjustments_optional& x);

    void
    dateAdjustments (::std::auto_ptr< dateAdjustments_type > p);

    // dateAdjustmentsReference
    // 
    typedef ::FpML_4_2::BusinessDayAdjustmentsReference dateAdjustmentsReference_type;
    typedef ::xsd::cxx::tree::optional< dateAdjustmentsReference_type > dateAdjustmentsReference_optional;
    typedef ::xsd::cxx::tree::traits< dateAdjustmentsReference_type, char > dateAdjustmentsReference_traits;

    const dateAdjustmentsReference_optional&
    dateAdjustmentsReference () const;

    dateAdjustmentsReference_optional&
    dateAdjustmentsReference ();

    void
    dateAdjustmentsReference (const dateAdjustmentsReference_type& x);

    void
    dateAdjustmentsReference (const dateAdjustmentsReference_optional& x);

    void
    dateAdjustmentsReference (::std::auto_ptr< dateAdjustmentsReference_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    AdjustableDate2 (const unadjustedDate_type&);

    AdjustableDate2 (::std::auto_ptr< unadjustedDate_type >&);

    AdjustableDate2 (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    AdjustableDate2 (const AdjustableDate2& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual AdjustableDate2*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdjustableDate2 ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< unadjustedDate_type > unadjustedDate_;
    dateAdjustments_optional dateAdjustments_;
    dateAdjustmentsReference_optional dateAdjustmentsReference_;
    id_optional id_;
  };

  class AdjustableDates: public ::xml_schema::type
  {
    public:
    // unadjustedDate
    // 
    typedef ::FpML_4_2::IdentifiedDate unadjustedDate_type;
    typedef ::xsd::cxx::tree::sequence< unadjustedDate_type > unadjustedDate_sequence;
    typedef unadjustedDate_sequence::iterator unadjustedDate_iterator;
    typedef unadjustedDate_sequence::const_iterator unadjustedDate_const_iterator;
    typedef ::xsd::cxx::tree::traits< unadjustedDate_type, char > unadjustedDate_traits;

    const unadjustedDate_sequence&
    unadjustedDate () const;

    unadjustedDate_sequence&
    unadjustedDate ();

    void
    unadjustedDate (const unadjustedDate_sequence& s);

    // dateAdjustments
    // 
    typedef ::FpML_4_2::BusinessDayAdjustments dateAdjustments_type;
    typedef ::xsd::cxx::tree::traits< dateAdjustments_type, char > dateAdjustments_traits;

    const dateAdjustments_type&
    dateAdjustments () const;

    dateAdjustments_type&
    dateAdjustments ();

    void
    dateAdjustments (const dateAdjustments_type& x);

    void
    dateAdjustments (::std::auto_ptr< dateAdjustments_type > p);

    // Constructors.
    //
    AdjustableDates (const dateAdjustments_type&);

    AdjustableDates (::std::auto_ptr< dateAdjustments_type >&);

    AdjustableDates (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    AdjustableDates (const AdjustableDates& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual AdjustableDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdjustableDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    unadjustedDate_sequence unadjustedDate_;
    ::xsd::cxx::tree::one< dateAdjustments_type > dateAdjustments_;
  };

  class AdjustableOrRelativeDate: public ::xml_schema::type
  {
    public:
    // adjustableDate
    // 
    typedef ::FpML_4_2::AdjustableDate adjustableDate_type;
    typedef ::xsd::cxx::tree::optional< adjustableDate_type > adjustableDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustableDate_type, char > adjustableDate_traits;

    const adjustableDate_optional&
    adjustableDate () const;

    adjustableDate_optional&
    adjustableDate ();

    void
    adjustableDate (const adjustableDate_type& x);

    void
    adjustableDate (const adjustableDate_optional& x);

    void
    adjustableDate (::std::auto_ptr< adjustableDate_type > p);

    // relativeDate
    // 
    typedef ::FpML_4_2::RelativeDateOffset relativeDate_type;
    typedef ::xsd::cxx::tree::optional< relativeDate_type > relativeDate_optional;
    typedef ::xsd::cxx::tree::traits< relativeDate_type, char > relativeDate_traits;

    const relativeDate_optional&
    relativeDate () const;

    relativeDate_optional&
    relativeDate ();

    void
    relativeDate (const relativeDate_type& x);

    void
    relativeDate (const relativeDate_optional& x);

    void
    relativeDate (::std::auto_ptr< relativeDate_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    AdjustableOrRelativeDate ();

    AdjustableOrRelativeDate (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    AdjustableOrRelativeDate (const AdjustableOrRelativeDate& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual AdjustableOrRelativeDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdjustableOrRelativeDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    adjustableDate_optional adjustableDate_;
    relativeDate_optional relativeDate_;
    id_optional id_;
  };

  class AdjustableOrRelativeDates: public ::xml_schema::type
  {
    public:
    // adjustableDates
    // 
    typedef ::FpML_4_2::AdjustableDates adjustableDates_type;
    typedef ::xsd::cxx::tree::optional< adjustableDates_type > adjustableDates_optional;
    typedef ::xsd::cxx::tree::traits< adjustableDates_type, char > adjustableDates_traits;

    const adjustableDates_optional&
    adjustableDates () const;

    adjustableDates_optional&
    adjustableDates ();

    void
    adjustableDates (const adjustableDates_type& x);

    void
    adjustableDates (const adjustableDates_optional& x);

    void
    adjustableDates (::std::auto_ptr< adjustableDates_type > p);

    // relativeDates
    // 
    typedef ::FpML_4_2::RelativeDates relativeDates_type;
    typedef ::xsd::cxx::tree::optional< relativeDates_type > relativeDates_optional;
    typedef ::xsd::cxx::tree::traits< relativeDates_type, char > relativeDates_traits;

    const relativeDates_optional&
    relativeDates () const;

    relativeDates_optional&
    relativeDates ();

    void
    relativeDates (const relativeDates_type& x);

    void
    relativeDates (const relativeDates_optional& x);

    void
    relativeDates (::std::auto_ptr< relativeDates_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    AdjustableOrRelativeDates ();

    AdjustableOrRelativeDates (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    AdjustableOrRelativeDates (const AdjustableOrRelativeDates& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual AdjustableOrRelativeDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdjustableOrRelativeDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    adjustableDates_optional adjustableDates_;
    relativeDates_optional relativeDates_;
    id_optional id_;
  };

  class AdjustableRelativeOrPeriodicDates: public ::xml_schema::type
  {
    public:
    // adjustableDates
    // 
    typedef ::FpML_4_2::AdjustableDates adjustableDates_type;
    typedef ::xsd::cxx::tree::optional< adjustableDates_type > adjustableDates_optional;
    typedef ::xsd::cxx::tree::traits< adjustableDates_type, char > adjustableDates_traits;

    const adjustableDates_optional&
    adjustableDates () const;

    adjustableDates_optional&
    adjustableDates ();

    void
    adjustableDates (const adjustableDates_type& x);

    void
    adjustableDates (const adjustableDates_optional& x);

    void
    adjustableDates (::std::auto_ptr< adjustableDates_type > p);

    // relativeDateSequence
    // 
    typedef ::FpML_4_2::RelativeDateSequence relativeDateSequence_type;
    typedef ::xsd::cxx::tree::optional< relativeDateSequence_type > relativeDateSequence_optional;
    typedef ::xsd::cxx::tree::traits< relativeDateSequence_type, char > relativeDateSequence_traits;

    const relativeDateSequence_optional&
    relativeDateSequence () const;

    relativeDateSequence_optional&
    relativeDateSequence ();

    void
    relativeDateSequence (const relativeDateSequence_type& x);

    void
    relativeDateSequence (const relativeDateSequence_optional& x);

    void
    relativeDateSequence (::std::auto_ptr< relativeDateSequence_type > p);

    // periodicDates
    // 
    typedef ::FpML_4_2::PeriodicDates periodicDates_type;
    typedef ::xsd::cxx::tree::optional< periodicDates_type > periodicDates_optional;
    typedef ::xsd::cxx::tree::traits< periodicDates_type, char > periodicDates_traits;

    const periodicDates_optional&
    periodicDates () const;

    periodicDates_optional&
    periodicDates ();

    void
    periodicDates (const periodicDates_type& x);

    void
    periodicDates (const periodicDates_optional& x);

    void
    periodicDates (::std::auto_ptr< periodicDates_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    AdjustableRelativeOrPeriodicDates ();

    AdjustableRelativeOrPeriodicDates (const ::xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    AdjustableRelativeOrPeriodicDates (const AdjustableRelativeOrPeriodicDates& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual AdjustableRelativeOrPeriodicDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdjustableRelativeOrPeriodicDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    adjustableDates_optional adjustableDates_;
    relativeDateSequence_optional relativeDateSequence_;
    periodicDates_optional periodicDates_;
    id_optional id_;
  };

  class Interval: public ::xml_schema::type
  {
    public:
    // periodMultiplier
    // 
    typedef ::xml_schema::integer periodMultiplier_type;
    typedef ::xsd::cxx::tree::traits< periodMultiplier_type, char > periodMultiplier_traits;

    const periodMultiplier_type&
    periodMultiplier () const;

    periodMultiplier_type&
    periodMultiplier ();

    void
    periodMultiplier (const periodMultiplier_type& x);

    // period
    // 
    typedef ::FpML_4_2::PeriodEnum period_type;
    typedef ::xsd::cxx::tree::traits< period_type, char > period_traits;

    const period_type&
    period () const;

    period_type&
    period ();

    void
    period (const period_type& x);

    void
    period (::std::auto_ptr< period_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Interval (const periodMultiplier_type&,
              const period_type&);

    Interval (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Interval (const Interval& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Interval*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Interval ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< periodMultiplier_type > periodMultiplier_;
    ::xsd::cxx::tree::one< period_type > period_;
    id_optional id_;
  };

  class Offset: public ::FpML_4_2::Interval
  {
    public:
    // dayType
    // 
    typedef ::FpML_4_2::DayTypeEnum dayType_type;
    typedef ::xsd::cxx::tree::optional< dayType_type > dayType_optional;
    typedef ::xsd::cxx::tree::traits< dayType_type, char > dayType_traits;

    const dayType_optional&
    dayType () const;

    dayType_optional&
    dayType ();

    void
    dayType (const dayType_type& x);

    void
    dayType (const dayType_optional& x);

    void
    dayType (::std::auto_ptr< dayType_type > p);

    // Constructors.
    //
    Offset (const periodMultiplier_type&,
            const period_type&);

    Offset (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Offset (const Offset& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Offset*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Offset ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    dayType_optional dayType_;
  };

  class RelativeDateOffset: public ::FpML_4_2::Offset
  {
    public:
    // businessDayConvention
    // 
    typedef ::FpML_4_2::BusinessDayConventionEnum businessDayConvention_type;
    typedef ::xsd::cxx::tree::traits< businessDayConvention_type, char > businessDayConvention_traits;

    const businessDayConvention_type&
    businessDayConvention () const;

    businessDayConvention_type&
    businessDayConvention ();

    void
    businessDayConvention (const businessDayConvention_type& x);

    void
    businessDayConvention (::std::auto_ptr< businessDayConvention_type > p);

    // businessCentersReference
    // 
    typedef ::FpML_4_2::BusinessCentersReference businessCentersReference_type;
    typedef ::xsd::cxx::tree::optional< businessCentersReference_type > businessCentersReference_optional;
    typedef ::xsd::cxx::tree::traits< businessCentersReference_type, char > businessCentersReference_traits;

    const businessCentersReference_optional&
    businessCentersReference () const;

    businessCentersReference_optional&
    businessCentersReference ();

    void
    businessCentersReference (const businessCentersReference_type& x);

    void
    businessCentersReference (const businessCentersReference_optional& x);

    void
    businessCentersReference (::std::auto_ptr< businessCentersReference_type > p);

    // businessCenters
    // 
    typedef ::FpML_4_2::BusinessCenters businessCenters_type;
    typedef ::xsd::cxx::tree::optional< businessCenters_type > businessCenters_optional;
    typedef ::xsd::cxx::tree::traits< businessCenters_type, char > businessCenters_traits;

    const businessCenters_optional&
    businessCenters () const;

    businessCenters_optional&
    businessCenters ();

    void
    businessCenters (const businessCenters_type& x);

    void
    businessCenters (const businessCenters_optional& x);

    void
    businessCenters (::std::auto_ptr< businessCenters_type > p);

    // dateRelativeTo
    // 
    typedef ::FpML_4_2::DateReference dateRelativeTo_type;
    typedef ::xsd::cxx::tree::traits< dateRelativeTo_type, char > dateRelativeTo_traits;

    const dateRelativeTo_type&
    dateRelativeTo () const;

    dateRelativeTo_type&
    dateRelativeTo ();

    void
    dateRelativeTo (const dateRelativeTo_type& x);

    void
    dateRelativeTo (::std::auto_ptr< dateRelativeTo_type > p);

    // Constructors.
    //
    RelativeDateOffset (const periodMultiplier_type&,
                        const period_type&,
                        const businessDayConvention_type&,
                        const dateRelativeTo_type&);

    RelativeDateOffset (const periodMultiplier_type&,
                        const period_type&,
                        const businessDayConvention_type&,
                        ::std::auto_ptr< dateRelativeTo_type >&);

    RelativeDateOffset (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    RelativeDateOffset (const RelativeDateOffset& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual RelativeDateOffset*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RelativeDateOffset ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< businessDayConvention_type > businessDayConvention_;
    businessCentersReference_optional businessCentersReference_;
    businessCenters_optional businessCenters_;
    ::xsd::cxx::tree::one< dateRelativeTo_type > dateRelativeTo_;
  };

  class AdjustedRelativeDateOffset: public ::FpML_4_2::RelativeDateOffset
  {
    public:
    // relativeDateAdjustments
    // 
    typedef ::FpML_4_2::BusinessDayAdjustments relativeDateAdjustments_type;
    typedef ::xsd::cxx::tree::optional< relativeDateAdjustments_type > relativeDateAdjustments_optional;
    typedef ::xsd::cxx::tree::traits< relativeDateAdjustments_type, char > relativeDateAdjustments_traits;

    const relativeDateAdjustments_optional&
    relativeDateAdjustments () const;

    relativeDateAdjustments_optional&
    relativeDateAdjustments ();

    void
    relativeDateAdjustments (const relativeDateAdjustments_type& x);

    void
    relativeDateAdjustments (const relativeDateAdjustments_optional& x);

    void
    relativeDateAdjustments (::std::auto_ptr< relativeDateAdjustments_type > p);

    // Constructors.
    //
    AdjustedRelativeDateOffset (const periodMultiplier_type&,
                                const period_type&,
                                const businessDayConvention_type&,
                                const dateRelativeTo_type&);

    AdjustedRelativeDateOffset (const periodMultiplier_type&,
                                const period_type&,
                                const businessDayConvention_type&,
                                ::std::auto_ptr< dateRelativeTo_type >&);

    AdjustedRelativeDateOffset (const ::xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    AdjustedRelativeDateOffset (const AdjustedRelativeDateOffset& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual AdjustedRelativeDateOffset*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AdjustedRelativeDateOffset ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    relativeDateAdjustments_optional relativeDateAdjustments_;
  };

  class Exercise: public ::xml_schema::type
  {
    public:
    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Exercise ();

    Exercise (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Exercise (const Exercise& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Exercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Exercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    id_optional id_;
  };

  class AmericanExercise: public ::FpML_4_2::Exercise
  {
    public:
    // commencementDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate commencementDate_type;
    typedef ::xsd::cxx::tree::traits< commencementDate_type, char > commencementDate_traits;

    const commencementDate_type&
    commencementDate () const;

    commencementDate_type&
    commencementDate ();

    void
    commencementDate (const commencementDate_type& x);

    void
    commencementDate (::std::auto_ptr< commencementDate_type > p);

    // expirationDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate expirationDate_type;
    typedef ::xsd::cxx::tree::traits< expirationDate_type, char > expirationDate_traits;

    const expirationDate_type&
    expirationDate () const;

    expirationDate_type&
    expirationDate ();

    void
    expirationDate (const expirationDate_type& x);

    void
    expirationDate (::std::auto_ptr< expirationDate_type > p);

    // relevantUnderlyingDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDates relevantUnderlyingDate_type;
    typedef ::xsd::cxx::tree::optional< relevantUnderlyingDate_type > relevantUnderlyingDate_optional;
    typedef ::xsd::cxx::tree::traits< relevantUnderlyingDate_type, char > relevantUnderlyingDate_traits;

    const relevantUnderlyingDate_optional&
    relevantUnderlyingDate () const;

    relevantUnderlyingDate_optional&
    relevantUnderlyingDate ();

    void
    relevantUnderlyingDate (const relevantUnderlyingDate_type& x);

    void
    relevantUnderlyingDate (const relevantUnderlyingDate_optional& x);

    void
    relevantUnderlyingDate (::std::auto_ptr< relevantUnderlyingDate_type > p);

    // earliestExerciseTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime earliestExerciseTime_type;
    typedef ::xsd::cxx::tree::traits< earliestExerciseTime_type, char > earliestExerciseTime_traits;

    const earliestExerciseTime_type&
    earliestExerciseTime () const;

    earliestExerciseTime_type&
    earliestExerciseTime ();

    void
    earliestExerciseTime (const earliestExerciseTime_type& x);

    void
    earliestExerciseTime (::std::auto_ptr< earliestExerciseTime_type > p);

    // latestExerciseTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime latestExerciseTime_type;
    typedef ::xsd::cxx::tree::optional< latestExerciseTime_type > latestExerciseTime_optional;
    typedef ::xsd::cxx::tree::traits< latestExerciseTime_type, char > latestExerciseTime_traits;

    const latestExerciseTime_optional&
    latestExerciseTime () const;

    latestExerciseTime_optional&
    latestExerciseTime ();

    void
    latestExerciseTime (const latestExerciseTime_type& x);

    void
    latestExerciseTime (const latestExerciseTime_optional& x);

    void
    latestExerciseTime (::std::auto_ptr< latestExerciseTime_type > p);

    // expirationTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime expirationTime_type;
    typedef ::xsd::cxx::tree::traits< expirationTime_type, char > expirationTime_traits;

    const expirationTime_type&
    expirationTime () const;

    expirationTime_type&
    expirationTime ();

    void
    expirationTime (const expirationTime_type& x);

    void
    expirationTime (::std::auto_ptr< expirationTime_type > p);

    // multipleExercise
    // 
    typedef ::FpML_4_2::MultipleExercise multipleExercise_type;
    typedef ::xsd::cxx::tree::optional< multipleExercise_type > multipleExercise_optional;
    typedef ::xsd::cxx::tree::traits< multipleExercise_type, char > multipleExercise_traits;

    const multipleExercise_optional&
    multipleExercise () const;

    multipleExercise_optional&
    multipleExercise ();

    void
    multipleExercise (const multipleExercise_type& x);

    void
    multipleExercise (const multipleExercise_optional& x);

    void
    multipleExercise (::std::auto_ptr< multipleExercise_type > p);

    // exerciseFeeSchedule
    // 
    typedef ::FpML_4_2::ExerciseFeeSchedule exerciseFeeSchedule_type;
    typedef ::xsd::cxx::tree::optional< exerciseFeeSchedule_type > exerciseFeeSchedule_optional;
    typedef ::xsd::cxx::tree::traits< exerciseFeeSchedule_type, char > exerciseFeeSchedule_traits;

    const exerciseFeeSchedule_optional&
    exerciseFeeSchedule () const;

    exerciseFeeSchedule_optional&
    exerciseFeeSchedule ();

    void
    exerciseFeeSchedule (const exerciseFeeSchedule_type& x);

    void
    exerciseFeeSchedule (const exerciseFeeSchedule_optional& x);

    void
    exerciseFeeSchedule (::std::auto_ptr< exerciseFeeSchedule_type > p);

    // Constructors.
    //
    AmericanExercise (const commencementDate_type&,
                      const expirationDate_type&,
                      const earliestExerciseTime_type&,
                      const expirationTime_type&);

    AmericanExercise (::std::auto_ptr< commencementDate_type >&,
                      ::std::auto_ptr< expirationDate_type >&,
                      ::std::auto_ptr< earliestExerciseTime_type >&,
                      ::std::auto_ptr< expirationTime_type >&);

    AmericanExercise (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    AmericanExercise (const AmericanExercise& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual AmericanExercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AmericanExercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< commencementDate_type > commencementDate_;
    ::xsd::cxx::tree::one< expirationDate_type > expirationDate_;
    relevantUnderlyingDate_optional relevantUnderlyingDate_;
    ::xsd::cxx::tree::one< earliestExerciseTime_type > earliestExerciseTime_;
    latestExerciseTime_optional latestExerciseTime_;
    ::xsd::cxx::tree::one< expirationTime_type > expirationTime_;
    multipleExercise_optional multipleExercise_;
    exerciseFeeSchedule_optional exerciseFeeSchedule_;
  };

  class AmountReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    AmountReference (const href_type&);

    AmountReference (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    AmountReference (const AmountReference& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual AmountReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AmountReference ();
  };

  class Schedule: public ::xml_schema::type
  {
    public:
    // initialValue
    // 
    typedef ::xml_schema::decimal initialValue_type;
    typedef ::xsd::cxx::tree::traits< initialValue_type, char, ::xsd::cxx::tree::schema_type::decimal > initialValue_traits;

    const initialValue_type&
    initialValue () const;

    initialValue_type&
    initialValue ();

    void
    initialValue (const initialValue_type& x);

    // step
    // 
    typedef ::FpML_4_2::Step step_type;
    typedef ::xsd::cxx::tree::sequence< step_type > step_sequence;
    typedef step_sequence::iterator step_iterator;
    typedef step_sequence::const_iterator step_const_iterator;
    typedef ::xsd::cxx::tree::traits< step_type, char > step_traits;

    const step_sequence&
    step () const;

    step_sequence&
    step ();

    void
    step (const step_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Schedule (const initialValue_type&);

    Schedule (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Schedule (const Schedule& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Schedule*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Schedule ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< initialValue_type > initialValue_;
    step_sequence step_;
    id_optional id_;
  };

  class AmountSchedule: public ::FpML_4_2::Schedule
  {
    public:
    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_type&
    currency () const;

    currency_type&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // Constructors.
    //
    AmountSchedule (const initialValue_type&,
                    const currency_type&);

    AmountSchedule (const initialValue_type&,
                    ::std::auto_ptr< currency_type >&);

    AmountSchedule (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    AmountSchedule (const AmountSchedule& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual AmountSchedule*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AmountSchedule ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< currency_type > currency_;
  };

  class AssetReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    AssetReference (const href_type&);

    AssetReference (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    AssetReference (const AssetReference& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual AssetReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AssetReference ();
  };

  class AutomaticExercise: public ::xml_schema::type
  {
    public:
    // thresholdRate
    // 
    typedef ::xml_schema::decimal thresholdRate_type;
    typedef ::xsd::cxx::tree::traits< thresholdRate_type, char, ::xsd::cxx::tree::schema_type::decimal > thresholdRate_traits;

    const thresholdRate_type&
    thresholdRate () const;

    thresholdRate_type&
    thresholdRate ();

    void
    thresholdRate (const thresholdRate_type& x);

    // Constructors.
    //
    AutomaticExercise (const thresholdRate_type&);

    AutomaticExercise (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    AutomaticExercise (const AutomaticExercise& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual AutomaticExercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~AutomaticExercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< thresholdRate_type > thresholdRate_;
  };

  class Routing: public ::xml_schema::type
  {
    public:
    // routingIds
    // 
    typedef ::FpML_4_2::RoutingIds routingIds_type;
    typedef ::xsd::cxx::tree::optional< routingIds_type > routingIds_optional;
    typedef ::xsd::cxx::tree::traits< routingIds_type, char > routingIds_traits;

    const routingIds_optional&
    routingIds () const;

    routingIds_optional&
    routingIds ();

    void
    routingIds (const routingIds_type& x);

    void
    routingIds (const routingIds_optional& x);

    void
    routingIds (::std::auto_ptr< routingIds_type > p);

    // routingExplicitDetails
    // 
    typedef ::FpML_4_2::RoutingExplicitDetails routingExplicitDetails_type;
    typedef ::xsd::cxx::tree::optional< routingExplicitDetails_type > routingExplicitDetails_optional;
    typedef ::xsd::cxx::tree::traits< routingExplicitDetails_type, char > routingExplicitDetails_traits;

    const routingExplicitDetails_optional&
    routingExplicitDetails () const;

    routingExplicitDetails_optional&
    routingExplicitDetails ();

    void
    routingExplicitDetails (const routingExplicitDetails_type& x);

    void
    routingExplicitDetails (const routingExplicitDetails_optional& x);

    void
    routingExplicitDetails (::std::auto_ptr< routingExplicitDetails_type > p);

    // routingIdsAndExplicitDetails
    // 
    typedef ::FpML_4_2::RoutingIdsAndExplicitDetails routingIdsAndExplicitDetails_type;
    typedef ::xsd::cxx::tree::optional< routingIdsAndExplicitDetails_type > routingIdsAndExplicitDetails_optional;
    typedef ::xsd::cxx::tree::traits< routingIdsAndExplicitDetails_type, char > routingIdsAndExplicitDetails_traits;

    const routingIdsAndExplicitDetails_optional&
    routingIdsAndExplicitDetails () const;

    routingIdsAndExplicitDetails_optional&
    routingIdsAndExplicitDetails ();

    void
    routingIdsAndExplicitDetails (const routingIdsAndExplicitDetails_type& x);

    void
    routingIdsAndExplicitDetails (const routingIdsAndExplicitDetails_optional& x);

    void
    routingIdsAndExplicitDetails (::std::auto_ptr< routingIdsAndExplicitDetails_type > p);

    // Constructors.
    //
    Routing ();

    Routing (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Routing (const Routing& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Routing*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Routing ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    routingIds_optional routingIds_;
    routingExplicitDetails_optional routingExplicitDetails_;
    routingIdsAndExplicitDetails_optional routingIdsAndExplicitDetails_;
  };

  class Beneficiary: public ::FpML_4_2::Routing
  {
    public:
    // beneficiaryPartyReference
    // 
    typedef ::FpML_4_2::PartyReference beneficiaryPartyReference_type;
    typedef ::xsd::cxx::tree::optional< beneficiaryPartyReference_type > beneficiaryPartyReference_optional;
    typedef ::xsd::cxx::tree::traits< beneficiaryPartyReference_type, char > beneficiaryPartyReference_traits;

    const beneficiaryPartyReference_optional&
    beneficiaryPartyReference () const;

    beneficiaryPartyReference_optional&
    beneficiaryPartyReference ();

    void
    beneficiaryPartyReference (const beneficiaryPartyReference_type& x);

    void
    beneficiaryPartyReference (const beneficiaryPartyReference_optional& x);

    void
    beneficiaryPartyReference (::std::auto_ptr< beneficiaryPartyReference_type > p);

    // Constructors.
    //
    Beneficiary ();

    Beneficiary (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    Beneficiary (const Beneficiary& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual Beneficiary*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Beneficiary ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    beneficiaryPartyReference_optional beneficiaryPartyReference_;
  };

  class BermudaExercise: public ::FpML_4_2::Exercise
  {
    public:
    // bermudaExerciseDates
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDates bermudaExerciseDates_type;
    typedef ::xsd::cxx::tree::traits< bermudaExerciseDates_type, char > bermudaExerciseDates_traits;

    const bermudaExerciseDates_type&
    bermudaExerciseDates () const;

    bermudaExerciseDates_type&
    bermudaExerciseDates ();

    void
    bermudaExerciseDates (const bermudaExerciseDates_type& x);

    void
    bermudaExerciseDates (::std::auto_ptr< bermudaExerciseDates_type > p);

    // relevantUnderlyingDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDates relevantUnderlyingDate_type;
    typedef ::xsd::cxx::tree::optional< relevantUnderlyingDate_type > relevantUnderlyingDate_optional;
    typedef ::xsd::cxx::tree::traits< relevantUnderlyingDate_type, char > relevantUnderlyingDate_traits;

    const relevantUnderlyingDate_optional&
    relevantUnderlyingDate () const;

    relevantUnderlyingDate_optional&
    relevantUnderlyingDate ();

    void
    relevantUnderlyingDate (const relevantUnderlyingDate_type& x);

    void
    relevantUnderlyingDate (const relevantUnderlyingDate_optional& x);

    void
    relevantUnderlyingDate (::std::auto_ptr< relevantUnderlyingDate_type > p);

    // earliestExerciseTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime earliestExerciseTime_type;
    typedef ::xsd::cxx::tree::traits< earliestExerciseTime_type, char > earliestExerciseTime_traits;

    const earliestExerciseTime_type&
    earliestExerciseTime () const;

    earliestExerciseTime_type&
    earliestExerciseTime ();

    void
    earliestExerciseTime (const earliestExerciseTime_type& x);

    void
    earliestExerciseTime (::std::auto_ptr< earliestExerciseTime_type > p);

    // latestExerciseTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime latestExerciseTime_type;
    typedef ::xsd::cxx::tree::optional< latestExerciseTime_type > latestExerciseTime_optional;
    typedef ::xsd::cxx::tree::traits< latestExerciseTime_type, char > latestExerciseTime_traits;

    const latestExerciseTime_optional&
    latestExerciseTime () const;

    latestExerciseTime_optional&
    latestExerciseTime ();

    void
    latestExerciseTime (const latestExerciseTime_type& x);

    void
    latestExerciseTime (const latestExerciseTime_optional& x);

    void
    latestExerciseTime (::std::auto_ptr< latestExerciseTime_type > p);

    // expirationTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime expirationTime_type;
    typedef ::xsd::cxx::tree::traits< expirationTime_type, char > expirationTime_traits;

    const expirationTime_type&
    expirationTime () const;

    expirationTime_type&
    expirationTime ();

    void
    expirationTime (const expirationTime_type& x);

    void
    expirationTime (::std::auto_ptr< expirationTime_type > p);

    // multipleExercise
    // 
    typedef ::FpML_4_2::MultipleExercise multipleExercise_type;
    typedef ::xsd::cxx::tree::optional< multipleExercise_type > multipleExercise_optional;
    typedef ::xsd::cxx::tree::traits< multipleExercise_type, char > multipleExercise_traits;

    const multipleExercise_optional&
    multipleExercise () const;

    multipleExercise_optional&
    multipleExercise ();

    void
    multipleExercise (const multipleExercise_type& x);

    void
    multipleExercise (const multipleExercise_optional& x);

    void
    multipleExercise (::std::auto_ptr< multipleExercise_type > p);

    // exerciseFeeSchedule
    // 
    typedef ::FpML_4_2::ExerciseFeeSchedule exerciseFeeSchedule_type;
    typedef ::xsd::cxx::tree::optional< exerciseFeeSchedule_type > exerciseFeeSchedule_optional;
    typedef ::xsd::cxx::tree::traits< exerciseFeeSchedule_type, char > exerciseFeeSchedule_traits;

    const exerciseFeeSchedule_optional&
    exerciseFeeSchedule () const;

    exerciseFeeSchedule_optional&
    exerciseFeeSchedule ();

    void
    exerciseFeeSchedule (const exerciseFeeSchedule_type& x);

    void
    exerciseFeeSchedule (const exerciseFeeSchedule_optional& x);

    void
    exerciseFeeSchedule (::std::auto_ptr< exerciseFeeSchedule_type > p);

    // Constructors.
    //
    BermudaExercise (const bermudaExerciseDates_type&,
                     const earliestExerciseTime_type&,
                     const expirationTime_type&);

    BermudaExercise (::std::auto_ptr< bermudaExerciseDates_type >&,
                     ::std::auto_ptr< earliestExerciseTime_type >&,
                     ::std::auto_ptr< expirationTime_type >&);

    BermudaExercise (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    BermudaExercise (const BermudaExercise& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual BermudaExercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BermudaExercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< bermudaExerciseDates_type > bermudaExerciseDates_;
    relevantUnderlyingDate_optional relevantUnderlyingDate_;
    ::xsd::cxx::tree::one< earliestExerciseTime_type > earliestExerciseTime_;
    latestExerciseTime_optional latestExerciseTime_;
    ::xsd::cxx::tree::one< expirationTime_type > expirationTime_;
    multipleExercise_optional multipleExercise_;
    exerciseFeeSchedule_optional exerciseFeeSchedule_;
  };

  class BrokerConfirmation: public ::xml_schema::type
  {
    public:
    // brokerConfirmationType
    // 
    typedef ::FpML_4_2::BrokerConfirmationType brokerConfirmationType_type;
    typedef ::xsd::cxx::tree::traits< brokerConfirmationType_type, char > brokerConfirmationType_traits;

    const brokerConfirmationType_type&
    brokerConfirmationType () const;

    brokerConfirmationType_type&
    brokerConfirmationType ();

    void
    brokerConfirmationType (const brokerConfirmationType_type& x);

    void
    brokerConfirmationType (::std::auto_ptr< brokerConfirmationType_type > p);

    // Constructors.
    //
    BrokerConfirmation (const brokerConfirmationType_type&);

    BrokerConfirmation (::std::auto_ptr< brokerConfirmationType_type >&);

    BrokerConfirmation (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    BrokerConfirmation (const BrokerConfirmation& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual BrokerConfirmation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BrokerConfirmation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< brokerConfirmationType_type > brokerConfirmationType_;
  };

  class BrokerConfirmationType: public ::xml_schema::normalized_string
  {
    public:
    // brokerConfirmationTypeScheme
    // 
    typedef ::xml_schema::uri brokerConfirmationTypeScheme_type;
    typedef ::xsd::cxx::tree::traits< brokerConfirmationTypeScheme_type, char > brokerConfirmationTypeScheme_traits;

    const brokerConfirmationTypeScheme_type&
    brokerConfirmationTypeScheme () const;

    brokerConfirmationTypeScheme_type&
    brokerConfirmationTypeScheme ();

    void
    brokerConfirmationTypeScheme (const brokerConfirmationTypeScheme_type& x);

    void
    brokerConfirmationTypeScheme (::std::auto_ptr< brokerConfirmationTypeScheme_type > p);

    static const brokerConfirmationTypeScheme_type&
    brokerConfirmationTypeScheme_default_value ();

    // Constructors.
    //
    BrokerConfirmationType ();

    BrokerConfirmationType (const char*);

    BrokerConfirmationType (const ::std::string&);

    BrokerConfirmationType (const ::xml_schema::normalized_string&);

    BrokerConfirmationType (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    BrokerConfirmationType (const BrokerConfirmationType& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual BrokerConfirmationType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BrokerConfirmationType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< brokerConfirmationTypeScheme_type > brokerConfirmationTypeScheme_;
    static const brokerConfirmationTypeScheme_type brokerConfirmationTypeScheme_default_value_;
  };

  class BusinessCenter: public ::xml_schema::normalized_string
  {
    public:
    // businessCenterScheme
    // 
    typedef ::xml_schema::uri businessCenterScheme_type;
    typedef ::xsd::cxx::tree::traits< businessCenterScheme_type, char > businessCenterScheme_traits;

    const businessCenterScheme_type&
    businessCenterScheme () const;

    businessCenterScheme_type&
    businessCenterScheme ();

    void
    businessCenterScheme (const businessCenterScheme_type& x);

    void
    businessCenterScheme (::std::auto_ptr< businessCenterScheme_type > p);

    static const businessCenterScheme_type&
    businessCenterScheme_default_value ();

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    BusinessCenter ();

    BusinessCenter (const char*);

    BusinessCenter (const ::std::string&);

    BusinessCenter (const ::xml_schema::normalized_string&);

    BusinessCenter (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    BusinessCenter (const BusinessCenter& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual BusinessCenter*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BusinessCenter ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< businessCenterScheme_type > businessCenterScheme_;
    static const businessCenterScheme_type businessCenterScheme_default_value_;
    id_optional id_;
  };

  class BusinessCenters: public ::xml_schema::type
  {
    public:
    // businessCenter
    // 
    typedef ::FpML_4_2::BusinessCenter businessCenter_type;
    typedef ::xsd::cxx::tree::sequence< businessCenter_type > businessCenter_sequence;
    typedef businessCenter_sequence::iterator businessCenter_iterator;
    typedef businessCenter_sequence::const_iterator businessCenter_const_iterator;
    typedef ::xsd::cxx::tree::traits< businessCenter_type, char > businessCenter_traits;

    const businessCenter_sequence&
    businessCenter () const;

    businessCenter_sequence&
    businessCenter ();

    void
    businessCenter (const businessCenter_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    BusinessCenters ();

    BusinessCenters (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    BusinessCenters (const BusinessCenters& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual BusinessCenters*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BusinessCenters ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    businessCenter_sequence businessCenter_;
    id_optional id_;
  };

  class BusinessCentersReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    BusinessCentersReference (const href_type&);

    BusinessCentersReference (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    BusinessCentersReference (const BusinessCentersReference& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual BusinessCentersReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BusinessCentersReference ();
  };

  class BusinessCenterTime: public ::xml_schema::type
  {
    public:
    // hourMinuteTime
    // 
    typedef ::FpML_4_2::HourMinuteTime hourMinuteTime_type;
    typedef ::xsd::cxx::tree::traits< hourMinuteTime_type, char > hourMinuteTime_traits;

    const hourMinuteTime_type&
    hourMinuteTime () const;

    hourMinuteTime_type&
    hourMinuteTime ();

    void
    hourMinuteTime (const hourMinuteTime_type& x);

    void
    hourMinuteTime (::std::auto_ptr< hourMinuteTime_type > p);

    // businessCenter
    // 
    typedef ::FpML_4_2::BusinessCenter businessCenter_type;
    typedef ::xsd::cxx::tree::traits< businessCenter_type, char > businessCenter_traits;

    const businessCenter_type&
    businessCenter () const;

    businessCenter_type&
    businessCenter ();

    void
    businessCenter (const businessCenter_type& x);

    void
    businessCenter (::std::auto_ptr< businessCenter_type > p);

    // Constructors.
    //
    BusinessCenterTime (const hourMinuteTime_type&,
                        const businessCenter_type&);

    BusinessCenterTime (const hourMinuteTime_type&,
                        ::std::auto_ptr< businessCenter_type >&);

    BusinessCenterTime (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    BusinessCenterTime (const BusinessCenterTime& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual BusinessCenterTime*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BusinessCenterTime ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< hourMinuteTime_type > hourMinuteTime_;
    ::xsd::cxx::tree::one< businessCenter_type > businessCenter_;
  };

  class DateRange: public ::xml_schema::type
  {
    public:
    // unadjustedFirstDate
    // 
    typedef ::xml_schema::date unadjustedFirstDate_type;
    typedef ::xsd::cxx::tree::traits< unadjustedFirstDate_type, char > unadjustedFirstDate_traits;

    const unadjustedFirstDate_type&
    unadjustedFirstDate () const;

    unadjustedFirstDate_type&
    unadjustedFirstDate ();

    void
    unadjustedFirstDate (const unadjustedFirstDate_type& x);

    void
    unadjustedFirstDate (::std::auto_ptr< unadjustedFirstDate_type > p);

    // unadjustedLastDate
    // 
    typedef ::xml_schema::date unadjustedLastDate_type;
    typedef ::xsd::cxx::tree::traits< unadjustedLastDate_type, char > unadjustedLastDate_traits;

    const unadjustedLastDate_type&
    unadjustedLastDate () const;

    unadjustedLastDate_type&
    unadjustedLastDate ();

    void
    unadjustedLastDate (const unadjustedLastDate_type& x);

    void
    unadjustedLastDate (::std::auto_ptr< unadjustedLastDate_type > p);

    // Constructors.
    //
    DateRange (const unadjustedFirstDate_type&,
               const unadjustedLastDate_type&);

    DateRange (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    DateRange (const DateRange& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual DateRange*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DateRange ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< unadjustedFirstDate_type > unadjustedFirstDate_;
    ::xsd::cxx::tree::one< unadjustedLastDate_type > unadjustedLastDate_;
  };

  class BusinessDateRange: public ::FpML_4_2::DateRange
  {
    public:
    // businessDayConvention
    // 
    typedef ::FpML_4_2::BusinessDayConventionEnum businessDayConvention_type;
    typedef ::xsd::cxx::tree::traits< businessDayConvention_type, char > businessDayConvention_traits;

    const businessDayConvention_type&
    businessDayConvention () const;

    businessDayConvention_type&
    businessDayConvention ();

    void
    businessDayConvention (const businessDayConvention_type& x);

    void
    businessDayConvention (::std::auto_ptr< businessDayConvention_type > p);

    // businessCentersReference
    // 
    typedef ::FpML_4_2::BusinessCentersReference businessCentersReference_type;
    typedef ::xsd::cxx::tree::optional< businessCentersReference_type > businessCentersReference_optional;
    typedef ::xsd::cxx::tree::traits< businessCentersReference_type, char > businessCentersReference_traits;

    const businessCentersReference_optional&
    businessCentersReference () const;

    businessCentersReference_optional&
    businessCentersReference ();

    void
    businessCentersReference (const businessCentersReference_type& x);

    void
    businessCentersReference (const businessCentersReference_optional& x);

    void
    businessCentersReference (::std::auto_ptr< businessCentersReference_type > p);

    // businessCenters
    // 
    typedef ::FpML_4_2::BusinessCenters businessCenters_type;
    typedef ::xsd::cxx::tree::optional< businessCenters_type > businessCenters_optional;
    typedef ::xsd::cxx::tree::traits< businessCenters_type, char > businessCenters_traits;

    const businessCenters_optional&
    businessCenters () const;

    businessCenters_optional&
    businessCenters ();

    void
    businessCenters (const businessCenters_type& x);

    void
    businessCenters (const businessCenters_optional& x);

    void
    businessCenters (::std::auto_ptr< businessCenters_type > p);

    // Constructors.
    //
    BusinessDateRange (const unadjustedFirstDate_type&,
                       const unadjustedLastDate_type&,
                       const businessDayConvention_type&);

    BusinessDateRange (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    BusinessDateRange (const BusinessDateRange& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual BusinessDateRange*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BusinessDateRange ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< businessDayConvention_type > businessDayConvention_;
    businessCentersReference_optional businessCentersReference_;
    businessCenters_optional businessCenters_;
  };

  class BusinessDayAdjustments: public ::xml_schema::type
  {
    public:
    // businessDayConvention
    // 
    typedef ::FpML_4_2::BusinessDayConventionEnum businessDayConvention_type;
    typedef ::xsd::cxx::tree::traits< businessDayConvention_type, char > businessDayConvention_traits;

    const businessDayConvention_type&
    businessDayConvention () const;

    businessDayConvention_type&
    businessDayConvention ();

    void
    businessDayConvention (const businessDayConvention_type& x);

    void
    businessDayConvention (::std::auto_ptr< businessDayConvention_type > p);

    // businessCentersReference
    // 
    typedef ::FpML_4_2::BusinessCentersReference businessCentersReference_type;
    typedef ::xsd::cxx::tree::optional< businessCentersReference_type > businessCentersReference_optional;
    typedef ::xsd::cxx::tree::traits< businessCentersReference_type, char > businessCentersReference_traits;

    const businessCentersReference_optional&
    businessCentersReference () const;

    businessCentersReference_optional&
    businessCentersReference ();

    void
    businessCentersReference (const businessCentersReference_type& x);

    void
    businessCentersReference (const businessCentersReference_optional& x);

    void
    businessCentersReference (::std::auto_ptr< businessCentersReference_type > p);

    // businessCenters
    // 
    typedef ::FpML_4_2::BusinessCenters businessCenters_type;
    typedef ::xsd::cxx::tree::optional< businessCenters_type > businessCenters_optional;
    typedef ::xsd::cxx::tree::traits< businessCenters_type, char > businessCenters_traits;

    const businessCenters_optional&
    businessCenters () const;

    businessCenters_optional&
    businessCenters ();

    void
    businessCenters (const businessCenters_type& x);

    void
    businessCenters (const businessCenters_optional& x);

    void
    businessCenters (::std::auto_ptr< businessCenters_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    BusinessDayAdjustments (const businessDayConvention_type&);

    BusinessDayAdjustments (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    BusinessDayAdjustments (const BusinessDayAdjustments& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual BusinessDayAdjustments*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BusinessDayAdjustments ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< businessDayConvention_type > businessDayConvention_;
    businessCentersReference_optional businessCentersReference_;
    businessCenters_optional businessCenters_;
    id_optional id_;
  };

  class BusinessDayAdjustmentsReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    BusinessDayAdjustmentsReference (const href_type&);

    BusinessDayAdjustmentsReference (const ::xercesc::DOMElement& e,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    BusinessDayAdjustmentsReference (const BusinessDayAdjustmentsReference& x,
                                     ::xml_schema::flags f = 0,
                                     ::xml_schema::container* c = 0);

    virtual BusinessDayAdjustmentsReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~BusinessDayAdjustmentsReference ();
  };

  class CalculationAgent: public ::xml_schema::type
  {
    public:
    // calculationAgentPartyReference
    // 
    typedef ::FpML_4_2::PartyReference calculationAgentPartyReference_type;
    typedef ::xsd::cxx::tree::sequence< calculationAgentPartyReference_type > calculationAgentPartyReference_sequence;
    typedef calculationAgentPartyReference_sequence::iterator calculationAgentPartyReference_iterator;
    typedef calculationAgentPartyReference_sequence::const_iterator calculationAgentPartyReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< calculationAgentPartyReference_type, char > calculationAgentPartyReference_traits;

    const calculationAgentPartyReference_sequence&
    calculationAgentPartyReference () const;

    calculationAgentPartyReference_sequence&
    calculationAgentPartyReference ();

    void
    calculationAgentPartyReference (const calculationAgentPartyReference_sequence& s);

    // calculationAgentParty
    // 
    typedef ::FpML_4_2::CalculationAgentPartyEnum calculationAgentParty_type;
    typedef ::xsd::cxx::tree::optional< calculationAgentParty_type > calculationAgentParty_optional;
    typedef ::xsd::cxx::tree::traits< calculationAgentParty_type, char > calculationAgentParty_traits;

    const calculationAgentParty_optional&
    calculationAgentParty () const;

    calculationAgentParty_optional&
    calculationAgentParty ();

    void
    calculationAgentParty (const calculationAgentParty_type& x);

    void
    calculationAgentParty (const calculationAgentParty_optional& x);

    void
    calculationAgentParty (::std::auto_ptr< calculationAgentParty_type > p);

    // Constructors.
    //
    CalculationAgent ();

    CalculationAgent (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    CalculationAgent (const CalculationAgent& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual CalculationAgent*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CalculationAgent ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    calculationAgentPartyReference_sequence calculationAgentPartyReference_;
    calculationAgentParty_optional calculationAgentParty_;
  };

  class CalculationPeriodFrequency: public ::FpML_4_2::Interval
  {
    public:
    // rollConvention
    // 
    typedef ::FpML_4_2::RollConventionEnum rollConvention_type;
    typedef ::xsd::cxx::tree::traits< rollConvention_type, char > rollConvention_traits;

    const rollConvention_type&
    rollConvention () const;

    rollConvention_type&
    rollConvention ();

    void
    rollConvention (const rollConvention_type& x);

    void
    rollConvention (::std::auto_ptr< rollConvention_type > p);

    // Constructors.
    //
    CalculationPeriodFrequency (const periodMultiplier_type&,
                                const period_type&,
                                const rollConvention_type&);

    CalculationPeriodFrequency (const ::xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    CalculationPeriodFrequency (const CalculationPeriodFrequency& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual CalculationPeriodFrequency*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CalculationPeriodFrequency ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< rollConvention_type > rollConvention_;
  };

  class CashflowType: public ::xml_schema::normalized_string
  {
    public:
    // cashflowTypeScheme
    // 
    typedef ::xml_schema::uri cashflowTypeScheme_type;
    typedef ::xsd::cxx::tree::traits< cashflowTypeScheme_type, char > cashflowTypeScheme_traits;

    const cashflowTypeScheme_type&
    cashflowTypeScheme () const;

    cashflowTypeScheme_type&
    cashflowTypeScheme ();

    void
    cashflowTypeScheme (const cashflowTypeScheme_type& x);

    void
    cashflowTypeScheme (::std::auto_ptr< cashflowTypeScheme_type > p);

    static const cashflowTypeScheme_type&
    cashflowTypeScheme_default_value ();

    // Constructors.
    //
    CashflowType ();

    CashflowType (const char*);

    CashflowType (const ::std::string&);

    CashflowType (const ::xml_schema::normalized_string&);

    CashflowType (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    CashflowType (const CashflowType& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual CashflowType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CashflowType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< cashflowTypeScheme_type > cashflowTypeScheme_;
    static const cashflowTypeScheme_type cashflowTypeScheme_default_value_;
  };

  class CashSettlementReferenceBanks: public ::xml_schema::type
  {
    public:
    // referenceBank
    // 
    typedef ::FpML_4_2::ReferenceBank referenceBank_type;
    typedef ::xsd::cxx::tree::sequence< referenceBank_type > referenceBank_sequence;
    typedef referenceBank_sequence::iterator referenceBank_iterator;
    typedef referenceBank_sequence::const_iterator referenceBank_const_iterator;
    typedef ::xsd::cxx::tree::traits< referenceBank_type, char > referenceBank_traits;

    const referenceBank_sequence&
    referenceBank () const;

    referenceBank_sequence&
    referenceBank ();

    void
    referenceBank (const referenceBank_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    CashSettlementReferenceBanks ();

    CashSettlementReferenceBanks (const ::xercesc::DOMElement& e,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    CashSettlementReferenceBanks (const CashSettlementReferenceBanks& x,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    virtual CashSettlementReferenceBanks*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CashSettlementReferenceBanks ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    referenceBank_sequence referenceBank_;
    id_optional id_;
  };

  class ClearanceSystem: public ::xml_schema::normalized_string
  {
    public:
    // clearanceSystemScheme
    // 
    typedef ::xml_schema::uri clearanceSystemScheme_type;
    typedef ::xsd::cxx::tree::traits< clearanceSystemScheme_type, char > clearanceSystemScheme_traits;

    const clearanceSystemScheme_type&
    clearanceSystemScheme () const;

    clearanceSystemScheme_type&
    clearanceSystemScheme ();

    void
    clearanceSystemScheme (const clearanceSystemScheme_type& x);

    void
    clearanceSystemScheme (::std::auto_ptr< clearanceSystemScheme_type > p);

    static const clearanceSystemScheme_type&
    clearanceSystemScheme_default_value ();

    // Constructors.
    //
    ClearanceSystem ();

    ClearanceSystem (const char*);

    ClearanceSystem (const ::std::string&);

    ClearanceSystem (const ::xml_schema::normalized_string&);

    ClearanceSystem (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    ClearanceSystem (const ClearanceSystem& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual ClearanceSystem*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ClearanceSystem ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< clearanceSystemScheme_type > clearanceSystemScheme_;
    static const clearanceSystemScheme_type clearanceSystemScheme_default_value_;
  };

  class ContractualDefinitions: public ::xml_schema::normalized_string
  {
    public:
    // contractualDefinitionsScheme
    // 
    typedef ::xml_schema::uri contractualDefinitionsScheme_type;
    typedef ::xsd::cxx::tree::traits< contractualDefinitionsScheme_type, char > contractualDefinitionsScheme_traits;

    const contractualDefinitionsScheme_type&
    contractualDefinitionsScheme () const;

    contractualDefinitionsScheme_type&
    contractualDefinitionsScheme ();

    void
    contractualDefinitionsScheme (const contractualDefinitionsScheme_type& x);

    void
    contractualDefinitionsScheme (::std::auto_ptr< contractualDefinitionsScheme_type > p);

    static const contractualDefinitionsScheme_type&
    contractualDefinitionsScheme_default_value ();

    // Constructors.
    //
    ContractualDefinitions ();

    ContractualDefinitions (const char*);

    ContractualDefinitions (const ::std::string&);

    ContractualDefinitions (const ::xml_schema::normalized_string&);

    ContractualDefinitions (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    ContractualDefinitions (const ContractualDefinitions& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual ContractualDefinitions*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ContractualDefinitions ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< contractualDefinitionsScheme_type > contractualDefinitionsScheme_;
    static const contractualDefinitionsScheme_type contractualDefinitionsScheme_default_value_;
  };

  class ContractualMatrix: public ::xml_schema::type
  {
    public:
    // matrixType
    // 
    typedef ::FpML_4_2::MatrixType matrixType_type;
    typedef ::xsd::cxx::tree::traits< matrixType_type, char > matrixType_traits;

    const matrixType_type&
    matrixType () const;

    matrixType_type&
    matrixType ();

    void
    matrixType (const matrixType_type& x);

    void
    matrixType (::std::auto_ptr< matrixType_type > p);

    // publicationDate
    // 
    typedef ::xml_schema::date publicationDate_type;
    typedef ::xsd::cxx::tree::optional< publicationDate_type > publicationDate_optional;
    typedef ::xsd::cxx::tree::traits< publicationDate_type, char > publicationDate_traits;

    const publicationDate_optional&
    publicationDate () const;

    publicationDate_optional&
    publicationDate ();

    void
    publicationDate (const publicationDate_type& x);

    void
    publicationDate (const publicationDate_optional& x);

    void
    publicationDate (::std::auto_ptr< publicationDate_type > p);

    // matrixTerm
    // 
    typedef ::FpML_4_2::MatrixTerm matrixTerm_type;
    typedef ::xsd::cxx::tree::optional< matrixTerm_type > matrixTerm_optional;
    typedef ::xsd::cxx::tree::traits< matrixTerm_type, char > matrixTerm_traits;

    const matrixTerm_optional&
    matrixTerm () const;

    matrixTerm_optional&
    matrixTerm ();

    void
    matrixTerm (const matrixTerm_type& x);

    void
    matrixTerm (const matrixTerm_optional& x);

    void
    matrixTerm (::std::auto_ptr< matrixTerm_type > p);

    // Constructors.
    //
    ContractualMatrix (const matrixType_type&);

    ContractualMatrix (::std::auto_ptr< matrixType_type >&);

    ContractualMatrix (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ContractualMatrix (const ContractualMatrix& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual ContractualMatrix*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ContractualMatrix ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< matrixType_type > matrixType_;
    publicationDate_optional publicationDate_;
    matrixTerm_optional matrixTerm_;
  };

  class ContractualSupplement: public ::xml_schema::normalized_string
  {
    public:
    // contractualSupplementScheme
    // 
    typedef ::xml_schema::uri contractualSupplementScheme_type;
    typedef ::xsd::cxx::tree::traits< contractualSupplementScheme_type, char > contractualSupplementScheme_traits;

    const contractualSupplementScheme_type&
    contractualSupplementScheme () const;

    contractualSupplementScheme_type&
    contractualSupplementScheme ();

    void
    contractualSupplementScheme (const contractualSupplementScheme_type& x);

    void
    contractualSupplementScheme (::std::auto_ptr< contractualSupplementScheme_type > p);

    static const contractualSupplementScheme_type&
    contractualSupplementScheme_default_value ();

    // Constructors.
    //
    ContractualSupplement ();

    ContractualSupplement (const char*);

    ContractualSupplement (const ::std::string&);

    ContractualSupplement (const ::xml_schema::normalized_string&);

    ContractualSupplement (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    ContractualSupplement (const ContractualSupplement& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual ContractualSupplement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ContractualSupplement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< contractualSupplementScheme_type > contractualSupplementScheme_;
    static const contractualSupplementScheme_type contractualSupplementScheme_default_value_;
  };

  class ContractualTermsSupplement: public ::xml_schema::type
  {
    public:
    // type
    // 
    typedef ::FpML_4_2::ContractualSupplement type_type;
    typedef ::xsd::cxx::tree::traits< type_type, char > type_traits;

    const type_type&
    type () const;

    type_type&
    type ();

    void
    type (const type_type& x);

    void
    type (::std::auto_ptr< type_type > p);

    // publicationDate
    // 
    typedef ::xml_schema::date publicationDate_type;
    typedef ::xsd::cxx::tree::optional< publicationDate_type > publicationDate_optional;
    typedef ::xsd::cxx::tree::traits< publicationDate_type, char > publicationDate_traits;

    const publicationDate_optional&
    publicationDate () const;

    publicationDate_optional&
    publicationDate ();

    void
    publicationDate (const publicationDate_type& x);

    void
    publicationDate (const publicationDate_optional& x);

    void
    publicationDate (::std::auto_ptr< publicationDate_type > p);

    // Constructors.
    //
    ContractualTermsSupplement (const type_type&);

    ContractualTermsSupplement (::std::auto_ptr< type_type >&);

    ContractualTermsSupplement (const ::xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    ContractualTermsSupplement (const ContractualTermsSupplement& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual ContractualTermsSupplement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ContractualTermsSupplement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< type_type > type_;
    publicationDate_optional publicationDate_;
  };

  class CorrespondentInformation: public ::FpML_4_2::Routing
  {
    public:
    // correspondentPartyReference
    // 
    typedef ::FpML_4_2::PartyReference correspondentPartyReference_type;
    typedef ::xsd::cxx::tree::optional< correspondentPartyReference_type > correspondentPartyReference_optional;
    typedef ::xsd::cxx::tree::traits< correspondentPartyReference_type, char > correspondentPartyReference_traits;

    const correspondentPartyReference_optional&
    correspondentPartyReference () const;

    correspondentPartyReference_optional&
    correspondentPartyReference ();

    void
    correspondentPartyReference (const correspondentPartyReference_type& x);

    void
    correspondentPartyReference (const correspondentPartyReference_optional& x);

    void
    correspondentPartyReference (::std::auto_ptr< correspondentPartyReference_type > p);

    // Constructors.
    //
    CorrespondentInformation ();

    CorrespondentInformation (const ::xercesc::DOMElement& e,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    CorrespondentInformation (const CorrespondentInformation& x,
                              ::xml_schema::flags f = 0,
                              ::xml_schema::container* c = 0);

    virtual CorrespondentInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CorrespondentInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    correspondentPartyReference_optional correspondentPartyReference_;
  };

  class Country: public ::xml_schema::normalized_string
  {
    public:
    // countryScheme
    // 
    typedef ::xml_schema::uri countryScheme_type;
    typedef ::xsd::cxx::tree::traits< countryScheme_type, char > countryScheme_traits;

    const countryScheme_type&
    countryScheme () const;

    countryScheme_type&
    countryScheme ();

    void
    countryScheme (const countryScheme_type& x);

    void
    countryScheme (::std::auto_ptr< countryScheme_type > p);

    static const countryScheme_type&
    countryScheme_default_value ();

    // Constructors.
    //
    Country ();

    Country (const char*);

    Country (const ::std::string&);

    Country (const ::xml_schema::normalized_string&);

    Country (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Country (const Country& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Country*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Country ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< countryScheme_type > countryScheme_;
    static const countryScheme_type countryScheme_default_value_;
  };

  class CreditSeniority: public ::xml_schema::normalized_string
  {
    public:
    // creditSeniorityScheme
    // 
    typedef ::xml_schema::uri creditSeniorityScheme_type;
    typedef ::xsd::cxx::tree::traits< creditSeniorityScheme_type, char > creditSeniorityScheme_traits;

    const creditSeniorityScheme_type&
    creditSeniorityScheme () const;

    creditSeniorityScheme_type&
    creditSeniorityScheme ();

    void
    creditSeniorityScheme (const creditSeniorityScheme_type& x);

    void
    creditSeniorityScheme (::std::auto_ptr< creditSeniorityScheme_type > p);

    static const creditSeniorityScheme_type&
    creditSeniorityScheme_default_value ();

    // Constructors.
    //
    CreditSeniority ();

    CreditSeniority (const char*);

    CreditSeniority (const ::std::string&);

    CreditSeniority (const ::xml_schema::normalized_string&);

    CreditSeniority (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    CreditSeniority (const CreditSeniority& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual CreditSeniority*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~CreditSeniority ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< creditSeniorityScheme_type > creditSeniorityScheme_;
    static const creditSeniorityScheme_type creditSeniorityScheme_default_value_;
  };

  class Currency: public ::xml_schema::normalized_string
  {
    public:
    // currencyScheme
    // 
    typedef ::xml_schema::uri currencyScheme_type;
    typedef ::xsd::cxx::tree::traits< currencyScheme_type, char > currencyScheme_traits;

    const currencyScheme_type&
    currencyScheme () const;

    currencyScheme_type&
    currencyScheme ();

    void
    currencyScheme (const currencyScheme_type& x);

    void
    currencyScheme (::std::auto_ptr< currencyScheme_type > p);

    static const currencyScheme_type&
    currencyScheme_default_value ();

    // Constructors.
    //
    Currency ();

    Currency (const char*);

    Currency (const ::std::string&);

    Currency (const ::xml_schema::normalized_string&);

    Currency (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Currency (const Currency& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Currency*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Currency ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< currencyScheme_type > currencyScheme_;
    static const currencyScheme_type currencyScheme_default_value_;
  };

  class DateList: public ::xml_schema::type
  {
    public:
    // date
    // 
    typedef ::xml_schema::date date_type;
    typedef ::xsd::cxx::tree::sequence< date_type > date_sequence;
    typedef date_sequence::iterator date_iterator;
    typedef date_sequence::const_iterator date_const_iterator;
    typedef ::xsd::cxx::tree::traits< date_type, char > date_traits;

    const date_sequence&
    date () const;

    date_sequence&
    date ();

    void
    date (const date_sequence& s);

    // Constructors.
    //
    DateList ();

    DateList (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    DateList (const DateList& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual DateList*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DateList ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    date_sequence date_;
  };

  class DateOffset: public ::FpML_4_2::Offset
  {
    public:
    // businessDayConvention
    // 
    typedef ::FpML_4_2::BusinessDayConventionEnum businessDayConvention_type;
    typedef ::xsd::cxx::tree::traits< businessDayConvention_type, char > businessDayConvention_traits;

    const businessDayConvention_type&
    businessDayConvention () const;

    businessDayConvention_type&
    businessDayConvention ();

    void
    businessDayConvention (const businessDayConvention_type& x);

    void
    businessDayConvention (::std::auto_ptr< businessDayConvention_type > p);

    // sequence
    // 
    typedef ::xml_schema::integer sequence_type;
    typedef ::xsd::cxx::tree::optional< sequence_type > sequence_optional;
    typedef ::xsd::cxx::tree::traits< sequence_type, char > sequence_traits;

    const sequence_optional&
    sequence () const;

    sequence_optional&
    sequence ();

    void
    sequence (const sequence_type& x);

    void
    sequence (const sequence_optional& x);

    // Constructors.
    //
    DateOffset (const periodMultiplier_type&,
                const period_type&,
                const businessDayConvention_type&);

    DateOffset (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    DateOffset (const DateOffset& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual DateOffset*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DateOffset ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< businessDayConvention_type > businessDayConvention_;
    sequence_optional sequence_;
  };

  class DateReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    DateReference (const href_type&);

    DateReference (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    DateReference (const DateReference& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual DateReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DateReference ();
  };

  class DateTimeList: public ::xml_schema::type
  {
    public:
    // dateTime
    // 
    typedef ::xml_schema::date_time dateTime_type;
    typedef ::xsd::cxx::tree::sequence< dateTime_type > dateTime_sequence;
    typedef dateTime_sequence::iterator dateTime_iterator;
    typedef dateTime_sequence::const_iterator dateTime_const_iterator;
    typedef ::xsd::cxx::tree::traits< dateTime_type, char > dateTime_traits;

    const dateTime_sequence&
    dateTime () const;

    dateTime_sequence&
    dateTime ();

    void
    dateTime (const dateTime_sequence& s);

    // Constructors.
    //
    DateTimeList ();

    DateTimeList (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    DateTimeList (const DateTimeList& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual DateTimeList*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DateTimeList ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    dateTime_sequence dateTime_;
  };

  class DayCountFraction: public ::xml_schema::normalized_string
  {
    public:
    // dayCountFractionScheme
    // 
    typedef ::xml_schema::uri dayCountFractionScheme_type;
    typedef ::xsd::cxx::tree::traits< dayCountFractionScheme_type, char > dayCountFractionScheme_traits;

    const dayCountFractionScheme_type&
    dayCountFractionScheme () const;

    dayCountFractionScheme_type&
    dayCountFractionScheme ();

    void
    dayCountFractionScheme (const dayCountFractionScheme_type& x);

    void
    dayCountFractionScheme (::std::auto_ptr< dayCountFractionScheme_type > p);

    static const dayCountFractionScheme_type&
    dayCountFractionScheme_default_value ();

    // Constructors.
    //
    DayCountFraction ();

    DayCountFraction (const char*);

    DayCountFraction (const ::std::string&);

    DayCountFraction (const ::xml_schema::normalized_string&);

    DayCountFraction (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    DayCountFraction (const DayCountFraction& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual DayCountFraction*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DayCountFraction ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< dayCountFractionScheme_type > dayCountFractionScheme_;
    static const dayCountFractionScheme_type dayCountFractionScheme_default_value_;
  };

  class DeterminationMethod: public ::xml_schema::normalized_string
  {
    public:
    // determinationMethodScheme
    // 
    typedef ::xml_schema::uri determinationMethodScheme_type;
    typedef ::xsd::cxx::tree::optional< determinationMethodScheme_type > determinationMethodScheme_optional;
    typedef ::xsd::cxx::tree::traits< determinationMethodScheme_type, char > determinationMethodScheme_traits;

    const determinationMethodScheme_optional&
    determinationMethodScheme () const;

    determinationMethodScheme_optional&
    determinationMethodScheme ();

    void
    determinationMethodScheme (const determinationMethodScheme_type& x);

    void
    determinationMethodScheme (const determinationMethodScheme_optional& x);

    void
    determinationMethodScheme (::std::auto_ptr< determinationMethodScheme_type > p);

    // Constructors.
    //
    DeterminationMethod ();

    DeterminationMethod (const char*);

    DeterminationMethod (const ::std::string&);

    DeterminationMethod (const ::xml_schema::normalized_string&);

    DeterminationMethod (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    DeterminationMethod (const DeterminationMethod& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual DeterminationMethod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DeterminationMethod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    determinationMethodScheme_optional determinationMethodScheme_;
  };

  class DividendConditions: public ::xml_schema::type
  {
    public:
    // dividendReinvestment
    // 
    typedef ::xml_schema::boolean dividendReinvestment_type;
    typedef ::xsd::cxx::tree::optional< dividendReinvestment_type > dividendReinvestment_optional;
    typedef ::xsd::cxx::tree::traits< dividendReinvestment_type, char > dividendReinvestment_traits;

    const dividendReinvestment_optional&
    dividendReinvestment () const;

    dividendReinvestment_optional&
    dividendReinvestment ();

    void
    dividendReinvestment (const dividendReinvestment_type& x);

    void
    dividendReinvestment (const dividendReinvestment_optional& x);

    // dividendEntitlement
    // 
    typedef ::FpML_4_2::DividendEntitlementEnum dividendEntitlement_type;
    typedef ::xsd::cxx::tree::optional< dividendEntitlement_type > dividendEntitlement_optional;
    typedef ::xsd::cxx::tree::traits< dividendEntitlement_type, char > dividendEntitlement_traits;

    const dividendEntitlement_optional&
    dividendEntitlement () const;

    dividendEntitlement_optional&
    dividendEntitlement ();

    void
    dividendEntitlement (const dividendEntitlement_type& x);

    void
    dividendEntitlement (const dividendEntitlement_optional& x);

    void
    dividendEntitlement (::std::auto_ptr< dividendEntitlement_type > p);

    // dividendAmount
    // 
    typedef ::FpML_4_2::DividendAmountTypeEnum dividendAmount_type;
    typedef ::xsd::cxx::tree::optional< dividendAmount_type > dividendAmount_optional;
    typedef ::xsd::cxx::tree::traits< dividendAmount_type, char > dividendAmount_traits;

    const dividendAmount_optional&
    dividendAmount () const;

    dividendAmount_optional&
    dividendAmount ();

    void
    dividendAmount (const dividendAmount_type& x);

    void
    dividendAmount (const dividendAmount_optional& x);

    void
    dividendAmount (::std::auto_ptr< dividendAmount_type > p);

    // dividendPaymentDate
    // 
    typedef ::FpML_4_2::DividendPaymentDate dividendPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< dividendPaymentDate_type > dividendPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< dividendPaymentDate_type, char > dividendPaymentDate_traits;

    const dividendPaymentDate_optional&
    dividendPaymentDate () const;

    dividendPaymentDate_optional&
    dividendPaymentDate ();

    void
    dividendPaymentDate (const dividendPaymentDate_type& x);

    void
    dividendPaymentDate (const dividendPaymentDate_optional& x);

    void
    dividendPaymentDate (::std::auto_ptr< dividendPaymentDate_type > p);

    // dividendPeriodEffectiveDate
    // 
    typedef ::FpML_4_2::DateReference dividendPeriodEffectiveDate_type;
    typedef ::xsd::cxx::tree::optional< dividendPeriodEffectiveDate_type > dividendPeriodEffectiveDate_optional;
    typedef ::xsd::cxx::tree::traits< dividendPeriodEffectiveDate_type, char > dividendPeriodEffectiveDate_traits;

    const dividendPeriodEffectiveDate_optional&
    dividendPeriodEffectiveDate () const;

    dividendPeriodEffectiveDate_optional&
    dividendPeriodEffectiveDate ();

    void
    dividendPeriodEffectiveDate (const dividendPeriodEffectiveDate_type& x);

    void
    dividendPeriodEffectiveDate (const dividendPeriodEffectiveDate_optional& x);

    void
    dividendPeriodEffectiveDate (::std::auto_ptr< dividendPeriodEffectiveDate_type > p);

    // dividendPeriodEndDate
    // 
    typedef ::FpML_4_2::DateReference dividendPeriodEndDate_type;
    typedef ::xsd::cxx::tree::optional< dividendPeriodEndDate_type > dividendPeriodEndDate_optional;
    typedef ::xsd::cxx::tree::traits< dividendPeriodEndDate_type, char > dividendPeriodEndDate_traits;

    const dividendPeriodEndDate_optional&
    dividendPeriodEndDate () const;

    dividendPeriodEndDate_optional&
    dividendPeriodEndDate ();

    void
    dividendPeriodEndDate (const dividendPeriodEndDate_type& x);

    void
    dividendPeriodEndDate (const dividendPeriodEndDate_optional& x);

    void
    dividendPeriodEndDate (::std::auto_ptr< dividendPeriodEndDate_type > p);

    // dividendPeriod
    // 
    typedef ::FpML_4_2::DividendPeriodEnum dividendPeriod_type;
    typedef ::xsd::cxx::tree::optional< dividendPeriod_type > dividendPeriod_optional;
    typedef ::xsd::cxx::tree::traits< dividendPeriod_type, char > dividendPeriod_traits;

    const dividendPeriod_optional&
    dividendPeriod () const;

    dividendPeriod_optional&
    dividendPeriod ();

    void
    dividendPeriod (const dividendPeriod_type& x);

    void
    dividendPeriod (const dividendPeriod_optional& x);

    void
    dividendPeriod (::std::auto_ptr< dividendPeriod_type > p);

    // extraOrdinaryDividends
    // 
    typedef ::FpML_4_2::PartyReference extraOrdinaryDividends_type;
    typedef ::xsd::cxx::tree::optional< extraOrdinaryDividends_type > extraOrdinaryDividends_optional;
    typedef ::xsd::cxx::tree::traits< extraOrdinaryDividends_type, char > extraOrdinaryDividends_traits;

    const extraOrdinaryDividends_optional&
    extraOrdinaryDividends () const;

    extraOrdinaryDividends_optional&
    extraOrdinaryDividends ();

    void
    extraOrdinaryDividends (const extraOrdinaryDividends_type& x);

    void
    extraOrdinaryDividends (const extraOrdinaryDividends_optional& x);

    void
    extraOrdinaryDividends (::std::auto_ptr< extraOrdinaryDividends_type > p);

    // excessDividendAmount
    // 
    typedef ::FpML_4_2::DividendAmountTypeEnum excessDividendAmount_type;
    typedef ::xsd::cxx::tree::optional< excessDividendAmount_type > excessDividendAmount_optional;
    typedef ::xsd::cxx::tree::traits< excessDividendAmount_type, char > excessDividendAmount_traits;

    const excessDividendAmount_optional&
    excessDividendAmount () const;

    excessDividendAmount_optional&
    excessDividendAmount ();

    void
    excessDividendAmount (const excessDividendAmount_type& x);

    void
    excessDividendAmount (const excessDividendAmount_optional& x);

    void
    excessDividendAmount (::std::auto_ptr< excessDividendAmount_type > p);

    // paymentCurrency
    // 
    typedef ::FpML_4_2::PaymentCurrency paymentCurrency_type;
    typedef ::xsd::cxx::tree::optional< paymentCurrency_type > paymentCurrency_optional;
    typedef ::xsd::cxx::tree::traits< paymentCurrency_type, char > paymentCurrency_traits;

    const paymentCurrency_optional&
    paymentCurrency () const;

    paymentCurrency_optional&
    paymentCurrency ();

    void
    paymentCurrency (const paymentCurrency_type& x);

    void
    paymentCurrency (const paymentCurrency_optional& x);

    void
    paymentCurrency (::std::auto_ptr< paymentCurrency_type > p);

    // dividendFxTriggerDate
    // 
    typedef ::FpML_4_2::DividendPaymentDate dividendFxTriggerDate_type;
    typedef ::xsd::cxx::tree::optional< dividendFxTriggerDate_type > dividendFxTriggerDate_optional;
    typedef ::xsd::cxx::tree::traits< dividendFxTriggerDate_type, char > dividendFxTriggerDate_traits;

    const dividendFxTriggerDate_optional&
    dividendFxTriggerDate () const;

    dividendFxTriggerDate_optional&
    dividendFxTriggerDate ();

    void
    dividendFxTriggerDate (const dividendFxTriggerDate_type& x);

    void
    dividendFxTriggerDate (const dividendFxTriggerDate_optional& x);

    void
    dividendFxTriggerDate (::std::auto_ptr< dividendFxTriggerDate_type > p);

    // interestAccrualsMethod
    // 
    typedef ::FpML_4_2::InterestAccrualsCompoundingMethod interestAccrualsMethod_type;
    typedef ::xsd::cxx::tree::optional< interestAccrualsMethod_type > interestAccrualsMethod_optional;
    typedef ::xsd::cxx::tree::traits< interestAccrualsMethod_type, char > interestAccrualsMethod_traits;

    const interestAccrualsMethod_optional&
    interestAccrualsMethod () const;

    interestAccrualsMethod_optional&
    interestAccrualsMethod ();

    void
    interestAccrualsMethod (const interestAccrualsMethod_type& x);

    void
    interestAccrualsMethod (const interestAccrualsMethod_optional& x);

    void
    interestAccrualsMethod (::std::auto_ptr< interestAccrualsMethod_type > p);

    // Constructors.
    //
    DividendConditions ();

    DividendConditions (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    DividendConditions (const DividendConditions& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual DividendConditions*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DividendConditions ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    dividendReinvestment_optional dividendReinvestment_;
    dividendEntitlement_optional dividendEntitlement_;
    dividendAmount_optional dividendAmount_;
    dividendPaymentDate_optional dividendPaymentDate_;
    dividendPeriodEffectiveDate_optional dividendPeriodEffectiveDate_;
    dividendPeriodEndDate_optional dividendPeriodEndDate_;
    dividendPeriod_optional dividendPeriod_;
    extraOrdinaryDividends_optional extraOrdinaryDividends_;
    excessDividendAmount_optional excessDividendAmount_;
    paymentCurrency_optional paymentCurrency_;
    dividendFxTriggerDate_optional dividendFxTriggerDate_;
    interestAccrualsMethod_optional interestAccrualsMethod_;
  };

  class DividendPaymentDate: public ::xml_schema::type
  {
    public:
    // dividendDateReference
    // 
    typedef ::FpML_4_2::DividendDateReferenceEnum dividendDateReference_type;
    typedef ::xsd::cxx::tree::optional< dividendDateReference_type > dividendDateReference_optional;
    typedef ::xsd::cxx::tree::traits< dividendDateReference_type, char > dividendDateReference_traits;

    const dividendDateReference_optional&
    dividendDateReference () const;

    dividendDateReference_optional&
    dividendDateReference ();

    void
    dividendDateReference (const dividendDateReference_type& x);

    void
    dividendDateReference (const dividendDateReference_optional& x);

    void
    dividendDateReference (::std::auto_ptr< dividendDateReference_type > p);

    // adjustableDate
    // 
    typedef ::FpML_4_2::AdjustableDate adjustableDate_type;
    typedef ::xsd::cxx::tree::optional< adjustableDate_type > adjustableDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustableDate_type, char > adjustableDate_traits;

    const adjustableDate_optional&
    adjustableDate () const;

    adjustableDate_optional&
    adjustableDate ();

    void
    adjustableDate (const adjustableDate_type& x);

    void
    adjustableDate (const adjustableDate_optional& x);

    void
    adjustableDate (::std::auto_ptr< adjustableDate_type > p);

    // Constructors.
    //
    DividendPaymentDate ();

    DividendPaymentDate (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    DividendPaymentDate (const DividendPaymentDate& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual DividendPaymentDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~DividendPaymentDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    dividendDateReference_optional dividendDateReference_;
    adjustableDate_optional adjustableDate_;
  };

  class Documentation: public ::xml_schema::type
  {
    public:
    // masterAgreement
    // 
    typedef ::FpML_4_2::MasterAgreement masterAgreement_type;
    typedef ::xsd::cxx::tree::optional< masterAgreement_type > masterAgreement_optional;
    typedef ::xsd::cxx::tree::traits< masterAgreement_type, char > masterAgreement_traits;

    const masterAgreement_optional&
    masterAgreement () const;

    masterAgreement_optional&
    masterAgreement ();

    void
    masterAgreement (const masterAgreement_type& x);

    void
    masterAgreement (const masterAgreement_optional& x);

    void
    masterAgreement (::std::auto_ptr< masterAgreement_type > p);

    // masterConfirmation
    // 
    typedef ::FpML_4_2::MasterConfirmation masterConfirmation_type;
    typedef ::xsd::cxx::tree::optional< masterConfirmation_type > masterConfirmation_optional;
    typedef ::xsd::cxx::tree::traits< masterConfirmation_type, char > masterConfirmation_traits;

    const masterConfirmation_optional&
    masterConfirmation () const;

    masterConfirmation_optional&
    masterConfirmation ();

    void
    masterConfirmation (const masterConfirmation_type& x);

    void
    masterConfirmation (const masterConfirmation_optional& x);

    void
    masterConfirmation (::std::auto_ptr< masterConfirmation_type > p);

    // brokerConfirmation
    // 
    typedef ::FpML_4_2::BrokerConfirmation brokerConfirmation_type;
    typedef ::xsd::cxx::tree::optional< brokerConfirmation_type > brokerConfirmation_optional;
    typedef ::xsd::cxx::tree::traits< brokerConfirmation_type, char > brokerConfirmation_traits;

    const brokerConfirmation_optional&
    brokerConfirmation () const;

    brokerConfirmation_optional&
    brokerConfirmation ();

    void
    brokerConfirmation (const brokerConfirmation_type& x);

    void
    brokerConfirmation (const brokerConfirmation_optional& x);

    void
    brokerConfirmation (::std::auto_ptr< brokerConfirmation_type > p);

    // contractualDefinitions
    // 
    typedef ::FpML_4_2::ContractualDefinitions contractualDefinitions_type;
    typedef ::xsd::cxx::tree::sequence< contractualDefinitions_type > contractualDefinitions_sequence;
    typedef contractualDefinitions_sequence::iterator contractualDefinitions_iterator;
    typedef contractualDefinitions_sequence::const_iterator contractualDefinitions_const_iterator;
    typedef ::xsd::cxx::tree::traits< contractualDefinitions_type, char > contractualDefinitions_traits;

    const contractualDefinitions_sequence&
    contractualDefinitions () const;

    contractualDefinitions_sequence&
    contractualDefinitions ();

    void
    contractualDefinitions (const contractualDefinitions_sequence& s);

    // contractualSupplement
    // 
    typedef ::FpML_4_2::ContractualSupplement contractualSupplement_type;
    typedef ::xsd::cxx::tree::sequence< contractualSupplement_type > contractualSupplement_sequence;
    typedef contractualSupplement_sequence::iterator contractualSupplement_iterator;
    typedef contractualSupplement_sequence::const_iterator contractualSupplement_const_iterator;
    typedef ::xsd::cxx::tree::traits< contractualSupplement_type, char > contractualSupplement_traits;

    const contractualSupplement_sequence&
    contractualSupplement () const;

    contractualSupplement_sequence&
    contractualSupplement ();

    void
    contractualSupplement (const contractualSupplement_sequence& s);

    // contractualTermsSupplement
    // 
    typedef ::FpML_4_2::ContractualTermsSupplement contractualTermsSupplement_type;
    typedef ::xsd::cxx::tree::sequence< contractualTermsSupplement_type > contractualTermsSupplement_sequence;
    typedef contractualTermsSupplement_sequence::iterator contractualTermsSupplement_iterator;
    typedef contractualTermsSupplement_sequence::const_iterator contractualTermsSupplement_const_iterator;
    typedef ::xsd::cxx::tree::traits< contractualTermsSupplement_type, char > contractualTermsSupplement_traits;

    const contractualTermsSupplement_sequence&
    contractualTermsSupplement () const;

    contractualTermsSupplement_sequence&
    contractualTermsSupplement ();

    void
    contractualTermsSupplement (const contractualTermsSupplement_sequence& s);

    // contractualMatrix
    // 
    typedef ::FpML_4_2::ContractualMatrix contractualMatrix_type;
    typedef ::xsd::cxx::tree::sequence< contractualMatrix_type > contractualMatrix_sequence;
    typedef contractualMatrix_sequence::iterator contractualMatrix_iterator;
    typedef contractualMatrix_sequence::const_iterator contractualMatrix_const_iterator;
    typedef ::xsd::cxx::tree::traits< contractualMatrix_type, char > contractualMatrix_traits;

    const contractualMatrix_sequence&
    contractualMatrix () const;

    contractualMatrix_sequence&
    contractualMatrix ();

    void
    contractualMatrix (const contractualMatrix_sequence& s);

    // creditSupportDocument
    // 
    typedef ::xml_schema::normalized_string creditSupportDocument_type;
    typedef ::xsd::cxx::tree::optional< creditSupportDocument_type > creditSupportDocument_optional;
    typedef ::xsd::cxx::tree::traits< creditSupportDocument_type, char > creditSupportDocument_traits;

    const creditSupportDocument_optional&
    creditSupportDocument () const;

    creditSupportDocument_optional&
    creditSupportDocument ();

    void
    creditSupportDocument (const creditSupportDocument_type& x);

    void
    creditSupportDocument (const creditSupportDocument_optional& x);

    void
    creditSupportDocument (::std::auto_ptr< creditSupportDocument_type > p);

    // Constructors.
    //
    Documentation ();

    Documentation (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    Documentation (const Documentation& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual Documentation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Documentation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    masterAgreement_optional masterAgreement_;
    masterConfirmation_optional masterConfirmation_;
    brokerConfirmation_optional brokerConfirmation_;
    contractualDefinitions_sequence contractualDefinitions_;
    contractualSupplement_sequence contractualSupplement_;
    contractualTermsSupplement_sequence contractualTermsSupplement_;
    contractualMatrix_sequence contractualMatrix_;
    creditSupportDocument_optional creditSupportDocument_;
  };

  class Empty: public ::xml_schema::type
  {
    public:
    // Constructors.
    //
    Empty ();

    Empty (const ::xercesc::DOMElement& e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Empty (const ::xercesc::DOMAttr& a,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Empty (const ::std::string& s,
           const ::xercesc::DOMElement* e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Empty (const Empty& x,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    virtual Empty*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Empty ();
  };

  class EntityId: public ::xml_schema::normalized_string
  {
    public:
    // entityIdScheme
    // 
    typedef ::xml_schema::uri entityIdScheme_type;
    typedef ::xsd::cxx::tree::traits< entityIdScheme_type, char > entityIdScheme_traits;

    const entityIdScheme_type&
    entityIdScheme () const;

    entityIdScheme_type&
    entityIdScheme ();

    void
    entityIdScheme (const entityIdScheme_type& x);

    void
    entityIdScheme (::std::auto_ptr< entityIdScheme_type > p);

    static const entityIdScheme_type&
    entityIdScheme_default_value ();

    // Constructors.
    //
    EntityId ();

    EntityId (const char*);

    EntityId (const ::std::string&);

    EntityId (const ::xml_schema::normalized_string&);

    EntityId (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    EntityId (const EntityId& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual EntityId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EntityId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< entityIdScheme_type > entityIdScheme_;
    static const entityIdScheme_type entityIdScheme_default_value_;
  };

  class EntityName: public ::xml_schema::normalized_string
  {
    public:
    // entityNameScheme
    // 
    typedef ::xml_schema::uri entityNameScheme_type;
    typedef ::xsd::cxx::tree::traits< entityNameScheme_type, char > entityNameScheme_traits;

    const entityNameScheme_type&
    entityNameScheme () const;

    entityNameScheme_type&
    entityNameScheme ();

    void
    entityNameScheme (const entityNameScheme_type& x);

    void
    entityNameScheme (::std::auto_ptr< entityNameScheme_type > p);

    static const entityNameScheme_type&
    entityNameScheme_default_value ();

    // Constructors.
    //
    EntityName ();

    EntityName (const char*);

    EntityName (const ::std::string&);

    EntityName (const ::xml_schema::normalized_string&);

    EntityName (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    EntityName (const EntityName& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual EntityName*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EntityName ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< entityNameScheme_type > entityNameScheme_;
    static const entityNameScheme_type entityNameScheme_default_value_;
  };

  class EuropeanExercise: public ::FpML_4_2::Exercise
  {
    public:
    // expirationDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate expirationDate_type;
    typedef ::xsd::cxx::tree::traits< expirationDate_type, char > expirationDate_traits;

    const expirationDate_type&
    expirationDate () const;

    expirationDate_type&
    expirationDate ();

    void
    expirationDate (const expirationDate_type& x);

    void
    expirationDate (::std::auto_ptr< expirationDate_type > p);

    // relevantUnderlyingDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDates relevantUnderlyingDate_type;
    typedef ::xsd::cxx::tree::optional< relevantUnderlyingDate_type > relevantUnderlyingDate_optional;
    typedef ::xsd::cxx::tree::traits< relevantUnderlyingDate_type, char > relevantUnderlyingDate_traits;

    const relevantUnderlyingDate_optional&
    relevantUnderlyingDate () const;

    relevantUnderlyingDate_optional&
    relevantUnderlyingDate ();

    void
    relevantUnderlyingDate (const relevantUnderlyingDate_type& x);

    void
    relevantUnderlyingDate (const relevantUnderlyingDate_optional& x);

    void
    relevantUnderlyingDate (::std::auto_ptr< relevantUnderlyingDate_type > p);

    // earliestExerciseTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime earliestExerciseTime_type;
    typedef ::xsd::cxx::tree::traits< earliestExerciseTime_type, char > earliestExerciseTime_traits;

    const earliestExerciseTime_type&
    earliestExerciseTime () const;

    earliestExerciseTime_type&
    earliestExerciseTime ();

    void
    earliestExerciseTime (const earliestExerciseTime_type& x);

    void
    earliestExerciseTime (::std::auto_ptr< earliestExerciseTime_type > p);

    // expirationTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime expirationTime_type;
    typedef ::xsd::cxx::tree::traits< expirationTime_type, char > expirationTime_traits;

    const expirationTime_type&
    expirationTime () const;

    expirationTime_type&
    expirationTime ();

    void
    expirationTime (const expirationTime_type& x);

    void
    expirationTime (::std::auto_ptr< expirationTime_type > p);

    // partialExercise
    // 
    typedef ::FpML_4_2::PartialExercise partialExercise_type;
    typedef ::xsd::cxx::tree::optional< partialExercise_type > partialExercise_optional;
    typedef ::xsd::cxx::tree::traits< partialExercise_type, char > partialExercise_traits;

    const partialExercise_optional&
    partialExercise () const;

    partialExercise_optional&
    partialExercise ();

    void
    partialExercise (const partialExercise_type& x);

    void
    partialExercise (const partialExercise_optional& x);

    void
    partialExercise (::std::auto_ptr< partialExercise_type > p);

    // exerciseFee
    // 
    typedef ::FpML_4_2::ExerciseFee exerciseFee_type;
    typedef ::xsd::cxx::tree::optional< exerciseFee_type > exerciseFee_optional;
    typedef ::xsd::cxx::tree::traits< exerciseFee_type, char > exerciseFee_traits;

    const exerciseFee_optional&
    exerciseFee () const;

    exerciseFee_optional&
    exerciseFee ();

    void
    exerciseFee (const exerciseFee_type& x);

    void
    exerciseFee (const exerciseFee_optional& x);

    void
    exerciseFee (::std::auto_ptr< exerciseFee_type > p);

    // Constructors.
    //
    EuropeanExercise (const expirationDate_type&,
                      const earliestExerciseTime_type&,
                      const expirationTime_type&);

    EuropeanExercise (::std::auto_ptr< expirationDate_type >&,
                      ::std::auto_ptr< earliestExerciseTime_type >&,
                      ::std::auto_ptr< expirationTime_type >&);

    EuropeanExercise (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    EuropeanExercise (const EuropeanExercise& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual EuropeanExercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~EuropeanExercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< expirationDate_type > expirationDate_;
    relevantUnderlyingDate_optional relevantUnderlyingDate_;
    ::xsd::cxx::tree::one< earliestExerciseTime_type > earliestExerciseTime_;
    ::xsd::cxx::tree::one< expirationTime_type > expirationTime_;
    partialExercise_optional partialExercise_;
    exerciseFee_optional exerciseFee_;
  };

  class ExchangeId: public ::xml_schema::normalized_string
  {
    public:
    // exchangeIdScheme
    // 
    typedef ::xml_schema::uri exchangeIdScheme_type;
    typedef ::xsd::cxx::tree::traits< exchangeIdScheme_type, char > exchangeIdScheme_traits;

    const exchangeIdScheme_type&
    exchangeIdScheme () const;

    exchangeIdScheme_type&
    exchangeIdScheme ();

    void
    exchangeIdScheme (const exchangeIdScheme_type& x);

    void
    exchangeIdScheme (::std::auto_ptr< exchangeIdScheme_type > p);

    static const exchangeIdScheme_type&
    exchangeIdScheme_default_value ();

    // Constructors.
    //
    ExchangeId ();

    ExchangeId (const char*);

    ExchangeId (const ::std::string&);

    ExchangeId (const ::xml_schema::normalized_string&);

    ExchangeId (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    ExchangeId (const ExchangeId& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual ExchangeId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExchangeId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< exchangeIdScheme_type > exchangeIdScheme_;
    static const exchangeIdScheme_type exchangeIdScheme_default_value_;
  };

  class ExerciseFee: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // notionalReference
    // 
    typedef ::FpML_4_2::ScheduleReference notionalReference_type;
    typedef ::xsd::cxx::tree::traits< notionalReference_type, char > notionalReference_traits;

    const notionalReference_type&
    notionalReference () const;

    notionalReference_type&
    notionalReference ();

    void
    notionalReference (const notionalReference_type& x);

    void
    notionalReference (::std::auto_ptr< notionalReference_type > p);

    // feeAmount
    // 
    typedef ::xml_schema::decimal feeAmount_type;
    typedef ::xsd::cxx::tree::optional< feeAmount_type > feeAmount_optional;
    typedef ::xsd::cxx::tree::traits< feeAmount_type, char, ::xsd::cxx::tree::schema_type::decimal > feeAmount_traits;

    const feeAmount_optional&
    feeAmount () const;

    feeAmount_optional&
    feeAmount ();

    void
    feeAmount (const feeAmount_type& x);

    void
    feeAmount (const feeAmount_optional& x);

    // feeRate
    // 
    typedef ::xml_schema::decimal feeRate_type;
    typedef ::xsd::cxx::tree::optional< feeRate_type > feeRate_optional;
    typedef ::xsd::cxx::tree::traits< feeRate_type, char, ::xsd::cxx::tree::schema_type::decimal > feeRate_traits;

    const feeRate_optional&
    feeRate () const;

    feeRate_optional&
    feeRate ();

    void
    feeRate (const feeRate_type& x);

    void
    feeRate (const feeRate_optional& x);

    // feePaymentDate
    // 
    typedef ::FpML_4_2::RelativeDateOffset feePaymentDate_type;
    typedef ::xsd::cxx::tree::traits< feePaymentDate_type, char > feePaymentDate_traits;

    const feePaymentDate_type&
    feePaymentDate () const;

    feePaymentDate_type&
    feePaymentDate ();

    void
    feePaymentDate (const feePaymentDate_type& x);

    void
    feePaymentDate (::std::auto_ptr< feePaymentDate_type > p);

    // Constructors.
    //
    ExerciseFee (const payerPartyReference_type&,
                 const receiverPartyReference_type&,
                 const notionalReference_type&,
                 const feePaymentDate_type&);

    ExerciseFee (::std::auto_ptr< payerPartyReference_type >&,
                 ::std::auto_ptr< receiverPartyReference_type >&,
                 ::std::auto_ptr< notionalReference_type >&,
                 ::std::auto_ptr< feePaymentDate_type >&);

    ExerciseFee (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    ExerciseFee (const ExerciseFee& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual ExerciseFee*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExerciseFee ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    ::xsd::cxx::tree::one< notionalReference_type > notionalReference_;
    feeAmount_optional feeAmount_;
    feeRate_optional feeRate_;
    ::xsd::cxx::tree::one< feePaymentDate_type > feePaymentDate_;
  };

  class ExerciseFeeSchedule: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // notionalReference
    // 
    typedef ::FpML_4_2::ScheduleReference notionalReference_type;
    typedef ::xsd::cxx::tree::traits< notionalReference_type, char > notionalReference_traits;

    const notionalReference_type&
    notionalReference () const;

    notionalReference_type&
    notionalReference ();

    void
    notionalReference (const notionalReference_type& x);

    void
    notionalReference (::std::auto_ptr< notionalReference_type > p);

    // feeAmountSchedule
    // 
    typedef ::FpML_4_2::AmountSchedule feeAmountSchedule_type;
    typedef ::xsd::cxx::tree::optional< feeAmountSchedule_type > feeAmountSchedule_optional;
    typedef ::xsd::cxx::tree::traits< feeAmountSchedule_type, char > feeAmountSchedule_traits;

    const feeAmountSchedule_optional&
    feeAmountSchedule () const;

    feeAmountSchedule_optional&
    feeAmountSchedule ();

    void
    feeAmountSchedule (const feeAmountSchedule_type& x);

    void
    feeAmountSchedule (const feeAmountSchedule_optional& x);

    void
    feeAmountSchedule (::std::auto_ptr< feeAmountSchedule_type > p);

    // feeRateSchedule
    // 
    typedef ::FpML_4_2::Schedule feeRateSchedule_type;
    typedef ::xsd::cxx::tree::optional< feeRateSchedule_type > feeRateSchedule_optional;
    typedef ::xsd::cxx::tree::traits< feeRateSchedule_type, char > feeRateSchedule_traits;

    const feeRateSchedule_optional&
    feeRateSchedule () const;

    feeRateSchedule_optional&
    feeRateSchedule ();

    void
    feeRateSchedule (const feeRateSchedule_type& x);

    void
    feeRateSchedule (const feeRateSchedule_optional& x);

    void
    feeRateSchedule (::std::auto_ptr< feeRateSchedule_type > p);

    // feePaymentDate
    // 
    typedef ::FpML_4_2::RelativeDateOffset feePaymentDate_type;
    typedef ::xsd::cxx::tree::traits< feePaymentDate_type, char > feePaymentDate_traits;

    const feePaymentDate_type&
    feePaymentDate () const;

    feePaymentDate_type&
    feePaymentDate ();

    void
    feePaymentDate (const feePaymentDate_type& x);

    void
    feePaymentDate (::std::auto_ptr< feePaymentDate_type > p);

    // Constructors.
    //
    ExerciseFeeSchedule (const payerPartyReference_type&,
                         const receiverPartyReference_type&,
                         const notionalReference_type&,
                         const feePaymentDate_type&);

    ExerciseFeeSchedule (::std::auto_ptr< payerPartyReference_type >&,
                         ::std::auto_ptr< receiverPartyReference_type >&,
                         ::std::auto_ptr< notionalReference_type >&,
                         ::std::auto_ptr< feePaymentDate_type >&);

    ExerciseFeeSchedule (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    ExerciseFeeSchedule (const ExerciseFeeSchedule& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual ExerciseFeeSchedule*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExerciseFeeSchedule ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    ::xsd::cxx::tree::one< notionalReference_type > notionalReference_;
    feeAmountSchedule_optional feeAmountSchedule_;
    feeRateSchedule_optional feeRateSchedule_;
    ::xsd::cxx::tree::one< feePaymentDate_type > feePaymentDate_;
  };

  class ExerciseNotice: public ::xml_schema::type
  {
    public:
    // partyReference
    // 
    typedef ::FpML_4_2::PartyReference partyReference_type;
    typedef ::xsd::cxx::tree::traits< partyReference_type, char > partyReference_traits;

    const partyReference_type&
    partyReference () const;

    partyReference_type&
    partyReference ();

    void
    partyReference (const partyReference_type& x);

    void
    partyReference (::std::auto_ptr< partyReference_type > p);

    // exerciseNoticePartyReference
    // 
    typedef ::FpML_4_2::PartyReference exerciseNoticePartyReference_type;
    typedef ::xsd::cxx::tree::optional< exerciseNoticePartyReference_type > exerciseNoticePartyReference_optional;
    typedef ::xsd::cxx::tree::traits< exerciseNoticePartyReference_type, char > exerciseNoticePartyReference_traits;

    const exerciseNoticePartyReference_optional&
    exerciseNoticePartyReference () const;

    exerciseNoticePartyReference_optional&
    exerciseNoticePartyReference ();

    void
    exerciseNoticePartyReference (const exerciseNoticePartyReference_type& x);

    void
    exerciseNoticePartyReference (const exerciseNoticePartyReference_optional& x);

    void
    exerciseNoticePartyReference (::std::auto_ptr< exerciseNoticePartyReference_type > p);

    // businessCenter
    // 
    typedef ::FpML_4_2::BusinessCenter businessCenter_type;
    typedef ::xsd::cxx::tree::traits< businessCenter_type, char > businessCenter_traits;

    const businessCenter_type&
    businessCenter () const;

    businessCenter_type&
    businessCenter ();

    void
    businessCenter (const businessCenter_type& x);

    void
    businessCenter (::std::auto_ptr< businessCenter_type > p);

    // Constructors.
    //
    ExerciseNotice (const partyReference_type&,
                    const businessCenter_type&);

    ExerciseNotice (::std::auto_ptr< partyReference_type >&,
                    ::std::auto_ptr< businessCenter_type >&);

    ExerciseNotice (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ExerciseNotice (const ExerciseNotice& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ExerciseNotice*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExerciseNotice ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< partyReference_type > partyReference_;
    exerciseNoticePartyReference_optional exerciseNoticePartyReference_;
    ::xsd::cxx::tree::one< businessCenter_type > businessCenter_;
  };

  class ExerciseProcedure: public ::xml_schema::type
  {
    public:
    // manualExercise
    // 
    typedef ::FpML_4_2::ManualExercise manualExercise_type;
    typedef ::xsd::cxx::tree::optional< manualExercise_type > manualExercise_optional;
    typedef ::xsd::cxx::tree::traits< manualExercise_type, char > manualExercise_traits;

    const manualExercise_optional&
    manualExercise () const;

    manualExercise_optional&
    manualExercise ();

    void
    manualExercise (const manualExercise_type& x);

    void
    manualExercise (const manualExercise_optional& x);

    void
    manualExercise (::std::auto_ptr< manualExercise_type > p);

    // automaticExercise
    // 
    typedef ::FpML_4_2::AutomaticExercise automaticExercise_type;
    typedef ::xsd::cxx::tree::optional< automaticExercise_type > automaticExercise_optional;
    typedef ::xsd::cxx::tree::traits< automaticExercise_type, char > automaticExercise_traits;

    const automaticExercise_optional&
    automaticExercise () const;

    automaticExercise_optional&
    automaticExercise ();

    void
    automaticExercise (const automaticExercise_type& x);

    void
    automaticExercise (const automaticExercise_optional& x);

    void
    automaticExercise (::std::auto_ptr< automaticExercise_type > p);

    // followUpConfirmation
    // 
    typedef ::xml_schema::boolean followUpConfirmation_type;
    typedef ::xsd::cxx::tree::traits< followUpConfirmation_type, char > followUpConfirmation_traits;

    const followUpConfirmation_type&
    followUpConfirmation () const;

    followUpConfirmation_type&
    followUpConfirmation ();

    void
    followUpConfirmation (const followUpConfirmation_type& x);

    // Constructors.
    //
    ExerciseProcedure (const followUpConfirmation_type&);

    ExerciseProcedure (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ExerciseProcedure (const ExerciseProcedure& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual ExerciseProcedure*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ExerciseProcedure ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    manualExercise_optional manualExercise_;
    automaticExercise_optional automaticExercise_;
    ::xsd::cxx::tree::one< followUpConfirmation_type > followUpConfirmation_;
  };

  class Rate: public ::xml_schema::type
  {
    public:
    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Rate ();

    Rate (const ::xercesc::DOMElement& e,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    Rate (const Rate& x,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    virtual Rate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Rate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    id_optional id_;
  };

  class FloatingRate: public ::FpML_4_2::Rate
  {
    public:
    // floatingRateIndex
    // 
    typedef ::FpML_4_2::FloatingRateIndex floatingRateIndex_type;
    typedef ::xsd::cxx::tree::traits< floatingRateIndex_type, char > floatingRateIndex_traits;

    const floatingRateIndex_type&
    floatingRateIndex () const;

    floatingRateIndex_type&
    floatingRateIndex ();

    void
    floatingRateIndex (const floatingRateIndex_type& x);

    void
    floatingRateIndex (::std::auto_ptr< floatingRateIndex_type > p);

    // indexTenor
    // 
    typedef ::FpML_4_2::Interval indexTenor_type;
    typedef ::xsd::cxx::tree::optional< indexTenor_type > indexTenor_optional;
    typedef ::xsd::cxx::tree::traits< indexTenor_type, char > indexTenor_traits;

    const indexTenor_optional&
    indexTenor () const;

    indexTenor_optional&
    indexTenor ();

    void
    indexTenor (const indexTenor_type& x);

    void
    indexTenor (const indexTenor_optional& x);

    void
    indexTenor (::std::auto_ptr< indexTenor_type > p);

    // floatingRateMultiplierSchedule
    // 
    typedef ::FpML_4_2::Schedule floatingRateMultiplierSchedule_type;
    typedef ::xsd::cxx::tree::optional< floatingRateMultiplierSchedule_type > floatingRateMultiplierSchedule_optional;
    typedef ::xsd::cxx::tree::traits< floatingRateMultiplierSchedule_type, char > floatingRateMultiplierSchedule_traits;

    const floatingRateMultiplierSchedule_optional&
    floatingRateMultiplierSchedule () const;

    floatingRateMultiplierSchedule_optional&
    floatingRateMultiplierSchedule ();

    void
    floatingRateMultiplierSchedule (const floatingRateMultiplierSchedule_type& x);

    void
    floatingRateMultiplierSchedule (const floatingRateMultiplierSchedule_optional& x);

    void
    floatingRateMultiplierSchedule (::std::auto_ptr< floatingRateMultiplierSchedule_type > p);

    // spreadSchedule
    // 
    typedef ::FpML_4_2::SpreadSchedule spreadSchedule_type;
    typedef ::xsd::cxx::tree::sequence< spreadSchedule_type > spreadSchedule_sequence;
    typedef spreadSchedule_sequence::iterator spreadSchedule_iterator;
    typedef spreadSchedule_sequence::const_iterator spreadSchedule_const_iterator;
    typedef ::xsd::cxx::tree::traits< spreadSchedule_type, char > spreadSchedule_traits;

    const spreadSchedule_sequence&
    spreadSchedule () const;

    spreadSchedule_sequence&
    spreadSchedule ();

    void
    spreadSchedule (const spreadSchedule_sequence& s);

    // rateTreatment
    // 
    typedef ::FpML_4_2::RateTreatmentEnum rateTreatment_type;
    typedef ::xsd::cxx::tree::optional< rateTreatment_type > rateTreatment_optional;
    typedef ::xsd::cxx::tree::traits< rateTreatment_type, char > rateTreatment_traits;

    const rateTreatment_optional&
    rateTreatment () const;

    rateTreatment_optional&
    rateTreatment ();

    void
    rateTreatment (const rateTreatment_type& x);

    void
    rateTreatment (const rateTreatment_optional& x);

    void
    rateTreatment (::std::auto_ptr< rateTreatment_type > p);

    // capRateSchedule
    // 
    typedef ::FpML_4_2::StrikeSchedule capRateSchedule_type;
    typedef ::xsd::cxx::tree::sequence< capRateSchedule_type > capRateSchedule_sequence;
    typedef capRateSchedule_sequence::iterator capRateSchedule_iterator;
    typedef capRateSchedule_sequence::const_iterator capRateSchedule_const_iterator;
    typedef ::xsd::cxx::tree::traits< capRateSchedule_type, char > capRateSchedule_traits;

    const capRateSchedule_sequence&
    capRateSchedule () const;

    capRateSchedule_sequence&
    capRateSchedule ();

    void
    capRateSchedule (const capRateSchedule_sequence& s);

    // floorRateSchedule
    // 
    typedef ::FpML_4_2::StrikeSchedule floorRateSchedule_type;
    typedef ::xsd::cxx::tree::sequence< floorRateSchedule_type > floorRateSchedule_sequence;
    typedef floorRateSchedule_sequence::iterator floorRateSchedule_iterator;
    typedef floorRateSchedule_sequence::const_iterator floorRateSchedule_const_iterator;
    typedef ::xsd::cxx::tree::traits< floorRateSchedule_type, char > floorRateSchedule_traits;

    const floorRateSchedule_sequence&
    floorRateSchedule () const;

    floorRateSchedule_sequence&
    floorRateSchedule ();

    void
    floorRateSchedule (const floorRateSchedule_sequence& s);

    // Constructors.
    //
    FloatingRate (const floatingRateIndex_type&);

    FloatingRate (::std::auto_ptr< floatingRateIndex_type >&);

    FloatingRate (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    FloatingRate (const FloatingRate& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual FloatingRate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FloatingRate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< floatingRateIndex_type > floatingRateIndex_;
    indexTenor_optional indexTenor_;
    floatingRateMultiplierSchedule_optional floatingRateMultiplierSchedule_;
    spreadSchedule_sequence spreadSchedule_;
    rateTreatment_optional rateTreatment_;
    capRateSchedule_sequence capRateSchedule_;
    floorRateSchedule_sequence floorRateSchedule_;
  };

  class FloatingRateCalculation: public ::FpML_4_2::FloatingRate
  {
    public:
    // initialRate
    // 
    typedef ::xml_schema::decimal initialRate_type;
    typedef ::xsd::cxx::tree::optional< initialRate_type > initialRate_optional;
    typedef ::xsd::cxx::tree::traits< initialRate_type, char, ::xsd::cxx::tree::schema_type::decimal > initialRate_traits;

    const initialRate_optional&
    initialRate () const;

    initialRate_optional&
    initialRate ();

    void
    initialRate (const initialRate_type& x);

    void
    initialRate (const initialRate_optional& x);

    // finalRateRounding
    // 
    typedef ::FpML_4_2::Rounding finalRateRounding_type;
    typedef ::xsd::cxx::tree::optional< finalRateRounding_type > finalRateRounding_optional;
    typedef ::xsd::cxx::tree::traits< finalRateRounding_type, char > finalRateRounding_traits;

    const finalRateRounding_optional&
    finalRateRounding () const;

    finalRateRounding_optional&
    finalRateRounding ();

    void
    finalRateRounding (const finalRateRounding_type& x);

    void
    finalRateRounding (const finalRateRounding_optional& x);

    void
    finalRateRounding (::std::auto_ptr< finalRateRounding_type > p);

    // averagingMethod
    // 
    typedef ::FpML_4_2::AveragingMethodEnum averagingMethod_type;
    typedef ::xsd::cxx::tree::optional< averagingMethod_type > averagingMethod_optional;
    typedef ::xsd::cxx::tree::traits< averagingMethod_type, char > averagingMethod_traits;

    const averagingMethod_optional&
    averagingMethod () const;

    averagingMethod_optional&
    averagingMethod ();

    void
    averagingMethod (const averagingMethod_type& x);

    void
    averagingMethod (const averagingMethod_optional& x);

    void
    averagingMethod (::std::auto_ptr< averagingMethod_type > p);

    // negativeInterestRateTreatment
    // 
    typedef ::FpML_4_2::NegativeInterestRateTreatmentEnum negativeInterestRateTreatment_type;
    typedef ::xsd::cxx::tree::optional< negativeInterestRateTreatment_type > negativeInterestRateTreatment_optional;
    typedef ::xsd::cxx::tree::traits< negativeInterestRateTreatment_type, char > negativeInterestRateTreatment_traits;

    const negativeInterestRateTreatment_optional&
    negativeInterestRateTreatment () const;

    negativeInterestRateTreatment_optional&
    negativeInterestRateTreatment ();

    void
    negativeInterestRateTreatment (const negativeInterestRateTreatment_type& x);

    void
    negativeInterestRateTreatment (const negativeInterestRateTreatment_optional& x);

    void
    negativeInterestRateTreatment (::std::auto_ptr< negativeInterestRateTreatment_type > p);

    // Constructors.
    //
    FloatingRateCalculation (const floatingRateIndex_type&);

    FloatingRateCalculation (::std::auto_ptr< floatingRateIndex_type >&);

    FloatingRateCalculation (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    FloatingRateCalculation (const FloatingRateCalculation& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual FloatingRateCalculation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FloatingRateCalculation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    initialRate_optional initialRate_;
    finalRateRounding_optional finalRateRounding_;
    averagingMethod_optional averagingMethod_;
    negativeInterestRateTreatment_optional negativeInterestRateTreatment_;
  };

  class FloatingRateIndex: public ::xml_schema::normalized_string
  {
    public:
    // floatingRateIndexScheme
    // 
    typedef ::xml_schema::uri floatingRateIndexScheme_type;
    typedef ::xsd::cxx::tree::traits< floatingRateIndexScheme_type, char > floatingRateIndexScheme_traits;

    const floatingRateIndexScheme_type&
    floatingRateIndexScheme () const;

    floatingRateIndexScheme_type&
    floatingRateIndexScheme ();

    void
    floatingRateIndexScheme (const floatingRateIndexScheme_type& x);

    void
    floatingRateIndexScheme (::std::auto_ptr< floatingRateIndexScheme_type > p);

    static const floatingRateIndexScheme_type&
    floatingRateIndexScheme_default_value ();

    // Constructors.
    //
    FloatingRateIndex ();

    FloatingRateIndex (const char*);

    FloatingRateIndex (const ::std::string&);

    FloatingRateIndex (const ::xml_schema::normalized_string&);

    FloatingRateIndex (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    FloatingRateIndex (const FloatingRateIndex& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual FloatingRateIndex*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FloatingRateIndex ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< floatingRateIndexScheme_type > floatingRateIndexScheme_;
    static const floatingRateIndexScheme_type floatingRateIndexScheme_default_value_;
  };

  class ForecastRateIndex: public ::xml_schema::type
  {
    public:
    // floatingRateIndex
    // 
    typedef ::FpML_4_2::FloatingRateIndex floatingRateIndex_type;
    typedef ::xsd::cxx::tree::traits< floatingRateIndex_type, char > floatingRateIndex_traits;

    const floatingRateIndex_type&
    floatingRateIndex () const;

    floatingRateIndex_type&
    floatingRateIndex ();

    void
    floatingRateIndex (const floatingRateIndex_type& x);

    void
    floatingRateIndex (::std::auto_ptr< floatingRateIndex_type > p);

    // indexTenor
    // 
    typedef ::FpML_4_2::Interval indexTenor_type;
    typedef ::xsd::cxx::tree::traits< indexTenor_type, char > indexTenor_traits;

    const indexTenor_type&
    indexTenor () const;

    indexTenor_type&
    indexTenor ();

    void
    indexTenor (const indexTenor_type& x);

    void
    indexTenor (::std::auto_ptr< indexTenor_type > p);

    // Constructors.
    //
    ForecastRateIndex (const floatingRateIndex_type&,
                       const indexTenor_type&);

    ForecastRateIndex (::std::auto_ptr< floatingRateIndex_type >&,
                       ::std::auto_ptr< indexTenor_type >&);

    ForecastRateIndex (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ForecastRateIndex (const ForecastRateIndex& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual ForecastRateIndex*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ForecastRateIndex ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< floatingRateIndex_type > floatingRateIndex_;
    ::xsd::cxx::tree::one< indexTenor_type > indexTenor_;
  };

  class Formula: public ::xml_schema::type
  {
    public:
    // formulaDescription
    // 
    typedef ::xml_schema::string formulaDescription_type;
    typedef ::xsd::cxx::tree::optional< formulaDescription_type > formulaDescription_optional;
    typedef ::xsd::cxx::tree::traits< formulaDescription_type, char > formulaDescription_traits;

    const formulaDescription_optional&
    formulaDescription () const;

    formulaDescription_optional&
    formulaDescription ();

    void
    formulaDescription (const formulaDescription_type& x);

    void
    formulaDescription (const formulaDescription_optional& x);

    void
    formulaDescription (::std::auto_ptr< formulaDescription_type > p);

    // math
    // 
    typedef ::FpML_4_2::Math math_type;
    typedef ::xsd::cxx::tree::optional< math_type > math_optional;
    typedef ::xsd::cxx::tree::traits< math_type, char > math_traits;

    const math_optional&
    math () const;

    math_optional&
    math ();

    void
    math (const math_type& x);

    void
    math (const math_optional& x);

    void
    math (::std::auto_ptr< math_type > p);

    // formulaComponent
    // 
    typedef ::FpML_4_2::FormulaComponent formulaComponent_type;
    typedef ::xsd::cxx::tree::sequence< formulaComponent_type > formulaComponent_sequence;
    typedef formulaComponent_sequence::iterator formulaComponent_iterator;
    typedef formulaComponent_sequence::const_iterator formulaComponent_const_iterator;
    typedef ::xsd::cxx::tree::traits< formulaComponent_type, char > formulaComponent_traits;

    const formulaComponent_sequence&
    formulaComponent () const;

    formulaComponent_sequence&
    formulaComponent ();

    void
    formulaComponent (const formulaComponent_sequence& s);

    // Constructors.
    //
    Formula ();

    Formula (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Formula (const Formula& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Formula*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Formula ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    formulaDescription_optional formulaDescription_;
    math_optional math_;
    formulaComponent_sequence formulaComponent_;
  };

  class FormulaComponent: public ::xml_schema::type
  {
    public:
    // componentDescription
    // 
    typedef ::xml_schema::string componentDescription_type;
    typedef ::xsd::cxx::tree::traits< componentDescription_type, char > componentDescription_traits;

    const componentDescription_type&
    componentDescription () const;

    componentDescription_type&
    componentDescription ();

    void
    componentDescription (const componentDescription_type& x);

    void
    componentDescription (::std::auto_ptr< componentDescription_type > p);

    // formula
    // 
    typedef ::FpML_4_2::Formula formula_type;
    typedef ::xsd::cxx::tree::optional< formula_type > formula_optional;
    typedef ::xsd::cxx::tree::traits< formula_type, char > formula_traits;

    const formula_optional&
    formula () const;

    formula_optional&
    formula ();

    void
    formula (const formula_type& x);

    void
    formula (const formula_optional& x);

    void
    formula (::std::auto_ptr< formula_type > p);

    // name
    // 
    typedef ::xml_schema::normalized_string name_type;
    typedef ::xsd::cxx::tree::optional< name_type > name_optional;
    typedef ::xsd::cxx::tree::traits< name_type, char > name_traits;

    const name_optional&
    name () const;

    name_optional&
    name ();

    void
    name (const name_type& x);

    void
    name (const name_optional& x);

    void
    name (::std::auto_ptr< name_type > p);

    // href
    // 
    typedef ::xml_schema::idref href_type;
    typedef ::xsd::cxx::tree::optional< href_type > href_optional;
    typedef ::xsd::cxx::tree::traits< href_type, char > href_traits;

    const href_optional&
    href () const;

    href_optional&
    href ();

    void
    href (const href_type& x);

    void
    href (const href_optional& x);

    void
    href (::std::auto_ptr< href_type > p);

    // Constructors.
    //
    FormulaComponent (const componentDescription_type&);

    FormulaComponent (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    FormulaComponent (const FormulaComponent& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual FormulaComponent*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FormulaComponent ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< componentDescription_type > componentDescription_;
    formula_optional formula_;
    name_optional name_;
    href_optional href_;
  };

  class FxCashSettlement: public ::xml_schema::type
  {
    public:
    // settlementCurrency
    // 
    typedef ::FpML_4_2::Currency settlementCurrency_type;
    typedef ::xsd::cxx::tree::traits< settlementCurrency_type, char > settlementCurrency_traits;

    const settlementCurrency_type&
    settlementCurrency () const;

    settlementCurrency_type&
    settlementCurrency ();

    void
    settlementCurrency (const settlementCurrency_type& x);

    void
    settlementCurrency (::std::auto_ptr< settlementCurrency_type > p);

    // fixing
    // 
    typedef ::FpML_4_2::FxFixing fixing_type;
    typedef ::xsd::cxx::tree::sequence< fixing_type > fixing_sequence;
    typedef fixing_sequence::iterator fixing_iterator;
    typedef fixing_sequence::const_iterator fixing_const_iterator;
    typedef ::xsd::cxx::tree::traits< fixing_type, char > fixing_traits;

    const fixing_sequence&
    fixing () const;

    fixing_sequence&
    fixing ();

    void
    fixing (const fixing_sequence& s);

    // Constructors.
    //
    FxCashSettlement (const settlementCurrency_type&);

    FxCashSettlement (::std::auto_ptr< settlementCurrency_type >&);

    FxCashSettlement (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    FxCashSettlement (const FxCashSettlement& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual FxCashSettlement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxCashSettlement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< settlementCurrency_type > settlementCurrency_;
    fixing_sequence fixing_;
  };

  class FxSpotRateSource: public ::xml_schema::type
  {
    public:
    // primaryRateSource
    // 
    typedef ::FpML_4_2::InformationSource primaryRateSource_type;
    typedef ::xsd::cxx::tree::traits< primaryRateSource_type, char > primaryRateSource_traits;

    const primaryRateSource_type&
    primaryRateSource () const;

    primaryRateSource_type&
    primaryRateSource ();

    void
    primaryRateSource (const primaryRateSource_type& x);

    void
    primaryRateSource (::std::auto_ptr< primaryRateSource_type > p);

    // secondaryRateSource
    // 
    typedef ::FpML_4_2::InformationSource secondaryRateSource_type;
    typedef ::xsd::cxx::tree::optional< secondaryRateSource_type > secondaryRateSource_optional;
    typedef ::xsd::cxx::tree::traits< secondaryRateSource_type, char > secondaryRateSource_traits;

    const secondaryRateSource_optional&
    secondaryRateSource () const;

    secondaryRateSource_optional&
    secondaryRateSource ();

    void
    secondaryRateSource (const secondaryRateSource_type& x);

    void
    secondaryRateSource (const secondaryRateSource_optional& x);

    void
    secondaryRateSource (::std::auto_ptr< secondaryRateSource_type > p);

    // fixingTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime fixingTime_type;
    typedef ::xsd::cxx::tree::traits< fixingTime_type, char > fixingTime_traits;

    const fixingTime_type&
    fixingTime () const;

    fixingTime_type&
    fixingTime ();

    void
    fixingTime (const fixingTime_type& x);

    void
    fixingTime (::std::auto_ptr< fixingTime_type > p);

    // Constructors.
    //
    FxSpotRateSource (const primaryRateSource_type&,
                      const fixingTime_type&);

    FxSpotRateSource (::std::auto_ptr< primaryRateSource_type >&,
                      ::std::auto_ptr< fixingTime_type >&);

    FxSpotRateSource (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    FxSpotRateSource (const FxSpotRateSource& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual FxSpotRateSource*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxSpotRateSource ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< primaryRateSource_type > primaryRateSource_;
    secondaryRateSource_optional secondaryRateSource_;
    ::xsd::cxx::tree::one< fixingTime_type > fixingTime_;
  };

  class FxFixing: public ::FpML_4_2::FxSpotRateSource
  {
    public:
    // quotedCurrencyPair
    // 
    typedef ::FpML_4_2::QuotedCurrencyPair quotedCurrencyPair_type;
    typedef ::xsd::cxx::tree::traits< quotedCurrencyPair_type, char > quotedCurrencyPair_traits;

    const quotedCurrencyPair_type&
    quotedCurrencyPair () const;

    quotedCurrencyPair_type&
    quotedCurrencyPair ();

    void
    quotedCurrencyPair (const quotedCurrencyPair_type& x);

    void
    quotedCurrencyPair (::std::auto_ptr< quotedCurrencyPair_type > p);

    // fixingDate
    // 
    typedef ::xml_schema::date fixingDate_type;
    typedef ::xsd::cxx::tree::traits< fixingDate_type, char > fixingDate_traits;

    const fixingDate_type&
    fixingDate () const;

    fixingDate_type&
    fixingDate ();

    void
    fixingDate (const fixingDate_type& x);

    void
    fixingDate (::std::auto_ptr< fixingDate_type > p);

    // Constructors.
    //
    FxFixing (const primaryRateSource_type&,
              const fixingTime_type&,
              const quotedCurrencyPair_type&,
              const fixingDate_type&);

    FxFixing (::std::auto_ptr< primaryRateSource_type >&,
              ::std::auto_ptr< fixingTime_type >&,
              ::std::auto_ptr< quotedCurrencyPair_type >&,
              const fixingDate_type&);

    FxFixing (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    FxFixing (const FxFixing& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual FxFixing*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxFixing ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< quotedCurrencyPair_type > quotedCurrencyPair_;
    ::xsd::cxx::tree::one< fixingDate_type > fixingDate_;
  };

  class FxRate: public ::xml_schema::type
  {
    public:
    // quotedCurrencyPair
    // 
    typedef ::FpML_4_2::QuotedCurrencyPair quotedCurrencyPair_type;
    typedef ::xsd::cxx::tree::traits< quotedCurrencyPair_type, char > quotedCurrencyPair_traits;

    const quotedCurrencyPair_type&
    quotedCurrencyPair () const;

    quotedCurrencyPair_type&
    quotedCurrencyPair ();

    void
    quotedCurrencyPair (const quotedCurrencyPair_type& x);

    void
    quotedCurrencyPair (::std::auto_ptr< quotedCurrencyPair_type > p);

    // rate
    // 
    typedef ::xml_schema::decimal rate_type;
    typedef ::xsd::cxx::tree::traits< rate_type, char, ::xsd::cxx::tree::schema_type::decimal > rate_traits;

    const rate_type&
    rate () const;

    rate_type&
    rate ();

    void
    rate (const rate_type& x);

    // Constructors.
    //
    FxRate (const quotedCurrencyPair_type&,
            const rate_type&);

    FxRate (::std::auto_ptr< quotedCurrencyPair_type >&,
            const rate_type&);

    FxRate (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    FxRate (const FxRate& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual FxRate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~FxRate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< quotedCurrencyPair_type > quotedCurrencyPair_;
    ::xsd::cxx::tree::one< rate_type > rate_;
  };

  class GoverningLaw: public ::xml_schema::normalized_string
  {
    public:
    // governingLawScheme
    // 
    typedef ::xml_schema::uri governingLawScheme_type;
    typedef ::xsd::cxx::tree::traits< governingLawScheme_type, char > governingLawScheme_traits;

    const governingLawScheme_type&
    governingLawScheme () const;

    governingLawScheme_type&
    governingLawScheme ();

    void
    governingLawScheme (const governingLawScheme_type& x);

    void
    governingLawScheme (::std::auto_ptr< governingLawScheme_type > p);

    static const governingLawScheme_type&
    governingLawScheme_default_value ();

    // Constructors.
    //
    GoverningLaw ();

    GoverningLaw (const char*);

    GoverningLaw (const ::std::string&);

    GoverningLaw (const ::xml_schema::normalized_string&);

    GoverningLaw (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    GoverningLaw (const GoverningLaw& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual GoverningLaw*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~GoverningLaw ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< governingLawScheme_type > governingLawScheme_;
    static const governingLawScheme_type governingLawScheme_default_value_;
  };

  class IdentifiedCurrency: public ::FpML_4_2::Currency
  {
    public:
    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    IdentifiedCurrency ();

    IdentifiedCurrency (const char*);

    IdentifiedCurrency (const ::std::string&);

    IdentifiedCurrency (const ::xml_schema::normalized_string&);

    IdentifiedCurrency (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    IdentifiedCurrency (const IdentifiedCurrency& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual IdentifiedCurrency*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IdentifiedCurrency ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    id_optional id_;
  };

  class IdentifiedDate: public ::xml_schema::date
  {
    public:
    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    IdentifiedDate (const ::xml_schema::date&);

    IdentifiedDate (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    IdentifiedDate (const IdentifiedDate& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual IdentifiedDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IdentifiedDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    id_optional id_;
  };

  class IdentifiedPayerReceiver: public ::FpML_4_2::PayerReceiverEnum
  {
    public:
    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    IdentifiedPayerReceiver (::FpML_4_2::PayerReceiverEnum::value);

    IdentifiedPayerReceiver (const char*);

    IdentifiedPayerReceiver (const ::std::string&);

    IdentifiedPayerReceiver (const ::FpML_4_2::PayerReceiverEnum&);

    IdentifiedPayerReceiver (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    IdentifiedPayerReceiver (const IdentifiedPayerReceiver& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual IdentifiedPayerReceiver*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IdentifiedPayerReceiver ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    id_optional id_;
  };

  class InformationProvider: public ::xml_schema::normalized_string
  {
    public:
    // informationProviderScheme
    // 
    typedef ::xml_schema::uri informationProviderScheme_type;
    typedef ::xsd::cxx::tree::traits< informationProviderScheme_type, char > informationProviderScheme_traits;

    const informationProviderScheme_type&
    informationProviderScheme () const;

    informationProviderScheme_type&
    informationProviderScheme ();

    void
    informationProviderScheme (const informationProviderScheme_type& x);

    void
    informationProviderScheme (::std::auto_ptr< informationProviderScheme_type > p);

    static const informationProviderScheme_type&
    informationProviderScheme_default_value ();

    // Constructors.
    //
    InformationProvider ();

    InformationProvider (const char*);

    InformationProvider (const ::std::string&);

    InformationProvider (const ::xml_schema::normalized_string&);

    InformationProvider (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    InformationProvider (const InformationProvider& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual InformationProvider*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InformationProvider ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< informationProviderScheme_type > informationProviderScheme_;
    static const informationProviderScheme_type informationProviderScheme_default_value_;
  };

  class InformationSource: public ::xml_schema::type
  {
    public:
    // rateSource
    // 
    typedef ::FpML_4_2::InformationProvider rateSource_type;
    typedef ::xsd::cxx::tree::traits< rateSource_type, char > rateSource_traits;

    const rateSource_type&
    rateSource () const;

    rateSource_type&
    rateSource ();

    void
    rateSource (const rateSource_type& x);

    void
    rateSource (::std::auto_ptr< rateSource_type > p);

    // rateSourcePage
    // 
    typedef ::FpML_4_2::RateSourcePage rateSourcePage_type;
    typedef ::xsd::cxx::tree::optional< rateSourcePage_type > rateSourcePage_optional;
    typedef ::xsd::cxx::tree::traits< rateSourcePage_type, char > rateSourcePage_traits;

    const rateSourcePage_optional&
    rateSourcePage () const;

    rateSourcePage_optional&
    rateSourcePage ();

    void
    rateSourcePage (const rateSourcePage_type& x);

    void
    rateSourcePage (const rateSourcePage_optional& x);

    void
    rateSourcePage (::std::auto_ptr< rateSourcePage_type > p);

    // rateSourcePageHeading
    // 
    typedef ::xml_schema::string rateSourcePageHeading_type;
    typedef ::xsd::cxx::tree::optional< rateSourcePageHeading_type > rateSourcePageHeading_optional;
    typedef ::xsd::cxx::tree::traits< rateSourcePageHeading_type, char > rateSourcePageHeading_traits;

    const rateSourcePageHeading_optional&
    rateSourcePageHeading () const;

    rateSourcePageHeading_optional&
    rateSourcePageHeading ();

    void
    rateSourcePageHeading (const rateSourcePageHeading_type& x);

    void
    rateSourcePageHeading (const rateSourcePageHeading_optional& x);

    void
    rateSourcePageHeading (::std::auto_ptr< rateSourcePageHeading_type > p);

    // Constructors.
    //
    InformationSource (const rateSource_type&);

    InformationSource (::std::auto_ptr< rateSource_type >&);

    InformationSource (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    InformationSource (const InformationSource& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual InformationSource*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InformationSource ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< rateSource_type > rateSource_;
    rateSourcePage_optional rateSourcePage_;
    rateSourcePageHeading_optional rateSourcePageHeading_;
  };

  class InstrumentId: public ::xml_schema::normalized_string
  {
    public:
    // instrumentIdScheme
    // 
    typedef ::xml_schema::uri instrumentIdScheme_type;
    typedef ::xsd::cxx::tree::traits< instrumentIdScheme_type, char > instrumentIdScheme_traits;

    const instrumentIdScheme_type&
    instrumentIdScheme () const;

    instrumentIdScheme_type&
    instrumentIdScheme ();

    void
    instrumentIdScheme (const instrumentIdScheme_type& x);

    void
    instrumentIdScheme (::std::auto_ptr< instrumentIdScheme_type > p);

    // Constructors.
    //
    InstrumentId (const instrumentIdScheme_type&);

    InstrumentId (const char*,
                  const instrumentIdScheme_type&);

    InstrumentId (const ::std::string&,
                  const instrumentIdScheme_type&);

    InstrumentId (const ::xml_schema::normalized_string&,
                  const instrumentIdScheme_type&);

    InstrumentId (const ::xercesc::DOMElement& e,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    InstrumentId (const InstrumentId& x,
                  ::xml_schema::flags f = 0,
                  ::xml_schema::container* c = 0);

    virtual InstrumentId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InstrumentId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< instrumentIdScheme_type > instrumentIdScheme_;
  };

  class InterestAccrualsMethod: public ::xml_schema::type
  {
    public:
    // floatingRateCalculation
    // 
    typedef ::FpML_4_2::FloatingRateCalculation floatingRateCalculation_type;
    typedef ::xsd::cxx::tree::optional< floatingRateCalculation_type > floatingRateCalculation_optional;
    typedef ::xsd::cxx::tree::traits< floatingRateCalculation_type, char > floatingRateCalculation_traits;

    const floatingRateCalculation_optional&
    floatingRateCalculation () const;

    floatingRateCalculation_optional&
    floatingRateCalculation ();

    void
    floatingRateCalculation (const floatingRateCalculation_type& x);

    void
    floatingRateCalculation (const floatingRateCalculation_optional& x);

    void
    floatingRateCalculation (::std::auto_ptr< floatingRateCalculation_type > p);

    // fixedRate
    // 
    typedef ::xml_schema::decimal fixedRate_type;
    typedef ::xsd::cxx::tree::optional< fixedRate_type > fixedRate_optional;
    typedef ::xsd::cxx::tree::traits< fixedRate_type, char, ::xsd::cxx::tree::schema_type::decimal > fixedRate_traits;

    const fixedRate_optional&
    fixedRate () const;

    fixedRate_optional&
    fixedRate ();

    void
    fixedRate (const fixedRate_type& x);

    void
    fixedRate (const fixedRate_optional& x);

    // Constructors.
    //
    InterestAccrualsMethod ();

    InterestAccrualsMethod (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    InterestAccrualsMethod (const InterestAccrualsMethod& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual InterestAccrualsMethod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InterestAccrualsMethod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    floatingRateCalculation_optional floatingRateCalculation_;
    fixedRate_optional fixedRate_;
  };

  class InterestAccrualsCompoundingMethod: public ::FpML_4_2::InterestAccrualsMethod
  {
    public:
    // compoundingMethod
    // 
    typedef ::FpML_4_2::CompoundingMethodEnum compoundingMethod_type;
    typedef ::xsd::cxx::tree::optional< compoundingMethod_type > compoundingMethod_optional;
    typedef ::xsd::cxx::tree::traits< compoundingMethod_type, char > compoundingMethod_traits;

    const compoundingMethod_optional&
    compoundingMethod () const;

    compoundingMethod_optional&
    compoundingMethod ();

    void
    compoundingMethod (const compoundingMethod_type& x);

    void
    compoundingMethod (const compoundingMethod_optional& x);

    void
    compoundingMethod (::std::auto_ptr< compoundingMethod_type > p);

    // Constructors.
    //
    InterestAccrualsCompoundingMethod ();

    InterestAccrualsCompoundingMethod (const ::xercesc::DOMElement& e,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    InterestAccrualsCompoundingMethod (const InterestAccrualsCompoundingMethod& x,
                                       ::xml_schema::flags f = 0,
                                       ::xml_schema::container* c = 0);

    virtual InterestAccrualsCompoundingMethod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~InterestAccrualsCompoundingMethod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    compoundingMethod_optional compoundingMethod_;
  };

  class IntermediaryInformation: public ::FpML_4_2::Routing
  {
    public:
    // intermediarySequenceNumber
    // 
    typedef ::xml_schema::integer intermediarySequenceNumber_type;
    typedef ::xsd::cxx::tree::traits< intermediarySequenceNumber_type, char > intermediarySequenceNumber_traits;

    const intermediarySequenceNumber_type&
    intermediarySequenceNumber () const;

    intermediarySequenceNumber_type&
    intermediarySequenceNumber ();

    void
    intermediarySequenceNumber (const intermediarySequenceNumber_type& x);

    // intermediaryPartyReference
    // 
    typedef ::FpML_4_2::PartyReference intermediaryPartyReference_type;
    typedef ::xsd::cxx::tree::optional< intermediaryPartyReference_type > intermediaryPartyReference_optional;
    typedef ::xsd::cxx::tree::traits< intermediaryPartyReference_type, char > intermediaryPartyReference_traits;

    const intermediaryPartyReference_optional&
    intermediaryPartyReference () const;

    intermediaryPartyReference_optional&
    intermediaryPartyReference ();

    void
    intermediaryPartyReference (const intermediaryPartyReference_type& x);

    void
    intermediaryPartyReference (const intermediaryPartyReference_optional& x);

    void
    intermediaryPartyReference (::std::auto_ptr< intermediaryPartyReference_type > p);

    // Constructors.
    //
    IntermediaryInformation (const intermediarySequenceNumber_type&);

    IntermediaryInformation (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    IntermediaryInformation (const IntermediaryInformation& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual IntermediaryInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~IntermediaryInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< intermediarySequenceNumber_type > intermediarySequenceNumber_;
    intermediaryPartyReference_optional intermediaryPartyReference_;
  };

  class LegalEntity: public ::xml_schema::type
  {
    public:
    // entityName
    // 
    typedef ::FpML_4_2::EntityName entityName_type;
    typedef ::xsd::cxx::tree::optional< entityName_type > entityName_optional;
    typedef ::xsd::cxx::tree::traits< entityName_type, char > entityName_traits;

    const entityName_optional&
    entityName () const;

    entityName_optional&
    entityName ();

    void
    entityName (const entityName_type& x);

    void
    entityName (const entityName_optional& x);

    void
    entityName (::std::auto_ptr< entityName_type > p);

    // entityId
    // 
    typedef ::FpML_4_2::EntityId entityId_type;
    typedef ::xsd::cxx::tree::sequence< entityId_type > entityId_sequence;
    typedef entityId_sequence::iterator entityId_iterator;
    typedef entityId_sequence::const_iterator entityId_const_iterator;
    typedef ::xsd::cxx::tree::traits< entityId_type, char > entityId_traits;

    const entityId_sequence&
    entityId () const;

    entityId_sequence&
    entityId ();

    void
    entityId (const entityId_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    LegalEntity ();

    LegalEntity (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    LegalEntity (const LegalEntity& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual LegalEntity*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~LegalEntity ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    entityName_optional entityName_;
    entityId_sequence entityId_;
    id_optional id_;
  };

  class LegalEntityReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    LegalEntityReference (const href_type&);

    LegalEntityReference (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    LegalEntityReference (const LegalEntityReference& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual LegalEntityReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~LegalEntityReference ();
  };

  class MainPublication: public ::xml_schema::normalized_string
  {
    public:
    // mainPublicationScheme
    // 
    typedef ::xml_schema::uri mainPublicationScheme_type;
    typedef ::xsd::cxx::tree::traits< mainPublicationScheme_type, char > mainPublicationScheme_traits;

    const mainPublicationScheme_type&
    mainPublicationScheme () const;

    mainPublicationScheme_type&
    mainPublicationScheme ();

    void
    mainPublicationScheme (const mainPublicationScheme_type& x);

    void
    mainPublicationScheme (::std::auto_ptr< mainPublicationScheme_type > p);

    static const mainPublicationScheme_type&
    mainPublicationScheme_default_value ();

    // Constructors.
    //
    MainPublication ();

    MainPublication (const char*);

    MainPublication (const ::std::string&);

    MainPublication (const ::xml_schema::normalized_string&);

    MainPublication (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    MainPublication (const MainPublication& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual MainPublication*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MainPublication ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< mainPublicationScheme_type > mainPublicationScheme_;
    static const mainPublicationScheme_type mainPublicationScheme_default_value_;
  };

  class ManualExercise: public ::xml_schema::type
  {
    public:
    // exerciseNotice
    // 
    typedef ::FpML_4_2::ExerciseNotice exerciseNotice_type;
    typedef ::xsd::cxx::tree::optional< exerciseNotice_type > exerciseNotice_optional;
    typedef ::xsd::cxx::tree::traits< exerciseNotice_type, char > exerciseNotice_traits;

    const exerciseNotice_optional&
    exerciseNotice () const;

    exerciseNotice_optional&
    exerciseNotice ();

    void
    exerciseNotice (const exerciseNotice_type& x);

    void
    exerciseNotice (const exerciseNotice_optional& x);

    void
    exerciseNotice (::std::auto_ptr< exerciseNotice_type > p);

    // fallbackExercise
    // 
    typedef ::xml_schema::boolean fallbackExercise_type;
    typedef ::xsd::cxx::tree::optional< fallbackExercise_type > fallbackExercise_optional;
    typedef ::xsd::cxx::tree::traits< fallbackExercise_type, char > fallbackExercise_traits;

    const fallbackExercise_optional&
    fallbackExercise () const;

    fallbackExercise_optional&
    fallbackExercise ();

    void
    fallbackExercise (const fallbackExercise_type& x);

    void
    fallbackExercise (const fallbackExercise_optional& x);

    // Constructors.
    //
    ManualExercise ();

    ManualExercise (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ManualExercise (const ManualExercise& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ManualExercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ManualExercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    exerciseNotice_optional exerciseNotice_;
    fallbackExercise_optional fallbackExercise_;
  };

  class MasterAgreement: public ::xml_schema::type
  {
    public:
    // masterAgreementType
    // 
    typedef ::FpML_4_2::MasterAgreementType masterAgreementType_type;
    typedef ::xsd::cxx::tree::traits< masterAgreementType_type, char > masterAgreementType_traits;

    const masterAgreementType_type&
    masterAgreementType () const;

    masterAgreementType_type&
    masterAgreementType ();

    void
    masterAgreementType (const masterAgreementType_type& x);

    void
    masterAgreementType (::std::auto_ptr< masterAgreementType_type > p);

    // masterAgreementDate
    // 
    typedef ::xml_schema::date masterAgreementDate_type;
    typedef ::xsd::cxx::tree::optional< masterAgreementDate_type > masterAgreementDate_optional;
    typedef ::xsd::cxx::tree::traits< masterAgreementDate_type, char > masterAgreementDate_traits;

    const masterAgreementDate_optional&
    masterAgreementDate () const;

    masterAgreementDate_optional&
    masterAgreementDate ();

    void
    masterAgreementDate (const masterAgreementDate_type& x);

    void
    masterAgreementDate (const masterAgreementDate_optional& x);

    void
    masterAgreementDate (::std::auto_ptr< masterAgreementDate_type > p);

    // Constructors.
    //
    MasterAgreement (const masterAgreementType_type&);

    MasterAgreement (::std::auto_ptr< masterAgreementType_type >&);

    MasterAgreement (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    MasterAgreement (const MasterAgreement& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual MasterAgreement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MasterAgreement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< masterAgreementType_type > masterAgreementType_;
    masterAgreementDate_optional masterAgreementDate_;
  };

  class MasterAgreementType: public ::xml_schema::normalized_string
  {
    public:
    // masterAgreementTypeScheme
    // 
    typedef ::xml_schema::uri masterAgreementTypeScheme_type;
    typedef ::xsd::cxx::tree::traits< masterAgreementTypeScheme_type, char > masterAgreementTypeScheme_traits;

    const masterAgreementTypeScheme_type&
    masterAgreementTypeScheme () const;

    masterAgreementTypeScheme_type&
    masterAgreementTypeScheme ();

    void
    masterAgreementTypeScheme (const masterAgreementTypeScheme_type& x);

    void
    masterAgreementTypeScheme (::std::auto_ptr< masterAgreementTypeScheme_type > p);

    static const masterAgreementTypeScheme_type&
    masterAgreementTypeScheme_default_value ();

    // Constructors.
    //
    MasterAgreementType ();

    MasterAgreementType (const char*);

    MasterAgreementType (const ::std::string&);

    MasterAgreementType (const ::xml_schema::normalized_string&);

    MasterAgreementType (const ::xercesc::DOMElement& e,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    MasterAgreementType (const MasterAgreementType& x,
                         ::xml_schema::flags f = 0,
                         ::xml_schema::container* c = 0);

    virtual MasterAgreementType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MasterAgreementType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< masterAgreementTypeScheme_type > masterAgreementTypeScheme_;
    static const masterAgreementTypeScheme_type masterAgreementTypeScheme_default_value_;
  };

  class MasterConfirmation: public ::xml_schema::type
  {
    public:
    // masterConfirmationType
    // 
    typedef ::FpML_4_2::MasterConfirmationType masterConfirmationType_type;
    typedef ::xsd::cxx::tree::traits< masterConfirmationType_type, char > masterConfirmationType_traits;

    const masterConfirmationType_type&
    masterConfirmationType () const;

    masterConfirmationType_type&
    masterConfirmationType ();

    void
    masterConfirmationType (const masterConfirmationType_type& x);

    void
    masterConfirmationType (::std::auto_ptr< masterConfirmationType_type > p);

    // masterConfirmationDate
    // 
    typedef ::xml_schema::date masterConfirmationDate_type;
    typedef ::xsd::cxx::tree::traits< masterConfirmationDate_type, char > masterConfirmationDate_traits;

    const masterConfirmationDate_type&
    masterConfirmationDate () const;

    masterConfirmationDate_type&
    masterConfirmationDate ();

    void
    masterConfirmationDate (const masterConfirmationDate_type& x);

    void
    masterConfirmationDate (::std::auto_ptr< masterConfirmationDate_type > p);

    // masterConfirmationAnnexDate
    // 
    typedef ::xml_schema::date masterConfirmationAnnexDate_type;
    typedef ::xsd::cxx::tree::optional< masterConfirmationAnnexDate_type > masterConfirmationAnnexDate_optional;
    typedef ::xsd::cxx::tree::traits< masterConfirmationAnnexDate_type, char > masterConfirmationAnnexDate_traits;

    const masterConfirmationAnnexDate_optional&
    masterConfirmationAnnexDate () const;

    masterConfirmationAnnexDate_optional&
    masterConfirmationAnnexDate ();

    void
    masterConfirmationAnnexDate (const masterConfirmationAnnexDate_type& x);

    void
    masterConfirmationAnnexDate (const masterConfirmationAnnexDate_optional& x);

    void
    masterConfirmationAnnexDate (::std::auto_ptr< masterConfirmationAnnexDate_type > p);

    // Constructors.
    //
    MasterConfirmation (const masterConfirmationType_type&,
                        const masterConfirmationDate_type&);

    MasterConfirmation (::std::auto_ptr< masterConfirmationType_type >&,
                        const masterConfirmationDate_type&);

    MasterConfirmation (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    MasterConfirmation (const MasterConfirmation& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual MasterConfirmation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MasterConfirmation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< masterConfirmationType_type > masterConfirmationType_;
    ::xsd::cxx::tree::one< masterConfirmationDate_type > masterConfirmationDate_;
    masterConfirmationAnnexDate_optional masterConfirmationAnnexDate_;
  };

  class MasterConfirmationType: public ::xml_schema::normalized_string
  {
    public:
    // masterConfirmationTypeScheme
    // 
    typedef ::xml_schema::uri masterConfirmationTypeScheme_type;
    typedef ::xsd::cxx::tree::traits< masterConfirmationTypeScheme_type, char > masterConfirmationTypeScheme_traits;

    const masterConfirmationTypeScheme_type&
    masterConfirmationTypeScheme () const;

    masterConfirmationTypeScheme_type&
    masterConfirmationTypeScheme ();

    void
    masterConfirmationTypeScheme (const masterConfirmationTypeScheme_type& x);

    void
    masterConfirmationTypeScheme (::std::auto_ptr< masterConfirmationTypeScheme_type > p);

    static const masterConfirmationTypeScheme_type&
    masterConfirmationTypeScheme_default_value ();

    // Constructors.
    //
    MasterConfirmationType ();

    MasterConfirmationType (const char*);

    MasterConfirmationType (const ::std::string&);

    MasterConfirmationType (const ::xml_schema::normalized_string&);

    MasterConfirmationType (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    MasterConfirmationType (const MasterConfirmationType& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual MasterConfirmationType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MasterConfirmationType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< masterConfirmationTypeScheme_type > masterConfirmationTypeScheme_;
    static const masterConfirmationTypeScheme_type masterConfirmationTypeScheme_default_value_;
  };

  class Math: public ::xml_schema::type
  {
    public:
    // Constructors.
    //
    Math ();

    Math (const ::xercesc::DOMElement& e,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    Math (const Math& x,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    virtual Math*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Math ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
  };

  class MatrixType: public ::xml_schema::normalized_string
  {
    public:
    // matrixTypeScheme
    // 
    typedef ::xml_schema::uri matrixTypeScheme_type;
    typedef ::xsd::cxx::tree::traits< matrixTypeScheme_type, char > matrixTypeScheme_traits;

    const matrixTypeScheme_type&
    matrixTypeScheme () const;

    matrixTypeScheme_type&
    matrixTypeScheme ();

    void
    matrixTypeScheme (const matrixTypeScheme_type& x);

    void
    matrixTypeScheme (::std::auto_ptr< matrixTypeScheme_type > p);

    static const matrixTypeScheme_type&
    matrixTypeScheme_default_value ();

    // Constructors.
    //
    MatrixType ();

    MatrixType (const char*);

    MatrixType (const ::std::string&);

    MatrixType (const ::xml_schema::normalized_string&);

    MatrixType (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    MatrixType (const MatrixType& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual MatrixType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MatrixType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< matrixTypeScheme_type > matrixTypeScheme_;
    static const matrixTypeScheme_type matrixTypeScheme_default_value_;
  };

  class MatrixTerm: public ::xml_schema::normalized_string
  {
    public:
    // matrixTermScheme
    // 
    typedef ::xml_schema::uri matrixTermScheme_type;
    typedef ::xsd::cxx::tree::traits< matrixTermScheme_type, char > matrixTermScheme_traits;

    const matrixTermScheme_type&
    matrixTermScheme () const;

    matrixTermScheme_type&
    matrixTermScheme ();

    void
    matrixTermScheme (const matrixTermScheme_type& x);

    void
    matrixTermScheme (::std::auto_ptr< matrixTermScheme_type > p);

    static const matrixTermScheme_type&
    matrixTermScheme_default_value ();

    // Constructors.
    //
    MatrixTerm ();

    MatrixTerm (const char*);

    MatrixTerm (const ::std::string&);

    MatrixTerm (const ::xml_schema::normalized_string&);

    MatrixTerm (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    MatrixTerm (const MatrixTerm& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual MatrixTerm*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MatrixTerm ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< matrixTermScheme_type > matrixTermScheme_;
    static const matrixTermScheme_type matrixTermScheme_default_value_;
  };

  class Money: public ::xml_schema::type
  {
    public:
    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_type&
    currency () const;

    currency_type&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // amount
    // 
    typedef ::xml_schema::decimal amount_type;
    typedef ::xsd::cxx::tree::traits< amount_type, char, ::xsd::cxx::tree::schema_type::decimal > amount_traits;

    const amount_type&
    amount () const;

    amount_type&
    amount ();

    void
    amount (const amount_type& x);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Money (const currency_type&,
           const amount_type&);

    Money (::std::auto_ptr< currency_type >&,
           const amount_type&);

    Money (const ::xercesc::DOMElement& e,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    Money (const Money& x,
           ::xml_schema::flags f = 0,
           ::xml_schema::container* c = 0);

    virtual Money*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Money ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< currency_type > currency_;
    ::xsd::cxx::tree::one< amount_type > amount_;
    id_optional id_;
  };

  class PartialExercise: public ::xml_schema::type
  {
    public:
    // notionalReference
    // 
    typedef ::FpML_4_2::ScheduleReference notionalReference_type;
    typedef ::xsd::cxx::tree::sequence< notionalReference_type > notionalReference_sequence;
    typedef notionalReference_sequence::iterator notionalReference_iterator;
    typedef notionalReference_sequence::const_iterator notionalReference_const_iterator;
    typedef ::xsd::cxx::tree::traits< notionalReference_type, char > notionalReference_traits;

    const notionalReference_sequence&
    notionalReference () const;

    notionalReference_sequence&
    notionalReference ();

    void
    notionalReference (const notionalReference_sequence& s);

    // integralMultipleAmount
    // 
    typedef ::xml_schema::decimal integralMultipleAmount_type;
    typedef ::xsd::cxx::tree::optional< integralMultipleAmount_type > integralMultipleAmount_optional;
    typedef ::xsd::cxx::tree::traits< integralMultipleAmount_type, char, ::xsd::cxx::tree::schema_type::decimal > integralMultipleAmount_traits;

    const integralMultipleAmount_optional&
    integralMultipleAmount () const;

    integralMultipleAmount_optional&
    integralMultipleAmount ();

    void
    integralMultipleAmount (const integralMultipleAmount_type& x);

    void
    integralMultipleAmount (const integralMultipleAmount_optional& x);

    // minimumNotionalAmount
    // 
    typedef ::xml_schema::decimal minimumNotionalAmount_type;
    typedef ::xsd::cxx::tree::traits< minimumNotionalAmount_type, char, ::xsd::cxx::tree::schema_type::decimal > minimumNotionalAmount_traits;

    const minimumNotionalAmount_type&
    minimumNotionalAmount () const;

    minimumNotionalAmount_type&
    minimumNotionalAmount ();

    void
    minimumNotionalAmount (const minimumNotionalAmount_type& x);

    // Constructors.
    //
    PartialExercise (const minimumNotionalAmount_type&);

    PartialExercise (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    PartialExercise (const PartialExercise& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual PartialExercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PartialExercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    notionalReference_sequence notionalReference_;
    integralMultipleAmount_optional integralMultipleAmount_;
    ::xsd::cxx::tree::one< minimumNotionalAmount_type > minimumNotionalAmount_;
  };

  class MultipleExercise: public ::FpML_4_2::PartialExercise
  {
    public:
    // maximumNotionalAmount
    // 
    typedef ::xml_schema::decimal maximumNotionalAmount_type;
    typedef ::xsd::cxx::tree::optional< maximumNotionalAmount_type > maximumNotionalAmount_optional;
    typedef ::xsd::cxx::tree::traits< maximumNotionalAmount_type, char, ::xsd::cxx::tree::schema_type::decimal > maximumNotionalAmount_traits;

    const maximumNotionalAmount_optional&
    maximumNotionalAmount () const;

    maximumNotionalAmount_optional&
    maximumNotionalAmount ();

    void
    maximumNotionalAmount (const maximumNotionalAmount_type& x);

    void
    maximumNotionalAmount (const maximumNotionalAmount_optional& x);

    // Constructors.
    //
    MultipleExercise (const minimumNotionalAmount_type&);

    MultipleExercise (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    MultipleExercise (const MultipleExercise& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual MultipleExercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~MultipleExercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    maximumNotionalAmount_optional maximumNotionalAmount_;
  };

  class NotionalAmountReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    NotionalAmountReference (const href_type&);

    NotionalAmountReference (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    NotionalAmountReference (const NotionalAmountReference& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual NotionalAmountReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~NotionalAmountReference ();
  };

  class PartyOrAccountReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    PartyOrAccountReference (const href_type&);

    PartyOrAccountReference (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    PartyOrAccountReference (const PartyOrAccountReference& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual PartyOrAccountReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PartyOrAccountReference ();
  };

  class PartyOrTradeSideReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    PartyOrTradeSideReference (const href_type&);

    PartyOrTradeSideReference (const ::xercesc::DOMElement& e,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    PartyOrTradeSideReference (const PartyOrTradeSideReference& x,
                               ::xml_schema::flags f = 0,
                               ::xml_schema::container* c = 0);

    virtual PartyOrTradeSideReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PartyOrTradeSideReference ();
  };

  class PartyReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    PartyReference (const href_type&);

    PartyReference (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    PartyReference (const PartyReference& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual PartyReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PartyReference ();
  };

  class Payment: public ::xml_schema::type
  {
    public:
    // payerPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference payerPartyReference_type;
    typedef ::xsd::cxx::tree::traits< payerPartyReference_type, char > payerPartyReference_traits;

    const payerPartyReference_type&
    payerPartyReference () const;

    payerPartyReference_type&
    payerPartyReference ();

    void
    payerPartyReference (const payerPartyReference_type& x);

    void
    payerPartyReference (::std::auto_ptr< payerPartyReference_type > p);

    // receiverPartyReference
    // 
    typedef ::FpML_4_2::PartyOrAccountReference receiverPartyReference_type;
    typedef ::xsd::cxx::tree::traits< receiverPartyReference_type, char > receiverPartyReference_traits;

    const receiverPartyReference_type&
    receiverPartyReference () const;

    receiverPartyReference_type&
    receiverPartyReference ();

    void
    receiverPartyReference (const receiverPartyReference_type& x);

    void
    receiverPartyReference (::std::auto_ptr< receiverPartyReference_type > p);

    // paymentAmount
    // 
    typedef ::FpML_4_2::Money paymentAmount_type;
    typedef ::xsd::cxx::tree::traits< paymentAmount_type, char > paymentAmount_traits;

    const paymentAmount_type&
    paymentAmount () const;

    paymentAmount_type&
    paymentAmount ();

    void
    paymentAmount (const paymentAmount_type& x);

    void
    paymentAmount (::std::auto_ptr< paymentAmount_type > p);

    // paymentDate
    // 
    typedef ::FpML_4_2::AdjustableDate paymentDate_type;
    typedef ::xsd::cxx::tree::optional< paymentDate_type > paymentDate_optional;
    typedef ::xsd::cxx::tree::traits< paymentDate_type, char > paymentDate_traits;

    const paymentDate_optional&
    paymentDate () const;

    paymentDate_optional&
    paymentDate ();

    void
    paymentDate (const paymentDate_type& x);

    void
    paymentDate (const paymentDate_optional& x);

    void
    paymentDate (::std::auto_ptr< paymentDate_type > p);

    // adjustedPaymentDate
    // 
    typedef ::FpML_4_2::IdentifiedDate adjustedPaymentDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedPaymentDate_type > adjustedPaymentDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedPaymentDate_type, char > adjustedPaymentDate_traits;

    const adjustedPaymentDate_optional&
    adjustedPaymentDate () const;

    adjustedPaymentDate_optional&
    adjustedPaymentDate ();

    void
    adjustedPaymentDate (const adjustedPaymentDate_type& x);

    void
    adjustedPaymentDate (const adjustedPaymentDate_optional& x);

    void
    adjustedPaymentDate (::std::auto_ptr< adjustedPaymentDate_type > p);

    // paymentType
    // 
    typedef ::FpML_4_2::PaymentType paymentType_type;
    typedef ::xsd::cxx::tree::optional< paymentType_type > paymentType_optional;
    typedef ::xsd::cxx::tree::traits< paymentType_type, char > paymentType_traits;

    const paymentType_optional&
    paymentType () const;

    paymentType_optional&
    paymentType ();

    void
    paymentType (const paymentType_type& x);

    void
    paymentType (const paymentType_optional& x);

    void
    paymentType (::std::auto_ptr< paymentType_type > p);

    // settlementInformation
    // 
    typedef ::FpML_4_2::SettlementInformation settlementInformation_type;
    typedef ::xsd::cxx::tree::optional< settlementInformation_type > settlementInformation_optional;
    typedef ::xsd::cxx::tree::traits< settlementInformation_type, char > settlementInformation_traits;

    const settlementInformation_optional&
    settlementInformation () const;

    settlementInformation_optional&
    settlementInformation ();

    void
    settlementInformation (const settlementInformation_type& x);

    void
    settlementInformation (const settlementInformation_optional& x);

    void
    settlementInformation (::std::auto_ptr< settlementInformation_type > p);

    // discountFactor
    // 
    typedef ::xml_schema::decimal discountFactor_type;
    typedef ::xsd::cxx::tree::optional< discountFactor_type > discountFactor_optional;
    typedef ::xsd::cxx::tree::traits< discountFactor_type, char, ::xsd::cxx::tree::schema_type::decimal > discountFactor_traits;

    const discountFactor_optional&
    discountFactor () const;

    discountFactor_optional&
    discountFactor ();

    void
    discountFactor (const discountFactor_type& x);

    void
    discountFactor (const discountFactor_optional& x);

    // presentValueAmount
    // 
    typedef ::FpML_4_2::Money presentValueAmount_type;
    typedef ::xsd::cxx::tree::optional< presentValueAmount_type > presentValueAmount_optional;
    typedef ::xsd::cxx::tree::traits< presentValueAmount_type, char > presentValueAmount_traits;

    const presentValueAmount_optional&
    presentValueAmount () const;

    presentValueAmount_optional&
    presentValueAmount ();

    void
    presentValueAmount (const presentValueAmount_type& x);

    void
    presentValueAmount (const presentValueAmount_optional& x);

    void
    presentValueAmount (::std::auto_ptr< presentValueAmount_type > p);

    // href
    // 
    typedef ::xml_schema::idref href_type;
    typedef ::xsd::cxx::tree::optional< href_type > href_optional;
    typedef ::xsd::cxx::tree::traits< href_type, char > href_traits;

    const href_optional&
    href () const;

    href_optional&
    href ();

    void
    href (const href_type& x);

    void
    href (const href_optional& x);

    void
    href (::std::auto_ptr< href_type > p);

    // Constructors.
    //
    Payment (const payerPartyReference_type&,
             const receiverPartyReference_type&,
             const paymentAmount_type&);

    Payment (::std::auto_ptr< payerPartyReference_type >&,
             ::std::auto_ptr< receiverPartyReference_type >&,
             ::std::auto_ptr< paymentAmount_type >&);

    Payment (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Payment (const Payment& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Payment*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Payment ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< payerPartyReference_type > payerPartyReference_;
    ::xsd::cxx::tree::one< receiverPartyReference_type > receiverPartyReference_;
    ::xsd::cxx::tree::one< paymentAmount_type > paymentAmount_;
    paymentDate_optional paymentDate_;
    adjustedPaymentDate_optional adjustedPaymentDate_;
    paymentType_optional paymentType_;
    settlementInformation_optional settlementInformation_;
    discountFactor_optional discountFactor_;
    presentValueAmount_optional presentValueAmount_;
    href_optional href_;
  };

  class PaymentCurrency: public ::xml_schema::type
  {
    public:
    // currency
    // 
    typedef ::FpML_4_2::Currency currency_type;
    typedef ::xsd::cxx::tree::optional< currency_type > currency_optional;
    typedef ::xsd::cxx::tree::traits< currency_type, char > currency_traits;

    const currency_optional&
    currency () const;

    currency_optional&
    currency ();

    void
    currency (const currency_type& x);

    void
    currency (const currency_optional& x);

    void
    currency (::std::auto_ptr< currency_type > p);

    // determinationMethod
    // 
    typedef ::FpML_4_2::DeterminationMethod determinationMethod_type;
    typedef ::xsd::cxx::tree::optional< determinationMethod_type > determinationMethod_optional;
    typedef ::xsd::cxx::tree::traits< determinationMethod_type, char > determinationMethod_traits;

    const determinationMethod_optional&
    determinationMethod () const;

    determinationMethod_optional&
    determinationMethod ();

    void
    determinationMethod (const determinationMethod_type& x);

    void
    determinationMethod (const determinationMethod_optional& x);

    void
    determinationMethod (::std::auto_ptr< determinationMethod_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // href
    // 
    typedef ::xml_schema::idref href_type;
    typedef ::xsd::cxx::tree::optional< href_type > href_optional;
    typedef ::xsd::cxx::tree::traits< href_type, char > href_traits;

    const href_optional&
    href () const;

    href_optional&
    href ();

    void
    href (const href_type& x);

    void
    href (const href_optional& x);

    void
    href (::std::auto_ptr< href_type > p);

    // Constructors.
    //
    PaymentCurrency ();

    PaymentCurrency (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    PaymentCurrency (const PaymentCurrency& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual PaymentCurrency*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PaymentCurrency ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    currency_optional currency_;
    determinationMethod_optional determinationMethod_;
    id_optional id_;
    href_optional href_;
  };

  class PaymentType: public ::xml_schema::normalized_string
  {
    public:
    // paymentTypeScheme
    // 
    typedef ::xml_schema::uri paymentTypeScheme_type;
    typedef ::xsd::cxx::tree::optional< paymentTypeScheme_type > paymentTypeScheme_optional;
    typedef ::xsd::cxx::tree::traits< paymentTypeScheme_type, char > paymentTypeScheme_traits;

    const paymentTypeScheme_optional&
    paymentTypeScheme () const;

    paymentTypeScheme_optional&
    paymentTypeScheme ();

    void
    paymentTypeScheme (const paymentTypeScheme_type& x);

    void
    paymentTypeScheme (const paymentTypeScheme_optional& x);

    void
    paymentTypeScheme (::std::auto_ptr< paymentTypeScheme_type > p);

    // Constructors.
    //
    PaymentType ();

    PaymentType (const char*);

    PaymentType (const ::std::string&);

    PaymentType (const ::xml_schema::normalized_string&);

    PaymentType (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    PaymentType (const PaymentType& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual PaymentType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PaymentType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    paymentTypeScheme_optional paymentTypeScheme_;
  };

  class PeriodicDates: public ::xml_schema::type
  {
    public:
    // calculationStartDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate calculationStartDate_type;
    typedef ::xsd::cxx::tree::traits< calculationStartDate_type, char > calculationStartDate_traits;

    const calculationStartDate_type&
    calculationStartDate () const;

    calculationStartDate_type&
    calculationStartDate ();

    void
    calculationStartDate (const calculationStartDate_type& x);

    void
    calculationStartDate (::std::auto_ptr< calculationStartDate_type > p);

    // calculationEndDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate calculationEndDate_type;
    typedef ::xsd::cxx::tree::optional< calculationEndDate_type > calculationEndDate_optional;
    typedef ::xsd::cxx::tree::traits< calculationEndDate_type, char > calculationEndDate_traits;

    const calculationEndDate_optional&
    calculationEndDate () const;

    calculationEndDate_optional&
    calculationEndDate ();

    void
    calculationEndDate (const calculationEndDate_type& x);

    void
    calculationEndDate (const calculationEndDate_optional& x);

    void
    calculationEndDate (::std::auto_ptr< calculationEndDate_type > p);

    // calculationPeriodFrequency
    // 
    typedef ::FpML_4_2::CalculationPeriodFrequency calculationPeriodFrequency_type;
    typedef ::xsd::cxx::tree::traits< calculationPeriodFrequency_type, char > calculationPeriodFrequency_traits;

    const calculationPeriodFrequency_type&
    calculationPeriodFrequency () const;

    calculationPeriodFrequency_type&
    calculationPeriodFrequency ();

    void
    calculationPeriodFrequency (const calculationPeriodFrequency_type& x);

    void
    calculationPeriodFrequency (::std::auto_ptr< calculationPeriodFrequency_type > p);

    // calculationPeriodDatesAdjustments
    // 
    typedef ::FpML_4_2::BusinessDayAdjustments calculationPeriodDatesAdjustments_type;
    typedef ::xsd::cxx::tree::traits< calculationPeriodDatesAdjustments_type, char > calculationPeriodDatesAdjustments_traits;

    const calculationPeriodDatesAdjustments_type&
    calculationPeriodDatesAdjustments () const;

    calculationPeriodDatesAdjustments_type&
    calculationPeriodDatesAdjustments ();

    void
    calculationPeriodDatesAdjustments (const calculationPeriodDatesAdjustments_type& x);

    void
    calculationPeriodDatesAdjustments (::std::auto_ptr< calculationPeriodDatesAdjustments_type > p);

    // Constructors.
    //
    PeriodicDates (const calculationStartDate_type&,
                   const calculationPeriodFrequency_type&,
                   const calculationPeriodDatesAdjustments_type&);

    PeriodicDates (::std::auto_ptr< calculationStartDate_type >&,
                   ::std::auto_ptr< calculationPeriodFrequency_type >&,
                   ::std::auto_ptr< calculationPeriodDatesAdjustments_type >&);

    PeriodicDates (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    PeriodicDates (const PeriodicDates& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual PeriodicDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PeriodicDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< calculationStartDate_type > calculationStartDate_;
    calculationEndDate_optional calculationEndDate_;
    ::xsd::cxx::tree::one< calculationPeriodFrequency_type > calculationPeriodFrequency_;
    ::xsd::cxx::tree::one< calculationPeriodDatesAdjustments_type > calculationPeriodDatesAdjustments_;
  };

  class PrincipalExchanges: public ::xml_schema::type
  {
    public:
    // initialExchange
    // 
    typedef ::xml_schema::boolean initialExchange_type;
    typedef ::xsd::cxx::tree::traits< initialExchange_type, char > initialExchange_traits;

    const initialExchange_type&
    initialExchange () const;

    initialExchange_type&
    initialExchange ();

    void
    initialExchange (const initialExchange_type& x);

    // finalExchange
    // 
    typedef ::xml_schema::boolean finalExchange_type;
    typedef ::xsd::cxx::tree::traits< finalExchange_type, char > finalExchange_traits;

    const finalExchange_type&
    finalExchange () const;

    finalExchange_type&
    finalExchange ();

    void
    finalExchange (const finalExchange_type& x);

    // intermediateExchange
    // 
    typedef ::xml_schema::boolean intermediateExchange_type;
    typedef ::xsd::cxx::tree::traits< intermediateExchange_type, char > intermediateExchange_traits;

    const intermediateExchange_type&
    intermediateExchange () const;

    intermediateExchange_type&
    intermediateExchange ();

    void
    intermediateExchange (const intermediateExchange_type& x);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    PrincipalExchanges (const initialExchange_type&,
                        const finalExchange_type&,
                        const intermediateExchange_type&);

    PrincipalExchanges (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    PrincipalExchanges (const PrincipalExchanges& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual PrincipalExchanges*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~PrincipalExchanges ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< initialExchange_type > initialExchange_;
    ::xsd::cxx::tree::one< finalExchange_type > finalExchange_;
    ::xsd::cxx::tree::one< intermediateExchange_type > intermediateExchange_;
    id_optional id_;
  };

  class Product: public ::xml_schema::type
  {
    public:
    // productType
    // 
    typedef ::FpML_4_2::ProductType productType_type;
    typedef ::xsd::cxx::tree::sequence< productType_type > productType_sequence;
    typedef productType_sequence::iterator productType_iterator;
    typedef productType_sequence::const_iterator productType_const_iterator;
    typedef ::xsd::cxx::tree::traits< productType_type, char > productType_traits;

    const productType_sequence&
    productType () const;

    productType_sequence&
    productType ();

    void
    productType (const productType_sequence& s);

    // productId
    // 
    typedef ::FpML_4_2::ProductId productId_type;
    typedef ::xsd::cxx::tree::sequence< productId_type > productId_sequence;
    typedef productId_sequence::iterator productId_iterator;
    typedef productId_sequence::const_iterator productId_const_iterator;
    typedef ::xsd::cxx::tree::traits< productId_type, char > productId_traits;

    const productId_sequence&
    productId () const;

    productId_sequence&
    productId ();

    void
    productId (const productId_sequence& s);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Product ();

    Product (const ::xercesc::DOMElement& e,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    Product (const Product& x,
             ::xml_schema::flags f = 0,
             ::xml_schema::container* c = 0);

    virtual Product*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Product ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    productType_sequence productType_;
    productId_sequence productId_;
    id_optional id_;
  };

  class ProductId: public ::xml_schema::normalized_string
  {
    public:
    // productIdScheme
    // 
    typedef ::xml_schema::uri productIdScheme_type;
    typedef ::xsd::cxx::tree::optional< productIdScheme_type > productIdScheme_optional;
    typedef ::xsd::cxx::tree::traits< productIdScheme_type, char > productIdScheme_traits;

    const productIdScheme_optional&
    productIdScheme () const;

    productIdScheme_optional&
    productIdScheme ();

    void
    productIdScheme (const productIdScheme_type& x);

    void
    productIdScheme (const productIdScheme_optional& x);

    void
    productIdScheme (::std::auto_ptr< productIdScheme_type > p);

    // Constructors.
    //
    ProductId ();

    ProductId (const char*);

    ProductId (const ::std::string&);

    ProductId (const ::xml_schema::normalized_string&);

    ProductId (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    ProductId (const ProductId& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual ProductId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ProductId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    productIdScheme_optional productIdScheme_;
  };

  class ProductReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    ProductReference (const href_type&);

    ProductReference (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    ProductReference (const ProductReference& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual ProductReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ProductReference ();
  };

  class ProductType: public ::xml_schema::normalized_string
  {
    public:
    // productTypeScheme
    // 
    typedef ::xml_schema::uri productTypeScheme_type;
    typedef ::xsd::cxx::tree::traits< productTypeScheme_type, char > productTypeScheme_traits;

    const productTypeScheme_type&
    productTypeScheme () const;

    productTypeScheme_type&
    productTypeScheme ();

    void
    productTypeScheme (const productTypeScheme_type& x);

    void
    productTypeScheme (::std::auto_ptr< productTypeScheme_type > p);

    static const productTypeScheme_type&
    productTypeScheme_default_value ();

    // Constructors.
    //
    ProductType ();

    ProductType (const char*);

    ProductType (const ::std::string&);

    ProductType (const ::xml_schema::normalized_string&);

    ProductType (const ::xercesc::DOMElement& e,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    ProductType (const ProductType& x,
                 ::xml_schema::flags f = 0,
                 ::xml_schema::container* c = 0);

    virtual ProductType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ProductType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< productTypeScheme_type > productTypeScheme_;
    static const productTypeScheme_type productTypeScheme_default_value_;
  };

  class QuotedCurrencyPair: public ::xml_schema::type
  {
    public:
    // currency1
    // 
    typedef ::FpML_4_2::Currency currency1_type;
    typedef ::xsd::cxx::tree::traits< currency1_type, char > currency1_traits;

    const currency1_type&
    currency1 () const;

    currency1_type&
    currency1 ();

    void
    currency1 (const currency1_type& x);

    void
    currency1 (::std::auto_ptr< currency1_type > p);

    // currency2
    // 
    typedef ::FpML_4_2::Currency currency2_type;
    typedef ::xsd::cxx::tree::traits< currency2_type, char > currency2_traits;

    const currency2_type&
    currency2 () const;

    currency2_type&
    currency2 ();

    void
    currency2 (const currency2_type& x);

    void
    currency2 (::std::auto_ptr< currency2_type > p);

    // quoteBasis
    // 
    typedef ::FpML_4_2::QuoteBasisEnum quoteBasis_type;
    typedef ::xsd::cxx::tree::traits< quoteBasis_type, char > quoteBasis_traits;

    const quoteBasis_type&
    quoteBasis () const;

    quoteBasis_type&
    quoteBasis ();

    void
    quoteBasis (const quoteBasis_type& x);

    void
    quoteBasis (::std::auto_ptr< quoteBasis_type > p);

    // Constructors.
    //
    QuotedCurrencyPair (const currency1_type&,
                        const currency2_type&,
                        const quoteBasis_type&);

    QuotedCurrencyPair (::std::auto_ptr< currency1_type >&,
                        ::std::auto_ptr< currency2_type >&,
                        const quoteBasis_type&);

    QuotedCurrencyPair (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    QuotedCurrencyPair (const QuotedCurrencyPair& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual QuotedCurrencyPair*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~QuotedCurrencyPair ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< currency1_type > currency1_;
    ::xsd::cxx::tree::one< currency2_type > currency2_;
    ::xsd::cxx::tree::one< quoteBasis_type > quoteBasis_;
  };

  class RateReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    RateReference (const href_type&);

    RateReference (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    RateReference (const RateReference& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual RateReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RateReference ();
  };

  class RateObservation: public ::xml_schema::type
  {
    public:
    // resetDate
    // 
    typedef ::xml_schema::date resetDate_type;
    typedef ::xsd::cxx::tree::optional< resetDate_type > resetDate_optional;
    typedef ::xsd::cxx::tree::traits< resetDate_type, char > resetDate_traits;

    const resetDate_optional&
    resetDate () const;

    resetDate_optional&
    resetDate ();

    void
    resetDate (const resetDate_type& x);

    void
    resetDate (const resetDate_optional& x);

    void
    resetDate (::std::auto_ptr< resetDate_type > p);

    // adjustedFixingDate
    // 
    typedef ::xml_schema::date adjustedFixingDate_type;
    typedef ::xsd::cxx::tree::optional< adjustedFixingDate_type > adjustedFixingDate_optional;
    typedef ::xsd::cxx::tree::traits< adjustedFixingDate_type, char > adjustedFixingDate_traits;

    const adjustedFixingDate_optional&
    adjustedFixingDate () const;

    adjustedFixingDate_optional&
    adjustedFixingDate ();

    void
    adjustedFixingDate (const adjustedFixingDate_type& x);

    void
    adjustedFixingDate (const adjustedFixingDate_optional& x);

    void
    adjustedFixingDate (::std::auto_ptr< adjustedFixingDate_type > p);

    // observedRate
    // 
    typedef ::xml_schema::decimal observedRate_type;
    typedef ::xsd::cxx::tree::optional< observedRate_type > observedRate_optional;
    typedef ::xsd::cxx::tree::traits< observedRate_type, char, ::xsd::cxx::tree::schema_type::decimal > observedRate_traits;

    const observedRate_optional&
    observedRate () const;

    observedRate_optional&
    observedRate ();

    void
    observedRate (const observedRate_type& x);

    void
    observedRate (const observedRate_optional& x);

    // treatedRate
    // 
    typedef ::xml_schema::decimal treatedRate_type;
    typedef ::xsd::cxx::tree::optional< treatedRate_type > treatedRate_optional;
    typedef ::xsd::cxx::tree::traits< treatedRate_type, char, ::xsd::cxx::tree::schema_type::decimal > treatedRate_traits;

    const treatedRate_optional&
    treatedRate () const;

    treatedRate_optional&
    treatedRate ();

    void
    treatedRate (const treatedRate_type& x);

    void
    treatedRate (const treatedRate_optional& x);

    // observationWeight
    // 
    typedef ::xml_schema::positive_integer observationWeight_type;
    typedef ::xsd::cxx::tree::traits< observationWeight_type, char > observationWeight_traits;

    const observationWeight_type&
    observationWeight () const;

    observationWeight_type&
    observationWeight ();

    void
    observationWeight (const observationWeight_type& x);

    // rateReference
    // 
    typedef ::FpML_4_2::RateReference rateReference_type;
    typedef ::xsd::cxx::tree::optional< rateReference_type > rateReference_optional;
    typedef ::xsd::cxx::tree::traits< rateReference_type, char > rateReference_traits;

    const rateReference_optional&
    rateReference () const;

    rateReference_optional&
    rateReference ();

    void
    rateReference (const rateReference_type& x);

    void
    rateReference (const rateReference_optional& x);

    void
    rateReference (::std::auto_ptr< rateReference_type > p);

    // forecastRate
    // 
    typedef ::xml_schema::decimal forecastRate_type;
    typedef ::xsd::cxx::tree::optional< forecastRate_type > forecastRate_optional;
    typedef ::xsd::cxx::tree::traits< forecastRate_type, char, ::xsd::cxx::tree::schema_type::decimal > forecastRate_traits;

    const forecastRate_optional&
    forecastRate () const;

    forecastRate_optional&
    forecastRate ();

    void
    forecastRate (const forecastRate_type& x);

    void
    forecastRate (const forecastRate_optional& x);

    // treatedForecastRate
    // 
    typedef ::xml_schema::decimal treatedForecastRate_type;
    typedef ::xsd::cxx::tree::optional< treatedForecastRate_type > treatedForecastRate_optional;
    typedef ::xsd::cxx::tree::traits< treatedForecastRate_type, char, ::xsd::cxx::tree::schema_type::decimal > treatedForecastRate_traits;

    const treatedForecastRate_optional&
    treatedForecastRate () const;

    treatedForecastRate_optional&
    treatedForecastRate ();

    void
    treatedForecastRate (const treatedForecastRate_type& x);

    void
    treatedForecastRate (const treatedForecastRate_optional& x);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    RateObservation (const observationWeight_type&);

    RateObservation (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    RateObservation (const RateObservation& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual RateObservation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RateObservation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    resetDate_optional resetDate_;
    adjustedFixingDate_optional adjustedFixingDate_;
    observedRate_optional observedRate_;
    treatedRate_optional treatedRate_;
    ::xsd::cxx::tree::one< observationWeight_type > observationWeight_;
    rateReference_optional rateReference_;
    forecastRate_optional forecastRate_;
    treatedForecastRate_optional treatedForecastRate_;
    id_optional id_;
  };

  class RateSourcePage: public ::xml_schema::normalized_string
  {
    public:
    // rateSourcePageScheme
    // 
    typedef ::xml_schema::uri rateSourcePageScheme_type;
    typedef ::xsd::cxx::tree::optional< rateSourcePageScheme_type > rateSourcePageScheme_optional;
    typedef ::xsd::cxx::tree::traits< rateSourcePageScheme_type, char > rateSourcePageScheme_traits;

    const rateSourcePageScheme_optional&
    rateSourcePageScheme () const;

    rateSourcePageScheme_optional&
    rateSourcePageScheme ();

    void
    rateSourcePageScheme (const rateSourcePageScheme_type& x);

    void
    rateSourcePageScheme (const rateSourcePageScheme_optional& x);

    void
    rateSourcePageScheme (::std::auto_ptr< rateSourcePageScheme_type > p);

    // Constructors.
    //
    RateSourcePage ();

    RateSourcePage (const char*);

    RateSourcePage (const ::std::string&);

    RateSourcePage (const ::xml_schema::normalized_string&);

    RateSourcePage (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    RateSourcePage (const RateSourcePage& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual RateSourcePage*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RateSourcePage ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    rateSourcePageScheme_optional rateSourcePageScheme_;
  };

  class ReferenceAmount: public ::xml_schema::normalized_string
  {
    public:
    // referenceAmountScheme
    // 
    typedef ::xml_schema::uri referenceAmountScheme_type;
    typedef ::xsd::cxx::tree::optional< referenceAmountScheme_type > referenceAmountScheme_optional;
    typedef ::xsd::cxx::tree::traits< referenceAmountScheme_type, char > referenceAmountScheme_traits;

    const referenceAmountScheme_optional&
    referenceAmountScheme () const;

    referenceAmountScheme_optional&
    referenceAmountScheme ();

    void
    referenceAmountScheme (const referenceAmountScheme_type& x);

    void
    referenceAmountScheme (const referenceAmountScheme_optional& x);

    void
    referenceAmountScheme (::std::auto_ptr< referenceAmountScheme_type > p);

    // Constructors.
    //
    ReferenceAmount ();

    ReferenceAmount (const char*);

    ReferenceAmount (const ::std::string&);

    ReferenceAmount (const ::xml_schema::normalized_string&);

    ReferenceAmount (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    ReferenceAmount (const ReferenceAmount& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual ReferenceAmount*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReferenceAmount ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    referenceAmountScheme_optional referenceAmountScheme_;
  };

  class ReferenceBank: public ::xml_schema::type
  {
    public:
    // referenceBankId
    // 
    typedef ::FpML_4_2::ReferenceBankId referenceBankId_type;
    typedef ::xsd::cxx::tree::traits< referenceBankId_type, char > referenceBankId_traits;

    const referenceBankId_type&
    referenceBankId () const;

    referenceBankId_type&
    referenceBankId ();

    void
    referenceBankId (const referenceBankId_type& x);

    void
    referenceBankId (::std::auto_ptr< referenceBankId_type > p);

    // referenceBankName
    // 
    typedef ::xml_schema::string referenceBankName_type;
    typedef ::xsd::cxx::tree::optional< referenceBankName_type > referenceBankName_optional;
    typedef ::xsd::cxx::tree::traits< referenceBankName_type, char > referenceBankName_traits;

    const referenceBankName_optional&
    referenceBankName () const;

    referenceBankName_optional&
    referenceBankName ();

    void
    referenceBankName (const referenceBankName_type& x);

    void
    referenceBankName (const referenceBankName_optional& x);

    void
    referenceBankName (::std::auto_ptr< referenceBankName_type > p);

    // Constructors.
    //
    ReferenceBank (const referenceBankId_type&);

    ReferenceBank (::std::auto_ptr< referenceBankId_type >&);

    ReferenceBank (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    ReferenceBank (const ReferenceBank& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual ReferenceBank*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReferenceBank ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< referenceBankId_type > referenceBankId_;
    referenceBankName_optional referenceBankName_;
  };

  class ReferenceBankId: public ::xml_schema::normalized_string
  {
    public:
    // referenceBankIdScheme
    // 
    typedef ::xml_schema::uri referenceBankIdScheme_type;
    typedef ::xsd::cxx::tree::optional< referenceBankIdScheme_type > referenceBankIdScheme_optional;
    typedef ::xsd::cxx::tree::traits< referenceBankIdScheme_type, char > referenceBankIdScheme_traits;

    const referenceBankIdScheme_optional&
    referenceBankIdScheme () const;

    referenceBankIdScheme_optional&
    referenceBankIdScheme ();

    void
    referenceBankIdScheme (const referenceBankIdScheme_type& x);

    void
    referenceBankIdScheme (const referenceBankIdScheme_optional& x);

    void
    referenceBankIdScheme (::std::auto_ptr< referenceBankIdScheme_type > p);

    // Constructors.
    //
    ReferenceBankId ();

    ReferenceBankId (const char*);

    ReferenceBankId (const ::std::string&);

    ReferenceBankId (const ::xml_schema::normalized_string&);

    ReferenceBankId (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    ReferenceBankId (const ReferenceBankId& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual ReferenceBankId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ReferenceBankId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    referenceBankIdScheme_optional referenceBankIdScheme_;
  };

  class RelativeDates: public ::FpML_4_2::RelativeDateOffset
  {
    public:
    // periodSkip
    // 
    typedef ::xml_schema::positive_integer periodSkip_type;
    typedef ::xsd::cxx::tree::optional< periodSkip_type > periodSkip_optional;
    typedef ::xsd::cxx::tree::traits< periodSkip_type, char > periodSkip_traits;

    const periodSkip_optional&
    periodSkip () const;

    periodSkip_optional&
    periodSkip ();

    void
    periodSkip (const periodSkip_type& x);

    void
    periodSkip (const periodSkip_optional& x);

    // scheduleBounds
    // 
    typedef ::FpML_4_2::DateRange scheduleBounds_type;
    typedef ::xsd::cxx::tree::optional< scheduleBounds_type > scheduleBounds_optional;
    typedef ::xsd::cxx::tree::traits< scheduleBounds_type, char > scheduleBounds_traits;

    const scheduleBounds_optional&
    scheduleBounds () const;

    scheduleBounds_optional&
    scheduleBounds ();

    void
    scheduleBounds (const scheduleBounds_type& x);

    void
    scheduleBounds (const scheduleBounds_optional& x);

    void
    scheduleBounds (::std::auto_ptr< scheduleBounds_type > p);

    // Constructors.
    //
    RelativeDates (const periodMultiplier_type&,
                   const period_type&,
                   const businessDayConvention_type&,
                   const dateRelativeTo_type&);

    RelativeDates (const periodMultiplier_type&,
                   const period_type&,
                   const businessDayConvention_type&,
                   ::std::auto_ptr< dateRelativeTo_type >&);

    RelativeDates (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    RelativeDates (const RelativeDates& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual RelativeDates*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RelativeDates ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    periodSkip_optional periodSkip_;
    scheduleBounds_optional scheduleBounds_;
  };

  class RelativeDateSequence: public ::xml_schema::type
  {
    public:
    // dateRelativeTo
    // 
    typedef ::FpML_4_2::DateReference dateRelativeTo_type;
    typedef ::xsd::cxx::tree::traits< dateRelativeTo_type, char > dateRelativeTo_traits;

    const dateRelativeTo_type&
    dateRelativeTo () const;

    dateRelativeTo_type&
    dateRelativeTo ();

    void
    dateRelativeTo (const dateRelativeTo_type& x);

    void
    dateRelativeTo (::std::auto_ptr< dateRelativeTo_type > p);

    // dateOffset
    // 
    typedef ::FpML_4_2::DateOffset dateOffset_type;
    typedef ::xsd::cxx::tree::sequence< dateOffset_type > dateOffset_sequence;
    typedef dateOffset_sequence::iterator dateOffset_iterator;
    typedef dateOffset_sequence::const_iterator dateOffset_const_iterator;
    typedef ::xsd::cxx::tree::traits< dateOffset_type, char > dateOffset_traits;

    const dateOffset_sequence&
    dateOffset () const;

    dateOffset_sequence&
    dateOffset ();

    void
    dateOffset (const dateOffset_sequence& s);

    // businessCentersReference
    // 
    typedef ::FpML_4_2::BusinessCentersReference businessCentersReference_type;
    typedef ::xsd::cxx::tree::optional< businessCentersReference_type > businessCentersReference_optional;
    typedef ::xsd::cxx::tree::traits< businessCentersReference_type, char > businessCentersReference_traits;

    const businessCentersReference_optional&
    businessCentersReference () const;

    businessCentersReference_optional&
    businessCentersReference ();

    void
    businessCentersReference (const businessCentersReference_type& x);

    void
    businessCentersReference (const businessCentersReference_optional& x);

    void
    businessCentersReference (::std::auto_ptr< businessCentersReference_type > p);

    // businessCenters
    // 
    typedef ::FpML_4_2::BusinessCenters businessCenters_type;
    typedef ::xsd::cxx::tree::optional< businessCenters_type > businessCenters_optional;
    typedef ::xsd::cxx::tree::traits< businessCenters_type, char > businessCenters_traits;

    const businessCenters_optional&
    businessCenters () const;

    businessCenters_optional&
    businessCenters ();

    void
    businessCenters (const businessCenters_type& x);

    void
    businessCenters (const businessCenters_optional& x);

    void
    businessCenters (::std::auto_ptr< businessCenters_type > p);

    // Constructors.
    //
    RelativeDateSequence (const dateRelativeTo_type&);

    RelativeDateSequence (::std::auto_ptr< dateRelativeTo_type >&);

    RelativeDateSequence (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    RelativeDateSequence (const RelativeDateSequence& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual RelativeDateSequence*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RelativeDateSequence ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< dateRelativeTo_type > dateRelativeTo_;
    dateOffset_sequence dateOffset_;
    businessCentersReference_optional businessCentersReference_;
    businessCenters_optional businessCenters_;
  };

  class RequiredIdentifierDate: public ::xml_schema::date
  {
    public:
    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_type&
    id () const;

    id_type&
    id ();

    void
    id (const id_type& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    RequiredIdentifierDate (const ::xml_schema::date&,
                            const id_type&);

    RequiredIdentifierDate (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    RequiredIdentifierDate (const RequiredIdentifierDate& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual RequiredIdentifierDate*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RequiredIdentifierDate ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< id_type > id_;
  };

  class ResetFrequency: public ::FpML_4_2::Interval
  {
    public:
    // weeklyRollConvention
    // 
    typedef ::FpML_4_2::WeeklyRollConventionEnum weeklyRollConvention_type;
    typedef ::xsd::cxx::tree::optional< weeklyRollConvention_type > weeklyRollConvention_optional;
    typedef ::xsd::cxx::tree::traits< weeklyRollConvention_type, char > weeklyRollConvention_traits;

    const weeklyRollConvention_optional&
    weeklyRollConvention () const;

    weeklyRollConvention_optional&
    weeklyRollConvention ();

    void
    weeklyRollConvention (const weeklyRollConvention_type& x);

    void
    weeklyRollConvention (const weeklyRollConvention_optional& x);

    void
    weeklyRollConvention (::std::auto_ptr< weeklyRollConvention_type > p);

    // Constructors.
    //
    ResetFrequency (const periodMultiplier_type&,
                    const period_type&);

    ResetFrequency (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    ResetFrequency (const ResetFrequency& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual ResetFrequency*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ResetFrequency ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    weeklyRollConvention_optional weeklyRollConvention_;
  };

  class Rounding: public ::xml_schema::type
  {
    public:
    // roundingDirection
    // 
    typedef ::FpML_4_2::RoundingDirectionEnum roundingDirection_type;
    typedef ::xsd::cxx::tree::traits< roundingDirection_type, char > roundingDirection_traits;

    const roundingDirection_type&
    roundingDirection () const;

    roundingDirection_type&
    roundingDirection ();

    void
    roundingDirection (const roundingDirection_type& x);

    void
    roundingDirection (::std::auto_ptr< roundingDirection_type > p);

    // precision
    // 
    typedef ::xml_schema::non_negative_integer precision_type;
    typedef ::xsd::cxx::tree::traits< precision_type, char > precision_traits;

    const precision_type&
    precision () const;

    precision_type&
    precision ();

    void
    precision (const precision_type& x);

    // Constructors.
    //
    Rounding (const roundingDirection_type&,
              const precision_type&);

    Rounding (const ::xercesc::DOMElement& e,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    Rounding (const Rounding& x,
              ::xml_schema::flags f = 0,
              ::xml_schema::container* c = 0);

    virtual Rounding*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Rounding ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< roundingDirection_type > roundingDirection_;
    ::xsd::cxx::tree::one< precision_type > precision_;
  };

  class RoutingExplicitDetails: public ::xml_schema::type
  {
    public:
    // routingName
    // 
    typedef ::xml_schema::string routingName_type;
    typedef ::xsd::cxx::tree::traits< routingName_type, char > routingName_traits;

    const routingName_type&
    routingName () const;

    routingName_type&
    routingName ();

    void
    routingName (const routingName_type& x);

    void
    routingName (::std::auto_ptr< routingName_type > p);

    // routingAddress
    // 
    typedef ::FpML_4_2::Address routingAddress_type;
    typedef ::xsd::cxx::tree::optional< routingAddress_type > routingAddress_optional;
    typedef ::xsd::cxx::tree::traits< routingAddress_type, char > routingAddress_traits;

    const routingAddress_optional&
    routingAddress () const;

    routingAddress_optional&
    routingAddress ();

    void
    routingAddress (const routingAddress_type& x);

    void
    routingAddress (const routingAddress_optional& x);

    void
    routingAddress (::std::auto_ptr< routingAddress_type > p);

    // routingAccountNumber
    // 
    typedef ::xml_schema::string routingAccountNumber_type;
    typedef ::xsd::cxx::tree::optional< routingAccountNumber_type > routingAccountNumber_optional;
    typedef ::xsd::cxx::tree::traits< routingAccountNumber_type, char > routingAccountNumber_traits;

    const routingAccountNumber_optional&
    routingAccountNumber () const;

    routingAccountNumber_optional&
    routingAccountNumber ();

    void
    routingAccountNumber (const routingAccountNumber_type& x);

    void
    routingAccountNumber (const routingAccountNumber_optional& x);

    void
    routingAccountNumber (::std::auto_ptr< routingAccountNumber_type > p);

    // routingReferenceText
    // 
    typedef ::xml_schema::string routingReferenceText_type;
    typedef ::xsd::cxx::tree::sequence< routingReferenceText_type > routingReferenceText_sequence;
    typedef routingReferenceText_sequence::iterator routingReferenceText_iterator;
    typedef routingReferenceText_sequence::const_iterator routingReferenceText_const_iterator;
    typedef ::xsd::cxx::tree::traits< routingReferenceText_type, char > routingReferenceText_traits;

    const routingReferenceText_sequence&
    routingReferenceText () const;

    routingReferenceText_sequence&
    routingReferenceText ();

    void
    routingReferenceText (const routingReferenceText_sequence& s);

    // Constructors.
    //
    RoutingExplicitDetails (const routingName_type&);

    RoutingExplicitDetails (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    RoutingExplicitDetails (const RoutingExplicitDetails& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual RoutingExplicitDetails*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoutingExplicitDetails ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< routingName_type > routingName_;
    routingAddress_optional routingAddress_;
    routingAccountNumber_optional routingAccountNumber_;
    routingReferenceText_sequence routingReferenceText_;
  };

  class RoutingId: public ::xml_schema::normalized_string
  {
    public:
    // routingIdCodeScheme
    // 
    typedef ::xml_schema::uri routingIdCodeScheme_type;
    typedef ::xsd::cxx::tree::traits< routingIdCodeScheme_type, char > routingIdCodeScheme_traits;

    const routingIdCodeScheme_type&
    routingIdCodeScheme () const;

    routingIdCodeScheme_type&
    routingIdCodeScheme ();

    void
    routingIdCodeScheme (const routingIdCodeScheme_type& x);

    void
    routingIdCodeScheme (::std::auto_ptr< routingIdCodeScheme_type > p);

    static const routingIdCodeScheme_type&
    routingIdCodeScheme_default_value ();

    // Constructors.
    //
    RoutingId ();

    RoutingId (const char*);

    RoutingId (const ::std::string&);

    RoutingId (const ::xml_schema::normalized_string&);

    RoutingId (const ::xercesc::DOMElement& e,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    RoutingId (const RoutingId& x,
               ::xml_schema::flags f = 0,
               ::xml_schema::container* c = 0);

    virtual RoutingId*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoutingId ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< routingIdCodeScheme_type > routingIdCodeScheme_;
    static const routingIdCodeScheme_type routingIdCodeScheme_default_value_;
  };

  class RoutingIds: public ::xml_schema::type
  {
    public:
    // routingId
    // 
    typedef ::FpML_4_2::RoutingId routingId_type;
    typedef ::xsd::cxx::tree::sequence< routingId_type > routingId_sequence;
    typedef routingId_sequence::iterator routingId_iterator;
    typedef routingId_sequence::const_iterator routingId_const_iterator;
    typedef ::xsd::cxx::tree::traits< routingId_type, char > routingId_traits;

    const routingId_sequence&
    routingId () const;

    routingId_sequence&
    routingId ();

    void
    routingId (const routingId_sequence& s);

    // Constructors.
    //
    RoutingIds ();

    RoutingIds (const ::xercesc::DOMElement& e,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    RoutingIds (const RoutingIds& x,
                ::xml_schema::flags f = 0,
                ::xml_schema::container* c = 0);

    virtual RoutingIds*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoutingIds ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    routingId_sequence routingId_;
  };

  class RoutingIdsAndExplicitDetails: public ::xml_schema::type
  {
    public:
    // routingIds
    // 
    typedef ::FpML_4_2::RoutingIds routingIds_type;
    typedef ::xsd::cxx::tree::sequence< routingIds_type > routingIds_sequence;
    typedef routingIds_sequence::iterator routingIds_iterator;
    typedef routingIds_sequence::const_iterator routingIds_const_iterator;
    typedef ::xsd::cxx::tree::traits< routingIds_type, char > routingIds_traits;

    const routingIds_sequence&
    routingIds () const;

    routingIds_sequence&
    routingIds ();

    void
    routingIds (const routingIds_sequence& s);

    // routingName
    // 
    typedef ::xml_schema::string routingName_type;
    typedef ::xsd::cxx::tree::traits< routingName_type, char > routingName_traits;

    const routingName_type&
    routingName () const;

    routingName_type&
    routingName ();

    void
    routingName (const routingName_type& x);

    void
    routingName (::std::auto_ptr< routingName_type > p);

    // routingAddress
    // 
    typedef ::FpML_4_2::Address routingAddress_type;
    typedef ::xsd::cxx::tree::optional< routingAddress_type > routingAddress_optional;
    typedef ::xsd::cxx::tree::traits< routingAddress_type, char > routingAddress_traits;

    const routingAddress_optional&
    routingAddress () const;

    routingAddress_optional&
    routingAddress ();

    void
    routingAddress (const routingAddress_type& x);

    void
    routingAddress (const routingAddress_optional& x);

    void
    routingAddress (::std::auto_ptr< routingAddress_type > p);

    // routingAccountNumber
    // 
    typedef ::xml_schema::string routingAccountNumber_type;
    typedef ::xsd::cxx::tree::optional< routingAccountNumber_type > routingAccountNumber_optional;
    typedef ::xsd::cxx::tree::traits< routingAccountNumber_type, char > routingAccountNumber_traits;

    const routingAccountNumber_optional&
    routingAccountNumber () const;

    routingAccountNumber_optional&
    routingAccountNumber ();

    void
    routingAccountNumber (const routingAccountNumber_type& x);

    void
    routingAccountNumber (const routingAccountNumber_optional& x);

    void
    routingAccountNumber (::std::auto_ptr< routingAccountNumber_type > p);

    // routingReferenceText
    // 
    typedef ::xml_schema::string routingReferenceText_type;
    typedef ::xsd::cxx::tree::sequence< routingReferenceText_type > routingReferenceText_sequence;
    typedef routingReferenceText_sequence::iterator routingReferenceText_iterator;
    typedef routingReferenceText_sequence::const_iterator routingReferenceText_const_iterator;
    typedef ::xsd::cxx::tree::traits< routingReferenceText_type, char > routingReferenceText_traits;

    const routingReferenceText_sequence&
    routingReferenceText () const;

    routingReferenceText_sequence&
    routingReferenceText ();

    void
    routingReferenceText (const routingReferenceText_sequence& s);

    // Constructors.
    //
    RoutingIdsAndExplicitDetails (const routingName_type&);

    RoutingIdsAndExplicitDetails (const ::xercesc::DOMElement& e,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    RoutingIdsAndExplicitDetails (const RoutingIdsAndExplicitDetails& x,
                                  ::xml_schema::flags f = 0,
                                  ::xml_schema::container* c = 0);

    virtual RoutingIdsAndExplicitDetails*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~RoutingIdsAndExplicitDetails ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    routingIds_sequence routingIds_;
    ::xsd::cxx::tree::one< routingName_type > routingName_;
    routingAddress_optional routingAddress_;
    routingAccountNumber_optional routingAccountNumber_;
    routingReferenceText_sequence routingReferenceText_;
  };

  class ScheduleReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    ScheduleReference (const href_type&);

    ScheduleReference (const ::xercesc::DOMElement& e,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    ScheduleReference (const ScheduleReference& x,
                       ::xml_schema::flags f = 0,
                       ::xml_schema::container* c = 0);

    virtual ScheduleReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ScheduleReference ();
  };

  class SettlementInformation: public ::xml_schema::type
  {
    public:
    // standardSettlementStyle
    // 
    typedef ::FpML_4_2::StandardSettlementStyleEnum standardSettlementStyle_type;
    typedef ::xsd::cxx::tree::optional< standardSettlementStyle_type > standardSettlementStyle_optional;
    typedef ::xsd::cxx::tree::traits< standardSettlementStyle_type, char > standardSettlementStyle_traits;

    const standardSettlementStyle_optional&
    standardSettlementStyle () const;

    standardSettlementStyle_optional&
    standardSettlementStyle ();

    void
    standardSettlementStyle (const standardSettlementStyle_type& x);

    void
    standardSettlementStyle (const standardSettlementStyle_optional& x);

    void
    standardSettlementStyle (::std::auto_ptr< standardSettlementStyle_type > p);

    // settlementInstruction
    // 
    typedef ::FpML_4_2::SettlementInstruction settlementInstruction_type;
    typedef ::xsd::cxx::tree::optional< settlementInstruction_type > settlementInstruction_optional;
    typedef ::xsd::cxx::tree::traits< settlementInstruction_type, char > settlementInstruction_traits;

    const settlementInstruction_optional&
    settlementInstruction () const;

    settlementInstruction_optional&
    settlementInstruction ();

    void
    settlementInstruction (const settlementInstruction_type& x);

    void
    settlementInstruction (const settlementInstruction_optional& x);

    void
    settlementInstruction (::std::auto_ptr< settlementInstruction_type > p);

    // Constructors.
    //
    SettlementInformation ();

    SettlementInformation (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    SettlementInformation (const SettlementInformation& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual SettlementInformation*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SettlementInformation ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    standardSettlementStyle_optional standardSettlementStyle_;
    settlementInstruction_optional settlementInstruction_;
  };

  class SettlementInstruction: public ::xml_schema::type
  {
    public:
    // settlementMethod
    // 
    typedef ::FpML_4_2::SettlementMethod settlementMethod_type;
    typedef ::xsd::cxx::tree::optional< settlementMethod_type > settlementMethod_optional;
    typedef ::xsd::cxx::tree::traits< settlementMethod_type, char > settlementMethod_traits;

    const settlementMethod_optional&
    settlementMethod () const;

    settlementMethod_optional&
    settlementMethod ();

    void
    settlementMethod (const settlementMethod_type& x);

    void
    settlementMethod (const settlementMethod_optional& x);

    void
    settlementMethod (::std::auto_ptr< settlementMethod_type > p);

    // correspondentInformation
    // 
    typedef ::FpML_4_2::CorrespondentInformation correspondentInformation_type;
    typedef ::xsd::cxx::tree::optional< correspondentInformation_type > correspondentInformation_optional;
    typedef ::xsd::cxx::tree::traits< correspondentInformation_type, char > correspondentInformation_traits;

    const correspondentInformation_optional&
    correspondentInformation () const;

    correspondentInformation_optional&
    correspondentInformation ();

    void
    correspondentInformation (const correspondentInformation_type& x);

    void
    correspondentInformation (const correspondentInformation_optional& x);

    void
    correspondentInformation (::std::auto_ptr< correspondentInformation_type > p);

    // intermediaryInformation
    // 
    typedef ::FpML_4_2::IntermediaryInformation intermediaryInformation_type;
    typedef ::xsd::cxx::tree::sequence< intermediaryInformation_type > intermediaryInformation_sequence;
    typedef intermediaryInformation_sequence::iterator intermediaryInformation_iterator;
    typedef intermediaryInformation_sequence::const_iterator intermediaryInformation_const_iterator;
    typedef ::xsd::cxx::tree::traits< intermediaryInformation_type, char > intermediaryInformation_traits;

    const intermediaryInformation_sequence&
    intermediaryInformation () const;

    intermediaryInformation_sequence&
    intermediaryInformation ();

    void
    intermediaryInformation (const intermediaryInformation_sequence& s);

    // beneficiaryBank
    // 
    typedef ::FpML_4_2::Beneficiary beneficiaryBank_type;
    typedef ::xsd::cxx::tree::optional< beneficiaryBank_type > beneficiaryBank_optional;
    typedef ::xsd::cxx::tree::traits< beneficiaryBank_type, char > beneficiaryBank_traits;

    const beneficiaryBank_optional&
    beneficiaryBank () const;

    beneficiaryBank_optional&
    beneficiaryBank ();

    void
    beneficiaryBank (const beneficiaryBank_type& x);

    void
    beneficiaryBank (const beneficiaryBank_optional& x);

    void
    beneficiaryBank (::std::auto_ptr< beneficiaryBank_type > p);

    // beneficiary
    // 
    typedef ::FpML_4_2::Beneficiary beneficiary_type;
    typedef ::xsd::cxx::tree::traits< beneficiary_type, char > beneficiary_traits;

    const beneficiary_type&
    beneficiary () const;

    beneficiary_type&
    beneficiary ();

    void
    beneficiary (const beneficiary_type& x);

    void
    beneficiary (::std::auto_ptr< beneficiary_type > p);

    // depositoryPartyReference
    // 
    typedef ::FpML_4_2::PartyReference depositoryPartyReference_type;
    typedef ::xsd::cxx::tree::optional< depositoryPartyReference_type > depositoryPartyReference_optional;
    typedef ::xsd::cxx::tree::traits< depositoryPartyReference_type, char > depositoryPartyReference_traits;

    const depositoryPartyReference_optional&
    depositoryPartyReference () const;

    depositoryPartyReference_optional&
    depositoryPartyReference ();

    void
    depositoryPartyReference (const depositoryPartyReference_type& x);

    void
    depositoryPartyReference (const depositoryPartyReference_optional& x);

    void
    depositoryPartyReference (::std::auto_ptr< depositoryPartyReference_type > p);

    // splitSettlement
    // 
    typedef ::FpML_4_2::SplitSettlement splitSettlement_type;
    typedef ::xsd::cxx::tree::sequence< splitSettlement_type > splitSettlement_sequence;
    typedef splitSettlement_sequence::iterator splitSettlement_iterator;
    typedef splitSettlement_sequence::const_iterator splitSettlement_const_iterator;
    typedef ::xsd::cxx::tree::traits< splitSettlement_type, char > splitSettlement_traits;

    const splitSettlement_sequence&
    splitSettlement () const;

    splitSettlement_sequence&
    splitSettlement ();

    void
    splitSettlement (const splitSettlement_sequence& s);

    // Constructors.
    //
    SettlementInstruction (const beneficiary_type&);

    SettlementInstruction (::std::auto_ptr< beneficiary_type >&);

    SettlementInstruction (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    SettlementInstruction (const SettlementInstruction& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual SettlementInstruction*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SettlementInstruction ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    settlementMethod_optional settlementMethod_;
    correspondentInformation_optional correspondentInformation_;
    intermediaryInformation_sequence intermediaryInformation_;
    beneficiaryBank_optional beneficiaryBank_;
    ::xsd::cxx::tree::one< beneficiary_type > beneficiary_;
    depositoryPartyReference_optional depositoryPartyReference_;
    splitSettlement_sequence splitSettlement_;
  };

  class SettlementMethod: public ::xml_schema::normalized_string
  {
    public:
    // settlementMethodScheme
    // 
    typedef ::xml_schema::uri settlementMethodScheme_type;
    typedef ::xsd::cxx::tree::traits< settlementMethodScheme_type, char > settlementMethodScheme_traits;

    const settlementMethodScheme_type&
    settlementMethodScheme () const;

    settlementMethodScheme_type&
    settlementMethodScheme ();

    void
    settlementMethodScheme (const settlementMethodScheme_type& x);

    void
    settlementMethodScheme (::std::auto_ptr< settlementMethodScheme_type > p);

    static const settlementMethodScheme_type&
    settlementMethodScheme_default_value ();

    // Constructors.
    //
    SettlementMethod ();

    SettlementMethod (const char*);

    SettlementMethod (const ::std::string&);

    SettlementMethod (const ::xml_schema::normalized_string&);

    SettlementMethod (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    SettlementMethod (const SettlementMethod& x,
                      ::xml_schema::flags f = 0,
                      ::xml_schema::container* c = 0);

    virtual SettlementMethod*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SettlementMethod ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< settlementMethodScheme_type > settlementMethodScheme_;
    static const settlementMethodScheme_type settlementMethodScheme_default_value_;
  };

  class SettlementPriceSource: public ::xml_schema::normalized_string
  {
    public:
    // settlementPriceSourceScheme
    // 
    typedef ::xml_schema::uri settlementPriceSourceScheme_type;
    typedef ::xsd::cxx::tree::traits< settlementPriceSourceScheme_type, char > settlementPriceSourceScheme_traits;

    const settlementPriceSourceScheme_type&
    settlementPriceSourceScheme () const;

    settlementPriceSourceScheme_type&
    settlementPriceSourceScheme ();

    void
    settlementPriceSourceScheme (const settlementPriceSourceScheme_type& x);

    void
    settlementPriceSourceScheme (::std::auto_ptr< settlementPriceSourceScheme_type > p);

    static const settlementPriceSourceScheme_type&
    settlementPriceSourceScheme_default_value ();

    // Constructors.
    //
    SettlementPriceSource ();

    SettlementPriceSource (const char*);

    SettlementPriceSource (const ::std::string&);

    SettlementPriceSource (const ::xml_schema::normalized_string&);

    SettlementPriceSource (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    SettlementPriceSource (const SettlementPriceSource& x,
                           ::xml_schema::flags f = 0,
                           ::xml_schema::container* c = 0);

    virtual SettlementPriceSource*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SettlementPriceSource ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< settlementPriceSourceScheme_type > settlementPriceSourceScheme_;
    static const settlementPriceSourceScheme_type settlementPriceSourceScheme_default_value_;
  };

  class SettlementRateSource: public ::xml_schema::type
  {
    public:
    // informationSource
    // 
    typedef ::FpML_4_2::InformationSource informationSource_type;
    typedef ::xsd::cxx::tree::optional< informationSource_type > informationSource_optional;
    typedef ::xsd::cxx::tree::traits< informationSource_type, char > informationSource_traits;

    const informationSource_optional&
    informationSource () const;

    informationSource_optional&
    informationSource ();

    void
    informationSource (const informationSource_type& x);

    void
    informationSource (const informationSource_optional& x);

    void
    informationSource (::std::auto_ptr< informationSource_type > p);

    // cashSettlementReferenceBanks
    // 
    typedef ::FpML_4_2::CashSettlementReferenceBanks cashSettlementReferenceBanks_type;
    typedef ::xsd::cxx::tree::optional< cashSettlementReferenceBanks_type > cashSettlementReferenceBanks_optional;
    typedef ::xsd::cxx::tree::traits< cashSettlementReferenceBanks_type, char > cashSettlementReferenceBanks_traits;

    const cashSettlementReferenceBanks_optional&
    cashSettlementReferenceBanks () const;

    cashSettlementReferenceBanks_optional&
    cashSettlementReferenceBanks ();

    void
    cashSettlementReferenceBanks (const cashSettlementReferenceBanks_type& x);

    void
    cashSettlementReferenceBanks (const cashSettlementReferenceBanks_optional& x);

    void
    cashSettlementReferenceBanks (::std::auto_ptr< cashSettlementReferenceBanks_type > p);

    // Constructors.
    //
    SettlementRateSource ();

    SettlementRateSource (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    SettlementRateSource (const SettlementRateSource& x,
                          ::xml_schema::flags f = 0,
                          ::xml_schema::container* c = 0);

    virtual SettlementRateSource*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SettlementRateSource ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    informationSource_optional informationSource_;
    cashSettlementReferenceBanks_optional cashSettlementReferenceBanks_;
  };

  class SharedAmericanExercise: public ::FpML_4_2::Exercise
  {
    public:
    // commencementDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate commencementDate_type;
    typedef ::xsd::cxx::tree::traits< commencementDate_type, char > commencementDate_traits;

    const commencementDate_type&
    commencementDate () const;

    commencementDate_type&
    commencementDate ();

    void
    commencementDate (const commencementDate_type& x);

    void
    commencementDate (::std::auto_ptr< commencementDate_type > p);

    // expirationDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate expirationDate_type;
    typedef ::xsd::cxx::tree::traits< expirationDate_type, char > expirationDate_traits;

    const expirationDate_type&
    expirationDate () const;

    expirationDate_type&
    expirationDate ();

    void
    expirationDate (const expirationDate_type& x);

    void
    expirationDate (::std::auto_ptr< expirationDate_type > p);

    // latestExerciseTime
    // 
    typedef ::FpML_4_2::BusinessCenterTime latestExerciseTime_type;
    typedef ::xsd::cxx::tree::optional< latestExerciseTime_type > latestExerciseTime_optional;
    typedef ::xsd::cxx::tree::traits< latestExerciseTime_type, char > latestExerciseTime_traits;

    const latestExerciseTime_optional&
    latestExerciseTime () const;

    latestExerciseTime_optional&
    latestExerciseTime ();

    void
    latestExerciseTime (const latestExerciseTime_type& x);

    void
    latestExerciseTime (const latestExerciseTime_optional& x);

    void
    latestExerciseTime (::std::auto_ptr< latestExerciseTime_type > p);

    // Constructors.
    //
    SharedAmericanExercise (const commencementDate_type&,
                            const expirationDate_type&);

    SharedAmericanExercise (::std::auto_ptr< commencementDate_type >&,
                            ::std::auto_ptr< expirationDate_type >&);

    SharedAmericanExercise (const ::xercesc::DOMElement& e,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    SharedAmericanExercise (const SharedAmericanExercise& x,
                            ::xml_schema::flags f = 0,
                            ::xml_schema::container* c = 0);

    virtual SharedAmericanExercise*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SharedAmericanExercise ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< commencementDate_type > commencementDate_;
    ::xsd::cxx::tree::one< expirationDate_type > expirationDate_;
    latestExerciseTime_optional latestExerciseTime_;
  };

  class SplitSettlement: public ::xml_schema::type
  {
    public:
    // splitSettlementAmount
    // 
    typedef ::FpML_4_2::Money splitSettlementAmount_type;
    typedef ::xsd::cxx::tree::traits< splitSettlementAmount_type, char > splitSettlementAmount_traits;

    const splitSettlementAmount_type&
    splitSettlementAmount () const;

    splitSettlementAmount_type&
    splitSettlementAmount ();

    void
    splitSettlementAmount (const splitSettlementAmount_type& x);

    void
    splitSettlementAmount (::std::auto_ptr< splitSettlementAmount_type > p);

    // beneficiaryBank
    // 
    typedef ::FpML_4_2::Routing beneficiaryBank_type;
    typedef ::xsd::cxx::tree::optional< beneficiaryBank_type > beneficiaryBank_optional;
    typedef ::xsd::cxx::tree::traits< beneficiaryBank_type, char > beneficiaryBank_traits;

    const beneficiaryBank_optional&
    beneficiaryBank () const;

    beneficiaryBank_optional&
    beneficiaryBank ();

    void
    beneficiaryBank (const beneficiaryBank_type& x);

    void
    beneficiaryBank (const beneficiaryBank_optional& x);

    void
    beneficiaryBank (::std::auto_ptr< beneficiaryBank_type > p);

    // beneficiary
    // 
    typedef ::FpML_4_2::Routing beneficiary_type;
    typedef ::xsd::cxx::tree::traits< beneficiary_type, char > beneficiary_traits;

    const beneficiary_type&
    beneficiary () const;

    beneficiary_type&
    beneficiary ();

    void
    beneficiary (const beneficiary_type& x);

    void
    beneficiary (::std::auto_ptr< beneficiary_type > p);

    // Constructors.
    //
    SplitSettlement (const splitSettlementAmount_type&,
                     const beneficiary_type&);

    SplitSettlement (::std::auto_ptr< splitSettlementAmount_type >&,
                     ::std::auto_ptr< beneficiary_type >&);

    SplitSettlement (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    SplitSettlement (const SplitSettlement& x,
                     ::xml_schema::flags f = 0,
                     ::xml_schema::container* c = 0);

    virtual SplitSettlement*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SplitSettlement ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< splitSettlementAmount_type > splitSettlementAmount_;
    beneficiaryBank_optional beneficiaryBank_;
    ::xsd::cxx::tree::one< beneficiary_type > beneficiary_;
  };

  class SpreadSchedule: public ::FpML_4_2::Schedule
  {
    public:
    // type
    // 
    typedef ::FpML_4_2::SpreadScheduleType type_type;
    typedef ::xsd::cxx::tree::optional< type_type > type_optional;
    typedef ::xsd::cxx::tree::traits< type_type, char > type_traits;

    const type_optional&
    type () const;

    type_optional&
    type ();

    void
    type (const type_type& x);

    void
    type (const type_optional& x);

    void
    type (::std::auto_ptr< type_type > p);

    // Constructors.
    //
    SpreadSchedule (const initialValue_type&);

    SpreadSchedule (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    SpreadSchedule (const SpreadSchedule& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual SpreadSchedule*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SpreadSchedule ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    type_optional type_;
  };

  class SpreadScheduleReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    SpreadScheduleReference (const href_type&);

    SpreadScheduleReference (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    SpreadScheduleReference (const SpreadScheduleReference& x,
                             ::xml_schema::flags f = 0,
                             ::xml_schema::container* c = 0);

    virtual SpreadScheduleReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SpreadScheduleReference ();
  };

  class SpreadScheduleType: public ::xml_schema::normalized_string
  {
    public:
    // spreadScheduleTypeScheme
    // 
    typedef ::xml_schema::uri spreadScheduleTypeScheme_type;
    typedef ::xsd::cxx::tree::traits< spreadScheduleTypeScheme_type, char > spreadScheduleTypeScheme_traits;

    const spreadScheduleTypeScheme_type&
    spreadScheduleTypeScheme () const;

    spreadScheduleTypeScheme_type&
    spreadScheduleTypeScheme ();

    void
    spreadScheduleTypeScheme (const spreadScheduleTypeScheme_type& x);

    void
    spreadScheduleTypeScheme (::std::auto_ptr< spreadScheduleTypeScheme_type > p);

    static const spreadScheduleTypeScheme_type&
    spreadScheduleTypeScheme_default_value ();

    // Constructors.
    //
    SpreadScheduleType ();

    SpreadScheduleType (const char*);

    SpreadScheduleType (const ::std::string&);

    SpreadScheduleType (const ::xml_schema::normalized_string&);

    SpreadScheduleType (const ::xercesc::DOMElement& e,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    SpreadScheduleType (const SpreadScheduleType& x,
                        ::xml_schema::flags f = 0,
                        ::xml_schema::container* c = 0);

    virtual SpreadScheduleType*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~SpreadScheduleType ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< spreadScheduleTypeScheme_type > spreadScheduleTypeScheme_;
    static const spreadScheduleTypeScheme_type spreadScheduleTypeScheme_default_value_;
  };

  class Step: public ::xml_schema::type
  {
    public:
    // stepDate
    // 
    typedef ::xml_schema::date stepDate_type;
    typedef ::xsd::cxx::tree::traits< stepDate_type, char > stepDate_traits;

    const stepDate_type&
    stepDate () const;

    stepDate_type&
    stepDate ();

    void
    stepDate (const stepDate_type& x);

    void
    stepDate (::std::auto_ptr< stepDate_type > p);

    // stepValue
    // 
    typedef ::xml_schema::decimal stepValue_type;
    typedef ::xsd::cxx::tree::traits< stepValue_type, char, ::xsd::cxx::tree::schema_type::decimal > stepValue_traits;

    const stepValue_type&
    stepValue () const;

    stepValue_type&
    stepValue ();

    void
    stepValue (const stepValue_type& x);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Step (const stepDate_type&,
          const stepValue_type&);

    Step (const ::xercesc::DOMElement& e,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    Step (const Step& x,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    virtual Step*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Step ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< stepDate_type > stepDate_;
    ::xsd::cxx::tree::one< stepValue_type > stepValue_;
    id_optional id_;
  };

  class StreetAddress: public ::xml_schema::type
  {
    public:
    // streetLine
    // 
    typedef ::xml_schema::string streetLine_type;
    typedef ::xsd::cxx::tree::sequence< streetLine_type > streetLine_sequence;
    typedef streetLine_sequence::iterator streetLine_iterator;
    typedef streetLine_sequence::const_iterator streetLine_const_iterator;
    typedef ::xsd::cxx::tree::traits< streetLine_type, char > streetLine_traits;

    const streetLine_sequence&
    streetLine () const;

    streetLine_sequence&
    streetLine ();

    void
    streetLine (const streetLine_sequence& s);

    // Constructors.
    //
    StreetAddress ();

    StreetAddress (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    StreetAddress (const StreetAddress& x,
                   ::xml_schema::flags f = 0,
                   ::xml_schema::container* c = 0);

    virtual StreetAddress*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~StreetAddress ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    streetLine_sequence streetLine_;
  };

  class Stub: public ::xml_schema::type
  {
    public:
    // floatingRate
    // 
    typedef ::FpML_4_2::FloatingRate floatingRate_type;
    typedef ::xsd::cxx::tree::sequence< floatingRate_type > floatingRate_sequence;
    typedef floatingRate_sequence::iterator floatingRate_iterator;
    typedef floatingRate_sequence::const_iterator floatingRate_const_iterator;
    typedef ::xsd::cxx::tree::traits< floatingRate_type, char > floatingRate_traits;

    const floatingRate_sequence&
    floatingRate () const;

    floatingRate_sequence&
    floatingRate ();

    void
    floatingRate (const floatingRate_sequence& s);

    // stubRate
    // 
    typedef ::xml_schema::decimal stubRate_type;
    typedef ::xsd::cxx::tree::optional< stubRate_type > stubRate_optional;
    typedef ::xsd::cxx::tree::traits< stubRate_type, char, ::xsd::cxx::tree::schema_type::decimal > stubRate_traits;

    const stubRate_optional&
    stubRate () const;

    stubRate_optional&
    stubRate ();

    void
    stubRate (const stubRate_type& x);

    void
    stubRate (const stubRate_optional& x);

    // stubAmount
    // 
    typedef ::FpML_4_2::Money stubAmount_type;
    typedef ::xsd::cxx::tree::optional< stubAmount_type > stubAmount_optional;
    typedef ::xsd::cxx::tree::traits< stubAmount_type, char > stubAmount_traits;

    const stubAmount_optional&
    stubAmount () const;

    stubAmount_optional&
    stubAmount ();

    void
    stubAmount (const stubAmount_type& x);

    void
    stubAmount (const stubAmount_optional& x);

    void
    stubAmount (::std::auto_ptr< stubAmount_type > p);

    // stubStartDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate stubStartDate_type;
    typedef ::xsd::cxx::tree::optional< stubStartDate_type > stubStartDate_optional;
    typedef ::xsd::cxx::tree::traits< stubStartDate_type, char > stubStartDate_traits;

    const stubStartDate_optional&
    stubStartDate () const;

    stubStartDate_optional&
    stubStartDate ();

    void
    stubStartDate (const stubStartDate_type& x);

    void
    stubStartDate (const stubStartDate_optional& x);

    void
    stubStartDate (::std::auto_ptr< stubStartDate_type > p);

    // stubEndDate
    // 
    typedef ::FpML_4_2::AdjustableOrRelativeDate stubEndDate_type;
    typedef ::xsd::cxx::tree::optional< stubEndDate_type > stubEndDate_optional;
    typedef ::xsd::cxx::tree::traits< stubEndDate_type, char > stubEndDate_traits;

    const stubEndDate_optional&
    stubEndDate () const;

    stubEndDate_optional&
    stubEndDate ();

    void
    stubEndDate (const stubEndDate_type& x);

    void
    stubEndDate (const stubEndDate_optional& x);

    void
    stubEndDate (::std::auto_ptr< stubEndDate_type > p);

    // Constructors.
    //
    Stub ();

    Stub (const ::xercesc::DOMElement& e,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    Stub (const Stub& x,
          ::xml_schema::flags f = 0,
          ::xml_schema::container* c = 0);

    virtual Stub*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Stub ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    floatingRate_sequence floatingRate_;
    stubRate_optional stubRate_;
    stubAmount_optional stubAmount_;
    stubStartDate_optional stubStartDate_;
    stubEndDate_optional stubEndDate_;
  };

  class Strike: public ::xml_schema::type
  {
    public:
    // strikeRate
    // 
    typedef ::xml_schema::decimal strikeRate_type;
    typedef ::xsd::cxx::tree::traits< strikeRate_type, char, ::xsd::cxx::tree::schema_type::decimal > strikeRate_traits;

    const strikeRate_type&
    strikeRate () const;

    strikeRate_type&
    strikeRate ();

    void
    strikeRate (const strikeRate_type& x);

    // buyer
    // 
    typedef ::FpML_4_2::IdentifiedPayerReceiver buyer_type;
    typedef ::xsd::cxx::tree::optional< buyer_type > buyer_optional;
    typedef ::xsd::cxx::tree::traits< buyer_type, char > buyer_traits;

    const buyer_optional&
    buyer () const;

    buyer_optional&
    buyer ();

    void
    buyer (const buyer_type& x);

    void
    buyer (const buyer_optional& x);

    void
    buyer (::std::auto_ptr< buyer_type > p);

    // seller
    // 
    typedef ::FpML_4_2::IdentifiedPayerReceiver seller_type;
    typedef ::xsd::cxx::tree::optional< seller_type > seller_optional;
    typedef ::xsd::cxx::tree::traits< seller_type, char > seller_traits;

    const seller_optional&
    seller () const;

    seller_optional&
    seller ();

    void
    seller (const seller_type& x);

    void
    seller (const seller_optional& x);

    void
    seller (::std::auto_ptr< seller_type > p);

    // id
    // 
    typedef ::xml_schema::id id_type;
    typedef ::xsd::cxx::tree::optional< id_type > id_optional;
    typedef ::xsd::cxx::tree::traits< id_type, char > id_traits;

    const id_optional&
    id () const;

    id_optional&
    id ();

    void
    id (const id_type& x);

    void
    id (const id_optional& x);

    void
    id (::std::auto_ptr< id_type > p);

    // Constructors.
    //
    Strike (const strikeRate_type&);

    Strike (const ::xercesc::DOMElement& e,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    Strike (const Strike& x,
            ::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0);

    virtual Strike*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~Strike ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    ::xsd::cxx::tree::one< strikeRate_type > strikeRate_;
    buyer_optional buyer_;
    seller_optional seller_;
    id_optional id_;
  };

  class StrikeSchedule: public ::FpML_4_2::Schedule
  {
    public:
    // buyer
    // 
    typedef ::FpML_4_2::IdentifiedPayerReceiver buyer_type;
    typedef ::xsd::cxx::tree::optional< buyer_type > buyer_optional;
    typedef ::xsd::cxx::tree::traits< buyer_type, char > buyer_traits;

    const buyer_optional&
    buyer () const;

    buyer_optional&
    buyer ();

    void
    buyer (const buyer_type& x);

    void
    buyer (const buyer_optional& x);

    void
    buyer (::std::auto_ptr< buyer_type > p);

    // seller
    // 
    typedef ::FpML_4_2::IdentifiedPayerReceiver seller_type;
    typedef ::xsd::cxx::tree::optional< seller_type > seller_optional;
    typedef ::xsd::cxx::tree::traits< seller_type, char > seller_traits;

    const seller_optional&
    seller () const;

    seller_optional&
    seller ();

    void
    seller (const seller_type& x);

    void
    seller (const seller_optional& x);

    void
    seller (::std::auto_ptr< seller_type > p);

    // Constructors.
    //
    StrikeSchedule (const initialValue_type&);

    StrikeSchedule (const ::xercesc::DOMElement& e,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    StrikeSchedule (const StrikeSchedule& x,
                    ::xml_schema::flags f = 0,
                    ::xml_schema::container* c = 0);

    virtual StrikeSchedule*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~StrikeSchedule ();

    // Implementation.
    //
    protected:
    void
    parse (::xsd::cxx::xml::dom::parser< char >&,
           ::xml_schema::flags);

    protected:
    buyer_optional buyer_;
    seller_optional seller_;
  };

  class ValuationScenarioReference: public ::FpML_4_2::Reference
  {
    public:
    // Constructors.
    //
    ValuationScenarioReference (const href_type&);

    ValuationScenarioReference (const ::xercesc::DOMElement& e,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    ValuationScenarioReference (const ValuationScenarioReference& x,
                                ::xml_schema::flags f = 0,
                                ::xml_schema::container* c = 0);

    virtual ValuationScenarioReference*
    _clone (::xml_schema::flags f = 0,
            ::xml_schema::container* c = 0) const;

    virtual 
    ~ValuationScenarioReference ();
  };
}

#include <iosfwd>

#include <xercesc/sax/InputSource.hpp>
#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>

namespace FpML_4_2
{
}

#include <iosfwd>

#include <xercesc/dom/DOMDocument.hpp>
#include <xercesc/dom/DOMErrorHandler.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <xsd/cxx/xml/dom/auto-ptr.hxx>

namespace FpML_4_2
{
  void
  operator<< (::xercesc::DOMElement&, const HourMinuteTime&);

  void
  operator<< (::xercesc::DOMAttr&, const HourMinuteTime&);

  void
  operator<< (::xml_schema::list_stream&,
              const HourMinuteTime&);

  void
  operator<< (::xercesc::DOMElement&, const RestrictedPercentage&);

  void
  operator<< (::xercesc::DOMAttr&, const RestrictedPercentage&);

  void
  operator<< (::xml_schema::list_stream&,
              const RestrictedPercentage&);

  void
  operator<< (::xercesc::DOMElement&, const Reference&);

  void
  operator<< (::xercesc::DOMElement&, const AccountReference&);

  void
  operator<< (::xercesc::DOMElement&, const Address&);

  void
  operator<< (::xercesc::DOMElement&, const AdjustableDate&);

  void
  operator<< (::xercesc::DOMElement&, const AdjustableDate2&);

  void
  operator<< (::xercesc::DOMElement&, const AdjustableDates&);

  void
  operator<< (::xercesc::DOMElement&, const AdjustableOrRelativeDate&);

  void
  operator<< (::xercesc::DOMElement&, const AdjustableOrRelativeDates&);

  void
  operator<< (::xercesc::DOMElement&, const AdjustableRelativeOrPeriodicDates&);

  void
  operator<< (::xercesc::DOMElement&, const Interval&);

  void
  operator<< (::xercesc::DOMElement&, const Offset&);

  void
  operator<< (::xercesc::DOMElement&, const RelativeDateOffset&);

  void
  operator<< (::xercesc::DOMElement&, const AdjustedRelativeDateOffset&);

  void
  operator<< (::xercesc::DOMElement&, const Exercise&);

  void
  operator<< (::xercesc::DOMElement&, const AmericanExercise&);

  void
  operator<< (::xercesc::DOMElement&, const AmountReference&);

  void
  operator<< (::xercesc::DOMElement&, const Schedule&);

  void
  operator<< (::xercesc::DOMElement&, const AmountSchedule&);

  void
  operator<< (::xercesc::DOMElement&, const AssetReference&);

  void
  operator<< (::xercesc::DOMElement&, const AutomaticExercise&);

  void
  operator<< (::xercesc::DOMElement&, const Routing&);

  void
  operator<< (::xercesc::DOMElement&, const Beneficiary&);

  void
  operator<< (::xercesc::DOMElement&, const BermudaExercise&);

  void
  operator<< (::xercesc::DOMElement&, const BrokerConfirmation&);

  void
  operator<< (::xercesc::DOMElement&, const BrokerConfirmationType&);

  void
  operator<< (::xercesc::DOMElement&, const BusinessCenter&);

  void
  operator<< (::xercesc::DOMElement&, const BusinessCenters&);

  void
  operator<< (::xercesc::DOMElement&, const BusinessCentersReference&);

  void
  operator<< (::xercesc::DOMElement&, const BusinessCenterTime&);

  void
  operator<< (::xercesc::DOMElement&, const DateRange&);

  void
  operator<< (::xercesc::DOMElement&, const BusinessDateRange&);

  void
  operator<< (::xercesc::DOMElement&, const BusinessDayAdjustments&);

  void
  operator<< (::xercesc::DOMElement&, const BusinessDayAdjustmentsReference&);

  void
  operator<< (::xercesc::DOMElement&, const CalculationAgent&);

  void
  operator<< (::xercesc::DOMElement&, const CalculationPeriodFrequency&);

  void
  operator<< (::xercesc::DOMElement&, const CashflowType&);

  void
  operator<< (::xercesc::DOMElement&, const CashSettlementReferenceBanks&);

  void
  operator<< (::xercesc::DOMElement&, const ClearanceSystem&);

  void
  operator<< (::xercesc::DOMElement&, const ContractualDefinitions&);

  void
  operator<< (::xercesc::DOMElement&, const ContractualMatrix&);

  void
  operator<< (::xercesc::DOMElement&, const ContractualSupplement&);

  void
  operator<< (::xercesc::DOMElement&, const ContractualTermsSupplement&);

  void
  operator<< (::xercesc::DOMElement&, const CorrespondentInformation&);

  void
  operator<< (::xercesc::DOMElement&, const Country&);

  void
  operator<< (::xercesc::DOMElement&, const CreditSeniority&);

  void
  operator<< (::xercesc::DOMElement&, const Currency&);

  void
  operator<< (::xercesc::DOMElement&, const DateList&);

  void
  operator<< (::xercesc::DOMElement&, const DateOffset&);

  void
  operator<< (::xercesc::DOMElement&, const DateReference&);

  void
  operator<< (::xercesc::DOMElement&, const DateTimeList&);

  void
  operator<< (::xercesc::DOMElement&, const DayCountFraction&);

  void
  operator<< (::xercesc::DOMElement&, const DeterminationMethod&);

  void
  operator<< (::xercesc::DOMElement&, const DividendConditions&);

  void
  operator<< (::xercesc::DOMElement&, const DividendPaymentDate&);

  void
  operator<< (::xercesc::DOMElement&, const Documentation&);

  void
  operator<< (::xercesc::DOMElement&, const Empty&);

  void
  operator<< (::xercesc::DOMAttr&, const Empty&);

  void
  operator<< (::xml_schema::list_stream&,
              const Empty&);

  void
  operator<< (::xercesc::DOMElement&, const EntityId&);

  void
  operator<< (::xercesc::DOMElement&, const EntityName&);

  void
  operator<< (::xercesc::DOMElement&, const EuropeanExercise&);

  void
  operator<< (::xercesc::DOMElement&, const ExchangeId&);

  void
  operator<< (::xercesc::DOMElement&, const ExerciseFee&);

  void
  operator<< (::xercesc::DOMElement&, const ExerciseFeeSchedule&);

  void
  operator<< (::xercesc::DOMElement&, const ExerciseNotice&);

  void
  operator<< (::xercesc::DOMElement&, const ExerciseProcedure&);

  void
  operator<< (::xercesc::DOMElement&, const Rate&);

  void
  operator<< (::xercesc::DOMElement&, const FloatingRate&);

  void
  operator<< (::xercesc::DOMElement&, const FloatingRateCalculation&);

  void
  operator<< (::xercesc::DOMElement&, const FloatingRateIndex&);

  void
  operator<< (::xercesc::DOMElement&, const ForecastRateIndex&);

  void
  operator<< (::xercesc::DOMElement&, const Formula&);

  void
  operator<< (::xercesc::DOMElement&, const FormulaComponent&);

  void
  operator<< (::xercesc::DOMElement&, const FxCashSettlement&);

  void
  operator<< (::xercesc::DOMElement&, const FxSpotRateSource&);

  void
  operator<< (::xercesc::DOMElement&, const FxFixing&);

  void
  operator<< (::xercesc::DOMElement&, const FxRate&);

  void
  operator<< (::xercesc::DOMElement&, const GoverningLaw&);

  void
  operator<< (::xercesc::DOMElement&, const IdentifiedCurrency&);

  void
  operator<< (::xercesc::DOMElement&, const IdentifiedDate&);

  void
  operator<< (::xercesc::DOMElement&, const IdentifiedPayerReceiver&);

  void
  operator<< (::xercesc::DOMElement&, const InformationProvider&);

  void
  operator<< (::xercesc::DOMElement&, const InformationSource&);

  void
  operator<< (::xercesc::DOMElement&, const InstrumentId&);

  void
  operator<< (::xercesc::DOMElement&, const InterestAccrualsMethod&);

  void
  operator<< (::xercesc::DOMElement&, const InterestAccrualsCompoundingMethod&);

  void
  operator<< (::xercesc::DOMElement&, const IntermediaryInformation&);

  void
  operator<< (::xercesc::DOMElement&, const LegalEntity&);

  void
  operator<< (::xercesc::DOMElement&, const LegalEntityReference&);

  void
  operator<< (::xercesc::DOMElement&, const MainPublication&);

  void
  operator<< (::xercesc::DOMElement&, const ManualExercise&);

  void
  operator<< (::xercesc::DOMElement&, const MasterAgreement&);

  void
  operator<< (::xercesc::DOMElement&, const MasterAgreementType&);

  void
  operator<< (::xercesc::DOMElement&, const MasterConfirmation&);

  void
  operator<< (::xercesc::DOMElement&, const MasterConfirmationType&);

  void
  operator<< (::xercesc::DOMElement&, const Math&);

  void
  operator<< (::xercesc::DOMElement&, const MatrixType&);

  void
  operator<< (::xercesc::DOMElement&, const MatrixTerm&);

  void
  operator<< (::xercesc::DOMElement&, const Money&);

  void
  operator<< (::xercesc::DOMElement&, const PartialExercise&);

  void
  operator<< (::xercesc::DOMElement&, const MultipleExercise&);

  void
  operator<< (::xercesc::DOMElement&, const NotionalAmountReference&);

  void
  operator<< (::xercesc::DOMElement&, const PartyOrAccountReference&);

  void
  operator<< (::xercesc::DOMElement&, const PartyOrTradeSideReference&);

  void
  operator<< (::xercesc::DOMElement&, const PartyReference&);

  void
  operator<< (::xercesc::DOMElement&, const Payment&);

  void
  operator<< (::xercesc::DOMElement&, const PaymentCurrency&);

  void
  operator<< (::xercesc::DOMElement&, const PaymentType&);

  void
  operator<< (::xercesc::DOMElement&, const PeriodicDates&);

  void
  operator<< (::xercesc::DOMElement&, const PrincipalExchanges&);

  void
  operator<< (::xercesc::DOMElement&, const Product&);

  void
  operator<< (::xercesc::DOMElement&, const ProductId&);

  void
  operator<< (::xercesc::DOMElement&, const ProductReference&);

  void
  operator<< (::xercesc::DOMElement&, const ProductType&);

  void
  operator<< (::xercesc::DOMElement&, const QuotedCurrencyPair&);

  void
  operator<< (::xercesc::DOMElement&, const RateReference&);

  void
  operator<< (::xercesc::DOMElement&, const RateObservation&);

  void
  operator<< (::xercesc::DOMElement&, const RateSourcePage&);

  void
  operator<< (::xercesc::DOMElement&, const ReferenceAmount&);

  void
  operator<< (::xercesc::DOMElement&, const ReferenceBank&);

  void
  operator<< (::xercesc::DOMElement&, const ReferenceBankId&);

  void
  operator<< (::xercesc::DOMElement&, const RelativeDates&);

  void
  operator<< (::xercesc::DOMElement&, const RelativeDateSequence&);

  void
  operator<< (::xercesc::DOMElement&, const RequiredIdentifierDate&);

  void
  operator<< (::xercesc::DOMElement&, const ResetFrequency&);

  void
  operator<< (::xercesc::DOMElement&, const Rounding&);

  void
  operator<< (::xercesc::DOMElement&, const RoutingExplicitDetails&);

  void
  operator<< (::xercesc::DOMElement&, const RoutingId&);

  void
  operator<< (::xercesc::DOMElement&, const RoutingIds&);

  void
  operator<< (::xercesc::DOMElement&, const RoutingIdsAndExplicitDetails&);

  void
  operator<< (::xercesc::DOMElement&, const ScheduleReference&);

  void
  operator<< (::xercesc::DOMElement&, const SettlementInformation&);

  void
  operator<< (::xercesc::DOMElement&, const SettlementInstruction&);

  void
  operator<< (::xercesc::DOMElement&, const SettlementMethod&);

  void
  operator<< (::xercesc::DOMElement&, const SettlementPriceSource&);

  void
  operator<< (::xercesc::DOMElement&, const SettlementRateSource&);

  void
  operator<< (::xercesc::DOMElement&, const SharedAmericanExercise&);

  void
  operator<< (::xercesc::DOMElement&, const SplitSettlement&);

  void
  operator<< (::xercesc::DOMElement&, const SpreadSchedule&);

  void
  operator<< (::xercesc::DOMElement&, const SpreadScheduleReference&);

  void
  operator<< (::xercesc::DOMElement&, const SpreadScheduleType&);

  void
  operator<< (::xercesc::DOMElement&, const Step&);

  void
  operator<< (::xercesc::DOMElement&, const StreetAddress&);

  void
  operator<< (::xercesc::DOMElement&, const Stub&);

  void
  operator<< (::xercesc::DOMElement&, const Strike&);

  void
  operator<< (::xercesc::DOMElement&, const StrikeSchedule&);

  void
  operator<< (::xercesc::DOMElement&, const ValuationScenarioReference&);
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // FPML_SHARED_4_2_HXX
